function StObject(){};
function StBehavior(){};
function StClass(){};
function StMetaclass(){ this.$meta = true; };
function StMethod(){};

function StUndefinedObject(){};
var nil = new StUndefinedObject();
nil.toString = function() { return 'nil'; }

function StSystemDictionary(){

	var st = this;
	st.$imageFileName = "s8.image.js";
	st.isNil = function(aValue) { // return true if aValue is considered nil
		return (aValue || nil) === nil;
	}

	st.setClass = function(aClass, spec) { // set aClass from literal spec
		if(st.isNil(spec)) { return aClass; };
		if(!spec.meta) {
			aClass.$klass["@instanceClass"] = aClass;
			aClass.$className = spec.className;
			aClass.$klass.$className = spec.className + " class";
		}
		aClass.$fn = spec.fn || function(){};
		aClass.$superclass = spec.superclass || nil;
		if(!st.isNil(aClass.$superclass)) { if(!st.isNil(aClass.$klass)) {
			aClass.$klass.$superclass = aClass.$superclass.$klass;
			if(aClass.$klass.$superclass) delete aClass.$klass.$superclass["@subclasses"];
			}
			delete aClass.$superclass["@subclasses"];
		}
		if (!aClass.$iVarNames) { aClass.$iVarNames = spec.iVarNames || []; }
		if (!aClass.$fn.prototype.$methods) { aClass.$fn.prototype.$methods = {}; }
		aClass.$fn.prototype.$klass = aClass;
		aClass.$category = spec.category || "";
		return aClass;
	};

	st.klass = function(spec) { // return a new class from literal spec
		if(st.isNil(spec)) { return st.klass({}) };
		var result;
		if(spec.meta) {
			result = new StMetaclass();
		} else {
			result = new (st.klass({meta:true})).$fn;
		}
		st.setClass(result,spec);
		return result;
	};

	st.transferPropertiesFrom_to_ = function(source,target) { // populate target with the properties defined in source if not already defined
		for(var i in source) {
			if(typeof target[i] == "undefined") { target[i] = source[i]; }
		}
		return target;
	}

	st.setChain = function(aClass) { // Set the __proto__ delegation chain
		if(this.__proto__) {
			aClass.$fn.prototype.__proto__ = aClass.$superclass.$fn.prototype;
		} else { // unsuported __proto__ feature (e.g. IE)
			var target = aClass.$fn.prototype;
			var source = aClass.$superclass.$fn.prototype;
			st.transferPropertiesFrom_to_(source,target);
		}
		return aClass;
	};

	st.setMetaChain = function(aClass) { // Set the __proto__ delegation chain
		if(this.__proto__) {
			// do nothing
		} else { // unsuported __proto__ feature (e.g. IE)
			var target = aClass.$fn.prototype;
			for (var current=st.Class;(!st.isNil(current));current=current.$superclass){
				var source = current.$fn.prototype;
				st.transferPropertiesFrom_to_(source,target);
			}
		}
		return aClass;
	};

	st.initClass = function(aClass) { // Private - Actions to initialize aClass (nothing done on subclasses)
		if(aClass.$meta && st.isNil(aClass.$superclass)) {
			if(this.__proto__) {
				aClass.$superclass = smalltalk.Class;
			}
		}
		if(aClass.$klass && !aClass.$meta) {
			st.initClass(aClass.$klass);
		}
		if(aClass.$iVarNames)
			for(var i=0;i<aClass.$iVarNames.length;i++) {
				aClass.$fn.prototype["@"+aClass.$iVarNames[i]] = nil;
			}
		if(!st.isNil(aClass.$superclass)) {
			st.setChain(aClass);
			if(aClass.$superclass.$iVarNames)
				for(var i=0;i<aClass.$superclass.$iVarNames.length;i++) {
					if(!aClass["@"+aClass.$superclass.$iVarNames[i]]) {
						aClass.$fn.prototype["@"+aClass.$superclass.$iVarNames[i]] = nil;
					}
				}
		} else {
			if(aClass.$meta) { st.setMetaChain(aClass); }
		}
		return aClass;
	};

	st.initWithSubclasses = function(aClass) { // Private - Initialize aClass and its subclasses.
		st.initClass(aClass);
		var subclasses = st.allSubclasses(aClass);
		//var i=subclasses.length;while(i--){ st.initClass(subclasses[i]); }
		for(var i=0;i<subclasses.length;i++) { st.initClass(subclasses[i]); }
		return aClass;
	};
	st.init = st.initWithSubclasses;

	st.initRoots = function(){ // initialize all the root classes in the system
		var classes = st.classes();
		var i=classes.length;while(i--){
			if(st.isNil(classes[i].$superclass)) {
				st.initWithSubclasses(classes[i]);
			}
		}
		return classes;
	};

	st.classes = function() { // Return all the global classes
		var classes = [];
		for (var i in st){ if (st.hasOwnProperty(i) && (i != "$klass")) {
		    var cls = st[i]; if(!st.isNil(cls)){
			if(cls.$klass && cls.$className){ classes.push(cls); }
		    } }
		}
		return classes;
	};

	st.subclasses = function(aClass) { // Return the subclasses of aClass (use instanceVar chache)
		if(aClass.hasOwnProperty("@subclasses")) return aClass["@subclasses"];
		var result = [];
		var classes = st.classes();
		var i=classes.length;while(i--){
		    if(classes[i].$fn) {
			if(classes[i].$klass
				&& classes[i].$klass.$superclass === aClass)
				{ result.push(classes[i].$klass); }
			if(classes[i].$superclass === aClass)
				{ result.push(classes[i]); }
		    }
		}
		if(st.Class){ // Class is linked to Object.klass but it is not a subclass relationship
			if(aClass === st.Class) { var k;
				for(var i in result) {
					if(result[i] === st.Object.$klass) { k = i; }
				}
				if(k) result.splice(k,1);
			}
		}
		aClass["@subclasses"] = result;
		return result;
	};

	st.allSubclasses = function(aClass) { // Return all the subclasses of aClass
		var subclasses = st.subclasses(aClass);
		var result = subclasses;
		for(var i=0;i<subclasses.length;i++) {
			result = result.concat(st.allSubclasses(subclasses[i]));
		}
		return result;
	};

	st.mapClassName = function(className, category, fn, superclass) { // Return a smalltalk class mapped to an existing javascript implementation
		if (st[className]) { // class already exists
			return st.setClass(st[className],{
				className:	className, 
				category:	category, 
				superclass:	superclass,
				fn:		fn	});
		}
		st[className] = st.klass({
			className:	className, 
			category:	category, 
			superclass:	superclass,
			fn:		fn
		});
		return st[className];
	};

	st.addClass = function(className, superclass, iVarNames, category) { // Register a (potentially new) global class in the System
		st.debugAddClass(className, superclass, iVarNames, category);
		if(st[className]) {
			var aClass = st[className];
			var sameShape = (aClass.$superclass == superclass)
				&& (aClass.$iVarNames == iVarNames);
			if (sameShape && (aClass.$category == category) ) return aClass;
			st.aboutToChangeClass(aClass,superclass,iVarNames,category);
			if(st[className].$superclass) {
				delete st[className].$superclass["@subclasses"];
			}
			st[className].$superclass = superclass;
			if(superclass && (superclass["@subclasses"])) {
				if(st.isNil(superclass["@subclasses"])) { superclass["@subclasses"] = []; }
				superclass["@subclasses"].push(st[className]); 
			}
			st[className].$iVarNames = iVarNames;
			st[className].$category = category || st[className].$category;
			if (!sameShape) st.classShapeChanged(aClass);
		} else {
			st.aboutToCreateClass(className,superclass,iVarNames,category);
			st[className] = st.klass({
				className: className, 
				iVarNames: iVarNames,
				superclass: superclass
			});
			if(st.isNil(superclass)) {
				st[className].$klass.$superclass = st.Class;
			}
			st[className].$category = category || "";
		}
		st.classChanged(st[className]);
		return st[className];
	};
	st.renameClass = function(aClass,aString) {
		delete smalltalk[aClass.$className];
		aClass.$className = aString;
		smalltalk[aString] = aClass;
		st.classChanged(aClass);
	};
	st.removeClass = function(aClass) {
		var deleted = "Deleted-";
		if(aClass.$superclass) { delete aClass.$superclass["@subclasses"]; }
		delete smalltalk[aClass.$className];
		aClass.$className = deleted + aClass.$className;
		aClass.$klass.$className = deleted + aClass.$klass.$className;
		st.classChanged(aClass);
	};
	st.metaVarNames = function(aMetaClass,iVarNames) {
		if (aMetaClass.$iVarNames == iVarNames) return false;
		aMetaClass.$iVarNames = iVarNames;
		st.classShapeChanged(aMetaClass);
		st.classChanged(aMetaClass);
		return true;
	};

	st.smDo = function(block) {
		if (!st.SystemManager) return nil;
		if (!st.SystemManager.classVariableAt_) return nil;
		if (!st.SystemManager.currentOrNil) return nil;
		var sm = st.SystemManager.currentOrNil();
		if (!st.isNil(sm)) return block(sm);
	};
	st.classChanged = function(aBehavior) {
		st.smDo(function(sm){sm.classChanged_(aBehavior)})
	};
	st.classShapeChanged = function(aBehavior) {
		st.smDo(function(sm){sm.classShapeChanged_(aBehavior)})
	};
	st.aboutToCreateClass = function(className,superclass,iVarNames,category) {
		st.smDo(function(sm){sm.aboutToCreateClass_superclass_iVarNames_category_(className,superclass,iVarNames,category)})
	};
	st.aboutToChangeClass = function(aClass,superclass,iVarNames,category) {
		st.smDo(function(sm){sm.aboutToChange_superclass_iVarNames_category_(aClass,superclass,iVarNames,category)})
	};
	st.methodBoundTo = function(method,klass) {
		st.smDo(function(sm){sm.methodBound_to_(method,klass)})
		return method;
	};
	st.aboutToBindTo = function(method,klass) {
		st.smDo(function(sm){sm.aboutToBind_to_(method,klass)})
		return method;
	};
	st.aboutToRemoveFrom = function(method,klass) {
		st.smDo(function(sm){sm.aboutToRemove_from_(method,klass)})
		return method;
	};
	st.methodRemovedFrom = function(method,klass) {
		st.smDo(function(sm){sm.methodRemoved_from_(method,klass)})
		return method;
	};

	st.whoImplements = function(klass,jsSelector) { // Return the implementor of a jsSelector
		var cls = klass;
		do {	if(cls.$fn.prototype.hasOwnProperty(jsSelector)) return cls;
			cls = cls.$superclass;
		} while (cls);
		return nil;
	};

	st.addMethod = function(jsSelector, method, klass) {
		st.aboutToBindTo(method,klass);
		klass.$fn.prototype[jsSelector] = method.$fn;
		klass.$fn.prototype.$methods[method.$selector] = method;
		method["@classField"] = klass;
		return st.methodBoundTo(method,klass);
//Ale #addMethod y #removeMethod deben ser sencibles a que si ocurren
// en Class (o una superclase) debera hacerse un init de las root classes
// en realidad solo setMetaChain de la metaclase.
	};

	st.bind = function(klass,stSelector,jsSelector,jsFunction,category,stSource) {
		st.debugBind(klass,stSelector,jsSelector,jsFunction,category,stSource);
		var method = new StMethod();
		method.$selector	= stSelector;
		method.$fn		= jsFunction;
		method.$category	= category;
		method.$source		= stSource;
		if(!st.isNil(klass)) { st.addMethod(jsSelector,method,klass); };
		return method;
	};

	st.removeMethod = function(aClass,aMethod) {
		st.aboutToRemoveFrom(aMethod,aClass);
		delete aClass.$fn.prototype[aMethod.$selector.asSelector()];
		delete aClass.$fn.prototype.$methods[aMethod.$selector]
		return st.methodRemovedFrom(aMethod,aClass);
//Ale #addMethod y #removeMethod deben ser sencibles a que si ocurren
// en Class (o una superclase) debera hacerse un init de las root classes
// en realidad solo setMetaChain de la metaclase.
	};

	st.newMethod = function(currentClass,selector,fn,source) {
		return st.bind(nil,selector,nil,fn,nil,source);
	};
	st.method = function(spec) { // OBSOLETE - Return a new method from spec literal
		return st.bind(nil,spec.selector,nil,spec.fn,spec.category,spec.source);
	};

	st.readJSObject = function(js) { // Return a Smalltalk Object from javascript literal(js).
		if(!js) return nil;
		var object = js;
		var readObject = (js.constructor === Object);
		var readArray = (js.constructor === Array);
		if(readObject) { object = st.Dictionary.$$new(); }
		for(var i in js) {
			if (!js.hasOwnProperty(i)) break;
			if(readObject) { object.at_put_(i, st.readJSObject(js[i])); } 
			if(readArray) { object[i] = st.readJSObject(js[i]); }
		}
		return object;
	};

	st.globalsDo = function(action) { // Evaluate an action on each global key
		for (key in smalltalk) { // globals are detected as non-class&non-method objects bound to smalltalk
			if (!smalltalk.hasOwnProperty(key)) break;
			if((typeof(st[key]) != "function")
			 && (st[key].isClass
			 && (!st[key].isClass()))) { action(key) } }
		return st;
	};

	st.launchImage = function(imageName) { // Load an image from file, initialize and launch the system
		if(!st.isNil(imageName)) {
			st.$imageFileName = imageName;
			load(imageName);
		}
		st.initRoots();
		if(st.launch && typeof st.launch == "function") { st.launch(); }
		return st;
	}

	st.debugBind = function(klass,stSelector,jsSelector,jsFunction,category,stSource) { return st; };
	st.debugAddClass = function(className, superclass, iVarNames, category) { return st; };
}; // Smalltalk definition

var smalltalk = new StSystemDictionary();
smalltalk.toString = function() { return "smalltalk"; }
smalltalk.OverwriteMethods = smalltalk.OverwriteMethods || nil;
smalltalk.DumpOverwriteMethods = smalltalk.DumpOverwriteMethods || nil;

smalltalk.mapClassName("Object", "Kernel", StObject);
smalltalk.mapClassName("Smalltalk", "Kernel", StSystemDictionary, smalltalk.Object);
smalltalk.mapClassName("Behavior", "Kernel", StBehavior, smalltalk.Object);
smalltalk.mapClassName("Class", "Kernel", StClass, smalltalk.Behavior);
smalltalk.mapClassName("Metaclass", "Kernel", StMetaclass, smalltalk.Behavior);
smalltalk.mapClassName("CompiledMethod", "Kernel", StMethod, smalltalk.Object);

smalltalk.mapClassName("Number", "Kernel", Number, smalltalk.Object);
smalltalk.mapClassName("BlockClosure", "Kernel", Function, smalltalk.Object);
smalltalk.mapClassName("Boolean", "Kernel", Boolean, smalltalk.Object);
smalltalk.mapClassName("DateTime", "Kernel", Date, smalltalk.Object);
smalltalk.mapClassName("UndefinedObject", "Kernel", StUndefinedObject, smalltalk.Object);

smalltalk.mapClassName("Collection", "Kernel", undefined, smalltalk.Object);
smalltalk.mapClassName("SequenceableCollection", "Kernel", undefined, smalltalk.Collection);
smalltalk.mapClassName("String", "Kernel", String, smalltalk.SequenceableCollection);
smalltalk.mapClassName("Array", "Kernel", Array, smalltalk.SequenceableCollection);
smalltalk.mapClassName("RegularExpression", "Kernel", RegExp, smalltalk.Object);

smalltalk.initRoots();