

// Smalltalk Classes.

if(StObject && !smalltalk.Object) smalltalk.mapClassName("Object","Kernel",StObject,undefined);

smalltalk.addClass("Object",undefined, [], 'Kernel');

smalltalk.addClass("S8Web",smalltalk.Object, ['id', 'widgets', 'requireMap', 'requireSolver'], 'S8Web');

smalltalk.S8Web.$classVariableNames=unescape("InitialCodeContents%20CommonExpressions%20OnLoadActions")

smalltalk.S8Web.$klass.$iVarNames = ['instances'];

smalltalk.addClass("Exception",smalltalk.Object, ['messageText'], 'Kernel');

smalltalk.addClass("Association",smalltalk.Object, ['key', 'value'], 'Kernel');

smalltalk.addClass("ClassBuilder",smalltalk.Object, [], 'Kernel');

smalltalk.addClass("Stream",smalltalk.Object, ['collection', 'position', 'readLimit'], 'Kernel');

smalltalk.addClass("Random",smalltalk.Object, [], 'Kernel');

smalltalk.addClass("Point",smalltalk.Object, ['x', 'y'], 'Kernel');

smalltalk.addClass("Rectangle",smalltalk.Object, ['leftTop', 'rightBottom'], 'Kernel');

smalltalk.addClass("EvaluableAction",smalltalk.Object, [], 'Kernel');

smalltalk.EvaluableAction.$comment=unescape("%0D%0A%09Action%20model%2C%20evaluable%20and%20composable%20actions%20are%20implemented%20to%20support%20evaluations.%0D%0A")

smalltalk.addClass("ActionSequence",smalltalk.Object, ['contents'], 'Kernel');

smalltalk.addClass("EventManager",smalltalk.Object, ['handlers'], 'Kernel');

smalltalk.EventManager.$comment=unescape("%0D%0A%09Event%20system%2C%20properties%20and%20change/update/release%20mechanism.%0D%0A%09We%20hook%20%24properties%20and%20%24handlers%20internal%20properties%20to%20manage%20properties%20and%20events%20at%20Object%20level.%0D%0A%09EventManager%20instances%20implement%20events%20handler%20as%20pure%20instance%20variable.%0D%0A")

smalltalk.EventManager.$klass.$iVarNames = ['eventsTriggered'];

smalltalk.addClass("CompilerNode",smalltalk.Object, ['nodes', 'start', 'end'], 'Compiler');

smalltalk.addClass("PPFailure",smalltalk.Object, ['position', 'reason'], 'Compiler-Parser');

smalltalk.addClass("PPParser",smalltalk.Object, ['memo'], 'Compiler-Parser');

smalltalk.addClass("SmalltalkParser",smalltalk.Object, [], 'Compiler-Parser');

smalltalk.addClass("FileInReader",smalltalk.Object, [], 'Compiler-FileIn');

smalltalk.FileInReader.$comment=unescape("%0D%0A%09Perform%20sequential%20reading%20from%20aStream%20in%20chunk%20format.%0D%0A%09Instances%20implement%20%23scanFrom%3A%20message%2C%20advancing%20aStream%20upto%20next%20reader%20instantiation%20chunk.")

smalltalk.addClass("Exporter",smalltalk.Object, [], 'Compiler-FileOut');

smalltalk.addClass("DoIt",smalltalk.Object, [], 'Compiler-Evaluation');

smalltalk.addClass("Snapshot",smalltalk.Object, ['system'], 'Image');

smalltalk.Snapshot.$comment=unescape("%0D%0A%09Instances%20of%20the%20receiver%20produce%20snpashots%20of%20Smalltalk%20systems.%0D%0A%09The%20default%20implementation%20export%20full/runnable%20images%20containing%20boot%20sections.%0D%0A%09The%20subclasses%20can%20refine%20behavior%20to%20select/customize%20exports%20and%20format.%0D%0A%09@2011%20Alejandro%20Reimondo%20aleReimondo@smalltalking.net%0D%0A%09")

smalltalk.addClass("Transcript",smalltalk.Object, ['stream'], 'Transcript');

smalltalk.Transcript.$klass.$iVarNames = ['current'];

smalltalk.addClass("NativeObject",smalltalk.Object, ['handle'], 'Natives');

smalltalk.NativeObject.$comment=unescape("%0D%0A%09Implementation%20of%20wrapper%20to%20native%20%28js%29%20objects.%0D%0A%09@2011%20Alejandro%20F.%20Reimondo%0D%0A%09aleReimondo@smalltalking.net%0D%0A")

if(RegExp && !smalltalk.RegularExpression) smalltalk.mapClassName("RegularExpression","Kernel",RegExp,smalltalk.Object);

smalltalk.addClass("RegularExpression",smalltalk.Object, [], 'Kernel');

smalltalk.addClass("Collection",smalltalk.Object, [], 'Kernel');

if(StUndefinedObject && !smalltalk.UndefinedObject) smalltalk.mapClassName("UndefinedObject","Kernel",StUndefinedObject,smalltalk.Object);

smalltalk.addClass("UndefinedObject",smalltalk.Object, [], 'Kernel');

if(Date && !smalltalk.DateTime) smalltalk.mapClassName("DateTime","Kernel",Date,smalltalk.Object);

smalltalk.addClass("DateTime",smalltalk.Object, [], 'Kernel');

if(Boolean && !smalltalk.Boolean) smalltalk.mapClassName("Boolean","Kernel",Boolean,smalltalk.Object);

smalltalk.addClass("Boolean",smalltalk.Object, [], 'Kernel');

if(Function && !smalltalk.BlockClosure) smalltalk.mapClassName("BlockClosure","Kernel",Function,smalltalk.Object);

smalltalk.addClass("BlockClosure",smalltalk.Object, [], 'Kernel');

if(Number && !smalltalk.Number) smalltalk.mapClassName("Number","Kernel",Number,smalltalk.Object);

smalltalk.addClass("Number",smalltalk.Object, [], 'Kernel');

if(StMethod && !smalltalk.CompiledMethod) smalltalk.mapClassName("CompiledMethod","Kernel",StMethod,smalltalk.Object);

smalltalk.addClass("CompiledMethod",smalltalk.Object, ['classField'], 'Kernel');

if(StBehavior && !smalltalk.Behavior) smalltalk.mapClassName("Behavior","Kernel",StBehavior,smalltalk.Object);

smalltalk.addClass("Behavior",smalltalk.Object, [], 'Kernel');

if(StSystemDictionary && !smalltalk.Smalltalk) smalltalk.mapClassName("Smalltalk","Kernel",StSystemDictionary,smalltalk.Object);

smalltalk.addClass("Smalltalk",smalltalk.Object, [], 'Kernel');

smalltalk.addClass("Error",smalltalk.Exception, [], 'Kernel');

smalltalk.addClass("MessageNotUnderstood",smalltalk.Error, ['message', 'receiver'], 'Kernel');

smalltalk.addClass("StringStream",smalltalk.Stream, [], 'Kernel');

smalltalk.addClass("Message",smalltalk.EvaluableAction, ['selector', 'arguments', 'receiver'], 'Kernel');

smalltalk.addClass("LinkMessage",smalltalk.Message, ['resultAction'], 'Kernel');

smalltalk.LinkMessage.$comment=unescape("%0D%0A%09Implement%20evaluation%20cascading%20argument%20evaluations.")

smalltalk.addClass("CompilerNodeVisitor",smalltalk.EventManager, [], 'Compiler');

smalltalk.addClass("MethodReferences",smalltalk.EventManager, ['rootClasses', 'results'], 'Compiler');

smalltalk.addClass("SystemManager",smalltalk.EventManager, [], 'Image');

smalltalk.SystemManager.$classVariableNames="Current"

smalltalk.addClass("Compiler",smalltalk.CompilerNodeVisitor, ['stream', 'startOffset', 'nestedBlocks', 'earlyReturn', 'currentClass', 'functionName', 'unknownVariables', 'tempVariables', 'transformers', 'optimizationMap'], 'Compiler');

smalltalk.addClass("MethodNode",smalltalk.CompilerNode, ['selector', 'arguments', 'source'], 'Compiler');

smalltalk.addClass("SendNode",smalltalk.CompilerNode, ['selector', 'arguments', 'receiver'], 'Compiler');

smalltalk.addClass("CascadeNode",smalltalk.CompilerNode, ['receiver'], 'Compiler');

smalltalk.addClass("AssignmentNode",smalltalk.CompilerNode, ['left', 'right'], 'Compiler');

smalltalk.addClass("BlockNode",smalltalk.CompilerNode, ['parameters'], 'Compiler');

smalltalk.addClass("SequenceNode",smalltalk.CompilerNode, ['temps'], 'Compiler');

smalltalk.addClass("ReturnNode",smalltalk.CompilerNode, [], 'Compiler');

smalltalk.addClass("ValueNode",smalltalk.CompilerNode, ['value'], 'Compiler');

smalltalk.addClass("JSStatementNode",smalltalk.CompilerNode, ['source'], 'Compiler');

smalltalk.addClass("BlockSequenceNode",smalltalk.SequenceNode, [], 'Compiler');

smalltalk.addClass("ExtendedSequenceNode",smalltalk.SequenceNode, ['directive'], 'Compiler');

smalltalk.addClass("VariableNode",smalltalk.ValueNode, ['indices'], 'Compiler');

smalltalk.addClass("GlobalReferenceNode",smalltalk.VariableNode, [], 'Compiler');

smalltalk.addClass("NoReceiverNode",smalltalk.VariableNode, [], 'Compiler');

smalltalk.addClass("AlienNode",smalltalk.VariableNode, [], 'Compiler');

smalltalk.addClass("PPEOFParser",smalltalk.PPParser, [], 'Compiler-Parser');

smalltalk.addClass("PPAnyParser",smalltalk.PPParser, [], 'Compiler-Parser');

smalltalk.addClass("PPEpsilonParser",smalltalk.PPParser, [], 'Compiler-Parser');

smalltalk.addClass("PPStringParser",smalltalk.PPParser, ['string'], 'Compiler-Parser');

smalltalk.addClass("PPStStringParser",smalltalk.PPParser, [], 'Compiler-Parser');

smalltalk.addClass("PPCharacterParser",smalltalk.PPParser, ['regexp'], 'Compiler-Parser');

smalltalk.addClass("PPListParser",smalltalk.PPParser, ['parsers'], 'Compiler-Parser');

smalltalk.addClass("PPDelegateParser",smalltalk.PPParser, ['parser'], 'Compiler-Parser');

smalltalk.addClass("PPSequenceParser",smalltalk.PPListParser, [], 'Compiler-Parser');

smalltalk.addClass("PPChoiceParser",smalltalk.PPListParser, [], 'Compiler-Parser');

smalltalk.addClass("PPAndParser",smalltalk.PPDelegateParser, [], 'Compiler-Parser');

smalltalk.addClass("PPActionParser",smalltalk.PPDelegateParser, ['block'], 'Compiler-Parser');

smalltalk.addClass("PPFlattenParser",smalltalk.PPDelegateParser, [], 'Compiler-Parser');

smalltalk.addClass("PPSourceParser",smalltalk.PPDelegateParser, [], 'Compiler-Parser');

smalltalk.addClass("PPRepeatingParser",smalltalk.PPDelegateParser, ['min'], 'Compiler-Parser');

smalltalk.addClass("PPNotParser",smalltalk.PPAndParser, [], 'Compiler-Parser');

smalltalk.addClass("ChunkReader",smalltalk.FileInReader, ['actionBlock', 'terminationBlock'], 'Compiler-FileIn');

smalltalk.ChunkReader.$comment=unescape("%0D%0A%09Pluggable%20FileInReader.%0D%0A%09actionBlock%20is%20evaluated%20with%20input%20stream%20as%20argument.%0D%0A%09Read%20chunks%20until%20empty%20chunk%2C%20terminationBlock%20is%20nil%20or%20evaluates%20to%20true.")

smalltalk.addClass("ClassCategoryReader",smalltalk.FileInReader, ['class', 'category'], 'Compiler-FileIn');

smalltalk.addClass("ClassCommentReader",smalltalk.FileInReader, ['class'], 'Compiler-FileIn');

smalltalk.addClass("CancelFileInReader",smalltalk.FileInReader, [], 'Compiler-FileIn');

smalltalk.addClass("AssociationsReader",smalltalk.FileInReader, [], 'Compiler-FileIn');

smalltalk.addClass("PoolDictionaryReader",smalltalk.AssociationsReader, ['scope'], 'Compiler-FileIn');

smalltalk.addClass("JSReader",smalltalk.AssociationsReader, ['object'], 'Compiler-FileIn');

smalltalk.addClass("PhoneGap",smalltalk.NativeObject, [], 'PG8');

smalltalk.PhoneGap.$comment=unescape("%0D%0A%09Root%20of%20PhoneGap%20framework%20hierarchy.%0D%0A%09PhoneGap%20is%20an%20HTML5%20app%20platform%20that%20allows%20you%20to%20author%20native%20applications%20with%20web%20technologies%20and%20get%20access%20to%20APIs%20and%20app%20stores.%0D%0A%09http%3A//phonegap.com%0D%0A%09@2011%20Alejandro%20Reimondo%20-%20aleReimondo@smalltalking.net%0D%0A")

smalltalk.addClass("DOM",smalltalk.NativeObject, [], 'DOM');

smalltalk.addClass("JS",smalltalk.NativeObject, [], 'Natives');

smalltalk.JS.$comment=unescape("%0D%0A%09Implementation%20of%20reflection%20interface%20for%20%28js%29%20objects.%0D%0A%09@2011%20Alejandro%20F.%20Reimondo%0D%0A%09aleReimondo@smalltalking.net%0D%0A")

smalltalk.addClass("NativeLibraryObject",smalltalk.NativeObject, [], 'Natives');

smalltalk.NativeLibraryObject.$comment=unescape("%0D%0A%09Abstract%20wrapper%20to%20external%20Javascript%20library.%0D%0A%09@2012%20Alejandro%20Reimondo%20-%20aleReimondo@smalltalking.net%0D%0A")

smalltalk.NativeLibraryObject.$classVariableNames="BindingListeners"

smalltalk.addClass("PG8LocalStorage",smalltalk.PhoneGap, [], 'PG8');

smalltalk.PG8LocalStorage.$comment=unescape("%0D%0A%09Provides%20access%20to%20a%20W3C%20Storage%20interface.%0D%0A%09http%3A//dev.w3.org/html5/webstorage/%23the-localstorage-attribute%0D%0A")

smalltalk.addClass("PG8SQLResultSet",smalltalk.PhoneGap, [], 'PG8');

smalltalk.PG8SQLResultSet.$comment=unescape("%0D%0A%09The%20result%20of%20executeSql%20message%20object%20has%20three%20properties.%0D%0A%09The%20first%20is%20the%20insertId%20which%20will%20return%20the%20row%20number%20of%20a%20success%20SQL%20insert%20statement.%0D%0A%09If%20the%20SQL%20statement%20is%20not%20an%20insert%20then%20the%20insertId%20is%20not%20set.%0D%0A%09The%20rowAffected%20is%20always%200%20for%20a%20SQL%20select%20statement.%0D%0A%09For%20insert%20or%20update%20statements%20it%20returns%20the%20number%20of%20rows%20that%20have%20been%20modified.%0D%0A%09The%20final%20property%20is%20of%20type%20SQLResultSetList%20and%20it%20contains%20the%20data%20returned%20from%20a%20SQL%20select%20statement.%0D%0A")

smalltalk.addClass("PG8SQLTransaction",smalltalk.PhoneGap, [], 'PG8');

smalltalk.PG8SQLTransaction.$comment=unescape("%0D%0A%09Execute%20SQL%20statements%20against%20the%20Database.%0D%0A")

smalltalk.addClass("Notification",smalltalk.PhoneGap, [], 'PG8');

smalltalk.Notification.$comment=unescape("%0D%0A%09Visual%2C%20audible%2C%20and%20tactile%20device%20notifications.%0D%0A")

smalltalk.addClass("GeoCoordinates",smalltalk.PhoneGap, [], 'PG8');

smalltalk.GeoCoordinates.$comment=unescape("%0D%0A%09Instances%20contain%20geoggraphic%20coordinates%20of%20a%20GeoPosition.%0D%0A")

smalltalk.addClass("GeoPosition",smalltalk.PhoneGap, [], 'PG8');

smalltalk.GeoPosition.$comment=unescape("%0D%0A%09Instances%20contain%20coordinates%20created%20by%20geolocation%20API.%0D%0A")

smalltalk.addClass("FileUploadResult",smalltalk.PhoneGap, [], 'PG8');

smalltalk.FileUploadResult.$comment=unescape("%0D%0A%09A%20file%20upload%20succeded.%20Instance%20has%20report%20information.%0D%0A")

smalltalk.addClass("FileUploadOptions",smalltalk.PhoneGap, [], 'PG8');

smalltalk.FileUploadOptions.$comment=unescape("%0D%0A%09Specify%20additional%20parameters%20to%20the%20upload%20script.%0D%0A")

smalltalk.addClass("FileTransfer",smalltalk.PhoneGap, [], 'PG8');

smalltalk.FileTransfer.$comment=unescape("%0D%0A%09Instances%20allows%20you%20to%20upload%20files%20to%20a%20server.%0D%0A")

smalltalk.addClass("DirectoryReader",smalltalk.PhoneGap, [], 'PG8');

smalltalk.addClass("PG8File",smalltalk.PhoneGap, [], 'PG8');

smalltalk.PG8File.$comment=unescape("%0D%0A%09Instances%20contains%20attributes%20of%20a%20single%20file.%0D%0A")

smalltalk.addClass("Metadata",smalltalk.PhoneGap, [], 'PG8');

smalltalk.Metadata.$comment=unescape("%0D%0A%09Instances%20supplies%20information%20about%20the%20state%20of%20a%20file%20or%20directory.%0D%0A")

smalltalk.addClass("FileAccessor",smalltalk.PhoneGap, [], 'PG8');

smalltalk.FileAccessor.$comment=unescape("%0D%0A%09Abstract%20interface%20to%20read/write%20files%20from%20the%20devices%20file%20system.%0D%0A")

smalltalk.addClass("FileEntity",smalltalk.PhoneGap, [], 'PG8');

smalltalk.addClass("ContactOrganization",smalltalk.PhoneGap, [], 'PG8');

smalltalk.ContactOrganization.$comment=unescape("%0D%0A%09Organization%20related%20properties%20of%20a%20contact.%0D%0A")

smalltalk.addClass("ContactName",smalltalk.PhoneGap, [], 'PG8');

smalltalk.ContactName.$comment=unescape("%0D%0A%09Name%20related%20properties%20of%20a%20contact.%0D%0A")

smalltalk.addClass("ContactField",smalltalk.PhoneGap, [], 'PG8');

smalltalk.ContactField.$comment=unescape("%0D%0A%09Generic%20fields%20in%20a%20Contact%20object.%0D%0A%09Some%20properties%20that%20are%20stored%20as%20ContactField%20objects%20include%20email%20addresses%2C%20phone%20numbers%2C%20and%20urls.%0D%0A")

smalltalk.addClass("ContactAddress",smalltalk.PhoneGap, [], 'PG8');

smalltalk.ContactAddress.$comment=unescape("%0D%0A%09A%20single%20address%20of%20a%20contact.%0D%0A%09A%20Contact%20object%20can%20have%20one%20or%20more%20addresses.%0D%0A")

smalltalk.addClass("Contact",smalltalk.PhoneGap, [], 'PG8');

smalltalk.Contact.$comment=unescape("%0D%0A%09Describe%20a%20contact%2C%20such%20as%20a%20user%20personal%20or%20business%20contact.%0D%0A")

smalltalk.addClass("CompassHeading",smalltalk.PhoneGap, [], 'PG8');

smalltalk.CompassHeading.$comment=unescape("%0D%0A%09Compass%20data%20captured%20at%20a%20specific%20point%20in%20time.")

smalltalk.addClass("MediaFileData",smalltalk.PhoneGap, [], 'PG8');

smalltalk.MediaFileData.$comment=unescape("%0D%0A%09Format%20information%20about%20a%20captured%20media%20file.%0D%0A")

smalltalk.addClass("PhoneGapEvents",smalltalk.PhoneGap, [], 'PG8');

smalltalk.addClass("Device",smalltalk.PhoneGap, [], 'PG8');

smalltalk.Device.$comment=unescape("%0D%0A%09Describes%20the%20device%20hardware%20and%20software.%0D%0A")

smalltalk.addClass("Acceleration",smalltalk.PhoneGap, [], 'PG8');

smalltalk.Acceleration.$comment=unescape("%0D%0A%09Accelerometer%20data%20captured%20at%20a%20specific%20point%20in%20time.")

smalltalk.addClass("PG8AsyncObject",smalltalk.PhoneGap, ['id'], 'PG8');

smalltalk.addClass("FileWriter",smalltalk.FileAccessor, [], 'PG8');

smalltalk.FileWriter.$comment=unescape("%0D%0A%09FileWriter%20is%20a%20way%20to%20write%20files%20from%20the%20devices%20file%20system.%0D%0A%09Users%20register%20their%20own%20event%20listeners%20to%20receive%20the%20writestart%2C%20progress%2C%20write%2C%20writeend%2C%20error%20and%20abort%20events.%0D%0A%09A%20FileWriter%20is%20created%20for%20a%20single%20file.%0D%0A%09You%20can%20use%20it%20to%20write%20to%20a%20file%20multiple%20times.%0D%0A%09The%20FileWriter%20maintains%20the%20file%20position%20and%20length%20attributes%2C%20so%20you%20can%20seek%20and%20write%20anywhere%20in%20the%20file.%0D%0A%09By%20default%2C%20the%20FileWriter%20writes%20to%20the%20beginning%20of%20the%20file%20%28will%20overwrite%20existing%20data%29.%0D%0A")

smalltalk.addClass("FileReader",smalltalk.FileAccessor, [], 'PG8');

smalltalk.FileReader.$comment=unescape("%0D%0A%09FileReader%20is%20a%20way%20to%20read%20files%20from%20the%20devices%20file%20system.%0D%0A%09Files%20can%20be%20read%20as%20text%20or%20as%20a%20base64%20data%20encoded%20string.%0D%0A%09Users%20register%20their%20own%20event%20listners%20to%20receive%20the%20loadstart%2C%20progress%2C%20load%2C%20loadend%2C%20error%20and%20abort%20events.%0D%0A")

smalltalk.addClass("FileSystemElement",smalltalk.FileEntity, [], 'PG8');

smalltalk.addClass("FileSystem",smalltalk.FileEntity, [], 'PG8');

smalltalk.FileSystem.$comment=unescape("%0D%0A%09Instances%20represents%20information%20about%20the%20file%20system.%0D%0A%09The%20name%20of%20the%20file%20system%20will%20be%20unique%20across%20the%20list%20of%20exposed%20file%20systems.%0D%0A%09The%20root%20property%20contains%20a%20DirectoryEntry%20object%20which%20represents%20the%20root%20directory%20of%20the%20file%20system.%0D%0A")

smalltalk.addClass("FileEntry",smalltalk.FileSystemElement, [], 'PG8');

smalltalk.FileEntry.$comment=unescape("%0D%0A%09Instances%20represents%20a%20file%20on%20a%20file%20system.%0D%0A%09It%20is%20defined%20in%20the%20W3C%20Directories%20and%20Systems%20specification.%0D%0A")

smalltalk.addClass("DirectoryEntry",smalltalk.FileSystemElement, [], 'PG8');

smalltalk.DirectoryEntry.$comment=unescape("%0D%0A%09Instances%20represents%20a%20directory%20on%20a%20file%20system.%0D%0A%09It%20is%20defined%20in%20the%20W3C%20Directories%20and%20Systems%20specification.%0D%0A")

smalltalk.addClass("Contacts",smalltalk.PG8AsyncObject, ['fields'], 'PG8');

smalltalk.addClass("PG8DataBase",smalltalk.PG8AsyncObject, [], 'PG8');

smalltalk.PG8DataBase.$comment=unescape("%0D%0A%09Provides%20access%20to%20the%20devices%20storage%20options.%20%0D%0A%09This%20API%20is%20based%20on%20the%20W3C%20Web%20SQL%20Database%20Specification%20and%20W3C%20Web%20Storage%20API%20Specification.%0D%0A%09Some%20devices%20already%20provide%20an%20implementation%20of%20this%20spec.%0D%0A")

smalltalk.addClass("MediaFile",smalltalk.PG8AsyncObject, [], 'PG8');

smalltalk.MediaFile.$comment=unescape("%0D%0A%09Properties%20of%20a%20media%20capture%20file.%0D%0A")

smalltalk.addClass("Geolocation",smalltalk.PG8AsyncObject, [], 'PG8');

smalltalk.Geolocation.$comment=unescape("%0D%0A%09Instances%20provide%20access%20to%20the%20device%20GPS%20sensor.%20%0D%0A%09Geolocation%20provides%20location%20information%20for%20the%20device%2C%20such%20as%20latitude%20and%20longitude.%0D%0A%09Common%20sources%20of%20location%20information%20include%20Global%20Positioning%20System%20%28GPS%29%20and%20location%20inferred%20from%20network%20signals%20such%20as%20IP%20address%2C%20RFID%2C%20WiFi%20and%20Bluetooth%20MAC%20addresses%2C%20and%20GSM/CDMA%20cell%20IDs.%0D%0A%09No%20guarantee%20is%20given%20that%20the%20API%20returns%20the%20device%20actual%20location.%0D%0A%09This%20API%20is%20based%20on%20the%20W3C%20Geo%20location%20API%20Specification.%0D%0A")

smalltalk.addClass("Connection",smalltalk.PG8AsyncObject, [], 'PG8');

smalltalk.Connection.$comment=unescape("%0D%0A%09Checks%20the%20active%20network%20connection%20that%20is%20being%20used.%0D%0A%09A%20fast%20way%20to%20determine%20the%20device%20network%20connection%20state%2C%20and%20type%20of%20connection.")

smalltalk.addClass("Compass",smalltalk.PG8AsyncObject, [], 'PG8');

smalltalk.Compass.$comment=unescape("%0D%0A%09The%20compass%20is%20a%20sensor%20that%20detects%20the%20direction%20that%20the%20device%20is%20pointed.%0D%0A%09It%20measures%20the%20heading%20in%20degrees%20from%200%20to%20359.99.%0D%0A")

smalltalk.addClass("Capture",smalltalk.PG8AsyncObject, [], 'PG8');

smalltalk.addClass("Camera",smalltalk.PG8AsyncObject, [], 'PG8');

smalltalk.Camera.$comment=unescape("%0D%0A%09The%20camera%20object%20provides%20access%20to%20the%20device%20default%20camera%20application.%0D%0A%09Open%20the%20device%20default%20camera%20application%20so%20that%20the%20user%20can%20take%20a%20picture.%0D%0A%09Once%20the%20photo%20is%20taken%2C%20the%20camera%20application%20closes%20and%20your%20application%20is%20restored.%0D%0A")

smalltalk.addClass("Accelerometer",smalltalk.PG8AsyncObject, [], 'PG8');

smalltalk.Accelerometer.$comment=unescape("%0D%0A%09The%20accelerometer%20is%20a%20motion%20sensor%20that%20detects%20the%20change%20%28delta%29%20in%20movement%20relative%20to%20the%20current%20device%20orientation.%0D%0A%09The%20accelerometer%20can%20detect%203D%20movement%20along%20the%20x%2C%20y%2C%20and%20z%20axis.%0D%0A")

smalltalk.addClass("CompassFilter",smalltalk.Compass, [], 'PG8');

smalltalk.CompassFilter.$comment=unescape("%0D%0A%09The%20CompassFilter%20is%20a%20sensor%20that%20detects%20the%20heading%20that%20the%20device%20is%20pointed.%0D%0A%09It%20measures%20the%20heading%20in%20degrees%20from%200%20to%20359.99.%0D%0A")

smalltalk.addClass("CaptureVideo",smalltalk.Capture, [], 'PG8');

smalltalk.addClass("CaptureImage",smalltalk.Capture, [], 'PG8');

smalltalk.addClass("CaptureAudio",smalltalk.Capture, [], 'PG8');

smalltalk.addClass("DOMEventModel",smalltalk.DOM, [], 'DOM-Events');

smalltalk.addClass("DOMNode",smalltalk.DOM, [], 'DOM');

smalltalk.addClass("DOMDocument",smalltalk.DOM, [], 'DOM');

smalltalk.addClass("BrowserObject",smalltalk.DOM, [], 'DOM-Browser');

smalltalk.addClass("HTML5",smalltalk.DOM, [], 'DOM-HTML5');

smalltalk.addClass("TouchList",smalltalk.DOMEventModel, [], 'DOM-Events');

smalltalk.addClass("Touch",smalltalk.DOMEventModel, [], 'DOM-Events');

smalltalk.addClass("DOMEventListener",smalltalk.DOMEventModel, [], 'DOM-Events');

smalltalk.addClass("DOMEvent",smalltalk.DOMEventModel, [], 'DOM-Events');

smalltalk.addClass("HTML5EventModel",smalltalk.DOMEventModel, [], 'DOM-HTML5');

smalltalk.addClass("MessageEvent",smalltalk.DOMEvent, [], 'DOM-Events');

smalltalk.addClass("TouchEvent",smalltalk.DOMEvent, [], 'DOM-Events');

smalltalk.addClass("DOMMouseEvent",smalltalk.DOMEvent, [], 'DOM-Events');

smalltalk.addClass("DOMMutationEvent",smalltalk.DOMEvent, [], 'DOM-Events');

smalltalk.addClass("DOMUIEvent",smalltalk.DOMEvent, [], 'DOM-Events');

smalltalk.addClass("MessagePort",smalltalk.HTML5EventModel, [], 'DOM-HTML5');

smalltalk.addClass("DOMAttribute",smalltalk.DOMNode, [], 'DOM-HTML');

smalltalk.addClass("DOMElement",smalltalk.DOMNode, [], 'DOM');

smalltalk.DOMElement.$classVariableNames="TagMap"

smalltalk.addClass("DOMCharacterData",smalltalk.DOMNode, [], 'DOM');

smalltalk.addClass("HTMLElement",smalltalk.DOMElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLUList",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLTitle",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLTextarea",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLThead",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLTfoot",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLTbody",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLTableRow",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLTableCol",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLTableCell",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLTableCaption",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLTable",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLStyle",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLSelect",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLScript",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLQuote",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLPre",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLParam",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLParagraph",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLOption",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLOptGroup",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLOList",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLObject",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLMod",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLMeta",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLMenu",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLMap",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLLink",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLLI",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLLegend",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLILayer",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLLayer",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLLabel",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLIsIndex",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLInput",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLImage",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLIFrame",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLPage",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLHR",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLHead",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLHeading",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLFrameset",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLFrame",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLForm",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLFont",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLFieldSet",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLDiv",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLDList",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLDirectory",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLButton",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLBR",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLBody",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLBlockquote",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLBaseFont",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLBase",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLArea",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLApplet",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLAnchor",smalltalk.HTMLElement, [], 'DOM-HTML');

smalltalk.addClass("HTMLInputText",smalltalk.HTMLInput, [], 'DOM-HTML');

smalltalk.addClass("HTMLInputRadio",smalltalk.HTMLInput, [], 'DOM-HTML');

smalltalk.addClass("HTMLInputHidden",smalltalk.HTMLInput, [], 'DOM-HTML');

smalltalk.addClass("HTMLInputFile",smalltalk.HTMLInput, [], 'DOM-HTML');

smalltalk.addClass("HTMLInputCheckbox",smalltalk.HTMLInput, [], 'DOM-HTML');

smalltalk.addClass("HTMLInputButton",smalltalk.HTMLInput, [], 'DOM-HTML');

smalltalk.addClass("HTMLInputPassword",smalltalk.HTMLInputText, [], 'DOM-HTML');

smalltalk.addClass("HTMLInputSubmit",smalltalk.HTMLInputButton, [], 'DOM-HTML');

smalltalk.addClass("HTMLInputReset",smalltalk.HTMLInputButton, [], 'DOM-HTML');

smalltalk.addClass("DOMText",smalltalk.DOMCharacterData, [], 'DOM');

smalltalk.addClass("HTMLDocument",smalltalk.DOMDocument, [], 'DOM-HTML');

smalltalk.addClass("BrowserScreen",smalltalk.BrowserObject, [], 'DOM-Browser');

smalltalk.addClass("BrowserNavigator",smalltalk.BrowserObject, [], 'DOM-Browser');

smalltalk.addClass("BrowserLocation",smalltalk.BrowserObject, [], 'DOM-Browser');

smalltalk.addClass("BrowserHistory",smalltalk.BrowserObject, [], 'DOM-Browser');

smalltalk.addClass("BrowserWindow",smalltalk.BrowserObject, [], 'DOM-Browser');

smalltalk.addClass("HTML5Structure",smalltalk.HTML5, [], 'DOM-HTML5');

smalltalk.addClass("Set",smalltalk.Collection, ['contents'], 'Kernel');

smalltalk.addClass("Dictionary",smalltalk.Collection, ['keys', 'values'], 'Kernel');

smalltalk.addClass("SequenceableCollection",smalltalk.Collection, [], 'Kernel');

smalltalk.addClass("HashedSet",smalltalk.Set, ['hash'], 'Kernel');

smalltalk.addClass("ArrayedContents",smalltalk.SequenceableCollection, ['contents'], 'Kernel');

if(Array && !smalltalk.Array) smalltalk.mapClassName("Array","Kernel",Array,smalltalk.SequenceableCollection);

smalltalk.addClass("Array",smalltalk.SequenceableCollection, [], 'Kernel');

if(String && !smalltalk.String) smalltalk.mapClassName("String","Kernel",String,smalltalk.SequenceableCollection);

smalltalk.addClass("String",smalltalk.SequenceableCollection, [], 'Kernel');

smalltalk.addClass("ComposedAssociations",smalltalk.ArrayedContents, [], 'Kernel');

if(StMetaclass && !smalltalk.Metaclass) smalltalk.mapClassName("Metaclass","Kernel",StMetaclass,smalltalk.Behavior);

smalltalk.addClass("Metaclass",smalltalk.Behavior, ['instanceClass'], 'Kernel');

if(StClass && !smalltalk.Class) smalltalk.mapClassName("Class","Kernel",StClass,smalltalk.Behavior);

smalltalk.addClass("Class",smalltalk.Behavior, [], 'Kernel');


smalltalk.bind(smalltalk.Object.$klass,"eventsTriggered","eventsTriggered"

,function (){var self=this;return self.constructEventsTriggered();return self;}

,"events",unescape("eventsTriggered%0D%0A%09%22%20Return%20all%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20constructEventsTriggered"));

smalltalk.bind(smalltalk.Object.$klass,"constructEventsTriggered","constructEventsTriggered"

,function (){var self=this;return ["changed"];return self;}

,"events",unescape("constructEventsTriggered%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%0D%0A%09The%20default%20implementation%20return%20support%20for%20MVC%20change/update%20mechanism.%0D%0A%09This%20method%20can%20be%20refined%20by%20the%20subclasses%20to%20extend%20event%20support.%0D%0A%09%22%0D%0A%0D%0A%09%5E%23%28%20%23changed%20%29"));

smalltalk.bind(smalltalk.Object.$klass,"canTriggerEvent:","canTriggerEvent_"

,function (anEvent){var self=this;return self.eventsTriggered().includes_(anEvent);return self;}

,"events",unescape("canTriggerEvent%3A%20anEvent%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20trigger%20anEvent.%22%0D%0A%0D%0A%09%5Eself%20eventsTriggered%20includes%3A%20anEvent"));

smalltalk.bind(smalltalk.Object,"print:","print_"

,function (aString){var self=this;print(aString);return self;}

,"printing",unescape("print%3A%20aString%0D%0A%09%22%20Output%20aString%20to%20output%20device.%20%22%0D%0A%0D%0A%09%23%20%23print%3A%20aString"));

smalltalk.bind(smalltalk.Object,"fileIn:","fileIn_"

,function (fileName){var self=this;self.print_(unescape("//%20fileIn%28%22")._comma(fileName)._comma(unescape("%22%29%3B")));

return fileIn(fileName);return self;}

,"fileIn",unescape("fileIn%3A%20fileName%0D%0A%09%22%20FileIn%20contents%20of%20file%20at%20fileName.%20%22%0D%0A%0D%0A%09self%20print%3A%20%27//%20fileIn%28%22%27%2C%20fileName%2C%20%27%22%29%3B%27.%0D%0A%09%5E%23%20%23fileIn%3A%20fileName"));

smalltalk.bind(smalltalk.Object,"fileInJS:","fileInJS_"

,function (fileName){var self=this;self.print_(unescape("//%20fileInJS%28%22")._comma(fileName)._comma(unescape("%22%29%3B")));

return fileInJS(fileName);return self;}

,"fileIn",unescape("fileInJS%3A%20fileName%0D%0A%09%22%20Load%20javascript%20code%20from%20file%20at%20fileName.%20%22%0D%0A%0D%0A%09self%20print%3A%20%27//%20fileInJS%28%22%27%2C%20fileName%2C%20%27%22%29%3B%27.%0D%0A%09%5E%23%20%23fileInJS%3A%20fileName"));

smalltalk.bind(smalltalk.Object,"halt","halt"

,function (){var self=this; debugger; ;return self;}

,"debug",unescape("halt%0D%0A%09%22%20Private%20-%20Halt%20execution%20entering%20debugger.%20%22%0D%0A%0D%0A%7B%27%20debugger%3B%20%27%7D"));

smalltalk.bind(smalltalk.Object,"notImplementedYet","notImplementedYet"

,function (){var self=this;self.halt();

self.error_("Not implemented. Yet");return self;}

,"development",unescape("notImplementedYet%0D%0A%09%22%20Private%20-%20Halt%20execution%20and/or%20generate%20an%20error%20reporting%20implementation%20incomplete.%20%22%0D%0A%0D%0A%09self%20halt.%0D%0A%09self%20error%3A%20%27Not%20implemented.%20Yet%27"));

smalltalk.bind(smalltalk.Object,"accept:","accept_"

,function (what){var self=this;self.print_(unescape("%5Bbug%5D%20")._comma(self.asString())._comma(" accept: ")._comma(what.asString()));

return self.error_(unescape("%23accept%3A%20out%20of%20control."));return self;}

,unescape("compiler/parser%20bug"),unescape("accept%3A%20what%0D%0A%09%22%20Private%20-%20Report%20buggy%20send%20in%20compiler.%20%22%0D%0A%0D%0A%09self%20print%3A%20%27%5Bbug%5D%20%27%2Cself%20asString%2C%27%20accept%3A%20%27%2Cwhat%20asString.%0D%0A%09%5Eself%20error%3A%20%27%23accept%3A%20out%20of%20control.%27"));

smalltalk.bind(smalltalk.Object,"=","_eq"

,function (anObject){var self=this;	return self == anObject;return self;}

,"comparing",unescape("%3D%20anObject%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20equal%20to%20anObject.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%3D%3D%20anObject%27%7D"));

smalltalk.bind(smalltalk.Object,"~=","_no_eq"

,function (anObject){var self=this;return (self._eq(anObject) === false);return self;}

,"comparing",unescape("%7E%3D%20anObject%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20not%20equal%20to%20anObject.%20%22%0D%0A%0D%0A%09%5E%28self%20%3D%20anObject%29%20%3D%3D%20false"));

smalltalk.bind(smalltalk.Object,"initialize","initialize"

,function (){var self=this;return self;}

,"initialize",unescape("initialize%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%0D%0A%09The%20default%20implementation%20do%20nothing.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses%20to%20support%20creation%20time%20initialization%20of%20collaborators.%0D%0A%09%22"));

smalltalk.bind(smalltalk.Object,"yourself","yourself"

,function (){var self=this;return self;return self;}

,"identity",unescape("yourself%0D%0A%09%22%20Return%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Object,"class","$$class"

,function (){var self=this;return (self["$klass"] || nil);return self;}

,"accessing",unescape("class%0D%0A%09%22%20Return%20the%20class%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24klass%27"));

smalltalk.bind(smalltalk.Object,"size","size"

,function (){var self=this;return (0);return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%0D%0A%09The%20default%20implementation%20return%20zero.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses%20to%20support%20indexed%20access.%0D%0A%09%22%0D%0A%0D%0A%09%5E0"));

smalltalk.bind(smalltalk.Object,"copy","copy"

,function (){var self=this;return self.shallowCopy();return self;}

,"copying",unescape("copy%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20shallowCopy"));

smalltalk.bind(smalltalk.Object,"shallowCopy","shallowCopy"

,function (){var self=this;var result=nil;result=self.$klass.basicNew();

	for(var i in self) {
		if (!self.hasOwnProperty[i]) break;
		if(/^@.+/.test(i)) { result[i] = self[i]; }
	};
	return result;;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20class%20basicNew.%0D%0A%7B%27%09for%28var%20i%20in%20self%29%20%7B%0D%0A%09%09if%20%28%21self.hasOwnProperty%5Bi%5D%29%20break%3B%0D%0A%09%09if%28/%5E@.+/.test%28i%29%29%20%7B%20result%5Bi%5D%20%3D%20self%5Bi%5D%3B%20%7D%0D%0A%09%7D%3B%0D%0A%09return%20result%3B%27%7D"));

smalltalk.bind(smalltalk.Object,"deepCopy","deepCopy"

,function (){var self=this;var result=nil;result=self.$klass.basicNew();

	for(var i in self) {
		if (!self.hasOwnProperty[i]) break;
		if(/^@.+/.test(i)) { result[i] = self[i].deepCopy(); }
	};
	return result;;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20class%20basicNew.%0D%0A%7B%27%09for%28var%20i%20in%20self%29%20%7B%0D%0A%09%09if%20%28%21self.hasOwnProperty%5Bi%5D%29%20break%3B%0D%0A%09%09if%28/%5E@.+/.test%28i%29%29%20%7B%20result%5Bi%5D%20%3D%20self%5Bi%5D.deepCopy%28%29%3B%20%7D%0D%0A%09%7D%3B%0D%0A%09return%20result%3B%27%7D."));

smalltalk.bind(smalltalk.Object,"->","_minus_gt"

,function (anObject){var self=this;return smalltalk.Association.key_value_(self, anObject);return self;}

,"converting",unescape("-%3E%20anObject%0D%0A%09%22%20Return%20an%20association%20of%20the%20receiver%20to%20anObject.%20%22%0D%0A%0D%0A%09%5EAssociation%20key%3A%20self%20value%3A%20anObject"));

smalltalk.bind(smalltalk.Object,"asString","asString"

,function (){var self=this;return self.printString();return self;}

,"converting",unescape("asString%0D%0A%09%22%20Return%20the%20receiver%20as%20a%20String.%20%22%0D%0A%0D%0A%09%5Eself%20printString"));

smalltalk.bind(smalltalk.Object,"toString","toString"

,function (){var self=this;return unescape("%7Bst%3Aa")._comma(self.$klass.name())._comma(unescape("%7D"));return self;}

,"converting",unescape("toString%0D%0A%09%22%20Convert%20the%20receiver%20to%20a%20String.%20%22%0D%0A%0D%0A%09%5E%27%7Bst%3Aa%27%2Cself%20class%20name%2C%24%7D"));

smalltalk.bind(smalltalk.Object,"asJavascript","asJavascript"

,function (){var self=this;return self.asString();return self;}

,"converting",unescape("asJavascript%0D%0A%09%22%20Return%20the%20javascript%20representation%20of%20the%20receiver.%0D%0A%09The%20default%20implementation%20return%20the%20receiver%20as%20a%20String.%0D%0A%09This%20method%20must%20be%20refined%20by%20subclasses%20implementing%20literal%20representation%20in%20javascript.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20asString"));

smalltalk.bind(smalltalk.Object,"asJSON","asJSON"

,function (){var self=this;var json=nil;json=smalltalk.Smalltalk.current().jsObjectAt_("JSON");

return json.stringify(self.asJSONObject());return self;}

,"converting",unescape("asJSON%0D%0A%09%22%20JSON%20-%20Return%20the%20JSON%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20json%20%7C%0D%0A%09json%20%3A%3D%20Smalltalk%20current%20jsObjectAt%3A%20%23JSON.%0D%0A%09%5Ejson%20%23stringify%3A%20self%20asJSONObject"));

smalltalk.bind(smalltalk.Object,"escapedCode","escapedCode"

,function (){var self=this;return self.asJavascript();return self;}

,"converting",unescape("escapedCode%0D%0A%09%22%20Return%20the%20code%20to%20reproduce%20receiver%20from%20%28javascript%29%20code.%20%22%0D%0A%0D%0A%09%5Eself%20asJavascript"));

smalltalk.bind(smalltalk.Object,"perform:","perform_"

,function (aSymbol){var self=this;return self.perform_withArguments_(aSymbol, []);return self;}

,unescape("message%20handling"),unescape("perform%3A%20aSymbol%0D%0A%09%22%20Return%20the%20result%20of%20sending%20message%20aSymbol%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20perform%3A%20aSymbol%20withArguments%3A%20%23%28%29"));

smalltalk.bind(smalltalk.Object,"perform:with:","perform_with_"

,function (aSymbol,argument){var self=this;return self.perform_withArguments_(aSymbol, smalltalk.Array.with_(argument));return self;}

,unescape("message%20handling"),unescape("perform%3A%20aSymbol%20with%3A%20argument%0D%0A%09%22%20Return%20the%20result%20of%20sending%20message%20aSymbol%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20perform%3A%20aSymbol%20withArguments%3A%20%28Array%20with%3A%20argument%29"));

smalltalk.bind(smalltalk.Object,"perform:withArguments:","perform_withArguments_"

,function (aSymbol,aCollection){var self=this;return self.basicPerform_withArguments_(aSymbol.asSelector(), aCollection);return self;}

,unescape("message%20handling"),unescape("perform%3A%20aSymbol%20withArguments%3A%20aCollection%0D%0A%09%22%20Return%20the%20result%20of%20sending%20message%20aSymbol%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicPerform%3A%20aSymbol%20asSelector%20withArguments%3A%20aCollection"));

smalltalk.bind(smalltalk.Object,"basicAt:","basicAt_"

,function (aString){var self=this;return (self[aString] || nil);return self;}

,"accessing",unescape("basicAt%3A%20aString%0D%0A%09%22%20Return%20the%20property%20of%20the%20receiver%20known%20as%20aString%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%5BaString%5D%20%7C%7C%20nil"));

smalltalk.bind(smalltalk.Object,"basicAt:ifAbsent:","basicAt_ifAbsent_"

,function (aString,aBlock){var self=this;return (self[aString] || aBlock.value());return self;}

,"accessing",unescape("basicAt%3A%20aString%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20property%20of%20the%20receiver%20known%20as%20aString%20%28or%20the%20result%20of%20evaluating%20aBlock%29.%20%22%0D%0A%0D%0A%09%5Eself%5BaString%5D%20%7C%7C%20aBlock%20value"));

smalltalk.bind(smalltalk.Object,"basicAt:ifAbsentPut:","basicAt_ifAbsentPut_"

,function (aString,aBlock){var self=this;return (self[aString] || (function(){return (self[aString]=(aBlock.value()));}).value());return self;}

,"accessing",unescape("basicAt%3A%20aString%20ifAbsentPut%3A%20aBlock%0D%0A%09%22%20Return%20the%20property%20of%20the%20receiver%20known%20as%20aString%20%28or%20set%20it%20with%20the%20result%20of%20evaluating%20aBlock%29.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20aString%20ifAbsent%3A%20%5B%20self%20basicAt%3A%20aString%20put%3A%20aBlock%20value%20%5D"));

smalltalk.bind(smalltalk.Object,"instVarAt:","instVarAt_"

,function (instVarName){var self=this;try{((instVarName.isNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "instVarAt_", fn: function(){return self.instVarAt_(self.$klass.allInstVarNames().at_(instVarName))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "instVarAt_", fn: function(){return (self[unescape("@")._comma(instVarName)] || nil)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "instVarAt_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("instVarAt%3A%20instVarName%0D%0A%09%22%20Return%20the%20internal%20collaborator%20of%20the%20receiver%20known%20as%20instVarName.%20%22%0D%0A%0D%0A%09instVarName%20isNumber%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20instVarAt%3A%20%28self%20class%20allInstVarNames%20at%3A%20instVarName%29%0D%0A%09%5D.%0D%0A%09%5Eself%20basicAt%3A%20%27@%27%2C%20instVarName"));

smalltalk.bind(smalltalk.Object,"instVarAt:put:","instVarAt_put_"

,function (instVarName,anObject){var self=this;try{((instVarName.isNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "instVarAt_put_", fn: function(){return self.instVarAt_put_(self.$klass.allInstVarNames().at_(instVarName), anObject)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "instVarAt_put_", fn: function(){return (self[unescape("@")._comma(instVarName)]=(anObject))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "instVarAt_put_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("instVarAt%3A%20instVarName%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20internal%20collaborator%20of%20the%20receiver%20known%20as%20instVarName%20to%20anObject.%20%22%0D%0A%0D%0A%09instVarName%20isNumber%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20instVarAt%3A%20%28self%20class%20allInstVarNames%20at%3A%20instVarName%29%20put%3A%20anObject%0D%0A%09%5D.%0D%0A%09%5Eself%20basicAt%3A%20%27@%27%2C%20instVarName%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Object,"basicAt:put:","basicAt_put_"

,function (aString,anObject){var self=this;return self[aString]=anObject;return self;}

,"accessing",unescape("basicAt%3A%20aString%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20property%20of%20the%20receiver%20known%20as%20aString.%20%22%0D%0A%0D%0A%09%5Eself%5BaString%5D%20%3A%3D%20anObject"));

smalltalk.bind(smalltalk.Object,"error:","error_"

,function (aString){var self=this;return smalltalk.Error.signal_(aString);return self;}

,unescape("error%20handling"),unescape("error%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20managing%20error%28aString%29%20in%20the%20receiver.%0D%0A%09The%20default%20action%20signal%20an%20error.%0D%0A%09%22%0D%0A%0D%0A%09%5EError%20signal%3A%20aString"));

smalltalk.bind(smalltalk.Object,"subclassResponsibility","subclassResponsibility"

,function (){var self=this;return self.error_("This method is a responsibility of a subclass");return self;}

,unescape("error%20handling"),unescape("subclassResponsibility%0D%0A%09%22%20Private%20-%20The%20concrete%20implementation%20on%20the%20receiver%20is%20not%20complete.%0D%0A%09It%20is%20considered%20an%20error%20at%20this%20level%20and%20a%20method%20must%20be%20implemented%20at%20a%20lower%20level%20of%20abstraction.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20error%3A%20%27This%20method%20is%20a%20responsibility%20of%20a%20subclass%27"));

smalltalk.bind(smalltalk.Object,"implementedBySubclass","implementedBySubclass"

,function (){var self=this;return self.subclassResponsibility();return self;}

,unescape("error%20handling"),unescape("implementedBySubclass%0D%0A%09%22%20Private%20-%20The%20concrete%20implementation%20on%20the%20receiver%20is%20not%20complete.%0D%0A%09It%20is%20considered%20an%20error%20at%20this%20level%20and%20a%20method%20must%20be%20implemented%20at%20a%20lower%20level%20of%20abstraction.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20subclassResponsibility"));

smalltalk.bind(smalltalk.Object,"shouldNotImplement","shouldNotImplement"

,function (){var self=this;return self.error_("This method should not be implemented for instances of "._comma(self.$klass.name()));return self;}

,unescape("error%20handling"),unescape("shouldNotImplement%0D%0A%09%22%20The%20receiver%20received%20a%20message%20that%20is%20wrong.%0D%0A%09The%20default%20action%20signal%20an%20error.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20error%3A%20%27This%20method%20should%20not%20be%20implemented%20for%20instances%20of%20%27%2C%20self%20class%20name"));

smalltalk.bind(smalltalk.Object,"invalidMessage","invalidMessage"

,function (){var self=this;return self.error_("This message should not be sent to instances of "._comma(self.$klass.name()));return self;}

,unescape("error%20handling"),unescape("invalidMessage%0D%0A%09%22%20The%20receiver%20received%20a%20message%20that%20is%20invalid%20%28not%20expected%20for%20this%20object%29.%0D%0A%09The%20default%20action%20signal%20an%20error.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20error%3A%20%27This%20message%20should%20not%20be%20sent%20to%20instances%20of%20%27%2C%20self%20class%20name"));

smalltalk.bind(smalltalk.Object,"smalltalkErrorOf:","smalltalkErrorOf_"

,function (aNativeException){var self=this;var smalltalkError=nil;smalltalkError=(aNativeException["smalltalkError"] || (function(){return ((((aNativeException.$klass || nil) === nil)).mustBeBoolean()==true ? (function(){return smalltalk.Error.$$new().messageText_(((aNativeException.description || aNativeException.message) || nil));})() : (function(){return aNativeException;})());}).value());

smalltalkError.nativeException_(aNativeException);

return smalltalkError;return self;}

,unescape("exception%20handling"),unescape("smalltalkErrorOf%3A%20aNativeException%0D%0A%09%22%20Private%2C%20Internal%20-%20Return%20anException%20associated%20with%20a%20native%28javascript%29%20exception.%20%22%0D%0A%0D%0A%09%7C%20smalltalkError%20%7C%0D%0A%09smalltalkError%20%3A%3D%20aNativeException%20basicAt%3A%20%27smalltalkError%27%20ifAbsent%3A%20%5B%0D%0A%09%09aNativeException%5B%27%24klass%27%5D%20isNil%20ifTrue%3A%20%5B%0D%0A%09%09%09Error%20new%20messageText%3A%20aNativeException%23description%20%7C%7C%20aNativeException%23message%20%7C%7C%20nil%0D%0A%09%09%09%5D%20ifFalse%3A%20%5B%20aNativeException%20%5D%0D%0A%09%09%5D.%0D%0A%09smalltalkError%20nativeException%3A%20aNativeException.%0D%0A%09%5EsmalltalkError"));

smalltalk.bind(smalltalk.Object,"printString","printString"

,function (){var self=this;return "a "._comma(self.$klass.name());return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20a%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27a%20%27%2C%20self%20class%20name"));

smalltalk.bind(smalltalk.Object,"isKindOf:","isKindOf_"

,function (aClass){var self=this;return self.isMemberOf_(aClass).or_((function(){return self.$klass.inheritsFrom_(aClass);}));return self;}

,"testing",unescape("isKindOf%3A%20aClass%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20kind%20of%20aClass.%20%22%0D%0A%0D%0A%09%5E%28self%20isMemberOf%3A%20aClass%29%20or%3A%20%5B%20self%20class%20inheritsFrom%3A%20aClass%20%5D"));

smalltalk.bind(smalltalk.Object,"isMemberOf:","isMemberOf_"

,function (aClass){var self=this;return self.$klass._eq(aClass);return self;}

,"testing",unescape("isMemberOf%3A%20aClass%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20member%20of%20aClass.%20%22%0D%0A%0D%0A%09%5Eself%20class%20%3D%20aClass"));

smalltalk.bind(smalltalk.Object,"ifNil:","ifNil_"

,function (aBlock){var self=this;return self;return self;}

,"testing",unescape("ifNil%3A%20aBlock%0D%0A%09%22%20Return%20the%20receiver%20if%20it%20is%20not%20nil%2C%20or%20the%20result%20of%20evaluating%20aBlock%20%28if%20it%20is%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Object,"ifNil:ifNotNil:","ifNil_ifNotNil_"

,function (aBlock,anotherBlock){var self=this;return anotherBlock.value();return self;}

,"testing",unescape("ifNil%3A%20aBlock%20ifNotNil%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%20if%20the%20receiver%20is%20nil%20or%20the%20result%20of%20evaluating%20anotherBlock%20%28if%20not%20nil%29.%20%22%0D%0A%0D%0A%09%5EanotherBlock%20value"));

smalltalk.bind(smalltalk.Object,"ifNotNil:","ifNotNil_"

,function (aBlock){var self=this;return aBlock.value();return self;}

,"testing",unescape("ifNotNil%3A%20aBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%20if%20the%20receiver%20is%20not%20nil%2C%20or%20nil%20if%20it%20is%20nil.%20%22%0D%0A%0D%0A%09%5EaBlock%20value"));

smalltalk.bind(smalltalk.Object,"ifNotNil:ifNil:","ifNotNil_ifNil_"

,function (aBlock,anotherBlock){var self=this;return aBlock.value();return self;}

,"testing",unescape("ifNotNil%3A%20aBlock%20ifNil%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%20if%20the%20receiver%20is%20not%20nil%2C%20or%20the%20result%20of%20evaluating%20anotherBlock%20if%20it%20is%20nil.%20%22%0D%0A%0D%0A%09%5EaBlock%20value"));

smalltalk.bind(smalltalk.Object,"isNil","isNil"

,function (){var self=this;return false;return self;}

,"testing",unescape("isNil%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20nil.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"notNil","notNil"

,function (){var self=this;return ((self || nil) === nil).not();return self;}

,"testing",unescape("notNil%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20not%20nil.%20%22%0D%0A%0D%0A%09%5Eself%20isNil%20not"));

smalltalk.bind(smalltalk.Object,"isClass","isClass"

,function (){var self=this;return false;return self;}

,"testing",unescape("isClass%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20Class.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"isMetaclass","isMetaclass"

,function (){var self=this;return false;return self;}

,"testing",unescape("isMetaclass%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20metaclass.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"isNumber","isNumber"

,function (){var self=this;return false;return self;}

,"testing",unescape("isNumber%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20Number.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"isString","isString"

,function (){var self=this;return false;return self;}

,"testing",unescape("isString%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20String.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"isArray","isArray"

,function (){var self=this;return false;return self;}

,"testing",unescape("isArray%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20an%20Array.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"isObject:","isObject_"

,function (anObject){var self=this;	if (!anObject) return false
;

return (((anObject["$klass"] || nil) || nil) !== nil);return self;}

,"accessing",unescape("isObject%3A%20anObject%0D%0A%09%22%20Return%20true%20if%20anObject%20is%20a%20smalltalk%20object.%0D%0A%09Return%20false%20if%20the%20object%20is%20foreign%20%28e.g.%20javascript%29%20object.%0D%0A%09%22%0D%0A%0D%0A%7B%27%09if%20%28%21anObject%29%20return%20false%0D%0A%27%7D.%09%5E%28anObject%20basicAt%3A%20%27%24klass%27%29%20notNil"));

smalltalk.bind(smalltalk.Object,"methodFor:","methodFor_"

,function (aSymbol){var self=this;return self.$klass._gt_gt_gt(aSymbol);return self;}

,unescape("message%20handling"),unescape("methodFor%3A%20aSymbol%20%0D%0A%09%22%20Return%20the%20method%20implementing%20aSymbol%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20class%20%3E%3E%3E%20aSymbol"));

smalltalk.bind(smalltalk.Object,"respondsTo:","respondsTo_"

,function (aSymbol){var self=this;return ((self.methodFor_(aSymbol) || nil) !== nil);return self;}

,unescape("message%20handling"),unescape("respondsTo%3A%20aSymbol%20%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20respond%20to%20message%20aSymbol.%20%22%0D%0A%0D%0A%09%5E%28self%20methodFor%3A%20aSymbol%29%20notNil"));

smalltalk.bind(smalltalk.Object,"basicPerform:","basicPerform_"

,function (aSymbol){var self=this;return self.basicPerform_withArguments_(aSymbol, []);return self;}

,unescape("message%20handling"),unescape("basicPerform%3A%20aSymbol%20%0D%0A%09%22%20Private%20-%20Basic%20implementation%20of%20%23perform...%20%22%0D%0A%0D%0A%09%5Eself%20basicPerform%3A%20aSymbol%20withArguments%3A%20%23%28%29"));

smalltalk.bind(smalltalk.Object,"basicPerform:withArguments:","basicPerform_withArguments_"

,function (aSymbol,aCollection){var self=this;return self[aSymbol].apply(self, aCollection);return self;}

,unescape("message%20handling"),unescape("basicPerform%3A%20aSymbol%20withArguments%3A%20aCollection%0D%0A%09%22%20Private%20-%20Basic%20implementation%20of%20%23perform...%20%22%0D%0A%0D%0A%09%5Eself%5BaSymbol%5D%20%23apply%3A%20self%20withArguments%3A%20aCollection"));

smalltalk.bind(smalltalk.Object,"basicDelete:","basicDelete_"

,function (aString){var self=this;	delete self[aString];return self;}

,"accessing",unescape("basicDelete%3A%20aString%0D%0A%09%22%20Private%20-%20Basic%20implementation%20of%20deletion%20of%20property%20aString%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09delete%20self%5BaString%5D%27%7D"));

smalltalk.bind(smalltalk.Object,"doesNotUnderstand:","doesNotUnderstand_"

,function (aMessage){var self=this;return (function($rec){$rec.receiver_(self);$rec.message_(aMessage);return $rec.signal();})(smalltalk.MessageNotUnderstood.$$new());return self;}

,unescape("error%20handling"),unescape("doesNotUnderstand%3A%20aMessage%0D%0A%09%22%20Private%20-%20Basic%20implementation%20of%20a%20message%20sent%20and%20not%20understood%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EMessageNotUnderstood%20new%0D%0A%09%09receiver%3A%20self%3B%0D%0A%09%09message%3A%20aMessage%3B%0D%0A%09%09signal"));

smalltalk.bind(smalltalk.Object,"json","json"

,function (){var self=this;return self.asJSONObject();return self;}

,"converting",unescape("json%0D%0A%09%22%20Return%20the%20receiver%20as%20a%20hash%20object.%20%22%0D%0A%0D%0A%09%5Eself%20asJSONObject"));

smalltalk.bind(smalltalk.Object,"asJson:","asJson_"

,function (anObject){var self=this;try{((((anObject || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asJson_", fn: function(){return nil.json()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "asJson_", fn: function(){return ((self.isObject_(anObject)).mustBeBoolean()==true ? (function(){return anObject.json();})() : (function(){return anObject;})())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "asJson_"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("asJson%3A%20anObject%0D%0A%09%22%20Return%20anObject%20as%20a%20hash%20object.%20%22%0D%0A%0D%0A%09anObject%20isNil%20ifTrue%3A%20%5B%20%5Enil%20json%20%5D.%0D%0A%09%5E%28self%20isObject%3A%20anObject%29%0D%0A%09%09ifTrue%3A%20%5B%20anObject%20json%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20anObject%20%5D"));

smalltalk.bind(smalltalk.Object,"asJSONObject","asJSONObject"

,function (){var self=this;var result=nil;var value=nil;result={};

self.jsonFieldsDo_ignoring_((function(field, value){return ((((value || nil) !== nil).or_((function(){return self.jsonExportNil();}))).mustBeBoolean()==true ? (function(){return (result[field]=(self.asJson_(value)));})() : nil);}), self.jsonHiddenNames());

return result;return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20the%20default%20mapping%20of%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%7C%20result%20value%20%7C%0D%0A%09result%20%3A%3D%20%7B%27%7B%7D%27%7D.%0D%0A%09self%09jsonFieldsDo%3A%20%5B%3Afield%20%3Avalue%7C%0D%0A%09%09%28value%20notNil%20or%3A%20%5B%20self%20jsonExportNil%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%09result%20basicAt%3A%20field%20put%3A%20%28self%20asJson%3A%20value%29%0D%0A%09%09%5D.%0D%0A%09%5D%09ignoring%3A%20self%20jsonHiddenNames.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Object,"jsonHiddenNames","jsonHiddenNames"

,function (){var self=this;return nil;return self;}

,"converting",unescape("jsonHiddenNames%0D%0A%09%22%20Private%20-%20Return%20the%20names%20of%20the%20fields%20to%20skip%20when%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.Object,"jsonFieldsDo:ignoring:","jsonFieldsDo_ignoring_"

,function (aBlock,ignored){var self=this;return self.$klass.allInstVarNamesDo_((function(each){return ((((ignored || nil) !== nil).and_((function(){return ignored.includes_(each);}))).mustBeBoolean()==true ? nil : (function(){return aBlock.value_value_(each, self.instVarAt_(each));})());}));return self;}

,"converting",unescape("jsonFieldsDo%3A%20aBlock%20ignoring%3A%20ignored%0D%0A%09%22%20Private%20-%20Evaluates%20a%28TwoArguments%29Block%20with%20the%20fields%20to%20map%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Eself%20class%20allInstVarNamesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09%28ignored%20notNil%20and%3A%20%5B%20ignored%20includes%3A%20each%20%5D%29%20ifFalse%3A%20%5B%0D%0A%09%09%09aBlock%20value%3A%20each%20value%3A%20%28self%20instVarAt%3A%20each%29%0D%0A%09%09%5D.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Object,"jsonExportNil","jsonExportNil"

,function (){var self=this;return false;return self;}

,"converting",unescape("jsonExportNil%0D%0A%09%22%20Private%20-%20Return%20true%20if%20the%20receiver%20export%20nil%20values.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"asLiteral","asLiteral"

,function (){var self=this;return self.printString();return self;}

,"converting",unescape("asLiteral%0D%0A%09%22%20Return%20the%20receiver%20represented%20in%20literal%20notation.%20%22%0D%0A%0D%0A%09%5Eself%20printString"));

smalltalk.bind(smalltalk.Object,"-->","_minus_minus_gt"

,function (anObject){var self=this;return smalltalk.Association.key_value_(self.asArrayOfSubstringsSeparatedBy_("."), anObject);return self;}

,"converting",unescape("--%3E%20anObject%0D%0A%09%22%20Return%20a%20far-association%20of%20the%20receiver%20to%20anObject.%20%22%0D%0A%0D%0A%09%5EAssociation%20key%3A%20%28self%20asArrayOfSubstringsSeparatedBy%3A%20%24.%29%20value%3A%20anObject"));

smalltalk.bind(smalltalk.Object,"isAssociation","isAssociation"

,function (){var self=this;return false;return self;}

,"testing",unescape("isAssociation%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20anAssociation.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"isRectangle","isRectangle"

,function (){var self=this;return false;return self;}

,"testing",unescape("isRectangle%0D%0A%09%22%20Return%20true%20if%20receiver%20is%20a%20Rectangle.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"smalltalk","smalltalk"

,function (){var self=this;	 return smalltalk; ;return self;}

,"access",unescape("smalltalk%0D%0A%09%22%20Return%20the%20current%20smalltalk%20system.%20%22%0D%0A%0D%0A%7B%27%09%20return%20smalltalk%3B%20%27%7D"));

smalltalk.bind(smalltalk.Object,"argumentCount","argumentCount"

,function (){var self=this;return (0);return self;}

,"evaluating",unescape("argumentCount%0D%0A%09%22%20Return%20the%20number%20of%20arguments%20required%20to%20evaluate%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E0"));

smalltalk.bind(smalltalk.Object,"numberOfArguments","numberOfArguments"

,function (){var self=this;return self.argumentCount();return self;}

,"evaluating",unescape("numberOfArguments%0D%0A%09%22%20Return%20the%20number%20of%20arguments%20required%20to%20evaluate%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20argumentCount"));

smalltalk.bind(smalltalk.Object,"evaluate","evaluate"

,function (){var self=this;return self;return self;}

,"evaluating",unescape("evaluate%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Object,"evaluateDeferred","evaluateDeferred"

,function (){var self=this;(function(){return self.evaluate();}).valueDeferred();return self;}

,"evaluating",unescape("evaluateDeferred%0D%0A%09%22%20Evaluating%20the%20receiver%20deferred%20in%20time.%0D%0A%09Return%20the%20receiver.%20%22%0D%0A%0D%0A%09%5B%20self%20evaluate%20%5D%20valueDeferred."));

smalltalk.bind(smalltalk.Object,"evaluateWithArguments:","evaluateWithArguments_"

,function (anArray){var self=this;return self;return self;}

,"evaluating",unescape("evaluateWithArguments%3A%20anArray%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Object,"evaluateWith:","evaluateWith_"

,function (anObject){var self=this;return self.evaluateWithArguments_(smalltalk.Array.with_(anObject));return self;}

,"evaluating",unescape("evaluateWith%3A%20anObject%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20evaluateWithArguments%3A%20%28Array%20with%3A%20anObject%29"));

smalltalk.bind(smalltalk.Object,"asActionSequence","asActionSequence"

,function (){var self=this;return smalltalk.ActionSequence.with_(self);return self;}

,"conversion",unescape("asActionSequence%0D%0A%09%22%20Return%20an%20action%20sequence%20containing%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EActionSequence%20with%3A%20self"));

smalltalk.bind(smalltalk.Object,"eventTable","eventTable"

,function (){var self=this;return (self[unescape("@handlers")] || (function(){return self.eventTableCreate();}).value());return self;}

,"events",unescape("eventTable%0D%0A%09%22%20Private%20-%20Returns%20the%20mapping%20event%20names%20to%20actions%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27@handlers%27%20ifAbsent%3A%20%5B%20self%20eventTableCreate%20%5D"));

smalltalk.bind(smalltalk.Object,"eventTableForEdit","eventTableForEdit"

,function (){var self=this;return (self[unescape("@handlers")] || (function(){return (self[unescape("@handlers")]=(self.eventTableCreate()));}).value());return self;}

,"events",unescape("eventTableForEdit%0D%0A%09%22%20Private%20-%20Returns%20the%20mapping%20event%20names%20to%20actions%20of%20the%20receiver.%0D%0A%09Set%20the%20internal%20map%20if%20not%20present.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27@handlers%27%20ifAbsent%3A%20%5B%0D%0A%09%09self%20basicAt%3A%20%27@handlers%27%20put%3A%20self%20eventTableCreate%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Object,"releaseEventTable","releaseEventTable"

,function (){var self=this;self.basicDelete_(unescape("@handlers"));return self;}

,"events",unescape("releaseEventTable%0D%0A%09%22%20Private%20-%20Release%20the%20event%20table.%20%22%0D%0A%0D%0A%09self%20basicDelete%3A%20%27@handlers%27"));

smalltalk.bind(smalltalk.Object,"release","release"

,function (){var self=this;self.releaseEventTable();return self;}

,"initialize/release",unescape("release%0D%0A%09%22%20Release%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20releaseEventTable"));

smalltalk.bind(smalltalk.Object,"eventTableCreate","eventTableCreate"

,function (){var self=this;return smalltalk.Dictionary.$$new();return self;}

,"events",unescape("eventTableCreate%0D%0A%09%22%20Private%20-%20Returns%20a%20new%20mapping%20for%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDictionary%20new"));

smalltalk.bind(smalltalk.Object,"canTriggerEvent:","canTriggerEvent_"

,function (anEvent){var self=this;return self.$klass.canTriggerEvent_(anEvent);return self;}

,"events",unescape("canTriggerEvent%3A%20anEvent%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20can%20trigger%20anEvent.%22%0D%0A%0D%0A%09%5Eself%20class%20canTriggerEvent%3A%20anEvent"));

smalltalk.bind(smalltalk.Object,"invalidEvent:","invalidEvent_"

,function (anEvent){var self=this;return self;return self;}

,"events",unescape("invalidEvent%3A%20anEvent%0D%0A%09%22%20Private%20-%20Notify%20the%20situation%20where%20an%20unknown%20event%20is%20registered.%0D%0A%09Default%20implementation%20ignore%20error%20during%20unknown%20event%20registration.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%0D%0A%22DEBUG-%09%5Eself%20print%3A%20self%20class%20name%2C%27%20invalidEvent%3A%20%23%27%2CanEvent%20asString.%20%22"));

smalltalk.bind(smalltalk.Object,"when:evaluate:","when_evaluate_"

,function (anEvent,anAction){var self=this;try{var actions=nil;((self.canTriggerEvent_(anEvent)).mustBeBoolean()==true ? nil : (function(){return self.invalidEvent_(anEvent);})());

actions=self.actionListForEvent_(anEvent);

((actions.includes_(anAction)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "when_evaluate_", fn: function(){return self}})})();})() : nil);

self.setActionList_forEvent_(actions.copyWith_(anAction), anEvent);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "when_evaluate_"){return $$ex.fn();} throw($$ex);}}

,"events",unescape("when%3A%20anEvent%20evaluate%3A%20anAction%0D%0A%09%22%20Register%20anAction%20to%20the%20be%20evaluated%20when%20the%20receiver%20triggers%20the%20event.%20%22%0D%0A%0D%0A%09%7C%20actions%20%7C%0D%0A%09%28self%20canTriggerEvent%3A%20anEvent%29%20ifFalse%3A%20%5B%20self%20invalidEvent%3A%20anEvent%20%5D.%0D%0A%09actions%20%3A%3D%20self%20actionListForEvent%3A%20anEvent.%0D%0A%09%28actions%20includes%3A%20anAction%29%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09self%0D%0A%09%09setActionList%3A%20%28actions%20copyWith%3A%20anAction%29%0D%0A%09%09forEvent%3A%20anEvent"));

smalltalk.bind(smalltalk.Object,"actionListForEvent:","actionListForEvent_"

,function (anEvent){var self=this;try{var result=nil;result=self.eventTable().at_ifAbsent_(anEvent, (function(){return (function(){throw({name: "stReturn", selector: "actionListForEvent_", fn: function(){return smalltalk.ActionSequence.$$new()}})})();}));

(function(){throw({name: "stReturn", selector: "actionListForEvent_", fn: function(){return result.asActionSequence()}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "actionListForEvent_"){return $$ex.fn();} throw($$ex);}}

,"events",unescape("actionListForEvent%3A%20anEvent%0D%0A%09%22%20Private%20-%20Return%20a%20collection%20of%20actions%20to%20evaluate%20when%20the%20event%20is%20triggered.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20eventTable%20at%3A%20anEvent%20ifAbsent%3A%20%5B%20%5EActionSequence%20new%20%5D.%0D%0A%09%5Eresult%20asActionSequence"));

smalltalk.bind(smalltalk.Object,"setActionList:forEvent:","setActionList_forEvent_"

,function (actionSequence,anEvent){var self=this;try{var action=nil;action=actionSequence.reduced();

((((action || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "setActionList_forEvent_", fn: function(){return self.removeActionsForEvent_(anEvent)}})})();})() : nil);

self.eventTableForEdit().at_put_(anEvent, action);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "setActionList_forEvent_"){return $$ex.fn();} throw($$ex);}}

,"events",unescape("setActionList%3A%20actionSequence%20forEvent%3A%20anEvent%0D%0A%09%22%20Private%20-%20Set%20the%20list%20of%20actions%20to%20evaluate%20when%20the%20event%20is%20triggered%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20actionSequence%20reduced.%0D%0A%09action%20isNil%20ifTrue%3A%20%5B%20%5Eself%20removeActionsForEvent%3A%20anEvent%20%5D.%0D%0A%09self%20eventTableForEdit%20at%3A%20anEvent%20put%3A%20action."));

smalltalk.bind(smalltalk.Object,"removeActionsSatisfying:forEvent:","removeActionsSatisfying_forEvent_"

,function (aBlock,anEvent){var self=this;self.setActionList_forEvent_(self.actionListForEvent_(anEvent).reject_(aBlock), anEvent);return self;}

,"events",unescape("removeActionsSatisfying%3A%20aBlock%20forEvent%3A%20anEvent%0D%0A%09%22%20Private%20-%20Remove%20all%20actions%20for%20the%20event%20that%20evaluates%20aBlock%20to%20true.%22%0D%0A%0D%0A%09self%0D%0A%09%09setActionList%3A%20%28%28self%20actionListForEvent%3A%20anEvent%29%20reject%3A%20aBlock%29%0D%0A%09%09forEvent%3A%20anEvent"));

smalltalk.bind(smalltalk.Object,"removeActionsWithReceiver:forEvent:","removeActionsWithReceiver_forEvent_"

,function (anObject,anEvent){var self=this;self.removeActionsSatisfying_forEvent_((function(each){return each.respondsTo_("receiver").and_((function(){return (each.receiver() === anObject);}));}), anEvent);return self;}

,"events",unescape("removeActionsWithReceiver%3A%20anObject%20forEvent%3A%20anEvent%0D%0A%09%22%20Remove%20all%20actions%20for%20the%20event%20in%20the%20receiver%27s%20event%20table%20which%20have%20anObject%20as%20receiver.%20%22%0D%0A%0D%0A%09self%0D%0A%09%09removeActionsSatisfying%3A%20%5B%3Aeach%7C%20%28each%20respondsTo%3A%20%23receiver%29%20and%3A%20%5B%20each%20receiver%20%3D%3D%20anObject%20%5D%20%5D%0D%0A%09%09forEvent%3A%20anEvent"));

smalltalk.bind(smalltalk.Object,"removeAction:forEvent:","removeAction_forEvent_"

,function (anAction,anEvent){var self=this;self.removeActionsSatisfying_forEvent_((function(each){return each._eq(anAction);}), anEvent);return self;}

,"events",unescape("removeAction%3A%20anAction%20forEvent%3A%20anEvent%0D%0A%09%22%20Remove%20anAction%20for%20the%20event%20in%20the%20receiver%27s%20event%20table%20which%20have%20anObject%20as%20receiver.%20%22%0D%0A%0D%0A%09self%0D%0A%09%09removeActionsSatisfying%3A%20%5B%3Aeach%7C%20each%20%3D%20anAction%20%5D%0D%0A%09%09forEvent%3A%20anEvent"));

smalltalk.bind(smalltalk.Object,"when:do:","when_do_"

,function (anEvent,aBlock){var self=this;self.when_evaluate_(anEvent, aBlock);return self;}

,"events",unescape("when%3A%20anEvent%20do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20when%20the%20receiver%20triggers%20the%20event.%20%22%0D%0A%0D%0A%09self%20when%3A%20anEvent%20evaluate%3A%20aBlock"));

smalltalk.bind(smalltalk.Object,"when:send:to:withArguments:","when_send_to_withArguments_"

,function (anEvent,selector,anObject,array){var self=this;self.when_evaluate_(anEvent, smalltalk.LinkMessage.receiver_selector_arguments_(anObject, selector, array));return self;}

,"events",unescape("when%3A%20anEvent%20send%3A%20selector%20to%3A%20anObject%20withArguments%3A%20array%0D%0A%09%22%20Send%20the%20message%20when%20the%20receiver%20triggers%20the%20event.%20%22%0D%0A%0D%0A%09self%0D%0A%09%09when%3A%20anEvent%0D%0A%09%09evaluate%3A%20%28LinkMessage%0D%0A%09%09%09receiver%3A%20anObject%0D%0A%09%09%09selector%3A%20selector%0D%0A%09%09%09arguments%3A%20array%29"));

smalltalk.bind(smalltalk.Object,"when:send:to:","when_send_to_"

,function (anEvent,selector,anObject){var self=this;self.when_evaluate_(anEvent, smalltalk.Message.receiver_selector_arguments_(anObject, selector, smalltalk.Array.new_(selector.argumentCount())));return self;}

,"events",unescape("when%3A%20anEvent%20send%3A%20selector%20to%3A%20anObject%0D%0A%09%22%20Send%20the%20message%20when%20the%20receiver%20triggers%20the%20event.%20%22%0D%0A%0D%0A%09self%0D%0A%09%09when%3A%20anEvent%0D%0A%09%09evaluate%3A%20%28Message%0D%0A%09%09%09receiver%3A%20anObject%0D%0A%09%09%09selector%3A%20selector%0D%0A%09%09%09arguments%3A%20%28Array%20new%3A%20selector%20argumentCount%29%29"));

smalltalk.bind(smalltalk.Object,"triggerEvent:ifNotHandled:","triggerEvent_ifNotHandled_"

,function (anEvent,aBlock){var self=this;return self.eventTable().at_ifAbsent_(anEvent, (function(){return aBlock;})).evaluate();return self;}

,"events",unescape("triggerEvent%3A%20anEvent%20ifNotHandled%3A%20aBlock%0D%0A%09%22%20Trigger%20the%20event.%0D%0A%09If%20the%20event%20is%20not%20handled%2C%20return%20the%20value%20of%20evaluating%20aBlock%2C%0D%0A%20%20%20%20%20%20%20%20or%20the%20value%20returned%20by%20the%20most%20recently%20defined%20event%20handler.%0D%0A%09%22%0D%0A%0D%0A%09%5E%28self%20eventTable%20at%3A%20anEvent%20ifAbsent%3A%20%5B%20aBlock%20%5D%29%20evaluate"));

smalltalk.bind(smalltalk.Object,"actionForEvent:","actionForEvent_"

,function (anEvent){var self=this;return self.eventTable().at_ifAbsent_(anEvent, (function(){return nil;}));return self;}

,"events",unescape("actionForEvent%3A%20anEvent%0D%0A%09%22%20Return%20the%20action%20to%20evaluate%20when%20the%20event%20is%20triggered%20by%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20eventTable%20at%3A%20anEvent%20ifAbsent%3A%20%5B%20nil%20%5D"));

smalltalk.bind(smalltalk.Object,"triggerEvent:","triggerEvent_"

,function (anEvent){var self=this;return self.actionForEvent_(anEvent).evaluate();return self;}

,"events",unescape("triggerEvent%3A%20anEvent%0D%0A%09%22%20Return%20the%20result%20of%20triggering%20the%20event.%20%22%0D%0A%0D%0A%09%5E%28self%20actionForEvent%3A%20anEvent%29%20evaluate"));

smalltalk.bind(smalltalk.Object,"triggerEvent:withArguments:","triggerEvent_withArguments_"

,function (anEvent,array){var self=this;return self.actionForEvent_(anEvent).evaluateWithArguments_(array);return self;}

,"events",unescape("triggerEvent%3A%20anEvent%20withArguments%3A%20array%0D%0A%09%22%20Return%20the%20result%20of%20triggering%20the%20event.%20%22%0D%0A%0D%0A%09%5E%28self%20actionForEvent%3A%20anEvent%29%20evaluateWithArguments%3A%20array"));

smalltalk.bind(smalltalk.Object,"triggerEvent:with:","triggerEvent_with_"

,function (anEvent,anObject){var self=this;return self.triggerEvent_withArguments_(anEvent, smalltalk.Array.with_(anObject));return self;}

,"events",unescape("triggerEvent%3A%20anEvent%20with%3A%20anObject%0D%0A%09%22%20Return%20the%20result%20of%20triggering%20the%20event.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20anEvent%20withArguments%3A%20%28Array%20with%3A%20anObject%29"));

smalltalk.bind(smalltalk.Object,"triggerEvent:with:with:","triggerEvent_with_with_"

,function (anEvent,anObject,anotherObject){var self=this;return self.triggerEvent_withArguments_(anEvent, smalltalk.Array.with_with_(anObject, anotherObject));return self;}

,"events",unescape("triggerEvent%3A%20anEvent%20with%3A%20anObject%20with%3A%20anotherObject%0D%0A%09%22%20Return%20the%20result%20of%20triggering%20the%20event.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20anEvent%20withArguments%3A%20%28Array%20with%3A%20anObject%20with%3A%20anotherObject%29"));

smalltalk.bind(smalltalk.Object,"triggerEvent:withArguments:ifNotHandled:","triggerEvent_withArguments_ifNotHandled_"

,function (anEvent,array,aBlock){var self=this;return self.eventTable().at_ifAbsent_(anEvent, (function(){return aBlock;})).evaluateWithArguments_(array);return self;}

,"events",unescape("triggerEvent%3A%20anEvent%20withArguments%3A%20array%20ifNotHandled%3A%20aBlock%0D%0A%09%22%20Return%20the%20result%20of%20triggering%20the%20eventwith%20the%20arguments.%0D%0A%09If%20the%20event%20is%20not%20handled%2C%20return%20the%20value%20of%20evaluating%20aBlock%2C%0D%0A%09or%20the%20value%20returned%20by%20the%20most%20recently%20defined%20event%20handler%20action.%0D%0A%09%22%0D%0A%0D%0A%09%5E%28self%20eventTable%20at%3A%20anEvent%20ifAbsent%3A%20%5B%20aBlock%20%5D%29%20evaluateWithArguments%3A%20array"));

smalltalk.bind(smalltalk.Object,"triggerEvent:with:ifNotHandled:","triggerEvent_with_ifNotHandled_"

,function (anEvent,anObject,aBlock){var self=this;return self.triggerEvent_withArguments_ifNotHandled_(anEvent, smalltalk.Array.with_(anObject), aBlock);return self;}

,"events",unescape("triggerEvent%3A%20anEvent%20with%3A%20anObject%20ifNotHandled%3A%20aBlock%0D%0A%09%22%20Return%20the%20result%20of%20triggering%20the%20eventwith.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20anEvent%20withArguments%3A%20%28Array%20with%3A%20anObject%29%20ifNotHandled%3A%20aBlock"));

smalltalk.bind(smalltalk.Object,"hasActionForEvent:","hasActionForEvent_"

,function (anEvent){var self=this;return self.eventTable().includesKey_(anEvent);return self;}

,"events",unescape("hasActionForEvent%3A%20anEvent%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20has%20an%20action%20registered%20for%20the%20event.%20%22%0D%0A%0D%0A%09%5Eself%20eventTable%20includesKey%3A%20anEvent"));

smalltalk.bind(smalltalk.Object,"eventsHandled","eventsHandled"

,function (){var self=this;return self.eventTable().keys();return self;}

,"events",unescape("eventsHandled%0D%0A%09%22%20Return%20the%20events%20for%20which%20there%20are%20actions%20registered%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20eventTable%20keys"));

smalltalk.bind(smalltalk.Object,"removeAllActionsWithReceiver:","removeAllActionsWithReceiver_"

,function (anObject){var self=this;self.eventTable().keys().do_((function(each){return self.removeActionsWithReceiver_forEvent_(anObject, each);}));return self;}

,"events",unescape("removeAllActionsWithReceiver%3A%20anObject%0D%0A%09%22%20Remove%20all%20actions%20for%20all%20events%20in%20the%20receiver%27s%20event%20table%20with%20anObject%20as%20receiver.%20%22%0D%0A%0D%0A%09self%20eventTable%20keys%20do%3A%20%5B%3Aeach%7Cself%20removeActionsWithReceiver%3A%20anObject%20forEvent%3A%20each%20%5D"));

smalltalk.bind(smalltalk.Object,"removeActionsForEvent:","removeActionsForEvent_"

,function (anEvent){var self=this;try{var actions=nil;actions=self.eventTable();

actions.removeKey_ifAbsent_(anEvent, (function(){return (function(){throw({name: "stReturn", selector: "removeActionsForEvent_", fn: function(){return self}})})();}));

((actions.isEmpty()).mustBeBoolean()==true ? (function(){return self.releaseEventTable();})() : nil);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "removeActionsForEvent_"){return $$ex.fn();} throw($$ex);}}

,"events",unescape("removeActionsForEvent%3A%20anEvent%0D%0A%09%22%20Remove%20all%20actions%20for%20the%20event.%20%22%0D%0A%0D%0A%09%7C%20actions%20%7C%0D%0A%09actions%20%3A%3D%20self%20eventTable.%0D%0A%09actions%20removeKey%3A%20anEvent%20ifAbsent%3A%20%5B%20%5Eself%20%5D.%0D%0A%09actions%20isEmpty%20ifTrue%3A%20%5B%20self%20releaseEventTable%20%5D."));

smalltalk.bind(smalltalk.Object,"addDependent:","addDependent_"

,function (anObject){var self=this;self.when_send_to_("changed", "update", anObject);return self;}

,"changes",unescape("addDependent%3A%20anObject%0D%0A%09%22%20Make%20anObject%20dependent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20when%3A%20%23changed%20send%3A%20%23update%20to%3A%20anObject"));

smalltalk.bind(smalltalk.Object,"changed","changed"

,function (){var self=this;self.triggerEvent_("changed");return self;}

,"changes",unescape("changed%0D%0A%09%22%20Update%20the%20dependents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20triggerEvent%3A%20%23changed"));

smalltalk.bind(smalltalk.Object,"updateEvent:selector:arguments:","updateEvent_selector_arguments_"

,function (anEvent,selector,array){var self=this;try{var action=nil;action=self.eventTable().at_ifAbsent_(anEvent, (function(){return (function(){throw({name: "stReturn", selector: "updateEvent_selector_arguments_", fn: function(){return nil}})})();}));

action.asActionSequence().evaluateWithSelector_withArguments_(selector, array);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "updateEvent_selector_arguments_"){return $$ex.fn();} throw($$ex);}}

,"changes",unescape("updateEvent%3A%20anEvent%20selector%3A%20selector%20arguments%3A%20array%0D%0A%09%22%20Private%20-%20Trigger%20the%20event%20with%20the%20message%20selector%20and%20the%20arguments.%20%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20self%20eventTable%20at%3A%20anEvent%20ifAbsent%3A%20%5B%20%5Enil%20%5D.%0D%0A%09action%20asActionSequence%0D%0A%20%20%20%20%20%20%20%20%20%20%20%20evaluateWithSelector%3A%20selector%0D%0A%20%20%20%20%20%20%20%20%20%20%20%20withArguments%3A%20array"));

smalltalk.bind(smalltalk.Object,"changed:","changed_"

,function (aspect){var self=this;self.updateEvent_selector_arguments_("changed", "update:", smalltalk.Array.with_(aspect));return self;}

,"changes",unescape("changed%3A%20aspect%0D%0A%09%22%20Update%20the%20dependents%20on%20aspect%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20updateEvent%3A%20%23changed%20selector%3A%20%23update%3A%20arguments%3A%20%28Array%20with%3A%20aspect%29"));

smalltalk.bind(smalltalk.Object,"changed:with:","changed_with_"

,function (aspect,anObject){var self=this;self.updateEvent_selector_arguments_("changed", "update:with:", smalltalk.Array.with_with_(aspect, anObject));return self;}

,"changes",unescape("changed%3A%20aspect%20with%3A%20anObject%0D%0A%09%22%20Update%20the%20dependents%20on%20aspect%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20updateEvent%3A%20%23changed%20selector%3A%20%23update%3Awith%3A%20arguments%3A%20%28Array%20with%3A%20aspect%20with%3A%20anObject%29"));

smalltalk.bind(smalltalk.Object,"changed:with:with:","changed_with_with_"

,function (aspect,anObject,anotherObject){var self=this;self.updateEvent_selector_arguments_("changed", "update:with:with:", smalltalk.Array.with_with_with_(aspect, anObject, anotherObject));return self;}

,"changes",unescape("changed%3A%20aspect%20with%3A%20anObject%20with%3A%20anotherObject%0D%0A%09%22%20Update%20the%20dependents%20on%20aspect%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20updateEvent%3A%20%23changed%20selector%3A%20%23update%3Awith%3Awith%3A%20arguments%3A%20%28Array%20with%3A%20aspect%20with%3A%20anObject%20with%3A%20anotherObject%29"));

smalltalk.bind(smalltalk.Object,"dependents","dependents"

,function (){var self=this;return self.actionListForEvent_("changed").collect_((function(each){return each.receiver();}));return self;}

,"changes",unescape("dependents%0D%0A%09%22%20Return%20the%20dependents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28self%20actionListForEvent%3A%20%23changed%29%20collect%3A%20%5B%3Aeach%20%7C%20each%20receiver%20%5D"));

smalltalk.bind(smalltalk.Object,"update:with:","update_with_"

,function (anObject,anotherObject){var self=this;return self;}

,"changes",unescape("update%3A%20anObject%20with%3A%20anotherObject%0D%0A%09%22%20Update%20the%20receiver.%0D%0A%09Default%20implementation%20do%20nothing.%0D%0A%09This%20method%20must%20be%20refined%20by%20subclasses%20to%20support%20change/update%20protocoll.%0D%0A%09%22"));

smalltalk.bind(smalltalk.Object,"update:","update_"

,function (anObject){var self=this;return self;}

,"changes",unescape("update%3A%20anObject%0D%0A%09%22%20Update%20the%20receiver.%0D%0A%09Default%20implementation%20do%20nothing.%0D%0A%09This%20method%20must%20be%20refined%20by%20subclasses%20to%20support%20change/update%20protocoll.%0D%0A%09%22"));

smalltalk.bind(smalltalk.Object,"printingWith:do:","printingWith_do_"

,function (printBlock,aBlock){var self=this;var backup=nil;var result=nil;backup=print;

(function(){printBlock.installAs_("print");return result=aBlock.value();}).ensure_((function(){return backup.installAs_("print");}));

return result;return self;}

,"printing",unescape("printingWith%3A%20printBlock%20do%3A%20aBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%2C%20redirecting%20output%20to%20printBlock.%20%22%0D%0A%0D%0A%09%7C%20backup%20result%20%7C%0D%0A%09backup%20%3A%3D%20%23%7Bprint%7D.%0D%0A%09%5B%09printBlock%20installAs%3A%20%23print.%0D%0A%09%09result%20%3A%3D%20aBlock%20value.%0D%0A%09%5D%20ensure%3A%20%5B%20backup%20installAs%3A%20%23print%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Object,"emmit:startingWith:","emmit_startingWith_"

,function (fileName,initial){var self=this;try{var output=nil;var cr=nil;output=initial;

cr=unescape("%0D%0A");

self.print_(unescape("//%20emmit%28%22")._comma(fileName)._comma(unescape("%22%29")));

(function(){self.printingWith_do_((function(what){return output=((((output || nil) === nil)).mustBeBoolean()==true ? (function(){return what;})() : (function(){return output._comma(cr)._comma(what);})());}), (function(){return self.fileIn_(fileName);}));return output.outputToFile_(fileName._comma(".js"));}).on_do_(smalltalk.Error, (function(ex){output.asString()._comma(cr)._comma(ex.toString()).outputToFile_(fileName._comma(".error.txt"));self.print_(ex.toString());return (function(){throw({name: "stReturn", selector: "emmit_startingWith_", fn: function(){return ex.toString()}})})();}));

(function(){throw({name: "stReturn", selector: "emmit_startingWith_", fn: function(){return output}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "emmit_startingWith_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("emmit%3A%20fileName%20startingWith%3A%20initial%0D%0A%09%22%20FileIn%20the%20contents%20of%20file%20at%20fileName%20redirecting%20output%28emmited%20code%29%20to%20a%20.js%20file.%20%22%0D%0A%0D%0A%09%7C%20output%20cr%20%7C%0D%0A%09output%20%3A%3D%20initial.%20cr%20%3A%3D%20%27%0D%0A%27.%09self%20print%3A%20%27//%20emmit%28%22%27%2CfileName%2C%27%22%29%27.%0D%0A%5B%09self%09printingWith%3A%20%5B%3Awhat%7C%0D%0A%09%09%09output%20%3A%3D%20output%20isNil%20ifTrue%3A%20%5Bwhat%5D%0D%0A%09%09%09%09ifFalse%3A%20%5B%20output%20%2Ccr%20%2Cwhat%20%5D%0D%0A%09%09%5D%20do%3A%20%5B%20self%20fileIn%3A%20fileName%20%5D.%0D%0A%09output%20outputToFile%3A%20fileName%2C%27.js%27.%0D%0A%5D%09on%3A%20Error%20do%3A%20%5B%3Aex%7C%0D%0A%09%28output%20asString%20%2Ccr%20%2Cex%20toString%29%0D%0A%09%09outputToFile%3A%20fileName%2C%27.error.txt%27.%0D%0A%09self%20print%3A%20ex%20toString.%0D%0A%09%5Eex%20toString%0D%0A%5D.%0D%0A%09%5Eoutput"));

smalltalk.bind(smalltalk.Object,"emmit:","emmit_"

,function (fileName){var self=this;return self.emmit_startingWith_(fileName, nil);return self;}

,unescape("code%20generation"),unescape("emmit%3A%20fileName%0D%0A%09%22%20FileIn%20the%20contents%20of%20file%20at%20fileName%20redirecting%20output%28emmited%20code%29%20to%20a%20.js%20file.%20%22%0D%0A%0D%0A%09%5Eself%20emmit%3A%20fileName%20startingWith%3A%20nil"));

smalltalk.bind(smalltalk.Object,"isParseFailure","isParseFailure"

,function (){var self=this;return false;return self;}

,"Compiler-testing",unescape("isParseFailure%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20parsing%20failure.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Object,"asParser","asParser"

,function (){var self=this;return self.subclassResponsibility();return self;}

,"Compiler-converting",unescape("asParser%0D%0A%09%22%20Return%20a%20parser%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20subclassResponsibility"));

smalltalk.bind(smalltalk.Object,"mustBeBoolean","mustBeBoolean"

,function (){var self=this;return self.error_("Must be boolean.");return self;}

,"Compiler-testing",unescape("mustBeBoolean%0D%0A%09%22%20Signal%20an%20error%20if%20the%20receiver%20is%20not%20a%20Boolean.%20%22%0D%0A%0D%0A%09%5Eself%20error%3A%20%27Must%20be%20boolean.%27"));

smalltalk.bind(smalltalk.Object,"scanFrom:","scanFrom_"

,function (aStream){var self=this;try{var chunk=nil;chunk=aStream.nextChunk();

((chunk.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "scanFrom_", fn: function(){return nil}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "scanFrom_", fn: function(){return chunk.evaluate()}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "scanFrom_"){return $$ex.fn();} throw($$ex);}}

,"Compiler-fileIn",unescape("scanFrom%3A%20aStream%0D%0A%09%22%20FileIn%20-%20Return%20the%20result%20of%20evaluating%20the%20next%20chunk%20of%20data%20from%20aStream.%0D%0A%09The%20method%20can%20be%20refined%20by%20chunk%20readers%20to%20support%20custom%20fileIn%20features.%0D%0A%09Must%20return%20the%20next%20reader%20to%20use%20for%20reading%20remaining%20contents%20from%20aStream.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20chunk%20%7C%0D%0A%09chunk%20%3A%3D%20aStream%20nextChunk.%0D%0A%09chunk%20isEmpty%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09%5Echunk%20evaluate"));

smalltalk.bind(smalltalk.Object,"javascriptCodeFollows","javascriptCodeFollows"

,function (){var self=this;return smalltalk.ChunkReader.javascript();return self;}

,"Compiler-fileIn",unescape("javascriptCodeFollows%0D%0A%09%22%20FileIn%20-%20FileIn%20javascript%20code%20on%20current%20stream.%0D%0A%09Consume%20stream%20contents%20upto%20end%20of%20stream%20evaluating%20the%20contents%20as%20javascript%20code.%0D%0A%09%22%0D%0A%0D%0A%09%5EChunkReader%20javascript"));

smalltalk.bind(smalltalk.Object,"cancelFileIn","cancelFileIn"

,function (){var self=this;return smalltalk.CancelFileInReader.$$new();return self;}

,"Compiler-fileIn",unescape("cancelFileIn%0D%0A%09%22%20FileIn%20-%20Cancel%20fileIn%20on%20current%20stream.%0D%0A%09Consume/Ignore%20stream%20contents%20upto%20end%20of%20stream.%0D%0A%09%22%0D%0A%09%5ECancelFileInReader%20new"));

smalltalk.bind(smalltalk.Object,"==","_eq_eq"

,function (anObject){var self=this;return (self === anObject);return self;}

,"Compiler-comparing",unescape("%3D%3D%20anObject%0D%0A%09%5Eself%20%3D%3D%3D%20anObject"));

smalltalk.bind(smalltalk.Object,"~~","_no_no"

,function (anObject){var self=this;return ((self === anObject) === false);return self;}

,"Compiler-comparing",unescape("%7E%7E%20anObject%0D%0A%09%5E%28self%20%3D%3D%20anObject%29%20%3D%3D%20false"));

smalltalk.bind(smalltalk.Object,"asJS","asJS"

,function (){var self=this;return smalltalk.JS._at(self);return self;}

,"converting",unescape("asJS%0D%0A%09%22%20Convert%20the%20receiver%20to%20JS%20instance%20%28for%20reflection%29.%20%22%0D%0A%0D%0A%09%5EJS%20@%20self"));

smalltalk.bind(smalltalk.S8Web.$klass,"install:","install_"

,function (id){var self=this;self._at(id).install();return self;}

,"startup",unescape("install%3A%20id%0D%0A%09%22%20Install%20an%20instance%20of%20the%20receiver%20in%20container.%20%22%0D%0A%0D%0A%09%28self%20@%20id%29%20install"));

smalltalk.bind(smalltalk.S8Web.$klass,"@","_at"

,function (id){var self=this;try{self.instances().do_((function(each){return ((each.id()._eq(id)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_at", fn: function(){return each}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "_at", fn: function(){return self.instances().add_(self.$$new().id_(id))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_at"){return $$ex.fn();} throw($$ex);}}

,unescape("accessing/instance%20creation"),unescape("@%20id%0D%0A%09%22%20Return%20the%20instance%20of%20the%20receiver%20with%20id.%0D%0A%09If%20there%20is%20no%20instance%20with%20that%20id%2C%20a%20new%20instance%20will%20be%20registered%20and%20returned.%0D%0A%09%22%0D%0A%0D%0A%09self%20instances%20do%3A%20%5B%3Aeach%7C%20each%20id%20%3D%20id%20ifTrue%3A%20%5B%20%5Eeach%20%5D.%20%5D.%0D%0A%09%5Eself%20instances%20add%3A%20%28self%20new%20id%3A%20id%29"));

smalltalk.bind(smalltalk.S8Web.$klass,"instances","instances"

,function (){var self=this;((((self['@instances'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@instances']=smalltalk.Array.$$new();})() : nil);

return self['@instances'];return self;}

,"accessing",unescape("instances%0D%0A%09%22%20Private%20-%20Return%20the%20running%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09instances%20isNil%20ifTrue%3A%20%5B%20instances%20%3A%3D%20Array%20new%20%5D.%0D%0A%09%5Einstances"));

smalltalk.bind(smalltalk.S8Web.$klass,"tool","tool"

,function (){var self=this;return ((self.instances().notEmpty()).mustBeBoolean()==true ? (function(){return self.instances().first();})() : nil);return self;}

,"accessing",unescape("tool%0D%0A%09%22%20Private%20-%20Return%20the%20first%20instance%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20instances%20notEmpty%20ifTrue%3A%20%5B%20self%20instances%20first%20%5D"));

smalltalk.bind(smalltalk.S8Web.$klass,"current","current"

,function (){var self=this;return self.tool();return self;}

,"accessing",unescape("current%0D%0A%09%22%20Private%20-%20Return%20the%20current%20instance%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20tool"));

smalltalk.bind(smalltalk.S8Web.$klass,"commonExpressions","commonExpressions"

,function (){var self=this;((((smalltalk.S8Web.classVariableAt_("CommonExpressions") || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeCommonExpressions();})() : nil);

return smalltalk.S8Web.classVariableAt_("CommonExpressions");return self;}

,"workspace",unescape("commonExpressions%0D%0A%09%22%20Private%20-%20Return%20the%20collection%20of%20frequent/common%20expressions.%20%22%0D%0A%0D%0A%09CommonExpressions%20isNil%20ifTrue%3A%20%5B%20self%20initializeCommonExpressions%20%5D.%0D%0A%09%5ECommonExpressions"));

smalltalk.bind(smalltalk.S8Web.$klass,"onLoadActions","onLoadActions"

,function (){var self=this;((((smalltalk.S8Web.classVariableAt_("OnLoadActions") || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeOnLoadActions();})() : nil);

return smalltalk.S8Web.classVariableAt_("OnLoadActions");return self;}

,"loading",unescape("onLoadActions%0D%0A%09%22%20Private%20-%20Return%20the%20collection%20of%20actions%20to%20evaluate%20when%20loaded.%20%22%0D%0A%0D%0A%09OnLoadActions%20isNil%20ifTrue%3A%20%5B%20self%20initializeOnLoadActions%20%5D.%0D%0A%09%5EOnLoadActions"));

smalltalk.bind(smalltalk.S8Web.$klass,"onLoad:","onLoad_"

,function (anAction){var self=this;try{((((anAction || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "onLoad_", fn: function(){return self.initializeOnLoadActions()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "onLoad_", fn: function(){return self.onLoadActions().add_(anAction)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "onLoad_"){return $$ex.fn();} throw($$ex);}}

,"loading",unescape("onLoad%3A%20anAction%0D%0A%09%22%20Private%20-%20Set%20an%20action%20to%20be%20evaluated%20when%20the%20receiver%20has%20loaded.%0D%0A%09If%20anAction%20isNil%2C%20the%20known%20actions%20are%20reset.%0D%0A%09%22%0D%0A%0D%0A%09anAction%20isNil%20ifTrue%3A%20%5B%20%5Eself%20initializeOnLoadActions%20%5D.%0D%0A%09%5Eself%20onLoadActions%20add%3A%20anAction"));

smalltalk.bind(smalltalk.S8Web.$klass,"require:","require_"

,function (requirement){var self=this;return self.current().require_(requirement);return self;}

,"require",unescape("require%3A%20requirement%0D%0A%09%22%20Return%20the%20required%20object%20obtained%20from%20loading%20requirement.%20%22%0D%0A%0D%0A%09%5Eself%20current%20require%3A%20requirement"));

smalltalk.bind(smalltalk.S8Web.$klass,"addExpressions:","addExpressions_"

,function (aCollection){var self=this;smalltalk.S8Web.classVariableAt_put_("CommonExpressions",aCollection._comma(self.commonExpressions()));return self;}

,"workspace",unescape("addExpressions%3A%20aCollection%0D%0A%09%22%20Add%20a%20collection%20of%20frequent/common%20expressions%20to%20durrent%20expressions.%20%22%0D%0A%0D%0A%09CommonExpressions%20%3A%3D%20aCollection%20%2C%20self%20commonExpressions"));

smalltalk.bind(smalltalk.S8Web.$klass,"initializeCommonExpressions","initializeCommonExpressions"

,function (){var self=this;smalltalk.S8Web.classVariableAt_put_("CommonExpressions",[[unescape("%5BS8%5D--Frequent%20expressions--"), ""], ["Object withAllSubclasses...", unescape("Object%20withAllSubclasses%20collect%3A%20%5B%3Aeach%7C%20each%20name%20%5D")], ["aClass selectors", "Object selectors"], ["New class...", unescape("Object%20subclass%3A%20%23MyClass%20instanceVariableNames%3A%20%27%20%20one%20two%20%27%20category%3A%20%27MyCategory%27.")], ["FileOut aClass", "Exporter new fileOut: aClass"], ["FileOut aCategory", unescape("Exporter%20new%20fileOutCategory%3A%20%27Kernel%27.")], [unescape("System%20-%20Snapshot"), "Snapshot contents"], [unescape("System%20-%20Contents"), "Smalltalk current imageContents"], ["Scale workspace", "S8Web tool scaleWorkspaceAreas"], [unescape("%5Bupdate%20this%20list%5D"), "S8Web tool updateCommonExpressions"]]);return self;}

,"workspace",unescape("initializeCommonExpressions%0D%0A%09%22%20Private%20-%20Initialize%20the%20common%20expressions%20collection.%20%22%0D%0A%0D%0A%09CommonExpressions%20%3A%3D%20%23%28%0D%0A%09%09%23%28%20%27%5BS8%5D--Frequent%20expressions--%27%20%27%27%20%29%0D%0A%09%09%23%28%20%27Object%20withAllSubclasses...%27%20%27Object%20withAllSubclasses%20collect%3A%20%5B%3Aeach%7C%20each%20name%20%5D%27%20%29%0D%0A%09%09%23%28%20%27aClass%20selectors%27%20%27Object%20selectors%27%20%29%0D%0A%09%09%23%28%20%27New%20class...%27%20%27Object%20subclass%3A%20%23MyClass%20instanceVariableNames%3A%20%27%27%20%20one%20two%20%27%27%20category%3A%20%27%27MyCategory%27%27.%27%20%29%0D%0A%09%09%23%28%20%27FileOut%20aClass%27%20%27Exporter%20new%20fileOut%3A%20aClass%27%20%29%0D%0A%09%09%23%28%20%27FileOut%20aCategory%27%20%27Exporter%20new%20fileOutCategory%3A%20%27%27Kernel%27%27.%27%20%29%0D%0A%09%09%23%28%20%27System%20-%20Snapshot%27%20%27Snapshot%20contents%27%20%29%0D%0A%09%09%23%28%20%27System%20-%20Contents%27%20%27Smalltalk%20current%20imageContents%27%20%29%0D%0A%09%09%23%28%20%27Scale%20workspace%27%20%27S8Web%20tool%20scaleWorkspaceAreas%27%20%29%0D%0A%09%09%23%28%20%27%5Bupdate%20this%20list%5D%27%20%27S8Web%20tool%20updateCommonExpressions%27%20%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.S8Web.$klass,"initializeOnLoadActions","initializeOnLoadActions"

,function (){var self=this;smalltalk.S8Web.classVariableAt_put_("OnLoadActions",smalltalk.Array.$$new());return self;}

,"initialize/release",unescape("initializeOnLoadActions%0D%0A%09%22%20Private%20-%20Initialize%20the%20onLoad%20actions%20collection.%20%22%0D%0A%0D%0A%09OnLoadActions%20%3A%3D%20Array%20new"));

smalltalk.bind(smalltalk.S8Web.$klass,"initialCodeContents","initialCodeContents"

,function (){var self=this;((((smalltalk.S8Web.classVariableAt_("InitialCodeContents") || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeInitialCodeContents();})() : nil);

return smalltalk.S8Web.classVariableAt_("InitialCodeContents");return self;}

,"workspace",unescape("initialCodeContents%0D%0A%09%22%20Private%20-%20Initialize%20the%20initial%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09InitialCodeContents%20isNil%20ifTrue%3A%20%5B%20self%20initializeInitialCodeContents%20%5D.%0D%0A%09%5EInitialCodeContents"));

smalltalk.bind(smalltalk.S8Web.$klass,"initialCodeContents:","initialCodeContents_"

,function (aString){var self=this;smalltalk.S8Web.classVariableAt_put_("InitialCodeContents",aString);return self;}

,"workspace",unescape("initialCodeContents%3A%20aString%0D%0A%09%22%20Set%20the%20initial%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09InitialCodeContents%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.S8Web.$klass,"initializeInitialCodeContents","initializeInitialCodeContents"

,function (){var self=this;self.initialCodeContents_(unescape("%0D%0A%09Object%20selectors%20sorted%0D%0A%09"));return self;}

,"workspace",unescape("initializeInitialCodeContents%0D%0A%09%22%20Private%20-%20Returns%20the%20initial%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09self%20initialCodeContents%3A%20%27%0D%0A%09Object%20selectors%20sorted%0D%0A%09%27"));

smalltalk.bind(smalltalk.S8Web,"home","home"

,function (){var self=this;return unescape("http%3A//www.aleReimondo.com");return self;}

,"accessing",unescape("home%0D%0A%09%22%20Return%20the%20home%20address.%20%22%0D%0A%0D%0A%09%5E%27http%3A//www.aleReimondo.com%27"));

smalltalk.bind(smalltalk.S8Web,"id","id"

,function (){var self=this;return self['@id'];return self;}

,"accessing",unescape("id%0D%0A%09%22%20Return%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eid"));

smalltalk.bind(smalltalk.S8Web,"id:","id_"

,function (aSymbol){var self=this;self['@id']=aSymbol;return self;}

,"accessing",unescape("id%3A%20aSymbol%0D%0A%09%22%20Set%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09id%20%3A%3D%20aSymbol"));

smalltalk.bind(smalltalk.S8Web,"useCache","useCache"

,function (){var self=this;return true;return self;}

,"private",unescape("useCache%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20use%20internal%20cache.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.S8Web,"soleInstance","soleInstance"

,function (){var self=this;return self.$klass.instances().size()._eq((1));return self;}

,"private",unescape("soleInstance%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20the%20only%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20instances%20size%20%3D%201"));

smalltalk.bind(smalltalk.S8Web,"widgets","widgets"

,function (){var self=this;((((self['@widgets'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@widgets']=smalltalk.Dictionary.$$new();})() : nil);

return self['@widgets'];return self;}

,"private",unescape("widgets%0D%0A%09%22%20Private%20-%20Return%20the%20catched%20widgets%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09widgets%20isNil%20ifTrue%3A%20%5B%20widgets%20%3A%3D%20Dictionary%20new%20%5D.%0D%0A%09%5Ewidgets"));

smalltalk.bind(smalltalk.S8Web,"withChildrenOf:do:","withChildrenOf_do_"

,function (aDOMElement,aBlock){var self=this;aDOMElement.childNodesDo_((function(each){aBlock.value_(each);return self.withChildrenOf_do_(each, aBlock);}));return self;}

,"private",unescape("withChildrenOf%3A%20aDOMElement%20do%3A%20aBlock%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20for%20children%20of%20aDOMElement%20recursivelly.%20%22%0D%0A%0D%0A%09aDOMElement%20childNodesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09aBlock%20value%3A%20each.%0D%0A%09%09self%20withChildrenOf%3A%20each%20do%3A%20aBlock.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.S8Web,"container","container"

,function (){var self=this;return smalltalk.DOM.document().getElementById_(self.id());return self;}

,"private",unescape("container%0D%0A%09%22%20Private%20-%20Return%20the%20DOMElement%20containing%20the%20GUI%20of%20receiver.%20%22%0D%0A%0D%0A%09%5EDOM%20document%20getElementById%3A%20self%20id"));

smalltalk.bind(smalltalk.S8Web,"widgetNamed:","widgetNamed_"

,function (aSymbol){var self=this;try{((self.soleInstance()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "widgetNamed_", fn: function(){return smalltalk.DOM.document().getElementById_(aSymbol)}})})();})() : nil);

self.withChildrenOf_do_(self.container(), (function(each){return ((aSymbol._eq(each.id())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "widgetNamed_", fn: function(){return each}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "widgetNamed_", fn: function(){return self.error_(unescape("Missing%20widget%20named%20%23")._comma(aSymbol))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "widgetNamed_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("widgetNamed%3A%20aSymbol%0D%0A%09%22%20Private%20-%20Return%20the%20widget%20with%20id%20aSymbol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20soleInstance%20ifTrue%3A%20%5B%20%22we%20use%20global%20lookup%20if%20possible%22%0D%0A%09%09%5EDOM%20document%20getElementById%3A%20aSymbol%0D%0A%09%5D.%0D%0A%09self%20withChildrenOf%3A%20self%20container%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09aSymbol%20%3D%20each%20id%20ifTrue%3A%20%5B%20%5Eeach%20%5D.%0D%0A%09%5D.%0D%0A%09%5Eself%20error%3A%20%27Missing%20widget%20named%20%23%27%2CaSymbol%20"));

smalltalk.bind(smalltalk.S8Web,"@","_at"

,function (aSymbol){var self=this;try{((self.useCache()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_at", fn: function(){return self.widgetNamed_(aSymbol)}})})();})());

(function(){throw({name: "stReturn", selector: "_at", fn: function(){return self.widgets().at_ifAbsentPut_(aSymbol, (function(){return self.widgetNamed_(aSymbol);}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_at"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("@%20aSymbol%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20element%20with%20id%20aSymbol%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20useCache%20ifFalse%3A%20%5B%20%5Eself%20widgetNamed%3A%20aSymbol%20%5D.%0D%0A%09%5Eself%20widgets%20at%3A%20aSymbol%20ifAbsentPut%3A%20%5B%20self%20widgetNamed%3A%20aSymbol%20%5D"));

smalltalk.bind(smalltalk.S8Web,"playground","playground"

,function (){var self=this;return self._at("playground");return self;}

,"private",unescape("playground%0D%0A%09%22%20Private%20-%20Return%20the%20DOMElement%20for%20playground%20embedding.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23playground"));

smalltalk.bind(smalltalk.S8Web,"showLicense","showLicense"

,function (){var self=this;(function(){return self._at("license").innerHTML_(unescape("%3Cpre%3E")._comma(smalltalk.Smalltalk.current().licenseTerms())._comma(unescape("%3C/pre%3E%0D%0A%09%3Cbr%3E%3Cb%3ENote%3A%3C/b%3E%20To%20change%20this%20text%20edit%20the%20methods%20at%20Smalltalk%23license...%0D%0A%09%3Cbr%3EPlease%20read%20the%20terms%20of%20use%20before%20saving%20this%20image.")));}).on_do_(smalltalk.Error, (function(){return self.show_(unescape("%3Ca%20href%3D%22mailTo%3AaleReimondo@smalltalking.net%22%3EWrite%20an%20email%3C/a%3E%20to%20ask%20for%20License%20terms."));}));return self;}

,"private",unescape("showLicense%0D%0A%09%22%20Private%20-%20Show%20the%20license%20terms.%20%22%0D%0A%0D%0A%09%5B%20self%20@%20%23license%20innerHTML%3A%20%27%3Cpre%3E%27%2CSmalltalk%20current%20licenseTerms%2C%27%3C/pre%3E%0D%0A%09%3Cbr%3E%3Cb%3ENote%3A%3C/b%3E%20To%20change%20this%20text%20edit%20the%20methods%20at%20Smalltalk%23license...%0D%0A%09%3Cbr%3EPlease%20read%20the%20terms%20of%20use%20before%20saving%20this%20image.%27%0D%0A%09%5D%20on%3A%20Error%20do%3A%20%5B%20self%20show%3A%20%27%3Ca%20href%3D%22mailTo%3AaleReimondo@smalltalking.net%22%3EWrite%20an%20email%3C/a%3E%20to%20ask%20for%20License%20terms.%27%20%5D."));

smalltalk.bind(smalltalk.S8Web,"install","install"

,function (){var self=this;self.container().innerHTML_(self.html());

self.open();return self;}

,"startup",unescape("install%0D%0A%09%22%20Install%20the%20receiver%20in%20element%20with%20id.%20%22%0D%0A%0D%0A%09self%20container%20innerHTML%3A%20self%20html.%0D%0A%09self%20open."));

smalltalk.bind(smalltalk.S8Web,"html","html"

,function (){var self=this;return self.workspaceHTML()._comma(self.quickViewHTML())._comma(self.transcriptHTML());return self;}

,"gui",unescape("html%0D%0A%09%22%20Return%20the%20HTML%20code%20for%20widgets%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20workspaceHTML%0D%0A%09%09%2Cself%20quickViewHTML%0D%0A%09%09%2Cself%20transcriptHTML"));

smalltalk.bind(smalltalk.S8Web,"reference","reference"

,function (){var self=this;return unescape("%28S8Web%20@%20%23")._comma(self.id().asString())._comma(unescape("%29%20"));return self;}

,"gui",unescape("reference%0D%0A%09%22%20Private%20-%20Self%20reference.%20%22%0D%0A%0D%0A%09%5E%27%28S8Web%20@%20%23%27%2Cself%20id%20asString%2C%27%29%20%27"));

smalltalk.bind(smalltalk.S8Web,"with:event:do:","with_event_do_"

,function (anID,eventName,aString){var self=this;var element=nil;element=self._at(anID).handle();

element[eventName]=self.scriptSending_(aString);return self;}

,"gui",unescape("with%3A%20anID%20event%3A%20eventName%20do%3A%20aString%0D%0A%09%22%20Private%20-%20Evaluate%20code%20in%20aString%20on%20HTML%20event%20named%20eventName%20triggered%20by%20aDOMElement.%20%22%0D%0A%0D%0A%22Do%20NOT%20work%20on%20IE%20-%20See%20https%3A//developer.mozilla.org/en/DOM/element.addEventListener%0D%0A%09self%20@%20anID%0D%0A%09%09setAttribute%3A%20eventName%0D%0A%09%09to%3A%20%28self%20codeSending%3A%20aString%29.%0D%0AWe%20use%20OLD%20mechanism%20to%20set%20handler.%0D%0A%22%09%7C%20element%20%7C%0D%0A%09element%20%3A%3D%20%28self%20@%20anID%29%20handle.%0D%0A%09element%5BeventName%5D%20%3A%3D%20%28self%20scriptSending%3A%20aString%29.%20"));

smalltalk.bind(smalltalk.S8Web,"open","open"

,function (){var self=this;self.initializeWorkspace();

self.initializeQuickView();

self.updateQuickView();

(function(aString){return self.show_(aString);}).installAs_("print");

self.onLoadActions().asActionSequence().evaluateWithArguments_(smalltalk.Array.with_(self));

self.print_(self.reference()._comma(unescape("Installed%21")));return self;}

,"gui",unescape("open%0D%0A%09%22%20Open%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20initializeWorkspace.%0D%0A%09self%20initializeQuickView.%0D%0A%09self%20updateQuickView.%0D%0A%09%5B%3AaString%7C%20self%20show%3A%20aString%20%5D%20installAs%3A%20%23print.%0D%0A%09self%20onLoadActions%20asActionSequence%20evaluateWithArguments%3A%20%28Array%20with%3A%20self%29.%0D%0A%09self%20print%3A%20self%20reference%2C%27Installed%21%27."));

smalltalk.bind(smalltalk.S8Web,"show:","show_"

,function (aString){var self=this;try{var transcript=nil;var maxSize=nil;var stream=nil;var newLine=nil;var old=nil;maxSize=((1024) * (2));

newLine=unescape("%3Cbr/%3E");

transcript=self._at("transcriptView");

((((transcript || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "show_", fn: function(){return self}})})();})() : nil);

((((aString || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "show_", fn: function(){return transcript.innerHTML_("")}})})();})() : nil);

old=transcript.innerHTML();

((((old || nil) === nil)).mustBeBoolean()==true ? (function(){return old="";})() : nil);

((old.size()._gt(maxSize)).mustBeBoolean()==true ? (function(){stream=old.copyFrom_to_((old.size()._minus(maxSize) + (1)), old.size()).stream();return old="..."._comma((function($rec){$rec.upTo_(newLine);return $rec.upTo_(smalltalk.Object.$$new());})(stream));})() : nil);

transcript.innerHTML_(old._comma(newLine)._comma(aString));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "show_"){return $$ex.fn();} throw($$ex);}}

,"transcript",unescape("show%3A%20aString%0D%0A%09%22%20Output%20aString%20on%20transcript.%20%22%0D%0A%0D%0A%09%7C%20transcript%20maxSize%20stream%20newLine%20old%20%7C%0D%0A%09maxSize%20%3A%3D%201024%20*%202.%0D%0A%09newLine%20%3A%3D%20%27%3Cbr/%3E%27.%0D%0A%09transcript%20%3A%3D%20self%20@%20%23transcriptView.%0D%0A%09transcript%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09aString%20isNil%20ifTrue%3A%20%5B%20%5Etranscript%20innerHTML%3A%20%27%27%20%5D.%0D%0A%09old%20%3A%3D%20transcript%20innerHTML.%0D%0A%09old%20isNil%20ifTrue%3A%20%5B%20old%20%3A%3D%20%27%27%20%5D.%0D%0A%09old%20size%20%3E%20maxSize%20ifTrue%3A%20%5B%0D%0A%09%09stream%20%3A%3D%20%28old%20copyFrom%3A%20old%20size%20-%20maxSize%20+%201%20to%3A%20old%20size%29%20stream.%0D%0A%09%09old%20%3A%3D%20%27...%27%2C%28stream%20upTo%3A%20newLine%3B%20upTo%3A%20Object%20new%29.%0D%0A%09%5D.%0D%0A%09transcript%20innerHTML%3A%20old%20%2CnewLine%20%2CaString"));

smalltalk.bind(smalltalk.S8Web,"clearTranscript","clearTranscript"

,function (){var self=this;return self.show_(nil);return self;}

,"transcript",unescape("clearTranscript%0D%0A%09%22%20Clear%20the%20transcript%20view.%20%22%0D%0A%0D%0A%09%5Eself%20show%3A%20nil"));

smalltalk.bind(smalltalk.S8Web,"codeSending:to:","codeSending_to_"

,function (messageString,aReceiverString){var self=this;return unescape("%27")._comma(aReceiverString)._comma(messageString)._comma(unescape("%27"))._comma(unescape(".doIt%28%29"));return self;}

,"quickView",unescape("codeSending%3A%20messageString%20to%3A%20aReceiverString%0D%0A%09%22%20Private%20-%20Return%20the%20script%20code%20to%20route%20message%20aReceiverString.%20%22%0D%0A%0D%0A%09%5E%24%27%20%2CaReceiverString%20%2CmessageString%20%2C%24%27%20%2C%27.doIt%28%29%27"));

smalltalk.bind(smalltalk.S8Web,"codeSending:","codeSending_"

,function (messageString){var self=this;return self.codeSending_to_(messageString, self.reference());return self;}

,"quickView",unescape("codeSending%3A%20messageString%0D%0A%09%22%20Private%20-%20Return%20the%20script%20code%20to%20route%20message%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20codeSending%3A%20messageString%20to%3A%20self%20reference"));

smalltalk.bind(smalltalk.S8Web,"scriptSending:","scriptSending_"

,function (messageString){var self=this;return unescape("%5B")._comma(self.reference())._comma(messageString)._comma(unescape("%5D")).doIt();return self;}

,"quickView",unescape("scriptSending%3A%20messageString%0D%0A%09%22%20Private%20-%20Return%20the%20script%20code%20to%20route%20message%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28%27%5B%27%20%2Cself%20reference%20%2CmessageString%20%2C%27%5D%27%29%20doIt"));

smalltalk.bind(smalltalk.S8Web,"updateClassList","updateClassList"

,function (){var self=this;var list=nil;var mask=nil;var names=nil;var maxNames=nil;maxNames=(50);

list=self._at("classList");

mask=self._at("classMask").value();

names=smalltalk.Smalltalk.current().classes().collect_((function(each){return each.name();}));

((((mask || nil) !== nil)).mustBeBoolean()==true ? (function(){return names=names.select_((function(each){return each.match_(mask);}));})() : nil);

names=names.sorted();

((names.size()._gt(maxNames)).mustBeBoolean()==true ? (function(){return names=names.copyFrom_to_((1), maxNames).copyWith_(unescape("%22...more%22"));})() : nil);

list.items_([unescape("%22--class%20selector--%22")]._comma(names));return self;}

,"quickView",unescape("updateClassList%0D%0A%09%22%20Private%20-%20Update%20the%20class%20view%20widget.%20%22%0D%0A%0D%0A%09%7C%20list%20mask%20names%20maxNames%20%7C%0D%0A%09maxNames%20%3A%3D%2050.%0D%0A%09list%20%3A%3D%20self%20@%20%23classList.%0D%0A%09mask%20%3A%3D%20%28self%20@%20%23classMask%29%20value.%0D%0A%09names%20%3A%3D%20Smalltalk%20current%20classes%20collect%3A%20%5B%3Aeach%7C%20each%20name%20%5D.%0D%0A%09mask%20notNil%20ifTrue%3A%20%5B%20names%20%3A%3D%20names%20select%3A%20%5B%3Aeach%7C%20each%20match%3A%20mask%20%5D%20%5D.%0D%0A%09names%20%3A%3D%20names%20sorted.%0D%0A%09names%20size%20%3E%20maxNames%20ifTrue%3A%20%5B%20names%20%3A%3D%20%28names%20copyFrom%3A%201%20to%3A%20maxNames%29%20copyWith%3A%20%27%22...more%22%27%20%5D.%0D%0A%09list%20items%3A%20%23%28%20%27%22--class%20selector--%22%27%20%29%20%2Cnames"));

smalltalk.bind(smalltalk.S8Web,"updateMethodList","updateMethodList"

,function (){var self=this;try{var list=nil;var option=nil;var aClass=nil;var mask=nil;var addItem=nil;var addSelectors=nil;var selection=nil;var addItems=nil;var addClasses=nil;list=self._at("classList");

option=list.selectedOption();

((((option || nil) === nil).or_((function(){aClass=option.value().doIt();return ((aClass || nil) === nil);}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "updateMethodList", fn: function(){return self._at("methodList").removeAll()}})})();})() : nil);

mask=self._at("methodMask").value();

list=self._at("methodList");

list.removeAll();

addItem=(function(what){return list.addItem_(what);});

addItems=(function(tag, items){return ((items.notEmpty()).mustBeBoolean()==true ? (function(){addItem.value_(unescape("%22--")._comma(tag)._comma(unescape("--%22")));return items.do_((function(each){return addItem.value_(each);}));})() : nil);});

addClasses=(function(tag, classes){return addItems.value_value_(tag, classes.collect_((function(each){return each.name();})));});

addSelectors=(function(cls, title){selection=((((mask || nil) === nil)).mustBeBoolean()==true ? (function(){return cls.selectors();})() : (function(){return cls.selectors().select_((function(each){return each.match_(mask);}));})());return ((selection.notEmpty()).mustBeBoolean()==true ? (function(){addItem.value_(title);return selection.sorted().do_((function(selector){return addItem.value_(cls.name()._comma(unescape("%3E%3E%23"))._comma(selector));}));})() : nil);});

addItem.value_(unescape("%22")._comma(aClass.name())._comma(unescape("%22")));

addItem.value_(aClass.name()._comma(unescape("%22%20--%20fileOut%20--%20%22")));

addItems.value_value_("samples", self.expressionsFor_category_(aClass, "sample"));

addItems.value_value_("tests", self.expressionsFor_category_(aClass, "test"));

addClasses.value_value_("superclasses", aClass.allSuperclasses());

(function($rec){$rec.value_value_(aClass, unescape("%22--%20instance%20methods%20--%22"));return $rec.value_value_(aClass.$klass, unescape("%22--%20class%20methods%20--%22"));})(addSelectors);

addClasses.value_value_("subclasses", aClass.subclasses());return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "updateMethodList"){return $$ex.fn();} throw($$ex);}}

,"quickView",unescape("updateMethodList%0D%0A%09%22%20Private%20-%20Update%20the%20methods%20view%20widget.%20%22%0D%0A%0D%0A%09%7C%20list%20option%20aClass%20mask%20addItem%20addSelectors%20selection%20addItems%20addClasses%20%7C%0D%0A%09list%20%3A%3D%20self%20@%20%23classList.%0D%0A%09option%20%3A%3D%20list%20selectedOption.%0D%0A%09%28option%20isNil%20or%3A%20%5B%0D%0A%09%09aClass%20%3A%3D%20option%20value%20doIt.%20aClass%20isNil%20%5D%29%0D%0A%09%09ifTrue%3A%20%5B%20%5E%28self%20@%20%23methodList%29%20removeAll%20%5D.%0D%0A%09mask%20%3A%3D%20%28self%20@%20%23methodMask%29%20value.%0D%0A%09list%20%3A%3D%20self%20@%20%23methodList.%0D%0A%09list%20removeAll.%0D%0A%09addItem%20%3A%3D%20%5B%3Awhat%7C%20list%20addItem%3A%20what%20%5D.%0D%0A%09addItems%20%3A%3D%20%5B%3Atag%20%3Aitems%7C%0D%0A%09%09items%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%09%09addItem%20value%3A%20%27%22--%27%2Ctag%2C%27--%22%27.%0D%0A%09%09%09items%20do%3A%20%5B%3Aeach%7C%20addItem%20value%3A%20each%20%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09addClasses%20%3A%3D%20%5B%3Atag%20%3Aclasses%7C%0D%0A%09%09addItems%20value%3A%20tag%20value%3A%20%28classes%20collect%3A%20%5B%3Aeach%7C%20each%20name%20%5D%29%0D%0A%09%5D.%0D%0A%09addSelectors%20%3A%3D%20%5B%3Acls%20%3Atitle%7C%0D%0A%09%09selection%20%3A%3D%20mask%20isNil%20ifTrue%3A%20%5B%20cls%20selectors%20%5D%20ifFalse%3A%20%5B%0D%0A%09%09%09cls%20selectors%20select%3A%20%5B%3Aeach%7C%20each%20match%3A%20mask%20%5D.%0D%0A%09%09%5D.%0D%0A%09%09selection%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%09%09addItem%20value%3A%20title.%0D%0A%09%09%09selection%20sorted%20do%3A%20%5B%3Aselector%7C%0D%0A%09%09%09%09addItem%20value%3A%20cls%20name%20%2C%27%3E%3E%23%27%20%2Cselector%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09addItem%20value%3A%20%27%22%27%2CaClass%20name%2C%27%22%27.%0D%0A%09addItem%20value%3A%20aClass%20name%2C%27%22%20--%20fileOut%20--%20%22%27.%0D%0A%09addItems%20value%3A%20%23samples%20value%3A%20%28self%20expressionsFor%3A%20aClass%20category%3A%20%23sample%29.%0D%0A%09addItems%20value%3A%20%23tests%20value%3A%20%28self%20expressionsFor%3A%20aClass%20category%3A%20%23test%29.%0D%0A%09addClasses%20value%3A%20%23superclasses%20value%3A%20aClass%20allSuperclasses.%0D%0A%09addSelectors%0D%0A%09%09value%3A%20aClass%20value%3A%20%27%22--%20instance%20methods%20--%22%27%3B%0D%0A%09%09value%3A%20aClass%20class%20value%3A%20%27%22--%20class%20methods%20--%22%27.%0D%0A%09addClasses%20value%3A%20%23subclasses%20value%3A%20aClass%20subclasses."));

smalltalk.bind(smalltalk.S8Web,"expressionsFor:category:","expressionsFor_category_"

,function (aClass,category){var self=this;return aClass.$klass.selectors().select_((function(each){return each.includes_(":").not().and_((function(){return aClass.$klass._gt_gt(each).category().match_(category);}));})).collect_((function(each){return aClass.name()._comma(" ")._comma(each);}));return self;}

,"quickView",unescape("expressionsFor%3A%20aClass%20category%3A%20category%0D%0A%09%22%20Private%20-%20Return%20the%20evaluable%20expressions%20defined%20by%20aClass%20under%20category.%20%22%0D%0A%0D%0A%09%5E%28aClass%20class%20selectors%0D%0A%09%09select%3A%20%5B%3Aeach%7C%20%28each%20includes%3A%20%24%3A%29%20not%0D%0A%09%09%09and%3A%20%5B%20%28aClass%20class%20%3E%3E%20each%29%20category%20match%3A%20category%20%5D%0D%0A%09%09%5D%29%20collect%3A%20%5B%3Aeach%7C%20aClass%20name%20%2C%27%20%27%20%2Ceach%20%5D"));

smalltalk.bind(smalltalk.S8Web,"quickFileOutClassNamed:","quickFileOutClassNamed_"

,function (className){var self=this;try{var sourceCode=nil;((((className || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "quickFileOutClassNamed_", fn: function(){return self}})})();})() : nil);

sourceCode="Exporter new fileOut: "._comma(className);

(function($rec){$rec.resultValue_(sourceCode);$rec.resultValue_(sourceCode.doIt());return $rec.yourself();})(self);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "quickFileOutClassNamed_"){return $$ex.fn();} throw($$ex);}}

,"quickView",unescape("quickFileOutClassNamed%3A%20className%0D%0A%09%22%20FileOut%20smalltalk%20code%20of%20class%20named%20className.%20%22%0D%0A%0D%0A%09%7C%20sourceCode%20%7C%0D%0A%09className%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09sourceCode%20%3A%3D%20%27Exporter%20new%20fileOut%3A%20%27%20%2CclassName.%0D%0A%09self%0D%0A%09%09resultValue%3A%20sourceCode%3B%0D%0A%09%09resultValue%3A%20sourceCode%20doIt%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.S8Web,"quickFileOutMethod:","quickFileOutMethod_"

,function (spec){var self=this;try{var what=nil;((((spec || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "quickFileOutMethod_", fn: function(){return self}})})();})() : nil);

what=spec.doIt();

((((what || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "quickFileOutMethod_", fn: function(){return self}})})();})() : nil);

((what.isClass()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "quickFileOutMethod_", fn: function(){return self.quickFileOutClassNamed_(spec)}})})();})() : nil);

sourceCode=unescape("Exporter%20new%20fileOutMethod%3A%20%28")._comma(spec)._comma(unescape("%29%20of%3A%20"))._comma(spec.upTo_(unescape("%3E")));

(function($rec){$rec.value_(sourceCode);$rec.value_(sourceCode.doIt());return $rec.yourself();})(self._at("result"));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "quickFileOutMethod_"){return $$ex.fn();} throw($$ex);}}

,"quickView",unescape("quickFileOutMethod%3A%20spec%0D%0A%09%22%20FileOut%20smalltalk%20code%20of%20method%20in%20spec%20string.%20%22%0D%0A%0D%0A%09%7C%20what%20%7C%0D%0A%09spec%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09what%20%3A%3D%20spec%20doIt.%0D%0A%09what%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09what%20isClass%20ifTrue%3A%20%5B%20%5Eself%20quickFileOutClassNamed%3A%20spec%20%5D.%0D%0A%09sourceCode%20%3A%3D%20%27Exporter%20new%20fileOutMethod%3A%20%28%27%20%2Cspec%20%2C%27%29%20of%3A%20%27%20%2C%28spec%20upTo%3A%20%24%3E%29.%0D%0A%09%28self%20@%20%23result%29%0D%0A%09%09value%3A%20sourceCode%3B%0D%0A%09%09value%3A%20sourceCode%20doIt%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.S8Web,"classListUpdate","classListUpdate"

,function (){var self=this;var option=nil;option=self._at("classList").selectedOption();

((((option || nil) !== nil)).mustBeBoolean()==true ? (function(){return nil;})() : nil);

self.updateMethodList();return self;}

,"quickView",unescape("classListUpdate%0D%0A%09%22%20The%20classList%20has%20changed%2C%20update%20GUI%20reflecting%20change.%20%22%0D%0A%0D%0A%09%7C%20option%20%7C%0D%0A%09option%20%3A%3D%20%28self%20@%20%23classList%29%20selectedOption.%0D%0A%09option%20notNil%20ifTrue%3A%20%5B%20%22self%20quickFileOutClassNamed%3A%20option%20value%22%20%5D.%0D%0A%09self%20updateMethodList."));

smalltalk.bind(smalltalk.S8Web,"methodListUpdate","methodListUpdate"

,function (){var self=this;var option=nil;option=self._at("methodList").selectedOption();

((((option || nil) !== nil)).mustBeBoolean()==true ? (function(){return self.quickFileOutMethod_(option.value());})() : nil);return self;}

,"quickView",unescape("methodListUpdate%0D%0A%09%22%20The%20methodList%20has%20changed%2C%20update%20GUI%20reflecting%20change.%20%22%0D%0A%0D%0A%09%7C%20option%20%7C%0D%0A%09option%20%3A%3D%20%28self%20@%20%23methodList%29%20selectedOption.%0D%0A%09option%20notNil%20ifTrue%3A%20%5B%20self%20quickFileOutMethod%3A%20option%20value%20%5D."));

smalltalk.bind(smalltalk.S8Web,"updateQuickView","updateQuickView"

,function (){var self=this;(function($rec){$rec.updateClassList();$rec.updateMethodList();return $rec.yourself();})(self);return self;}

,"quickView",unescape("updateQuickView%0D%0A%09%22%20Fill%20the%20QuickView%20widgets.%20%22%0D%0A%0D%0A%09self%0D%0A%09%09updateClassList%3B%0D%0A%09%09updateMethodList%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.S8Web,"initializeQuickView","initializeQuickView"

,function (){var self=this;self.with_event_do_("transcriptReset", "onclick", "clearTranscript");

self.with_event_do_("classMask", "onchange", "updateQuickView");

self.with_event_do_("classMaskChanged", "onclick", "updateQuickView");

self.with_event_do_("classList", "onchange", "classListUpdate");

self.with_event_do_("methodMask", "onchange", "updateMethodList");

self.with_event_do_("methodMaskChanged", "onclick", "updateMethodList");

self.with_event_do_("methodList", "onchange", "methodListUpdate");return self;}

,"quickView",unescape("initializeQuickView%0D%0A%09%22%20Private%20-%20Initialize%20the%20QuickView%20widgets.%20%22%0D%0A%0D%0A%09self%20with%3A%20%23transcriptReset%20event%3A%20%27onclick%27%20do%3A%20%23clearTranscript.%0D%0A%09self%20with%3A%20%23classMask%20event%3A%20%27onchange%27%20do%3A%20%23updateQuickView.%0D%0A%09self%20with%3A%20%23classMaskChanged%20event%3A%20%27onclick%27%20do%3A%20%23updateQuickView.%0D%0A%09self%20with%3A%20%23classList%20event%3A%20%27onchange%27%20do%3A%20%23classListUpdate.%0D%0A%09self%20with%3A%20%23methodMask%20event%3A%20%27onchange%27%20do%3A%20%23updateMethodList.%0D%0A%09self%20with%3A%20%23methodMaskChanged%20event%3A%20%27onclick%27%20do%3A%20%23updateMethodList.%0D%0A%09self%20with%3A%20%23methodList%20event%3A%20%27onchange%27%20do%3A%20%23methodListUpdate."));

smalltalk.bind(smalltalk.S8Web,"showIt","showIt"

,function (){var self=this;self.resultValue_(self.codeValue().doIt());return self;}

,"workspace",unescape("showIt%0D%0A%09%22%20Evaluate%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09self%20resultValue%3A%20self%20codeValue%20doIt"));

smalltalk.bind(smalltalk.S8Web,"fileItIn","fileItIn"

,function (){var self=this;self.resultValue_(self.codeValue().fileIn());return self;}

,"workspace",unescape("fileItIn%0D%0A%09%22%20FileIn%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09self%20resultValue%3A%20self%20codeValue%20fileIn"));

smalltalk.bind(smalltalk.S8Web,"evalIt","evalIt"

,function (){var self=this;self.resultValue_(eval(self.codeValue()));return self;}

,"workspace",unescape("evalIt%0D%0A%09%22%20Evaluate%20%28javascript%29%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09self%20resultValue%3A%20%28%23%20%23eval%3A%20self%20codeValue%29"));

smalltalk.bind(smalltalk.S8Web,"updateCommonExpressions","updateCommonExpressions"

,function (){var self=this;self._at("frequentSelector").items_(self.$klass.commonExpressions());return self;}

,"udate",unescape("updateCommonExpressions%0D%0A%09%22%20Update%20the%20common%20expressions%20list.%20%22%0D%0A%0D%0A%09self%20@%20%23frequentSelector%20items%3A%20self%20class%20commonExpressions"));

smalltalk.bind(smalltalk.S8Web,"frequentSelectorChanged","frequentSelectorChanged"

,function (){var self=this;try{var option=nil;option=self._at("frequentSelector").selectedOption();

((((option || nil) !== nil)).mustBeBoolean()==true ? (function(){option=option.value();((option.isString().and_((function(){return option.notEmpty().and_((function(){return option.first()._eq(unescape("%21"));}));}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "frequentSelectorChanged", fn: function(){return self.resultValue_(option.fileIn())}})})();})() : nil);return self.codeValue_(option);})() : nil);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "frequentSelectorChanged"){return $$ex.fn();} throw($$ex);}}

,"workspace",unescape("frequentSelectorChanged%0D%0A%09%22%20The%20user%20selected%20an%20item%20of%20frequent%20expressions.%20%22%0D%0A%0D%0A%09%7C%20option%20%7C%0D%0A%09option%20%3A%3D%20%28self%20@%20%23frequentSelector%29%20selectedOption.%0D%0A%09option%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09option%20%3A%3D%20option%20value.%0D%0A%09%09%28option%20isString%20and%3A%20%5B%20option%20notEmpty%0D%0A%09%09%09and%3A%20%5B%20option%20first%20%3D%20%24%21%20%5D%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%5Eself%20resultValue%3A%20option%20fileIn%0D%0A%09%09%5D.%0D%0A%09%09self%20codeValue%3A%20option%0D%0A%09%5D"));

smalltalk.bind(smalltalk.S8Web,"initializeWorkspace","initializeWorkspace"

,function (){var self=this;var frequent=nil;self.with_event_do_("showIt", "onclick", "showIt");

self.with_event_do_("fileItIn", "onclick", "fileItIn");

self.with_event_do_("evalIt", "onclick", "evalIt");

self.with_event_do_("frequentSelector", "onchange", "frequentSelectorChanged");

self.updateCommonExpressions();

self.initializeNotes();

(function(){return self.scaleWorkspaceAreas();}).on_do_(smalltalk.Error, (function(){return nil;}));return self;}

,"workspace",unescape("initializeWorkspace%0D%0A%09%22%20Private%20-%20Initialize%20the%20workspace%20widgets.%20%22%0D%0A%0D%0A%09%7C%20frequent%20%7C%0D%0A%09self%20with%3A%20%23showIt%20event%3A%20%27onclick%27%20do%3A%20%23showIt.%0D%0A%09self%20with%3A%20%23fileItIn%20event%3A%20%27onclick%27%20do%3A%20%23fileItIn.%0D%0A%09self%20with%3A%20%23evalIt%20event%3A%20%27onclick%27%20do%3A%20%23evalIt.%0D%0A%0D%0A%09self%20with%3A%20%23frequentSelector%20event%3A%20%27onchange%27%20do%3A%20%23frequentSelectorChanged.%0D%0A%09self%20updateCommonExpressions.%0D%0A%09self%20initializeNotes.%0D%0A%09%5B%20self%20scaleWorkspaceAreas%20%5D%20on%3A%20Error%20do%3A%20%5B%5D."));

smalltalk.bind(smalltalk.S8Web,"initializeNotes","initializeNotes"

,function (){var self=this;self.with_event_do_("prevNote", "onclick", "prevNote");

self.with_event_do_("addNote", "onclick", "addNote");

self.with_event_do_("removeNote", "onclick", "removeNote");

self.with_event_do_("nextNote", "onclick", "nextNote");return self;}

,"notes",unescape("initializeNotes%0D%0A%09%22%20Private%20-%20Initialize%20the%20notes%20widgets.%20%22%0D%0A%0D%0A%09self%20with%3A%20%23prevNote%20event%3A%20%27onclick%27%20do%3A%20%23prevNote.%0D%0A%09self%20with%3A%20%23addNote%20event%3A%20%27onclick%27%20do%3A%20%23addNote.%0D%0A%09self%20with%3A%20%23removeNote%20event%3A%20%27onclick%27%20do%3A%20%23removeNote.%0D%0A%09self%20with%3A%20%23nextNote%20event%3A%20%27onclick%27%20do%3A%20%23nextNote."));

smalltalk.bind(smalltalk.S8Web,"scaleWorkspaceAreas","scaleWorkspaceAreas"

,function (){var self=this;var width=nil;width=smalltalk.DOM.window().innerWidth();

((((width || nil) === nil)).mustBeBoolean()==true ? (function(){return width=smalltalk.DOM.document().body().offsetWidth();})() : nil);

((((width || nil) === nil)).mustBeBoolean()==true ? (function(){return width=smalltalk.DOM.screen().width();})() : nil);

self.scaleWidthsOf_to_(smalltalk.Array.with_with_(self._at("code"), self._at("result")), (width - (80))._slash_slash(((self.portrait()).mustBeBoolean()==true ? (function(){return (1);})() : (function(){return (2);})())));return self;}

,"workspace",unescape("scaleWorkspaceAreas%0D%0A%09%22%20Scale%20the%20code%20areas%20of%20worspace%20to%20window.%20%22%0D%0A%0D%0A%09%7C%20width%20%7C%0D%0A%09width%20%3A%3D%20DOM%20window%20innerWidth.%0D%0A%09width%20isNil%20ifTrue%3A%20%5B%20width%20%3A%3D%20DOM%20document%20body%20offsetWidth%20%5D.%0D%0A%09width%20isNil%20ifTrue%3A%20%5B%20width%20%3A%3D%20DOM%20screen%20width%20%5D.%0D%0A%09self%0D%0A%09%09scaleWidthsOf%3A%20%28Array%20with%3A%20self%20@%20%23code%20with%3A%20self%20@%20%23result%29%0D%0A%09%09to%3A%20width%20-%2080%20//%20%28self%20portrait%20ifTrue%3A%20%5B1%5D%20ifFalse%3A%20%5B2%5D%29"));

smalltalk.bind(smalltalk.S8Web,"scaleWidthsOf:to:","scaleWidthsOf_to_"

,function (textAreas,width){var self=this;var colSize=nil;textAreas.do_((function(each){((each.cols()._eq((0))).mustBeBoolean()==true ? (function(){return each.cols_((1));})() : nil);colSize=each.clientWidth()._slash_slash(each.cols()).max_((1));return each.cols_(width._slash_slash(colSize));}));return self;}

,"private",unescape("scaleWidthsOf%3A%20textAreas%20to%3A%20width%0D%0A%09%22%20Private%20-%20Change%20the%20widths%20of%20textArea%20elements%20to%20width%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09%7C%20colSize%20%7C%0D%0A%09textAreas%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20cols%20%3D%200%20ifTrue%3A%20%5B%20each%20cols%3A%201%20%5D.%0D%0A%09%09colSize%20%3A%3D%20each%20clientWidth%20//%20each%20cols%20max%3A%201.%0D%0A%09%09each%20cols%3A%20width%20//%20colSize.%09%09%0D%0A%09%5D"));

smalltalk.bind(smalltalk.S8Web,"quickViewHTML","quickViewHTML"

,function (){var self=this;return unescape("%0D%0A%3Cform%20name%3D%22quickView%22%20style%3D%22margin-bottom%3A0px%22%3E%0D%0A%09%3Ctable%20border%3D0%20cellspacing%3D1%3E%3Ctr%3E%3Ctd%3E%3Cfont%20size%3D+2%3E%0D%0A%09%3Cinput%20type%3D%22text%22%20size%3D5%20id%3D%22classMask%22%20/%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22classMaskChanged%22%20value%3D%22%3E%3E%22%3E%0D%0A%09%3Cselect%20id%3D%22classList%22%20size%3D1%3E%3C/select%3E%0D%0A%09%3C/font%3E%3C/td%3E%3Ctd%3E%3Cfont%20size%3D+2%3E%0D%0A%09%3Cinput%20type%3D%22text%22%20size%3D5%20id%3D%22methodMask%22%20/%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22methodMaskChanged%22%20value%3D%22%3E%3E%22%3E%0D%0A%09%3Cselect%20id%3D%22methodList%22%20size%3D1%3E%0D%0A%09%3C/select%3E%0D%0A%09%3C/font%3E%3C/td%3E%3C/tr%3E%3C/table%3E%0D%0A%3C/form%3E");return self;}

,"views",unescape("quickViewHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20workspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%0D%0A%3Cform%20name%3D%22quickView%22%20style%3D%22margin-bottom%3A0px%22%3E%0D%0A%09%3Ctable%20border%3D0%20cellspacing%3D1%3E%3Ctr%3E%3Ctd%3E%3Cfont%20size%3D+2%3E%0D%0A%09%3Cinput%20type%3D%22text%22%20size%3D5%20id%3D%22classMask%22%20/%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22classMaskChanged%22%20value%3D%22%3E%3E%22%3E%0D%0A%09%3Cselect%20id%3D%22classList%22%20size%3D1%3E%3C/select%3E%0D%0A%09%3C/font%3E%3C/td%3E%3Ctd%3E%3Cfont%20size%3D+2%3E%0D%0A%09%3Cinput%20type%3D%22text%22%20size%3D5%20id%3D%22methodMask%22%20/%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22methodMaskChanged%22%20value%3D%22%3E%3E%22%3E%0D%0A%09%3Cselect%20id%3D%22methodList%22%20size%3D1%3E%0D%0A%09%3C/select%3E%0D%0A%09%3C/font%3E%3C/td%3E%3C/tr%3E%3C/table%3E%0D%0A%3C/form%3E%27"));

smalltalk.bind(smalltalk.S8Web,"transcriptHTML","transcriptHTML"

,function (){var self=this;return unescape("%0D%0A%3Cform%20name%3D%22transcriptForm%22%3E%3Chr%3E%0D%0A%09%3Ctable%20border%3D0%3E%3Ctr%3E%3Ctd%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20value%3D%22Clear%22%20id%3D%22transcriptReset%22%20onClick%3D%22%22%3E%3C/td%3E%3Ctd%3E%0D%0A%09%3Cdiv%20id%3D%22transcriptView%22%3E%5BTranscript%5D%3C/div%3E%0D%0A%09%3C/td%3E%3C/tr%3E%3C/table%3E%0D%0A%3C/form%3E");return self;}

,"views",unescape("transcriptHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20workspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%0D%0A%3Cform%20name%3D%22transcriptForm%22%3E%3Chr%3E%0D%0A%09%3Ctable%20border%3D0%3E%3Ctr%3E%3Ctd%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20value%3D%22Clear%22%20id%3D%22transcriptReset%22%20onClick%3D%22%22%3E%3C/td%3E%3Ctd%3E%0D%0A%09%3Cdiv%20id%3D%22transcriptView%22%3E%5BTranscript%5D%3C/div%3E%0D%0A%09%3C/td%3E%3C/tr%3E%3C/table%3E%0D%0A%3C/form%3E%27"));

smalltalk.bind(smalltalk.S8Web,"portrait","portrait"

,function (){var self=this;return smalltalk.DOM.screen().width()._lt(smalltalk.DOM.screen().height());return self;}

,"orientation",unescape("portrait%0D%0A%09%22%20Private%20-%20Return%20true%20if%20the%20layout%20of%20the%20receiver%20is%20%23portrait.%20%22%0D%0A%0D%0A%09%5EDOM%20screen%20width%20%3C%20DOM%20screen%20height"));

smalltalk.bind(smalltalk.S8Web,"workspaceCodeHTML","workspaceCodeHTML"

,function (){var self=this;return unescape("%3Ctextarea%20id%3D%22code%22%20rows%3D15%20cols%3D67%3E")._comma(self.$klass.initialCodeContents())._comma(unescape("%3C/textArea%3E"));return self;}

,"views",unescape("workspaceCodeHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28workspace%29code%20pane%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Ctextarea%20id%3D%22code%22%20rows%3D15%20cols%3D67%3E%27%20%2Cself%20class%20initialCodeContents%20%2C%27%3C/textArea%3E%27"));

smalltalk.bind(smalltalk.S8Web,"workspaceResultHTML","workspaceResultHTML"

,function (){var self=this;return unescape("%3Ctextarea%20id%3D%22result%22%20rows%3D15%20cols%3D60%3E%20%3C/textarea%3E");return self;}

,"views",unescape("workspaceResultHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28workspace%29result%20pane%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Ctextarea%20id%3D%22result%22%20rows%3D15%20cols%3D60%3E%20%3C/textarea%3E%27"));

smalltalk.bind(smalltalk.S8Web,"workspaceActionsHTML","workspaceActionsHTML"

,function (){var self=this;return unescape("%3Cfont%20size%3D+2%3E%3Cb%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22showIt%22%20value%3D%22showIt%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22fileItIn%22%20value%3D%22fileIn%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22evalIt%22%20value%3D%22javascript%22%3E%0D%0A%09%5B")._comma(self.notesHTML())._comma(unescape("%5D%0D%0A%09%3Cselect%20id%3D%22frequentSelector%22%20size%3D%221%22%3E%3C/select%3E%0D%0A%09%3C/b%3E%3C/font%3E"));return self;}

,"views",unescape("workspaceActionsHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28workspace%29actions%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Cfont%20size%3D+2%3E%3Cb%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22showIt%22%20value%3D%22showIt%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22fileItIn%22%20value%3D%22fileIn%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22evalIt%22%20value%3D%22javascript%22%3E%0D%0A%09%5B%27%2Cself%20notesHTML%2C%27%5D%0D%0A%09%3Cselect%20id%3D%22frequentSelector%22%20size%3D%221%22%3E%3C/select%3E%0D%0A%09%3C/b%3E%3C/font%3E%27"));

smalltalk.bind(smalltalk.S8Web,"notesHTML","notesHTML"

,function (){var self=this;return unescape("%3Cinput%20type%3D%22button%22%20id%3D%22prevNote%22%20value%3D%22%3C%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22addNote%22%20value%3D%22+%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22removeNote%22%20value%3D%22-%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22nextNote%22%20value%3D%22%3E%22%3E");return self;}

,"views",unescape("notesHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28note%29actions%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Cinput%20type%3D%22button%22%20id%3D%22prevNote%22%20value%3D%22%3C%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22addNote%22%20value%3D%22+%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22removeNote%22%20value%3D%22-%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22nextNote%22%20value%3D%22%3E%22%3E%27"));

smalltalk.bind(smalltalk.S8Web,"workspaceRowsHTML","workspaceRowsHTML"

,function (){var self=this;var separator=nil;var colspan=nil;separator=colspan="";

((self.portrait()).mustBeBoolean()==true ? (function(){return separator=unescape("%3C/tr%3E%3Ctr%3E");})() : (function(){return colspan=unescape("%20colspan%3D2");})());

return unescape("%3Ctr%3E%3Ctd%3E")._comma(self.workspaceCodeHTML())._comma(unescape("%3C/td%3E"))._comma(separator)._comma(unescape("%3Ctd%3E"))._comma(self.workspaceResultHTML())._comma(unescape("%3C/td%3E%3Ctr"))._comma(colspan)._comma(unescape("%3E%3Ctd%3E"))._comma(self.workspaceActionsHTML())._comma(unescape("%3C/td%3E%3C/tr%3E"));return self;}

,"views",unescape("workspaceRowsHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28workspace%29rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20separator%20colspan%20%7C%0D%0A%09separator%20%3A%3D%20colspan%20%3A%3D%20%27%27.%0D%0A%09self%20portrait%20ifTrue%3A%20%5B%0D%0A%09%09separator%20%3A%3D%20%27%3C/tr%3E%3Ctr%3E%27.%0D%0A%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09colspan%20%20%20%3A%3D%20%27%20colspan%3D2%27.%0D%0A%09%5D.%0D%0A%0D%0A%09%5E%27%3Ctr%3E%3Ctd%3E%27%2C%09self%20workspaceCodeHTML%0D%0A%09%2C%27%3C/td%3E%27%2C%09separator%0D%0A%09%2C%27%3Ctd%3E%27%2C%09self%20workspaceResultHTML%0D%0A%09%2C%27%3C/td%3E%3Ctr%27%2C%09colspan%0D%0A%09%2C%27%3E%3Ctd%3E%27%2C%09self%20workspaceActionsHTML%0D%0A%09%2C%27%3C/td%3E%3C/tr%3E%27"));

smalltalk.bind(smalltalk.S8Web,"workspaceHTML","workspaceHTML"

,function (){var self=this;return unescape("%3Cform%3E%3Ctable%20border%3D0%3E%0D%0A%09")._comma(self.workspaceRowsHTML())._comma(unescape("%0D%0A%09%3C/table%3E%3C/form%3E"));return self;}

,"views",unescape("workspaceHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20workspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Cform%3E%3Ctable%20border%3D0%3E%0D%0A%09%27%2Cself%20workspaceRowsHTML%2C%27%0D%0A%09%3C/table%3E%3C/form%3E%27"));

smalltalk.bind(smalltalk.S8Web,"maximizePlayground","maximizePlayground"

,function (){var self=this;(function($rec){$rec.left_((0));$rec.top_((0));$rec.width_(unescape("100%25"));return $rec.height_(unescape("100%25"));})(self.playground().style());

self.hideAllExcept_("playground");return self;}

,"GUI",unescape("maximizePlayground%0D%0A%09%22%20Private%20-%20Maximize%20the%20playground.%20%22%0D%0A%0D%0A%09self%20playground%20style%0D%0A%09%09left%3A%200%3B%20top%3A%200%3B%0D%0A%09%09width%3A%20%27100%25%27%3B%20height%3A%20%27100%25%27.%0D%0A%09self%20hideAllExcept%3A%20%23playground."));

smalltalk.bind(smalltalk.S8Web,"hideAllExcept:","hideAllExcept_"

,function (anId){var self=this;smalltalk.DOM.document().body().childNodes().do_((function(each){return ((((each.id() || nil) === nil).or_((function(){return each.id()._eq(anId);}))).mustBeBoolean()==true ? nil : (function(){return ((((each.style() || nil) !== nil)).mustBeBoolean()==true ? (function(){return each.style().display_("none");})() : nil);})());}));return self;}

,"GUI",unescape("hideAllExcept%3A%20anId%0D%0A%09%22%20Maximize%20the%20elements%20in%20current%20document%20except%20the%20element%20with%20id%20anId.%20%22%0D%0A%0D%0A%09DOM%20document%20body%20childNodes%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09%28each%20id%20isNil%20or%3A%20%5B%20each%20id%20%3D%20anId%20%5D%29%20ifFalse%3A%20%5B%0D%0A%09%09%09each%20style%20notNil%20ifTrue%3A%20%5B%20each%20style%20display%3A%20%23none%20%5D%0D%0A%09%09%5D.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.S8Web,"restorePlayground","restorePlayground"

,function (){var self=this;(function($rec){$rec.width_(unescape("100%25"));return $rec.height_("20px");})(self.playground().style());

self.playground().innerHTML_(unescape("-playground-"));return self;}

,"GUI",unescape("restorePlayground%0D%0A%09%22%20Private%20-%20Restore%20the%20playground%20to%20the%20original%20size%20and%20content.%20%22%0D%0A%0D%0A%09self%20playground%20style%20width%3A%20%27100%25%27%3B%20height%3A%20%2720px%27.%0D%0A%09self%20playground%20innerHTML%3A%20%27-playground-%27"));

smalltalk.bind(smalltalk.S8Web,"restoreAll","restoreAll"

,function (){var self=this;smalltalk.DOM.document().body().childNodes().do_((function(each){return ((((each.style() || nil) !== nil)).mustBeBoolean()==true ? (function(){return each.style().display_("block");})() : nil);}));

self.restorePlayground();return self;}

,"GUI",unescape("restoreAll%0D%0A%09%22%20Restore%20the%20elements%20in%20current%20document.%20%22%0D%0A%0D%0A%09DOM%20document%20body%20childNodes%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20style%20notNil%20ifTrue%3A%20%5B%20each%20style%20display%3A%20%23block%20%5D%0D%0A%09%5D.%0D%0A%09self%20restorePlayground."));

smalltalk.bind(smalltalk.S8Web,"codeValue","codeValue"

,function (){var self=this;return self._at("code").value();return self;}

,"accessing",unescape("codeValue%0D%0A%09%22%20Return%20the%20value%20in%20the%20code%20pane.%20%22%0D%0A%0D%0A%09%5E%28self%20@%20%23code%29%20value"));

smalltalk.bind(smalltalk.S8Web,"codeValue:","codeValue_"

,function (aValue){var self=this;return self._at("code").value_(aValue);return self;}

,"accessing",unescape("codeValue%3A%20aValue%0D%0A%09%22%20Set%20the%20value%20in%20the%20code%20pane.%20%22%0D%0A%0D%0A%09%5E%28self%20@%20%23code%29%20value%3A%20aValue"));

smalltalk.bind(smalltalk.S8Web,"resultValue","resultValue"

,function (){var self=this;return self._at("result").value();return self;}

,"accessing",unescape("resultValue%0D%0A%09%22%20Return%20the%20value%20in%20the%20result%20pane.%20%22%0D%0A%0D%0A%09%5E%28self%20@%20%23result%29%20value"));

smalltalk.bind(smalltalk.S8Web,"resultValue:","resultValue_"

,function (aValue){var self=this;return self._at("result").value_(aValue);return self;}

,"accessing",unescape("resultValue%3A%20aValue%0D%0A%09%22%20Set%20the%20value%20in%20the%20result%20pane.%20%22%0D%0A%0D%0A%09%5E%28self%20@%20%23result%29%20value%3A%20aValue"));

smalltalk.bind(smalltalk.S8Web,"onLoadActions","onLoadActions"

,function (){var self=this;return self.$klass.onLoadActions();return self;}

,"accessing",unescape("onLoadActions%0D%0A%09%22%20Return%20the%20actions%20to%20evaluate%20on%20load.%20%22%0D%0A%0D%0A%09%5Eself%20class%20onLoadActions"));

smalltalk.bind(smalltalk.S8Web,"sample","sample"

,function (){var self=this;try{var document=nil;var sample=nil;var first=nil;document=smalltalk.DOM.document();

sample=document._at("sample");

((((sample || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "sample", fn: function(){return sample}})})();})() : nil);

sample=document.createElement_("div");

sample.id_("sample");

first=document.body().childNodeAt_((1));

document.body().insert_before_(sample.handle(), first.handle());

(function(){throw({name: "stReturn", selector: "sample", fn: function(){return sample}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "sample"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("sample%0D%0A%09%22%20Return%20the%20sample%20DIV%20element.%0D%0A%09If%20the%20element%20is%20not%20still%20present%20in%20the%20page%2C%20it%20will%20be%20created.%0D%0A%09%22%0D%0A%09%7C%20document%20sample%20first%20%7C%0D%0A%09document%20%3A%3D%20DOM%20document.%0D%0A%09sample%20%3A%3D%20document%20@%20%23sample.%0D%0A%09sample%20notNil%20ifTrue%3A%20%5B%20%5Esample%20%5D.%0D%0A%09sample%20%3A%3D%20document%20createElement%3A%20%23div.%0D%0A%09sample%20id%3A%20%23sample.%0D%0A%09first%20%3A%3D%20document%20body%20childNodeAt%3A%201.%0D%0A%09document%20body%20insert%3A%20sample%20handle%20before%3A%20first%20handle.%0D%0A%09%5Esample%20"));

smalltalk.bind(smalltalk.S8Web,"notes","notes"

,function (){var self=this;return smalltalk.Smalltalk.at_ifAbsentPut_("WorkspaceAnnotations", (function(){return smalltalk.Array.$$new();}));return self;}

,"accessing",unescape("notes%0D%0A%09%22%20Return%20the%20notes%20stored%20in%20the%20annotation%20system.%20%22%0D%0A%0D%0A%09%5ESmalltalk%20at%3A%20%23WorkspaceAnnotations%20ifAbsentPut%3A%20%5B%20Array%20new%20%5D"));

smalltalk.bind(smalltalk.S8Web,"hasNotes","hasNotes"

,function (){var self=this;return smalltalk.Smalltalk.at_ifAbsent_("WorkspaceAnnotations", (function(){return [];})).notEmpty();return self;}

,"accessing",unescape("hasNotes%0D%0A%09%22%20Return%20true%20if%20there%20is%20at%20least%20one%20annotation%20saved.%20%22%0D%0A%0D%0A%09%5E%28Smalltalk%20at%3A%20%23WorkspaceAnnotations%20ifAbsent%3A%20%5B%20%23%28%29%20%5D%29%20notEmpty"));

smalltalk.bind(smalltalk.S8Web,"prevNote","prevNote"

,function (){var self=this;try{var note=nil;var index=nil;((self.hasNotes()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "prevNote", fn: function(){return self.print_("There is no annotations.")}})})();})());

note=self.codeValue();

index=self.notes().indexOf_ifAbsent_(note, (function(){return (0);}));

index=(index - (1));

(((index <= (0))).mustBeBoolean()==true ? (function(){return index=self.notes().size();})() : nil);

self.codeValue_(self.notes().at_ifAbsent_(index, (function(){return note;})));

self.print_(unescape("Annotation%20%23")._comma(index.asString()));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "prevNote"){return $$ex.fn();} throw($$ex);}}

,"notes",unescape("prevNote%0D%0A%09%22%20Fill%20contents%20of%20code%20pane%20with%20previous%20note.%20%22%0D%0A%0D%0A%09%7C%20note%20index%20%7C%0D%0A%09self%20hasNotes%20ifFalse%3A%20%5B%20%5Eself%20print%3A%20%27There%20is%20no%20annotations.%27%20%5D.%0D%0A%09note%20%3A%3D%20self%20codeValue.%0D%0A%09index%20%3A%3D%20self%20notes%20indexOf%3A%20note%20ifAbsent%3A%20%5B%200%20%5D.%0D%0A%09index%20%3A%3D%20index%20-%201.%0D%0A%09index%20%3C%3D%200%20ifTrue%3A%20%5B%20index%20%3A%3D%20self%20notes%20size%20%5D.%0D%0A%09self%20codeValue%3A%20%28self%20notes%20at%3A%20index%20ifAbsent%3A%20%5B%20note%20%5D%29.%0D%0A%09self%20print%3A%20%27Annotation%20%23%27%2Cindex%20asString."));

smalltalk.bind(smalltalk.S8Web,"nextNote","nextNote"

,function (){var self=this;try{var note=nil;var index=nil;((self.hasNotes()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "nextNote", fn: function(){return self.print_("There is no annotations.")}})})();})());

note=self.codeValue();

index=self.notes().indexOf_ifAbsent_(note, (function(){return self.notes().size();}));

index=(index + (1));

((index._gt(self.notes().size())).mustBeBoolean()==true ? (function(){return index=(1);})() : nil);

self.codeValue_(self.notes().at_ifAbsent_(index, (function(){return note;})));

self.print_(unescape("Annotation%20%23")._comma(index.asString()));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "nextNote"){return $$ex.fn();} throw($$ex);}}

,"notes",unescape("nextNote%0D%0A%09%22%20Fill%20contents%20of%20code%20pane%20with%20next%20note.%20%22%0D%0A%0D%0A%09%7C%20note%20index%20%7C%0D%0A%09self%20hasNotes%20ifFalse%3A%20%5B%20%5Eself%20print%3A%20%27There%20is%20no%20annotations.%27%20%5D.%0D%0A%09note%20%3A%3D%20self%20codeValue.%0D%0A%09index%20%3A%3D%20self%20notes%20indexOf%3A%20note%20ifAbsent%3A%20%5B%20self%20notes%20size%20%5D.%0D%0A%09index%20%3A%3D%20index%20+%201.%0D%0A%09index%20%3E%20self%20notes%20size%20ifTrue%3A%20%5B%20index%20%3A%3D%201%20%5D.%0D%0A%09self%20codeValue%3A%20%28self%20notes%20at%3A%20index%20ifAbsent%3A%20%5B%20note%20%5D%29.%0D%0A%09self%20print%3A%20%27Annotation%20%23%27%2Cindex%20asString."));

smalltalk.bind(smalltalk.S8Web,"addNote","addNote"

,function (){var self=this;self.notes().add_(self.codeValue());

self.print_(unescape("Annotation%20%23")._comma(self.notes().size().asString())._comma(" saved."));return self;}

,"notes",unescape("addNote%0D%0A%09%22%20Add%20the%20contents%20of%20code%20pane%20as%20a%20new%20note.%20%22%0D%0A%0D%0A%09self%20notes%20add%3A%20self%20codeValue.%0D%0A%09self%20print%3A%20%27Annotation%20%23%27%2Cself%20notes%20size%20asString%2C%27%20saved.%27"));

smalltalk.bind(smalltalk.S8Web,"removeNote","removeNote"

,function (){var self=this;try{((self.hasNotes()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "removeNote", fn: function(){return self.print_("There is no annotations.")}})})();})());

self.notes().remove_ifAbsent_(self.codeValue(), (function(){return (function(){throw({name: "stReturn", selector: "removeNote", fn: function(){return self.print_("There is no annotation with this text.")}})})();}));

self.print_("Annotation removed.");return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "removeNote"){return $$ex.fn();} throw($$ex);}}

,"notes",unescape("removeNote%0D%0A%09%22%20Remove%20the%20current%20contents%20of%20code%20pane%20from%20Annoation%20sytem.%20%22%0D%0A%0D%0A%09self%20hasNotes%20ifFalse%3A%20%5B%20%5Eself%20print%3A%20%27There%20is%20no%20annotations.%27%20%5D.%0D%0A%09self%20notes%0D%0A%09%09remove%3A%20self%20codeValue%0D%0A%09%09ifAbsent%3A%20%5B%20%5Eself%20print%3A%20%27There%20is%20no%20annotation%20with%20this%20text.%27%20%5D.%0D%0A%09self%20print%3A%20%27Annotation%20removed.%27"));

smalltalk.bind(smalltalk.S8Web,"require:","require_"

,function (requirement){var self=this;return self.require_useNative_(requirement, true);return self;}

,"require",unescape("require%3A%20requirement%0D%0A%09%5Eself%20require%3A%20requirement%20useNative%3A%20true"));

smalltalk.bind(smalltalk.S8Web,"require:useNative:","require_useNative_"

,function (requirement,useNative){var self=this;try{var $$native=nil;var url=nil;((requirement.isArray()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return requirement.collect_((function(each){return self.require_useNative_(each, useNative);}))}})})();})() : nil);

((useNative).mustBeBoolean()==true ? (function(){$$native=smalltalk.Smalltalk.jsObjectAt_ifAbsent_("require", (function(){return nil;}));(((($$native || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return $$native.value_(requirement)}})})();})() : nil);return (function(what){return self.require_useNative_(what, false);}).installAs_("require");})() : nil);

((((requirement || nil) === nil)).mustBeBoolean()==true ? (function(){self['@requireMap']=nil;return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return nil}})})();})() : nil);

url=self.resolve_(requirement);

((((url || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return nil}})})();})() : nil);

((url.isArray()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return self.require_useNative_(url, useNative)}})})();})() : nil);

((((self['@requireMap'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@requireMap']=smalltalk.Dictionary.$$new();})() : nil);

(function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return self['@requireMap'].at_ifAbsentPut_(url, (function(){return self.loadScript_(url);}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "require_useNative_"){return $$ex.fn();} throw($$ex);}}

,"require",unescape("require%3A%20requirement%20useNative%3A%20useNative%0D%0A%09%22%20Return%20the%20required%20object%20obtained%20from%20loading%20requirement.%0D%0A%09-%20requirement%20can%20be%20anArray%20of%20requirements%0D%0A%09-%20the%20native/global%20function%20require%28%29%20can%20be%20used%20if%20present%20in%20globals%0D%0A%09-%20if%20requirement%20isNil%2C%20the%20internal%20cache%20is%20reset.%0D%0A%09-%20see%20%23resolve%3A%20to%20understand%20name%20resolution%0D%0A%09--%20return%20nil%20if%20name%20can%uFFFDt%20be%20resolved%0D%0A%09--%20if%20resolution%20return%20an%20array%2C%20it%20will%20load%20multiple%20requirements%0D%0A%09-%20see%20%23basicRequire%3A%20to%20understand%20loading%20mechanism%0D%0A%09%22%0D%0A%0D%0A%09%7C%20native%20url%20%7C%0D%0A%09requirement%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09%5Erequirement%20collect%3A%20%5B%3Aeach%7C%20self%20require%3A%20each%20useNative%3A%20useNative%20%5D%0D%0A%09%5D.%0D%0A%09useNative%20ifTrue%3A%20%5B%0D%0A%09%09native%20%3A%3D%20Smalltalk%20jsObjectAt%3A%20%23require%20ifAbsent%3A%20%5B%5D.%0D%0A%09%09native%20notNil%20ifTrue%3A%20%5B%20%5Enative%20value%3A%20requirement%20%5D.%0D%0A%09%09%5B%3Awhat%7C%20self%20require%3A%20what%20useNative%3A%20false%20%5D%20installAs%3A%20%23require.%0D%0A%09%5D.%0D%0A%09requirement%20isNil%20ifTrue%3A%20%5B%20requireMap%20%3A%3D%20nil.%20%5Enil%20%5D.%0D%0A%09url%20%3A%3D%20self%20resolve%3A%20requirement.%0D%0A%09url%20isNil%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09url%20isArray%20ifTrue%3A%20%5B%20%5Eself%20require%3A%20url%20useNative%3A%20useNative%20%5D.%0D%0A%09requireMap%20isNil%20ifTrue%3A%20%5B%20requireMap%20%3A%3D%20Dictionary%20new%20%5D.%0D%0A%09%5ErequireMap%20at%3A%20url%20ifAbsentPut%3A%20%5B%20self%20loadScript%3A%20url%20%5D"));

smalltalk.bind(smalltalk.S8Web,"requireSolver:","requireSolver_"

,function (aBlock){var self=this;self['@requireSolver']=aBlock;return self;}

,"require",unescape("requireSolver%3A%20aBlock%0D%0A%09%22%20Set%20the%20solver%20used%20to%20find%20url%20of%20requirements.%20%22%0D%0A%0D%0A%09requireSolver%20%3A%3D%20aBlock"));

smalltalk.bind(smalltalk.S8Web,"resolve:","resolve_"

,function (codeName){var self=this;try{var result=nil;var fileName=nil;(("u8"._eq(codeName.upTo_(":"))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return self.resolve_(self.profileURL()._comma(codeName.copyFrom_to_((4), codeName.size())))}})})();})() : nil);

((((self['@requireSolver'] || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return self['@requireSolver'].value_(codeName)}})})();})() : nil);

((codeName.first()._eq(".")).mustBeBoolean()==true ? (function(){((codeName.second()._eq(unescape("/"))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return self.resolve_(requireFolder._comma(codeName.copyFrom_to_((3), codeName.size())))}})})();})() : nil);return ((codeName.third()._eq(".").and_((function(){return codeName.fourth()._eq(unescape("/"));}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return self.resolve_(self.$klass.parentURL_(requireFolder)._comma(codeName.copyFrom_to_((4), codeName.size())))}})})();})() : nil);})() : nil);

fileName=codeName.copyFrom_to_((codeName.lastIndexOf_(unescape("/")) + (1)), codeName.size());

(function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return ((fileName.includes_(".")).mustBeBoolean()==true ? (function(){return codeName;})() : (function(){return codeName._comma(".js");})())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "resolve_"){return $$ex.fn();} throw($$ex);}}

,"require",unescape("resolve%3A%20codeName%0D%0A%09%22%20Private%20-%20Try%20to%20resolve%20the%20codeName%20to%20return%20url%20of%20source%28s%29%20to%20load.%0D%0A%09Return%20nil%20on%20failure%2C%20an%20URL%20or%20anArray%20of%20codeNames%20to%20require%20%28recursivelly%29.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20result%20fileName%20%7C%0D%0A%09%23u8%20%3D%20%28codeName%20upTo%3A%20%24%3A%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20resolve%3A%20self%20profileURL%2C%20%28codeName%20copyFrom%3A%204%20to%3A%20codeName%20size%29%0D%0A%09%5D.%0D%0A%09requireSolver%20notNil%20ifTrue%3A%20%5B%20%5ErequireSolver%20value%3A%20codeName%20%5D.%0D%0A%09codeName%20first%20%3D%20%24.%20ifTrue%3A%20%5B%0D%0A%09%09codeName%20second%20%3D%20%24/%20ifTrue%3A%20%5B%0D%0A%09%09%09%5Eself%20resolve%3A%20requireFolder%20%2C%28codeName%20copyFrom%3A%203%20to%3A%20codeName%20size%29%0D%0A%09%09%5D.%0D%0A%09%09%28codeName%20third%20%3D%20%24.%20and%3A%20%5B%20codeName%20fourth%20%3D%20%24/%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%5Eself%20resolve%3A%20%28self%20class%20parentURL%3A%20requireFolder%29%20%2C%28codeName%20copyFrom%3A%204%20to%3A%20codeName%20size%29%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09fileName%20%3A%3D%20codeName%20copyFrom%3A%20%28codeName%20lastIndexOf%3A%20%24/%29%20+%201%20to%3A%20codeName%20size.%0D%0A%09%5E%28fileName%20includes%3A%20%24.%29%0D%0A%09%09ifTrue%3A%20%5B%20codeName%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20codeName%20%2C%27.js%27%20%5D"));

smalltalk.bind(smalltalk.S8Web,"loadScript:","loadScript_"

,function (url){var self=this;try{self.withContentsOf_do_(url, (function(contents){var old=nil;var result=nil;old=requireFolder;requireFolder=url.upToLast_(unescape("/"));(function(){return result=eval(unescape("function%28%29%20%7B%20var%20exports%20%3D%20%7B%7D%3B")._comma(contents)._comma(unescape("%20return%20exports%3B%7D%28%29%3B")));}).ensure_((function(){return requireFolder=old;}));return (function(){throw({name: "stReturn", selector: "loadScript_", fn: function(){return result}})})();}));

(function(){throw({name: "stReturn", selector: "loadScript_", fn: function(){return self.error_("Accessing code at "._comma(url))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "loadScript_"){return $$ex.fn();} throw($$ex);}}

,"require",unescape("loadScript%3A%20url%0D%0A%09%22%20Private%20-%20Load%20the%20%28require%20formated%29%20code%20script%20at%20url.%0D%0A%09Return%20the%20requirement%20result%20%28a%20hash%20object%29.%0D%0A%09Can%20trigger%20errors%20during%20loading...%0D%0A%09%22%0D%0A%0D%0A%09self%20withContentsOf%3A%20url%20do%3A%20%5B%3Acontents%7C%20%7C%20old%20result%20%7C%0D%0A%09%09old%20%3A%3D%20requireFolder.%0D%0A%09%09requireFolder%20%3A%3D%20url%20upToLast%3A%20%24/.%0D%0A%09%09%5B%20result%20%3A%3D%20%23%20%23eval%3A%20%28%0D%0A%09%09%09%27function%28%29%20%7B%20var%20exports%20%3D%20%7B%7D%3B%27%0D%0A%09%09%09%2Ccontents%0D%0A%09%09%09%2C%27%20return%20exports%3B%7D%28%29%3B%27%29.%0D%0A%09%09%5D%20ensure%3A%20%5B%20requireFolder%20%3A%3D%20old%20%5D.%0D%0A%09%09%5Eresult%0D%0A%09%5D.%0D%0A%09%5Eself%20error%3A%20%27Accessing%20code%20at%20%27%20%2Curl"));

smalltalk.bind(smalltalk.Exception,"nativeException","nativeException"

,function (){var self=this;return (self[unescape("@nativeException")] || nil);return self;}

,unescape("exception%20handling"),unescape("nativeException%0D%0A%09%22%20Private%2C%20Internal%20-%20Return%20the%20native%20exception%20associated%20with%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27@nativeException%27"));

smalltalk.bind(smalltalk.Exception,"nativeException:","nativeException_"

,function ($$native){var self=this;return (self[unescape("@nativeException")]=($$native));return self;}

,unescape("exception%20handling"),unescape("nativeException%3A%20native%0D%0A%09%22%20Private%2C%20Internal%20-%20Set%20the%20native%20exception%20associated%20with%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27@nativeException%27%20put%3A%20native"));

smalltalk.bind(smalltalk.Exception,"stack","stack"

,function (){var self=this;try{var aNative=nil;var result=nil;aNative=(self[unescape("@nativeException")] || nil);

((((aNative || nil) === nil).or_((function(){result=aNative.stack;return ((result || nil) === nil);}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "stack", fn: function(){return ""}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "stack", fn: function(){return result}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "stack"){return $$ex.fn();} throw($$ex);}}

,"stack-trace",unescape("stack%0D%0A%09%22%20Return%20a%20stack%20trace%20string%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%7C%20aNative%20result%20%7C%0D%0A%09aNative%20%3A%3D%20self%20basicAt%3A%20%27@nativeException%27.%0D%0A%09%28aNative%20isNil%20or%3A%20%5B%0D%0A%09%09result%20%3A%3D%20aNative%23stack.%0D%0A%09%09result%20isNil%0D%0A%09%5D%29%20ifTrue%3A%20%5B%20%5E%27%27%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Exception,"toString","toString"

,function (){var self=this;try{((((self.messageText() || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "toString", fn: function(){return unescape("%7Bst%3Aa")._comma(self.$klass.name())._comma(unescape("%20-%20"))._comma(self.messageText())._comma(unescape("%7D"))}})})();})() : nil);

((((self.nativeException() || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "toString", fn: function(){return unescape("%7Bst%3Aa")._comma(self.$klass.name())._comma(unescape("%20-%20"))._comma(self.nativeException().toString())._comma(unescape("%7D"))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "toString", fn: function(){return smalltalk.whoImplements(smalltalk.Exception,'toString').$superclass.$fn.prototype['toString'].apply(self, [])}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "toString"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("toString%0D%0A%09%22%20Convert%20the%20receiver%20to%20a%20String.%20%22%0D%0A%0D%0A%09self%20messageText%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%5E%27%7Bst%3Aa%27%20%2Cself%20class%20name%20%2C%27%20-%20%27%20%2Cself%20messageText%20%2C%24%7D%0D%0A%09%5D.%0D%0A%09self%20nativeException%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%5E%27%7Bst%3Aa%27%20%2Cself%20class%20name%20%2C%27%20-%20%27%20%2Cself%20nativeException%20toString%20%2C%24%7D%0D%0A%09%5D.%0D%0A%09%5Esuper%20toString"));

smalltalk.bind(smalltalk.Exception,"messageText","messageText"

,function (){var self=this;return self['@messageText'];return self;}

,"accessing",unescape("messageText%0D%0A%09%22%20Return%20the%20messageText%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EmessageText"));

smalltalk.bind(smalltalk.Exception,"description","description"

,function (){var self=this;return self.messageText().asString();return self;}

,"accessing",unescape("description%0D%0A%09%22%20Return%20the%20description%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20messageText%20asString"));

smalltalk.bind(smalltalk.Exception,"messageText:","messageText_"

,function (aString){var self=this;self['@messageText']=aString;return self;}

,"accessing",unescape("messageText%3A%20aString%0D%0A%09%22%20set%20the%20messageText%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09messageText%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.Exception,"signal","signal"

,function (){var self=this;self.print_(self.$klass.name()._comma(": ")._comma(self.description()));

throw(self);return self;}

,"signaling",unescape("signal%0D%0A%09%22%20Signal/throw%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20print%3A%20self%20class%20name%20%2C%27%3A%20%27%20%2Cself%20description.%0D%0A%09%23%20%23throw%3A%20self"));

smalltalk.bind(smalltalk.Association.$klass,"key:","key_"

,function (aKey){var self=this;return self.$$new().key_(aKey);return self;}

,unescape("instance%20creation"),unescape("key%3A%20aKey%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%20key%3A%20aKey"));

smalltalk.bind(smalltalk.Association.$klass,"key:value:","key_value_"

,function (aKey,aValue){var self=this;return self.key_(aKey).value_(aValue);return self;}

,unescape("instance%20creation"),unescape("key%3A%20aKey%20value%3A%20aValue%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28self%20key%3A%20aKey%29%20value%3A%20aValue"));

smalltalk.bind(smalltalk.Association,"=","_eq"

,function (anAssociation){var self=this;return self.$klass._eq(anAssociation.$klass).and_((function(){return self.key()._eq(anAssociation.key()).and_((function(){return self.value()._eq(anAssociation.value());}));}));return self;}

,"comparing",unescape("%3D%20anAssociation%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20equal%20to%20anAssociation.%20%22%0D%0A%0D%0A%09%5Eself%20class%20%3D%20anAssociation%20class%20and%3A%20%5B%0D%0A%09%20%20%20%20self%20key%20%3D%20anAssociation%20key%20and%3A%20%5B%0D%0A%09%09self%20value%20%3D%20anAssociation%20value%5D%5D"));

smalltalk.bind(smalltalk.Association,"key:","key_"

,function (aKey){var self=this;self['@key']=aKey;return self;}

,"accessing",unescape("key%3A%20aKey%0D%0A%09%22%20Set%20the%20key%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09key%20%3A%3D%20aKey"));

smalltalk.bind(smalltalk.Association,"key","key"

,function (){var self=this;return self['@key'];return self;}

,"accessing",unescape("key%0D%0A%09%22%20Return%20the%20key%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ekey"));

smalltalk.bind(smalltalk.Association,"value:","value_"

,function (aValue){var self=this;self['@value']=aValue;return self;}

,"accessing",unescape("value%3A%20aValue%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09value%20%3A%3D%20aValue"));

smalltalk.bind(smalltalk.Association,"value","value"

,function (){var self=this;return self['@value'];return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Evalue"));

smalltalk.bind(smalltalk.Association,",","_comma"

,function (anAssociation){var self=this;return smalltalk.ComposedAssociations.with_with_(self, anAssociation);return self;}

,"composing",unescape("%2C%20anAssociation%0D%0A%09%22%20Return%20the%20receiver%20composed%20with%20anAssociation.%20%22%0D%0A%0D%0A%09%5EComposedAssociations%20with%3A%20self%20with%3A%20anAssociation"));

smalltalk.bind(smalltalk.Association,"json","json"

,function (){var self=this;return smalltalk.ComposedAssociations.with_(self).json();return self;}

,"converting",unescape("json%0D%0A%09%22%20Return%20the%20receiver%20copied%20to%20a%20hash%20object.%20%22%0D%0A%0D%0A%09%5E%28ComposedAssociations%20with%3A%20self%29%20json"));

smalltalk.bind(smalltalk.Association,"isAssociation","isAssociation"

,function (){var self=this;return true;return self;}

,"testing",unescape("isAssociation%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20anAssociation.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.ClassBuilder,"superclass:subclass:","superclass_subclass_"

,function (aClass,aString){var self=this;return self.superclass_subclass_instanceVariableNames_category_(aClass, aString, "", nil);return self;}

,"instantiation",unescape("superclass%3A%20aClass%20subclass%3A%20aString%0D%0A%09%22%20Create/Register%20a%20new%20class%20in%20the%20system.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09superclass%3A%20aClass%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20%27%27%0D%0A%09%09category%3A%20nil"));

smalltalk.bind(smalltalk.ClassBuilder,"superclass:subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:","superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_"

,function (aClass,aString,aString2,classVarNames,poolVarNames,aString3){var self=this;var result=nil;var aCategory=nil;aCategory=((((aString3 || nil) === nil)).mustBeBoolean()==true ? (function(){return ((((aClass || nil) === nil)).mustBeBoolean()==true ? (function(){return "unclassified";})() : (function(){return aClass.category();})());})() : (function(){return aString3;})());

result=self.addSubclassOf_named_instanceVariableNames_(aClass, aString, self.instanceVariableNamesFor_(aString2));

self.setupClass_(result);

(function($rec){$rec.classVariableNames_(classVarNames);$rec.poolDictionaryNames_(poolVarNames);return $rec.category_(aCategory);})(result);

((((aClass || nil) !== nil).and_((function(){return smalltalk.Smalltalk.includesKey_("Exporter");}))).mustBeBoolean()==true ? (function(){return self.print_(smalltalk.Exporter.$$new().exportDefinitionOf_(result)._comma(unescape("smalltalk.init%28smalltalk."))._comma(aString)._comma(unescape("%29%3B")));})() : nil);

return result;return self;}

,"instantiation",unescape("superclass%3A%20aClass%0D%0A%09subclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09classVariableNames%3A%20classVarNames%0D%0A%09poolDictionaries%3A%20poolVarNames%0D%0A%09category%3A%20aString3%0D%0A%09%22%20Create/Register%20a%20new%20class%20in%20the%20system.%20%22%0D%0A%0D%0A%09%7C%20result%20aCategory%20%7C%0D%0A%09aCategory%20%3A%3D%20aString3%20isNil%20ifTrue%3A%20%5B%0D%0A%09%09%09aClass%20isNil%20ifTrue%3A%20%5B%20%23unclassified%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20aClass%20category%20%5D%0D%0A%09%09%5D%20ifFalse%3A%20%5B%20aString3%20%5D.%0D%0A%09result%20%3A%3D%20self%0D%0A%09%09addSubclassOf%3A%20aClass%20named%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20%28self%20instanceVariableNamesFor%3A%20aString2%29.%0D%0A%09self%20setupClass%3A%20result.%0D%0A%09result%20%0D%0A%09%09classVariableNames%3A%20classVarNames%3B%0D%0A%09%09poolDictionaryNames%3A%20poolVarNames%3B%0D%0A%09%09category%3A%20aCategory.%0D%0A%09%28aClass%20notNil%20and%3A%20%5B%20Smalltalk%20includesKey%3A%20%23Exporter%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09self%20print%3A%0D%0A%09%09%09%28Exporter%20new%20exportDefinitionOf%3A%20result%29%0D%0A%09%09%09%2C%27smalltalk.init%28smalltalk.%27%2CaString%2C%27%29%3B%27%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.ClassBuilder,"superclass:subclass:instanceVariableNames:category:","superclass_subclass_instanceVariableNames_category_"

,function (aClass,aString,aString2,aString3){var self=this;return self.superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aClass, aString, aString2, "", "", aString3);return self;}

,"instantiation",unescape("superclass%3A%20aClass%0D%0A%09subclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09category%3A%20aString3%0D%0A%09%22%20Create/Register%20a%20new%20class%20in%20the%20system.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09superclass%3A%20aClass%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20%27%27%0D%0A%09%09poolDictionaries%3A%20%27%27%0D%0A%09%09category%3A%20aString3"));

smalltalk.bind(smalltalk.ClassBuilder,"basicClass:instanceVariableNames:","basicClass_instanceVariableNames_"

,function (aMetaClass,anArray){var self=this;	return smalltalk.metaVarNames(aMetaClass,anArray); ;return self;}

,"private",unescape("basicClass%3A%20aMetaClass%20instanceVariableNames%3A%20anArray%0D%0A%09%22%20Private%20-%20Register%20instance%20variables%20onto%20aMetaClass.%20%22%0D%0A%0D%0A%7B%27%09return%20smalltalk.metaVarNames%28aMetaClass%2CanArray%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.ClassBuilder,"class:instanceVariableNames:","class_instanceVariableNames_"

,function (aMetaClass,aString){var self=this;try{var varNames=nil;((aMetaClass.isMetaclass()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "class_instanceVariableNames_", fn: function(){return self.error_(aMetaClass.name()._comma(" is not a metaclass"))}})})();})());

varNames=self.instanceVariableNamesFor_(aString);

((self.basicClass_instanceVariableNames_(aMetaClass, varNames)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "class_instanceVariableNames_", fn: function(){return self}})})();})());

self.setupClass_(aMetaClass);

((smalltalk.Smalltalk.includesKey_("Exporter")).mustBeBoolean()==true ? (function(){return self.print_(smalltalk.Exporter.$$new().exportMetaDefinitionOf_(aMetaClass.instanceClass()));})() : nil);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "class_instanceVariableNames_"){return $$ex.fn();} throw($$ex);}}

,unescape("metaclass%20change"),unescape("class%3A%20aMetaClass%20instanceVariableNames%3A%20aString%0D%0A%09%22%20Register%20instance%20variable%20names%20onto%20aMetaClass.%20%22%0D%0A%0D%0A%09%7C%20varNames%20%7C%0D%0A%09aMetaClass%20isMetaclass%20ifFalse%3A%20%5B%0D%0A%09%09%5Eself%20error%3A%20aMetaClass%20name%2C%20%27%20is%20not%20a%20metaclass%27%0D%0A%09%5D.%0D%0A%09varNames%20%3A%3D%20self%20instanceVariableNamesFor%3A%20aString.%0D%0A%09%28self%20basicClass%3A%20aMetaClass%20instanceVariableNames%3A%20varNames%29%20ifFalse%3A%20%5B%20%5Eself%20%5D.%0D%0A%09self%20setupClass%3A%20aMetaClass.%0D%0A%09%28Smalltalk%20includesKey%3A%20%23Exporter%29%20ifTrue%3A%20%5B%0D%0A%09%09self%20print%3A%20%28Exporter%20new%20exportMetaDefinitionOf%3A%20aMetaClass%20instanceClass%29%0D%0A%09%5D."));

smalltalk.bind(smalltalk.ClassBuilder,"instanceVariableNamesFor:","instanceVariableNamesFor_"

,function (aString){var self=this;return aString.tokenize_(" ").reject_((function(each){return each.isEmpty();}));return self;}

,"private",unescape("instanceVariableNamesFor%3A%20aString%0D%0A%09%22%20Private%20-%20Return%20the%20instance%20variable%20names%20string.%20%22%0D%0A%0D%0A%09%5E%28aString%20tokenize%3A%20%27%20%27%29%20reject%3A%20%5B%3Aeach%20%7C%20each%20isEmpty%20%5D"));

smalltalk.bind(smalltalk.ClassBuilder,"addSubclassOf:named:instanceVariableNames:","addSubclassOf_named_instanceVariableNames_"

,function (aClass,aString,aCollection){var self=this;	 smalltalk.addClass(aString, aClass, aCollection);
	return smalltalk[aString];return self;}

,"private",unescape("addSubclassOf%3A%20aClass%20named%3A%20aString%20instanceVariableNames%3A%20aCollection%0D%0A%09%22%20Private%20-%20Add%20the%20subclass%20to%20system.%20%22%0D%0A%0D%0A%7B%27%09%20smalltalk.addClass%28aString%2C%20aClass%2C%20aCollection%29%3B%0D%0A%09return%20smalltalk%5BaString%5D%27%7D"));

smalltalk.bind(smalltalk.ClassBuilder,"setupClass:","setupClass_"

,function (aClass){var self=this;	smalltalk.init(aClass); ;return self;}

,"private",unescape("setupClass%3A%20aClass%0D%0A%09%22%20Private%20-%20Bind/initialize%20the%20class%20delegation%20chain.%20%22%0D%0A%0D%0A%7B%27%09smalltalk.init%28aClass%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Stream.$klass,"on:","on_"

,function (aCollection){var self=this;return (function($rec){$rec.collection_(aCollection);$rec.readLimit_(aCollection.size());return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("on%3A%20aCollection%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%20%0D%0A%09%09collection%3A%20aCollection%3B%0D%0A%09%09readLimit%3A%20aCollection%20size%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Stream,"collection","collection"

,function (){var self=this;return self['@collection'];return self;}

,"accessing",unescape("collection%0D%0A%09%22%20Private%20-%20Return%20the%20collection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ecollection"));

smalltalk.bind(smalltalk.Stream,"collection:","collection_"

,function (aCollection){var self=this;self['@collection']=aCollection;return self;}

,"accessing",unescape("collection%3A%20aCollection%0D%0A%09%22%20Private%20-%20Set%20the%20collection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09collection%20%3A%3D%20aCollection"));

smalltalk.bind(smalltalk.Stream,"setCollection:","setCollection_"

,function (aCollection){var self=this;self.collection_(aCollection);return self;}

,"accessing",unescape("setCollection%3A%20aCollection%0D%0A%09%22%20Private%20-%20Set%20the%20receiver%20stream%20collection%20to%20aCollection.%20%22%0D%0A%0D%0A%09self%20collection%3A%20aCollection."));

smalltalk.bind(smalltalk.Stream,"position","position"

,function (){var self=this;((((self['@position'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@position']=(0);})() : nil);

return self['@position'];return self;}

,"accessing",unescape("position%0D%0A%09%22%20Return%20the%20position%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09position%20isNil%20ifTrue%3A%20%5B%20position%20%3A%3D%200%20%5D.%0D%0A%09%5Eposition"));

smalltalk.bind(smalltalk.Stream,"position:","position_"

,function (anInteger){var self=this;self['@position']=anInteger;return self;}

,"accessing",unescape("position%3A%20anInteger%0D%0A%09%22%20Set%20the%20collection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09position%20%3A%3D%20anInteger"));

smalltalk.bind(smalltalk.Stream,"readLimit","readLimit"

,function (){var self=this;((((self['@readLimit'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@readLimit']=self.collection().size();})() : nil);

return self['@readLimit'];return self;}

,"accessing",unescape("readLimit%0D%0A%09%22%20Private%20-%20Return%20the%20read%20limit%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09readLimit%20isNil%20ifTrue%3A%20%5B%20readLimit%20%3A%3D%20self%20collection%20size%20%5D.%0D%0A%09%5EreadLimit"));

smalltalk.bind(smalltalk.Stream,"readLimit:","readLimit_"

,function (anInteger){var self=this;self['@readLimit']=anInteger;return self;}

,"accessing",unescape("readLimit%3A%20anInteger%0D%0A%09%22%20Private%20-%20Set%20the%20stream%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09readLimit%20%3A%3D%20anInteger"));

smalltalk.bind(smalltalk.Stream,"contents","contents"

,function (){var self=this;return self.collection().copyFrom_to_((1), self.readLimit());return self;}

,"accessing",unescape("contents%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20collection%20copyFrom%3A%201%20to%3A%20self%20readLimit"));

smalltalk.bind(smalltalk.Stream,"size","size"

,function (){var self=this;return self.readLimit();return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20readLimit"));

smalltalk.bind(smalltalk.Stream,"reset","reset"

,function (){var self=this;self.position_((0));return self;}

,"actions",unescape("reset%0D%0A%09%22%20Reset%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20position%3A%200"));

smalltalk.bind(smalltalk.Stream,"close","close"

,function (){var self=this;return self;}

,"actions",unescape("close%0D%0A%09%22%20Close%20the%20receiver.%20%22"));

smalltalk.bind(smalltalk.Stream,"flush","flush"

,function (){var self=this;return self;}

,"actions",unescape("flush%0D%0A%09%22%20Flush%20the%20receiver.%20%22"));

smalltalk.bind(smalltalk.Stream,"resetContents","resetContents"

,function (){var self=this;(function($rec){$rec.reset();return $rec.readLimit_((0));})(self);return self;}

,"actions",unescape("resetContents%0D%0A%09%22%20Reset%20the%20receiver%20contents.%20%22%0D%0A%0D%0A%09self%20reset%3B%20readLimit%3A%200"));

smalltalk.bind(smalltalk.Stream,"do:","do_"

,function (aBlock){var self=this;(function(){while(!(function(){return self.atEnd();})()){(function(){return aBlock.value_(self.next());})()};return nil})();return self;}

,"enumerating",unescape("do%3A%20aBlock%0D%0A%09%22%20Evaluates%20aBlock%20streaming%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5B%20self%20atEnd%20%5D%20whileFalse%3A%20%5B%20aBlock%20value%3A%20self%20next%20%5D"));

smalltalk.bind(smalltalk.Stream,"setToEnd","setToEnd"

,function (){var self=this;self.position_(self.size());return self;}

,"positioning",unescape("setToEnd%0D%0A%09%22%20Position%20the%20receiver%20at%20end.%20%22%0D%0A%0D%0A%09self%20position%3A%20self%20size"));

smalltalk.bind(smalltalk.Stream,"skip:","skip_"

,function (anInteger){var self=this;self.position_(anInteger._plus(self.position()).min_(self.size()).max_((0)));return self;}

,"positioning",unescape("skip%3A%20anInteger%0D%0A%09%22%20Skip%20next%20anInteger%20readable%20elements%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20position%3A%20%28%28anInteger%20+%20self%20position%20min%3A%20self%20size%29%20max%3A%200%29"));

smalltalk.bind(smalltalk.Stream,"next","next"

,function (){var self=this;self.position_((self.position() + (1)));

return self['@collection'].at_(self.position());return self;}

,"reading",unescape("next%0D%0A%09%22%20Return%20the%20next%20readable%20element%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20position%3A%20self%20position%20+%201.%20%0D%0A%09%5Ecollection%20at%3A%20self%20position"));

smalltalk.bind(smalltalk.Stream,"next:","next_"

,function (anInteger){var self=this;try{var result=nil;result=self.collection().$klass.$$new();

(function(){for(var $1$=anInteger;$1$>0;$1$--){(function(){((self.atEnd()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "next_", fn: function(){return result}})})();})() : nil);return result.add_(self.next());})()};return nil})();

(function(){throw({name: "stReturn", selector: "next_", fn: function(){return result}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "next_"){return $$ex.fn();} throw($$ex);}}

,"reading",unescape("next%3A%20anInteger%0D%0A%09%22%20Return%20the%20next%20anInteger%20elements%20read%20from%20the%20receiver.%0D%0A%09If%20the%20receiver%20reach%20its%20end%2C%20the%20returned%20collection%20has%20less%20elements.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20collection%20class%20new.%0D%0A%09anInteger%20timesRepeat%3A%20%5B%0D%0A%09%09self%20atEnd%20ifTrue%3A%20%5B%20%5Eresult%20%5D.%0D%0A%09%09result%20add%3A%20self%20next.%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Stream,"nextPut:","nextPut_"

,function (anObject){var self=this;self.position_((self.position() + (1)));

self.collection().at_put_(self.position(), anObject);

self.readLimit_(self.readLimit().max_(self.position()));return self;}

,"writing",unescape("nextPut%3A%20anObject%0D%0A%09%22%20Put%20anObject%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20position%3A%20self%20position%20+%201.%0D%0A%09self%20collection%20at%3A%20self%20position%20put%3A%20anObject.%0D%0A%09self%20readLimit%3A%20%28self%20readLimit%20max%3A%20self%20position%29"));

smalltalk.bind(smalltalk.Stream,"nextPutAll:","nextPutAll_"

,function (aCollection){var self=this;aCollection.do_((function(each){return self.nextPut_(each);}));return self;}

,"writing",unescape("nextPutAll%3A%20aCollection%0D%0A%09%22%20Put%20aCollection%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09aCollection%20do%3A%20%5B%3Aeach%20%7C%20self%20nextPut%3A%20each%20%5D"));

smalltalk.bind(smalltalk.Stream,"cr","cr"

,function (){var self=this;self.nextPutAll_(smalltalk.String.crlf());return self;}

,"writing",unescape("cr%0D%0A%09%22%20Put%20a%20line%20break%20sequence%20onto%20the%20receiver.%0D%0A%09Note%3A%20this%20implementation%20MUST%20be%20consistent%20with%20%23nextLine%0D%0A%09%22%0D%0A%0D%0A%09self%20nextPutAll%3A%20String%20crlf"));

smalltalk.bind(smalltalk.Stream,"space","space"

,function (){var self=this;self.nextPutAll_(smalltalk.String.space());return self;}

,"writing",unescape("space%0D%0A%09%22%20Put%20a%20space%20sequence%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20nextPutAll%3A%20String%20space"));

smalltalk.bind(smalltalk.Stream,"tab","tab"

,function (){var self=this;self.nextPutAll_(smalltalk.String.tab());return self;}

,"writing",unescape("tab%0D%0A%09%22%20Put%20a%20tab%20sequence%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20nextPutAll%3A%20String%20tab"));

smalltalk.bind(smalltalk.Stream,"peek","peek"

,function (){var self=this;return ((self.atEnd()).mustBeBoolean()==true ? nil : (function(){return self.collection().at_((self.position() + (1)));})());return self;}

,"reading",unescape("peek%0D%0A%09%22%20Return%20the%20next%20readable%20element%20from%20the%20receiver%20without%20advancing%20the%20receiver%3B%20or%20nil.%20%22%0D%0A%0D%0A%09%5Eself%20atEnd%20ifFalse%3A%20%5B%0D%0A%09%20%20%20%20self%20collection%20at%3A%20self%20position%20+%201%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Stream,"atEnd","atEnd"

,function (){var self=this;return self.position()._gt_eq(self.size());return self;}

,"testing",unescape("atEnd%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20at%20end.%20%22%0D%0A%0D%0A%09%5Eself%20position%20%3E%3D%20self%20size"));

smalltalk.bind(smalltalk.Stream,"atStart","atStart"

,function (){var self=this;return self.position()._eq((0));return self;}

,"testing",unescape("atStart%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20at%20start%20position.%20%22%0D%0A%0D%0A%09%5Eself%20position%20%3D%200"));

smalltalk.bind(smalltalk.Stream,"isEmpty","isEmpty"

,function (){var self=this;return self.size()._eq((0));return self;}

,"testing",unescape("isEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%09%5Eself%20size%20%3D%200"));

smalltalk.bind(smalltalk.Stream,"upTo:","upTo_"

,function (anObject){var self=this;var result=nil;result=self.collection().$klass.$$new();

(function(){while(!(function(){return self.atEnd().or_((function(){return self.peek()._eq(anObject);}));})()){(function(){return result.add_(self.next());})()};return nil})();

((self.atEnd()).mustBeBoolean()==true ? nil : (function(){return self.next();})());

return result;return self;}

,"reading",unescape("upTo%3A%20anObject%0D%0A%09%22%20Return%20the%20elements%20read%20from%20the%20receiver%20upto%20anObject%20%28or%20end%29.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20collection%20class%20new.%0D%0A%09%5B%20self%20atEnd%20or%3A%20%5B%20self%20peek%20%3D%20anObject%20%5D%5D%20whileFalse%3A%20%5B%0D%0A%09%20%20%20%20result%20add%3A%20self%20next%0D%0A%09%5D.%0D%0A%09self%20atEnd%20ifFalse%3A%20%5B%20self%20next%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Stream,"upToEnd","upToEnd"

,function (){var self=this;var result=nil;result=self.collection().copyFrom_to_((self.position() + (1)), self.readLimit());

self.setToEnd();

return result;return self;}

,"reading",unescape("upToEnd%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver%20upto%20end.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20collection%20copyFrom%3A%20self%20position%20+%201%20to%3A%20self%20readLimit.%0D%0A%09self%20setToEnd.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Stream,"nextLine","nextLine"

,function (){var self=this;try{var result=nil;var start=nil;start=self.position();

result=self.upTo_(smalltalk.String.cr());

((result.includes_(smalltalk.String.lf())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "nextLine", fn: function(){return (function($rec){$rec.position_(start);return $rec.upTo_(smalltalk.String.lf());})(self)}})})();})() : nil);

((self.peek()._eq(smalltalk.String.lf())).mustBeBoolean()==true ? (function(){return self.next();})() : nil);

(function(){throw({name: "stReturn", selector: "nextLine", fn: function(){return result}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "nextLine"){return $$ex.fn();} throw($$ex);}}

,"reading",unescape("nextLine%0D%0A%09%22%20Return%20the%20characters%20read%20from%20the%20receiver%20up%20to%20the%20line%20delimiter.%20%22%0D%0A%0D%0A%09%7C%20result%20start%20%7C%0D%0A%09start%20%3A%3D%20self%20position.%0D%0A%09result%20%3A%3D%20self%20upTo%3A%20String%20cr.%0D%0A%09%28result%20includes%3A%20String%20lf%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20position%3A%20start%3B%20upTo%3A%20String%20lf%0D%0A%09%5D.%0D%0A%09%28self%20peek%20%3D%20String%20lf%29%20ifTrue%3A%20%5B%20self%20next%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Stream,"skipTo:","skipTo_"

,function (anObject){var self=this;try{(function(){while(!(function(){return self.atEnd();})()){(function(){return ((self.next()._eq(anObject)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "skipTo_", fn: function(){return true}})})();})() : nil);})()};return nil})();

(function(){throw({name: "stReturn", selector: "skipTo_", fn: function(){return false}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "skipTo_"){return $$ex.fn();} throw($$ex);}}

,"reading",unescape("skipTo%3A%20anObject%0D%0A%09%22%20Advance%20the%20receiver%20upto%20anObject%20%28or%20end%29.%20%22%0D%0A%0D%0A%09%5B%20self%20atEnd%20%5D%20whileFalse%3A%20%5B%0D%0A%09%09self%20next%20%3D%20anObject%20ifTrue%3A%20%5B%20%5Etrue%20%5D.%0D%0A%09%5D.%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Stream,"skipSeparators","skipSeparators"

,function (){var self=this;try{(function(){while((function(){((self.atEnd()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "skipSeparators", fn: function(){return false}})})();})() : nil);return self.peek().isSeparator();})()){(function(){return self.next();})()};return nil})();

(function(){throw({name: "stReturn", selector: "skipSeparators", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "skipSeparators"){return $$ex.fn();} throw($$ex);}}

,"reading",unescape("skipSeparators%0D%0A%09%22%20Advance%20the%20receiver%20upto%20a%20non-separator%20%28or%20end%29.%0D%0A%09Return%20true%20%20if%20a%20non-separator%20contents%20is%20found%2C%0D%0A%09return%20false%20if%20run%20upto%20end%20of%20stream.%0D%0A%09%22%0D%0A%0D%0A%09%5B%20self%20atEnd%20ifTrue%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%20%20self%20peek%20isSeparator%0D%0A%09%5D%20whileTrue%3A%20%5B%20self%20next%20%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Stream,"nextChunk","nextChunk"

,function (){var self=this;var result=nil;result=self.upTo_(unescape("%21"));

(function(){while((function(){return self.peek()._eq(unescape("%21"));})()){(function(){self.next();return result=result._comma(unescape("%21"))._comma(self.upTo_(unescape("%21")));})()};return nil})();

return result.trimFirst_((function(c){return (c.asciiValue() <= (32));}));return self;}

,"Compiler-fileIn",unescape("nextChunk%0D%0A%09%22%20FileIn%20-%20Return%20the%20next%20chunk%20read%20from%20the%20receiver.%0D%0A%09Trailing%20non-printing%20characters%20are%20skipped.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20upTo%3A%20%24%21.%0D%0A%09%5B%20self%20peek%20%3D%20%24%21%20%5D%20whileTrue%3A%20%5B%0D%0A%09%09self%20next.%0D%0A%09%09result%20%3A%3D%20result%2C%20%27%21%27%2C%20%28self%20upTo%3A%20%24%21%29%0D%0A%09%5D.%0D%0A%09%5Eresult%20trimFirst%3A%20%5B%3Ac%7C%20c%20asciiValue%20%3C%3D%2032%20%5D"));

smalltalk.bind(smalltalk.Stream,"fileIn","fileIn"

,function (){var self=this;var scanner=nil;(function(){while(!(function(){return self.atEnd();})()){(function(){return scanner=scanner.scanFrom_(self);})()};return nil})();

return scanner;return self;}

,"Compiler-fileIn",unescape("fileIn%0D%0A%09%22%20FileIn%20-%20FileIn%20the%20receiver%27s%20contents%20%28in%20chunk%20format%29.%20%22%0D%0A%0D%0A%09%7C%20scanner%20%7C%0D%0A%09%5Bself%20atEnd%5D%20whileFalse%3A%20%5B%20scanner%20%3A%3D%20scanner%20scanFrom%3A%20self%20%5D.%0D%0A%09%5Escanner"));

smalltalk.bind(smalltalk.Stream,"nextChunkPut:","nextChunkPut_"

,function (aString){var self=this;var oec=nil;var parts=nil;eoc=unescape("%21");

((((aString || nil) !== nil)).mustBeBoolean()==true ? (function(){return aString.asArrayOfSubstringsSeparatedBy_(eoc).do_separatedBy_((function(each){return self.nextPutAll_(each);}), (function(){return self.nextPutAll_(eoc._comma(eoc));}));})() : nil);

self.nextPut_(eoc);

return aString;return self;}

,"Compiler-fileOut",unescape("nextChunkPut%3A%20aString%0D%0A%09%22%20Output%20aString%20in%20chunk%20format.%20%22%0D%0A%0D%0A%09%7C%20oec%20parts%20%7C%0D%0A%09eoc%20%3A%3D%20%24%21.%0D%0A%09aString%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%28aString%20asArrayOfSubstringsSeparatedBy%3A%20eoc%29%0D%0A%09%09%09do%3A%20%5B%3Aeach%7C%20self%20nextPutAll%3A%20each%20%5D%0D%0A%09%09%09separatedBy%3A%20%5B%20self%20nextPutAll%3A%20eoc%2Ceoc%20%5D.%0D%0A%09%5D.%0D%0A%09self%20nextPut%3A%20eoc.%0D%0A%09%5EaString"));

smalltalk.bind(smalltalk.Random,"next","next"

,function (){var self=this;	return Math.random();return self;}

,"accessing",unescape("next%0D%0A%09%22%20Return%20the%20next%20random%20number.%20%22%0D%0A%0D%0A%7B%27%09return%20Math.random%28%29%27%7D"));

smalltalk.bind(smalltalk.Random,"next:","next_"

,function (anInteger){var self=this;return (1).to_(anInteger).collect_((function(each){return self.next();}));return self;}

,"accessing",unescape("next%3A%20anInteger%0D%0A%09%22%20Return%20the%20next%20anInteger%20random%20numbers.%20%22%0D%0A%0D%0A%09%5E%281%20to%3A%20anInteger%29%20collect%3A%20%5B%3Aeach%20%7C%20self%20next%20%5D"));

smalltalk.bind(smalltalk.Point.$klass,"x:y:","x_y_"

,function (x,y){var self=this;return (function($rec){$rec.x_(x);return $rec.y_(y);})(self.basicNew());return self;}

,unescape("instance%20creation"),unescape("x%3A%20x%20y%3A%20y%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicNew%20x%3A%20x%3B%20y%3A%20y"));

smalltalk.bind(smalltalk.Point,"x","x"

,function (){var self=this;return self['@x'];return self;}

,"accessing",unescape("x%0D%0A%09%22%20Return%20the%20x%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ex"));

smalltalk.bind(smalltalk.Point,"y","y"

,function (){var self=this;return self['@y'];return self;}

,"accessing",unescape("y%0D%0A%09%22%20Return%20the%20y%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ey"));

smalltalk.bind(smalltalk.Point,"y:","y_"

,function (aNumber){var self=this;self['@y']=((((aNumber || nil) === nil)).mustBeBoolean()==true ? (function(){return (0);})() : (function(){return aNumber;})());return self;}

,"accessing",unescape("y%3A%20aNumber%0D%0A%09%22%20Set%20the%20y%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09y%20%3A%3D%20aNumber%20isNil%20ifTrue%3A%20%5B%200%20%5D%20ifFalse%3A%20%5B%20aNumber%20%5D"));

smalltalk.bind(smalltalk.Point,"x:","x_"

,function (aNumber){var self=this;self['@x']=((((aNumber || nil) === nil)).mustBeBoolean()==true ? (function(){return (0);})() : (function(){return aNumber;})());return self;}

,"accessing",unescape("x%3A%20aNumber%0D%0A%09%22%20Set%20the%20x%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09x%20%3A%3D%20aNumber%20isNil%20ifTrue%3A%20%5B%200%20%5D%20ifFalse%3A%20%5B%20aNumber%20%5D"));

smalltalk.bind(smalltalk.Point,"*","_star"

,function (aPoint){var self=this;try{((aPoint.isNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_star", fn: function(){return self['@x']._star(aPoint)._at(self['@y']._star(aPoint))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_star", fn: function(){return smalltalk.Point.x_y_(self['@x']._star(aPoint.asPoint().x()), self['@y']._star(aPoint.asPoint().y()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_star"){return $$ex.fn();} throw($$ex);}}

,"arithmetic",unescape("*%20aPoint%0D%0A%09%22%20Return%20the%20result%20of%20operation%20with%20aPoint.%20%22%0D%0A%0D%0A%09aPoint%20isNumber%20ifTrue%3A%20%5B%20%5Ex%20*%20aPoint%20@%20%28y%20*%20aPoint%29%20%5D.%0D%0A%09%5EPoint%09x%3A%20x%20*%20aPoint%20asPoint%20x%0D%0A%09%09y%3A%20y%20*%20aPoint%20asPoint%20y"));

smalltalk.bind(smalltalk.Point,"+","_plus"

,function (aPoint){var self=this;try{((aPoint.isNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_plus", fn: function(){return self['@x']._plus(aPoint)._at(self['@y']._plus(aPoint))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_plus", fn: function(){return smalltalk.Point.x_y_(self['@x']._plus(aPoint.asPoint().x()), self['@y']._plus(aPoint.asPoint().y()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_plus"){return $$ex.fn();} throw($$ex);}}

,"arithmetic",unescape("+%20aPoint%0D%0A%09%22%20Return%20the%20result%20of%20operation%20with%20aPoint.%20%22%0D%0A%0D%0A%09aPoint%20isNumber%20ifTrue%3A%20%5B%20%5Ex%20+%20aPoint%20@%20%28y%20+%20aPoint%29%20%5D.%0D%0A%09%5EPoint%09x%3A%20x%20+%20aPoint%20asPoint%20x%0D%0A%09%09y%3A%20y%20+%20aPoint%20asPoint%20y"));

smalltalk.bind(smalltalk.Point,"-","_minus"

,function (aPoint){var self=this;try{((aPoint.isNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_minus", fn: function(){return self['@x']._minus(aPoint)._at(self['@y']._minus(aPoint))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_minus", fn: function(){return smalltalk.Point.x_y_(self['@x']._minus(aPoint.asPoint().x()), self['@y']._minus(aPoint.asPoint().y()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_minus"){return $$ex.fn();} throw($$ex);}}

,"arithmetic",unescape("-%20aPoint%0D%0A%09%22%20Return%20the%20result%20of%20operation%20with%20aPoint.%20%22%0D%0A%0D%0A%09aPoint%20isNumber%20ifTrue%3A%20%5B%20%5Ex%20-%20aPoint%20@%20%28y%20-%20aPoint%29%20%5D.%0D%0A%09%5EPoint%09x%3A%20x%20-%20aPoint%20asPoint%20x%0D%0A%09%09y%3A%20y%20-%20aPoint%20asPoint%20y"));

smalltalk.bind(smalltalk.Point,"/","_slash"

,function (aPoint){var self=this;try{((aPoint.isNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_slash", fn: function(){return self['@x']._slash(aPoint)._at(self['@y']._slash(aPoint))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_slash", fn: function(){return smalltalk.Point.x_y_(self['@x']._slash(aPoint.asPoint().x()), self['@y']._slash(aPoint.asPoint().y()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_slash"){return $$ex.fn();} throw($$ex);}}

,"arithmetic",unescape("/%20aPoint%0D%0A%09%22%20Return%20the%20result%20of%20operation%20with%20aPoint.%20%22%0D%0A%0D%0A%09aPoint%20isNumber%20ifTrue%3A%20%5B%20%5Ex%20/%20aPoint%20@%20%28y%20/%20aPoint%29%20%5D.%0D%0A%09%5EPoint%09x%3A%20x%20/%20aPoint%20asPoint%20x%0D%0A%09%09y%3A%20y%20/%20aPoint%20asPoint%20y"));

smalltalk.bind(smalltalk.Point,"//","_slash_slash"

,function (aPoint){var self=this;try{((aPoint.isNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_slash_slash", fn: function(){return self['@x']._slash_slash(aPoint)._at(self['@y']._slash_slash(aPoint))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_slash_slash", fn: function(){return smalltalk.Point.x_y_(self['@x']._slash_slash(aPoint.asPoint().x()), self['@y']._slash_slash(aPoint.asPoint().y()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_slash_slash"){return $$ex.fn();} throw($$ex);}}

,"arithmetic",unescape("//%20aPoint%0D%0A%09%22%20Return%20the%20result%20of%20operation%20with%20aPoint.%20%22%0D%0A%0D%0A%09aPoint%20isNumber%20ifTrue%3A%20%5B%20%5Ex%20//%20aPoint%20@%20%28y%20//%20aPoint%29%20%5D.%0D%0A%09%5EPoint%09x%3A%20x%20//%20aPoint%20asPoint%20x%0D%0A%09%09y%3A%20y%20//%20aPoint%20asPoint%20y"));

smalltalk.bind(smalltalk.Point,unescape("%5C%5C"),"_bk_bk"

,function (aPoint){var self=this;try{((aPoint.isNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_bk_bk_bk_bk", fn: function(){return self['@x']._bk_bk(aPoint)._at(self['@y']._bk_bk(aPoint))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_bk_bk_bk_bk", fn: function(){return smalltalk.Point.x_y_(self['@x']._bk_bk(aPoint.asPoint().x()), self['@y']._bk_bk(aPoint.asPoint().y()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_bk_bk_bk_bk"){return $$ex.fn();} throw($$ex);}}

,"arithmetic",unescape("%5C%5C%5C%5C%20aPoint%0D%0A%09%22%20Return%20the%20result%20of%20operation%20with%20aPoint.%20%22%0D%0A%0D%0A%09aPoint%20isNumber%20ifTrue%3A%20%5B%20%5Ex%20%5C%5C%20aPoint%20@%20%28y%20%5C%5C%20aPoint%29%20%5D.%0D%0A%09%5EPoint%09x%3A%20x%20%5C%5C%20aPoint%20asPoint%20x%0D%0A%09%09y%3A%20y%20%5C%5C%20aPoint%20asPoint%20y"));

smalltalk.bind(smalltalk.Point,"rounded","rounded"

,function (){var self=this;return self['@x'].rounded()._at(self['@y'].rounded());return self;}

,"converting",unescape("rounded%0D%0A%09%22%20Return%20the%20receiver%20rounded.%20%22%0D%0A%0D%0A%09%5Ex%20rounded%20@%20y%20rounded"));

smalltalk.bind(smalltalk.Point,"truncated","truncated"

,function (){var self=this;return self['@x'].truncated()._at(self['@y'].truncated());return self;}

,"converting",unescape("truncated%0D%0A%09%22%20Return%20the%20receiver%20truncated.%20%22%0D%0A%0D%0A%09%5Ex%20truncated%20@%20y%20truncated"));

smalltalk.bind(smalltalk.Point,"asPoint","asPoint"

,function (){var self=this;return self;return self;}

,"converting",unescape("asPoint%0D%0A%09%22%20Return%20the%20receiver%20as%20a%20Point.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Point,"printString","printString"

,function (){var self=this;return self['@x'].asString()._comma(unescape("%20@%20"))._comma(self['@y'].asString());return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20the%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ex%20asString%20%2C%27%20@%20%27%20%2Cy%20asString"));

smalltalk.bind(smalltalk.Point,"toString","toString"

,function (){var self=this;return self['@x'].toString()._comma(unescape("@"))._comma(self['@y'].toString());return self;}

,"printing",unescape("toString%0D%0A%09%22%20Return%20the%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ex%20toString%20%2C%27@%27%20%2Cy%20toString"));

smalltalk.bind(smalltalk.Point,"shallowCopy","shallowCopy"

,function (){var self=this;return self.$klass.x_y_(self.x(), self.y());return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20x%3A%20self%20x%20y%3A%20self%20y"));

smalltalk.bind(smalltalk.Point,"=","_eq"

,function (aPoint){var self=this;try{((aPoint.isMemberOf_(self.$klass)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return aPoint.asPoint()._eq(self)}})})();})());

(function(){throw({name: "stReturn", selector: "_eq", fn: function(){return self['@x']._eq(aPoint.x()).and_((function(){return self['@y']._eq(aPoint.y());}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_eq"){return $$ex.fn();} throw($$ex);}}

,"query",unescape("%3D%20aPoint%0D%0A%09%22%20Return%20the%20result%20of%20operation%20with%20aPoint.%20%22%0D%0A%0D%0A%09%28aPoint%20isMemberOf%3A%20self%20class%29%20ifFalse%3A%20%5B%0D%0A%09%09%5EaPoint%20asPoint%20%3D%20self%0D%0A%09%5D.%0D%0A%09%5Ex%20%3D%20aPoint%20x%20and%3A%20%5B%20y%20%3D%20aPoint%20y%20%5D"));

smalltalk.bind(smalltalk.Point,"min:","min_"

,function (aPoint){var self=this;return self['@x'].min_(aPoint.x())._at(self['@y'].min_(aPoint.y()));return self;}

,"magnitudes",unescape("min%3A%20aPoint%0D%0A%09%22%20Return%20the%20minimum%20of%20the%20receiver%20and%20aPoint.%20%22%0D%0A%0D%0A%09%5E%28x%20min%3A%20aPoint%20x%29%20@%20%28y%20min%3A%20aPoint%20y%29"));

smalltalk.bind(smalltalk.Point,"max:","max_"

,function (aPoint){var self=this;return self['@x'].max_(aPoint.x())._at(self['@y'].max_(aPoint.y()));return self;}

,"magnitudes",unescape("max%3A%20aPoint%0D%0A%09%22%20Return%20the%20maximum%20of%20the%20receiver%20and%20aPoint.%20%22%0D%0A%0D%0A%09%5E%28x%20max%3A%20aPoint%20x%29%20@%20%28y%20max%3A%20aPoint%20y%29"));

smalltalk.bind(smalltalk.Point,"extent:","extent_"

,function (extent){var self=this;return smalltalk.Rectangle.leftTop_rightBottom_(self, self._plus(extent));return self;}

,"converting",unescape("extent%3A%20extent%0D%0A%09%22%20Return%20a%20Rectangle%20from%20the%20receiver%20with%20specified%20extent.%20%22%0D%0A%0D%0A%09%5ERectangle%20leftTop%3A%20self%20rightBottom%3A%20self%20+%20extent"));

smalltalk.bind(smalltalk.Point,"rightBottom:","rightBottom_"

,function (rightBottom){var self=this;return smalltalk.Rectangle.leftTop_rightBottom_(self, rightBottom);return self;}

,"converting",unescape("rightBottom%3A%20rightBottom%0D%0A%09%22%20Return%20a%20Rectangle%20from%20the%20receiver%20to%20rightBottom.%20%22%0D%0A%0D%0A%09%5ERectangle%20leftTop%3A%20self%20rightBottom%3A%20rightBottom"));

smalltalk.bind(smalltalk.Rectangle.$klass,"leftTop:extent:","leftTop_extent_"

,function (leftTop,extent){var self=this;return self.$$new().leftTop_rightBottom_(leftTop, leftTop._plus(extent));return self;}

,unescape("instance%20creation"),unescape("leftTop%3A%20leftTop%20extent%3A%20extent%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%20leftTop%3A%20leftTop%20rightBottom%3A%20leftTop%20+%20extent"));

smalltalk.bind(smalltalk.Rectangle.$klass,"leftTop:rightBottom:","leftTop_rightBottom_"

,function (leftTop,rightBottom){var self=this;return self.$$new().leftTop_rightBottom_(leftTop, rightBottom);return self;}

,unescape("instance%20creation"),unescape("leftTop%3A%20leftTop%20rightBottom%3A%20rightBottom%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%20leftTop%3A%20leftTop%20rightBottom%3A%20rightBottom"));

smalltalk.bind(smalltalk.Rectangle,"=","_eq"

,function (aRectangle){var self=this;return aRectangle.isRectangle().and_((function(){return self['@leftTop']._eq(aRectangle.leftTop()).and_((function(){return self['@rightBottom']._eq(aRectangle.rightBottom());}));}));return self;}

,"testing",unescape("%3D%20aRectangle%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20equal%20to%20the%20aRectangle.%20%22%0D%0A%0D%0A%09%5EaRectangle%20isRectangle%0D%0A%09and%3A%20%5B%20leftTop%20%3D%20aRectangle%20leftTop%0D%0A%09and%3A%20%5B%20rightBottom%20%3D%20aRectangle%20rightBottom%20%5D%5D"));

smalltalk.bind(smalltalk.Rectangle,"area","area"

,function (){var self=this;return self.height()._star(self.width());return self;}

,"accessing",unescape("area%0D%0A%09%22%20Return%20the%20area%20of%20the%20receiver.%22%0D%0A%0D%0A%09%5Eself%20height%20*%20self%20width"));

smalltalk.bind(smalltalk.Rectangle,"areasOutside:","areasOutside_"

,function (aRectangle){var self=this;try{((self.intersects_(aRectangle)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "areasOutside_", fn: function(){return smalltalk.Array.with_(self)}})})();})());

((aRectangle.containsPoint_(self.topLeft()).and_((function(){return aRectangle.containsPoint_(self.bottomRight());}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "areasOutside_", fn: function(){return []}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "areasOutside_", fn: function(){return smalltalk.Array.with_with_with_with_(((aRectangle.top()._gt(self.top())).mustBeBoolean()==true ? (function(){return self.topLeft().rightBottom_(self.right()._at(aRectangle.top()));})() : nil), ((aRectangle.bottom()._lt(self.bottom())).mustBeBoolean()==true ? (function(){return self.left()._at(aRectangle.bottom()).rightBottom_(self.bottomRight());})() : nil), ((aRectangle.left()._gt(self.left())).mustBeBoolean()==true ? (function(){return self.left()._at(self.top().max_(aRectangle.top())).rightBottom_(aRectangle.left()._at(self.bottom().min_(aRectangle.bottom())));})() : nil), ((aRectangle.right()._lt(self.right())).mustBeBoolean()==true ? (function(){return aRectangle.right()._at(self.top().max_(aRectangle.top())).rightBottom_(self.right()._at(self.bottom().min_(aRectangle.bottom())));})() : nil)).select_((function(each){return ((each || nil) !== nil);}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "areasOutside_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("areasOutside%3A%20aRectangle%0D%0A%09%22Return%20a%20collection%20of%20rectangles%20where%20the%20receiver%20do%20not%20intersect%20aRectangle.%20%22%0D%0A%0D%0A%09%28self%20intersects%3A%20aRectangle%29%20ifFalse%3A%20%5B%20%5EArray%20with%3A%20self%20%5D.%0D%0A%09%28%28aRectangle%20containsPoint%3A%20self%20topLeft%29%0D%0A%09and%3A%20%5BaRectangle%20containsPoint%3A%20self%20bottomRight%5D%29%0D%0A%20%20%20%20%20%20%20%20ifTrue%3A%20%5B%20%5E%23%28%29%20%5D.%0D%0A%09%5E%28Array%0D%0A%09with%3A%20%28aRectangle%20top%20%3E%20self%20top%20ifTrue%3A%20%5B%20self%20topLeft%20rightBottom%3A%20self%20right%20@%20aRectangle%20top%5D%29%0D%0A%09with%3A%20%28aRectangle%20bottom%20%3C%20self%20bottom%20ifTrue%3A%20%5B%20self%20left%20@%20aRectangle%20bottom%20rightBottom%3A%20self%20bottomRight%5D%29%0D%0A%09with%3A%20%28aRectangle%20left%20%3E%20self%20left%20ifTrue%3A%20%5B%20self%20left%20@%20%28self%20top%20max%3A%20aRectangle%20top%29%20rightBottom%3A%20aRectangle%20left%20@%20%28self%20bottom%20min%3A%20aRectangle%20bottom%29%20%5D%29%0D%0A%09with%3A%20%28aRectangle%20right%20%3C%20self%20right%20ifTrue%3A%20%5B%20aRectangle%20right%20@%20%28self%20top%20max%3A%20aRectangle%20top%29%20rightBottom%3A%20self%20right%20@%20%28self%20bottom%20min%3A%20aRectangle%20bottom%29%20%5D%29%0D%0A%09%29%20select%3A%20%5B%3Aeach%7C%20each%20notNil%20%5D"));

smalltalk.bind(smalltalk.Rectangle,"bottom","bottom"

,function (){var self=this;return self['@rightBottom'].y();return self;}

,"accessing",unescape("bottom%0D%0A%09%22%20Return%20the%20bottom%20of%20the%20receiver.%22%0D%0A%0D%0A%09%5ErightBottom%20y"));

smalltalk.bind(smalltalk.Rectangle,"bottomCenter","bottomCenter"

,function (){var self=this;return self.center().x()._at(self.bottom());return self;}

,"accessing",unescape("bottomCenter%0D%0A%09%22%20Return%20the%20center%20of%20the%20bottom%20edge%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20center%20x%20@%20self%20bottom"));

smalltalk.bind(smalltalk.Rectangle,"bottomLeft","bottomLeft"

,function (){var self=this;return self.left()._at(self.bottom());return self;}

,"accessing",unescape("bottomLeft%0D%0A%09%22%20Return%20the%20bottom-left%20corner%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20left%20@%20self%20bottom"));

smalltalk.bind(smalltalk.Rectangle,"bottomRight","bottomRight"

,function (){var self=this;return self['@rightBottom'];return self;}

,"accessing",unescape("bottomRight%0D%0A%09%22%20Return%20the%20bottom-right%20corner%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ErightBottom"));

smalltalk.bind(smalltalk.Rectangle,"center","center"

,function (){var self=this;return self['@leftTop']._plus(self['@rightBottom'])._slash_slash((2));return self;}

,"accessing",unescape("center%0D%0A%09%22%20Return%20the%20center%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EleftTop%20+%20rightBottom%20//%202"));

smalltalk.bind(smalltalk.Rectangle,"centerTop","centerTop"

,function (){var self=this;return self.right()._plus(self.left())._slash_slash((2))._at(self.top());return self;}

,"accessing",unescape("centerTop%0D%0A%09%22%20Return%20the%20center%20top%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20right%20+%20self%20left%20//%202%20@%20self%20top"));

smalltalk.bind(smalltalk.Rectangle,"contains:","contains_"

,function (aRectangle){var self=this;return self.left()._lt_eq(aRectangle.left()).and_((function(){return aRectangle.right()._lt_eq(self.right()).and_((function(){return self.bottom()._gt_eq(aRectangle.bottom()).and_((function(){return aRectangle.top()._gt_eq(self.top());}));}));}));return self;}

,"testing",unescape("contains%3A%20aRectangle%0D%0A%09%22%20Return%20true%20if%20aRectangle%20lies%20completely%20within%20or%20on%20the%20edge%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20left%20%3C%3D%20aRectangle%20left%0D%0A%09and%3A%20%5B%20aRectangle%20right%20%3C%3D%20self%20right%0D%0A%09and%3A%20%5B%20self%20bottom%20%3E%3D%20aRectangle%20bottom%0D%0A%09and%3A%20%5B%20aRectangle%20top%20%3E%3D%20self%20top%20%5D%5D%5D"));

smalltalk.bind(smalltalk.Rectangle,"containsPoint:","containsPoint_"

,function (aPoint){var self=this;return self.left()._lt_eq(aPoint.x()).and_((function(){return aPoint.x()._lt(self.right()).and_((function(){return self.bottom()._gt(aPoint.y()).and_((function(){return aPoint.y()._gt_eq(self.top());}));}));}));return self;}

,"testing",unescape("containsPoint%3A%20aPoint%0D%0A%09%22%20Return%20true%20if%20aPoint%20is%20contained%20within%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28self%20left%20%3C%3D%20aPoint%20x%29%0D%0A%09and%3A%20%5B%20aPoint%20x%20%3C%20self%20right%0D%0A%09and%3A%20%5B%20self%20bottom%20%3E%20aPoint%20y%0D%0A%09and%3A%20%5B%20aPoint%20y%20%3E%3D%20self%20top%20%5D%5D%5D"));

smalltalk.bind(smalltalk.Rectangle,"expandBy:","expandBy_"

,function (delta){var self=this;try{((delta.isRectangle()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "expandBy_", fn: function(){return self['@leftTop']._minus(delta.leftTop()).rightBottom_(self['@rightBottom']._plus(delta.rightBottom()))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "expandBy_", fn: function(){return self['@leftTop']._minus(delta).rightBottom_(self['@rightBottom']._plus(delta))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "expandBy_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("expandBy%3A%20delta%0D%0A%09%22%20Return%20a%20Rectangle%20obtained%20from%20the%20receiver%20expanded%20by%20delta.%20%22%0D%0A%0D%0A%09delta%20isRectangle%20ifTrue%3A%20%5B%0D%0A%20%20%20%20%20%20%20%20%20%20%20%20%5EleftTop%20-%20delta%20leftTop%20rightBottom%3A%20rightBottom%20+%20delta%20rightBottom%0D%0A%09%5D.%0D%0A%09%5EleftTop%20-%20delta%20rightBottom%3A%20rightBottom%20+%20delta"));

smalltalk.bind(smalltalk.Rectangle,"extent","extent"

,function (){var self=this;return self.width()._at(self.height());return self;}

,"accessing",unescape("extent%0D%0A%09%22%20Return%20receiver%27s%20width%20and%20height.%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.Rectangle,"extent:","extent_"

,function (aPoint){var self=this;self.width_(aPoint.x());

self.height_(aPoint.y());return self;}

,"accessing",unescape("extent%3A%20aPoint%0D%0A%09%22%20Set%20the%20extent%20of%20receiver%20to%20aPoint.%20%22%0D%0A%0D%0A%09self%20width%3A%20aPoint%20x.%0D%0A%09self%20height%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.Rectangle,"height","height"

,function (){var self=this;return self['@leftTop'].y()._minus(self['@rightBottom'].y()).abs();return self;}

,"accessing",unescape("height%0D%0A%09%22%20Return%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28leftTop%20y%20-%20rightBottom%20y%29%20abs"));

smalltalk.bind(smalltalk.Rectangle,"height:","height_"

,function (aNumber){var self=this;self['@rightBottom'].y_(self['@leftTop'].y()._plus(aNumber));return self;}

,"accessing",unescape("height%3A%20aNumber%0D%0A%09%22%20Change%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09rightBottom%20y%3A%20leftTop%20y%20+%20aNumber"));

smalltalk.bind(smalltalk.Rectangle,"insetBy:","insetBy_"

,function (delta){var self=this;try{((delta.isRectangle()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "insetBy_", fn: function(){return self['@leftTop']._plus(delta.leftTop()).rightBottom_(self['@rightBottom']._minus(delta.rightBottom()))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "insetBy_", fn: function(){return self['@leftTop']._plus(delta).rightBottom_(self['@rightBottom']._minus(delta))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "insetBy_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("insetBy%3A%20delta%0D%0A%09%22%20Return%20the%20receiver%20inset%20by%20delta.%20%22%0D%0A%0D%0A%09delta%20isRectangle%20ifTrue%3A%20%5B%0D%0A%20%20%20%20%20%20%20%20%20%20%20%20%5EleftTop%20+%20delta%20leftTop%20rightBottom%3A%20rightBottom%20-%20delta%20rightBottom%0D%0A%09%5D.%0D%0A%09%5EleftTop%20+%20delta%20rightBottom%3A%20rightBottom%20-%20delta"));

smalltalk.bind(smalltalk.Rectangle,"intersect:","intersect_"

,function (aRectangle){var self=this;try{((((aRectangle || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "intersect_", fn: function(){return self}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "intersect_", fn: function(){return self['@leftTop'].max_(aRectangle.leftTop()).rightBottom_(self['@rightBottom'].min_(aRectangle.rightBottom()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "intersect_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("intersect%3A%20aRectangle%0D%0A%09%22%20Return%20the%20rectangle%20in%20which%20the%20receiver%20and%20aRectangle%20overlap.%20%22%0D%0A%0D%0A%09aRectangle%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09%5E%28leftTop%20max%3A%20aRectangle%20leftTop%29%0D%0A%20%20%20%20%20%20%20%20rightBottom%3A%20%28rightBottom%20min%3A%20aRectangle%20rightBottom%29"));

smalltalk.bind(smalltalk.Rectangle,"intersects:","intersects_"

,function (aRectangle){var self=this;return self['@leftTop']._lt(aRectangle.rightBottom()).and_((function(){return aRectangle.leftTop()._lt(self['@rightBottom']);}));return self;}

,"accessing",unescape("intersects%3A%20aRectangle%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20and%20aRectangle%20have%20any%20area%20in%20common.%20%22%0D%0A%0D%0A%09%5EleftTop%20%3C%20aRectangle%20rightBottom%0D%0A%09and%3A%20%5B%20aRectangle%20leftTop%20%3C%20rightBottom%20%5D"));

smalltalk.bind(smalltalk.Rectangle,"isRectangle","isRectangle"

,function (){var self=this;return true;return self;}

,"testing",unescape("isRectangle%0D%0A%09%22%20Return%20true%20if%20receiver%20is%20a%20Rectangle.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Rectangle,"left","left"

,function (){var self=this;return self['@leftTop'].x();return self;}

,"accessing",unescape("left%0D%0A%09%22%20Return%20the%20left%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EleftTop%20x"));

smalltalk.bind(smalltalk.Rectangle,"leftBottom","leftBottom"

,function (){var self=this;return self.left()._at(self.bottom());return self;}

,"accessing",unescape("leftBottom%0D%0A%09%22%20Return%20the%20left%20bottom%20corner%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20left%20@%20self%20bottom"));

smalltalk.bind(smalltalk.Rectangle,"leftCenter","leftCenter"

,function (){var self=this;return self.left()._at(self.center().y());return self;}

,"accessing",unescape("leftCenter%0D%0A%09%22%20Return%20the%20center%20of%20the%20left%20edge%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20left%20@%20self%20center%20y"));

smalltalk.bind(smalltalk.Rectangle,"leftTop","leftTop"

,function (){var self=this;return self['@leftTop'];return self;}

,"accessing",unescape("leftTop%0D%0A%09%22%20Return%20the%20left%20top%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EleftTop"));

smalltalk.bind(smalltalk.Rectangle,"leftTop:","leftTop_"

,function (aPoint){var self=this;self['@leftTop']=aPoint;return self;}

,"accessing",unescape("leftTop%3A%20aPoint%0D%0A%09%22%20Set%20the%20leftTop%20of%20the%20receiver.%22%0D%0A%0D%0A%09leftTop%20%3A%3D%20aPoint"));

smalltalk.bind(smalltalk.Rectangle,"leftTop:rightBottom:","leftTop_rightBottom_"

,function (leftTopPoint,rightBottomPoint){var self=this;self['@leftTop']=leftTopPoint;

self['@rightBottom']=rightBottomPoint;return self;}

,"accessing",unescape("leftTop%3A%20leftTopPoint%20rightBottom%3A%20rightBottomPoint%0D%0A%09%22Set%20the%20receiver%27s%20coordinates.%20%22%0D%0A%0D%0A%09leftTop%20%3A%3D%20leftTopPoint.%0D%0A%09rightBottom%20%3A%3D%20rightBottomPoint."));

smalltalk.bind(smalltalk.Rectangle,"merge:","merge_"

,function (aRectangle){var self=this;try{((((aRectangle || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "merge_", fn: function(){return self}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "merge_", fn: function(){return self['@leftTop'].min_(aRectangle.leftTop()).rightBottom_(self['@rightBottom'].max_(aRectangle.rightBottom()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "merge_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("merge%3A%20aRectangle%0D%0A%09%22%20Return%20a%20Rectangle%20representing%20the%20area%20in%20which%20the%20receiver%20and%20aRectangle%20merged%20together.%20%22%0D%0A%0D%0A%09aRectangle%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09%5E%28leftTop%20min%3A%20aRectangle%20leftTop%29%20rightBottom%3A%20%28rightBottom%20max%3A%20aRectangle%20rightBottom%29"));

smalltalk.bind(smalltalk.Rectangle,"moveBy:","moveBy_"

,function (aPoint){var self=this;self['@leftTop']=self['@leftTop']._plus(aPoint);

self['@rightBottom']=self['@rightBottom']._plus(aPoint);return self;}

,"accessing",unescape("moveBy%3A%20aPoint%0D%0A%09%22%20Move%20the%20receiver%20by%20aPoint.%20%22%0D%0A%0D%0A%09leftTop%20%3A%3D%20leftTop%20+%20aPoint.%0D%0A%09rightBottom%20%3A%3D%20rightBottom%20+%20aPoint"));

smalltalk.bind(smalltalk.Rectangle,"moveTo:","moveTo_"

,function (aPoint){var self=this;self.moveBy_(aPoint._minus(self['@leftTop']));return self;}

,"accessing",unescape("moveTo%3A%20aPoint%0D%0A%09%22%20Move%20the%20receiver%20to%20aPoint.%20%22%0D%0A%0D%0A%09self%20moveBy%3A%20aPoint%20-%20leftTop"));

smalltalk.bind(smalltalk.Rectangle,"moveToLeftTop:","moveToLeftTop_"

,function (aPoint){var self=this;self.moveBy_(aPoint._minus(self.leftTop()));return self;}

,"accessing",unescape("moveToLeftTop%3A%20aPoint%0D%0A%09%22%20Move%20the%20receiver%20to%20leftTop.%20%22%0D%0A%0D%0A%09self%20moveBy%3A%20aPoint%20-%20self%20leftTop"));

smalltalk.bind(smalltalk.Rectangle,"nonIntersections:","nonIntersections_"

,function (aRectangle){var self=this;try{var areas=nil;((self.intersects_(aRectangle)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "nonIntersections_", fn: function(){return smalltalk.Array.with_(self)}})})();})());

((aRectangle.containsPoint_(self['@leftTop']).and_((function(){return aRectangle.containsPoint_(self['@rightBottom']);}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "nonIntersections_", fn: function(){return []}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "nonIntersections_", fn: function(){return smalltalk.Array.with_with_with_with_(((aRectangle.top()._gt(self.top())).mustBeBoolean()==true ? (function(){return self['@leftTop'].rightBottom_(self['@rightBottom'].x()._at(aRectangle.top()));})() : nil), ((aRectangle.bottom()._lt(self.bottom())).mustBeBoolean()==true ? (function(){return self['@leftTop'].x()._at(aRectangle.bottom()).rightBottom_(self['@rightBottom']);})() : nil), ((aRectangle.left()._gt(self.left())).mustBeBoolean()==true ? (function(){return self['@leftTop'].x()._at(self['@leftTop'].y().max_(aRectangle.top())).rightBottom_(aRectangle.left()._at(self['@rightBottom'].y().min_(aRectangle.bottom())));})() : nil), ((aRectangle.right()._lt(self.right())).mustBeBoolean()==true ? (function(){return aRectangle.right()._at(self['@leftTop'].y().max_(aRectangle.top())).rightBottom_(self['@rightBottom'].x()._at(self['@rightBottom'].y().min_(aRectangle.bottom())));})() : nil)).select_((function(each){return ((each || nil) !== nil);}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "nonIntersections_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("nonIntersections%3A%20aRectangle%0D%0A%09%22%20Return%20the%20rectangles%20describing%20areas%20of%20the%20receiver%20outside%20aRectangle.%20%22%0D%0A%0D%0A%09%7C%20areas%20%7C%0D%0A%09%28self%20intersects%3A%20aRectangle%29%20ifFalse%3A%20%5B%20%5EArray%20with%3A%20self%20%5D.%0D%0A%09%28%28aRectangle%20containsPoint%3A%20leftTop%29%0D%0A%09%09and%3A%20%5B%20aRectangle%20containsPoint%3A%20rightBottom%20%5D%29%0D%0A%09%09ifTrue%3A%20%5B%20%5E%23%28%29%20%5D.%0D%0A%09%5E%28Array%0D%0A%09with%3A%20%28aRectangle%20top%20%3E%20self%20top%20ifTrue%3A%20%5B%20leftTop%20rightBottom%3A%20rightBottom%20x%20@%20aRectangle%20top%20%5D%29%0D%0A%09with%3A%20%28aRectangle%20bottom%20%3C%20self%20bottom%20ifTrue%3A%20%5B%20leftTop%20x%20@%20aRectangle%20bottom%20rightBottom%3A%20rightBottom%20%5D%29%0D%0A%09with%3A%20%28aRectangle%20left%20%3E%20self%20left%20ifTrue%3A%20%5B%20leftTop%20x%20@%20%28leftTop%20y%20max%3A%20aRectangle%20top%29%0D%0A%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20rightBottom%3A%20aRectangle%20left%20@%20%28rightBottom%20y%20min%3A%20aRectangle%20bottom%29%20%5D%29%0D%0A%09with%3A%20%28aRectangle%20right%20%3C%20self%20right%20ifTrue%3A%20%5B%20aRectangle%20right%20@%20%28leftTop%20y%20max%3A%20aRectangle%20top%29%0D%0A%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20rightBottom%3A%20rightBottom%20x%20@%20%28rightBottom%20y%20min%3A%20aRectangle%20bottom%29%20%5D%29%0D%0A%09%29%20select%3A%20%5B%3Aeach%7C%20each%20notNil%20%5D"));

smalltalk.bind(smalltalk.Rectangle,"toString","toString"

,function (){var self=this;return self['@leftTop'].toString()._comma(" rightBottom: ")._comma(self['@rightBottom'].toString());return self;}

,"printing",unescape("toString%0D%0A%09%22%20Return%20the%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EleftTop%20toString%20%2C%27%20rightBottom%3A%20%27%20%2CrightBottom%20toString"));

smalltalk.bind(smalltalk.Rectangle,"relativeTo:","relativeTo_"

,function (aRectangle){var self=this;try{var extent=nil;extent=aRectangle.extent();

((aRectangle.extent().x()._eq((0)).or_((function(){return aRectangle.extent().y()._eq((0));}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "relativeTo_", fn: function(){return self}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "relativeTo_", fn: function(){return self['@leftTop']._minus(aRectangle.leftTop())._slash(extent).extent_(self.extent()._slash(extent))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "relativeTo_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("relativeTo%3A%20aRectangle%0D%0A%09%22%20Return%20a%20Rectangle%20proportionally%20relative%20to%20aRectangle.%20%22%0D%0A%0D%0A%09%7C%20extent%20%7C%0D%0A%09extent%20%3A%3D%20aRectangle%20extent.%0D%0A%09%28aRectangle%20extent%20x%20%3D%200%20or%3A%20%5B%20aRectangle%20extent%20y%20%3D%200%20%5D%29%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09%5EleftTop%20-%20aRectangle%20leftTop%20/%20extent%20extent%3A%20self%20extent%20/%20extent"));

smalltalk.bind(smalltalk.Rectangle,"right","right"

,function (){var self=this;return self['@rightBottom'].x();return self;}

,"accessing",unescape("right%0D%0A%09%22%20Return%20the%20receiver%27s%20right%20side.%20%22%0D%0A%0D%0A%09%5ErightBottom%20x"));

smalltalk.bind(smalltalk.Rectangle,"rightBottom","rightBottom"

,function (){var self=this;return self['@rightBottom'];return self;}

,"accessing",unescape("rightBottom%0D%0A%09%22%20Return%20the%20right%20bottom%20corner.%20%22%0D%0A%0D%0A%09%5ErightBottom"));

smalltalk.bind(smalltalk.Rectangle,"rightBottom:","rightBottom_"

,function (aPoint){var self=this;self['@rightBottom']=aPoint;return self;}

,"accessing",unescape("rightBottom%3A%20aPoint%0D%0A%09%22%20Set%20the%20right%20bottom%20corner%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09rightBottom%20%3A%3D%20aPoint"));

smalltalk.bind(smalltalk.Rectangle,"rightCenter","rightCenter"

,function (){var self=this;return self.right()._at(self.center().y());return self;}

,"accessing",unescape("rightCenter%0D%0A%09%22%20Return%20the%20center%20of%20the%20right%20edge%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20right%20@%20self%20center%20y"));

smalltalk.bind(smalltalk.Rectangle,"rightTop","rightTop"

,function (){var self=this;return self.right()._at(self.top());return self;}

,"accessing",unescape("rightTop%0D%0A%20%20%20%20%20%20%20%20%22%20Return%20the%20right%20top%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20right%20@%20self%20top"));

smalltalk.bind(smalltalk.Rectangle,"rounded","rounded"

,function (){var self=this;self['@leftTop']=self['@leftTop'].rounded();

self['@rightBottom']=self['@rightBottom'].rounded();return self;}

,"accessing",unescape("rounded%0D%0A%09%22%20Set%20the%20receiver%20with%20coordinates%20rounded%20to%20integers.%20%22%0D%0A%0D%0A%09leftTop%20%3A%3D%20leftTop%20rounded.%0D%0A%09rightBottom%20%3A%3D%20rightBottom%20rounded."));

smalltalk.bind(smalltalk.Rectangle,"scaleBy:","scaleBy_"

,function (delta){var self=this;return self['@leftTop']._star(delta).rightBottom_(self['@rightBottom']._star(delta));return self;}

,"accessing",unescape("scaleBy%3A%20delta%0D%0A%09%22%20Return%20the%20receiver%20multiplied%20by%20delta.%20%22%0D%0A%0D%0A%09%5EleftTop%20*%20delta%20rightBottom%3A%20rightBottom%20*%20delta"));

smalltalk.bind(smalltalk.Rectangle,"scaleTo:","scaleTo_"

,function (aRectangle){var self=this;return aRectangle.scaleBy_(self.extent()).truncated().moveBy_(self.leftTop());return self;}

,"accessing",unescape("scaleTo%3A%20aRectangle%0D%0A%09%22%20Return%20a%20Rectangle%20whose%20size%20is%20proportional%20to%20the%20receiver%20with%20ratios%20specified%20by%20aRectangle.%20%22%0D%0A%0D%0A%09%5E%28aRectangle%20scaleBy%3A%20self%20extent%29%20truncated%20moveBy%3A%20self%20leftTop"));

smalltalk.bind(smalltalk.Rectangle,"top","top"

,function (){var self=this;return self['@leftTop'].y();return self;}

,"accessing",unescape("top%0D%0A%09%22%20Return%20the%20top%20side%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EleftTop%20y"));

smalltalk.bind(smalltalk.Rectangle,"topCenter","topCenter"

,function (){var self=this;return self.center().x()._at(self.top());return self;}

,"accessing",unescape("topCenter%0D%0A%09%22%20Return%20the%20center%20of%20the%20top%20edge%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20center%20x%20@%20self%20top"));

smalltalk.bind(smalltalk.Rectangle,"topLeft","topLeft"

,function (){var self=this;return self['@leftTop'];return self;}

,"accessing",unescape("topLeft%0D%0A%09%22%20Return%20the%20top-left%20corner%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EleftTop"));

smalltalk.bind(smalltalk.Rectangle,"topLeft:","topLeft_"

,function (aPoint){var self=this;self['@leftTop']=aPoint;return self;}

,"accessing",unescape("topLeft%3A%20aPoint%0D%0A%09%22Set%20the%20top%20left%20corner%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09leftTop%20%3A%3D%20aPoint"));

smalltalk.bind(smalltalk.Rectangle,"topRight","topRight"

,function (){var self=this;return self.right()._at(self.top());return self;}

,"accessing",unescape("topRight%0D%0A%09%22%20Return%20the%20top-right%20corner%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20right%20@%20self%20top"));

smalltalk.bind(smalltalk.Rectangle,"translateBy:","translateBy_"

,function (delta){var self=this;return self['@leftTop']._plus(delta).rightBottom_(self['@rightBottom']._plus(delta));return self;}

,"accessing",unescape("translateBy%3A%20delta%0D%0A%09%22%20Return%20the%20receiver%20with%20position%20incremented%20by%20delta.%20%22%0D%0A%0D%0A%09%5EleftTop%20+%20delta%20rightBottom%3A%20rightBottom%20+%20delta"));

smalltalk.bind(smalltalk.Rectangle,"truncated","truncated"

,function (){var self=this;self['@leftTop']=self['@leftTop'].truncated();

self['@rightBottom']=self['@rightBottom'].truncated();return self;}

,"accessing",unescape("truncated%0D%0A%09%22%20Set%20the%20receiver%20with%20the%20coordinates%20truncated%20to%20integers.%20%22%0D%0A%0D%0A%09leftTop%20%3A%3D%20leftTop%20truncated.%0D%0A%09rightBottom%20%3A%3D%20rightBottom%20truncated."));

smalltalk.bind(smalltalk.Rectangle,"width","width"

,function (){var self=this;return self['@rightBottom'].x()._minus(self['@leftTop'].x()).abs();return self;}

,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28rightBottom%20x%20-%20leftTop%20x%29%20abs"));

smalltalk.bind(smalltalk.Rectangle,"width:","width_"

,function (anInteger){var self=this;self['@rightBottom'].x_(self['@leftTop'].x()._plus(anInteger));return self;}

,"accessing",unescape("width%3A%20anInteger%0D%0A%09%22%20Set%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09rightBottom%20x%3A%20leftTop%20x%20+%20anInteger"));

smalltalk.bind(smalltalk.EvaluableAction,",","_comma"

,function (anAction){var self=this;return smalltalk.ActionSequence.with_with_(self, anAction);return self;}

,"conversion",unescape("%2C%20anAction%0D%0A%09%22%20Return%20an%20action%20composed%20with%20the%20receiver%20and%20anAction.%20%22%0D%0A%0D%0A%09%5EActionSequence%20with%3A%20self%20with%3A%20anAction"));

smalltalk.bind(smalltalk.ActionSequence.$klass,"withAll:","withAll_"

,function (aCollection){var self=this;return (function($rec){$rec.contents_(aCollection);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("withAll%3A%20aCollection%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09contents%3A%20aCollection%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.ActionSequence.$klass,"with:","with_"

,function (anObject){var self=this;return self.withAll_(smalltalk.Array.with_(anObject));return self;}

,unescape("instance%20creation"),unescape("with%3A%20anObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withAll%3A%20%28Array%20with%3A%20anObject%29"));

smalltalk.bind(smalltalk.ActionSequence.$klass,"with:with:","with_with_"

,function (anObject,bObject){var self=this;return self.withAll_(smalltalk.Array.with_with_(anObject, bObject));return self;}

,unescape("instance%20creation"),unescape("with%3A%20anObject%20with%3A%20bObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withAll%3A%20%28Array%20with%3A%20anObject%20with%3A%20bObject%29"));

smalltalk.bind(smalltalk.ActionSequence.$klass,"with:with:with:","with_with_with_"

,function (anObject,bObject,cObject){var self=this;return self.withAll_(smalltalk.Array.with_with_with_(anObject, bObject, cObject));return self;}

,unescape("instance%20creation"),unescape("with%3A%20anObject%20with%3A%20bObject%20with%3A%20cObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withAll%3A%20%28Array%20with%3A%20anObject%20with%3A%20bObject%20with%3A%20cObject%29"));

smalltalk.bind(smalltalk.ActionSequence,"contents:","contents_"

,function (aCollection){var self=this;self['@contents']=aCollection;return self;}

,"private",unescape("contents%3A%20aCollection%0D%0A%09%22%20Private%20-%20Set%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09contents%20%3A%3D%20aCollection"));

smalltalk.bind(smalltalk.ActionSequence,"contents","contents"

,function (){var self=this;((((self['@contents'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@contents']=smalltalk.Array.$$new();})() : nil);

return self['@contents'];return self;}

,"private",unescape("contents%0D%0A%09%22%20Private%20-%20Return%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09contents%20isNil%20ifTrue%3A%20%5B%20contents%20%3A%3D%20Array%20new%20%5D.%0D%0A%09%5Econtents"));

smalltalk.bind(smalltalk.ActionSequence,"isEmpty","isEmpty"

,function (){var self=this;return ((self['@contents'] || nil) === nil).or_((function(){return self['@contents'].isEmpty();}));return self;}

,"testing",unescape("isEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%09%5Econtents%20isNil%20or%3A%20%5B%20contents%20isEmpty%20%5D"));

smalltalk.bind(smalltalk.ActionSequence,"notEmpty","notEmpty"

,function (){var self=this;return ((self['@contents'] || nil) !== nil).and_((function(){return self['@contents'].notEmpty();}));return self;}

,"testing",unescape("notEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20not%20empty.%20%22%0D%0A%0D%0A%09%5Econtents%20notNil%20and%3A%20%5B%20contents%20notEmpty%20%5D"));

smalltalk.bind(smalltalk.ActionSequence,"asArray","asArray"

,function (){var self=this;try{((self.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asArray", fn: function(){return []}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "asArray", fn: function(){return self['@contents'].asArray()}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "asArray"){return $$ex.fn();} throw($$ex);}}

,"conversion",unescape("asArray%0D%0A%09%22Return%20an%20Array%20containing%20all%20the%20elements%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20isEmpty%20ifTrue%3A%20%5B%20%5E%23%28%29%20%5D.%0D%0A%09%5Econtents%20asArray"));

smalltalk.bind(smalltalk.ActionSequence,"asActionSequence","asActionSequence"

,function (){var self=this;return self;return self;}

,"conversion",unescape("asActionSequence%0D%0A%09%22%20Return%20an%20ActionSequence%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.ActionSequence,",","_comma"

,function (anAction){var self=this;try{((self.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_comma", fn: function(){return anAction.asActionSequence()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_comma", fn: function(){return self.$klass.withAll_(self.contents()._comma(anAction.asActionSequence().contents()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_comma"){return $$ex.fn();} throw($$ex);}}

,"conversion",unescape("%2C%20anAction%0D%0A%09%22%20Return%20an%20action%20composed%20with%20the%20receiver%20and%20anAction.%20%22%0D%0A%0D%0A%09self%20isEmpty%20ifTrue%3A%20%5B%20%5EanAction%20asActionSequence%20%5D.%0D%0A%09%5Eself%20class%20withAll%3A%20self%20contents%20%2C%20anAction%20asActionSequence%20contents"));

smalltalk.bind(smalltalk.ActionSequence,"copyWith:","copyWith_"

,function (anObject){var self=this;return self.$klass.withAll_(self.contents().copyWith_(anObject));return self;}

,"conversion",unescape("copyWith%3A%20anObject%0D%0A%09%22%20Return%20an%20action%20composed%20with%20the%20receiver%20and%20anObject.%20%22%0D%0A%0D%0A%09%5Eself%20class%20withAll%3A%20%28self%20contents%20copyWith%3A%20anObject%29"));

smalltalk.bind(smalltalk.ActionSequence,"do:","do_"

,function (aBlock){var self=this;return ((self.notEmpty()).mustBeBoolean()==true ? (function(){return self.contents().do_(aBlock);})() : nil);return self;}

,"conversion",unescape("do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20each%20object%20in%20the%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%09%5Eself%20notEmpty%20ifTrue%3A%20%5B%20self%20contents%20do%3A%20aBlock%20%5D"));

smalltalk.bind(smalltalk.ActionSequence,"includes:","includes_"

,function (anObject){var self=this;return self.notEmpty().and_((function(){return self.contents().includes_(anObject);}));return self;}

,"testing",unescape("includes%3A%20anObject%0D%0A%09%22%20Return%20true%20if%20anObject%20is%20in%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%09%5Eself%20notEmpty%20and%3A%20%5B%20self%20contents%20includes%3A%20anObject%20%5D"));

smalltalk.bind(smalltalk.ActionSequence,"select:","select_"

,function (aBlock){var self=this;return self.$klass.withAll_(self.asArray().select_(aBlock));return self;}

,"enumerating",unescape("select%3A%20aBlock%0D%0A%09%22%20Return%20the%20a%20copy%20of%20the%20receiver%20with%20elements%20wich%20evaluates%20aBlock%20to%20true.%20%22%0D%0A%0D%0A%09%5Eself%20class%20withAll%3A%20%28self%20asArray%20select%3A%20aBlock%29"));

smalltalk.bind(smalltalk.ActionSequence,"reject:","reject_"

,function (aBlock){var self=this;return self.$klass.withAll_(self.asArray().reject_(aBlock));return self;}

,"enumerating",unescape("reject%3A%20aBlock%0D%0A%09%22%20Return%20the%20a%20copy%20of%20the%20receiver%20with%20elements%20wich%20evaluates%20aBlock%20to%20false.%20%22%0D%0A%0D%0A%09%5Eself%20class%20withAll%3A%20%28self%20asArray%20reject%3A%20aBlock%29"));

smalltalk.bind(smalltalk.ActionSequence,"evaluate","evaluate"

,function (){var self=this;var result=nil;self.do_((function(each){return result=each.evaluate();}));

return result;return self;}

,"evaluating",unescape("evaluate%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09self%20do%3A%20%5B%3Aeach%7C%20result%20%3A%3D%20each%20evaluate%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.ActionSequence,"evaluateWithArguments:","evaluateWithArguments_"

,function (anArray){var self=this;var result=nil;self.do_((function(each){return result=each.evaluateWithArguments_(anArray);}));

return result;return self;}

,"evaluating",unescape("evaluateWithArguments%3A%20anArray%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09self%20do%3A%20%5B%3Aeach%7C%20result%20%3A%3D%20each%20evaluateWithArguments%3A%20anArray%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.ActionSequence,"evaluateFor:","evaluateFor_"

,function (anObject){var self=this;var result=nil;self.do_((function(each){return result=each.evaluateFor_(anObject);}));

return result;return self;}

,"evaluating",unescape("evaluateFor%3A%20anObject%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09self%20do%3A%20%5B%3Aeach%7C%20result%20%3A%3D%20each%20evaluateFor%3A%20anObject%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.ActionSequence,"reduced","reduced"

,function (){var self=this;return ((self.notEmpty()).mustBeBoolean()==true ? (function(){return ((self['@contents'].size()._eq((1))).mustBeBoolean()==true ? (function(){return self['@contents'].first();})() : (function(){return self;})());})() : nil);return self;}

,"events",unescape("reduced%0D%0A%09%22%20Return%20the%20receiver%20reduced%20to%20minimal%20evaluable%20expression.%20%22%0D%0A%0D%0A%09%5Eself%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%09contents%20size%20%3D%201%0D%0A%09%09ifTrue%3A%20%5B%20contents%20first%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20self%20%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.ActionSequence,"evaluateWithSelector:withArguments:","evaluateWithSelector_withArguments_"

,function (aSelector,array){var self=this;var result=nil;self.do_((function(each){return result=each.receiver().perform_withArguments_(aSelector, array);}));

return result;return self;}

,"changes",unescape("evaluateWithSelector%3A%20aSelector%20withArguments%3A%20array%0D%0A%09%22%20Private%20-%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20aSelector%20and%20arguments%20array.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09self%20do%3A%20%5B%3Aeach%7C%20result%20%3A%3D%20each%20receiver%20perform%3A%20aSelector%20withArguments%3A%20array%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.EventManager.$klass,"eventsTriggered","eventsTriggered"

,function (){var self=this;((((self['@eventsTriggered'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeEventsTriggered();})() : nil);

return self['@eventsTriggered'];return self;}

,"events",unescape("eventsTriggered%0D%0A%09%22%20Return%20all%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09eventsTriggered%20isNil%20ifTrue%3A%20%5B%20self%20initializeEventsTriggered%20%5D.%0D%0A%09%5EeventsTriggered"));

smalltalk.bind(smalltalk.EventManager.$klass,"eventsTriggered:","eventsTriggered_"

,function (aCollection){var self=this;self['@eventsTriggered']=aCollection;return self;}

,"events",unescape("eventsTriggered%3A%20aCollection%0D%0A%09%22%20Set%20all%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09eventsTriggered%20%3A%3D%20aCollection"));

smalltalk.bind(smalltalk.EventManager.$klass,"initializeEventsTriggered","initializeEventsTriggered"

,function (){var self=this;self.eventsTriggered_(self.constructEventsTriggered());return self;}

,"events",unescape("initializeEventsTriggered%0D%0A%09%22%20Private%20-%20Initialize%20all%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20eventsTriggered%3A%20self%20constructEventsTriggered"));

smalltalk.bind(smalltalk.EventManager,"eventTable","eventTable"

,function (){var self=this;return ((((self['@handlers'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self.eventTableCreate();})() : (function(){return self['@handlers'];})());return self;}

,"events",unescape("eventTable%0D%0A%09%22%20Private%20-%20Returns%20the%20mapping%20event%20names%20to%20actions%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandlers%20isNil%0D%0A%09%09ifTrue%3A%20%5B%20self%20eventTableCreate%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20handlers%20%5D"));

smalltalk.bind(smalltalk.EventManager,"eventTableForEdit","eventTableForEdit"

,function (){var self=this;((((self['@handlers'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@handlers']=self.eventTableCreate();})() : nil);

return self['@handlers'];return self;}

,"events",unescape("eventTableForEdit%0D%0A%09%22%20Private%20-%20Returns%20the%20mapping%20event%20names%20to%20actions%20of%20the%20receiver.%0D%0A%09Set%20the%20internal%20map%20if%20not%20present.%0D%0A%09%22%0D%0A%0D%0A%09handlers%20isNil%20ifTrue%3A%20%5B%20handlers%20%3A%3D%20self%20eventTableCreate%20%5D.%0D%0A%09%5Ehandlers"));

smalltalk.bind(smalltalk.EventManager,"releaseEventTable","releaseEventTable"

,function (){var self=this;self['@handlers']=nil;return self;}

,"events",unescape("releaseEventTable%0D%0A%09%22%20Private%20-%20Release%20the%20event%20table.%20%22%0D%0A%0D%0A%09handlers%20%3A%3D%20nil"));

smalltalk.bind(smalltalk.CompilerNode,"nodes","nodes"

,function (){var self=this;((((self['@nodes'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@nodes']=smalltalk.Array.$$new();})() : nil);

return self['@nodes'];return self;}

,"accessing",unescape("nodes%0D%0A%09nodes%20isNil%20ifTrue%3A%20%5B%20nodes%20%3A%3D%20Array%20new%20%5D.%0D%0A%09%5Enodes"));

smalltalk.bind(smalltalk.CompilerNode,"nodes:","nodes_"

,function (aCollection){var self=this;self['@nodes']=aCollection;return self;}

,"accessing",unescape("nodes%3A%20aCollection%0D%0A%09nodes%20%3A%3D%20aCollection"));

smalltalk.bind(smalltalk.CompilerNode,"addNode:","addNode_"

,function (aNode){var self=this;self.nodes().add_(aNode);return self;}

,"accessing",unescape("addNode%3A%20aNode%0D%0A%09self%20nodes%20add%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNode,"start","start"

,function (){var self=this;return self['@start'];return self;}

,"accessing",unescape("start%0D%0A%09%5Estart"));

smalltalk.bind(smalltalk.CompilerNode,"end","end"

,function (){var self=this;return self['@end'];return self;}

,"accessing",unescape("end%0D%0A%09%5Eend"));

smalltalk.bind(smalltalk.CompilerNode,"start:end:","start_end_"

,function (startOffset,endOffset){var self=this;self['@start']=startOffset;

self['@end']=endOffset;return self;}

,"accessing",unescape("start%3A%20startOffset%20end%3A%20endOffset%0D%0A%09%22%20Set%20the%20offsets%20of%20the%20receiver%20in%20source%20code.%20%22%0D%0A%0D%0A%09start%20%3A%3D%20startOffset.%0D%0A%09end%20%3A%3D%20endOffset."));

smalltalk.bind(smalltalk.CompilerNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitNode%3A%20self"));

smalltalk.bind(smalltalk.CompilerNode,"acceptMacroAssignment:with:","acceptMacroAssignment_with_"

,function (anExpressionNode,aVisitor){var self=this;return aVisitor.visitMacroAssignment_to_(self, anExpressionNode);return self;}

,"visiting",unescape("acceptMacroAssignment%3A%20anExpressionNode%20with%3A%20aVisitor%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20can%20resolve%20assignment%20on%20aVisitor.%20%22%0D%0A%0D%0A%09%5EaVisitor%20visitMacroAssignment%3A%20self%20to%3A%20anExpressionNode"));

smalltalk.bind(smalltalk.CompilerNode,"isSuper","isSuper"

,function (){var self=this;return false;return self;}

,"testing",unescape("isSuper%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20super.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.CompilerNode,"hasNumber","hasNumber"

,function (){var self=this;return false;return self;}

,"testing",unescape("hasNumber%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20has%20a%20numeric%20literal%20value.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.CompilerNode,"hasString","hasString"

,function (){var self=this;return false;return self;}

,"testing",unescape("hasString%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20has%20a%20string%20literal%20value.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.CompilerNode,"isAssignment","isAssignment"

,function (){var self=this;return false;return self;}

,"testing",unescape("isAssignment%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20an%20assignment%20node.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.CompilerNode,"bindings","bindings"

,function (){var self=this;return [];return self;}

,"bindings",unescape("bindings%0D%0A%09%22%20Return%20the%20bindings%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%23%28%29"));

smalltalk.bind(smalltalk.CompilerNode,"messageSendConnector","messageSendConnector"

,function (){var self=this;return ".";return self;}

,"accessing",unescape("messageSendConnector%0D%0A%09%22%20Return%20the%20binder%20used%20to%20send%20message%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27.%27"));

smalltalk.bind(smalltalk.PPFailure.$klass,"reason:at:","reason_at_"

,function (aString,anInteger){var self=this;return self.$$new().reason_at_(aString, anInteger);return self;}

,unescape("instance%20creation"),unescape("reason%3A%20aString%20at%3A%20anInteger%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%20reason%3A%20aString%20at%3A%20anInteger"));

smalltalk.bind(smalltalk.PPFailure,"position","position"

,function (){var self=this;try{((((self['@position'] || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "position", fn: function(){return (0)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "position", fn: function(){return self['@position']}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "position"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("position%0D%0A%09%22%20Return%20the%20position%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09position%20isNil%20ifTrue%3A%20%5B%20%5E0%20%5D.%0D%0A%09%5Eposition"));

smalltalk.bind(smalltalk.PPFailure,"position:","position_"

,function (aNumber){var self=this;self['@position']=aNumber;return self;}

,"accessing",unescape("position%3A%20aNumber%0D%0A%09%22%20Set%20the%20position%20of%20the%20rceiver.%20%22%0D%0A%0D%0A%09position%20%3A%3D%20aNumber"));

smalltalk.bind(smalltalk.PPFailure,"reason","reason"

,function (){var self=this;try{((((self['@reason'] || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "reason", fn: function(){return smalltalk.String.$$new()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "reason", fn: function(){return self['@reason']}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "reason"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("reason%0D%0A%09%22%20Return%20the%20reason%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09reason%20isNil%20ifTrue%3A%20%5B%20%5EString%20new%20%5D.%0D%0A%09%5Ereason"));

smalltalk.bind(smalltalk.PPFailure,"reason:","reason_"

,function (aString){var self=this;self['@reason']=aString;return self;}

,"accessing",unescape("reason%3A%20aString%0D%0A%09%22%20Set%20the%20reason%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09reason%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.PPFailure,"reason:at:","reason_at_"

,function (aString,anInteger){var self=this;(function($rec){$rec.reason_(aString);return $rec.position_(anInteger);})(self);return self;}

,"accessing",unescape("reason%3A%20aString%20at%3A%20anInteger%0D%0A%09%22%20Set%20the%20reason%20and%20position%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%0D%0A%09%09reason%3A%20aString%3B%20%0D%0A%09%09position%3A%20anInteger"));

smalltalk.bind(smalltalk.PPFailure,"isParseFailure","isParseFailure"

,function (){var self=this;return true;return self;}

,"testing",unescape("isParseFailure%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20parse%20failure.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.PPFailure,"accept:","accept_"

,function (aCompiler){var self=this;var description=nil;description="PPFailure: "._comma(self.reason())._comma(" at: ")._comma(self.position().asString())._comma(" source: ")._comma(aCompiler.stream().contents());

self.print_(description);

self.error_(unescape("%23accept%3A%20out%20of%20control%20-%20")._comma(description));return self;}

,unescape("compiler%20bug"),unescape("accept%3A%20aCompiler%0D%0A%09%22%20Report%20buggy%20send%20in%20compiler.%20%22%0D%0A%0D%0A%09%7C%20description%20%7C%0D%0A%09description%20%3A%3D%20%27PPFailure%3A%20%27%2C%20self%20reason%0D%0A%09%09%2C%27%20at%3A%20%27%20%2Cself%20position%20asString%0D%0A%09%09%2C%27%20source%3A%20%27%20%2CaCompiler%20stream%20contents.%0D%0A%09self%20print%3A%20description.%0D%0A%09self%20error%3A%20%27%23accept%3A%20out%20of%20control%20-%20%27%20%2Cdescription"));

smalltalk.bind(smalltalk.PPParser.$klass,",","_comma"

,function (anObject){var self=this;return anObject.asParser();return self;}

,unescape("instance%20creation"),unescape("%2C%20anObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EanObject%20asParser"));

smalltalk.bind(smalltalk.PPParser,"initialize","initialize"

,function (){var self=this;self['@memo']=smalltalk.Dictionary.$$new();return self;}

,"initialize",unescape("initialize%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%20%22%0D%0A%0D%0A%09memo%20%3A%3D%20Dictionary%20new"));

smalltalk.bind(smalltalk.PPParser,"memo","memo"

,function (){var self=this;return self['@memo'];return self;}

,"accessing",unescape("memo%0D%0A%09%22%20Return%20the%20memoized%20information.%20%22%0D%0A%0D%0A%09%5Ememo"));

smalltalk.bind(smalltalk.PPParser,"onFailure:","onFailure_"

,function (aBlock){var self=this;return smalltalk.PPFailureActionParser.on_block_(self, aBlock);return self;}

,unescape("error%20handling"),unescape("onFailure%3A%20aBlock%0D%0A%09%22%20Evaluate%20the%20receiver%20filtering%20parser%20failures.%20%22%0D%0A%0D%0A%09%5EPPFailureActionParser%20on%3A%20self%20block%3A%20aBlock"));

smalltalk.bind(smalltalk.PPParser,"set:start:end:","set_start_end_"

,function (anElement,start,end){var self=this;((anElement.respondsTo_("start:end:")).mustBeBoolean()==true ? (function(){return anElement.start_end_(start, end);})() : nil);return self;}

,"private",unescape("set%3A%20anElement%20start%3A%20start%20end%3A%20end%0D%0A%09%22%20Private%20-%20Set%20start%26end%20source%20offest%20of%20anElement.%20%22%0D%0A%0D%0A%09%28anElement%20respondsTo%3A%20%23start%3Aend%3A%29%20ifTrue%3A%20%5B%0D%0A%09%09anElement%20start%3A%20start%20end%3A%20end%0D%0A%09%5D"));

smalltalk.bind(smalltalk.PPParser,"flatten","flatten"

,function (){var self=this;return smalltalk.PPFlattenParser.on_(self);return self;}

,"operations",unescape("flatten%0D%0A%09%22%20Return%20a%20flattened%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPFlattenParser%20on%3A%20self"));

smalltalk.bind(smalltalk.PPParser,"withSource","withSource"

,function (){var self=this;return smalltalk.PPSourceParser.on_(self);return self;}

,"operations",unescape("withSource%0D%0A%09%22%20Return%20a%20source%20parser%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPSourceParser%20on%3A%20self"));

smalltalk.bind(smalltalk.PPParser,"==>","_eq_eq_gt"

,function (aBlock){var self=this;return smalltalk.PPActionParser.on_block_(self, aBlock);return self;}

,"operations",unescape("%3D%3D%3E%20aBlock%0D%0A%09%22%20Return%20an%20action%20parser%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPActionParser%20on%3A%20self%20block%3A%20aBlock"));

smalltalk.bind(smalltalk.PPParser,",","_comma"

,function (aParser){var self=this;return smalltalk.PPSequenceParser.with_with_(self, aParser);return self;}

,"operations",unescape("%2C%20aParser%0D%0A%09%22%20Return%20a%20composed%20version%20of%20the%20receiver%20and%20aParser.%20%22%0D%0A%0D%0A%09%5EPPSequenceParser%20with%3A%20self%20with%3A%20aParser"));

smalltalk.bind(smalltalk.PPParser,"/","_slash"

,function (aParser){var self=this;return smalltalk.PPChoiceParser.with_with_(self, aParser);return self;}

,"operations",unescape("/%20aParser%0D%0A%09%22%20Return%20a%20choice%20composite%20version%20of%20the%20receiver%20and%20aParser.%20%22%0D%0A%0D%0A%09%5EPPChoiceParser%20with%3A%20self%20with%3A%20aParser"));

smalltalk.bind(smalltalk.PPParser,"plus","plus"

,function (){var self=this;return smalltalk.PPRepeatingParser.on_min_(self, (1));return self;}

,"operations",unescape("plus%0D%0A%09%22%20Return%20an%20iterative%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPRepeatingParser%20on%3A%20self%20min%3A%201"));

smalltalk.bind(smalltalk.PPParser,"star","star"

,function (){var self=this;return smalltalk.PPRepeatingParser.on_min_(self, (0));return self;}

,"operations",unescape("star%0D%0A%09%22%20Return%20an%20iterative%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPRepeatingParser%20on%3A%20self%20min%3A%200"));

smalltalk.bind(smalltalk.PPParser,"not","not"

,function (){var self=this;return smalltalk.PPNotParser.on_(self);return self;}

,"operations",unescape("not%0D%0A%09%22%20Return%20the%20negation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPNotParser%20on%3A%20self"));

smalltalk.bind(smalltalk.PPParser,"optional","optional"

,function (){var self=this;return self._slash(smalltalk.PPEpsilonParser.$$new());return self;}

,"operations",unescape("optional%0D%0A%09%22%20Return%20an%20optional%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20/%20PPEpsilonParser%20new"));

smalltalk.bind(smalltalk.PPParser,"memoizedParse:","memoizedParse_"

,function (aStream){var self=this;var start=nil;var end=nil;var node=nil;start=aStream.position();

return self.memo().at_ifPresent_ifAbsent_(start, (function(value){aStream.position_(self.memo().at_(start).second());return value.first();}), (function(){node=self.parse_(aStream);end=aStream.position();self.set_start_end_(node, start, end);self.memo().at_put_(start, smalltalk.Array.with_with_(node, end));return node;}));return self;}

,"operations",unescape("memoizedParse%3A%20aStream%0D%0A%09%22%20Private%20-%20Evaluate%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20start%20end%20node%20%7C%0D%0A%09start%20%3A%3D%20aStream%20position.%0D%0A%09%5Eself%20memo%20at%3A%20start%20%0D%0A%09%20%20%20%20ifPresent%3A%20%5B%3Avalue%20%7C%0D%0A%09%09aStream%20position%3A%20%28self%20memo%20at%3A%20start%29%20second.%0D%0A%09%09value%20first%0D%0A%09%20%20%20%20%5D%20ifAbsent%3A%20%5B%0D%0A%09%09node%20%3A%3D%20self%20parse%3A%20aStream.%0D%0A%09%09end%20%3A%3D%20aStream%20position.%0D%0A%09%09self%20set%3A%20node%20start%3A%20start%20end%3A%20end.%0D%0A%09%09self%20memo%20at%3A%20start%20put%3A%20%28Array%20with%3A%20node%20with%3A%20end%29.%0D%0A%09%09node%0D%0A%09%20%20%20%20%5D"));

smalltalk.bind(smalltalk.PPParser,"parse:","parse_"

,function (aStream){var self=this;self.subclassResponsibility();return self;}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09self%20subclassResponsibility"));

smalltalk.bind(smalltalk.PPParser,"parseAll:","parseAll_"

,function (aStream){var self=this;var result=nil;result=smalltalk.PPSequenceParser.with_with_(self, smalltalk.PPEOFParser.$$new()).memoizedParse_(aStream);

return ((result.isParseFailure()).mustBeBoolean()==true ? (function(){return self.error_(result.messageFor_(aStream.contents()));})() : (function(){return result.first();})());return self;}

,"parsing",unescape("parseAll%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20%28PPSequenceParser%0D%0A%09%09with%3A%20self%20with%3A%20PPEOFParser%20new%29%0D%0A%09%09memoizedParse%3A%20aStream.%0D%0A%09%5Eresult%20isParseFailure%20%0D%0A%09%20%20%20%20ifTrue%3A%20%5B%20self%20error%3A%20%28result%20messageFor%3A%20aStream%20contents%29%20%5D%0D%0A%09%20%20%20%20ifFalse%3A%20%5B%20result%20first%20%5D"));

smalltalk.bind(smalltalk.PPParser,"asParser","asParser"

,function (){var self=this;return self;return self;}

,"converting",unescape("asParser%0D%0A%09%22%20Return%20a%20parser%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.SmalltalkParser.$klass,"parse:","parse_"

,function (aStream){var self=this;return self.$$new().parse_(aStream);return self;}

,unescape("instance%20creation"),unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%5Eself%20new%20parse%3A%20aStream%20"));

smalltalk.bind(smalltalk.SmalltalkParser,"directive:ws:","directive_ws_"

,function (number,ws){var self=this;var notImplemented=nil;notImplemented=unescape("%5E%3E").asCharacterParser().star().flatten()._comma(unescape("%3E"))._eq_eq_gt((function(node){return node.first().error_("Compiler directives not implemented.");}));

return unescape("%3C").asParser()._comma(ws._comma(notImplemented)._comma(ws))._eq_eq_gt((function(node){return node.second().second();}));return self;}

,"directives",unescape("directive%3A%20number%20ws%3A%20ws%0D%0A%09%22%20Private%20-%20Return%20the%20parser%20for%20directives.%20%22%0D%0A%0D%0A%09%7C%20notImplemented%20%7C%0D%0A%09notImplemented%20%3A%3D%20%27%5E%3E%27%20asCharacterParser%20star%20flatten%2C%20%24%3E%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%7C%20node%20first%20error%3A%20%27Compiler%20directives%20not%20implemented.%27%20%5D.%0D%0A%0D%0A%09%5E%24%3C%20asParser%2C%20%28ws%2C%20notImplemented%2C%20ws%29%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20second%20second%20%5D"));

smalltalk.bind(smalltalk.SmalltalkParser,"parse:","parse_"

,function (aStream){var self=this;return self.parser().parse_(aStream);return self;}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%5Eself%20parser%20parse%3A%20aStream"));

smalltalk.bind(smalltalk.SmalltalkParser,"parser","parser"

,function (){var self=this;var method=nil;var expression=nil;var separator=nil;var comment=nil;var ws=nil;var identifier=nil;var keyword=nil;var globalName=nil;var string=nil;var symbol=nil;var number=nil;var literalArray=nil;var variable=nil;var reference=nil;var globalReference=nil;var literal=nil;var returnExpression=nil;var methodParser=nil;var expressionParser=nil;var keyword=nil;var unarySelector=nil;var binarySelector=nil;var keywordPattern=nil;var unaryPattern=nil;var binaryPattern=nil;var assignment=nil;var temps=nil;var blockParamList=nil;var block=nil;var expression=nil;var expressions=nil;var subexpression=nil;var statements=nil;var sequence=nil;var operand=nil;var unaryMessage=nil;var unarySend=nil;var unaryTail=nil;var binaryMessage=nil;var binarySend=nil;var binaryTail=nil;var keywordMessage=nil;var keywordSend=nil;var keywordPair=nil;var cascade=nil;var message=nil;var jsStatement=nil;var jsIndex=nil;var character=nil;var directive=nil;var arrayLiteral=nil;var binarySelectorChars=nil;var symbolChars=nil;var extendedSymbolChars=nil;var stIdentifier=nil;var jsIdentifier=nil;var noReference=nil;var alienReference=nil;var primitive=nil;var api=nil;binarySelectorChars=unescape("%7C%26%5C%5C+*/%3D%3E%3C%2C@%25%7E-");

symbolChars=unescape("a-zA-Z0-9_");

extendedSymbolChars=symbolChars._comma(":")._comma(binarySelectorChars);

separator=smalltalk.String.cr()._comma(smalltalk.String.space())._comma(smalltalk.String.lf())._comma(smalltalk.String.tab()).asChoiceParser();

comment=unescape("%22").asCharacterParser()._comma(unescape("%22").asParser().not()._comma(smalltalk.PPAnyParser.$$new()).star())._comma(unescape("%22").asCharacterParser()).flatten();

ws=separator._slash(comment).star();

string=unescape("%27").asParser()._comma(smalltalk.PPStStringParser.$$new())._eq_eq_gt((function(node){return smalltalk.ValueNode.$$new().value_(node.second());}));

stIdentifier=unescape("a-z_").asCharacterParser()._comma(symbolChars.asCharacterParser().star()).flatten();

jsIdentifier=unescape("%23").asParser()._comma(symbolChars.asCharacterParser().plus()).flatten();

identifier=jsIdentifier._slash(stIdentifier);

keyword=identifier._comma(":").flatten();

globalName=unescape("A-Z").asCharacterParser()._comma(symbolChars.asCharacterParser().star()).flatten();

symbol=unescape("%23").asParser()._comma(extendedSymbolChars.asCharacterParser().plus().flatten())._eq_eq_gt((function(node){return smalltalk.ValueNode.$$new().value_(node.second());}));

number=unescape("-0-9").asCharacterParser().plus()._comma(".".asParser()._comma(unescape("0-9").asCharacterParser().plus()).optional())._comma("r".asParser()._comma(unescape("A-Z0-9").asCharacterParser().plus()).optional()).flatten()._eq_eq_gt((function(node){return smalltalk.ValueNode.$$new().value_(node.asNumber());}));

character="$".asParser()._comma(smalltalk.PPAnyParser.$$new())._eq_eq_gt((function(node){return smalltalk.ValueNode.$$new().value_(node.at_((2)));}));

directive=self.directive_ws_(number, ws);

variable=identifier._eq_eq_gt((function(token){return smalltalk.VariableNode.$$new().value_(token);}));

noReference=unescape("%23").asParser()._eq_eq_gt((function(token){return smalltalk.NoReceiverNode.$$new();}));

literal=smalltalk.PPDelegateParser.$$new();

expression=smalltalk.PPDelegateParser.$$new();

arrayLiteral=literal._slash(variable);

literalArray=unescape("%23%28").asParser()._comma(ws._comma(arrayLiteral)._comma(ws).star())._comma(unescape("%29"))._eq_eq_gt((function(node){return smalltalk.ValueNode.$$new().value_(smalltalk.Array.withAll_(node.second().collect_((function(each){return each.second().value();}))));}));

globalReference=globalName._eq_eq_gt((function(token){return smalltalk.GlobalReferenceNode.$$new().value_(token);}));

alienReference=unescape("%23%7B").asParser()._comma(identifier)._comma(unescape("%7D"))._eq_eq_gt((function(node){return smalltalk.AlienNode.$$new().value_(node.second());}));

jsIndex=unescape("%5B").asParser()._comma(expression)._comma(unescape("%5D"))._slash(unescape("%23").asParser()._comma(identifier));

reference=variable._slash(globalReference)._slash(alienReference)._comma(jsIndex.star())._eq_eq_gt((function(nodes){return nodes.first().indexedAs_(nodes);}));

binarySelector=unescape("%23").asParser().optional()._comma(binarySelectorChars.asCharacterParser().plus()).flatten();

unarySelector=identifier;

keywordPattern=ws._comma(keyword)._comma(ws)._comma(identifier).plus()._eq_eq_gt((function(nodes){return smalltalk.Array.with_with_(nodes.collect_((function(each){return each.at_((2));})).join_(""), nodes.collect_((function(each){return each.at_((4));})));}));

binaryPattern=ws._comma(binarySelector)._comma(ws)._comma(identifier)._eq_eq_gt((function(node){return smalltalk.Array.with_with_(node.second(), smalltalk.Array.with_(node.fourth()));}));

unaryPattern=ws._comma(unarySelector)._eq_eq_gt((function(node){return smalltalk.Array.with_with_(node.second(), smalltalk.Array.$$new());}));

expressions=expression._comma(ws._comma(".")._comma(ws)._comma(expression)._eq_eq_gt((function(node){return node.fourth();})).star())._eq_eq_gt((function(node){var result=nil;result=smalltalk.Array.with_(node.first());node.second().do_((function(each){return result.add_(each);}));return result;}));

assignment=reference._comma(ws)._comma(unescape("%3A%3D"))._comma(ws)._comma(expression)._eq_eq_gt((function(node){return (function($rec){$rec.left_(node.first());return $rec.right_(node.at_((5)));})(smalltalk.AssignmentNode.$$new());}));

returnExpression=unescape("%5E").asParser()._comma(ws)._comma(expression)._comma(ws)._comma(".".asParser().optional())._eq_eq_gt((function(node){return (function($rec){$rec.addNode_(node.third());return $rec.yourself();})(smalltalk.ReturnNode.$$new());}));

temps=unescape("%7C").asParser()._comma(ws._comma(identifier).star())._comma(ws)._comma(unescape("%7C"))._eq_eq_gt((function(node){return node.second().collect_((function(each){return each.second();}));}));

blockParamList=":".asParser()._comma(ws)._comma(identifier)._comma(ws).plus()._comma(unescape("%7C"))._eq_eq_gt((function(node){return node.first().collect_((function(each){return each.third();}));}));

subexpression=unescape("%28").asParser()._comma(ws)._comma(expression)._comma(ws)._comma(unescape("%29"))._eq_eq_gt((function(node){return node.third();}));

statements=returnExpression._eq_eq_gt((function(node){return smalltalk.Array.with_(node);}))._slash(expressions._comma(ws)._comma(".")._comma(ws)._comma(returnExpression)._eq_eq_gt((function(node){return (function($rec){$rec.add_(node.at_((5)));return $rec.yourself();})(node.first());})))._slash(expressions._comma(".".asParser().optional())._eq_eq_gt((function(node){return node.first();})));

sequence=temps.optional()._comma(ws)._comma(directive.optional())._comma(ws)._comma(statements.optional())._comma(ws)._eq_eq_gt((function(node){return (function($rec){$rec.directive_(node.third());$rec.temps_(node.first());$rec.nodes_(node.at_((5)));return $rec.yourself();})(smalltalk.ExtendedSequenceNode.$$new());}));

block=unescape("%5B").asParser()._comma(ws)._comma(blockParamList.optional())._comma(ws)._comma(sequence.optional())._comma(ws)._comma(unescape("%5D"))._eq_eq_gt((function(node){return (function($rec){$rec.parameters_(node.third());return $rec.addNode_(node.at_((5)).asBlockSequenceNode());})(smalltalk.BlockNode.$$new());}));

operand=literal._slash(reference)._slash(noReference)._slash(subexpression);

literal.parser_(character._slash(number)._slash(string)._slash(literalArray)._slash(symbol)._slash(block));

unaryMessage=ws._comma(unarySelector)._comma(":".asParser().not())._eq_eq_gt((function(node){return smalltalk.SendNode.$$new().selector_(node.second());}));

unaryTail=smalltalk.PPDelegateParser.$$new();

unaryTail.parser_(unaryMessage._comma(unaryTail.optional())._eq_eq_gt((function(node){return ((((node.second() || nil) === nil)).mustBeBoolean()==true ? (function(){return node.first();})() : (function(){return node.second().valueForReceiver_(node.first());})());})));

unarySend=operand._comma(unaryTail.optional())._eq_eq_gt((function(node){return ((((node.second() || nil) === nil)).mustBeBoolean()==true ? (function(){return node.first();})() : (function(){return node.second().valueForReceiver_(node.first());})());}));

binaryMessage=ws._comma(binarySelector)._comma(ws)._comma(unarySend._slash(operand))._eq_eq_gt((function(node){return (function($rec){$rec.selector_(node.second());return $rec.arguments_(smalltalk.Array.with_(node.fourth()));})(smalltalk.SendNode.$$new());}));

binaryTail=smalltalk.PPDelegateParser.$$new();

binaryTail.parser_(binaryMessage._comma(binaryTail.optional())._eq_eq_gt((function(node){return ((((node.second() || nil) === nil)).mustBeBoolean()==true ? (function(){return node.first();})() : (function(){return node.second().valueForReceiver_(node.first());})());})));

binarySend=unarySend._comma(binaryTail.optional())._eq_eq_gt((function(node){return ((((node.second() || nil) === nil)).mustBeBoolean()==true ? (function(){return node.first();})() : (function(){return node.second().valueForReceiver_(node.first());})());}));

keywordPair=keyword._comma(ws)._comma(binarySend);

keywordMessage=ws._comma(keywordPair).plus()._eq_eq_gt((function(nodes){return (function($rec){$rec.selector_(nodes.collect_((function(each){return each.second().first();})).join_(""));return $rec.arguments_(nodes.collect_((function(each){return each.second().third();})));})(smalltalk.SendNode.$$new());}));

keywordSend=binarySend._comma(keywordMessage)._eq_eq_gt((function(node){return node.second().valueForReceiver_(node.first());}));

message=binaryMessage._slash(unaryMessage)._slash(keywordMessage);

cascade=keywordSend._slash(binarySend)._comma(ws._comma(unescape("%3B"))._comma(message).plus())._eq_eq_gt((function(node){return node.first().cascadeNodeWithMessages_(node.second().collect_((function(each){return each.third();})));}));

jsStatement=unescape("%7B").asParser()._comma(ws)._comma(string)._comma(ws)._comma(unescape("%7D"))._eq_eq_gt((function(node){return (function($rec){$rec.source_(node.third());return $rec.yourself();})(smalltalk.JSStatementNode.$$new());}));

expression.parser_(assignment._slash(cascade)._slash(keywordSend)._slash(binarySend)._slash(jsStatement));

method=ws._comma(keywordPattern._slash(binaryPattern)._slash(unaryPattern))._comma(ws)._comma(sequence.optional())._comma(ws).withSource()._eq_eq_gt((function(node){return (function($rec){$rec.selector_(node.first().second().first());$rec.arguments_(node.first().second().second());$rec.addNode_(node.first().fourth());$rec.source_(node.second());return $rec.yourself();})(smalltalk.MethodNode.$$new());}));

return method._comma(smalltalk.PPEOFParser.$$new())._eq_eq_gt((function(node){return node.first();}));return self;}

,"parsing",unescape("parser%0D%0A%09%22%20Return%20the%20parser%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20method%20expression%20separator%20comment%20ws%20identifier%20keyword%20globalName%0D%0A%09%20string%20symbol%20number%20literalArray%20variable%20reference%20globalReference%0D%0A%09%20literal%20returnExpression%20methodParser%20expressionParser%20keyword%20unarySelector%0D%0A%09%20binarySelector%20keywordPattern%20unaryPattern%20binaryPattern%20assignment%0D%0A%09%20temps%20blockParamList%20block%20expression%20expressions%20subexpression%0D%0A%09%20statements%20sequence%20operand%20unaryMessage%20unarySend%20unaryTail%0D%0A%09%20binaryMessage%20binarySend%20binaryTail%20keywordMessage%20keywordSend%0D%0A%09%20keywordPair%20cascade%20message%20jsStatement%20jsIndex%0D%0A%09%20character%20directive%20arrayLiteral%0D%0A%09%20binarySelectorChars%20symbolChars%20extendedSymbolChars%0D%0A%09%20stIdentifier%20jsIdentifier%20noReference%20alienReference%0D%0A%09%20primitive%20api%0D%0A%09%7C%0D%0A%09binarySelectorChars%20%3A%3D%20%27%7C%26%5C%5C+*/%3D%3E%3C%2C@%25%7E-%27.%0D%0A%09symbolChars%20%3A%3D%20%27a-zA-Z0-9_%27.%0D%0A%09extendedSymbolChars%20%3A%3D%20symbolChars%20%2C%27%3A%27%20%2C%20binarySelectorChars.%0D%0A%0D%0A%09separator%20%3A%3D%20%28String%20cr%2C%20String%20space%2C%20String%20lf%2C%20String%20tab%29%20asChoiceParser.%0D%0A%09comment%20%3A%3D%20%28%24%22%20asCharacterParser%2C%20%28%24%22%20asParser%20not%2C%20PPAnyParser%20new%29%20star%2C%20%24%22%20asCharacterParser%29%20flatten.%0D%0A%0D%0A%09ws%20%3A%3D%20%28separator%20/%20comment%29%20star.%0D%0A%09%0D%0A%09string%20%3A%3D%20%24%27%20asParser%20%2C%20PPStStringParser%20new%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%7C%20ValueNode%20new%20value%3A%20node%20second%20%5D.%0D%0A%0D%0A%09stIdentifier%20%3A%3D%20%28%27a-z_%27%20asCharacterParser%2C%20symbolChars%20asCharacterParser%20star%29%20flatten.%0D%0A%09jsIdentifier%20%3A%3D%20%28%24%23%20asParser%2C%20symbolChars%20asCharacterParser%20plus%29%20flatten.%0D%0A%09identifier%20%3A%3D%20jsIdentifier%20/%20stIdentifier.%0D%0A%0D%0A%09keyword%20%3A%3D%20%28identifier%2C%20%24%3A%29%20flatten.%0D%0A%0D%0A%09globalName%20%3A%3D%20%28%27A-Z%27%20asCharacterParser%2C%20symbolChars%20asCharacterParser%20star%29%20flatten.%0D%0A%0D%0A%09symbol%20%3A%3D%20%24%23%20asParser%2C%20extendedSymbolChars%20asCharacterParser%20plus%20flatten%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20ValueNode%20new%20value%3A%20node%20second%5D.%0D%0A%0D%0A%09number%20%3A%3D%20%28%27-0-9%27%20asCharacterParser%20plus%0D%0A%09%09%2C%20%28%24.%20asParser%2C%20%270-9%27%20asCharacterParser%20plus%29%20optional%0D%0A%09%09%2C%20%28%24r%20asParser%2C%20%27A-Z0-9%27%20asCharacterParser%20plus%29%20optional%0D%0A%09%09%29%20flatten%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20ValueNode%20new%20value%3A%20node%20asNumber%20%5D.%0D%0A%0D%0A%09character%20%3A%3D%20%24%24%20asParser%2C%20PPAnyParser%20new%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20ValueNode%20new%20value%3A%20%28node%20at%3A%202%29%20%5D.%0D%0A%0D%0A%09directive%20%3A%3D%20self%20directive%3A%20number%20ws%3A%20ws.%0D%0A%0D%0A%09variable%20%3A%3D%20identifier%20%3D%3D%3E%20%5B%3Atoken%20%7C%20VariableNode%20new%20value%3A%20token%20%5D.%0D%0A%09noReference%20%3A%3D%20%24%23%20asParser%20%3D%3D%3E%20%5B%3Atoken%20%7C%20NoReceiverNode%20new%20%5D.%0D%0A%09literal%20%3A%3D%20PPDelegateParser%20new.%0D%0A%09expression%20%3A%3D%20PPDelegateParser%20new.%0D%0A%0D%0A%09arrayLiteral%20%3A%3D%20literal%20/%20variable.%0D%0A%09literalArray%20%3A%3D%20%27%23%28%27%20asParser%2C%20%28ws%2C%20arrayLiteral%2C%20ws%29%20star%2C%20%24%29%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20ValueNode%20new%20value%3A%20%28Array%20withAll%3A%20%28node%20second%20collect%3A%20%5B%3Aeach%20%7C%20each%20second%20value%5D%29%29%20%5D.%0D%0A%0D%0A%09globalReference%20%3A%3D%20globalName%20%3D%3D%3E%20%5B%3Atoken%20%7C%20GlobalReferenceNode%20new%20value%3A%20token%20%5D.%0D%0A%09alienReference%20%3A%3D%20%27%23%7B%27%20asParser%2C%20identifier%2C%20%24%7D%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20AlienNode%20new%20value%3A%20node%20second%20%5D.%0D%0A%0D%0A%09jsIndex%20%3A%3D%20%24%5B%20asParser%2C%20expression%2C%20%24%5D%0D%0A%09%09/%20%28%24%23%20asParser%2C%20identifier%29.%0D%0A%09reference%20%3A%3D%20%28variable%20/%20globalReference%20/%20alienReference%29%20%2C%20jsIndex%20star%0D%0A%09%09%3D%3D%3E%20%5B%3Anodes%20%7C%20nodes%20first%20indexedAs%3A%20nodes%20%5D.%0D%0A%0D%0A%09binarySelector%20%3A%3D%20%28%24%23%20asParser%20optional%2C%20binarySelectorChars%20asCharacterParser%20plus%29%20flatten.%0D%0A%0D%0A%09unarySelector%20%3A%3D%20identifier.%0D%0A%0D%0A%09keywordPattern%20%3A%3D%20%28ws%2C%20keyword%2C%20ws%2C%20identifier%29%20plus%0D%0A%09%09%3D%3D%3E%20%5B%3Anodes%20%7C%20Array%0D%0A%09%09%09with%3A%20%28%28nodes%20collect%3A%20%5B%3Aeach%20%7C%20each%20at%3A%202%5D%29%20join%3A%20%27%27%29%0D%0A%09%09%09with%3A%20%28nodes%20collect%3A%20%5B%3Aeach%20%7C%20each%20at%3A%204%5D%29%20%5D.%0D%0A%0D%0A%09binaryPattern%20%3A%3D%20ws%2C%20binarySelector%2C%20ws%2C%20identifier%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20Array%20with%3A%20node%20second%20with%3A%20%28Array%20with%3A%20node%20fourth%29%5D.%0D%0A%0D%0A%09unaryPattern%20%3A%3D%20ws%2C%20unarySelector%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20Array%20with%3A%20node%20second%20with%3A%20Array%20new%5D.%0D%0A%09%0D%0A%09expressions%20%3A%3D%20expression%2C%20%28%28ws%2C%20%24.%2C%20ws%2C%20expression%29%20%3D%3D%3E%20%5B%3Anode%20%7C%20node%20fourth%5D%29%20star%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%7C%20result%20%7C%0D%0A%09%09%20%20%20%20result%20%3A%3D%20Array%20with%3A%20node%20first.%0D%0A%09%09%20%20%20%20node%20second%20do%3A%20%5B%3Aeach%20%7C%20result%20add%3A%20each%20%5D.%0D%0A%09%09%20%20%20%20result%20%5D.%0D%0A%0D%0A%09assignment%20%3A%3D%20reference%2C%20ws%2C%20%27%3A%3D%27%2C%20ws%2C%20expression%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20AssignmentNode%20new%20left%3A%20node%20first%3B%20right%3A%20%28node%20at%3A%205%29%5D.%0D%0A%0D%0A%09returnExpression%20%3A%3D%20%24%5E%20asParser%2C%20ws%2C%20expression%2C%20ws%2C%20%24.%20asParser%20optional%0D%0A%09%20%20%20%20%3D%3D%3E%20%5B%3Anode%20%7C%20ReturnNode%20new%20addNode%3A%20node%20third%3B%20yourself%20%5D.%0D%0A%0D%0A%09temps%20%3A%3D%20%24%7C%20asParser%2C%20%28ws%2C%20identifier%29%20star%2C%20ws%2C%20%24%7C%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20second%20collect%3A%20%5B%3Aeach%20%7C%20each%20second%20%5D%20%5D.%0D%0A%0D%0A%09blockParamList%20%3A%3D%20%28%24%3A%20asParser%2C%20ws%2C%20identifier%2C%20ws%29%20plus%2C%20%24%7C%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20first%20collect%3A%20%5B%3Aeach%20%7C%20each%20third%20%5D%20%5D.%0D%0A%0D%0A%09subexpression%20%3A%3D%20%24%28%20asParser%2C%20ws%2C%20expression%2C%20ws%2C%20%24%29%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20third%20%5D.%0D%0A%0D%0A%09statements%20%3A%3D%20%28returnExpression%20%3D%3D%3E%20%5B%3Anode%20%7C%20Array%20with%3A%20node%5D%29%0D%0A%09%09/%20%28expressions%2C%20ws%2C%20%24.%2C%20ws%2C%20returnExpression%20%3D%3D%3E%20%5B%3Anode%20%7C%20node%20first%20add%3A%20%28node%20at%3A%205%29%3B%20yourself%20%5D%29%0D%0A%09%09/%20%28expressions%20%2C%20%24.%20asParser%20optional%20%3D%3D%3E%20%5B%3Anode%20%7C%20node%20first%20%5D%29.%0D%0A%0D%0A%09sequence%20%3A%3D%20temps%20optional%2C%20ws%2C%20directive%20optional%2C%20ws%2C%20statements%20optional%2C%20ws%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20ExtendedSequenceNode%20new%0D%0A%09%09%09directive%3A%20node%20third%3B%0D%0A%09%09%09temps%3A%20node%20first%3B%0D%0A%09%09%09nodes%3A%20%28node%20at%3A%205%29%3B%0D%0A%09%09%09yourself%20%5D.%0D%0A%0D%0A%09block%20%3A%3D%20%24%5B%20asParser%2C%20ws%2C%20blockParamList%20optional%2C%20ws%2C%20sequence%20optional%2C%20ws%2C%20%24%5D%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%0D%0A%09%09%20%20%20%20BlockNode%20new%0D%0A%09%09%09parameters%3A%20node%20third%3B%0D%0A%09%09%09addNode%3A%20%28node%20at%3A%205%29%20asBlockSequenceNode%20%5D.%0D%0A%0D%0A%09operand%20%3A%3D%20literal%20/%20reference%20/%20noReference%20/%20subexpression.%0D%0A%0D%0A%09literal%20parser%3A%20character%20/%20number%20/%20string%20/%20literalArray%20/%20symbol%20/%20block.%0D%0A%0D%0A%09unaryMessage%20%3A%3D%20ws%2C%20unarySelector%2C%20%24%3A%20asParser%20not%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20SendNode%20new%20selector%3A%20node%20second%20%5D.%0D%0A%0D%0A%09unaryTail%20%3A%3D%20PPDelegateParser%20new.%0D%0A%09unaryTail%20parser%3A%20%28unaryMessage%2C%20unaryTail%20optional%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20second%20isNil%20ifTrue%3A%20%5B%20node%20first%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20node%20second%20valueForReceiver%3A%20node%20first%20%5D%20%5D%29.%0D%0A%0D%0A%09unarySend%20%3A%3D%20operand%2C%20unaryTail%20optional%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20second%20isNil%20ifTrue%3A%20%5B%20node%20first%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20node%20second%20valueForReceiver%3A%20node%20first%20%5D%20%5D.%0D%0A%0D%0A%09binaryMessage%20%3A%3D%20ws%2C%20binarySelector%2C%20ws%2C%20%28unarySend%20/%20operand%29%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20SendNode%20new%0D%0A%09%09%09selector%3A%20node%20second%3B%0D%0A%09%09%09arguments%3A%20%28Array%20with%3A%20node%20fourth%29%20%5D.%0D%0A%0D%0A%09binaryTail%20%3A%3D%20PPDelegateParser%20new.%0D%0A%09binaryTail%20parser%3A%20%28binaryMessage%2C%20binaryTail%20optional%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20second%20isNil%20ifTrue%3A%20%5B%20node%20first%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20node%20second%20valueForReceiver%3A%20node%20first%20%5D%20%5D%29.%0D%0A%0D%0A%09binarySend%20%3A%3D%20unarySend%2C%20binaryTail%20optional%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20second%20isNil%20ifTrue%3A%20%5B%20node%20first%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20node%20second%20valueForReceiver%3A%20node%20first%20%5D%20%5D.%0D%0A%0D%0A%09keywordPair%20%3A%3D%20keyword%2C%20ws%2C%20binarySend.%0D%0A%0D%0A%09keywordMessage%20%3A%3D%20%28ws%2C%20keywordPair%29%20plus%0D%0A%09%09%3D%3D%3E%20%5B%3Anodes%20%7C%20SendNode%20new%0D%0A%09%09%09selector%3A%20%28%28nodes%20collect%3A%20%5B%3Aeach%20%7C%20each%20second%20first%5D%29%20join%3A%20%27%27%29%3B%0D%0A%09%09%09arguments%3A%20%28nodes%20collect%3A%20%5B%3Aeach%20%7C%20each%20second%20third%5D%29%5D.%0D%0A%0D%0A%09keywordSend%20%3A%3D%20binarySend%2C%20keywordMessage%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20second%20valueForReceiver%3A%20node%20first%5D.%0D%0A%0D%0A%09message%20%3A%3D%20binaryMessage%20/%20unaryMessage%20/%20keywordMessage.%0D%0A%0D%0A%09cascade%20%3A%3D%20%28keywordSend%20/%20binarySend%29%2C%20%28ws%2C%20%24%3B%2C%20message%29%20plus%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20node%20first%20cascadeNodeWithMessages%3A%20%0D%0A%09%09%09%28node%20second%20collect%3A%20%5B%3Aeach%20%7C%20each%20third%20%5D%29%5D.%0D%0A%0D%0A%09jsStatement%20%3A%3D%20%24%7B%20asParser%2C%20ws%2C%20string%2C%20ws%2C%20%24%7D%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20JSStatementNode%20new%20source%3A%20node%20third%3B%20yourself%20%5D.%0D%0A%0D%0A%09expression%20parser%3A%20assignment%20/%20cascade%20/%20keywordSend%20/%20binarySend%20/%20jsStatement.%0D%0A%0D%0A%09method%20%3A%3D%20%28ws%2C%20%28keywordPattern%20/%20binaryPattern%20/%20unaryPattern%29%2C%20ws%2C%20sequence%20optional%2C%20ws%29%20withSource%0D%0A%09%09%3D%3D%3E%20%5B%3Anode%20%7C%20MethodNode%20new%0D%0A%09%09%09selector%3A%20node%20first%20second%20first%3B%0D%0A%09%09%09arguments%3A%20node%20first%20second%20second%3B%0D%0A%09%09%09addNode%3A%20node%20first%20fourth%3B%0D%0A%09%09%09source%3A%20node%20second%3B%0D%0A%09%09%09yourself%20%5D.%0D%0A%09%0D%0A%09%5Emethod%2C%20PPEOFParser%20new%20%3D%3D%3E%20%5B%3Anode%20%7C%20node%20first%20%5D"));

smalltalk.bind(smalltalk.FileInReader,"scanFrom:","scanFrom_"

,function (aStream){var self=this;return self.implementedBySubclass();return self;}

,"fileIn",unescape("scanFrom%3A%20aStream%0D%0A%09%22%20FileIn%20-%20Return%20the%20result%20of%20evaluating%20the%20next%20chunk%20of%20data%20from%20aStream.%0D%0A%09The%20method%20must%20be%20implemented%20by%20chunk%20readers%20to%20support%20custom%20fileIn%20features.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20implementedBySubclass"));

smalltalk.bind(smalltalk.Exporter.$klass,"exportCategory:","exportCategory_"

,function (aString){var self=this;return self.$$new().exportCategory_(aString);return self;}

,"fileOut",unescape("exportCategory%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20all%20the%20classes%20in%20category%20aString.%20%22%0D%0A%0D%0A%09%5Eself%20new%20exportCategory%3A%20aString"));

smalltalk.bind(smalltalk.Exporter.$klass,"fileOutCategory:","fileOutCategory_"

,function (aString){var self=this;return self.$$new().fileOutCategory_(aString);return self;}

,"fileOut",unescape("fileOutCategory%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20fileOut%20all%20the%20classes%20in%20category%20aString.%20%22%0D%0A%0D%0A%09%5Eself%20new%20fileOutCategory%3A%20aString"));

smalltalk.bind(smalltalk.Exporter.$klass,"fileOutAll:","fileOutAll_"

,function (classes){var self=this;return self.$$new().fileOutAll_(classes);return self;}

,"fileOut",unescape("fileOutAll%3A%20classes%0D%0A%09%22%20Return%20the%20result%20of%20fileOut%20classes.%20%22%0D%0A%0D%0A%09%5Eself%20new%20fileOutAll%3A%20classes"));

smalltalk.bind(smalltalk.Exporter.$klass,"fileOutAll","fileOutAll"

,function (){var self=this;return self.fileOutAll_(self.allClasses());return self;}

,"fileOut",unescape("fileOutAll%0D%0A%09%22%20Return%20the%20result%20of%20fileOut%20of%20all%20classes%20in%20the%20system.%20%22%0D%0A%0D%0A%09%5Eself%20fileOutAll%3A%20self%20allClasses"));

smalltalk.bind(smalltalk.Exporter.$klass,"allClasses","allClasses"

,function (){var self=this;return smalltalk.Smalltalk.current().rootClasses().inject_into_(smalltalk.Array.$$new(), (function(total, each){return total._comma(each.withAllSubclasses());}));return self;}

,"private",unescape("allClasses%0D%0A%09%22%20Private%20-%20Return%20all%20the%20classes%20in%20the%20system%20%28in%20fileIn%20order%29.%20%22%0D%0A%0D%0A%09%5ESmalltalk%20current%20rootClasses%0D%0A%09%09inject%3A%20Array%20new%0D%0A%09%09into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%20%2C%20each%20withAllSubclasses%20%5D"));

smalltalk.bind(smalltalk.Exporter,"matchCategory:","matchCategory_"

,function (aString){var self=this;return self.matchCategory_from_(aString, smalltalk.Smalltalk.current().rootClasses());return self;}

,"categories",unescape("matchCategory%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20filtering%20all%20the%20classes%20%28and%20orphan%20methods%29%20in%20category%20aString.%20%22%0D%0A%0D%0A%09%5Eself%20matchCategory%3A%20aString%20from%3A%20Smalltalk%20current%20rootClasses"));

smalltalk.bind(smalltalk.Exporter,"matchCategory:from:","matchCategory_from_"

,function (aString,rootClasses){var self=this;var selection=nil;var selected=nil;var rejected=nil;var orphanMethods=nil;selected=smalltalk.Array.$$new();

rejected=smalltalk.Array.$$new();

orphanMethods=smalltalk.Array.$$new();

selection=((aString.includes_(unescape("-"))).mustBeBoolean()==true ? (function(){return (function(each){return each.category().asString().match_(aString);});})() : (function(){return (function(each){return each.category().asString().upTo_(unescape("-")).match_(aString);});})());

rootClasses.do_((function(root){return root.instanceClass().withAllSubclasses().do_((function(each){return ((selection.value_(each)).mustBeBoolean()==true ? (function(){return selected;})() : (function(){return rejected;})()).add_(each);}));}));

fileOutMethods=(function(cls){return cls.methodsDo_((function(aMethod){return ((selection.value_(aMethod)).mustBeBoolean()==true ? (function(){return orphanMethods.add_(aMethod);})() : nil);}));});

rejected.do_((function(each){return (function($rec){$rec.value_(each);return $rec.value_(each.$klass);})(fileOutMethods);}));

return smalltalk.Array.with_with_with_(selected, rejected, orphanMethods);return self;}

,"categories",unescape("matchCategory%3A%20aString%20from%3A%20rootClasses%0D%0A%09%22%20Return%20the%20result%20of%20filtering%20all%20the%20classes%20%28and%20orphan%20methods%29%20in%20category%20aString.%20%22%0D%0A%0D%0A%09%7C%20selection%20selected%20rejected%20orphanMethods%20%7C%0D%0A%09selected%20%3A%3D%20Array%20new.%0D%0A%09rejected%20%3A%3D%20Array%20new.%0D%0A%09orphanMethods%20%3A%3D%20Array%20new.%0D%0A%09selection%20%3A%3D%20%28aString%20includes%3A%20%24-%29%0D%0A%09%09ifTrue%3A%20%5B%20%5B%3Aeach%7C%20each%20category%20asString%20match%3A%20aString%20%5D%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20%5B%3Aeach%7C%20%28each%20category%20asString%20upTo%3A%20%24-%29%20match%3A%20aString%20%5D%20%5D.%0D%0A%09rootClasses%20do%3A%20%5B%3Aroot%7C%0D%0A%09%09root%20instanceClass%20withAllSubclasses%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09%09%28%28selection%20value%3A%20each%29%0D%0A%09%09%09%09ifTrue%3A%20%5B%20selected%20%5D%20ifFalse%3A%20%5B%20rejected%20%5D%29%0D%0A%09%09%09%09add%3A%20each%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09fileOutMethods%20%3A%3D%20%5B%3Acls%7C%0D%0A%09%09cls%20methodsDo%3A%20%5B%3AaMethod%20%7C%0D%0A%09%09%09%28selection%20value%3A%20aMethod%29%20ifTrue%3A%20%5B%20orphanMethods%20add%3A%20aMethod%20%5D%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09rejected%20do%3A%20%5B%3Aeach%7C%20fileOutMethods%20value%3A%20each%3B%20value%3A%20each%20class%20%5D.%0D%0A%09%5EArray%20with%3A%20selected%20with%3A%20rejected%20with%3A%20orphanMethods"));

smalltalk.bind(smalltalk.Exporter,"fileOutCategory:","fileOutCategory_"

,function (aString){var self=this;var stream=nil;var match=nil;stream="".writeStream();

match=self.matchCategory_(aString);

self.fileOutAll_on_(match.first(), stream);

match.last().do_((function(aMethod){return self.fileOutMethod_of_on_(aMethod, aMethod.classField(), stream);}));

return stream.contents();return self;}

,"fileOut",unescape("fileOutCategory%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20fileOut%20all%20the%20classes%20in%20category%20aString.%20%22%0D%0A%0D%0A%09%7C%20stream%20match%20%7C%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09match%20%3A%3D%20self%20matchCategory%3A%20aString.%0D%0A%09self%20fileOutAll%3A%20match%20first%20on%3A%20stream.%0D%0A%09match%20last%20do%3A%20%5B%3AaMethod%20%7C%0D%0A%09%09self%20fileOutMethod%3A%20aMethod%20of%3A%20aMethod%20classField%20on%3A%20stream%0D%0A%09%5D.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"fileOut:","fileOut_"

,function (aClass){var self=this;var stream=nil;stream="".writeStream();

self.fileOut_on_(aClass, stream);

return stream.contents();return self;}

,"fileOut",unescape("fileOut%3A%20aClass%0D%0A%09%22%20Return%20fileOut%20definition%20and%20code%20of%20a%20class.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09self%20fileOut%3A%20aClass%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"fileOutClass:","fileOutClass_"

,function (aClass){var self=this;return self.fileOut_(aClass);return self;}

,"fileOut",unescape("fileOutClass%3A%20aClass%0D%0A%09%22%20Return%20fileOut%20definition%20and%20code%20of%20a%20class.%20%22%0D%0A%0D%0A%09%5Eself%20fileOut%3A%20aClass"));

smalltalk.bind(smalltalk.Exporter,"fileOutAll:","fileOutAll_"

,function (classes){var self=this;var stream=nil;stream="".writeStream();

self.fileOutAll_on_(aClass, stream);

return stream.contents();return self;}

,"fileOut",unescape("fileOutAll%3A%20classes%0D%0A%09%22%20Return%20fileOut%20definition%20and%20code%20of%20classes.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09self%20fileOutAll%3A%20aClass%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"fileOutMethod:of:","fileOutMethod_of_"

,function (aMethod,aClass){var self=this;var stream=nil;stream="".writeStream();

self.fileOutMethod_of_on_(aMethod, aClass, stream);

return stream.contents();return self;}

,"fileOut",unescape("fileOutMethod%3A%20aMethod%20of%3A%20aClass%0D%0A%09%22%20Return%20fileOut%20method%20of%20a%20class.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09self%20fileOutMethod%3A%20aMethod%20of%3A%20aClass%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"fileOutAll:on:","fileOutAll_on_"

,function (classes,stream){var self=this;classes.do_((function(aClass){self.fileOutDefinitionOf_on_(aClass, stream);return self.fileOutDefinitionOf_on_(aClass.$klass, stream);}));

stream.cr();

classes.do_((function(aClass){self.fileOutMethodsOf_on_(aClass.$klass, stream);return self.fileOutMethodsOf_on_(aClass, stream);}));return self;}

,"fileOut",unescape("fileOutAll%3A%20classes%20on%3A%20stream%0D%0A%09%22%20FileOut%20definition%20and%20code%20of%20classes%20onto%20stream.%20%22%0D%0A%0D%0A%09classes%20do%3A%20%5B%3AaClass%7C%0D%0A%09%09self%20fileOutDefinitionOf%3A%20aClass%20on%3A%20stream.%0D%0A%09%09self%20fileOutDefinitionOf%3A%20aClass%20class%20on%3A%20stream%0D%0A%09%5D.%09stream%20cr.%0D%0A%09classes%20do%3A%20%5B%3AaClass%7C%0D%0A%09%09self%20fileOutMethodsOf%3A%20aClass%20class%20on%3A%20stream.%0D%0A%09%09self%20fileOutMethodsOf%3A%20aClass%20on%3A%20stream.%0D%0A%09%5D."));

smalltalk.bind(smalltalk.Exporter,"fileOutDefinitionOf:","fileOutDefinitionOf_"

,function (aClass){var self=this;var stream=nil;stream="".writeStream();

self.fileOutDefinitionOf_on_(aClass.instanceClass(), stream);

self.fileOutDefinitionOf_on_(aClass.instanceClass().$klass, stream);

return stream.contents();return self;}

,"fileOut",unescape("fileOutDefinitionOf%3A%20aClass%0D%0A%09%22%20Return%20the%20definition%20of%20a%20class.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09self%20fileOutDefinitionOf%3A%20aClass%20instanceClass%20on%3A%20stream.%0D%0A%09self%20fileOutDefinitionOf%3A%20aClass%20instanceClass%20class%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"fileOut:on:","fileOut_on_"

,function (aClass,stream){var self=this;self.fileOutAll_on_(smalltalk.Array.with_(aClass), stream);return self;}

,"fileOut",unescape("fileOut%3A%20aClass%20on%3A%20stream%0D%0A%09%22%20FileOut%20definition%20and%20code%20of%20a%20class%20onto%20stream.%20%22%0D%0A%0D%0A%09self%20fileOutAll%3A%20%28Array%20with%3A%20aClass%29%20on%3A%20stream."));

smalltalk.bind(smalltalk.Exporter,"fileOutDefinitionOf:on:","fileOutDefinitionOf_on_"

,function (aClass,stream){var self=this;try{((aClass.isMetaclass()).mustBeBoolean()==true ? (function(){((self.fileOutStrings_of_on_("instanceVariableNames", aClass, stream)).mustBeBoolean()==true ? (function(){return (function($rec){$rec.nextChunkPut_("");return $rec.cr();})(stream);})() : nil);((self.fileOutArray_of_on_("propertyNames", aClass, stream)).mustBeBoolean()==true ? (function(){return (function($rec){$rec.nextChunkPut_("");return $rec.cr();})(stream);})() : nil);return (function(){throw({name: "stReturn", selector: "fileOutDefinitionOf_on_", fn: function(){return self}})})();})() : nil);

(function($rec){$rec.nextPutAll_(aClass.superclass().asString());$rec.cr();$rec.tab();return $rec.nextPutAll_(unescape("subclass%3A%20%23"));})(stream);

((self.fileOutStrings_of_on_("instanceVariableNames", aClass, stream)).mustBeBoolean()==true ? nil : (function(){return (function($rec){$rec.nextPutAll_(aClass.name());$rec.cr();$rec.tab();$rec.nextPutAll_("instanceVariableNames: ");return $rec.nextPutAll_("".printString());})(stream);})());

((((aClass.classVariables() || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function($rec){$rec.cr();$rec.tab();$rec.nextPutAll_("classVariableNames: ");return $rec.nextPutAll_(aClass.classVariablesString().printString());})(stream);})() : nil);

((((aClass.poolDictionaries() || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function($rec){$rec.cr();$rec.tab();$rec.nextPutAll_("poolDictionaries: ");return $rec.nextPutAll_(aClass.poolDictionariesString().printString());})(stream);})() : nil);

(function($rec){$rec.cr();$rec.tab();$rec.nextPutAll_("category: ");return $rec.nextPutAll_(aClass.category().asLiteral());})(stream);

(function($rec){$rec.nextChunkPut_("");return $rec.cr();})(stream);

((self.fileOutArray_of_on_("propertyNames", aClass, stream)).mustBeBoolean()==true ? (function(){return (function($rec){$rec.nextChunkPut_("");return $rec.cr();})(stream);})() : nil);

((aClass.comment().notEmpty()).mustBeBoolean()==true ? (function(){stream.nextPutAll_(aClass.name()._comma(" comment: ")._comma(aClass.comment().printString()));return (function($rec){$rec.nextChunkPut_("");return $rec.cr();})(stream);})() : nil);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "fileOutDefinitionOf_on_"){return $$ex.fn();} throw($$ex);}}

,"fileOut",unescape("fileOutDefinitionOf%3A%20aClass%20on%3A%20stream%0D%0A%09%22%20FileOut%20definition%20of%20a%20class%20onto%20stream.%20%22%0D%0A%0D%0A%09aClass%20isMetaclass%20ifTrue%3A%20%5B%0D%0A%09%09%28self%20fileOutStrings%3A%20%23instanceVariableNames%20of%3A%20aClass%20on%3A%20stream%29%20ifTrue%3A%20%5B%0D%0A%09%09%09stream%20nextChunkPut%3A%20%27%27%3Bcr.%0D%0A%09%09%5D.%0D%0A%09%09%28self%20fileOutArray%3A%20%23propertyNames%20of%3A%20aClass%20on%3A%20stream%29%20ifTrue%3A%20%5B%0D%0A%09%09%09stream%20nextChunkPut%3A%20%27%27%3Bcr.%0D%0A%09%09%5D.%0D%0A%09%09%5Eself%0D%0A%09%5D.%0D%0A%0D%0A%09stream%0D%0A%09%09nextPutAll%3A%20aClass%20superclass%20asString%3B%20cr%3Btab%3B%0D%0A%09%09nextPutAll%3A%20%27subclass%3A%20%23%27.%0D%0A%09%28self%20fileOutStrings%3A%20%23instanceVariableNames%20of%3A%20aClass%20on%3A%20stream%29%20ifFalse%3A%20%5B%0D%0A%09%09stream%0D%0A%09%09%09nextPutAll%3A%20aClass%20name%3B%20cr%3Btab%3B%0D%0A%09%09%09nextPutAll%3A%20%27instanceVariableNames%3A%20%27%3B%0D%0A%09%09%09nextPutAll%3A%20%27%27%20printString%0D%0A%09%5D.%0D%0A%09aClass%20classVariables%20notNil%20ifTrue%3A%20%5B%0D%0A%09%20%20%20%20stream%09%20cr%3Btab%3B%0D%0A%09%09nextPutAll%3A%20%27classVariableNames%3A%20%27%3B%0D%0A%09%09nextPutAll%3A%20aClass%20classVariablesString%20printString%0D%0A%09%5D.%0D%0A%09aClass%20poolDictionaries%20notNil%20ifTrue%3A%20%5B%0D%0A%09%20%20%20%20stream%09%20cr%3Btab%3B%0D%0A%09%09nextPutAll%3A%20%27poolDictionaries%3A%20%27%3B%0D%0A%09%09nextPutAll%3A%20aClass%20poolDictionariesString%20printString%0D%0A%09%5D.%0D%0A%09stream%20cr%3Btab%3B%0D%0A%09%09nextPutAll%3A%20%27category%3A%20%27%3B%0D%0A%09%09nextPutAll%3A%20aClass%20category%20asLiteral.%0D%0A%09stream%20nextChunkPut%3A%20%27%27%3Bcr.%0D%0A%09%28self%20fileOutArray%3A%20%23propertyNames%20of%3A%20aClass%20on%3A%20stream%29%20ifTrue%3A%20%5B%0D%0A%09%09stream%20nextChunkPut%3A%20%27%27%3Bcr.%0D%0A%09%5D.%0D%0A%09aClass%20comment%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%09stream%20nextPutAll%3A%20aClass%20name%2C%27%20comment%3A%20%27%2C%20aClass%20comment%20printString.%0D%0A%09%09stream%20nextChunkPut%3A%20%27%27%3Bcr.%0D%0A%09%5D."));

smalltalk.bind(smalltalk.Exporter,"fileOutStrings:of:on:","fileOutStrings_of_on_"

,function (selector,aClass,stream){var self=this;try{var strings=nil;strings=aClass.perform_(selector);

((strings.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "fileOutStrings_of_on_", fn: function(){return false}})})();})() : nil);

(function($rec){$rec.nextPutAll_(aClass.name());$rec.cr();$rec.tab();return $rec.nextPutAll_(selector._comma(unescape("%3A%20%27")));})(stream);

strings.do_((function(each){return stream.nextPutAll_(" "._comma(each));}));

stream.nextPutAll_(unescape("%20%27"));

(function(){throw({name: "stReturn", selector: "fileOutStrings_of_on_", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "fileOutStrings_of_on_"){return $$ex.fn();} throw($$ex);}}

,"fileOut",unescape("fileOutStrings%3A%20selector%20of%3A%20aClass%20on%3A%20stream%0D%0A%09%22%20Private%20-%20FileOut%20selector%20strings%20of%20a%20class%20onto%20stream.%0D%0A%09Return%20true%20if%20code%20has%20been%20filedOut.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20strings%20%7C%0D%0A%09strings%20%3A%3D%20aClass%20perform%3A%20selector.%0D%0A%09strings%20isEmpty%20ifTrue%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09stream%0D%0A%09%09nextPutAll%3A%20aClass%20name%3B%20cr%3Btab%3B%0D%0A%09%09nextPutAll%3A%20selector%2C%27%3A%20%27%27%27.%0D%0A%09strings%20do%3A%20%5B%3Aeach%7C%20stream%20nextPutAll%3A%20%27%20%27%2Ceach%20%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%20%27%27%27.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Exporter,"fileOutArray:of:on:","fileOutArray_of_on_"

,function (selector,aClass,stream){var self=this;try{var strings=nil;strings=aClass.perform_(selector);

((strings.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "fileOutArray_of_on_", fn: function(){return false}})})();})() : nil);

(function($rec){$rec.nextPutAll_(aClass.name());return $rec.nextPutAll_do_(" "._comma(selector)._comma(unescape("%3A%20%23%28").strings()), (function(each){return stream.nextPutAll_(" "._comma(each.printString()));}));})(stream);

stream.nextPutAll_(unescape("%29"));

(function(){throw({name: "stReturn", selector: "fileOutArray_of_on_", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "fileOutArray_of_on_"){return $$ex.fn();} throw($$ex);}}

,"fileOut",unescape("fileOutArray%3A%20selector%20of%3A%20aClass%20on%3A%20stream%0D%0A%09%22%20Private%20-%20FileOut%20selector%20arrayed%20strings%20of%20a%20class%20onto%20stream.%0D%0A%09Return%20true%20if%20code%20has%20been%20filedOut.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20strings%20%7C%0D%0A%09strings%20%3A%3D%20aClass%20perform%3A%20selector.%0D%0A%09strings%20isEmpty%20ifTrue%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09stream%0D%0A%09%09nextPutAll%3A%20aClass%20name%3B%0D%0A%09%09nextPutAll%3A%20%27%20%27%2Cselector%2C%27%3A%20%23%28%27%0D%0A%09strings%20do%3A%20%5B%3Aeach%7C%20stream%20nextPutAll%3A%20%27%20%27%2Ceach%20printString%20%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%29%27.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Exporter,"fileOutMethodsOf:on:","fileOutMethodsOf_on_"

,function (aClass,stream){var self=this;try{var selectors=nil;selectors=aClass.selectors();

((selectors.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "fileOutMethodsOf_on_", fn: function(){return self}})})();})() : nil);

stream.cr();

selectors.sorted().do_((function(each){return self.fileOutMethod_of_on_(aClass.compiledMethodAt_(each), aClass, stream);}));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "fileOutMethodsOf_on_"){return $$ex.fn();} throw($$ex);}}

,"fileOut",unescape("fileOutMethodsOf%3A%20aClass%20on%3A%20stream%0D%0A%09%22%20FileOut%20methods%20of%20a%20class%20onto%20stream.%20%22%0D%0A%0D%0A%09%7C%20selectors%20%7C%0D%0A%09selectors%20%3A%3D%20aClass%20selectors.%0D%0A%09selectors%20isEmpty%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09stream%20cr.%0D%0A%09selectors%20sorted%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09self%0D%0A%09%09%09fileOutMethod%3A%20%28aClass%20compiledMethodAt%3A%20each%29%0D%0A%09%09%09of%3A%20aClass%20on%3A%20stream%0D%0A%09%5D."));

smalltalk.bind(smalltalk.Exporter,"isASymbol:","isASymbol_"

,function (aString){var self=this;return ((smalltalk.RegularExpression.fromString_(unescape("%5B%5Ea-zA-Z0-9_%3A%5D")).exec_(aString) || nil) === nil);return self;}

,"private",unescape("isASymbol%3A%20aString%0D%0A%09%22%20Private%20-%20Return%20true%20if%20aString%20can%20be%20output%20with%20symbol%20notation.%20%22%0D%0A%0D%0A%09%5E%28%28RegularExpression%20fromString%3A%20%27%5B%5Ea-zA-Z0-9_%3A%5D%27%29%20exec%3A%20aString%29%20isNil"));

smalltalk.bind(smalltalk.Exporter,"fileOutMethod:","fileOutMethod_"

,function (aMethod){var self=this;var stream=nil;stream="".writeStream();

self.fileOutMethod_of_on_(aMethod, aMethod.classField(), stream);

return stream.contents();return self;}

,"fileOut",unescape("fileOutMethod%3A%20aMethod%0D%0A%09%22%20Return%20the%20fileOut%20of%20aMethod.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09self%20fileOutMethod%3A%20aMethod%20of%3A%20aMethod%20classField%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"fileOutMethod:of:on:","fileOutMethod_of_on_"

,function (aMethod,aClass,stream){var self=this;(function($rec){$rec.cr();$rec.nextChunkPut_("");$rec.nextChunkPut_(" "._comma(aClass.name())._comma(" methodsFor: ")._comma(aMethod.category().asLiteral())._comma(" "));$rec.cr();$rec.nextChunkPut_(aMethod.source());$rec.nextChunkPut_(" ");return $rec.cr();})(stream);return self;}

,"fileOut",unescape("fileOutMethod%3A%20aMethod%20of%3A%20aClass%20on%3A%20stream%0D%0A%09%22%20FileOut%20method%20of%20a%20class%20onto%20stream.%20%22%0D%0A%0D%0A%09stream%0D%0A%09%09cr%3BnextChunkPut%3A%20%27%27%3B%0D%0A%09%09nextChunkPut%3A%20%27%20%27%2C%20aClass%20name%2C%20%27%20methodsFor%3A%20%27%2C%20aMethod%20category%20asLiteral%20%2C%27%20%27%3B%20cr%3B%0D%0A%09%09nextChunkPut%3A%20aMethod%20source%3B%0D%0A%09%09nextChunkPut%3A%20%27%20%27%3Bcr"));

smalltalk.bind(smalltalk.Exporter,"exportCategory:","exportCategory_"

,function (aString){var self=this;var stream=nil;var match=nil;stream="".writeStream();

match=self.matchCategory_(aString);

match.first().do_((function(each){return stream.nextPutAll_(self.export_(each));}));

match.last().do_((function(aMethod){return self.export_method_on_(aMethod.classField(), aMethod, stream);}));

return stream.contents();return self;}

,"fileOut",unescape("exportCategory%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20all%20the%20classes%20in%20category%20aString.%20%22%0D%0A%0D%0A%09%7C%20stream%20match%20%7C%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09match%20%3A%3D%20self%20matchCategory%3A%20aString.%0D%0A%09match%20first%20do%3A%20%5B%3Aeach%7C%20stream%20nextPutAll%3A%20%28self%20export%3A%20each%29%20%5D.%0D%0A%09match%20last%20do%3A%20%5B%3AaMethod%20%7C%0D%0A%09%09self%20export%3A%20aMethod%20classField%20method%3A%20aMethod%20on%3A%20stream%0D%0A%09%5D.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"export:","export_"

,function (aClass){var self=this;var stream=nil;stream="".writeStream();

self.exportDefinitionOf_on_(aClass, stream);

self.exportMetaDefinitionOf_on_(aClass, stream);

self.exportMethodsOf_on_(aClass, stream);

self.exportMethodsOf_on_(aClass.$klass, stream);

return stream.contents();return self;}

,"fileOut",unescape("export%3A%20aClass%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20definition%20and%20source%20code%20of%20a%20class.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09self%20exportDefinitionOf%3A%20aClass%20on%3A%20stream.%0D%0A%09self%20exportMetaDefinitionOf%3A%20aClass%20on%3A%20stream.%0D%0A%09self%20exportMethodsOf%3A%20aClass%20on%3A%20stream.%0D%0A%09self%20exportMethodsOf%3A%20aClass%20class%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"defaultRequirementsFor:","defaultRequirementsFor_"

,function (aClass){var self=this;try{var constructorName=nil;var code=nil;constructorName=aClass.constructorName();

((((constructorName || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "defaultRequirementsFor_", fn: function(){return []}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "defaultRequirementsFor_", fn: function(){return smalltalk.Array.with_(unescape("if%28")._comma(constructorName)._comma(unescape("%20%26%26%20%21"))._comma(self.smalltalkNameFor_(aClass))._comma(unescape("%29%20smalltalk.mapClassName%28%22"))._comma(aClass.name())._comma(unescape("%22%2C%22"))._comma(aClass.category())._comma(unescape("%22%2C"))._comma(constructorName)._comma(unescape("%2C"))._comma(self.smalltalkNameFor_(aClass.superclass()))._comma(unescape("%29%3B")))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "defaultRequirementsFor_"){return $$ex.fn();} throw($$ex);}}

,"requirements",unescape("defaultRequirementsFor%3A%20aClass%0D%0A%09%22%20Private%20-%20Return%20the%20default%20requirements%20to%20load%20aClass.%0D%0A%09Detect%20native%20bindings%20and%20generate%20code%20to%20rebind%20before%20class%20definition.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20constructorName%20code%20%7C%0D%0A%09constructorName%20%3A%3D%20aClass%20constructorName.%0D%0A%09constructorName%20isNil%20ifTrue%3A%20%5B%20%5E%23%28%29%20%5D.%0D%0A%09%5EArray%20with%3A%0D%0A%09%09%27if%28%27%2CconstructorName%2C%27%20%26%26%20%21%27%0D%0A%09%09%2C%20%28self%20smalltalkNameFor%3A%20aClass%29%0D%0A%09%09%2C%27%29%20smalltalk.mapClassName%28%22%27%0D%0A%09%09%2CaClass%20name%20%2C%27%22%2C%22%27%0D%0A%09%09%2CaClass%20category%2C%20%27%22%2C%27%0D%0A%09%09%2CconstructorName%2C%20%27%2C%27%0D%0A%09%09%2C%28self%20smalltalkNameFor%3A%20aClass%20superclass%29%0D%0A%09%09%2C%27%29%3B%27"));

smalltalk.bind(smalltalk.Exporter,"loadRequirementsOf:","loadRequirementsOf_"

,function (aClass){var self=this;var requirements=nil;requirements=self.defaultRequirementsFor_(aClass);

aClass.loadRequirementsInto_(requirements);

return requirements;return self;}

,"requirements",unescape("loadRequirementsOf%3A%20aClass%0D%0A%09%22%20Return%20the%20requirements%20to%20load%20aClass.%0D%0A%09It%20must%20be%20a%20collection%20of%20requirements.%0D%0A%09aRequirement%20must%20implement%20%23fileOutOn%3A%20or%20must%20be%20a%20string%20with%20javascript%20code%20to%20execute%20just%20before%20defining%20aClass.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20requirements%20%7C%0D%0A%09requirements%20%3A%3D%20self%20defaultRequirementsFor%3A%20aClass.%0D%0A%09aClass%20loadRequirementsInto%3A%20requirements.%0D%0A%09%5Erequirements"));

smalltalk.bind(smalltalk.Exporter,"exportDefinitionOf:on:","exportDefinitionOf_on_"

,function (aClass,aStream){var self=this;self.loadRequirementsOf_(aClass).do_((function(each){return ((each.isString()).mustBeBoolean()==true ? (function(){return (function($rec){$rec.nextPutAll_(each);return $rec.cr();})(aStream);})() : (function(){return aStream.fileOutOn_(aStream);})());}));

(function($rec){$rec.nextPutAll_(unescape("smalltalk.addClass%28%22")._comma(aClass.name())._comma(unescape("%22%2C")));$rec.nextPutAll_(self.smalltalkNameFor_(aClass.superclass()));return $rec.nextPutAll_(unescape("%2C%20%5B"));})(aStream);

aClass.instanceVariableNames().do_separatedBy_((function(each){return aStream.nextPutAll_(unescape("%27")._comma(each)._comma(unescape("%27")));}), (function(){return aStream.nextPutAll_(unescape("%2C%20"));}));

(function($rec){$rec.nextPutAll_(unescape("%5D%2C%20%27"));$rec.nextPutAll_(aClass.category()._comma(unescape("%27")));$rec.nextPutAll_(unescape("%29%3B"));return $rec.cr();})(aStream);

((aClass.comment().isMemberOf_(smalltalk.String).and_((function(){return aClass.comment().notEmpty();}))).mustBeBoolean()==true ? (function(){return (function($rec){$rec.nextPutAll_(self.smalltalkNameFor_(aClass));$rec.nextPutAll_(unescape(".%24comment%3D")._comma(aClass.comment().escapedCode()));return $rec.cr();})(aStream);})() : nil);

((((aClass.classVariables() || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function($rec){$rec.nextPutAll_(self.smalltalkNameFor_(aClass));$rec.nextPutAll_(unescape(".%24classVariableNames%3D")._comma(aClass.classVariablesString().escapedCode()));return $rec.cr();})(aStream);})() : nil);

((((aClass.poolDictionaries() || nil) !== nil)).mustBeBoolean()==true ? (function(){(function($rec){$rec.nextPutAll_(self.smalltalkNameFor_(aClass));return $rec.nextPutAll_(unescape(".%24poolDictionaries%3D%5B"));})(aStream);aClass.poolDictionaries().do_separatedBy_((function(each){return aStream.nextPutAll_(unescape("%27")._comma(each)._comma(unescape("%27")));}), (function(){return aStream.nextPutAll_(unescape("%2C%20"));}));return (function($rec){$rec.nextPutAll_(unescape("%5D%3B"));return $rec.cr();})(aStream);})() : nil);

((aClass.propertyNames().notEmpty()).mustBeBoolean()==true ? (function(){(function($rec){$rec.nextPutAll_(self.smalltalkNameFor_(aClass));return $rec.nextPutAll_(unescape(".%24propertyNames%3D%5B"));})(aStream);aClass.propertyNames().do_separatedBy_((function(each){return aStream.nextPutAll_(unescape("%27")._comma(each)._comma(unescape("%27")));}), (function(){return aStream.nextPutAll_(unescape("%2C%20"));}));return (function($rec){$rec.nextPutAll_(unescape("%5D%3B"));return $rec.cr();})(aStream);})() : nil);return self;}

,"private",unescape("exportDefinitionOf%3A%20aClass%20on%3A%20aStream%0D%0A%09%22%20Export%20definition%20of%20aClass%20onto%20aStream.%20%22%0D%0A%0D%0A%09%28self%20loadRequirementsOf%3A%20aClass%29%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20isString%0D%0A%09%09ifTrue%3A%20%5B%20aStream%20nextPutAll%3A%20each%3Bcr%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20aStream%20fileOutOn%3A%20aStream%20%5D.%0D%0A%09%5D.%0D%0A%09aStream%20%0D%0A%09%20%20%20%20nextPutAll%3A%20%27smalltalk.addClass%28%22%27%2C%20aClass%20name%2C%20%27%22%2C%27%3B%0D%0A%09%20%20%20%20nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20aClass%20superclass%29%3B%0D%0A%09%20%20%20%20nextPutAll%3A%20%27%2C%20%5B%27.%0D%0A%09aClass%20instanceVariableNames%20%0D%0A%09%20%20%20%20do%3A%20%5B%3Aeach%20%7C%20aStream%20nextPutAll%3A%20%27%27%27%27%2C%20each%2C%20%27%27%27%27%20%5D%0D%0A%09%20%20%20%20separatedBy%3A%20%5B%20aStream%20nextPutAll%3A%20%27%2C%20%27%20%5D.%0D%0A%09aStream%09%0D%0A%09%20%20%20%20nextPutAll%3A%20%27%5D%2C%20%27%27%27%3B%0D%0A%09%20%20%20%20nextPutAll%3A%20aClass%20category%2C%20%27%27%27%27%3B%0D%0A%09%20%20%20%20nextPutAll%3A%20%27%29%3B%27%3B%20cr.%0D%0A%09%28%28aClass%20comment%20isMemberOf%3A%20String%29%20and%3A%20%5BaClass%20comment%20notEmpty%5D%29%20ifTrue%3A%20%5B%0D%0A%09%20%20%20%20aStream%0D%0A%09%09nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20aClass%29%3B%0D%0A%09%09nextPutAll%3A%20%27.%24comment%3D%27%20%2CaClass%20comment%20escapedCode%3B%20cr%0D%0A%09%5D.%0D%0A%09aClass%20classVariables%20notNil%20ifTrue%3A%20%5B%0D%0A%09%20%20%20%20aStream%0D%0A%09%09nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20aClass%29%3B%0D%0A%09%09nextPutAll%3A%20%27.%24classVariableNames%3D%27%20%2CaClass%20classVariablesString%20escapedCode%3B%20cr%0D%0A%09%5D.%0D%0A%09aClass%20poolDictionaries%20notNil%20ifTrue%3A%20%5B%0D%0A%09%20%20%20%20aStream%0D%0A%09%09nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20aClass%29%3B%0D%0A%09%09nextPutAll%3A%20%27.%24poolDictionaries%3D%5B%27.%0D%0A%09%20%20%20%20aClass%20poolDictionaries%0D%0A%09%20%20%20%20%09do%3A%20%5B%3Aeach%20%7C%20aStream%20nextPutAll%3A%20%27%27%27%27%2C%20each%2C%20%27%27%27%27%20%5D%0D%0A%09%20%20%20%20%09separatedBy%3A%20%5B%20aStream%20nextPutAll%3A%20%27%2C%20%27%20%5D.%0D%0A%09%20%20%20%20aStream%20%20nextPutAll%3A%20%27%5D%3B%27%3B%20cr%0D%0A%09%5D.%0D%0A%09aClass%20propertyNames%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%20%20%20%20aStream%0D%0A%09%09nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20aClass%29%3B%0D%0A%09%09nextPutAll%3A%20%27.%24propertyNames%3D%5B%27.%0D%0A%09%20%20%20%20aClass%20propertyNames%0D%0A%09%20%20%20%20%09do%3A%20%5B%3Aeach%20%7C%20aStream%20nextPutAll%3A%20%27%27%27%27%2C%20each%2C%20%27%27%27%27%20%5D%0D%0A%09%20%20%20%20%09separatedBy%3A%20%5B%20aStream%20nextPutAll%3A%20%27%2C%20%27%20%5D.%0D%0A%09%20%20%20%20aStream%20%20nextPutAll%3A%20%27%5D%3B%27%3B%20cr%0D%0A%09%5D."));

smalltalk.bind(smalltalk.Exporter,"exportMetaDefinitionOf:on:","exportMetaDefinitionOf_on_"

,function (aClass,aStream){var self=this;((aClass.$klass.instanceVariableNames().notEmpty()).mustBeBoolean()==true ? (function(){(function($rec){$rec.nextPutAll_(self.smalltalkNameFor_(aClass.$klass));return $rec.nextPutAll_(unescape(".%24iVarNames%20%3D%20%5B"));})(aStream);aClass.$klass.instanceVariableNames().do_separatedBy_((function(each){return aStream.nextPutAll_(unescape("%27")._comma(each)._comma(unescape("%27")));}), (function(){return aStream.nextPutAll_(unescape("%2C"));}));return (function($rec){$rec.nextPutAll_(unescape("%5D%3B"));return $rec.cr();})(aStream);})() : nil);

((aClass.$klass.propertyNames().notEmpty()).mustBeBoolean()==true ? (function(){(function($rec){$rec.nextPutAll_(self.smalltalkNameFor_(aClass.$klass));return $rec.nextPutAll_(unescape(".%24propertyNames%20%3D%20%5B"));})(aStream);aClass.$klass.propertyNames().do_separatedBy_((function(each){return aStream.nextPutAll_(unescape("%27")._comma(each)._comma(unescape("%27")));}), (function(){return aStream.nextPutAll_(unescape("%2C"));}));return (function($rec){$rec.nextPutAll_(unescape("%5D%3B"));return $rec.cr();})(aStream);})() : nil);return self;}

,"private",unescape("exportMetaDefinitionOf%3A%20aClass%20on%3A%20aStream%0D%0A%09%22%20Export%20class%20side%20definition%20of%20aClass%20onto%20aStream.%20%22%0D%0A%0D%0A%09aClass%20class%20instanceVariableNames%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%09aStream%20%0D%0A%09%09%09nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20aClass%20class%29%3B%0D%0A%09%09%09nextPutAll%3A%20%27.%24iVarNames%20%3D%20%5B%27.%0D%0A%09%09aClass%20class%20instanceVariableNames%0D%0A%09%09%09do%3A%20%5B%3Aeach%20%7C%20aStream%20nextPutAll%3A%20%27%27%27%27%2C%20each%2C%20%27%27%27%27%20%5D%0D%0A%09%09%09separatedBy%3A%20%5B%20aStream%20nextPutAll%3A%20%27%2C%27%20%5D.%0D%0A%09%09aStream%20nextPutAll%3A%20%27%5D%3B%27%3B%20cr.%0D%0A%09%5D.%0D%0A%0D%0A%09aClass%20class%20propertyNames%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%09aStream%20%0D%0A%09%09%09nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20aClass%20class%29%3B%0D%0A%09%09%09nextPutAll%3A%20%27.%24propertyNames%20%3D%20%5B%27.%0D%0A%09%09aClass%20class%20propertyNames%0D%0A%09%09%09do%3A%20%5B%3Aeach%20%7C%20aStream%20nextPutAll%3A%20%27%27%27%27%2C%20each%2C%20%27%27%27%27%20%5D%0D%0A%09%09%09separatedBy%3A%20%5B%20aStream%20nextPutAll%3A%20%27%2C%27%20%5D.%0D%0A%09%09aStream%20nextPutAll%3A%20%27%5D%3B%27%3B%20cr.%0D%0A%09%5D."));

smalltalk.bind(smalltalk.Exporter,"smalltalkNameFor:","smalltalkNameFor_"

,function (aClass){var self=this;return aClass.compiler().smalltalkNameFor_(aClass);return self;}

,"private",unescape("smalltalkNameFor%3A%20aClass%0D%0A%09%22%20Private%20-%20Return%20the%20global%20name%20of%20aClass%20%28can%20be%20nil%29.%20%22%0D%0A%0D%0A%09%5EaClass%20compiler%20smalltalkNameFor%3A%20aClass"));

smalltalk.bind(smalltalk.Exporter,"exportAll","exportAll"

,function (){var self=this;var categories=nil;categories=smalltalk.Array.$$new();

self.$klass.allClasses().do_((function(each){return ((categories.includes_(each.category())).mustBeBoolean()==true ? nil : (function(){return categories.add_(each.category());})());}));

categories.do_((function(each){return self.exportCategory_(each);}));return self;}

,"fileOut",unescape("exportAll%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20all%20classes%20in%20the%20system.%20%22%0D%0A%0D%0A%09%7C%20categories%20%7C%0D%0A%09categories%20%3A%3D%20Array%20new.%0D%0A%09self%20class%20allClasses%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%09%28categories%20includes%3A%20each%20category%29%20ifFalse%3A%20%5B%0D%0A%09%09%09categories%20add%3A%20each%20category%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09categories%20do%3A%20%5B%3Aeach%20%7C%20self%20exportCategory%3A%20each%20%5D"));

smalltalk.bind(smalltalk.Exporter,"exportDefinitionOf:","exportDefinitionOf_"

,function (aClass){var self=this;var stream=nil;stream=smalltalk.String.$$new().writeStream();

self.exportDefinitionOf_on_(aClass, stream);

return stream.contents();return self;}

,"fileOut",unescape("exportDefinitionOf%3A%20aClass%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20the%20definition%20of%20aClass.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20String%20new%20writeStream.%0D%0A%09self%20exportDefinitionOf%3A%20aClass%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"exportMetaDefinitionOf:","exportMetaDefinitionOf_"

,function (aClass){var self=this;var stream=nil;stream=smalltalk.String.$$new().writeStream();

self.exportMetaDefinitionOf_on_(aClass, stream);

return stream.contents();return self;}

,"fileOut",unescape("exportMetaDefinitionOf%3A%20aClass%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20class%20side%20definition%20of%20aClass.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20String%20new%20writeStream.%0D%0A%09self%20exportMetaDefinitionOf%3A%20aClass%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"exportClasses:on:","exportClasses_on_"

,function (classes,stream){var self=this;classes.do_((function(aClass){self.exportDefinitionOf_on_(aClass, stream);return self.exportMetaDefinitionOf_on_(aClass, stream);}));

stream.cr();

classes.do_((function(aClass){self.exportMethodsOf_on_(aClass.$klass, stream);return self.exportMethodsOf_on_(aClass, stream);}));return self;}

,"fileOut",unescape("exportClasses%3A%20classes%20on%3A%20stream%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20class%20definitions%20onto%20stream.%20%22%0D%0A%0D%0A%09classes%20do%3A%20%5B%3AaClass%7C%0D%0A%09%09self%20exportDefinitionOf%3A%20aClass%20on%3A%20stream.%0D%0A%09%09self%20exportMetaDefinitionOf%3A%20aClass%20on%3A%20stream.%0D%0A%09%5D.%0D%0A%09stream%20cr.%0D%0A%09classes%20do%3A%20%5B%3AaClass%7C%0D%0A%09%09self%20exportMethodsOf%3A%20aClass%20class%20on%3A%20stream.%0D%0A%09%09self%20exportMethodsOf%3A%20aClass%20on%3A%20stream.%0D%0A%09%5D."));

smalltalk.bind(smalltalk.Exporter,"exportClasses:","exportClasses_"

,function (classes){var self=this;var stream=nil;stream=smalltalk.String.$$new().writeStream();

self.exportClasses_on_(classes, stream);

return stream.contents();return self;}

,"fileOut",unescape("exportClasses%3A%20classes%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20classes.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20String%20new%20writeStream.%0D%0A%09self%20exportClasses%3A%20classes%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"exportObject:on:","exportObject_on_"

,function (anObject,stream){var self=this;stream.nextPutAll_(anObject.asJavascript());return self;}

,"fileOut",unescape("exportObject%3A%20anObject%20on%3A%20stream%0D%0A%09%22%20Export%20a%20%28javascript%29literal%20representation%20of%20anObject%20onto%20stream.%20%22%0D%0A%0D%0A%09stream%20nextPutAll%3A%20anObject%20asJavascript."));

smalltalk.bind(smalltalk.Exporter,"exportObject:","exportObject_"

,function (anObject){var self=this;var stream=nil;stream=smalltalk.String.$$new().writeStream();

self.exportObject_on_(anObject, stream);

return stream.contents();return self;}

,"fileOut",unescape("exportObject%3A%20anObject%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20a%20literal%20representation%20of%20anObject.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20String%20new%20writeStream.%0D%0A%09self%20exportObject%3A%20anObject%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"export:method:","export_method_"

,function (aClass,aMethod){var self=this;var stream=nil;stream=smalltalk.String.$$new().writeStream();

self.export_method_on_(aClass, aMethod, stream);

return stream.contents();return self;}

,"fileOut",unescape("export%3A%20aClass%20method%3A%20aMethod%0D%0A%09%22%20Return%20the%20result%20of%20exporting%20aClass%20nethod.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20String%20new%20writeStream.%0D%0A%09self%20export%3A%20aClass%20method%3A%20aMethod%20on%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Exporter,"exportMethodsOf:on:","exportMethodsOf_on_"

,function (aClass,aStream){var self=this;aClass.methodsDo_((function(each){return self.export_method_on_(aClass, each, aStream);}));return self;}

,"private",unescape("exportMethodsOf%3A%20aClass%20on%3A%20aStream%0D%0A%09%22%20Export%20methods%20of%20aClass%20onto%20aStream.%20%22%0D%0A%0D%0A%09aClass%20methodsDo%3A%20%5B%3Aeach%7C%20self%20export%3A%20aClass%20method%3A%20each%20on%3A%20aStream%20%5D"));

smalltalk.bind(smalltalk.Exporter,"export:method:on:","export_method_on_"

,function (aClass,aMethod,aStream){var self=this;var functionName=nil;var selectorName=nil;var bar=nil;bar=unescape("%22").asString();

functionName=aMethod.selector();

((functionName.first().isBackSlash()).mustBeBoolean()==true ? (function(){selectorName=aMethod.selector().escapedCode();return functionName=functionName.asSelector().escapedCode();})() : (function(){selectorName=bar._comma(aMethod.selector())._comma(bar);return functionName=bar._comma(functionName.asSelector())._comma(bar);})());

(function($rec){$rec.nextPutAll_(unescape("smalltalk.bind%28")._comma(self.smalltalkNameFor_(aClass)));$rec.nextPutAll_(unescape("%2C")._comma(selectorName)._comma(unescape("%2C"))._comma(functionName));$rec.cr();return $rec.nextPutAll_(unescape("%2C")._comma(aMethod.fn().compiledSource()));})(aStream);

((((aMethod.source() || nil) !== nil).and_((function(){return aMethod.source().notEmpty();}))).mustBeBoolean()==true ? (function(){return (function($rec){$rec.cr();$rec.nextPutAll_(unescape("%2C")._comma(aMethod.category().escapedCode()));return $rec.nextPutAll_(unescape("%2C")._comma(aMethod.source().escapedCode()));})(aStream);})() : nil);

(function($rec){$rec.nextPutAll_(unescape("%29%3B"));return $rec.cr();})(aStream);return self;}

,"fileOut",unescape("export%3A%20aClass%20method%3A%20aMethod%20on%3A%20aStream%0D%0A%09%22%20Export%20a%20method%20definition%20of%20aClass%20onto%20aStream.%20%22%0D%0A%0D%0A%09%7C%20functionName%20selectorName%20bar%20%7C%0D%0A%09bar%20%3A%3D%20%24%22%20asString.%0D%0A%09functionName%20%3A%3D%20aMethod%20selector.%0D%0A%09functionName%20first%20isBackSlash%20ifTrue%3A%20%5B%0D%0A%09%09selectorName%20%3A%3D%20aMethod%20selector%20escapedCode.%0D%0A%09%09functionName%20%3A%3D%20functionName%20asSelector%20escapedCode.%0D%0A%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09selectorName%20%3A%3D%20bar%20%2CaMethod%20selector%2C%20bar.%0D%0A%09%09functionName%20%3A%3D%20bar%20%2CfunctionName%20asSelector%2C%20bar.%0D%0A%09%5D.%0D%0A%09aStream%0D%0A%09%09nextPutAll%3A%20%27smalltalk.bind%28%27%2C%20%28self%20smalltalkNameFor%3A%20aClass%29%3B%0D%0A%09%09nextPutAll%3A%20%27%2C%27%2C%20selectorName%2C%20%27%2C%27%2C%20functionName%3B%20cr%3B%0D%0A%09%09nextPutAll%3A%20%27%2C%27%2C%20aMethod%20fn%20compiledSource.%0D%0A%09%28aMethod%20source%20notNil%20and%3A%20%5B%20aMethod%20source%20notEmpty%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%20%20%20%20aStream%20cr%3B%20%22warning%3A%20this%20cr%20is%20important%20for%20debugger%22%0D%0A%09%09nextPutAll%3A%20%27%2C%27%2C%20aMethod%20category%20escapedCode%3B%0D%0A%09%09nextPutAll%3A%20%27%2C%27%2C%20aMethod%20source%20escapedCode.%0D%0A%09%5D.%0D%0A%09aStream%20nextPutAll%3A%20%27%29%3B%27%3B%20cr."));

smalltalk.bind(smalltalk.DoIt,"doIt","doIt"

,function (){var self=this;return (function(){return smalltalk.PG8LocalStorage.methodsFor_("reset");}).value();return self;}

,nil,unescape("doIt%20%5E%5BPG8LocalStorage%20methodsFor%3A%20%27reset%27%20%5D%20value"));

smalltalk.bind(smalltalk.Snapshot.$klass,"contents","contents"

,function (){var self=this;return self.$$new().contents();return self;}

,"accessing",unescape("contents%0D%0A%09%22%20Return%20a%20snapshot%20of%20current%20system%20contents.%20%22%0D%0A%0D%0A%09%5Eself%20new%20contents"));

smalltalk.bind(smalltalk.Snapshot.$klass,"outputToFile:","outputToFile_"

,function (fileName){var self=this;self.contents().outputToFile_(fileName);return self;}

,"saveImage",unescape("outputToFile%3A%20fileName%0D%0A%09%22%20Save%20a%20complete%20system%20snapshot%20in%20a%20file%20at%20fileName.%20%22%0D%0A%0D%0A%09self%20contents%20outputToFile%3A%20fileName"));

smalltalk.bind(smalltalk.Snapshot,"contents","contents"

,function (){var self=this;var stream=nil;stream=smalltalk.String.$$new().writeStream();

self.saveImageOn_(stream);

return stream.contents();return self;}

,"accessing",unescape("contents%0D%0A%09%22%20Return%20a%20snapshot%20of%20current%20system%20contents.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20String%20new%20writeStream.%0D%0A%09self%20saveImageOn%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Snapshot,"system","system"

,function (){var self=this;return self['@system'];return self;}

,"accessing",unescape("system%0D%0A%09%22%20Return%20the%20system%20to%20be%20captured.%20%22%0D%0A%0D%0A%09%5Esystem"));

smalltalk.bind(smalltalk.Snapshot,"saveImageOn:","saveImageOn_"

,function (stream){var self=this;return self.saveImage_on_(smalltalk.Smalltalk.current(), stream);return self;}

,unescape("save%20image"),unescape("saveImageOn%3A%20stream%0D%0A%09%22%20Save%20the%20current%20system%20contents%20onto%20stream.%20%22%0D%0A%0D%0A%09%5Eself%20saveImage%3A%20Smalltalk%20current%20on%3A%20stream"));

smalltalk.bind(smalltalk.Snapshot,"saveImage:on:","saveImage_on_"

,function (aSmalltalk,stream){var self=this;(function($rec){$rec.writeLicense_on_(aSmalltalk, stream);$rec.writeBootOn_(stream);$rec.writePrologueOn_(stream);$rec.writeImageContents_on_(aSmalltalk, stream);$rec.writeEpilogueOn_(stream);return $rec.yourself();})(self);return self;}

,unescape("save%20image"),unescape("saveImage%3A%20aSmalltalk%20on%3A%20stream%0D%0A%09%22%20Save%20aSmalltalk%20system%20contents%20onto%20stream.%20%22%0D%0A%0D%0A%09self%0D%0A%09%09writeLicense%3A%20aSmalltalk%20on%3A%20stream%3B%0D%0A%09%09writeBootOn%3A%20stream%3B%0D%0A%09%09writePrologueOn%3A%20stream%3B%0D%0A%09%09writeImageContents%3A%20aSmalltalk%20on%3A%20stream%3B%0D%0A%09%09writeEpilogueOn%3A%20stream%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Snapshot,"writeLicense:on:","writeLicense_on_"

,function (aSmalltalk,aStream){var self=this;(function($rec){$rec.nextPutAll_(unescape("/*"));$rec.cr();$rec.nextPutAll_(aSmalltalk.licenseTerms());$rec.cr();$rec.nextPutAll_(unescape("*/"));$rec.cr();return $rec.cr();})(aStream);return self;}

,"writing",unescape("writeLicense%3A%20aSmalltalk%20on%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20license%20terms%20onto%20aStream.%20%22%0D%0A%0D%0A%09aStream%0D%0A%09%09nextPutAll%3A%20%27/*%27%3Bcr%3B%0D%0A%09%09nextPutAll%3A%20aSmalltalk%20licenseTerms%3Bcr%3B%0D%0A%09%09nextPutAll%3A%20%27*/%27%3Bcr%3B%0D%0A%09%09cr"));

smalltalk.bind(smalltalk.Snapshot,"writeBootOn:","writeBootOn_"

,function (aStream){var self=this;self.writeJSGlobals_on_(["StObject", "StBehavior", "StClass", "StMetaclass", "StMethod", "StUndefinedObject"], aStream);

self.writeNilDefinitionOn_(aStream);

self.writeJSGlobals_on_(["StSystemDictionary"], aStream);

self.writeSystemDefinitionOn_(aStream);

self.write_mappingsOn_("Kernel", aStream);return self;}

,"writing",unescape("writeBootOn%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20boot%20section%20of%20the%20image%20onto%20aStream.%20%22%0D%0A%0D%0A%09self%20writeJSGlobals%3A%20%23%28%0D%0A%09%09%23StObject%20%23StBehavior%20%23StClass%20%23StMetaclass%0D%0A%09%09%23StMethod%0D%0A%09%09%23StUndefinedObject%0D%0A%09%09%29%20on%3A%20aStream.%0D%0A%09self%20writeNilDefinitionOn%3A%20aStream.%0D%0A%09self%20writeJSGlobals%3A%20%23%28%20%23StSystemDictionary%20%29%20on%3A%20aStream.%0D%0A%09self%20writeSystemDefinitionOn%3A%20aStream.%0D%0A%09self%20write%3A%20%23Kernel%20mappingsOn%3A%20aStream."));

smalltalk.bind(smalltalk.Snapshot,"writePrologueOn:","writePrologueOn_"

,function (aStream){var self=this;self.writeJSGlobals_on_(["smalltalk.st", "smalltalk.doIt", "fileIn", "fileInJS", "doit", "exportCategory", "saveImage", "saveImageAs"], aStream);

self.write_on_(unescape("smalltalk.%24imageFileName%20%3D%20smalltalk.%24imageFileName%20%20%7C%7C%20%22s8.image.js%22%3B"), aStream);return self;}

,"writing",unescape("writePrologueOn%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20prologue%20section%20of%20the%20image%20onto%20aStream.%20%22%0D%0A%0D%0A%09self%20writeJSGlobals%3A%20%23%28%0D%0A%09%09%27smalltalk.st%27%20%27smalltalk.doIt%27%0D%0A%09%09%23fileIn%20%23fileInJS%0D%0A%09%09%23doit%20%23exportCategory%0D%0A%09%09%23saveImage%20%23saveImageAs%0D%0A%09%09%29%20on%3A%20aStream.%0D%0A%09self%20write%3A%20%27smalltalk.%24imageFileName%20%3D%20smalltalk.%24imageFileName%20%20%7C%7C%20%22s8.image.js%22%3B%27%20on%3A%20aStream."));

smalltalk.bind(smalltalk.Snapshot,"writeEpilogueOn:","writeEpilogueOn_"

,function (aStream){var self=this;self.write_on_(unescape("//%20Launching%20S8%20image."), aStream);

self.write_on_(unescape("smalltalk.launchImage%28%29%3B"), aStream);return self;}

,"writing",unescape("writeEpilogueOn%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20epilogue%20section%20of%20the%20image%20onto%20aStream.%20%22%0D%0A%0D%0A%09self%20write%3A%20%27//%20Launching%20S8%20image.%27%20on%3A%20aStream.%0D%0A%09self%20write%3A%20%27smalltalk.launchImage%28%29%3B%27%20on%3A%20aStream."));

smalltalk.bind(smalltalk.Snapshot,"write:on:","write_on_"

,function (aString,aStream){var self=this;(function($rec){$rec.cr();return $rec.nextPutAll_(aString);})(aStream);return self;}

,"writing",unescape("write%3A%20aString%20on%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20aString%20onto%20aStream.%20%22%0D%0A%0D%0A%09aStream%20cr%3B%20nextPutAll%3A%20aString"));

smalltalk.bind(smalltalk.Snapshot,"globalNotFound:","globalNotFound_"

,function (aJSGlobal){var self=this;return self.error_("Global not found: "._comma(aJSGlobal));return self;}

,"error",unescape("globalNotFound%3A%20aJSGlobal%0D%0A%09%22%20Private%20-%20A%20global%20at%20javascript%20level%20has%20not%20been%20found.%20%22%0D%0A%0D%0A%09%5Eself%20error%3A%20%27Global%20not%20found%3A%20%27%2CaJSGlobal"));

smalltalk.bind(smalltalk.Snapshot,"writeJSGlobals:on:","writeJSGlobals_on_"

,function (globals,aStream){var self=this;var jsObject=nil;var varName=nil;globals.do_((function(each){jsObject=eval(each);((((jsObject || nil) === nil)).mustBeBoolean()==true ? (function(){return jsObject=self.globalNotFound_(each);})() : nil);varName=((each.includes_(".")).mustBeBoolean()==true ? (function(){return each;})() : (function(){return "var "._comma(each);})());return self.write_on_(varName._comma(unescape("%20%3D%20"))._comma(jsObject.toString()), aStream);}));return self;}

,"writing",unescape("writeJSGlobals%3A%20globals%20on%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20prologue%20section%20of%20the%20image%20onto%20aStream.%20%22%0D%0A%0D%0A%09%7C%20jsObject%20varName%20%7C%0D%0A%09globals%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09jsObject%20%3A%3D%20%23%20%23eval%3A%20each.%0D%0A%09%09jsObject%20isNil%20ifTrue%3A%20%5B%20jsObject%20%3A%3D%20self%20globalNotFound%3A%20each%20%5D.%0D%0A%09%09varName%20%3A%3D%20%28each%20includes%3A%20%24.%29%20ifTrue%3A%20%5B%20each%20%5D%20ifFalse%3A%20%5B%20%27var%20%27%2Ceach%20%5D.%0D%0A%09%09self%20write%3A%20varName%2C%27%20%3D%20%27%2C%20jsObject%20toString%20on%3A%20aStream.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Snapshot,"writeNilDefinitionOn:","writeNilDefinitionOn_"

,function (aStream){var self=this;self.write_on_(unescape("var%20nil%20%3D%20new%20StUndefinedObject%28%29%3B"), aStream);

self.write_on_(unescape("nil.toString%20%3D%20function%28%29%20%7B%20return%20%22nil%22%3B%20%7D"), aStream);return self;}

,"writing",unescape("writeNilDefinitionOn%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20definition%20of%20nil%20object%20onto%20aStream.%20%22%0D%0A%0D%0A%09self%20write%3A%20%27var%20nil%20%3D%20new%20StUndefinedObject%28%29%3B%27%20on%3A%20aStream.%0D%0A%09self%20write%3A%20%27nil.toString%20%3D%20function%28%29%20%7B%20return%20%22nil%22%3B%20%7D%27%20on%3A%20aStream"));

smalltalk.bind(smalltalk.Snapshot,"writeSystemDefinitionOn:","writeSystemDefinitionOn_"

,function (aStream){var self=this;self.write_on_(unescape("var%20smalltalk%20%3D%20new%20StSystemDictionary%28%29%3B"), aStream);

self.write_on_(unescape("smalltalk.toString%20%3D%20function%28%29%20%7B%20return%20%22smalltalk%22%3B%20%7D"), aStream);

self.write_on_(unescape("smalltalk.OverwriteMethods%20%3D%20smalltalk.OverwriteMethods%20%7C%7C%20nil%3B"), aStream);

self.write_on_(unescape("smalltalk.DumpOverwriteMethods%20%3D%20smalltalk.DumpOverwriteMethods%20%7C%7C%20nil%3B"), aStream);return self;}

,"writing",unescape("writeSystemDefinitionOn%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20definition%20of%20smalltalk%20object%20onto%20aStream.%20%22%0D%0A%0D%0A%09self%20write%3A%20%27var%20smalltalk%20%3D%20new%20StSystemDictionary%28%29%3B%27%20on%3A%20aStream.%0D%0A%09self%20write%3A%20%27smalltalk.toString%20%3D%20function%28%29%20%7B%20return%20%22smalltalk%22%3B%20%7D%27%20on%3A%20aStream.%0D%0A%09self%20write%3A%20%27smalltalk.OverwriteMethods%20%3D%20smalltalk.OverwriteMethods%20%7C%7C%20nil%3B%27%20on%3A%20aStream.%0D%0A%09self%20write%3A%20%27smalltalk.DumpOverwriteMethods%20%3D%20smalltalk.DumpOverwriteMethods%20%7C%7C%20nil%3B%27%20on%3A%20aStream."));

smalltalk.bind(smalltalk.Snapshot,"write:mappingsOn:","write_mappingsOn_"

,function (aCategory,aStream){var self=this;var mapped=nil;var mappings=nil;var done=nil;var register=nil;var row=nil;mapped=smalltalk.Smalltalk.current().classes().select_((function(each){return each.category()._eq(aCategory).and_((function(){return ((each.constructorName() || nil) !== nil);}));}));

mappings=smalltalk.Array.$$new();

done=smalltalk.Array.$$new();

register=(function(aClass){return ((((aClass || nil) === nil).or_((function(){return done.includes_(aClass);}))).mustBeBoolean()==true ? nil : (function(){register.value_(aClass.superclass());row=smalltalk.Array.with_(aClass.name());row.add_(((((aClass.constructorName() || nil) === nil)).mustBeBoolean()==true ? (function(){return "undefined";})() : (function(){return aClass.constructorName();})()));((((aClass.superclass() || nil) !== nil)).mustBeBoolean()==true ? (function(){return row.add_(aClass.superclass().name());})() : nil);mappings.add_(row);return done.add_(aClass);})());});

mapped.do_(register);

return self.write_mappings_on_(aCategory, mappings, aStream);return self;}

,"writing",unescape("write%3A%20aCategory%20mappingsOn%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20mappings%20for%20system%20classes%20in%20aCategory%20onto%20aStream.%20%22%0D%0A%0D%0A%09%7C%20mapped%20mappings%20done%20register%20row%20%7C%0D%0A%09mapped%20%3A%3D%20Smalltalk%20current%20classes%20select%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20category%20%3D%20aCategory%0D%0A%09%09and%3A%20%5B%20each%20constructorName%20notNil%20%5D%0D%0A%09%09%5D.%0D%0A%09mappings%20%3A%3D%20Array%20new.%0D%0A%09done%20%3A%3D%20Array%20new.%0D%0A%09register%20%3A%3D%20%5B%3AaClass%7C%0D%0A%09%09%28aClass%20isNil%20or%3A%20%5B%20done%20includes%3A%20aClass%20%5D%29%20ifFalse%3A%20%5B%0D%0A%09%09%09register%20value%3A%20aClass%20superclass.%0D%0A%09%09%09row%20%3A%3D%20Array%20with%3A%20aClass%20name.%0D%0A%09%09%09row%20add%3A%20%28aClass%20constructorName%20isNil%0D%0A%09%09%09%09ifTrue%3A%20%5B%20%23undefined%20%5D%0D%0A%09%09%09%09ifFalse%3A%20%5B%20aClass%20constructorName%20%5D%29.%0D%0A%09%09%09aClass%20superclass%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%09%09row%20add%3A%20aClass%20superclass%20name.%0D%0A%09%09%09%5D.%0D%0A%09%09%09mappings%20add%3A%20row.%0D%0A%09%09%09done%20add%3A%20aClass.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09mapped%20do%3A%20register.%0D%0A%09%5Eself%20write%3A%20aCategory%20mappings%3A%20mappings%20on%3A%20aStream"));

smalltalk.bind(smalltalk.Snapshot,"write:mappings:on:","write_mappings_on_"

,function (category,mappings,aStream){var self=this;var className=nil;var fn=nil;var superclass=nil;mappings.do_((function(tuple){className=tuple.first();fn=tuple.at_((2));superclass=((tuple.size()._eq((2))).mustBeBoolean()==true ? (function(){return "";})() : (function(){return unescape("%2Csmalltalk.")._comma(tuple.last());})());return self.write_on_(unescape("smalltalk.mapClassName%28")._comma(className.printString())._comma(unescape("%2C"))._comma(category.printString())._comma(unescape("%2C"))._comma(fn.asString())._comma(superclass)._comma(unescape("%29%3B")), aStream);}));return self;}

,"writing",unescape("write%3A%20category%20mappings%3A%20mappings%20on%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20mappings%20onto%20aStream.%20%22%0D%0A%0D%0A%09%7C%20className%20fn%20superclass%20%7C%0D%0A%09mappings%20do%3A%20%5B%3Atuple%7C%0D%0A%09%09className%20%3A%3D%20tuple%20first.%0D%0A%09%09fn%20%3A%3D%20tuple%20at%3A%202.%0D%0A%09%09superclass%20%3A%3D%20tuple%20size%20%3D%202%20ifTrue%3A%20%5B%20%27%27%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20%27%2Csmalltalk.%27%2Ctuple%20last%20%5D.%20%0D%0A%09%09self%20write%3A%20%27smalltalk.mapClassName%28%27%0D%0A%09%09%09%09%2CclassName%20printString%2C%20%27%2C%27%0D%0A%09%09%09%09%2Ccategory%20printString%2C%20%27%2C%27%0D%0A%09%09%09%09%2Cfn%20asString%0D%0A%09%09%09%09%2Csuperclass%0D%0A%09%09%09%2C%27%29%3B%27%20on%3A%20aStream.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Snapshot,"writeImageContents:on:","writeImageContents_on_"

,function (aSmalltalk,aStream){var self=this;var exporter=nil;var globals=nil;var classes=nil;self['@system']=aSmalltalk;

exporter=self.exporterFor_(aSmalltalk);

globals=self.globalsIn_(aSmalltalk);

classes=self.classesToExportFrom_with_(aSmalltalk, exporter).collect_((function(each){return each.aboutToSaveImage_on_(self, aStream);})).select_((function(each){return ((each || nil) !== nil);}));

exporter.exportClasses_on_(classes, aStream);

self.exportGlobals_with_on_(globals, exporter, aStream);

classes.do_((function(each){return each.imageSaved_on_(self, aStream);}));return self;}

,"writing",unescape("writeImageContents%3A%20aSmalltalk%20on%3A%20aStream%0D%0A%09%22%20Private%20-%20Write%20the%20image%20section%20of%20aSmalltalk%20system%20onto%20aStream.%20%22%0D%0A%0D%0A%09%7C%20exporter%20globals%20classes%20%7C%0D%0A%09system%20%3A%3D%20aSmalltalk.%0D%0A%09exporter%20%3A%3D%20self%20exporterFor%3A%20aSmalltalk.%0D%0A%09globals%20%3A%3D%20self%20globalsIn%3A%20aSmalltalk.%0D%0A%09classes%20%3A%3D%20%28%28self%20classesToExportFrom%3A%20aSmalltalk%20with%3A%20exporter%29%0D%0A%09%09collect%3A%20%5B%3Aeach%7C%20each%20aboutToSaveImage%3A%20self%20on%3A%20aStream%20%5D%29%0D%0A%09%09select%3A%20%5B%3Aeach%7C%20each%20notNil%20%5D.%0D%0A%22%09self%20exportGlobalNames%3A%20globals%20keys%20sorted%20in%3A%20aSmalltalk%20on%3A%20aStream.%0D%0A%22%09exporter%20exportClasses%3A%20classes%20on%3A%20aStream.%0D%0A%09self%20exportGlobals%3A%20globals%20with%3A%20exporter%20on%3A%20aStream.%0D%0A%09classes%20do%3A%20%5B%3Aeach%7C%20each%20imageSaved%3A%20self%20on%3A%20aStream%20%5D."));

smalltalk.bind(smalltalk.Snapshot,"exporterFor:","exporterFor_"

,function (aSmalltalk){var self=this;return smalltalk.Exporter.$$new();return self;}

,"exporting",unescape("exporterFor%3A%20aSmalltalk%0D%0A%09%22%20Private%20-%20Return%20the%20exporter%20to%20use%20to%20write%20contents%20of%20aSmalltalk%20system.%20%22%0D%0A%0D%0A%09%5EExporter%20new"));

smalltalk.bind(smalltalk.Snapshot,"globalsIn:","globalsIn_"

,function (aSmalltalk){var self=this;var result=nil;result=smalltalk.Dictionary.$$new();

aSmalltalk.globalsDo_((function(key){return result.at_put_(key, (aSmalltalk[key] || nil));}));

return result;return self;}

,"exporting",unescape("globalsIn%3A%20aSmalltalk%0D%0A%09%22%20Private%20-%20Return%20the%20globals%20defined%20in%20aSmalltalk%20system.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20Dictionary%20new.%0D%0A%09aSmalltalk%20globalsDo%3A%20%5B%3Akey%7C%20result%20at%3A%20key%20put%3A%20%28aSmalltalk%20basicAt%3A%20key%29%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Snapshot,"classesToExportFrom:with:","classesToExportFrom_with_"

,function (aSmalltalk,exporter){var self=this;return aSmalltalk.classes().select_((function(each){return ((each.superclass() || nil) === nil);})).inject_into_(smalltalk.Array.$$new(), (function(total, each){return total._comma(each.withAllSubclasses());}));return self;}

,"exporting",unescape("classesToExportFrom%3A%20aSmalltalk%20with%3A%20exporter%0D%0A%09%22%20Private%20-%20Return%20the%20classes%20to%20export%20from%20aSmalltalk%20system.%20%22%0D%0A%0D%0A%09%5E%28aSmalltalk%20classes%0D%0A%09%09select%3A%20%5B%3Aeach%7C%20each%20superclass%20isNil%20%5D%29%0D%0A%09%09inject%3A%20Array%20new%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%20%2C%20each%20withAllSubclasses%20%5D"));

smalltalk.bind(smalltalk.Snapshot,"exportGlobalNames:in:on:","exportGlobalNames_in_on_"

,function (names,aSmalltalk,aStream){var self=this;names.do_separatedBy_((function(key){return aStream.nextPutAll_("smalltalk."._comma(key));}), (function(){return aStream.nextPutAll_(unescape("%20%2C%20"));}));

(function($rec){$rec.nextPutAll_(unescape("%3Dnil%3B"));return $rec.cr();})(aStream);return self;}

,"exporting",unescape("exportGlobalNames%3A%20names%20in%3A%20aSmalltalk%20on%3A%20aStream%0D%0A%09%22%20Private%20-%20Export%20global%20names%20in%20aSmalltalk%20system.%20%22%0D%0A%0D%0A%09names%0D%0A%09%09do%3A%20%5B%3Akey%7C%20aStream%20nextPutAll%3A%20%27smalltalk.%27%2Ckey%20%5D%0D%0A%09%09separatedBy%3A%20%5B%20aStream%20nextPutAll%3A%20%27%20%2C%20%27%20%5D.%0D%0A%09aStream%20nextPutAll%3A%20%27%3Dnil%3B%27%3B%20cr."));

smalltalk.bind(smalltalk.Snapshot,"exportGlobals:with:on:","exportGlobals_with_on_"

,function (globals,exporter,aStream){var self=this;aStream.cr();

self.write_on_(unescape("smalltalk.initRoots%28%29%3B"), aStream);

globals.associationsDo_((function(binding){return self.write_on_("smalltalk."._comma(binding.key())._comma(unescape("%3D"))._comma(exporter.exportObject_(binding.value()))._comma(unescape("%3B")), aStream);}));return self;}

,"exporting",unescape("exportGlobals%3A%20globals%20with%3A%20exporter%20on%3A%20aStream%0D%0A%09%22%20Private%20-%20Export%20global%20objects%20onto%20aStream.%20%22%0D%0A%0D%0A%09aStream%20cr.%0D%0A%09self%20write%3A%20%27smalltalk.initRoots%28%29%3B%27%20on%3A%20aStream.%0D%0A%09globals%20associationsDo%3A%20%5B%3Abinding%7C%0D%0A%09%09self%20write%3A%20%27smalltalk.%27%2Cbinding%20key%2C%27%3D%27%0D%0A%09%09%09%2C%28exporter%20exportObject%3A%20binding%20value%29%0D%0A%09%09%09%2C%27%3B%27%20on%3A%20aStream%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Transcript.$klass,"current","current"

,function (){var self=this;((((self['@current'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@current']=self.$$new();})() : nil);

return self['@current'];return self;}

,"accessing",unescape("current%0D%0A%09current%20isNil%20ifTrue%3A%20%5B%20current%20%3A%3D%20self%20new%20%5D.%0D%0A%09%5Ecurrent"));

smalltalk.bind(smalltalk.Transcript.$klass,"cr","cr"

,function (){var self=this;return self.current().cr();return self;}

,"io",unescape("cr%0D%0A%09%5Eself%20current%20cr"));

smalltalk.bind(smalltalk.Transcript.$klass,"nextPutAll:","nextPutAll_"

,function (aString){var self=this;return self.current().nextPutAll_(aString);return self;}

,"io",unescape("nextPutAll%3A%20aString%0D%0A%09%5Eself%20current%20nextPutAll%3A%20aString"));

smalltalk.bind(smalltalk.Transcript.$klass,"show:","show_"

,function (aString){var self=this;return self.current().show_(aString);return self;}

,"io",unescape("show%3A%20aString%0D%0A%09%5Eself%20current%20show%3A%20aString"));

smalltalk.bind(smalltalk.Transcript,"cr","cr"

,function (){var self=this;self.stream().cr();return self;}

,"io",unescape("cr%0D%0A%09self%20stream%20cr"));

smalltalk.bind(smalltalk.Transcript,"nextPutAll:","nextPutAll_"

,function (aString){var self=this;return self.stream().nextPutAll_(aString.asString());return self;}

,"io",unescape("nextPutAll%3A%20aString%0D%0A%09%5Eself%20stream%20nextPutAll%3A%20aString%20asString"));

smalltalk.bind(smalltalk.Transcript,"show:","show_"

,function (aString){var self=this;self.stream().nextPutAll_(aString.asString());

self.flush();return self;}

,"io",unescape("show%3A%20aString%0D%0A%09self%20stream%20nextPutAll%3A%20aString%20asString.%0D%0A%09self%20flush."));

smalltalk.bind(smalltalk.Transcript,"flush","flush"

,function (){var self=this;((((self['@stream'] || nil) !== nil)).mustBeBoolean()==true ? (function(){self.print_(self['@stream'].contents());return self['@stream']=nil;})() : nil);return self;}

,"io",unescape("flush%0D%0A%09stream%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09self%20print%3A%20stream%20contents.%0D%0A%09%09stream%20%3A%3D%20nil.%0D%0A%09%5D."));

smalltalk.bind(smalltalk.Transcript,"stream","stream"

,function (){var self=this;((((self['@stream'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@stream']=smalltalk.String.$$new().stream();})() : nil);

return self['@stream'];return self;}

,"accessing",unescape("stream%0D%0A%09stream%20isNil%20ifTrue%3A%20%5B%20stream%20%3A%3D%20String%20new%20stream.%20%5D.%0D%0A%09%5Estream"));

smalltalk.bind(smalltalk.NativeObject.$klass,"jsNameFromSelector:","jsNameFromSelector_"

,function (aSymbol){var self=this;return aSymbol;return self;}

,unescape("code%20generation"),unescape("jsNameFromSelector%3A%20aSymbol%0D%0A%09%22%20Private%20-%20Return%20the%20property%20name%20for%20selector%20aSymbol.%20%22%0D%0A%0D%0A%09%5EaSymbol"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildGetter:","buildGetter_"

,function (aSelector){var self=this;try{((self.instanceVariableNames().includes_(aSelector)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildGetter_", fn: function(){return smalltalk.whoImplements(smalltalk.NativeObject.$klass,'buildGetter_').$superclass.$fn.prototype['buildGetter_'].apply(self, [aSelector])}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildGetter_", fn: function(){return self.implement_comment_as_category_(self.stMessageHeader_(aSelector), "Return the "._comma(aSelector)._comma(" of the receiver."), unescape("%5Eself%20handle%20basicAt%3A%20")._comma(self.jsNameFromSelector_(aSelector).printString()), "accessing")}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildGetter_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildGetter%3A%20aSelector%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20get%20native%20property.%20%22%0D%0A%0D%0A%09%28self%20instanceVariableNames%20includes%3A%20aSelector%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Esuper%20buildGetter%3A%20aSelector%0D%0A%09%5D.%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%0D%0A%09%09comment%3A%20%27Return%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5Eself%20handle%20basicAt%3A%20%27%20%2C%28self%20jsNameFromSelector%3A%20aSelector%29%20printString%20category%3A%20%23accessing"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildSetter:","buildSetter_"

,function (aSelector){var self=this;try{((self.instanceVariableNames().includes_(aSelector)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildSetter_", fn: function(){return smalltalk.whoImplements(smalltalk.NativeObject.$klass,'buildSetter_').$superclass.$fn.prototype['buildSetter_'].apply(self, [aSelector])}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildSetter_", fn: function(){return self.implement_comment_as_category_(self.stMessageHeader_(aSelector._comma(": anObject")), "Set the "._comma(aSelector)._comma(" of the receiver."), "self handle basicAt: "._comma(self.jsNameFromSelector_(aSelector).printString())._comma(" put: anObject"), "accessing")}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildSetter_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildSetter%3A%20aSelector%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20set%20native%20property.%20%22%0D%0A%0D%0A%09%28self%20instanceVariableNames%20includes%3A%20aSelector%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Esuper%20buildSetter%3A%20aSelector%0D%0A%09%5D.%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%20%2C%20%27%3A%20anObject%27%29%0D%0A%09%09comment%3A%20%27Set%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27self%20handle%20basicAt%3A%20%27%20%2C%28self%20jsNameFromSelector%3A%20aSelector%29%20printString%2C%20%27%20put%3A%20anObject%27%0D%0A%09%09category%3A%20%23accessing"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildTypedGetter:","buildTypedGetter_"

,function (tuple){var self=this;return self.implement_comment_as_category_(self.stMessageHeader_(tuple.first()), "Return the "._comma(tuple.first())._comma(" of the receiver."), unescape("%5E")._comma(tuple.last())._comma(unescape("%20@%20%28self%20handle%20basicAt%3A%20"))._comma(self.jsNameFromSelector_(tuple.first()).printString())._comma(unescape("%29")), "accessing");return self;}

,unescape("code%20generation"),unescape("buildTypedGetter%3A%20tuple%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20get%20property%20from%20spec%20array.%20%22%0D%0A%09%0D%0A%09%5E%28self%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20tuple%20first%29%0D%0A%09%09comment%3A%20%27Return%20the%20%27%20%2Ctuple%20first%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5E%27%2Ctuple%20last%2C%27%20@%20%28self%20handle%20basicAt%3A%20%27%20%2C%28self%20jsNameFromSelector%3A%20tuple%20first%29%20printString%20%2C%27%29%27%20category%3A%20%23accessing%29"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildTypedSetter:","buildTypedSetter_"

,function (tuple){var self=this;return self.implement_comment_as_category_(self.stMessageHeader_(tuple.first()._comma(": anObject")), "Set the "._comma(tuple.first())._comma(" of the receiver."), "self handle basicAt: "._comma(self.jsNameFromSelector_(tuple.first()).printString())._comma(" put: anObject handle"), "accessing");return self;}

,unescape("code%20generation"),unescape("buildTypedSetter%3A%20tuple%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20set%20property%20to%20spec%20array.%20%22%0D%0A%09%0D%0A%09%5E%28self%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20tuple%20first%20%2C%20%27%3A%20anObject%27%29%0D%0A%09%09comment%3A%20%27Set%20the%20%27%20%2Ctuple%20first%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27self%20handle%20basicAt%3A%20%27%20%2C%28self%20jsNameFromSelector%3A%20tuple%20first%29%20printString%20%2C%27%20put%3A%20anObject%20handle%27%20category%3A%20%23accessing%29"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildTypedGetters:","buildTypedGetters_"

,function (specs){var self=this;return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildTypedGetter_(each));}));return self;}

,unescape("code%20generation"),unescape("buildTypedGetters%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20get%20instancess.%20%22%0D%0A%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildTypedGetter%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildTypedAccessors:","buildTypedAccessors_"

,function (tuples){var self=this;return tuples.inject_into_(" ", (function(total, each){return total._comma(self.buildTypedGetter_(each))._comma(self.buildTypedSetter_(each));}));return self;}

,unescape("code%20generation"),unescape("buildTypedAccessors%3A%20tuples%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20methods%20to%20get/set%20property%20from/to%20tuples.%20%22%0D%0A%09%0D%0A%09%5Etuples%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%0D%0A%09%09total%0D%0A%09%09%09%2C%20%28self%20buildTypedGetter%3A%20each%29%0D%0A%09%09%09%2C%20%28self%20buildTypedSetter%3A%20each%29%0D%0A%09%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildFastGetter:","buildFastGetter_"

,function (aSelector){var self=this;return self.implement_comment_as_category_(self.stMessageHeader_(aSelector), "Return the "._comma(aSelector)._comma(" of the receiver."), unescape("%5Ehandle%23")._comma(self.jsNameFromSelector_(aSelector)), "accessing");return self;}

,unescape("code%20generation"),unescape("buildFastGetter%3A%20aSelector%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20get%20native%20property.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%0D%0A%09%09comment%3A%20%27Return%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5Ehandle%23%27%20%2C%28self%20jsNameFromSelector%3A%20aSelector%29%20category%3A%20%23accessing"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildFastAccessor:","buildFastAccessor_"

,function (accessor){var self=this;try{((accessor.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildFastAccessor_", fn: function(){return self.buildFastGetter_(accessor)._comma(self.buildSetter_(accessor))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildFastAccessor_", fn: function(){return self.error_(unescape("Invalid%20%28Fast%29accessors."))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildFastAccessor_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildFastAccessor%3A%20accessor%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20access%20native%20property.%20%22%0D%0A%0D%0A%09accessor%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5E%28self%20buildFastGetter%3A%20accessor%29%0D%0A%09%09%2C%28self%20buildSetter%3A%20accessor%29%0D%0A%09%5D.%0D%0A%09%5Eself%20error%3A%20%27Invalid%20%28Fast%29accessors.%27"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildFastGetters:","buildFastGetters_"

,function (specs){var self=this;try{((specs.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildFastGetters_", fn: function(){return self.buildFastGetters_(specs.asArrayOfSubstrings())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildFastGetters_", fn: function(){return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildFastGetter_(each));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildFastGetters_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildFastGetters%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20get%20instancess.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildFastGetters%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildFastGetter%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildFastAccessors:","buildFastAccessors_"

,function (specs){var self=this;try{((specs.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildFastAccessors_", fn: function(){return self.buildFastAccessors_(specs.asArrayOfSubstrings())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildFastAccessors_", fn: function(){return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildFastAccessor_(each));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildFastAccessors_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildFastAccessors%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20access%20instances.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildFastAccessors%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildFastAccessor%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildNumberGetter:","buildNumberGetter_"

,function (aSelector){var self=this;return self.implement_comment_as_category_(self.stMessageHeader_(aSelector), "Return the "._comma(aSelector)._comma(" of the receiver."), unescape("%5Ehandle%23")._comma(self.jsNameFromSelector_(aSelector))._comma(unescape("%20%7C%7C%200")), "accessing");return self;}

,unescape("code%20generation"),unescape("buildNumberGetter%3A%20aSelector%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20get%20native%20property.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%0D%0A%09%09comment%3A%20%27Return%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5Ehandle%23%27%20%2C%28self%20jsNameFromSelector%3A%20aSelector%29%20%2C%27%20%7C%7C%200%27%20category%3A%20%23accessing"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildNumberAccessor:","buildNumberAccessor_"

,function (accessor){var self=this;try{((accessor.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildNumberAccessor_", fn: function(){return self.buildNumberGetter_(accessor)._comma(self.buildSetter_(accessor))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildNumberAccessor_", fn: function(){return self.error_(unescape("Invalid%20%28Number%29accessors."))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildNumberAccessor_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildNumberAccessor%3A%20accessor%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20access%20native%20property.%20%22%0D%0A%0D%0A%09accessor%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5E%28self%20buildNumberGetter%3A%20accessor%29%0D%0A%09%09%2C%28self%20buildSetter%3A%20accessor%29%0D%0A%09%5D.%0D%0A%09%5Eself%20error%3A%20%27Invalid%20%28Number%29accessors.%27"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildNumberGetters:","buildNumberGetters_"

,function (specs){var self=this;try{((specs.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildNumberGetters_", fn: function(){return self.buildNumberGetters_(specs.asArrayOfSubstrings())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildNumberGetters_", fn: function(){return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildNumberGetter_(each));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildNumberGetters_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildNumberGetters%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20get%20instancess.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildNumberGetters%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildNumberGetter%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildNumberAccessors:","buildNumberAccessors_"

,function (specs){var self=this;try{((specs.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildNumberAccessors_", fn: function(){return self.buildNumberAccessors_(specs.asArrayOfSubstrings())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildNumberAccessors_", fn: function(){return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildNumberAccessor_(each));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildNumberAccessors_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildNumberAccessors%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20access%20instances.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildNumberAccessors%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildNumberAccessor%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildBooleanGetter:","buildBooleanGetter_"

,function (aSelector){var self=this;return self.implement_comment_as_category_(self.stMessageHeader_(aSelector), "Return the "._comma(aSelector)._comma(" of the receiver."), unescape("%5Etrue%20%3D%3D%20handle%23")._comma(self.jsNameFromSelector_(aSelector)), "accessing");return self;}

,unescape("code%20generation"),unescape("buildBooleanGetter%3A%20aSelector%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20get%20native%20property.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%0D%0A%09%09comment%3A%20%27Return%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5Etrue%20%3D%3D%20handle%23%27%20%2C%28self%20jsNameFromSelector%3A%20aSelector%29%20category%3A%20%23accessing"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildBooleanAccessor:","buildBooleanAccessor_"

,function (accessor){var self=this;try{((accessor.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildBooleanAccessor_", fn: function(){return self.buildBooleanGetter_(accessor)._comma(self.buildSetter_(accessor))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildBooleanAccessor_", fn: function(){return self.error_(unescape("Invalid%20%28Boolean%29accessors."))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildBooleanAccessor_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildBooleanAccessor%3A%20accessor%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20access%20native%20property.%20%22%0D%0A%0D%0A%09accessor%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5E%28self%20buildBooleanGetter%3A%20accessor%29%0D%0A%09%09%2C%28self%20buildSetter%3A%20accessor%29%0D%0A%09%5D.%0D%0A%09%5Eself%20error%3A%20%27Invalid%20%28Boolean%29accessors.%27"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildBooleanGetters:","buildBooleanGetters_"

,function (specs){var self=this;try{((specs.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildBooleanGetters_", fn: function(){return self.buildBooleanGetters_(specs.asArrayOfSubstrings())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildBooleanGetters_", fn: function(){return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildBooleanGetter_(each));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildBooleanGetters_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildBooleanGetters%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20get%20instancess.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildBooleanGetters%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildBooleanGetter%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildBooleanAccessors:","buildBooleanAccessors_"

,function (specs){var self=this;try{((specs.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildBooleanAccessors_", fn: function(){return self.buildBooleanAccessors_(specs.asArrayOfSubstrings())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildBooleanAccessors_", fn: function(){return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildBooleanAccessor_(each));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildBooleanAccessors_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildBooleanAccessors%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20access%20instances.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildBooleanAccessors%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildBooleanAccessor%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildSubclasses:","buildSubclasses_"

,function (aCollection){var self=this;var result=nil;aCollection.do_((function(tuple){return result=((tuple.isString()).mustBeBoolean()==true ? (function(){return self.buildSubclass_arguments_typed_(tuple, [], []);})() : (function(){return ((tuple.size()._eq((2))).mustBeBoolean()==true ? (function(){return self.buildSubclass_arguments_typed_(tuple.first(), tuple.second(), []);})() : (function(){return self.buildSubclass_arguments_typed_(tuple.first(), tuple.second(), tuple.last());})());})());}));

return result;return self;}

,unescape("code%20generation"),unescape("buildSubclasses%3A%20aCollection%0D%0A%09%22%20Private%20-%20Build%20aCollection%20of%20subclasses%20of%20the%20receiver%20as%20wrappers%20to%20the%20library.%0D%0A%09Return%20the%20last%20class%20created%20%28or%20nil%29.%0D%0A%09%22%0D%0A%20%0D%0A%09%7C%20result%20%7C%0D%0A%09aCollection%20do%3A%20%5B%3Atuple%7C%0D%0A%09%09result%20%3A%3D%20tuple%20isString%0D%0A%09%09ifTrue%3A%20%5B%20self%20buildSubclass%3A%20tuple%20arguments%3A%20%23%28%29%20typed%3A%20%23%28%29%20%5D%0D%0A%09%09ifFalse%3A%20%5B%0D%0A%09%09%09tuple%20size%20%3D%202%0D%0A%09%09%09ifTrue%3A%20%5B%20self%20buildSubclass%3A%20tuple%20first%20arguments%3A%20tuple%20second%20typed%3A%20%23%28%29%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20self%20buildSubclass%3A%20tuple%20first%20arguments%3A%20tuple%20second%20typed%3A%20tuple%20last%20%5D%0D%0A%09%09%20%5D%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildHierarchy:","buildHierarchy_"

,function (aCollection){var self=this;var stream=nil;var aClass=nil;stream=aCollection.stream();

(function(){while(!(function(){return stream.atEnd();})()){(function(){aClass=self.buildSubclasses_(smalltalk.Array.with_(stream.next()));return ((stream.peek().isArray()).mustBeBoolean()==true ? (function(){return aClass.buildHierarchy_(stream.next());})() : nil);})()};return nil})();return self;}

,unescape("code%20generation"),unescape("buildHierarchy%3A%20aCollection%0D%0A%09%22%20Private%20-%20Build%20aCollection%20of%20subclasses%20of%20the%20receiver%20as%20wrappers%20to%20the%20library.%20%22%0D%0A%20%0D%0A%09%7C%20stream%20aClass%20%7C%0D%0A%09stream%20%3A%3D%20aCollection%20stream.%0D%0A%09%5B%20stream%20atEnd%20%5D%20whileFalse%3A%20%5B%0D%0A%09%09aClass%20%3A%3D%20self%20buildSubclasses%3A%20%28Array%20with%3A%20stream%20next%29.%0D%0A%09%09stream%20peek%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09%09aClass%20buildHierarchy%3A%20stream%20next%0D%0A%09%09%5D.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildSubclass:arguments:typed:","buildSubclass_arguments_typed_"

,function (globalClassName,argList,typedArguments){var self=this;var cls=nil;var clsName=nil;clsName=globalClassName.first().asUppercase()._comma(globalClassName.copyFrom_to_((2), globalClassName.size()));

clsName=self.classToken()._comma(clsName);

self.subclass_instanceVariableNames_category_(clsName, "", self.category());

return smalltalk.Smalltalk.at_(clsName);return self;}

,unescape("code%20generation"),unescape("buildSubclass%3A%20globalClassName%20arguments%3A%20argList%20typed%3A%20typedArguments%0D%0A%09%22%20Private%20-%20Build%20a%20subclass%20of%20the%20receiver%20implementing%20a%20wrapper%20to%20the%20library.%0D%0A%09Note%3A%20argList%20and%20typed%20arguments%20are%20ignored%3B%20see%20subclasses%20to%20find%20concrete%20implementors.%0D%0A%09Return%20the%20created%20class.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20cls%20clsName%20%7C%0D%0A%09clsName%20%3A%3D%20globalClassName%20first%20asUppercase%0D%0A%09%09%09%2C%28globalClassName%20copyFrom%3A%202%20to%3A%20globalClassName%20size%29.%0D%0A%09clsName%20%3A%3D%20self%20classToken%20%2CclsName.%0D%0A%09self%0D%0A%09%09subclass%3A%20clsName%0D%0A%09%09instanceVariableNames%3A%20%27%27%0D%0A%09%09category%3A%20self%20category.%0D%0A%09%5ESmalltalk%20at%3A%20clsName"));

smalltalk.bind(smalltalk.NativeObject.$klass,"classToken","classToken"

,function (){var self=this;return "";return self;}

,unescape("code%20generation"),unescape("classToken%0D%0A%09%22%20Private%20-%20Return%20the%20classToken%20to%20prepend/tag%20the%20receiver.%0D%0A%09The%20default%20answer%20is%20empty.%0D%0A%09The%20subclasses%20can%20subclass%20to%20build%20tagged%20subclasses.%0D%0A%09%22%0D%0A%0D%0A%09%5E%27%27"));

smalltalk.bind(smalltalk.NativeObject.$klass,"classToken:","classToken_"

,function (aToken){var self=this;return self.implement_comment_as_category_("classToken", unescape("Private%20-%20Return%20the%20classToken%20to%20prepend/tag%20the%20receiver."), aToken.printString(), "code generation");return self;}

,unescape("code%20generation"),unescape("classToken%3A%20aToken%0D%0A%09%22%20Private%20-%20Generate%20code%20to%20return%20the%20classToken%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%23classToken%0D%0A%09%09comment%3A%20%27Private%20-%20Return%20the%20classToken%20to%20prepend/tag%20the%20receiver.%27%0D%0A%09%09as%3A%20aToken%20printString%0D%0A%09%09category%3A%20%27code%20generation%27"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildFunctions:","buildFunctions_"

,function (selectors){var self=this;selectors.do_((function(each){return self.buildFunction_(each);}));return self;}

,unescape("code%20generation"),unescape("buildFunctions%3A%20selectors%0D%0A%09%22%20Private%20-%20Generate%20code%20to%20delegate%20selectors%20as%20functions%20implemented%20by%20instance%20handle.%20%22%0D%0A%0D%0A%09selectors%20do%3A%20%5B%3Aeach%7C%20self%20buildFunction%3A%20each%20%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildFunction:","buildFunction_"

,function (selector){var self=this;try{((selector.isArray()).mustBeBoolean()==true ? (function(){return ((selector.last().isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildFunction_", fn: function(){return self.buildFunction_prologue_epilogue_(selector.first(), selector.last()._comma(unescape("%20@%20%28")), unescape("%29"))}})})();})() : nil);})() : nil);

(function(){throw({name: "stReturn", selector: "buildFunction_", fn: function(){return self.buildFunction_prologue_epilogue_(selector, "", "")}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildFunction_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildFunction%3A%20selector%0D%0A%09%22%20Private%20-%20Generate%20code%20to%20delegate%20message%20implemented%20as%20functions%20on%20instance%20handle.%0D%0A%09selector%20can%20be%3A%0D%0A%09%09aSymbol%20%28e.g.%20any%20smalltalk%20message%20selector%29%0D%0A%09%09%23%28%20selector%20%23ReturnClassName%20%29%0D%0A%09%09%23%28%20selector%20%23%28%20argumentNames%20%29%20%29%0D%0A%09%09%23%28%20%23%28%20selector%20%23%28%20argumentNames%20%29%20%29%20%23ReturnClassName%20%29%0D%0A%09argumentNames%20must%20match%20selector%20pattern%0D%0A%09if%20argumentNames%20is%20not%20given%2C%20it%20will%20be%20computed%20from%20selector%20pattern%0D%0A%09The%20function%20will%20return%20the%20result%20of%20calling%20the%20handle%2C%20or%20a%20wrapped%20to%20an%20instance%20of%20ReturnClassName%20%28expected%20to%20be%20subclass%20of%20NativeObject%29.%0D%0A%09%22%0D%0A%0D%0A%09selector%20isArray%20ifTrue%3A%20%5B%0D%0A%09%20%20%20%20selector%20last%20isString%20ifTrue%3A%20%5B%20%22%23%28%20selector%20%23RETURNClass%20%29%22%0D%0A%09%09%5Eself%0D%0A%09%09%09buildFunction%3A%20selector%20first%0D%0A%09%09%09prologue%3A%20selector%20last%20%2C%27%20@%20%28%27%0D%0A%09%09%09epilogue%3A%20%27%29%27%0D%0A%09%20%20%20%20%5D.%20%0D%0A%09%5D.%0D%0A%09%5Eself%20buildFunction%3A%20selector%20prologue%3A%20%27%27%20epilogue%3A%20%27%27"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildFunction:prologue:epilogue:","buildFunction_prologue_epilogue_"

,function (selector,prologue,epilogue){var self=this;try{var args=nil;((selector.isArray()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildFunction_prologue_epilogue_", fn: function(){return self.buildFunction_arguments_prologue_epilogue_(selector.first(), selector.last(), prologue, epilogue)}})})();})() : nil);

args=(1).to_(selector.occurrencesOf_(":")).collect_((function(i){return "arg"._comma(i.asString());}));

((args.size()._eq((1))).mustBeBoolean()==true ? (function(){return args=["anObject"];})() : nil);

(function(){throw({name: "stReturn", selector: "buildFunction_prologue_epilogue_", fn: function(){return self.buildFunction_arguments_prologue_epilogue_(selector, args, prologue, epilogue)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildFunction_prologue_epilogue_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildFunction%3A%20selector%20prologue%3A%20prologue%20epilogue%3A%20epilogue%20%0D%0A%09%22%20Private%20-%20Generate%20code%20to%20delegate%20message%20on%20instance%20handle.%20%22%0D%0A%0D%0A%09%7C%20args%20%7C%0D%0A%09selector%20isArray%20ifTrue%3A%20%5B%20%22%23%28%20selector%20%23%28argumentNames%29%20%29%22%0D%0A%09%09%5Eself%09buildFunction%3A%20selector%20first%0D%0A%09%09%09arguments%3A%20selector%20last%0D%0A%09%09%09prologue%3A%20prologue%20epilogue%3A%20epilogue%0D%0A%09%5D.%0D%0A%09args%20%3A%3D%20%20%281%20to%3A%20%28selector%20occurrencesOf%3A%20%24%3A%29%29%20collect%3A%20%5B%3Ai%7C%20%23arg%20%2C%20i%20asString%20%5D.%0D%0A%09args%20size%20%3D%201%20ifTrue%3A%20%5B%20args%20%3A%3D%20%23%28%20%23anObject%20%29%20%5D.%0D%0A%09%5Eself%0D%0A%09%09buildFunction%3A%20selector%20arguments%3A%20args%0D%0A%09%09prologue%3A%20prologue%20epilogue%3A%20epilogue%20"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildFunction:arguments:prologue:epilogue:","buildFunction_arguments_prologue_epilogue_"

,function (selector,args,prologue,epilogue){var self=this;var header=nil;var code=nil;var input=nil;var argStream=nil;var msg=nil;input=selector.stream();

argStream=args.stream();

header="".stream();

code="".stream();

code.nextPut_(input.peek());

header.nextPut_(input.next().asLowercase());

(function(){while(!(function(){return argStream.atEnd();})()){(function(){var param=nil;var expr=nil;((argStream.peek().isString()).mustBeBoolean()==true ? (function(){param=argStream.next();return expr=param;})() : (function(){param=argStream.peek().first();return expr=param._comma(" ")._comma(argStream.next().last());})());msg=input.upTo_(":")._comma(": ");code.nextPutAll_(msg._comma(expr)._comma(" "));return header.nextPutAll_(msg._comma(param)._comma(" "));})()};return nil})();

msg=input.upToEnd();

code.nextPutAll_(msg);

header.nextPutAll_(msg);

self.implement_comment_as_category_(self.stMessageHeader_(header.contents()), "Wrap method delegating "._comma(selector)._comma(" to handle."), unescape("%5E")._comma(prologue)._comma(unescape("self%20handle%20%23"))._comma(code.contents())._comma(epilogue), "wrappers");return self;}

,unescape("code%20generation"),unescape("buildFunction%3A%20selector%20arguments%3A%20args%20prologue%3A%20prologue%20epilogue%3A%20epilogue%20%0D%0A%09%22%20Private%20-%20Generate%20code%20to%20delegate%20message%20on%20instance%20handle.%20%22%0D%0A%0D%0A%09%7C%20header%20code%20input%20argStream%20msg%20%7C%0D%0A%09input%20%3A%3D%20selector%20stream.%0D%0A%09argStream%20%3A%3D%20args%20stream.%0D%0A%09header%20%3A%3D%20%27%27%20stream.%20code%20%3A%3D%20%27%27%20stream.%0D%0A%09code%20%20%20nextPut%3A%20input%20peek.%0D%0A%09header%20nextPut%3A%20input%20next%20asLowercase.%0D%0A%09%5B%20argStream%20atEnd%20%5D%20whileFalse%3A%20%5B%20%7C%20param%20expr%20%7C%0D%0A%09%09argStream%20peek%20isString%0D%0A%09%09ifTrue%3A%20%5B%20param%20%3A%3D%20argStream%20next.%20expr%20%3A%3D%20param%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20param%20%3A%3D%20argStream%20peek%20first.%20expr%20%3A%3D%20param%20%2C%27%20%27%20%2CargStream%20next%20last.%20%5D.%0D%0A%09%09msg%20%3A%3D%20%28input%20upTo%3A%20%24%3A%29%20%2C%27%3A%20%27.%0D%0A%09%09code%20%20%20nextPutAll%3A%20msg%2C%20expr%20%2C%27%20%27.%0D%0A%09%09header%20nextPutAll%3A%20msg%2C%20param%20%2C%27%20%27.%0D%0A%09%5D.%0D%0A%09msg%20%3A%3D%20input%20upToEnd.%0D%0A%09code%20%20%20nextPutAll%3A%20msg.%0D%0A%09header%20nextPutAll%3A%20msg.%0D%0A%0D%0A%09self%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20header%20contents%29%0D%0A%09%09%20%20comment%3A%20%27Wrap%20method%20delegating%20%27%2Cselector%2C%27%20to%20handle.%27%0D%0A%09%09%20%20as%3A%20%27%5E%27%0D%0A%09%09%09%2C%20prologue%0D%0A%09%09%09%2C%27self%20handle%20%23%27%2Ccode%20contents%0D%0A%09%09%09%2C%20epilogue%0D%0A%09%09%20%20category%3A%20%23wrappers"));

smalltalk.bind(smalltalk.NativeObject.$klass,"@","_at"

,function (handle){var self=this;return self.basicNew().handle_(handle);return self;}

,unescape("instance%20creation"),unescape("@%20handle%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicNew%20handle%3A%20handle"));

smalltalk.bind(smalltalk.NativeObject.$klass,"empty","empty"

,function (){var self=this;return self._at(smalltalk.Object.$$new().json());return self;}

,unescape("instance%20creation"),unescape("empty%0D%0A%09%22%20Return%20an%20empty%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20Object%20new%20json"));

smalltalk.bind(smalltalk.NativeObject.$klass,"for:","for_"

,function (handle){var self=this;return self.basicNew().handle_(handle);return self;}

,unescape("instance%20creation"),unescape("for%3A%20handle%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicNew%20handle%3A%20handle"));

smalltalk.bind(smalltalk.NativeObject.$klass,"from:","from_"

,function (aNativeObject){var self=this;return self.basicNew().copyFrom_(aNativeObject);return self;}

,unescape("instance%20creation"),unescape("from%3A%20aNativeObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicNew%20copyFrom%3A%20aNativeObject"));

smalltalk.bind(smalltalk.NativeObject.$klass,"html5Events","html5Events"

,function (){var self=this;return [];return self;}

,"events",unescape("html5Events%0D%0A%09%22%20Private%20-%20Return%20the%20html5%20events+notifications%20managed%20by%20instances%20of%20the%20receiver.%0D%0A%09Default%20answer%20is%20empty%2C%20this%20method%20can%20be%20refined%20by%20subclasses%20to%20handle%20html5%20events.%0D%0A%09%22%0D%0A%09%5E%23%28%29"));

smalltalk.bind(smalltalk.NativeObject.$klass,"localEvents","localEvents"

,function (){var self=this;return [];return self;}

,"events",unescape("localEvents%0D%0A%09%22%20Private%20-%20Return%20the%20smalltalk%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%23%28%29"));

smalltalk.bind(smalltalk.NativeObject.$klass,"constructEventsTriggered","constructEventsTriggered"

,function (){var self=this;return self.html5Events()._comma(self.localEvents())._comma(smalltalk.whoImplements(smalltalk.NativeObject.$klass,'constructEventsTriggered').$superclass.$fn.prototype['constructEventsTriggered'].apply(self, []));return self;}

,"events",unescape("constructEventsTriggered%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20html5Events%0D%0A%09%2Cself%20localEvents%0D%0A%09%2Csuper%20constructEventsTriggered"));

smalltalk.bind(smalltalk.NativeObject.$klass,"buildHTML5Events:","buildHTML5Events_"

,function (selectors){var self=this;self.$klass.implement_comment_as_category_("html5Events", unescape("Private%20-%20Return%20the%20html5%20events%20managed%20by%20instances%20of%20the%20receiver."), unescape("%5E%23%28%20")._comma(selectors.inject_into_("", (function(total, each){return total._comma(unescape("%23"))._comma(each)._comma(" ");})))._comma(unescape("%29%20%2C%20super%20html5Events")), "events");

self.buildGetters_(selectors.collect_((function(each){return self.selectorForHTML5Event_(each);})));return self;}

,unescape("code%20generation"),unescape("buildHTML5Events%3A%20selectors%0D%0A%09%22%20Private%20-%20Generate%20code%20to%20route%20events%20to%20handle.%20%22%0D%0A%0D%0A%09self%20class%0D%0A%09%09implement%3A%20%23html5Events%0D%0A%09%09comment%3A%20%27Private%20-%20Return%20the%20html5%20events%20managed%20by%20instances%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5E%23%28%20%27%20%2C%28selectors%20inject%3A%20%27%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%0D%0A%09%09%09total%20%2C%27%23%27%2Ceach%20%2C%27%20%27%0D%0A%09%09%09%5D%29%2C%27%29%20%2C%20super%20html5Events%27%0D%0A%09%09category%3A%20%23events.%0D%0A%09self%20buildGetters%3A%20%28selectors%20collect%3A%20%5B%3Aeach%7C%0D%0A%09%09self%20selectorForHTML5Event%3A%20each%0D%0A%09%5D%29"));

smalltalk.bind(smalltalk.NativeObject.$klass,"selectorForEvent:","selectorForEvent_"

,function (anEvent){var self=this;try{((self.localEvents().includes_(anEvent)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "selectorForEvent_", fn: function(){return nil}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "selectorForEvent_", fn: function(){return ((self.html5Events().includes_(anEvent)).mustBeBoolean()==true ? (function(){return self.selectorForHTML5Event_(anEvent);})() : nil)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "selectorForEvent_"){return $$ex.fn();} throw($$ex);}}

,"events",unescape("selectorForEvent%3A%20anEvent%0D%0A%09%22%20Private%20-%20Return%20the%20on...%20selector%20to%20use%20to%20register%20binding%20to%20anEvent.%20%22%0D%0A%0D%0A%09%28self%20localEvents%20includes%3A%20anEvent%29%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09%5E%28self%20html5Events%20includes%3A%20anEvent%29%20ifTrue%3A%20%5B%0D%0A%09%09self%20selectorForHTML5Event%3A%20anEvent%0D%0A%09%5D"));

smalltalk.bind(smalltalk.NativeObject.$klass,"selectorForHTML5Event:","selectorForHTML5Event_"

,function (anEvent){var self=this;return "on"._comma(anEvent.upTo_(":").asSmalltalkName_(true));return self;}

,"events",unescape("selectorForHTML5Event%3A%20anEvent%0D%0A%09%22%20Private%20-%20Return%20the%20on...%20selector%20to%20use%20to%20register%20binding%20to%20anEvent.%20%22%0D%0A%0D%0A%09%5E%23on%20%2C%20%28%28anEvent%20upTo%3A%20%24%3A%29%20asSmalltalkName%3A%20true%29"));

smalltalk.bind(smalltalk.NativeObject,"as:","as_"

,function (aNativeObjectClass){var self=this;return aNativeObjectClass.from_(self);return self;}

,"converting",unescape("as%3A%20aNativeObjectClass%0D%0A%09%22%20Return%20the%20receiver%20casted%20to%20aNativeObjectClass.%20%22%0D%0A%0D%0A%09%5EaNativeObjectClass%20from%3A%20self"));

smalltalk.bind(smalltalk.NativeObject,"handle","handle"

,function (){var self=this;((((self['@handle'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeHandle();})() : nil);

return self['@handle'];return self;}

,"accessing",unescape("handle%0D%0A%09%22%20Return%20the%20native%20handle.%20%22%0D%0A%0D%0A%09handle%20isNil%20ifTrue%3A%20%5B%20self%20initializeHandle%20%5D.%0D%0A%09%5Ehandle"));

smalltalk.bind(smalltalk.NativeObject,"handleOrNil","handleOrNil"

,function (){var self=this;return self['@handle'];return self;}

,"private",unescape("handleOrNil%0D%0A%09%22%20Return%20the%20native%20handle%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Ehandle"));

smalltalk.bind(smalltalk.NativeObject,"=","_eq"

,function (anObject){var self=this;try{(((self === anObject)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return true}})})();})() : nil);

((self.isObject_(anObject)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());

((anObject.respondsTo_("handle")).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());

(function(){throw({name: "stReturn", selector: "_eq", fn: function(){return (self['@handle'] === anObject.handleOrNil())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_eq"){return $$ex.fn();} throw($$ex);}}

,"query",unescape("%3D%20anObject%0D%0A%0D%0A%09self%20%3D%3D%20anObject%20ifTrue%3A%20%5B%20%5Etrue%20%5D.%0D%0A%09%28self%20isObject%3A%20anObject%29%20ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%28anObject%20respondsTo%3A%20%23handle%29%20ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%5Ehandle%20%3D%3D%20anObject%20handleOrNil%20"));

smalltalk.bind(smalltalk.NativeObject,"handle:","handle_"

,function (anAlien){var self=this;try{self['@handle']=anAlien;

((((self['@handle'] || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "handle_", fn: function(){return nil}})})();})() : nil);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "handle_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("handle%3A%20anAlien%0D%0A%09%22%20Set%20the%20native%20handle%20to%20a%20potentialy%20non-StObject.%0D%0A%09Return%20the%20receiver%2C%20or%20nil%20if%20the%20receiver%20is%20void.%0D%0A%09%22%0D%0A%0D%0A%09handle%20%3A%3D%20anAlien.%0D%0A%09handle%20isNil%20ifTrue%3A%20%5B%20%5Enil%20%5D."));

smalltalk.bind(smalltalk.NativeObject,"jsonHiddenNames","jsonHiddenNames"

,function (){var self=this;return ["handle"];return self;}

,"converting",unescape("jsonHiddenNames%0D%0A%09%22%20Private%20-%20Return%20the%20names%20of%20the%20instance%20variables%20to%20skip%20when%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5E%23%28%20%23handle%20%29"));

smalltalk.bind(smalltalk.NativeObject,"basicJson","basicJson"

,function (){var self=this;return smalltalk.whoImplements(smalltalk.NativeObject,'json').$superclass.$fn.prototype['json'].apply(self, []);return self;}

,"converting",unescape("basicJson%0D%0A%09%22%20Convert%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Esuper%20json"));

smalltalk.bind(smalltalk.NativeObject,"json","json"

,function (){var self=this;return self.handle();return self;}

,"converting",unescape("json%0D%0A%09%22%20Convert%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Eself%20handle"));

smalltalk.bind(smalltalk.NativeObject,"handleOf:","handleOf_"

,function (jsObject){var self=this;return ((((jsObject || nil) !== nil)).mustBeBoolean()==true ? (function(){return ((self.isObject_(jsObject)).mustBeBoolean()==true ? (function(){return jsObject.handle();})() : (function(){return jsObject;})());})() : (function(){return undefined;})());return self;}

,"utilities",unescape("handleOf%3A%20jsObject%0D%0A%09%22%20Private%20-%20Return%20the%20handle%20of%20jsObject%20%28or%20the%20object%29.%20%22%0D%0A%0D%0A%09%5EjsObject%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%28self%20isObject%3A%20jsObject%29%0D%0A%09%09ifTrue%3A%20%5B%20jsObject%20handle%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20jsObject%20%5D%0D%0A%09%5D%20ifFalse%3A%20%5B%20%23%7Bundefined%7D%20%5D"));

smalltalk.bind(smalltalk.NativeObject,"@","_at"

,function (propertyName){var self=this;return self['@handle'][propertyName];return self;}

,"accessing",unescape("@%20propertyName%0D%0A%09%22%20Return%20the%20property%20at%20propertyName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%5BpropertyName%5D"));

smalltalk.bind(smalltalk.NativeObject,"handleAt:","handleAt_"

,function (propertyName){var self=this;return self['@handle'][propertyName];return self;}

,"accessing",unescape("handleAt%3A%20propertyName%0D%0A%09%22%20Return%20the%20property%20at%20propertyName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%5BpropertyName%5D"));

smalltalk.bind(smalltalk.NativeObject,"handleAt:put:","handleAt_put_"

,function (propertyName,anObject){var self=this;return self['@handle'][propertyName]=anObject;return self;}

,"accessing",unescape("handleAt%3A%20propertyName%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20property%20at%20propertyName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%5BpropertyName%5D%20%3A%3D%20anObject"));

smalltalk.bind(smalltalk.NativeObject,"initializeHandle","initializeHandle"

,function (){var self=this;return self.error_("Missing "._comma(self.$klass.name())._comma(unescape("%3E%3E%23initializeHandle")));return self;}

,"initialize/release",unescape("initializeHandle%0D%0A%09%22%20Private%20-%20Initialize%20the%20native%20handle.%0D%0A%09This%20method%20must%20be%20implemented%20by%20subclasses.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20error%3A%20%27Missing%20%27%0D%0A%09%09%2Cself%20class%20name%0D%0A%09%09%2C%27%3E%3E%23initializeHandle%27"));

smalltalk.bind(smalltalk.NativeObject,"releaseHandle","releaseHandle"

,function (){var self=this;self['@handle']=nil;return self;}

,"initialize/release",unescape("releaseHandle%0D%0A%09%22%20Private%20-%20Release%20the%20native%20handle.%0D%0A%09The%20default%20implementation%20clear%20handle.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses%20to%20free%20external%20resources.%0D%0A%09%22%0D%0A%0D%0A%09handle%20%3A%3D%20nil"));

smalltalk.bind(smalltalk.NativeObject,"release","release"

,function (){var self=this;self.releaseHandle();

return smalltalk.whoImplements(smalltalk.NativeObject,'release').$superclass.$fn.prototype['release'].apply(self, []);return self;}

,"initialize/release",unescape("release%0D%0A%09%22%20Private%20-%20Release%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20releaseHandle.%0D%0A%09%5Esuper%20release"));

smalltalk.bind(smalltalk.NativeObject,"copyFrom:","copyFrom_"

,function (aNativeObject){var self=this;self['@handle']=aNativeObject.handle();return self;}

,"copying",unescape("copyFrom%3A%20aNativeObject%0D%0A%09%22%20Copy%20receiver%27s%20contents%20from%20the%20native%20object.%20%22%0D%0A%0D%0A%09handle%20%3A%3D%20aNativeObject%20handle."));

smalltalk.bind(smalltalk.NativeObject,"shallowCopy","shallowCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.NativeObject,"deepCopy","deepCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.NativeObject,"closureForEvent:","closureForEvent_"

,function (selector){var self=this;try{var argumentCount=nil;argumentCount=selector.argumentCount();

((argumentCount._eq((0))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "closureForEvent_", fn: function(){return (function(){return self.triggerEvent_(selector);})}})})();})() : nil);

((argumentCount._eq((1))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "closureForEvent_", fn: function(){return (function(arg1){return self.triggerEvent_with_(selector, arg1);})}})})();})() : nil);

((argumentCount._eq((2))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "closureForEvent_", fn: function(){return (function(arg1, arg2){return self.triggerEvent_with_with_(selector, arg1, arg2);})}})})();})() : nil);

((argumentCount._eq((3))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "closureForEvent_", fn: function(){return (function(arg1, arg2, arg3){return self.triggerEvent_withArguments_(selector, smalltalk.Array.with_with_with_(arg1, arg2, arg3));})}})})();})() : nil);

((argumentCount._eq((4))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "closureForEvent_", fn: function(){return (function(arg1, arg2, arg3, arg4){return self.triggerEvent_withArguments_(selector, smalltalk.Array.with_with_with_with_(arg1, arg2, arg3, arg4));})}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "closureForEvent_", fn: function(){return self.error_("Invalid argument count")}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "closureForEvent_"){return $$ex.fn();} throw($$ex);}}

,"events",unescape("closureForEvent%3A%20selector%0D%0A%09%22%20Private%20-%20Return%20the%20closure%20to%20handle%20event%20selector.%20%22%0D%0A%0D%0A%09%7C%20argumentCount%20%7C%0D%0A%09argumentCount%20%3A%3D%20selector%20argumentCount.%0D%0A%09argumentCount%20%3D%200%20ifTrue%3A%20%5B%20%5E%5B%20self%20triggerEvent%3A%20selector%20%5D%20%5D.%0D%0A%09argumentCount%20%3D%201%20ifTrue%3A%20%5B%20%5E%5B%3Aarg1%7C%20self%20triggerEvent%3A%20selector%20with%3A%20arg1%20%5D%20%5D.%0D%0A%09argumentCount%20%3D%202%20ifTrue%3A%20%5B%20%5E%5B%3Aarg1%20%3Aarg2%7C%20self%20triggerEvent%3A%20selector%20with%3A%20arg1%20with%3A%20arg2%20%5D%20%5D.%0D%0A%09argumentCount%20%3D%203%20ifTrue%3A%20%5B%20%5E%5B%3Aarg1%20%3Aarg2%20%3Aarg3%7C%20self%20triggerEvent%3A%20selector%20withArguments%3A%20%28Array%20with%3A%20arg1%20with%3A%20arg2%20with%3A%20arg3%29%20%5D%20%5D.%0D%0A%09argumentCount%20%3D%204%20ifTrue%3A%20%5B%20%5E%5B%3Aarg1%20%3Aarg2%20%3Aarg3%20%3Aarg4%7C%20self%20triggerEvent%3A%20selector%20withArguments%3A%20%28Array%20with%3A%20arg1%20with%3A%20arg2%20with%3A%20arg3%20with%3A%20arg4%29%20%5D%20%5D.%0D%0A%09%5Eself%20error%3A%20%27Invalid%20argument%20count%27"));

smalltalk.bind(smalltalk.NativeObject,"when:evaluate:","when_evaluate_"

,function (anEvent,anAction){var self=this;var result=nil;var closure=nil;var needsRegistration=nil;needsRegistration=((self.eventTable().at_ifAbsent_(anEvent, (function(){return nil;})) || nil) === nil);

result=smalltalk.whoImplements(smalltalk.NativeObject,'when_evaluate_').$superclass.$fn.prototype['when_evaluate_'].apply(self, [anEvent, anAction]);

((needsRegistration).mustBeBoolean()==true ? (function(){return self.registerEvent_doing_(anEvent, self.closureForEvent_(anEvent));})() : nil);

return result;return self;}

,"events",unescape("when%3A%20anEvent%20evaluate%3A%20anAction%0D%0A%09%22%20Register%20anAction%20to%20the%20be%20evaluated%20when%20the%20receiver%20triggers%20the%20event.%20%22%0D%0A%0D%0A%09%7C%20result%20closure%20needsRegistration%20%7C%0D%0A%09needsRegistration%20%3A%3D%20%28self%20eventTable%20at%3A%20anEvent%20ifAbsent%3A%20%5Bnil%5D%29%20isNil.%0D%0A%09result%20%3A%3D%20super%20when%3A%20anEvent%20evaluate%3A%20anAction.%0D%0A%09needsRegistration%20ifTrue%3A%20%5B%0D%0A%09%09self%09registerEvent%3A%20anEvent%0D%0A%09%09%09doing%3A%20%28self%20closureForEvent%3A%20anEvent%29.%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeObject,"registerEvent:doing:","registerEvent_doing_"

,function (anEvent,closure){var self=this;try{var onSelector=nil;onSelector=self.$klass.selectorForEvent_(anEvent);

((((onSelector || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "registerEvent_doing_", fn: function(){return self}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "registerEvent_doing_", fn: function(){return self.bindEvent_doing_(onSelector, closure)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "registerEvent_doing_"){return $$ex.fn();} throw($$ex);}}

,"events",unescape("registerEvent%3A%20anEvent%20doing%3A%20closure%0D%0A%09%22%20Private%20-%20Register%20basic%20event%20handler.%20%22%0D%0A%0D%0A%09%7C%20onSelector%20%7C%0D%0A%09onSelector%20%3A%3D%20self%20class%20selectorForEvent%3A%20anEvent.%0D%0A%09onSelector%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%20%22local/smalltalk%20event%22%0D%0A%09%5Eself%20bindEvent%3A%20onSelector%20doing%3A%20closure"));

smalltalk.bind(smalltalk.NativeObject,"bindEvent:doing:","bindEvent_doing_"

,function (onSelector,closure){var self=this;var $$native=nil;$$native=self.handle();

(((($$native[onSelector] || nil) === nil)).mustBeBoolean()==true ? (function(){return $$native[onSelector]=closure;})() : (function(){return $$native[onSelector].addListener(closure.json());})());return self;}

,"events",unescape("bindEvent%3A%20onSelector%20doing%3A%20closure%0D%0A%09%22%20Private%20-%20Bind%20the%20event%20handler.%20%22%0D%0A%0D%0A%09%7C%20native%20%7C%0D%0A%09native%20%3A%3D%20self%20handle.%0D%0A%09native%5BonSelector%5D%20isNil%20ifTrue%3A%20%5B%0D%0A%09%09native%5BonSelector%5D%20%3A%3D%20closure%0D%0A%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09native%5BonSelector%5D%20%23addListener%3A%20closure%20json%0D%0A%09%5D"));

smalltalk.bind(smalltalk.NativeObject,"description","description"

,function (){var self=this;return smalltalk.JS._at(self.handle()).description();return self;}

,"debug",unescape("description%0D%0A%09%22%20Return%20a%20string%20description%20from%20receiver%27s%20properties.%20%22%0D%0A%0D%0A%09%5E%28JS%20@%20self%20handle%29%20description"));

smalltalk.bind(smalltalk.NativeObject,"asJS","asJS"

,function (){var self=this;return smalltalk.JS._at(self.handle());return self;}

,"converting",unescape("asJS%0D%0A%09%22%20Convert%20the%20receiver%20to%20JS%20instance%20%28for%20reflection%29.%20%22%0D%0A%0D%0A%09%5EJS%20@%20self%20handle"));

smalltalk.bind(smalltalk.RegularExpression.$klass,"fromString:flag:","fromString_flag_"

,function (aString,anotherString){var self=this;	return new RegExp(aString, anotherString);;return self;}

,unescape("instance%20creation"),unescape("fromString%3A%20aString%20flag%3A%20anotherString%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20new%20RegExp%28aString%2C%20anotherString%29%3B%27%7D"));

smalltalk.bind(smalltalk.RegularExpression.$klass,"fromString:","fromString_"

,function (aString){var self=this;return self.fromString_flag_(aString, "");return self;}

,unescape("instance%20creation"),unescape("fromString%3A%20aString%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%20%20%20%20%5Eself%20fromString%3A%20aString%20flag%3A%20%27%27"));

smalltalk.bind(smalltalk.RegularExpression,"compile:","compile_"

,function (aString){var self=this;return self.compile(aString);return self;}

,"evaluating",unescape("compile%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20compilation%20of%20aString.%20%22%0D%0A%0D%0A%09%5Eself%20%23compile%3A%20aString"));

smalltalk.bind(smalltalk.RegularExpression,"exec:","exec_"

,function (aString){var self=this;return self.exec(aString);return self;}

,"evaluating",unescape("exec%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20excecution%20of%20aString.%20%22%0D%0A%0D%0A%09%5Eself%20%23exec%3A%20aString"));

smalltalk.bind(smalltalk.RegularExpression,"test:","test_"

,function (aString){var self=this;return self.test_(aString);return self;}

,"evaluating",unescape("test%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20testing%20of%20aString.%20%22%0D%0A%0D%0A%09%5Eself%20test%3A%20aString"));

smalltalk.bind(smalltalk.RegularExpression,"shallowCopy","shallowCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.RegularExpression,"deepCopy","deepCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Collection.$klass,"streamClass","streamClass"

,function (){var self=this;return smalltalk.Stream;return self;}

,"accessing",unescape("streamClass%0D%0A%09%22%20Private%20-%20Return%20the%20support%20for%20streamming%20on%20the%20receiver%27s%20instances.%20%22%0D%0A%0D%0A%09%20%20%20%20%5EStream"));

smalltalk.bind(smalltalk.Collection.$klass,"with:","with_"

,function (anObject){var self=this;return (function($rec){$rec.add_(anObject);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("with%3A%20anObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09add%3A%20anObject%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Collection.$klass,"with:with:","with_with_"

,function (anObject,anotherObject){var self=this;return (function($rec){$rec.add_(anObject);$rec.add_(anotherObject);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("with%3A%20anObject%20with%3A%20anotherObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09add%3A%20anObject%3B%0D%0A%09%09add%3A%20anotherObject%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Collection.$klass,"with:with:with:","with_with_with_"

,function (firstObject,secondObject,thirdObject){var self=this;return (function($rec){$rec.add_(firstObject);$rec.add_(secondObject);$rec.add_(thirdObject);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("with%3A%20firstObject%20with%3A%20secondObject%20with%3A%20thirdObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09add%3A%20firstObject%3B%0D%0A%09%09add%3A%20secondObject%3B%0D%0A%09%09add%3A%20thirdObject%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Collection.$klass,"with:with:with:with:","with_with_with_with_"

,function (firstObject,secondObject,thirdObject,fourthObject){var self=this;return (function($rec){$rec.add_(firstObject);$rec.add_(secondObject);$rec.add_(thirdObject);$rec.add_(fourthObject);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("with%3A%20firstObject%20with%3A%20secondObject%20with%3A%20thirdObject%20with%3A%20fourthObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09add%3A%20firstObject%3B%0D%0A%09%09add%3A%20secondObject%3B%0D%0A%09%09add%3A%20thirdObject%3B%0D%0A%09%09add%3A%20fourthObject%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Collection.$klass,"withAll:","withAll_"

,function (aCollection){var self=this;return (function($rec){$rec.addAll_(aCollection);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("withAll%3A%20aCollection%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09addAll%3A%20aCollection%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Collection.$klass,"basicNew:","basicNew_"

,function (size){var self=this;return self.implementedBySubclass();return self;}

,unescape("instance%20creation"),unescape("basicNew%3A%20size%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver%20of%20specified%20size.%20%22%0D%0A%0D%0A%09%5Eself%20implementedBySubclass"));

smalltalk.bind(smalltalk.Collection,"size","size"

,function (){var self=this;return self.subclassResponsibility();return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20subclassResponsibility"));

smalltalk.bind(smalltalk.Collection,"readStream","readStream"

,function (){var self=this;return self.stream();return self;}

,"accessing",unescape("readStream%0D%0A%09%22%20Return%20a%20read%20stream%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20stream"));

smalltalk.bind(smalltalk.Collection,"writeStream","writeStream"

,function (){var self=this;return self.stream();return self;}

,"accessing",unescape("writeStream%0D%0A%09%22%20Return%20a%20write%20stream%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20stream"));

smalltalk.bind(smalltalk.Collection,"stream","stream"

,function (){var self=this;return self.streamClass().on_(self);return self;}

,"accessing",unescape("stream%0D%0A%09%22%20Return%20a%20stream%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20streamClass%20on%3A%20self"));

smalltalk.bind(smalltalk.Collection,"streamClass","streamClass"

,function (){var self=this;return self.$klass.streamClass();return self;}

,"accessing",unescape("streamClass%0D%0A%09%22%20Private%20-%20Return%20the%20support%20for%20streamming%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20streamClass"));

smalltalk.bind(smalltalk.Collection,"add:","add_"

,function (anObject){var self=this;return self.subclassResponsibility();return self;}

,"adding/removing",unescape("add%3A%20anObject%0D%0A%09%22%20Add%20anObject%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20subclassResponsibility"));

smalltalk.bind(smalltalk.Collection,"addAll:","addAll_"

,function (aCollection){var self=this;aCollection.do_((function(each){return self.add_(each);}));

return aCollection;return self;}

,"adding/removing",unescape("addAll%3A%20aCollection%0D%0A%09%22%20Add%20objects%20in%20aCollection%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09aCollection%20do%3A%20%5B%3Aeach%20%7C%20self%20add%3A%20each%20%5D.%0D%0A%09%5EaCollection"));

smalltalk.bind(smalltalk.Collection,",","_comma"

,function (aCollection){var self=this;return (function($rec){$rec.addAll_(aCollection);return $rec.yourself();})(self.copy());return self;}

,"copying",unescape("%2C%20aCollection%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20all%20contents%20of%20aCollection.%20%22%0D%0A%0D%0A%09%5Eself%20copy%0D%0A%09%09addAll%3A%20aCollection%3B%20%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Collection,"copyWith:","copyWith_"

,function (anObject){var self=this;return (function($rec){$rec.add_(anObject);return $rec.yourself();})(self.copy());return self;}

,"copying",unescape("copyWith%3A%20anObject%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%09%5Eself%20copy%20add%3A%20anObject%3B%20yourself"));

smalltalk.bind(smalltalk.Collection,"copyWithAll:","copyWithAll_"

,function (aCollection){var self=this;return (function($rec){$rec.addAll_(aCollection);return $rec.yourself();})(self.copy());return self;}

,"copying",unescape("copyWithAll%3A%20aCollection%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20all%20contents%20of%20aCollection.%20%22%0D%0A%0D%0A%09%5Eself%20copy%0D%0A%09%09addAll%3A%20aCollection%3B%20%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Collection,"asArray","asArray"

,function (){var self=this;var result=nil;var index=nil;result=smalltalk.Array.$$new();

index=(0);

self.do_((function(each){index=(index + (1));return result.at_put_(index, each);}));

return result;return self;}

,"converting",unescape("asArray%0D%0A%09%22%20Return%20an%20array%20with%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20index%20%7C%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09index%20%3A%3D%200.%0D%0A%09self%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%20%20%20%20index%20%3A%3D%20index%20+%201.%0D%0A%09%20%20%20%20result%20at%3A%20index%20put%3A%20each%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Collection,"do:","do_"

,function (aBlock){var self=this;	for(var i=0;i<self.length;i++){aBlock(self[i]);} ;return self;}

,"enumerating",unescape("do%3A%20aBlock%0D%0A%09%22%20Shortcut%20-%20require%20%23length%20field.%0D%0A%09Evaluate%20aBlock%20with%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09for%28var%20i%3D0%3Bi%3Cself.length%3Bi++%29%7BaBlock%28self%5Bi%5D%29%3B%7D%20%27%7D"));

smalltalk.bind(smalltalk.Collection,"detect:ifNone:","detect_ifNone_"

,function (aBlock,anotherBlock){var self=this;	for(var i = 0; i < self.length; i++) if(aBlock(self[i])) return self[i];
	return anotherBlock();
;return self;}

,"enumerating",unescape("detect%3A%20aBlock%20ifNone%3A%20anotherBlock%0D%0A%09%22%20Shortcut%20-%20require%20%23length%20field.%0D%0A%09%20Return%20the%20object%20in%20the%20receiver%20that%20return%20true%20when%20evaluated%20with%20aBlock%20or%20the%20result%20of%20evaluating%20anotherBlock.%20%22%0D%0A%0D%0A%7B%27%09for%28var%20i%20%3D%200%3B%20i%20%3C%20self.length%3B%20i++%29%20if%28aBlock%28self%5Bi%5D%29%29%20return%20self%5Bi%5D%3B%0D%0A%09return%20anotherBlock%28%29%3B%0D%0A%27%7D"));

smalltalk.bind(smalltalk.Collection,"reverseDo:","reverseDo_"

,function (aBlock){var self=this;	var i=self.length;while(i--){aBlock(self[i]);} ;return self;}

,"enumerating",unescape("reverseDo%3A%20aBlock%0D%0A%09%22%20Shortcut%20-%20require%20%23length%20field.%0D%0A%09%20Evaluate%20aBlock%20with%20the%20contents%20of%20the%20receiver%20in%20reverse%20order%20of%20iteration.%20%22%0D%0A%0D%0A%7B%27%09var%20i%3Dself.length%3Bwhile%28i--%29%7BaBlock%28self%5Bi%5D%29%3B%7D%20%27%7D"));

smalltalk.bind(smalltalk.Collection,"collect:","collect_"

,function (aBlock){var self=this;var result=nil;result=self.$klass.$$new();

self.do_((function(each){return result.add_(aBlock.value_(each));}));

return result;return self;}

,"enumerating",unescape("collect%3A%20aBlock%0D%0A%09%22%20Return%20a%20collection%20with%20the%20result%20of%20evaluating%20aBlock%20with%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20class%20new.%0D%0A%09self%20do%3A%20%5B%3Aeach%20%7C%20result%20add%3A%20%28aBlock%20value%3A%20each%29%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Collection,"detect:","detect_"

,function (aBlock){var self=this;return self.detect_ifNone_(aBlock, (function(){return self.errorNotFound();}));return self;}

,"enumerating",unescape("detect%3A%20aBlock%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver%20that%20return%20true%20when%20evaluated%20with%20aBlock.%0D%0A%09Generates%20an%20error%20if%20there%20is%20no%20object%20that%20evaluates%20aBlock%20to%20true.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20detect%3A%20aBlock%20ifNone%3A%20%5B%20self%20errorNotFound%20%5D"));

smalltalk.bind(smalltalk.Collection,"do:separatedBy:","do_separatedBy_"

,function (aBlock,anotherBlock){var self=this;var first=nil;first=true;

self.do_((function(each){((first).mustBeBoolean()==true ? (function(){return first=false;})() : (function(){return anotherBlock.value();})());return aBlock.value_(each);}));return self;}

,"enumerating",unescape("do%3A%20aBlock%20separatedBy%3A%20anotherBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20contents%20of%20the%20receiver%20evaluating%20anotherBlock%20inbetween%20aBlock%20evaluations.%20%22%0D%0A%0D%0A%09%7C%20first%20%7C%0D%0A%09first%20%3A%3D%20true.%0D%0A%09self%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%20%20%20%20first%0D%0A%09%09ifTrue%3A%20%5B%20first%20%3A%3D%20false%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20anotherBlock%20value%20%5D.%0D%0A%09%20%20%20%20aBlock%20value%3A%20each%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Collection,"inject:into:","inject_into_"

,function (anObject,aBlock){var self=this;var result=nil;result=anObject;

self.do_((function(each){return result=aBlock.value_value_(result, each);}));

return result;return self;}

,"enumerating",unescape("inject%3A%20anObject%20into%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20result%20of%20previous%20evaluation%20and%20contents%20of%20the%20receiver.%0D%0A%09On%20first%20evaluation%20anObject%20is%20used%20as%20first%20argument%20to%20evaluate%20aBlock.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20anObject.%0D%0A%09self%20do%3A%20%5B%3Aeach%20%7C%20result%20%3A%3D%20aBlock%20value%3A%20result%20value%3A%20each%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Collection,"select:","select_"

,function (aBlock){var self=this;var stream=nil;stream=self.$klass.$$new().writeStream();

self.do_((function(each){return ((aBlock.value_(each)).mustBeBoolean()==true ? (function(){return stream.nextPut_(each);})() : nil);}));

return stream.contents();return self;}

,"enumerating",unescape("select%3A%20aBlock%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver%20wich%20evaluates%20aBlock%20to%20true.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20self%20class%20new%20writeStream.%0D%0A%09self%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%20%20%20%20%28aBlock%20value%3A%20each%29%20ifTrue%3A%20%5B%20stream%20nextPut%3A%20each%20%5D%0D%0A%09%5D.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Collection,"reject:","reject_"

,function (aBlock){var self=this;return self.select_((function(each){return aBlock.value_(each)._eq(false);}));return self;}

,"enumerating",unescape("reject%3A%20aBlock%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver%20wich%20evaluates%20aBlock%20to%20false.%20%22%0D%0A%0D%0A%09%5Eself%20select%3A%20%5B%3Aeach%20%7C%20%28aBlock%20value%3A%20each%29%20%3D%20false%5D"));

smalltalk.bind(smalltalk.Collection,"errorNotFound","errorNotFound"

,function (){var self=this;return self.error_("Object is not in the collection");return self;}

,unescape("error%20handling"),unescape("errorNotFound%0D%0A%09%22%20Private%20-%20Generates%20an%20error.%0D%0A%09An%20object%20was%20not%20found%20in%20the%20receiver%27s%20contents.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20error%3A%20%27Object%20is%20not%20in%20the%20collection%27"));

smalltalk.bind(smalltalk.Collection,"reversed","reversed"

,function (){var self=this;	var result = new Array();
	var len=self.length; var i=len;
	while(i--){result[len-i-1]= self[i];}
	return result;
;return self;}

,"copying",unescape("reversed%0D%0A%09%22%20Shortcut%20-%20require%20%23length%20field.%0D%0A%09%20Return%20an%20array%20with%20the%20contents%20of%20the%20receiver%20in%20reverse%20order.%20%22%0D%0A%0D%0A%7B%27%09var%20result%20%3D%20new%20Array%28%29%3B%0D%0A%09var%20len%3Dself.length%3B%20var%20i%3Dlen%3B%0D%0A%09while%28i--%29%7Bresult%5Blen-i-1%5D%3D%20self%5Bi%5D%3B%7D%0D%0A%09return%20result%3B%0D%0A%27%7D"));

smalltalk.bind(smalltalk.Collection,"includes:","includes_"

,function (anObject){var self=this;	var i = self.length;
	while (i--) { if (self[i]._eq(anObject)) { return true; } }
	return false;
;return self;}

,"testing",unescape("includes%3A%20anObject%0D%0A%09%22%20Shortcut%20-%20require%20%23length%20field.%0D%0A%09%20Return%20true%20if%20anObject%20is%20in%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%7B%27%09var%20i%20%3D%20self.length%3B%0D%0A%09while%20%28i--%29%20%7B%20if%20%28self%5Bi%5D._eq%28anObject%29%29%20%7B%20return%20true%3B%20%7D%20%7D%0D%0A%09return%20false%3B%0D%0A%27%7D"));

smalltalk.bind(smalltalk.Collection,"notEmpty","notEmpty"

,function (){var self=this;return self.isEmpty().not();return self;}

,"testing",unescape("notEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20not%20empty.%20%22%0D%0A%0D%0A%09%5Eself%20isEmpty%20not"));

smalltalk.bind(smalltalk.Collection,"isEmpty","isEmpty"

,function (){var self=this;	return (this.length)?false:true; ;return self;}

,"testing",unescape("isEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%7B%27%09return%20%28this.length%29%3Ffalse%3Atrue%3B%20%27%7D%0D%0A%22%28slow%29%09%5Eself%20size%20%3D%200%20%22"));

smalltalk.bind(smalltalk.Collection,"remove:","remove_"

,function (anObject){var self=this;return self.remove_ifAbsent_(anObject, (function(){return self.errorNotFound();}));return self;}

,"adding/removing",unescape("remove%3A%20anObject%0D%0A%09%22%20Remove%20anObject%20from%20receiver%2C%20return%20the%20removed%20object.%20%22%0D%0A%0D%0A%09%5Eself%20remove%3A%20anObject%20ifAbsent%3A%20%5B%20self%20errorNotFound%20%5D"));

smalltalk.bind(smalltalk.Collection,"remove:ifAbsent:","remove_ifAbsent_"

,function (anObject,aBlock){var self=this;return self.subclassResponsibility();return self;}

,"adding/removing",unescape("remove%3A%20anObject%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Remove%20anObject%20from%20receiver.%0D%0A%09Return%20the%20removed%20object%20or%20the%20result%20of%20evaluating%20aBlock%20%28if%20the%20object%20is%20not%20found%29.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20subclassResponsibility"));

smalltalk.bind(smalltalk.Collection,"occurrencesOf:","occurrencesOf_"

,function (anObject){var self=this;	var i = self.length;
	var count = 0;
	while (i--) { if (self[i]._eq(anObject)) { count++; } }
	return count;
;return self;}

,"counting",unescape("occurrencesOf%3A%20anObject%0D%0A%09%22%20Shortcut%20-%20require%20%23length%20field.%0D%0A%09%20Return%20the%20occurrences%20of%20anObject%20in%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09var%20i%20%3D%20self.length%3B%0D%0A%09var%20count%20%3D%200%3B%0D%0A%09while%20%28i--%29%20%7B%20if%20%28self%5Bi%5D._eq%28anObject%29%29%20%7B%20count++%3B%20%7D%20%7D%0D%0A%09return%20count%3B%0D%0A%27%7D"));

smalltalk.bind(smalltalk.Collection,"shallowCopy","shallowCopy"

,function (){var self=this;return self.collect_((function(each){return each;}));return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20collect%3A%20%5B%3Aeach%7C%20each%20%5D"));

smalltalk.bind(smalltalk.Collection,"deepCopy","deepCopy"

,function (){var self=this;return self.collect_((function(each){return each.deepCopy();}));return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20collect%3A%20%5B%3Aeach%7C%20each%20deepCopy%20%5D"));

smalltalk.bind(smalltalk.Collection,"asSet","asSet"

,function (){var self=this;return smalltalk.Set.withAll_(self);return self;}

,"converting",unescape("asSet%0D%0A%09%22%20Return%20the%20receiver%20contents%20in%20a%20Set.%20%22%0D%0A%0D%0A%09%5ESet%20withAll%3A%20self"));

smalltalk.bind(smalltalk.Collection,"asParser","asParser"

,function (){var self=this;return smalltalk.PPChoiceParser.withAll_(self.asArray());return self;}

,"Compiler-converting",unescape("asParser%0D%0A%09%22%20Return%20a%20parser%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPChoiceParser%20withAll%3A%20self%20asArray"));

smalltalk.bind(smalltalk.UndefinedObject.$klass,"new","$$new"

,function (){var self=this;return self.error_(unescape("UndefinedObject%20can%27t%20be%20instantiated."));return self;}

,unescape("instance%20creation"),unescape("new%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20error%3A%20%27UndefinedObject%20can%27%27t%20be%20instantiated.%27"));

smalltalk.bind(smalltalk.UndefinedObject,"ifNil:","ifNil_"

,function (aBlock){var self=this;return aBlock.value();return self;}

,"testing",unescape("ifNil%3A%20aBlock%0D%0A%09%22%20Return%20the%20receiver%20if%20it%20is%20not%20nil%2C%20or%20the%20result%20of%20evaluating%20aBlock%20%28if%20it%20is%20nil%29.%20%22%0D%0A%0D%0A%09%5EaBlock%20value"));

smalltalk.bind(smalltalk.UndefinedObject,"ifNotNil:","ifNotNil_"

,function (aBlock){var self=this;return self;return self;}

,"testing",unescape("ifNotNil%3A%20aBlock%0D%0A%09%22%20Return%20the%20receiver%20if%20it%20is%20nil%2C%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.UndefinedObject,"ifNil:ifNotNil:","ifNil_ifNotNil_"

,function (aBlock,anotherBlock){var self=this;return aBlock.value();return self;}

,"testing",unescape("ifNil%3A%20aBlock%20ifNotNil%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20receiver%20if%20it%20is%20nil%2C%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5EaBlock%20value"));

smalltalk.bind(smalltalk.UndefinedObject,"ifNotNil:ifNil:","ifNotNil_ifNil_"

,function (aBlock,anotherBlock){var self=this;return anotherBlock.value();return self;}

,"testing",unescape("ifNotNil%3A%20aBlock%20ifNil%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20anotherBlock%20if%20teh%20receiver%20is%20nil%2C%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5EanotherBlock%20value"));

smalltalk.bind(smalltalk.UndefinedObject,"isNil","isNil"

,function (){var self=this;return true;return self;}

,"testing",unescape("isNil%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20nil.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.UndefinedObject,"notNil","notNil"

,function (){var self=this;return false;return self;}

,"testing",unescape("notNil%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20not%20nil.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.UndefinedObject,"printString","printString"

,function (){var self=this;return "nil";return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20the%20text%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%23nil"));

smalltalk.bind(smalltalk.UndefinedObject,"compiler","compiler"

,function (){var self=this;return smalltalk.Compiler.for_(nil);return self;}

,"printing",unescape("compiler%0D%0A%09%22%20Return%20the%20compiler%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ECompiler%20for%3A%20nil"));

smalltalk.bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:","subclass_instanceVariableNames_"

,function (aString,anotherString){var self=this;return self.subclass_instanceVariableNames_category_(aString, anotherString, nil);return self;}

,"instantiation",unescape("subclass%3A%20aString%20instanceVariableNames%3A%20anotherString%0D%0A%09%22%20Create%20a%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20anotherString%0D%0A%09%09category%3A%20nil"));

smalltalk.bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:category:","subclass_instanceVariableNames_category_"

,function (aString,aString2,aString3){var self=this;return smalltalk.ClassBuilder.$$new().superclass_subclass_instanceVariableNames_category_(self, aString, aString2, aString3);return self;}

,"instantiation",unescape("subclass%3A%20aString%20instanceVariableNames%3A%20aString2%20category%3A%20aString3%0D%0A%09%22%20Create%20a%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EClassBuilder%20new%0D%0A%09%09superclass%3A%20self%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09category%3A%20aString3"));

smalltalk.bind(smalltalk.UndefinedObject,"asJSONObject","asJSONObject"

,function (){var self=this;return  null ;return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20object%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5E%7B%27%20null%20%27%7D"));

smalltalk.bind(smalltalk.UndefinedObject,"shallowCopy","shallowCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.UndefinedObject,"deepCopy","deepCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.UndefinedObject,"@","_at"

,function (aNumber){var self=this;return smalltalk.Point.x_y_((0), aNumber);return self;}

,"converting",unescape("@%20aNumber%0D%0A%09%22%20Return%20a%20Point%20with%20coordinates%20given%20by%20the%20receiver%20and%20aNumber.%20%22%0D%0A%0D%0A%09%5EPoint%20x%3A%200%20y%3A%20aNumber"));

smalltalk.bind(smalltalk.UndefinedObject,"category:","category_"

,function (ignored){var self=this;return self;}

,"instantiation",unescape("category%3A%20ignored%0D%0A%09%22%20BUG%20-%20throw%20an%20error%20in%20ClassBuilder.%20%22%20"));

smalltalk.bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:","subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_"

,function (aString,aString2,classVarNames,poolVarNames,aCategory){var self=this;(((((self.smalltalk()[aString] || nil) || nil) !== nil)).mustBeBoolean()==true ? (function(){return self.print_(unescape("//%20WARNING%3A%20class%20REdefinition%20for%20")._comma(aString));})() : nil);

return smalltalk.ClassBuilder.$$new().superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self, aString, aString2, classVarNames, poolVarNames, aCategory);return self;}

,"instantiation",unescape("subclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09classVariableNames%3A%20classVarNames%0D%0A%09poolDictionaries%3A%20poolVarNames%0D%0A%09category%3A%20aCategory%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%28self%20smalltalk%20basicAt%3A%20aString%29%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09self%20print%3A%20%27//%20WARNING%3A%20class%20REdefinition%20for%20%27%2CaString.%0D%0A%09%09%22%5Eself%20smalltalk%20basicAt%3A%20aString%22%0D%0A%09%5D.%0D%0A%0D%0A%09%22self%20print%3A%20%27//%20Creating%20ROOT%20class%20%27%2CaString.%22%0D%0A%09%5EClassBuilder%20new%0D%0A%09%09superclass%3A%20self%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20classVarNames%0D%0A%09%09poolDictionaries%3A%20poolVarNames%0D%0A%09%09category%3A%20aCategory"));

smalltalk.bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:","subclass_instanceVariableNames_classVariableNames_poolDictionaries_"

,function (aString,aString2,classVarNames,poolVarNames){var self=this;return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString, aString2, classVarNames, poolVarNames, nil);return self;}

,"instantiation",unescape("subclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09classVariableNames%3A%20classVarNames%0D%0A%09poolDictionaries%3A%20poolVarNames%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20classVarNames%0D%0A%09%09poolDictionaries%3A%20poolVarNames%0D%0A%09%09category%3A%20nil"));

smalltalk.bind(smalltalk.DateTime.$klass,"new:","new_"

,function (anObject){var self=this;	return new Date(anObject); ;return self;}

,unescape("instance%20creation"),unescape("new%3A%20anObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20new%20Date%28anObject%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.DateTime.$klass,"fromString:","fromString_"

,function (aString){var self=this;return self.new_(aString);return self;}

,unescape("instance%20creation"),unescape("fromString%3A%20aString%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%0D%0A%09DateTime%20fromString%3A%20%271962/12/15%2001%3A40%3A00%27%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20new%3A%20aString"));

smalltalk.bind(smalltalk.DateTime.$klass,"fromSeconds:","fromSeconds_"

,function (aNumber){var self=this;return self.fromMilliseconds_((aNumber * (1000)));return self;}

,unescape("instance%20creation"),unescape("fromSeconds%3A%20aNumber%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20fromMilliseconds%3A%20aNumber%20*%201000"));

smalltalk.bind(smalltalk.DateTime.$klass,"fromMilliseconds:","fromMilliseconds_"

,function (aNumber){var self=this;return self.new_(aNumber);return self;}

,unescape("instance%20creation"),unescape("fromMilliseconds%3A%20aNumber%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%3A%20aNumber"));

smalltalk.bind(smalltalk.DateTime.$klass,"today","today"

,function (){var self=this;return self.$$new();return self;}

,unescape("instance%20creation"),unescape("today%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new"));

smalltalk.bind(smalltalk.DateTime.$klass,"now","now"

,function (){var self=this;return self.today();return self;}

,unescape("instance%20creation"),unescape("now%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20today"));

smalltalk.bind(smalltalk.DateTime.$klass,"millisecondsToRun:","millisecondsToRun_"

,function (aBlock){var self=this;var start=nil;start=smalltalk.DateTime.now();

aBlock.value();

return smalltalk.DateTime.now()._minus(start);return self;}

,unescape("instance%20creation"),unescape("millisecondsToRun%3A%20aBlock%0D%0A%09%22%20Return%20the%20time%20elapsed%20during%20evaluation%20of%20aBlock.%20%22%0D%0A%0D%0A%09%7C%20start%20%7C%0D%0A%09start%20%3A%3D%20DateTime%20now.%0D%0A%09aBlock%20value.%0D%0A%09%5EDateTime%20now%20-%20start"));

smalltalk.bind(smalltalk.DateTime,"year","year"

,function (){var self=this;return self.getFullYear();return self;}

,"accessing",unescape("year%0D%0A%09%22%20Return%20the%20year%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23getFullYear"));

smalltalk.bind(smalltalk.DateTime,"month","month"

,function (){var self=this;return (self.getMonth() + (1));return self;}

,"accessing",unescape("month%0D%0A%09%22%20Return%20the%20month%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23getMonth%20+%201"));

smalltalk.bind(smalltalk.DateTime,"month:","month_"

,function (aNumber){var self=this;self.setMonth((aNumber - (1)));return self;}

,"accessing",unescape("month%3A%20aNumber%0D%0A%09%22%20Set%20the%20month%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23setMonth%3A%20aNumber%20-%201"));

smalltalk.bind(smalltalk.DateTime,"day","day"

,function (){var self=this;return self.dayOfWeek();return self;}

,"accessing",unescape("day%0D%0A%09%22%20Return%20the%20day%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20dayOfWeek"));

smalltalk.bind(smalltalk.DateTime,"dayOfWeek","dayOfWeek"

,function (){var self=this;return (self.getDay() + (1));return self;}

,"accessing",unescape("dayOfWeek%0D%0A%09%22%20Return%20the%20day%20of%20week%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23getDay%20+%201"));

smalltalk.bind(smalltalk.DateTime,"dayOfWeek:","dayOfWeek_"

,function (aNumber){var self=this;self.setDay((aNumber - (1)));return self;}

,"accessing",unescape("dayOfWeek%3A%20aNumber%0D%0A%09%22%20Set%20the%20day%20of%20week%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23setDay%3A%20aNumber%20-%201"));

smalltalk.bind(smalltalk.DateTime,"day:","day_"

,function (aNumber){var self=this;self.day_(aNumber);return self;}

,"accessing",unescape("day%3A%20aNumber%0D%0A%09%22%20Set%20the%20day%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20day%3A%20aNumber"));

smalltalk.bind(smalltalk.DateTime,"year:","year_"

,function (aNumber){var self=this;self.setFullYear(aNumber);return self;}

,"accessing",unescape("year%3A%20aNumber%0D%0A%09%22%20Set%20the%20year%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23setFullYear%3A%20aNumber"));

smalltalk.bind(smalltalk.DateTime,"dayOfMonth","dayOfMonth"

,function (){var self=this;return self.getDate();return self;}

,"accessing",unescape("dayOfMonth%0D%0A%09%22%20Return%20the%20day%20of%20month%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23getDate"));

smalltalk.bind(smalltalk.DateTime,"dayOfMonth:","dayOfMonth_"

,function (aNumber){var self=this;self.setDate(aNumber);return self;}

,"accessing",unescape("dayOfMonth%3A%20aNumber%0D%0A%09%22%20Set%20the%20day%20of%20month%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23setDate%3A%20aNumber"));

smalltalk.bind(smalltalk.DateTime,"asString","asString"

,function (){var self=this;return self.toString();return self;}

,"converting",unescape("asString%0D%0A%09%22%20Return%20the%20text%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23toString"));

smalltalk.bind(smalltalk.DateTime,"printString","printString"

,function (){var self=this;return self.asString();return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20the%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20asString"));

smalltalk.bind(smalltalk.DateTime,"asMilliseconds","asMilliseconds"

,function (){var self=this;return self.time();return self;}

,"converting",unescape("asMilliseconds%0D%0A%09%22%20Return%20the%20receiver%20as%20milliseconds.%20%22%0D%0A%0D%0A%09%5Eself%20time"));

smalltalk.bind(smalltalk.DateTime,"time","time"

,function (){var self=this;return self.getTime();return self;}

,"accessing",unescape("time%0D%0A%09%22%20Return%20the%20time%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23getTime"));

smalltalk.bind(smalltalk.DateTime,"time:","time_"

,function (aNumber){var self=this;self.setTime(aNumber);return self;}

,"accessing",unescape("time%3A%20aNumber%0D%0A%09%22%20Set%20the%20time%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23setTime%3A%20aNumber"));

smalltalk.bind(smalltalk.DateTime,"asDateString","asDateString"

,function (){var self=this;return self.toDateString();return self;}

,"converting",unescape("asDateString%0D%0A%09%22%20Return%20the%20date%20string%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23toDateString"));

smalltalk.bind(smalltalk.DateTime,"asTimeString","asTimeString"

,function (){var self=this;return self.toTimeString();return self;}

,"converting",unescape("asTimeString%0D%0A%09%22%20Return%20the%20time%20string%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23toTimeString"));

smalltalk.bind(smalltalk.DateTime,"asLocaleString","asLocaleString"

,function (){var self=this;return self.toLocaleString();return self;}

,"converting",unescape("asLocaleString%0D%0A%09%22%20Return%20the%20locale%20string%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23toLocaleString"));

smalltalk.bind(smalltalk.DateTime,"asNumber","asNumber"

,function (){var self=this;return self.asMilliseconds();return self;}

,"converting",unescape("asNumber%0D%0A%09%22%20Return%20the%20receiver%20as%20a%20Number.%20%22%0D%0A%0D%0A%09%5Eself%20asMilliseconds"));

smalltalk.bind(smalltalk.DateTime,"hours:","hours_"

,function (aNumber){var self=this;return self.setHours(aNumber);return self;}

,"accessing",unescape("hours%3A%20aNumber%0D%0A%09%22%20Set%20the%20hours%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23setHours%3A%20aNumber"));

smalltalk.bind(smalltalk.DateTime,"minutes:","minutes_"

,function (aNumber){var self=this;self.setMinutes(aNumber);return self;}

,"accessing",unescape("minutes%3A%20aNumber%0D%0A%09%22%20Set%20the%20minutes%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23setMinutes%3A%20aNumber"));

smalltalk.bind(smalltalk.DateTime,"seconds:","seconds_"

,function (aNumber){var self=this;self.setSeconds(aNumber);return self;}

,"accessing",unescape("seconds%3A%20aNumber%0D%0A%09%22%20Set%20the%20seconds%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23setSeconds%3A%20aNumber"));

smalltalk.bind(smalltalk.DateTime,"milliseconds:","milliseconds_"

,function (aNumber){var self=this;self.setMilliseconds(aNumber);return self;}

,"accessing",unescape("milliseconds%3A%20aNumber%0D%0A%09%22%20Set%20the%20milliseconds%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23setMilliseconds%3A%20aNumber"));

smalltalk.bind(smalltalk.DateTime,"hours","hours"

,function (){var self=this;return self.getHours();return self;}

,"accessing",unescape("hours%0D%0A%09%22%20Return%20the%20hours%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23getHours"));

smalltalk.bind(smalltalk.DateTime,"minutes","minutes"

,function (){var self=this;return self.getMinutes();return self;}

,"accessing",unescape("minutes%0D%0A%09%22%20Return%20the%20minutes%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20getMinutes"));

smalltalk.bind(smalltalk.DateTime,"seconds","seconds"

,function (){var self=this;return self.getSeconds();return self;}

,"accessing",unescape("seconds%0D%0A%09%22%20Return%20the%20seconds%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23getSeconds"));

smalltalk.bind(smalltalk.DateTime,"milliseconds","milliseconds"

,function (){var self=this;return self.getMilliseconds();return self;}

,"accessing",unescape("milliseconds%0D%0A%09%22%20Return%20the%20milliseconds%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23getMilliseconds"));

smalltalk.bind(smalltalk.DateTime,"<","_lt"

,function (aDateTime){var self=this;	return self < aDateTime; ;return self;}

,"comparing",unescape("%3C%20aDateTime%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20previous%20to%20aDateTime.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%3C%20aDateTime%3B%20%27%7D"));

smalltalk.bind(smalltalk.DateTime,">","_gt"

,function (aDateTime){var self=this;	return self > aDateTime; ;return self;}

,"comparing",unescape("%3E%20aDateTime%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20later%20than%20aDateTime.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%3E%20aDateTime%3B%20%27%7D"));

smalltalk.bind(smalltalk.DateTime,"<=","_lt_eq"

,function (aDateTime){var self=this;	return self <= aDateTime; ;return self;}

,"comparing",unescape("%3C%3D%20aDateTime%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20previous%20or%20equal%20to%20aDateTime.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%3C%3D%20aDateTime%3B%20%27%7D"));

smalltalk.bind(smalltalk.DateTime,">=","_gt_eq"

,function (aDateTime){var self=this;	return self >= aDateTime; ;return self;}

,"comparing",unescape("%3E%3D%20aDateTime%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20later%20or%20equal%20to%20aDateTime.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%3E%3D%20aDateTime%3B%20%27%7D"));

smalltalk.bind(smalltalk.DateTime,"-","_minus"

,function (aDateTime){var self=this;	return self - aDateTime; ;return self;}

,"arithmetic",unescape("-%20aDateTime%0D%0A%09%22%20Return%20the%20result%20of%20operation%20with%20receiver%20and%20aDateTime.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20-%20aDateTime%3B%20%27%7D"));

smalltalk.bind(smalltalk.DateTime,"+","_plus"

,function (aDateTime){var self=this;	return self + aDateTime; ;return self;}

,"arithmetic",unescape("+%20aDateTime%0D%0A%09%22%20Return%20the%20result%20of%20operation%20with%20receiver%20and%20aDateTime.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20+%20aDateTime%3B%20%27%7D"));

smalltalk.bind(smalltalk.DateTime,"asJSONObject","asJSONObject"

,function (){var self=this;return self;return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20object%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Boolean,"=","_eq"

,function (aBoolean){var self=this;	return Boolean(self == true) == aBoolean; ;return self;}

,"comparing",unescape("%3D%20aBoolean%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20equal%20to%20aBoolean.%20%22%0D%0A%0D%0A%7B%27%09return%20Boolean%28self%20%3D%3D%20true%29%20%3D%3D%20aBoolean%3B%20%27%7D"));

smalltalk.bind(smalltalk.Boolean,"ifTrue:","ifTrue_"

,function (aBlock){var self=this;return ((self).mustBeBoolean()==true ? (function(){return aBlock.value();})() : (function(){return nil;})());return self;}

,"controlling",unescape("ifTrue%3A%20aBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%20if%20the%20receiver%20is%20true%2C%20else%20return%20nil.%20%22%0D%0A%0D%0A%09%5Eself%20ifTrue%3A%20%5B%20aBlock%20value%20%5D%20ifFalse%3A%20%5B%5D"));

smalltalk.bind(smalltalk.Boolean,"ifFalse:","ifFalse_"

,function (aBlock){var self=this;return ((self).mustBeBoolean()==true ? (function(){return nil;})() : (function(){return aBlock.value();})());return self;}

,"controlling",unescape("ifFalse%3A%20aBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%20if%20the%20receiver%20is%20false%2C%20else%20return%20nil.%20%22%0D%0A%0D%0A%09%5Eself%20ifTrue%3A%20%5B%5D%20ifFalse%3A%20%5B%20aBlock%20value%20%5D"));

smalltalk.bind(smalltalk.Boolean,"ifFalse:ifTrue:","ifFalse_ifTrue_"

,function (aBlock,anotherBlock){var self=this;return self.ifTrue_ifFalse_(anotherBlock, (function(){return aBlock.value();}));return self;}

,"controlling",unescape("ifFalse%3A%20aBlock%20ifTrue%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%20if%20the%20receiver%20is%20false%2C%20else%20the%20result%20of%20evaluating%20anotherBlock.%20%22%0D%0A%0D%0A%09%5Eself%20ifTrue%3A%20anotherBlock%20ifFalse%3A%20%5B%20aBlock%20value%20%5D"));

smalltalk.bind(smalltalk.Boolean,"ifTrue:ifFalse:","ifTrue_ifFalse_"

,function (aBlock,anotherBlock){var self=this;	if(self == true) { return aBlock(); } else { return anotherBlock(); }; ;return self;}

,"controlling",unescape("ifTrue%3A%20aBlock%20ifFalse%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%20if%20the%20receiver%20is%20true%2C%20else%20the%20result%20of%20evaluating%20anotherBlock.%20%22%0D%0A%0D%0A%7B%27%09if%28self%20%3D%3D%20true%29%20%7B%20return%20aBlock%28%29%3B%20%7D%20else%20%7B%20return%20anotherBlock%28%29%3B%20%7D%3B%20%27%7D"));

smalltalk.bind(smalltalk.Boolean,"and:","and_"

,function (aBlock){var self=this;return ((self).mustBeBoolean()==true ? (function(){return aBlock.value();})() : (function(){return false;})());return self;}

,"controlling",unescape("and%3A%20aBlock%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20true%20and%20the%20result%20of%20evaluating%20aBlock%20is%20also%20true.%20%22%0D%0A%0D%0A%09%5Eself%20ifTrue%3A%20%5B%20aBlock%20value%20%5D%20ifFalse%3A%20%5Bfalse%5D"));

smalltalk.bind(smalltalk.Boolean,"or:","or_"

,function (aBlock){var self=this;return ((self).mustBeBoolean()==true ? (function(){return true;})() : (function(){return aBlock.value();})());return self;}

,"controlling",unescape("or%3A%20aBlock%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20true%20or%20the%20result%20of%20evaluating%20aBlock%20is%20true.%20%22%0D%0A%0D%0A%09%5Eself%20ifTrue%3A%20%5Btrue%5D%20ifFalse%3A%20%5B%20aBlock%20value%20%5D"));

smalltalk.bind(smalltalk.Boolean,"not","not"

,function (){var self=this;return  self == false ;return self;}

,"controlling",unescape("not%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20false.%20%22%0D%0A%0D%0A%09%5E%7B%27%20self%20%3D%3D%20false%20%27%7D"));

smalltalk.bind(smalltalk.Boolean,"printString","printString"

,function (){var self=this;return self.toString();return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20a%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23toString"));

smalltalk.bind(smalltalk.Boolean,"asJSONObject","asJSONObject"

,function (){var self=this;return self.and_((function(){return true;}));return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20object%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Eself%20and%3A%20%5B%20true%20%5D"));

smalltalk.bind(smalltalk.Boolean,"shallowCopy","shallowCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Boolean,"deepCopy","deepCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Boolean,"yourself","yourself"

,function (){var self=this;return self.and_((function(){return true;}));return self;}

,"identity",unescape("yourself%0D%0A%09%22%20Return%20the%20receiver.%0D%0A%09Note%3A%20do%20NOT%20modify/remove%20this%20method%20if%20you%20dont%20know%20what%20you%20are%20doing.%0D%0A%09Test%20the%20following%20expression%20after%20changing%20this%20code%3A%0D%0A%09%09true%20yourself%20%3D%3D%20true%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20and%3A%20%5B%20true%20%5D"));

smalltalk.bind(smalltalk.Boolean,"mustBeBoolean","mustBeBoolean"

,function (){var self=this;return self;return self;}

,"Compiler-testing",unescape("mustBeBoolean%0D%0A%09%22%20Signal%20an%20error%20if%20the%20receiver%20is%20not%20a%20Boolean.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.BlockClosure,"compiledSource","compiledSource"

,function (){var self=this;	return self.toString(); ;return self;}

,"accessing",unescape("compiledSource%0D%0A%09%22%20Return%20the%20source%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20self.toString%28%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"whileTrue:","whileTrue_"

,function (aBlock){var self=this;	while(self()) {aBlock()}; ;return self;}

,"controlling",unescape("whileTrue%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20while%20the%20result%20of%20evaluating%20the%20receiver%20is%20true.%20%22%0D%0A%0D%0A%7B%27%09while%28self%28%29%29%20%7BaBlock%28%29%7D%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"whileFalse:","whileFalse_"

,function (aBlock){var self=this;	while(!self()) {aBlock()}; ;return self;}

,"controlling",unescape("whileFalse%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20while%20the%20result%20of%20evaluating%20the%20receiver%20is%20false.%20%22%0D%0A%0D%0A%7B%27%09while%28%21self%28%29%29%20%7BaBlock%28%29%7D%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"value","value"

,function (){var self=this;	return self(); ;return self;}

,"evaluating",unescape("value%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20self%28%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"value:","value_"

,function (anObject){var self=this;	return self(anObject); ;return self;}

,"evaluating",unescape("value%3A%20anObject%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%7B%27%09return%20self%28anObject%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"value:value:","value_value_"

,function (firstArgument,secondArgument){var self=this;	return self(firstArgument, secondArgument); ;return self;}

,"evaluating",unescape("value%3A%20firstArgument%20value%3A%20secondArgument%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20arguments.%20%22%0D%0A%0D%0A%7B%27%09return%20self%28firstArgument%2C%20secondArgument%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"value:value:value:","value_value_value_"

,function (firstArgument,secondArgument,thirdArgument){var self=this;	return self(firstArgument, secondArgument, thirdArgument);	;return self;}

,"evaluating",unescape("value%3A%20firstArgument%20value%3A%20secondArgument%20value%3A%20thirdArgument%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20arguments.%20%22%0D%0A%0D%0A%7B%27%09return%20self%28firstArgument%2C%20secondArgument%2C%20thirdArgument%29%3B%09%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"valueWithPossibleArguments:","valueWithPossibleArguments_"

,function (aCollection){var self=this;	return self.apply(null, aCollection); ;return self;}

,"evaluating",unescape("valueWithPossibleArguments%3A%20aCollection%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20potential%20arguments.%20%22%0D%0A%0D%0A%7B%27%09return%20self.apply%28null%2C%20aCollection%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"on:do:","on_do_"

,function (anExceptionType,aBlock){var self=this;return self.try_catch_(self, (function(error){return ((error.isKindOf_(anExceptionType)).mustBeBoolean()==true ? (function(){return aBlock.value_(error);})() : (function(){return error.signal();})());}));return self;}

,unescape("error%20handling"),unescape("on%3A%20anExceptionType%20do%3A%20aBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20catching%20exceptions.%20%22%0D%0A%0D%0A%09%5Eself%20try%3A%20self%20catch%3A%20%5B%3Aerror%20%7C%0D%0A%09%09%28error%20isKindOf%3A%20anExceptionType%29%0D%0A%09%09ifTrue%3A%20%5B%20aBlock%20value%3A%20error%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20error%20signal%20%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.BlockClosure,"try:catch:","try_catch_"

,function (aBlock,anotherBlock){var self=this;	var result;
	try{ result = aBlock() } catch(e) {
		result = anotherBlock( self.smalltalkErrorOf_(e) )
	};
	return result || nil;
;return self;}

,unescape("native%20error%20handling"),unescape("try%3A%20aBlock%20catch%3A%20anotherBlock%0D%0A%09%22%20Try%20to%20evaluate%20aBlock%20catching%20exceptions%20with%20catchBlock.%20%22%0D%0A%0D%0A%7B%27%09var%20result%3B%0D%0A%09try%7B%20result%20%3D%20aBlock%28%29%20%7D%20catch%28e%29%20%7B%0D%0A%09%09result%20%3D%20anotherBlock%28%20self.smalltalkErrorOf_%28e%29%20%29%0D%0A%09%7D%3B%0D%0A%09return%20result%20%7C%7C%20nil%3B%0D%0A%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"valueDeferred:","valueDeferred_"

,function (milliseconds){var self=this;self.valueWithTimeout_(milliseconds);return self;}

,"evaluating",unescape("valueDeferred%3A%20milliseconds%0D%0A%09%22%20Evaluate%20the%20receiver%20deferred%20in%20time.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09self%20valueWithTimeout%3A%20milliseconds"));

smalltalk.bind(smalltalk.BlockClosure,"valueDeferred","valueDeferred"

,function (){var self=this;self.valueDeferred_((0));return self;}

,"evaluating",unescape("valueDeferred%0D%0A%09%22%20Evaluate%20the%20receiver%20deferred%20in%20time.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09self%20valueDeferred%3A%200"));

smalltalk.bind(smalltalk.BlockClosure,"valueWithTimeout:","valueWithTimeout_"

,function (aNumber){var self=this;	return setTimeout(self, aNumber); ;return self;}

,"timeout/interval",unescape("valueWithTimeout%3A%20aNumber%0D%0A%09%22%20Evaluate%20the%20receiver%20with%20time%20out.%20%22%0D%0A%0D%0A%7B%27%09return%20setTimeout%28self%2C%20aNumber%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"valueWithInterval:","valueWithInterval_"

,function (aNumber){var self=this;	return setInterval(self, aNumber); ;return self;}

,"timeout/interval",unescape("valueWithInterval%3A%20aNumber%0D%0A%09%22%20Evaluate%20the%20receiver%20with%20interval.%20%22%0D%0A%0D%0A%7B%27%09return%20setInterval%28self%2C%20aNumber%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"ensure:","ensure_"

,function (aBlock){var self=this;	var success = true;
	try{self()} catch(e) {
		success = false;
		aBlock();
		throw(e);
	}
	if(success) {aBlock()}; ;return self;}

,unescape("error%20handling"),unescape("ensure%3A%20aBlock%0D%0A%09%22%20Ensure%20the%20execution%20of%20aBlock%20after%20the%20receiver%20is%20executed.%20%22%0D%0A%0D%0A%7B%27%09var%20success%20%3D%20true%3B%0D%0A%09try%7Bself%28%29%7D%20catch%28e%29%20%7B%0D%0A%09%09success%20%3D%20false%3B%0D%0A%09%09aBlock%28%29%3B%0D%0A%09%09throw%28e%29%3B%0D%0A%09%7D%0D%0A%09if%28success%29%20%7BaBlock%28%29%7D%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"argumentCount","argumentCount"

,function (){var self=this;	return self.length; ;return self;}

,"evaluating",unescape("argumentCount%0D%0A%09%22%20Return%20the%20number%20of%20arguments%20defined%20by%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20self.length%3B%20%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"installAs:","installAs_"

,function (functionName){var self=this;	smalltalk.$$$installCookie = self;
	eval( functionName+" = smalltalk.$$$installCookie" );
	delete smalltalk.$$$installCookie;
;return self;}

,"installing",unescape("installAs%3A%20functionName%0D%0A%09%22%20Install%20the%20receiver%20as%20a%20function%20in%20global%20scope.%20%22%0D%0A%0D%0A%7B%27%09smalltalk.%24%24%24installCookie%20%3D%20self%3B%0D%0A%09eval%28%20functionName+%22%20%3D%20smalltalk.%24%24%24installCookie%22%20%29%3B%0D%0A%09delete%20smalltalk.%24%24%24installCookie%3B%0D%0A%27%7D"));

smalltalk.bind(smalltalk.BlockClosure,"asJSONObject","asJSONObject"

,function (){var self=this;return self;return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20object%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.BlockClosure,"shallowCopy","shallowCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.BlockClosure,"deepCopy","deepCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.BlockClosure,"ms","ms"

,function (){var self=this;return smalltalk.DateTime.millisecondsToRun_(self);return self;}

,unescape("evaluation%20time"),unescape("ms%0D%0A%09%22%20Return%20the%20milliseconds%20taken%20to%20evaluate%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDateTime%20millisecondsToRun%3A%20self"));

smalltalk.bind(smalltalk.BlockClosure,"evaluateFor:","evaluateFor_"

,function (anObject){var self=this;return self.value_(anObject);return self;}

,"evaluating",unescape("evaluateFor%3A%20anObject%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%09%5Eself%20value%3A%20anObject"));

smalltalk.bind(smalltalk.BlockClosure,"evaluate","evaluate"

,function (){var self=this;return self.value();return self;}

,"evaluating",unescape("evaluate%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20value"));

smalltalk.bind(smalltalk.BlockClosure,"evaluateWithArguments:","evaluateWithArguments_"

,function (anArray){var self=this;return self.valueWithPossibleArguments_(anArray);return self;}

,"evaluating",unescape("evaluateWithArguments%3A%20anArray%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20valueWithPossibleArguments%3A%20anArray"));

smalltalk.bind(smalltalk.BlockClosure,"valueWithArguments:","valueWithArguments_"

,function (anArray){var self=this;return self.valueWithPossibleArguments_(anArray);return self;}

,"evaluating",unescape("valueWithArguments%3A%20anArray%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20arguments.%20%22%0D%0A%0D%0A%09%5Eself%20valueWithPossibleArguments%3A%20anArray"));

smalltalk.bind(smalltalk.Number.$klass,"pi","pi"

,function (){var self=this;	return Math.PI; ;return self;}

,unescape("instance%20creation"),unescape("pi%0D%0A%09%22%20Return%20the%20singular%20value%20PI.%20%22%0D%0A%0D%0A%7B%27%09return%20Math.PI%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number.$klass,"readFrom:radix:","readFrom_radix_"

,function (aStream,radix){var self=this;try{var value=nil;var $$char=nil;value=(0);

(function(){while((function(){$$char=aStream.peek();return (($$char || nil) !== nil).and_((function(){return $$char.isDigit().or_((function(){return $$char.isUpperCase();}));}));})()){(function(){((radix._lt($$char.digitValue())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "readFrom_radix_", fn: function(){return value}})})();})() : nil);value=value._star(radix)._plus($$char.digitValue());return aStream.next();})()};return nil})();

(function(){throw({name: "stReturn", selector: "readFrom_radix_", fn: function(){return value}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "readFrom_radix_"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("readFrom%3A%20aStream%20radix%3A%20radix%0D%0A%09%22%20Private%20-%20Read%20an%20integer%20from%20%3CaStream%3E%20and%20return%20it.%20%22%0D%0A%0D%0A%09%7C%20value%20char%20%7C%0D%0A%09value%20%3A%3D%200.%0D%0A%09%5B%09char%20%3A%3D%20aStream%20peek.%0D%0A%09%09char%20notNil%20and%3A%20%5B%20char%20isDigit%20or%3A%20%5B%20char%20isUpperCase%20%5D%20%5D%0D%0A%09%5D%20whileTrue%3A%20%5B%0D%0A%09%09radix%20%3C%20%20char%20digitValue%20ifTrue%3A%20%5B%20%5Evalue%20%5D.%0D%0A%09%09value%20%3A%3D%20value%20*%20radix%20+%20char%20digitValue.%0D%0A%09%09aStream%20next%0D%0A%09%5D.%0D%0A%09%5Evalue"));

smalltalk.bind(smalltalk.Number.$klass,"readFrom:","readFrom_"

,function (aStream){var self=this;try{var value=nil;var $$char=nil;value=(0);

(function(){while((function(){$$char=aStream.peek();return (($$char || nil) !== nil).and_((function(){return $$char.isDigit();}));})()){(function(){value=(value * (10))._plus($$char.digitValue());return aStream.next();})()};return nil})();

((($$char === "r")).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "readFrom_", fn: function(){return value}})})();})());

aStream.next();

(function(){throw({name: "stReturn", selector: "readFrom_", fn: function(){return self.readFrom_radix_(aStream, value)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "readFrom_"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("readFrom%3A%20aStream%0D%0A%09%22%20Private%20-%20Read%20an%20integer%20from%20%3CaStream%3E%20and%20return%20it.%20%22%0D%0A%0D%0A%09%7C%20value%20char%20%7C%0D%0A%09value%20%3A%3D%200.%0D%0A%09%5B%09char%20%3A%3D%20aStream%20peek.%0D%0A%09%09char%20notNil%20and%3A%20%5B%20char%20isDigit%20%5D%0D%0A%09%5D%20whileTrue%3A%20%5B%0D%0A%09%09value%20%3A%3D%20value%20*%2010%20+%20char%20digitValue.%0D%0A%09%09aStream%20next%0D%0A%09%5D.%0D%0A%09char%20%3D%3D%20%22%24r%22%27r%27%20ifFalse%3A%20%5B%20%5Evalue%20%5D.%0D%0A%09aStream%20next.%20%22skip%20the%20r%22%0D%0A%09%5Eself%20readFrom%3A%20aStream%20radix%3A%20value"));

smalltalk.bind(smalltalk.Number,"=","_eq"

,function (aNumber){var self=this;	return Number(self) === Number(aNumber); ;return self;}

,"comparing",unescape("%3D%20aNumber%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20equal%20to%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20Number%28self%29%20%3D%3D%3D%20Number%28aNumber%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,">","_gt"

,function (aNumber){var self=this;	return self > aNumber; ;return self;}

,"comparing",unescape("%3E%20aNumber%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20greater%20to%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%3E%20aNumber%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"<","_lt"

,function (aNumber){var self=this;	return self < aNumber; ;return self;}

,"comparing",unescape("%3C%20aNumber%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20smaller%20to%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%3C%20aNumber%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,">=","_gt_eq"

,function (aNumber){var self=this;	return self >= aNumber; ;return self;}

,"comparing",unescape("%3E%3D%20aNumber%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20greater%20or%20equal%20to%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%3E%3D%20aNumber%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"<=","_lt_eq"

,function (aNumber){var self=this;	return self <= aNumber; ;return self;}

,"comparing",unescape("%3C%3D%20aNumber%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20smaller%20or%20equal%20to%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%3C%3D%20aNumber%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"+","_plus"

,function (aNumber){var self=this;	return self + aNumber; ;return self;}

,"arithmetic",unescape("+%20aNumber%0D%0A%09%22%20Return%20the%20result%20of%20operation%20on%20receiver%20and%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20+%20aNumber%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"-","_minus"

,function (aNumber){var self=this;	return self - aNumber; ;return self;}

,"arithmetic",unescape("-%20aNumber%0D%0A%09%22%20Return%20the%20result%20of%20operation%20on%20receiver%20and%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20-%20aNumber%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"*","_star"

,function (aNumber){var self=this;	return self * aNumber; ;return self;}

,"arithmetic",unescape("*%20aNumber%0D%0A%09%22%20Return%20the%20result%20of%20operation%20on%20receiver%20and%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20*%20aNumber%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"/","_slash"

,function (aNumber){var self=this;	return self / aNumber; ;return self;}

,"arithmetic",unescape("/%20aNumber%0D%0A%09%22%20Return%20the%20result%20of%20operation%20on%20receiver%20and%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20/%20aNumber%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"//","_slash_slash"

,function (aNumber){var self=this;return self._slash(aNumber).truncated();return self;}

,"arithmetic",unescape("//%20aNumber%0D%0A%09%22%20Return%20the%20result%20of%20operation%20on%20receiver%20and%20aNumber.%20%22%0D%0A%0D%0A%09%5E%28self%20/%20aNumber%29%20truncated"));

smalltalk.bind(smalltalk.Number,unescape("%5C%5C"),"_bk_bk"

,function (aNumber){var self=this;	return self % aNumber; ;return self;}

,"arithmetic",unescape("%5C%5C%5C%5C%20aNumber%0D%0A%09%22%20Return%20the%20reminder%20of%20dividing%20the%20receiver%20by%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20%25%20aNumber%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"sin","sin"

,function (){var self=this;	return Math.sin(self); ;return self;}

,"arithmetic",unescape("sin%0D%0A%7B%27%09return%20Math.sin%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"cos","cos"

,function (){var self=this;	return Math.cos(self); ;return self;}

,"arithmetic",unescape("cos%0D%0A%7B%27%09return%20Math.cos%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"tan","tan"

,function (){var self=this;	return Math.tan(self); ;return self;}

,"arithmetic",unescape("tan%0D%0A%7B%27%09return%20Math.tan%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"atan2:","atan2_"

,function (aNumber){var self=this;	return Math.atan2(self,aNumber); ;return self;}

,"arithmetic",unescape("atan2%3A%20aNumber%0D%0A%7B%27%09return%20Math.atan2%28self%2CaNumber%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"arcTan","arcTan"

,function (){var self=this;	return Math.atan(self); ;return self;}

,"arithmetic",unescape("arcTan%0D%0A%7B%27%09return%20Math.atan%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"arcSin","arcSin"

,function (){var self=this;	return Math.asin(self); ;return self;}

,"arithmetic",unescape("arcSin%0D%0A%7B%27%09return%20Math.asin%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"arcCos","arcCos"

,function (){var self=this;	return Math.acos(self); ;return self;}

,"arithmetic",unescape("arcCos%0D%0A%7B%27%09return%20Math.acos%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"negated","negated"

,function (){var self=this;return ((-1) * self);return self;}

,"arithmetic",unescape("negated%0D%0A%09%5E-1%20*%20self%20"));

smalltalk.bind(smalltalk.Number,"max:","max_"

,function (aNumber){var self=this;	return Math.max(self, aNumber); ;return self;}

,"arithmetic",unescape("max%3A%20aNumber%0D%0A%09%22%20Return%20the%20result%20of%20operation%20on%20receiver%20and%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20Math.max%28self%2C%20aNumber%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"min:","min_"

,function (aNumber){var self=this;	return Math.min(self, aNumber); ;return self;}

,"arithmetic",unescape("min%3A%20aNumber%0D%0A%09%22%20Return%20the%20result%20of%20operation%20on%20receiver%20and%20aNumber.%20%22%0D%0A%0D%0A%7B%27%09return%20Math.min%28self%2C%20aNumber%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"abs","abs"

,function (){var self=this;try{(((self < (0))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "abs", fn: function(){return self.negated()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "abs", fn: function(){return self}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "abs"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("abs%0D%0A%09%22%20Return%20the%20absolute%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%3C%200%20ifTrue%3A%20%5B%20%5Eself%20negated%20%5D.%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Number,"rounded","rounded"

,function (){var self=this;	return Math.round(self); ;return self;}

,"converting",unescape("rounded%0D%0A%09%22%20Return%20the%20receiver%20rounded.%20%22%0D%0A%0D%0A%7B%27%09return%20Math.round%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"truncated","truncated"

,function (){var self=this;	return Math.floor(self); ;return self;}

,"converting",unescape("truncated%0D%0A%09%22%20Return%20the%20receiver%20truncated.%20%22%0D%0A%0D%0A%7B%27%09return%20Math.floor%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"to:","to_"

,function (aNumber){var self=this;try{var array=nil;var first=nil;var last=nil;var count=nil;first=self.truncated();

last=(aNumber.truncated() + (1));

count=(1);

((first._lt_eq(last)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "to_", fn: function(){return self.error_("Wrong interval")}})})();})());

array=smalltalk.Array.$$new();

(function(){for(var $1$=last._minus(first);$1$>0;$1$--){(function(){array.at_put_(count, first);count=(count + (1));return first=(first + (1));})()};return nil})();

(function(){throw({name: "stReturn", selector: "to_", fn: function(){return array}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "to_"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("to%3A%20aNumber%0D%0A%09%22%20Return%20a%20collection%20of%20numbers%20from%20the%20receiver%20to%20aNumber.%20%22%0D%0A%0D%0A%09%7C%20array%20first%20last%20count%20%7C%0D%0A%09first%20%3A%3D%20self%20truncated.%0D%0A%09last%20%3A%3D%20aNumber%20truncated%20+%201.%0D%0A%09count%20%3A%3D%201.%0D%0A%09first%20%3C%3D%20last%20ifFalse%3A%20%5B%20%5Eself%20error%3A%20%27Wrong%20interval%27%20%5D.%0D%0A%09array%20%3A%3D%20Array%20new.%0D%0A%09last%20-%20first%20timesRepeat%3A%20%5B%0D%0A%09%09array%20at%3A%20count%20put%3A%20first.%0D%0A%09%09count%20%3A%3D%20count%20+%201.%0D%0A%09%09first%20%3A%3D%20first%20+%201%0D%0A%09%5D.%0D%0A%09%5Earray"));

smalltalk.bind(smalltalk.Number,"timesRepeat:","timesRepeat_"

,function (aBlock){var self=this;var count=nil;count=(1);

(function(){while(!(function(){return count._gt(self);})()){(function(){aBlock.value();return count=(count + (1));})()};return nil})();return self;}

,"enumerating",unescape("timesRepeat%3A%20aBlock%0D%0A%09%22%20Evaluates%20aBlock%20a%20number%20of%20times%20given%20by%20the%20receiver.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20count%20%7C%0D%0A%09count%20%3A%3D%201.%0D%0A%09%5B%20count%20%3E%20self%20%5D%20whileFalse%3A%20%5B%0D%0A%09%09aBlock%20value.%0D%0A%09%09count%20%3A%3D%20count%20+%201%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Number,"to:do:","to_do_"

,function (aNumber,aBlock){var self=this;	for(var i=self;i<=aNumber;i++){aBlock(i);} ;return self;}

,"iterating",unescape("to%3A%20aNumber%20do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20from%20the%20receiver%20to%20aNumber.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%22%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self.%0D%0A%09%5B%20index%20%3C%3D%20aNumber%20%5D%20whileTrue%3A%20%5B%0D%0A%09%09aBlock%20value%3A%20index.%0D%0A%09%09index%20%3A%3D%20index%20+%20increment%0D%0A%09%5D%22%0D%0A%7B%27%09for%28var%20i%3Dself%3Bi%3C%3DaNumber%3Bi++%29%7BaBlock%28i%29%3B%7D%20%27%7D"));

smalltalk.bind(smalltalk.Number,"to:by:do:","to_by_do_"

,function (aNumber,increment,aBlock){var self=this;	if(increment>0) {
		for(var i=self;i<=aNumber;i=i+increment){aBlock(i);}
	} else{
		for(var i=self;aNumber<=i;i=i+increment){aBlock(i);}
	}	;return self;}

,"iterating",unescape("to%3A%20aNumber%20by%3A%20increment%20do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20the%20numbers%20between%20the%20receiver%20and%20aNumber%20where%20each%20number%20is%20the%20previous%20number%20plus%20increment.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%7B%27%09if%28increment%3E0%29%20%7B%0D%0A%09%09for%28var%20i%3Dself%3Bi%3C%3DaNumber%3Bi%3Di+increment%29%7BaBlock%28i%29%3B%7D%0D%0A%09%7D%20else%7B%0D%0A%09%09for%28var%20i%3Dself%3BaNumber%3C%3Di%3Bi%3Di+increment%29%7BaBlock%28i%29%3B%7D%0D%0A%09%7D%09%27%7D"));

smalltalk.bind(smalltalk.Number,"asString","asString"

,function (){var self=this;return self.printString();return self;}

,"converting",unescape("asString%0D%0A%09%22%20Return%20the%20text%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20printString"));

smalltalk.bind(smalltalk.Number,"asJavascript","asJavascript"

,function (){var self=this;return unescape("%28")._comma(self.printString())._comma(unescape("%29"));return self;}

,"converting",unescape("asJavascript%0D%0A%09%22%20Return%20the%20javascript%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%28%27%2C%20self%20printString%2C%20%27%29%27"));

smalltalk.bind(smalltalk.Number,"printString","printString"

,function (){var self=this;	return String(self); ;return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20the%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20String%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"isNumber","isNumber"

,function (){var self=this;return true;return self;}

,"testing",unescape("isNumber%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20number.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Number,"atRandom","atRandom"

,function (){var self=this;return (smalltalk.Random.$$new().next()._star(self).truncated() + (1));return self;}

,"converting",unescape("atRandom%0D%0A%09%22%20Return%20a%20random%20integer%20in%20the%20interval%20from%201%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28Random%20new%20next%20*%20self%29%20truncated%20+%201"));

smalltalk.bind(smalltalk.Number,"@","_at"

,function (aNumber){var self=this;return smalltalk.Point.x_y_(self, ((((aNumber || nil) === nil)).mustBeBoolean()==true ? (function(){return (0);})() : (function(){return aNumber;})()));return self;}

,"converting",unescape("@%20aNumber%0D%0A%09%22%20Return%20a%20Point%20with%20coordinates%20given%20by%20the%20receiver%20and%20aNumber.%20%22%0D%0A%0D%0A%09%5EPoint%20x%3A%20self%20y%3A%20%28aNumber%20isNil%20ifTrue%3A%20%5B0%5D%20ifFalse%3A%20%5BaNumber%5D%29"));

smalltalk.bind(smalltalk.Number,"asPoint","asPoint"

,function (){var self=this;return smalltalk.Point.x_y_(self, self);return self;}

,"converting",unescape("asPoint%0D%0A%09%22%20Return%20a%20Point%20with%20both%20coordinates%20given%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPoint%20x%3A%20self%20y%3A%20self"));

smalltalk.bind(smalltalk.Number,"asJSONObject","asJSONObject"

,function (){var self=this;return (self + (0));return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20object%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Eself%20+%200%0D%0A%22Note%3A%09we%20need%20to%20normalize%20result%20to%20do%20not%20destroy%20typeof%20checkings%0D%0A%09Do%20NOT%20modify%20this%20method%20if%20you%20do%20not%20know%20what%20you%20are%20doing.%0D%0A%09If%20you%20remove%20the%20+%200%20computation%2C%20the%20returned%20object%20will%20return%20%27object%27%20and%20not%20%27number%27%20as%20result%20of%20typeof%20operation.%0D%0A%22"));

smalltalk.bind(smalltalk.Number,"between:and:","between_and_"

,function (min,max){var self=this;return min._lt_eq(self).and_((function(){return self._lt_eq(max);}));return self;}

,"testing",unescape("between%3A%20min%20and%3A%20max%0D%0A%09%22%20Answer%20true%20if%20the%20receiver%20is%20greater%20than%20or%20equal%20to%20min%20and%20less%20than%20or%20equal%20to%20max%2C%20else%20answer%20false.%20%22%0D%0A%0D%0A%09%5Emin%20%3C%3D%20self%20and%3A%20%5B%20self%20%3C%3D%20max%20%5D"));

smalltalk.bind(smalltalk.Number,"clearInterval","clearInterval"

,function (){var self=this;	clearInterval(Number(self)); ;return self;}

,"intervals",unescape("clearInterval%0D%0A%0D%0A%7B%27%09clearInterval%28Number%28self%29%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Number,"shallowCopy","shallowCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Number,"deepCopy","deepCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Number,"yourself","yourself"

,function (){var self=this;return (self + (0));return self;}

,"identity",unescape("yourself%20%0D%0A%09%22%20Return%20the%20receiver.%0D%0A%09Note%3A%20do%20NOT%20modify/remove%20this%20method%20if%20you%20dont%20know%20what%20you%20are%20doing.%0D%0A%09Test%20the%20following%20expression%20after%20changing%20this%20code%3A%0D%0A%09%09123%20yourself%20%3D%3D%20123%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20+%200"));

smalltalk.bind(smalltalk.CompiledMethod,"source","source"

,function (){var self=this;return (self["$source"] || (function(){return "";}).value());return self;}

,"accessing",unescape("source%0D%0A%09%22%20Return%20the%20source%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24source%27%20ifAbsent%3A%20%5B%27%27%5D"));

smalltalk.bind(smalltalk.CompiledMethod,"source:","source_"

,function (aString){var self=this;(self["$source"]=(aString));return self;}

,"accessing",unescape("source%3A%20aString%0D%0A%09%22%20Set%20the%20source%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20basicAt%3A%20%27%24source%27%20put%3A%20aString"));

smalltalk.bind(smalltalk.CompiledMethod,"category","category"

,function (){var self=this;return (self["$category"] || (function(){return "";}).value());return self;}

,"accessing",unescape("category%0D%0A%09%22%20Return%20the%20category%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24category%27%20ifAbsent%3A%20%5B%27%27%5D"));

smalltalk.bind(smalltalk.CompiledMethod,"category:","category_"

,function (aString){var self=this;(self["$category"]=(aString));return self;}

,"accessing",unescape("category%3A%20aString%0D%0A%09%22%20Set%20the%20category%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20basicAt%3A%20%27%24category%27%20put%3A%20aString"));

smalltalk.bind(smalltalk.CompiledMethod,"selector","selector"

,function (){var self=this;return (self["$selector"] || nil);return self;}

,"accessing",unescape("selector%0D%0A%09%22%20Return%20the%20selector%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24selector%27"));

smalltalk.bind(smalltalk.CompiledMethod,"selector:","selector_"

,function (aString){var self=this;(self["$selector"]=(aString));return self;}

,"accessing",unescape("selector%3A%20aString%0D%0A%09%22%20Set%20the%20selector%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20basicAt%3A%20%27%24selector%27%20put%3A%20aString"));

smalltalk.bind(smalltalk.CompiledMethod,"fn","fn"

,function (){var self=this;return (self["$fn"] || nil);return self;}

,"accessing",unescape("fn%0D%0A%09%22%20Return%20the%20function%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24fn%27"));

smalltalk.bind(smalltalk.CompiledMethod,"fn:","fn_"

,function (aBlock){var self=this;(self["$fn"]=(aBlock));return self;}

,"accessing",unescape("fn%3A%20aBlock%0D%0A%09%22%20Set%20the%20function%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20basicAt%3A%20%27%24fn%27%20put%3A%20aBlock"));

smalltalk.bind(smalltalk.CompiledMethod,"classField","classField"

,function (){var self=this;return self['@classField'];return self;}

,"accessing",unescape("classField%0D%0A%09%22%20Return%20the%20implementor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EclassField"));

smalltalk.bind(smalltalk.CompiledMethod,"classField:","classField_"

,function (aClass){var self=this;self['@classField']=aClass;return self;}

,"accessing",unescape("classField%3A%20aClass%0D%0A%09%22%20Set%20the%20implementor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09classField%20%3A%3D%20aClass"));

smalltalk.bind(smalltalk.CompiledMethod,"toString","toString"

,function (){var self=this;return ((((self['@classField'] || nil) !== nil)).mustBeBoolean()==true ? (function(){return self['@classField'];})() : nil).printString()._comma(unescape("%3E%3E%23"))._comma(self.selector().toString());return self;}

,"printing",unescape("toString%0D%0A%09%22%20Return%20the%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28classField%20notNil%20ifTrue%3A%20%5B%20classField%20%5D%29%20printString%0D%0A%09%09%2C%27%3E%3E%23%27%20%2Cself%20selector%20toString"));

smalltalk.bind(smalltalk.CompiledMethod,"printString","printString"

,function (){var self=this;return self.toString();return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20the%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20toString"));

smalltalk.bind(smalltalk.CompiledMethod,"asJSONObject","asJSONObject"

,function (){var self=this;return self;return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20object%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.CompiledMethod,"shallowCopy","shallowCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.CompiledMethod,"deepCopy","deepCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.CompiledMethod,"messages","messages"

,function (){var self=this;return smalltalk.MethodReferences.$$new().messagesOf_(self);return self;}

,"Compiler-accessing",unescape("messages%0D%0A%09%22%20Return%20all%20the%20messages%20that%20can%20be%20sent%20during%20execution%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EMethodReferences%20new%20messagesOf%3A%20self"));

smalltalk.bind(smalltalk.Behavior,"new","$$new"

,function (){var self=this;return self.basicNew().initialize();return self;}

,unescape("instance%20creation"),unescape("new%0D%0A%09%22%20Return%20a%20new%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicNew%20initialize"));

smalltalk.bind(smalltalk.Behavior,"new:","new_"

,function (size){var self=this;return self.basicNew_(size);return self;}

,unescape("instance%20creation"),unescape("new%3A%20size%0D%0A%09%22%20Return%20a%20new%20instance%20of%20the%20receiver%20of%20specified%20size.%20%22%0D%0A%0D%0A%09%5Eself%20basicNew%3A%20size"));

smalltalk.bind(smalltalk.Behavior,"basicNew:","basicNew_"

,function (size){var self=this;return self.invalidMessage();return self;}

,unescape("instance%20creation"),unescape("basicNew%3A%20size%0D%0A%09%22%20Return%20a%20new%20instance%20of%20the%20receiver%20of%20specified%20size.%20%22%0D%0A%0D%0A%09%5Eself%20invalidMessage"));

smalltalk.bind(smalltalk.Behavior,"basicNew","basicNew"

,function (){var self=this;	return new self.$fn();return self;}

,unescape("instance%20creation"),unescape("basicNew%0D%0A%09%22%20Return%20a%20new%20%28non-initialized%29%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20new%20self.%24fn%28%29%27%7D"));

smalltalk.bind(smalltalk.Behavior,"name","name"

,function (){var self=this;return (self["$className"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24className%27"));

smalltalk.bind(smalltalk.Behavior,"superclass","superclass"

,function (){var self=this;return (self["$superclass"] || nil);return self;}

,"accessing",unescape("superclass%0D%0A%09%22%20Return%20the%20superclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24superclass%27"));

smalltalk.bind(smalltalk.Behavior,"subclasses","subclasses"

,function (){var self=this;	return smalltalk.subclasses(self);return self;}

,"accessing",unescape("subclasses%0D%0A%09%22%20Return%20the%20subclasses%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20smalltalk.subclasses%28self%29%27%7D"));

smalltalk.bind(smalltalk.Behavior,"allSubclasses","allSubclasses"

,function (){var self=this;	 return smalltalk.allSubclasses(self); ;return self;}

,"query",unescape("allSubclasses%0D%0A%09%22%20Return%20all%20the%20subclasses%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09%20return%20smalltalk.allSubclasses%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Behavior,"withAllSubclasses","withAllSubclasses"

,function (){var self=this;return smalltalk.Array.with_(self)._comma(self.allSubclasses());return self;}

,"accessing",unescape("withAllSubclasses%0D%0A%09%22%20Return%20a%20collection%20with%20the%20receiver%20and%20all%20subclasses.%20%22%0D%0A%0D%0A%09%5E%28Array%20with%3A%20self%29%20%2C%20self%20allSubclasses"));

smalltalk.bind(smalltalk.Behavior,"allSuperclassesDo:","allSuperclassesDo_"

,function (aBlock){var self=this;var current=nil;current=self.superclass();

(function(){while((function(){return ((current || nil) !== nil);})()){(function(){aBlock.value_(current);return current=current.superclass();})()};return nil})();return self;}

,"accessing",unescape("allSuperclassesDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20superclasses%20of%20the%20receiver.%0D%0A%09The%20superclasses%20are%20walked%20in%20inverse%20hierarchical%20order%2C%20i.e%20class%20Object%20is%20last.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20current%20%7C%0D%0A%09current%20%3A%3D%20self%20superclass.%0D%0A%09%5B%20current%20notNil%20%5D%20whileTrue%3A%20%5B%0D%0A%09%20%20%20%20%20%20%20%20aBlock%20value%3A%20current.%0D%0A%09%09current%20%3A%3D%20current%20superclass.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Behavior,"withAllSuperclassesDo:","withAllSuperclassesDo_"

,function (aBlock){var self=this;aBlock.value_(self);

return self.allSuperclassesDo_(aBlock);return self;}

,"accessing",unescape("withAllSuperclassesDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20receiver%20and%20it%27s%20superclasses.%0D%0A%09The%20superclasses%20are%20walked%20in%20inverse%20hierarchical%20order%2C%20i.e%20class%20Object%20is%20last.%0D%0A%09%22%0D%0A%0D%0A%09aBlock%20value%3A%20self.%0D%0A%09%5Eself%20allSuperclassesDo%3A%20aBlock"));

smalltalk.bind(smalltalk.Behavior,"withAllSuperclasses","withAllSuperclasses"

,function (){var self=this;return smalltalk.Array.with_(self)._comma(self.allSuperclasses());return self;}

,"accessing",unescape("withAllSuperclasses%0D%0A%09%22%20Return%20a%20collection%20with%20the%20receiver%20and%20all%20superclasses.%20%22%0D%0A%0D%0A%09%5E%28Array%20with%3A%20self%29%20%2C%20self%20allSuperclasses"));

smalltalk.bind(smalltalk.Behavior,"allSuperclasses","allSuperclasses"

,function (){var self=this;var result=nil;result=smalltalk.Array.$$new();

self.allSuperclassesDo_((function(each){return result.add_(each);}));

return result;return self;}

,"accessing",unescape("allSuperclasses%0D%0A%09%22%20Return%20a%20collection%20of%20all%20the%20superclasses%20of%20the%20receiver.%0D%0A%09The%20superclasses%20are%20in%20inverse%20hierarchical%20order%2C%20i.e%20class%20Object%20is%20last.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09self%20allSuperclassesDo%3A%20%5B%3Aeach%7C%20result%20add%3A%20each%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Behavior,"inheritsFrom:","inheritsFrom_"

,function (aClass){var self=this;try{self.allSuperclassesDo_((function(each){return ((aClass._eq(each)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "inheritsFrom_", fn: function(){return true}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "inheritsFrom_", fn: function(){return false}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "inheritsFrom_"){return $$ex.fn();} throw($$ex);}}

,"query",unescape("inheritsFrom%3A%20aClass%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20inherits%20from%20aClass.%20%22%0D%0A%0D%0A%09self%20allSuperclassesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09aClass%20%3D%20each%20ifTrue%3A%20%5B%20%5Etrue%20%5D%0D%0A%09%5D.%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Behavior,"prototype","prototype"

,function (){var self=this;	return self.$fn.prototype || nil;return self;}

,"accessing",unescape("prototype%0D%0A%09%22%20Return%20the%20prototype%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%7B%27%09return%20self.%24fn.prototype%20%7C%7C%20nil%27%7D"));

smalltalk.bind(smalltalk.Behavior,"constructorName","constructorName"

,function (){var self=this;try{var result=nil;var fn=nil;fn=(self["$fn"] || nil);

result=(fn["name"] || nil);

((((result || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "constructorName", fn: function(){return result}})})();})() : nil);

result=fn.toString().upTo_(unescape("%28")).asArrayOfSubstrings();

((result.size()._eq((2))).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "constructorName", fn: function(){return nil}})})();})());

(function(){throw({name: "stReturn", selector: "constructorName", fn: function(){return result.last()}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "constructorName"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("constructorName%0D%0A%09%22%20Return%20the%20name%20of%20the%20constructor%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%7C%20result%20fn%20%7C%0D%0A%09fn%20%3A%3D%20self%20basicAt%3A%20%27%24fn%27.%0D%0A%09result%20%3A%3D%20fn%20basicAt%3A%20%23name.%0D%0A%09result%20notNil%20ifTrue%3A%20%5B%20%5Eresult%20%5D.%0D%0A%09result%20%3A%3D%20%28fn%20toString%20upTo%3A%20%24%28%29%20asArrayOfSubstrings.%0D%0A%09result%20size%20%3D%202%20ifFalse%3A%20%5B%20%5Enil%20%5D.%0D%0A%09%5Eresult%20last"));

smalltalk.bind(smalltalk.Behavior,"methodsDo:","methodsDo_"

,function (aBlock){var self=this;	var methods = self.$fn.prototype.$methods;
	for(var i in methods) {
		if (!methods.hasOwnProperty(i)) break;
		aBlock(methods[i]);
	}; ;return self;}

,"accessing",unescape("methodsDo%3A%20aBlock%0D%0A%09%22%20Evaluates%20aBlock%20for%20all%20the%20methods%20defined%20by%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09var%20methods%20%3D%20self.%24fn.prototype.%24methods%3B%0D%0A%09for%28var%20i%20in%20methods%29%20%7B%0D%0A%09%09if%20%28%21methods.hasOwnProperty%28i%29%29%20break%3B%0D%0A%09%09aBlock%28methods%5Bi%5D%29%3B%0D%0A%09%7D%3B%20%27%7D"));

smalltalk.bind(smalltalk.Behavior,"selectorsDo:","selectorsDo_"

,function (aBlock){var self=this;	var methods = self.$fn.prototype.$methods;
	for(var i in methods) {
		if (!methods.hasOwnProperty(i)) break;
		aBlock(methods[i].$selector);
	}; ;return self;}

,"accessing",unescape("selectorsDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20all%20the%20selectors%20implemented%20by%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09var%20methods%20%3D%20self.%24fn.prototype.%24methods%3B%0D%0A%09for%28var%20i%20in%20methods%29%20%7B%0D%0A%09%09if%20%28%21methods.hasOwnProperty%28i%29%29%20break%3B%0D%0A%09%09aBlock%28methods%5Bi%5D.%24selector%29%3B%0D%0A%09%7D%3B%20%27%7D"));

smalltalk.bind(smalltalk.Behavior,"methodDictionary","methodDictionary"

,function (){var self=this;var result=nil;result=smalltalk.Dictionary.$$new();

self.methodsDo_((function(each){return result.at_put_(each.selector(), each);}));

return result;return self;}

,"accessing",unescape("methodDictionary%0D%0A%09%22%20Return%20a%20dictionary%20with%20the%20methods%20implemented%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20Dictionary%20new.%0D%0A%09self%20methodsDo%3A%20%5B%3Aeach%7C%20result%20at%3A%20each%20selector%20put%3A%20each%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Behavior,"selectors","selectors"

,function (){var self=this;var result=nil;result=smalltalk.Array.$$new();

self.selectorsDo_((function(each){return result.add_(each);}));

return result;return self;}

,"accessing",unescape("selectors%0D%0A%09%22%20Return%20the%20selectors%20implemented%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09self%20selectorsDo%3A%20%5B%3Aeach%7C%20result%20add%3A%20each%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Behavior,"implements:","implements_"

,function (aSymbol){var self=this;	return (aSymbol in self.$fn.prototype.$methods); ;return self;}

,"query",unescape("implements%3A%20aSymbol%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20implements%20message%20aSymbol.%20%22%0D%0A%0D%0A%7B%27%09return%20%28aSymbol%20in%20self.%24fn.prototype.%24methods%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Behavior,"compiledMethodAt:","compiledMethodAt_"

,function (aSymbol){var self=this;	return self.$fn.prototype.$methods[aSymbol] || nil; ;return self;}

,"query",unescape("compiledMethodAt%3A%20aSymbol%0D%0A%09%22%20Return%20the%20compiled%20method%20at%20aSymbol%20implemented%20by%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%7B%27%09return%20self.%24fn.prototype.%24methods%5BaSymbol%5D%20%7C%7C%20nil%3B%20%27%7D"));

smalltalk.bind(smalltalk.Behavior,">>","_gt_gt"

,function (aSymbol){var self=this;return self.compiledMethodAt_(aSymbol);return self;}

,"query",unescape("%3E%3E%20aSymbol%0D%0A%09%22%20Return%20the%20method%20at%20aSymbol%20%28or%20nil%20if%20not%20implemented%20by%20the%20receiver%29.%20%22%0D%0A%0D%0A%09%5Eself%20compiledMethodAt%3A%20aSymbol"));

smalltalk.bind(smalltalk.Behavior,">>>","_gt_gt_gt"

,function (aSymbol){var self=this;try{var result=nil;result=self.compiledMethodAt_(aSymbol);

((((result || nil) === nil).and_((function(){return ((self.superclass() || nil) !== nil);}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_gt_gt_gt", fn: function(){return self.superclass()._gt_gt_gt(aSymbol)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_gt_gt_gt", fn: function(){return result}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_gt_gt_gt"){return $$ex.fn();} throw($$ex);}}

,"query",unescape("%3E%3E%3E%20aSymbol%0D%0A%09%22%20Return%20the%20method%20at%20aSymbol%20searching%20up%20in%20receiver%27s%20hierarchy%20%28or%20nil%20if%20not%20implemented%20by%20the%20receiver%20nor%20its%20superclasses%29.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20compiledMethodAt%3A%20aSymbol.%0D%0A%09%28result%20isNil%20and%3A%20%5B%20self%20superclass%20notNil%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20superclass%20%3E%3E%3E%20aSymbol%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Behavior,"instVarNames","instVarNames"

,function (){var self=this;return (self["$iVarNames"] || nil);return self;}

,"accessing",unescape("instVarNames%0D%0A%09%22%20Return%20the%20instance%20variable%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24iVarNames%27"));

smalltalk.bind(smalltalk.Behavior,"allInstVarNames","allInstVarNames"

,function (){var self=this;var result=nil;result=self.instVarNames();

self.allSuperclassesDo_((function(each){return result=each.instVarNames()._comma(result);}));

return result;return self;}

,"accessing",unescape("allInstVarNames%0D%0A%09%22%20Return%20all%20of%20the%20instance%20variable%20names%20defined%20in%20the%20receiver%20and%20its%20superclasses.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20instVarNames.%0D%0A%09self%20allSuperclassesDo%3A%20%5B%20%3Aeach%20%7C%20result%20%3A%3D%20each%20instVarNames%20%2C%20result%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Behavior,"instanceVariableNames","instanceVariableNames"

,function (){var self=this;return (self["$iVarNames"] || nil);return self;}

,"accessing",unescape("instanceVariableNames%0D%0A%09%22%20Return%20the%20instance%20variable%20names%20defined%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24iVarNames%27"));

smalltalk.bind(smalltalk.Behavior,"propertyNames","propertyNames"

,function (){var self=this;return (self["$propertyNames"] || (function(){return smalltalk.Array.$$new();}).value());return self;}

,"accessing",unescape("propertyNames%0D%0A%09%22%20Return%20the%20property%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24propertyNames%27%20ifAbsent%3A%20%5B%20Array%20new%20%5D"));

smalltalk.bind(smalltalk.Behavior,"propertyNames:","propertyNames_"

,function (anArray){var self=this;try{((((anArray || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "propertyNames_", fn: function(){return self.basicDelete_("$propertyNames")}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "propertyNames_", fn: function(){return (self["$propertyNames"]=(anArray))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "propertyNames_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("propertyNames%3A%20anArray%0D%0A%09%22%20Set%20the%20property%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09anArray%20isNil%20ifTrue%3A%20%5B%20%5Eself%20basicDelete%3A%20%27%24propertyNames%27%20%5D.%0D%0A%09%5Eself%20basicAt%3A%20%27%24propertyNames%27%20put%3A%20anArray"));

smalltalk.bind(smalltalk.Behavior,"allPropertyNamesDo:","allPropertyNamesDo_"

,function (aBlock){var self=this;self.propertyNames().do_(aBlock);

self.allSuperclassesDo_((function(each){return each.propertyNames().do_(aBlock);}));return self;}

,"accessing",unescape("allPropertyNamesDo%3A%20aBlock%0D%0A%09%22%20Evaluates%20aBlock%20for%20the%20property%20names%20defined%20in%20the%20receiver%20and%20its%20superclasses.%20%22%0D%0A%0D%0A%09self%20propertyNames%20do%3A%20aBlock.%0D%0A%09self%20allSuperclassesDo%3A%20%5B%20%3Aeach%20%7C%20each%20propertyNames%20do%3A%20aBlock%20%5D."));

smalltalk.bind(smalltalk.Behavior,"allInstVarNamesDo:","allInstVarNamesDo_"

,function (aBlock){var self=this;self.instVarNames().do_(aBlock);

self.allSuperclassesDo_((function(each){return each.instVarNames().do_(aBlock);}));return self;}

,"accessing",unescape("allInstVarNamesDo%3A%20aBlock%0D%0A%09%22%20Evaluates%20aBlock%20for%20the%20instance%20variable%20names%20defined%20in%20the%20receiver%20and%20its%20superclasses.%20%22%0D%0A%0D%0A%09self%20instVarNames%20do%3A%20aBlock.%0D%0A%09self%20allSuperclassesDo%3A%20%5B%20%3Aeach%20%7C%20each%20instVarNames%20do%3A%20aBlock%20%5D."));

smalltalk.bind(smalltalk.Behavior,"basicAddCompiledMethod:","basicAddCompiledMethod_"

,function (aMethod){var self=this;	smalltalk.addMethod(aMethod.$selector.asSelector(),aMethod,self); ;return self;}

,"add/remove",unescape("basicAddCompiledMethod%3A%20aMethod%0D%0A%09%22%20Private%20-%20Effectivelly%20add%20aMethod%20to%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09smalltalk.addMethod%28aMethod.%24selector.asSelector%28%29%2CaMethod%2Cself%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Behavior,"addCompiledMethod:","addCompiledMethod_"

,function (aMethod){var self=this;try{((((smalltalk.OverwriteMethods || nil) !== nil).and_((function(){return smalltalk.OverwriteMethods;}))).mustBeBoolean()==true ? nil : (function(){return ((self.implements_(aMethod.selector())).mustBeBoolean()==true ? (function(){return ((self.name()._eq("DoIt").and_((function(){return aMethod.selector()._eq("doIt");}))).mustBeBoolean()==true ? nil : (function(){((((smalltalk.DumpOverwritenMethods || nil) !== nil).and_((function(){return smalltalk.DumpOverwritenMethods.and_((function(){return ((smalltalk.Exporter || nil) !== nil);}));}))).mustBeBoolean()==true ? (function(){self.print_(unescape("//%3F%20")._comma(self.name())._comma(unescape("%3E%3E%23"))._comma(aMethod.selector()));return self.print_(smalltalk.Exporter.$$new().export_method_(self, aMethod));})() : (function(){return self.print_(unescape("//-Overwrite%20Conflict-%20")._comma(self.name())._comma(unescape("%3E%3E%23"))._comma(aMethod.selector()));})());return (function(){throw({name: "stReturn", selector: "addCompiledMethod_", fn: function(){return self}})})();})());})() : nil);})());

((((smalltalk.Exporter || nil) !== nil).and_((function(){return self.name()._eq("DoIt").and_((function(){return aMethod.selector()._eq("doIt");})).not();}))).mustBeBoolean()==true ? (function(){return self.print_(smalltalk.Exporter.$$new().export_method_(self, aMethod));})() : nil);

(function(){throw({name: "stReturn", selector: "addCompiledMethod_", fn: function(){return self.basicAddCompiledMethod_(aMethod)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "addCompiledMethod_"){return $$ex.fn();} throw($$ex);}}

,"add/remove",unescape("addCompiledMethod%3A%20aMethod%0D%0A%09%22%20Add%20the%20compiled%20method%2C%20if%20appropiate%2C%20and%20register%20the%20method%20in%20recent%20methods.%20%22%0D%0A%0D%0A%09%28OverwriteMethods%20notNil%20and%3A%20%5B%09OverwriteMethods%20%5D%29%20ifFalse%3A%20%5B%0D%0A%09%09%28self%20implements%3A%20aMethod%20selector%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%28self%20name%20%3D%20%27DoIt%27%20and%3A%20%5B%20aMethod%20selector%20%3D%20%23doIt%20%5D%29%20ifFalse%3A%20%5B%0D%0A%09%09%09%09%28DumpOverwritenMethods%20notNil%0D%0A%09%09%09%09and%3A%20%5B%20DumpOverwritenMethods%0D%0A%09%09%09%09and%3A%20%5B%20Exporter%20notNil%20%5D%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%09self%20print%3A%20%27//%3F%20%27%2Cself%20name%2C%27%3E%3E%23%27%2CaMethod%20selector.%0D%0A%09%09%09%09%09self%20print%3A%20%28Exporter%20new%20export%3A%20self%20method%3A%20aMethod%29.%0D%0A%09%09%09%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09%09%09%09self%20print%3A%20%27//-Overwrite%20Conflict-%20%27%2Cself%20name%2C%27%3E%3E%23%27%2CaMethod%20selector.%0D%0A%09%09%09%09%5D.%0D%0A%09%09%09%09%5Eself%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09%28Exporter%20notNil%20and%3A%20%5B%20%28self%20name%20%3D%20%27DoIt%27%20and%3A%20%5B%20aMethod%20selector%20%3D%20%23doIt%20%5D%29%20not%20%5D%29%20ifTrue%3A%20%5B%0D%0A%22%20DEBUG%20-%09self%20print%3A%20%27//%20%27%2Cself%20name%2C%27%3E%3E%23%27%2CaMethod%20selector.%22%0D%0A%09%09self%20print%3A%20%28Exporter%20new%20export%3A%20self%20method%3A%20aMethod%29.%0D%0A%09%5D.%0D%0A%09%5Eself%20basicAddCompiledMethod%3A%20aMethod"));

smalltalk.bind(smalltalk.Behavior,"comment","comment"

,function (){var self=this;return (self["$comment"] || (function(){return "";}).value());return self;}

,"accessing",unescape("comment%0D%0A%09%22%20Return%20the%20comment%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24comment%27%20ifAbsent%3A%20%5B%20%27%27%20%5D"));

smalltalk.bind(smalltalk.Behavior,"comment:","comment_"

,function (aString){var self=this;(self["$comment"]=(aString));return self;}

,"accessing",unescape("comment%3A%20aString%0D%0A%09%22%20Set%20the%20comment%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20basicAt%3A%20%27%24comment%27%20put%3A%20aString"));

smalltalk.bind(smalltalk.Behavior,"poolDictionaryNames","poolDictionaryNames"

,function (){var self=this;return self.instanceClass().poolDictionaryNames();return self;}

,"accessing",unescape("poolDictionaryNames%0D%0A%09%22%20Return%20the%20shared%20pool%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20instanceClass%20poolDictionaryNames"));

smalltalk.bind(smalltalk.Behavior,"sharedPoolsAndNamesDo:","sharedPoolsAndNamesDo_"

,function (aBlock){var self=this;var pool=nil;self.instanceClass().withAllSuperclassesDo_((function(each){return each.poolDictionaryNames().do_((function(aName){pool=smalltalk.Smalltalk.poolDictionary_ifAbsent_(aName, (function(){return nil;}));return ((((pool || nil) !== nil)).mustBeBoolean()==true ? (function(){return aBlock.value_value_(aName, pool);})() : nil);}));}));return self;}

,"accessing",unescape("sharedPoolsAndNamesDo%3A%20aBlock%0D%0A%09%22%20Execute%20aBlock%20for%20the%20pool%20dictionaries%20known%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20pool%20%7C%0D%0A%09self%20instanceClass%20withAllSuperclassesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20poolDictionaryNames%20do%3A%20%5B%3AaName%7C%0D%0A%09%09%09pool%20%3A%3D%20Smalltalk%20poolDictionary%3A%20aName%20ifAbsent%3A%20%5B%20nil%20%5D.%0D%0A%09%09%09pool%20notNil%20ifTrue%3A%20%5B%20aBlock%20value%3A%20aName%20value%3A%20pool%20%5D%0D%0A%09%09%5D.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Behavior,"sharedPoolsDo:","sharedPoolsDo_"

,function (aBlock){var self=this;self.sharedPoolsAndNamesDo_((function(aName, aPool){return aBlock.value_(aPool);}));return self;}

,"accessing",unescape("sharedPoolsDo%3A%20aBlock%0D%0A%09%22%20Execute%20aBlock%20for%20the%20pool%20dictionaries%20known%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20sharedPoolsAndNamesDo%3A%20%5B%3AaName%20%3AaPool%7C%20aBlock%20value%3A%20aPool%20%5D"));

smalltalk.bind(smalltalk.Behavior,"classVariablesDo:","classVariablesDo_"

,function (aBlock){var self=this;var bindings=nil;return self.instanceClass().withAllSuperclassesDo_((function(each){bindings=each.classVariables();return ((((bindings || nil) !== nil)).mustBeBoolean()==true ? (function(){return bindings.associationsDo_((function(assoc){return aBlock.value_(assoc);}));})() : nil);}));return self;}

,"accessing",unescape("classVariablesDo%3A%20aBlock%0D%0A%09%22%20Execute%20aBlock%20for%20the%20classVariables%20bindings%20known%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20bindings%20%7C%0D%0A%09%5Eself%20instanceClass%20withAllSuperclassesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09bindings%20%3A%3D%20each%20classVariables.%0D%0A%09%09bindings%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%09bindings%20associationsDo%3A%20%5B%3Aassoc%7C%20aBlock%20value%3A%20assoc%20%5D%0D%0A%09%09%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Behavior,"classVariableNamesDo:","classVariableNamesDo_"

,function (aBlock){var self=this;var bindings=nil;return self.instanceClass().withAllSuperclassesDo_((function(each){bindings=each.classVariables();return ((((bindings || nil) !== nil)).mustBeBoolean()==true ? (function(){return bindings.keysDo_((function(aName){return aBlock.value_(aName);}));})() : nil);}));return self;}

,"accessing",unescape("classVariableNamesDo%3A%20aBlock%0D%0A%09%22%20Execute%20aBlock%20for%20the%20classVariable%20names%20known%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20bindings%20%7C%0D%0A%09%5Eself%20instanceClass%20withAllSuperclassesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09bindings%20%3A%3D%20each%20classVariables.%0D%0A%09%09bindings%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%09bindings%20keysDo%3A%20%5B%3AaName%7C%20aBlock%20value%3A%20aName%20%5D%0D%0A%09%09%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Behavior,"classVariableAt:put:","classVariableAt_put_"

,function (aName,anObject){var self=this;return self.instanceClass().classVariables().at_put_(aName, anObject);return self;}

,"accessing",unescape("classVariableAt%3A%20aName%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20classVariable%20of%20the%20receiver%20to%20anObject.%20%22%0D%0A%0D%0A%09%5Eself%20instanceClass%20classVariables%20at%3A%20aName%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Behavior,"classVariableAt:ifAbsent:","classVariableAt_ifAbsent_"

,function (aName,aBlock){var self=this;try{var bindings=nil;self.instanceClass().withAllSuperclassesDo_((function(each){bindings=each.classVariables();return ((((bindings || nil) !== nil)).mustBeBoolean()==true ? (function(){return ((bindings.includesKey_(aName)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "classVariableAt_ifAbsent_", fn: function(){return bindings.at_(aName)}})})();})() : nil);})() : nil);}));

(function(){throw({name: "stReturn", selector: "classVariableAt_ifAbsent_", fn: function(){return aBlock.evaluate()}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "classVariableAt_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("classVariableAt%3A%20aName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20value%20of%20classVariable%20named%20aName.%20%22%0D%0A%0D%0A%09%7C%20bindings%20%7C%0D%0A%09self%20instanceClass%20withAllSuperclassesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09bindings%20%3A%3D%20each%20classVariables.%0D%0A%09%09bindings%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%09%28bindings%20includesKey%3A%20aName%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%5Ebindings%20at%3A%20aName%0D%0A%09%09%09%5D%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09%5EaBlock%20evaluate"));

smalltalk.bind(smalltalk.Behavior,"classVariableAt:","classVariableAt_"

,function (aName){var self=this;return self.classVariableAt_ifAbsent_(aName, (function(){return self.error_("Undefined class variable "._comma(aName));}));return self;}

,"accessing",unescape("classVariableAt%3A%20aName%0D%0A%09%22%20Return%20the%20value%20of%20classVariable%20named%20aName%20or%20generates%20an%20error.%20%22%0D%0A%0D%0A%09%5Eself%20classVariableAt%3A%20aName%20ifAbsent%3A%20%5B%0D%0A%09%09self%20error%3A%20%27Undefined%20class%20variable%20%27%2CaName%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Behavior,"pool:variableAt:put:","pool_variableAt_put_"

,function (poolName,aName,anObject){var self=this;try{var pool=nil;pool=smalltalk.Smalltalk.poolDictionary_ifAbsent_(poolName, (function(){return (function(){throw({name: "stReturn", selector: "pool_variableAt_put_", fn: function(){return self.error_("Undefined pool variable "._comma(poolName))}})})();}));

(function(){throw({name: "stReturn", selector: "pool_variableAt_put_", fn: function(){return pool.at_put_(aName, anObject)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "pool_variableAt_put_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("pool%3A%20poolName%20variableAt%3A%20aName%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20pool%20Variable%20of%20the%20receiver%20to%20anObject.%20%22%0D%0A%0D%0A%09%7C%20pool%20%7C%0D%0A%09pool%20%3A%3D%20Smalltalk%0D%0A%09%09poolDictionary%3A%20poolName%0D%0A%09%09ifAbsent%3A%20%5B%20%5Eself%20error%3A%20%27Undefined%20pool%20variable%20%27%2CpoolName%20%5D.%0D%0A%09%5Epool%20at%3A%20aName%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Behavior,"loadRequirementsInto:","loadRequirementsInto_"

,function (aCollection){var self=this;return self;return self;}

,"loading",unescape("loadRequirementsInto%3A%20aCollection%0D%0A%09%22%20Add%20the%20requirements%20to%20load%20the%20receiver%20from%20sources%20to%20aCollection.%0D%0A%09Default%20action%20do%20nothing%2C%20this%20method%20can%20be%20refined%20by%20the%20subclasses.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Behavior,"removeSelectors:","removeSelectors_"

,function (aCollection){var self=this;aCollection.do_((function(each){return self.removeSelector_(each);}));return self;}

,"add/remove",unescape("removeSelectors%3A%20aCollection%0D%0A%09%22%20Remove%20the%20methods%20for%20messages%20in%20aCollection%2C%20implemented%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09aCollection%20do%3A%20%5B%3Aeach%7C%20self%20removeSelector%3A%20each%20%5D"));

smalltalk.bind(smalltalk.Behavior,"removeCompiledMethod:","removeCompiledMethod_"

,function (aMethod){var self=this;	smalltalk.removeMethod(self,aMethod); ;return self;}

,"add/remove",unescape("removeCompiledMethod%3A%20aMethod%0D%0A%09%22%20Remove%20aMethod%20from%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09smalltalk.removeMethod%28self%2CaMethod%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Behavior,"removeSelector:","removeSelector_"

,function (aSelector){var self=this;var method=nil;method=self.compiledMethodAt_(aSelector);

((((method || nil) !== nil)).mustBeBoolean()==true ? (function(){return self.removeCompiledMethod_(method);})() : nil);return self;}

,"add/remove",unescape("removeSelector%3A%20aSelector%0D%0A%09%22%20Remove%20the%20method%20for%20message%20aSelector%20implemented%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20method%20%7C%0D%0A%09method%20%3A%3D%20self%20compiledMethodAt%3A%20aSelector.%0D%0A%09method%20notNil%20ifTrue%3A%20%5B%20self%20removeCompiledMethod%3A%20method%20%5D."));

smalltalk.bind(smalltalk.Behavior,"removeFromSystem","removeFromSystem"

,function (){var self=this;self.subclasses().do_((function(each){return each.removeFromSystem();}));

	smalltalk.removeClass(self); ;return self;}

,"remove",unescape("removeFromSystem%0D%0A%09%22%20Remove%20the%20receiver%20from%20system.%20%22%0D%0A%0D%0A%09self%20subclasses%20do%3A%20%5B%3Aeach%7C%20each%20removeFromSystem%20%5D.%0D%0A%7B%27%09smalltalk.removeClass%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Behavior,"compiler","compiler"

,function (){var self=this;return smalltalk.Compiler.for_(self);return self;}

,"compiling",unescape("compiler%0D%0A%09%22%20Return%20a%20compiler%20for%20receiver%27s%20source%20code.%20%22%0D%0A%0D%0A%09%5ECompiler%20for%3A%20self"));

smalltalk.bind(smalltalk.Behavior,"recompile","recompile"

,function (){var self=this;return self.compiler().recompile_(self);return self;}

,"compiling",unescape("recompile%0D%0A%09%22%20Recompile%20all%20the%20methods%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20compiler%20recompile%3A%20self"));

smalltalk.bind(smalltalk.Behavior,"recompileAll","recompileAll"

,function (){var self=this;return self.instanceClass().withAllSubclasses().do_((function(each){return each.recompile();}));return self;}

,"compiling",unescape("recompileAll%0D%0A%09%22%20Recompile%20all%20the%20methods%20of%20the%20receiver%20and%20its%20subclasses.%09%22%0D%0A%0D%0A%09%5Eself%20instanceClass%20withAllSubclasses%20do%3A%20%5B%3Aeach%7C%20each%20recompile%20%5D"));

smalltalk.bind(smalltalk.Behavior,"implementorsOf:","implementorsOf_"

,function (aSymbol){var self=this;var result=nil;var method=nil;result=smalltalk.Array.$$new();

self.withAllSubclasses().do_((function(each){method=each._gt_gt(aSymbol);((((method || nil) !== nil)).mustBeBoolean()==true ? (function(){return result.add_(method);})() : nil);method=each.$klass._gt_gt(aSymbol);return ((((method || nil) !== nil)).mustBeBoolean()==true ? (function(){return result.add_(method);})() : nil);}));

return result;return self;}

,"query",unescape("implementorsOf%3A%20aSymbol%0D%0A%09%22%20Return%20a%20collection%20of%20methods%20of%20the%20receiver%20and%20its%20subclasses%20that%20implement%20aSymbol.%20%22%0D%0A%0D%0A%09%7C%20result%20method%20%7C%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09self%20withAllSubclasses%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%09method%20%3A%3D%20each%20%3E%3E%20aSymbol.%0D%0A%09%09method%20notNil%20ifTrue%3A%20%5B%20result%20add%3A%20method%20%5D.%0D%0A%09%09method%20%3A%3D%20each%20class%20%3E%3E%20aSymbol.%0D%0A%09%09method%20notNil%20ifTrue%3A%20%5B%20result%20add%3A%20method%20%5D.%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Behavior,"implement:comment:as:category:","implement_comment_as_category_"

,function (messageHeader,aComment,sourceCode,aCategory){var self=this;var code=nil;code=unescape("%21%20")._comma(self.name())._comma(((((aCategory || nil) === nil)).mustBeBoolean()==true ? (function(){return " methods";})() : (function(){return " methodsFor: "._comma(aCategory.printString());})()))._comma(unescape("%20%21%0D%0A"))._comma(messageHeader)._comma(((((aComment || nil) === nil)).mustBeBoolean()==true ? (function(){return "";})() : (function(){return unescape("%0D%0A%09%22%20")._comma(aComment)._comma(unescape("%20%22"));})()))._comma(unescape("%0D%0A%0D%0A%09"))._comma(sourceCode)._comma(unescape("%21%20%21%0D%0A%0D%0A"));

return (function($rec){$rec.fileIn();return $rec.yourself();})(code);return self;}

,unescape("code%20generation"),unescape("implement%3A%20messageHeader%0D%0A%09comment%3A%20aComment%0D%0A%09as%3A%20sourceCode%0D%0A%09category%3A%20aCategory%0D%0A%09%22%20Private%20-%20Implement%20a%20method%20in%20the%20receiver.%0D%0A%09Note%3A%20sourceCode%20must%20be%20the%20source%20code%20in%20chunk%20format.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20code%20%7C%0D%0A%09code%20%3A%3D%20%27%21%20%27%2Cself%20name%2C%0D%0A%09%09%28aCategory%20isNil%0D%0A%09%09%09ifTrue%3A%20%5B%20%27%20methods%27%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20%27%20methodsFor%3A%20%27%2C%20aCategory%20printString%20%5D%29%0D%0A%2C%27%20%21%0D%0A%27%2CmessageHeader%2C%20%28aComment%20isNil%20ifTrue%3A%20%5B%20%27%27%20%5D%20ifFalse%3A%20%5B%27%0D%0A%09%22%20%27%2C%20aComment%2C%20%27%20%22%27%5D%29%2C%27%0D%0A%0D%0A%09%27%2CsourceCode%20%2C%27%21%20%21%0D%0A%0D%0A%27.%09%5Ecode%20fileIn%3B%20yourself"));

smalltalk.bind(smalltalk.Behavior,"implement:comment:as:","implement_comment_as_"

,function (messageHeader,aComment,sourceCode){var self=this;return self.implement_comment_as_category_(messageHeader, aComment, sourceCode, nil);return self;}

,unescape("code%20generation"),unescape("implement%3A%20messageHeader%20comment%3A%20aComment%20as%3A%20sourceCode%0D%0A%09%22%20Private%20-%20Implement%20a%20method%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20messageHeader%0D%0A%09%09comment%3A%20aComment%0D%0A%09%09as%3A%20sourceCode%0D%0A%09%09category%3A%20nil"));

smalltalk.bind(smalltalk.Behavior,"implement:as:","implement_as_"

,function (messageHeader,sourceCode){var self=this;return self.implement_comment_as_category_(messageHeader, nil, sourceCode, nil);return self;}

,unescape("code%20generation"),unescape("implement%3A%20messageHeader%20as%3A%20sourceCode%0D%0A%09%22%20Private%20-%20Implement%20a%20method%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20messageHeader%0D%0A%09%09comment%3A%20nil%0D%0A%09%09as%3A%20sourceCode%0D%0A%09%09category%3A%20nil"));

smalltalk.bind(smalltalk.Behavior,"implement:as:category:","implement_as_category_"

,function (messageHeader,sourceCode,aCategory){var self=this;return self.implement_comment_as_category_(messageHeader, nil, sourceCode, aCategory);return self;}

,unescape("code%20generation"),unescape("implement%3A%20messageHeader%20as%3A%20sourceCode%20category%3A%20aCategory%0D%0A%09%22%20Private%20-%20Implement%20a%20method%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20messageHeader%0D%0A%09%09comment%3A%20nil%0D%0A%09%09as%3A%20sourceCode%0D%0A%09%09category%3A%20aCategory"));

smalltalk.bind(smalltalk.Behavior,"class:implement:comment:as:category:","class_implement_comment_as_category_"

,function (aClass,message,aComment,sourceCode,aCategory){var self=this;try{((aClass.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "class_implement_comment_as_category_", fn: function(){return self.class_implement_comment_as_category_(aClass.doIt(), message, aComment, sourceCode, aCategory)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "class_implement_comment_as_category_", fn: function(){return aClass.implement_comment_as_category_(message, aComment, sourceCode, aCategory)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "class_implement_comment_as_category_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("class%3A%20aClass%20implement%3A%20message%0D%0A%09comment%3A%20aComment%20as%3A%20sourceCode%0D%0A%09category%3A%20aCategory%0D%0A%09%22%20Private%20-%20Implement%20a%20method%20in%20aClass.%20%22%0D%0A%0D%0A%09aClass%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%0D%0A%09%09%09class%3A%20aClass%20doIt%0D%0A%09%09%09implement%3A%20message%0D%0A%09%09%09comment%3A%20aComment%0D%0A%09%09%09as%3A%20sourceCode%0D%0A%09%09%09category%3A%20aCategory%0D%0A%09%5D.%0D%0A%09%5EaClass%0D%0A%09%09implement%3A%20message%0D%0A%09%09comment%3A%20aComment%0D%0A%09%09as%3A%20sourceCode%0D%0A%09%09category%3A%20aCategory"));

smalltalk.bind(smalltalk.Behavior,"buildAPI:","buildAPI_"

,function (specs){var self=this;specs.do_((function(spec){return ((spec.isString()).mustBeBoolean()==true ? (function(){spec.evaluateIn();return self;})() : (function(){return self.perform_withArguments_(spec.first(), spec.copyFrom_to_((2), spec.size()));})());}));return self;}

,unescape("code%20generation"),unescape("buildAPI%3A%20specs%0D%0A%09%22%20Generate%20code%20to%20implement%20API%20protocoll%20defined%20by%20specs.%0D%0A%09specs%20must%20be%20an%20array%20of%20%3A%0D%0A%09%09-%20string%20%3A%20it%20will%20be%20considered%20as%20an%20evaluable%20expression%20to%20be%20executed%20in%20the%20context%20of%20the%20receiver.%0D%0A%09%09-%20anArray%20%3A%20of%20%23%28%20selector%20arg1%20arg2%20arg3%20arg4...%20%29%20to%20be%20performed%20for%20code%20generation/setup%20of%20the%20receiver%0D%0A%09%09%09where%20selector%20is%20frequently%20a%20selector%20under%20%27code%20generation%27%20category.%0D%0A%09%22%0D%0A%0D%0A%09specs%20do%3A%20%5B%3Aspec%7C%0D%0A%09%09spec%20isString%0D%0A%09%09ifTrue%3A%20%5B%20spec%20evaluateIn.%20self%20%5D%0D%0A%09%09ifFalse%3A%20%5B%0D%0A%09%09%09self%09perform%3A%20spec%20first%0D%0A%09%09%09%09withArguments%3A%20%28spec%20copyFrom%3A%202%20to%3A%20spec%20size%29%0D%0A%09%09%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Behavior,"stMessageHeader:","stMessageHeader_"

,function (msgHeader){var self=this;return msgHeader;return self;}

,unescape("code%20generation"),unescape("stMessageHeader%3A%20msgHeader%0D%0A%09%22%20Private%20-%20Return%20a%20message%20header%20string%20with%20nice%20smalltalk%20looking.%0D%0A%09Default%20implementation%20leave%20the%20message%20header%20as%20is.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses%20to%20transform%20message%20pattern%20for%20better%20code%20generation.%0D%0A%09%22%0D%0A%0D%0A%09%5EmsgHeader"));

smalltalk.bind(smalltalk.Behavior,"buildAccessor:","buildAccessor_"

,function (accessor){var self=this;try{((accessor.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildAccessor_", fn: function(){return self.buildGetter_(accessor)._comma(self.buildSetter_(accessor))}})})();})() : nil);

(((accessor.size() > (1)).and_((function(){return accessor.second()._eq("initialize");}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildAccessor_", fn: function(){return self.buildGetter_initialize_(accessor.first(), accessor.last())._comma(self.buildSetter_(accessor.first()))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildAccessor_", fn: function(){return accessor.inject_into_(" ", (function(total, tuple){return total._comma(self.implement_comment_as_category_(tuple.first(), tuple.at_((2)), tuple.at_((3)), "accessing"));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildAccessor_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildAccessor%3A%20accessor%0D%0A%09%22%20Private%20-%20Build%20%28instance%29%20method%20to%20access%20native%20property.%20%22%0D%0A%0D%0A%09accessor%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5E%28self%20buildGetter%3A%20accessor%29%0D%0A%09%09%2C%28self%20buildSetter%3A%20accessor%29%0D%0A%09%5D.%0D%0A%09%28accessor%20size%20%3E%201%20and%3A%20%5B%20accessor%20second%20%3D%20%23initialize%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%5E%28self%20buildGetter%3A%20accessor%20first%20initialize%3A%20accessor%20last%29%0D%0A%09%09%2C%28self%20buildSetter%3A%20accessor%20first%29%0D%0A%09%5D.%0D%0A%0D%0A%09%5Eaccessor%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Atuple%7C%0D%0A%09%09total%20%2C%20%28self%0D%0A%09%09%09implement%3A%20tuple%20first%20comment%3A%20%28tuple%20at%3A%202%29%0D%0A%09%09%09as%3A%20%28tuple%20at%3A%203%29%20category%3A%20%23accessing%29%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Behavior,"buildGetter:","buildGetter_"

,function (aSelector){var self=this;return self.implement_comment_as_category_(self.stMessageHeader_(aSelector), "Return the "._comma(aSelector)._comma(" of the receiver."), unescape("%5E")._comma(aSelector), "accessing");return self;}

,unescape("code%20generation"),unescape("buildGetter%3A%20aSelector%0D%0A%09%22%20Private%20-%20Build%20method%20to%20get%20instance%20aSelector.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%0D%0A%09%09comment%3A%20%27Return%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5E%27%20%2CaSelector%20category%3A%20%23accessing"));

smalltalk.bind(smalltalk.Behavior,"buildInitialize:with:","buildInitialize_with_"

,function (aSelector,initializer){var self=this;return self.implement_comment_as_category_("initialize"._comma(aSelector.asSmalltalkName_(true)), unescape("Private%20-%20Initialize%20the%20")._comma(aSelector)._comma(" of the receiver."), initializer, "initialize");return self;}

,unescape("code%20generation"),unescape("buildInitialize%3A%20aSelector%20with%3A%20initializer%0D%0A%09%22%20Private%20-%20Build%20method%20to%20initialize%20instance%20variable%20aSelector.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%23initialize%20%2C%28aSelector%20asSmalltalkName%3A%20true%29%0D%0A%09%09comment%3A%20%27Private%20-%20Initialize%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20initializer%0D%0A%09%09category%3A%20%23initialize"));

smalltalk.bind(smalltalk.Behavior,"buildGetter:initialize:","buildGetter_initialize_"

,function (aSelector,initializer){var self=this;var code=nil;code=((initializer._eq("initialize")).mustBeBoolean()==true ? (function(){return unescape("%5Eself%20implementedBySubclass");})() : (function(){return ((initializer.notEmpty()).mustBeBoolean()==true ? (function(){return ((initializer.first()._eq(".")).mustBeBoolean()==true ? (function(){return initializer.copyFrom_to_((2), initializer.size());})() : (function(){return aSelector._comma(unescape("%20%3A%3D%20"))._comma(((initializer.first().isUppercase().and_((function(){return initializer.asArrayOfSubstrings().size()._eq((1));}))).mustBeBoolean()==true ? (function(){return initializer._comma(" new");})() : (function(){return initializer;})()));})());})() : nil);})());

return ((((code || nil) !== nil)).mustBeBoolean()==true ? (function(){return self.buildInitialize_with_(aSelector, code);})() : (function(){return "";})())._comma(self.implement_comment_as_category_(self.stMessageHeader_(aSelector), "Return the "._comma(aSelector)._comma(" of the receiver."), aSelector._comma(unescape("%20isNil%20ifTrue%3A%20%5B%20self%20"))._comma("initialize")._comma(aSelector.asSmalltalkName_(true))._comma(unescape("%5D.%0D%0A%09%5E"))._comma(aSelector), "accessing"));return self;}

,unescape("code%20generation"),unescape("buildGetter%3A%20aSelector%20initialize%3A%20initializer%0D%0A%09%22%20Private%20-%20Build%20method%20to%20get%20instance%20aSelector%20w/deferred%20initialization%20mode.%0D%0A%09Note%3A%20%23initializer%20can%20be%3A%0D%0A%09%09%23initialize%20to%20generate%20default/deferred%20implementation.%0D%0A%09%09empty%20string%20to%20do%20NOT%20generate%20%23initialize...%20method.%0D%0A%09%09smalltalk%20code%20starting%20with%20%24.%20to%20use%20that%20code%20as%20method%20implementation.%0D%0A%09%09smalltalk%20expression%20for%20asignment%20%28to%20be%20used%20as%20assignment%20to%20instance%29.%0D%0A%09%09GlobalName%20if%20code%20do%20not%20have%20blanks%20and%20start%20with%20uppercase%2C%20it%20will%20be%20used%20as%20class%20to%20instantiate%20during%20initialization.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20code%20%7C%0D%0A%09code%20%3A%3D%20initializer%20%3D%20%23initialize%0D%0A%09%20%20ifTrue%3A%20%5B%20%27%5Eself%20implementedBySubclass%27%20%5D%20ifFalse%3A%20%5B%0D%0A%09%09initializer%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%09%09initializer%20first%20%3D%20%24.%0D%0A%09%09%09ifTrue%3A%20%5B%20initializer%20copyFrom%3A%202%20to%3A%20initializer%20size%20%5D%20ifFalse%3A%20%5B%0D%0A%09%09%09%09aSelector%20%2C%27%20%3A%3D%20%27%20%2C%28%0D%0A%09%09%09%09%09%28initializer%20first%20isUppercase%20and%3A%20%5B%20initializer%20asArrayOfSubstrings%20size%20%3D%201%20%5D%29%0D%0A%09%09%09%09%09ifTrue%3A%20%5B%20initializer%20%2C%27%20new%27%20%5D%0D%0A%09%09%09%09%09ifFalse%3A%20%5B%20initializer%20%5D%29%0D%0A%09%09%09%5D%0D%0A%09%09%5D%0D%0A%09%20%20%5D.%0D%0A%09%5E%28code%20notNil%20ifTrue%3A%20%5B%20self%20buildInitialize%3A%20aSelector%20with%3A%20code%20%5D%20ifFalse%3A%20%5B%20%27%27%20%5D%29%0D%0A%09%2C%28self%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%0D%0A%09%09comment%3A%20%27Return%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20aSelector%2C%27%20isNil%20ifTrue%3A%20%5B%20self%20%27%20%2C%20%23initialize%20%2C%28aSelector%20asSmalltalkName%3A%20true%29%20%2C%27%5D.%0D%0A%09%5E%27%20%2CaSelector%20category%3A%20%23accessing%29"));

smalltalk.bind(smalltalk.Behavior,"buildSetter:","buildSetter_"

,function (aSelector){var self=this;return self.implement_comment_as_category_(self.stMessageHeader_(aSelector)._comma(": anObject"), "Set the "._comma(aSelector)._comma(" of the receiver."), aSelector._comma(unescape("%20%3A%3D%20anObject")), "accessing");return self;}

,unescape("code%20generation"),unescape("buildSetter%3A%20aSelector%0D%0A%09%22%20Private%20-%20Build%20method%20to%20set%20instance%20aSelector.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%20%2C%27%3A%20anObject%27%0D%0A%09%09comment%3A%20%27Set%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20aSelector%20%2C%27%20%3A%3D%20anObject%27%0D%0A%09%09category%3A%20%23accessing"));

smalltalk.bind(smalltalk.Behavior,"buildGetters:","buildGetters_"

,function (specs){var self=this;try{((specs.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildGetters_", fn: function(){return self.buildGetters_(specs.asArrayOfSubstrings())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildGetters_", fn: function(){return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildGetter_(each));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildGetters_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildGetters%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20get%20instancess.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildGetters%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildGetter%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.Behavior,"buildSetters:","buildSetters_"

,function (specs){var self=this;try{((specs.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildSetters_", fn: function(){return self.buildSetters_(specs.asArrayOfSubstrings())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildSetters_", fn: function(){return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildSetter_(each));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildSetters_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildSetters%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20set%20instances.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildSetters%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildSetter%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.Behavior,"buildAccessors:","buildAccessors_"

,function (specs){var self=this;try{((specs.isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildAccessors_", fn: function(){return self.buildAccessors_(specs.asArrayOfSubstrings())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "buildAccessors_", fn: function(){return specs.inject_into_(" ", (function(total, each){return total._comma(self.buildAccessor_(each));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildAccessors_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildAccessors%3A%20specs%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20access%20instances.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildAccessors%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Especs%20inject%3A%20%27%20%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%20%28self%20buildAccessor%3A%20each%29%20%5D"));

smalltalk.bind(smalltalk.Behavior,"buildAccessors","buildAccessors"

,function (){var self=this;return self.buildAccessors_(self.instanceVariableNames());return self;}

,unescape("code%20generation"),unescape("buildAccessors%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20access%20all%20instance%20variables.%20%22%0D%0A%0D%0A%09%5Eself%20buildAccessors%3A%20self%20instanceVariableNames"));

smalltalk.bind(smalltalk.Behavior,"asJSONObject","asJSONObject"

,function (){var self=this;return self;return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20object%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Behavior,"shallowCopy","shallowCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Behavior,"deepCopy","deepCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Behavior,"codeFor:accessing:","codeFor_accessing_"

,function (aCompiler,aNode){var self=this;try{var aName=nil;aName=aNode.value();

self.allInstVarNamesDo_((function(each){return ((aName._eq(each)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "codeFor_accessing_", fn: function(){return aCompiler.codeToAccessInstanceVariable_(aName)}})})();})() : nil);}));

self.allPropertyNamesDo_((function(each){return ((aName._eq(each)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "codeFor_accessing_", fn: function(){return aCompiler.codeToAccessProperty_(aName)}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "codeFor_accessing_", fn: function(){return nil}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "codeFor_accessing_"){return $$ex.fn();} throw($$ex);}}

,"Compiler-generation",unescape("codeFor%3A%20aCompiler%20accessing%3A%20aNode%0D%0A%09%22%20Return%20the%20code%20to%20access%20variable%20in%20aNode%20%28aVariableNode%29.%0D%0A%09Return%20nil%20if%20the%20code%20to%20access%20variable%20can%uFFFDt%20be%20generated.%0D%0A%09The%20default%20implementation%20return%20code%20to%20access%20instance%20variables.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20aName%20%7C%0D%0A%09aName%20%3A%3D%20aNode%20value.%0D%0A%09self%20allInstVarNamesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09aName%20%3D%20each%20ifTrue%3A%20%5B%0D%0A%09%09%09%5EaCompiler%20codeToAccessInstanceVariable%3A%20aName%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09self%20allPropertyNamesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09aName%20%3D%20each%20ifTrue%3A%20%5B%0D%0A%09%09%09%5EaCompiler%20codeToAccessProperty%3A%20aName%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.Behavior,"methodsFor:","methodsFor_"

,function (aString){var self=this;return smalltalk.ClassCategoryReader.$$new().class_category_(self, aString);return self;}

,"Compiler-fileIn",unescape("methodsFor%3A%20aString%0D%0A%09%22%20FileIn%20-%20Return%20a%20chunk%20reader%20to%20fileIn%20methods%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EClassCategoryReader%20new%20class%3A%20self%20category%3A%20aString"));

smalltalk.bind(smalltalk.Behavior,"methods","methods"

,function (){var self=this;return self.methodsFor_("unclassified");return self;}

,"Compiler-fileIn",unescape("methods%0D%0A%09%22%20FileIn%20-%20Return%20a%20chunk%20reader%20to%20fileIn%20methods%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20methodsFor%3A%20%23unclassified%20"));

smalltalk.bind(smalltalk.Behavior,"commentStamp","commentStamp"

,function (){var self=this;return smalltalk.ClassCommentReader.$$new().class_(self);return self;}

,"Compiler-fileIn",unescape("commentStamp%0D%0A%09%22%20Return%20a%20comment%20reader%20for%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EClassCommentReader%20new%20class%3A%20self"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"current","current"

,function (){var self=this;	return smalltalk;return self;}

,"accessing",unescape("current%0D%0A%09%22%20Return%20the%20current%20smalltalk%20system%20instance.%20%22%0D%0A%0D%0A%7B%27%09return%20smalltalk%27%7D"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"at:ifAbsent:","at_ifAbsent_"

,function (aGlobalName,aBlock){var self=this;return (self.current()[aGlobalName] || aBlock.value());return self;}

,"accessing",unescape("at%3A%20aGlobalName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20global%20known%20as%20aGlobalName%20in%20the%20receiver%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5Eself%20current%20basicAt%3A%20aGlobalName%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"includesKey:","includesKey_"

,function (aGlobalName){var self=this;try{self.at_ifAbsent_(aGlobalName, (function(){return (function(){throw({name: "stReturn", selector: "includesKey_", fn: function(){return false}})})();}));

(function(){throw({name: "stReturn", selector: "includesKey_", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "includesKey_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("includesKey%3A%20aGlobalName%0D%0A%09%22%20Return%20true%20if%20the%20global%20aGlobalName%20is%20defined%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20at%3A%20aGlobalName%20ifAbsent%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"at:","at_"

,function (aGlobalName){var self=this;return (self.current()[aGlobalName] || (function(){return nil;}).value());return self;}

,"accessing",unescape("at%3A%20aGlobalName%0D%0A%09%22%20Return%20the%20global%20known%20as%20aGlobalName%20in%20the%20receiver%20or%20nil.%20%22%0D%0A%0D%0A%09%5Eself%20current%20basicAt%3A%20aGlobalName%20ifAbsent%3A%20%5B%20nil%20%5D"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"at:put:","at_put_"

,function (aGlobalName,anObject){var self=this;return (self.current()[aGlobalName]=(anObject));return self;}

,"accessing",unescape("at%3A%20aGlobalName%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20global%20known%20as%20aGlobalName%20in%20the%20receiver%20top%20anObject.%20%22%0D%0A%0D%0A%09%5Eself%20current%20basicAt%3A%20aGlobalName%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"at:ifAbsentPut:","at_ifAbsentPut_"

,function (aGlobalName,aBlock){var self=this;return self.at_ifAbsent_(aGlobalName, (function(){return self.at_put_(aGlobalName, aBlock.value());}));return self;}

,"accessing",unescape("at%3A%20aGlobalName%20ifAbsentPut%3A%20aBlock%0D%0A%09%22%20Return%20the%20global%20known%20as%20aGlobalName%20in%20the%20receiver%20or%20the%20result%20of%20evaluating%20aBlock.%0D%0A%09Set%20the%20global%20to%20return%20value%20if%20was%20absent.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20at%3A%20aGlobalName%20ifAbsent%3A%20%5B%0D%0A%09%09self%20at%3A%20aGlobalName%20put%3A%20aBlock%20value%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"definePool:with:","definePool_with_"

,function (poolName,tuples){var self=this;return self.current().definePool_with_(poolName, tuples);return self;}

,"accessing",unescape("definePool%3A%20poolName%20with%3A%20tuples%0D%0A%09%22%20Define%20the%20pool%20dictionary%20from%20tuples%20specification.%20%22%0D%0A%0D%0A%09%5Eself%20current%20definePool%3A%20poolName%20with%3A%20tuples"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"poolDictionary:ifAbsent:","poolDictionary_ifAbsent_"

,function (aPoolName,aBlock){var self=this;return self.current().poolDictionary_ifAbsent_(aPoolName, aBlock);return self;}

,"accessing",unescape("poolDictionary%3A%20aPoolName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20pool%20dictionary%20named%20aPoolName%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5Eself%20current%20poolDictionary%3A%20aPoolName%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"objectAt:ifAbsent:","objectAt_ifAbsent_"

,function (aName,aBlock){var self=this;return self.current().objectAt_ifAbsent_(aName, aBlock);return self;}

,"accessing",unescape("objectAt%3A%20aName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20%28global%20scoped%29%20smalltalk%20object%20at%20aName%20or%20the%20result%20of%20evaluating%20aBlock%20%28if%20undefined%20or%20not%20an%20Object%20instance%29.%20%22%0D%0A%0D%0A%09%5Eself%20current%20objectAt%3A%20aName%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"jsObjectAt:ifAbsent:","jsObjectAt_ifAbsent_"

,function (aName,aBlock){var self=this;return self.current().jsObjectAt_ifAbsent_(aName, aBlock);return self;}

,"accessing",unescape("jsObjectAt%3A%20aName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20%28global%20scoped%29%20javascript%20object%20at%20aName%20or%20the%20result%20of%20evaluating%20aBlock%20%28if%20undefined%29.%20%22%0D%0A%0D%0A%09%5Eself%20current%20jsObjectAt%3A%20aName%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"jsObjectAt:","jsObjectAt_"

,function (aName){var self=this;return self.jsObjectAt_ifAbsent_(aName, (function(){return self.error_("Undefined "._comma(aName));}));return self;}

,"accessing",unescape("jsObjectAt%3A%20aName%0D%0A%09%22%20Return%20the%20%28global%20scoped%29%20javascript%20object%20at%20aName.%20%22%0D%0A%0D%0A%09%5Eself%20jsObjectAt%3A%20aName%20ifAbsent%3A%20%5B%20self%20error%3A%20%27Undefined%20%27%2CaName%20%5D"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"global","global"

,function (){var self=this;return (function(){return this;}).call(null);return self;}

,"accessing",unescape("global%0D%0A%09%22%20Return%20the%20global%20%28javascript%29%20object.%20%22%0D%0A%0D%0A%09%5E%5B%23%7Bthis%7D%5D%20%23call%3A%20%23%7Bnull%7D"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"classes","classes"

,function (){var self=this;return self.current().classes();return self;}

,"accessing",unescape("classes%0D%0A%09%22%20Return%20the%20classes%20defined%20in%20current%20instance.%20%22%0D%0A%0D%0A%09%5Eself%20current%20classes"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"implementorsOf:","implementorsOf_"

,function (aSymbol){var self=this;return self.current().implementorsOf_(aSymbol);return self;}

,"query",unescape("implementorsOf%3A%20aSymbol%0D%0A%09%22%20Return%20a%20collection%20of%20methods%20implementing%20aSymbol.%20%22%0D%0A%0D%0A%09%5Eself%20current%20implementorsOf%3A%20aSymbol"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"bindingsFor:","bindingsFor_"

,function (aScope){var self=this;return smalltalk.PoolDictionaryReader.$$new().scope_(aScope);return self;}

,unescape("Compiler-pool%20variables"),unescape("bindingsFor%3A%20aScope%0D%0A%09%22%20FileIn%20-%20Return%20a%20reader%20to%20fileIn%20bindings%20in%20a%20%28global%29%20scope.%0D%0A%09aScope%20can%20be%20a%20string%20or%20a%20dictionary.%0D%0A%09In%20case%20of%20aScope%20been%20a%20String%2C%20it%20will%20be%20considered%20a%20PoolDictionaryName%0D%0A%09See%20PoolDictionaryReader%3E%3E%23scanFrom%3A%0D%0A%09%22%0D%0A%0D%0A%09%5EPoolDictionaryReader%20new%20scope%3A%20aScope"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"sendersOf:","sendersOf_"

,function (selector){var self=this;return self.current().sendersOf_(selector);return self;}

,"Compiler-query",unescape("sendersOf%3A%20selector%0D%0A%09%22%20Return%20the%20senders%20of%20message%20selector.%20%22%0D%0A%0D%0A%09%5Eself%20current%20sendersOf%3A%20selector"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"saveImageAs:","saveImageAs_"

,function (fileName){var self=this;self.current().saveImageAs_(fileName);return self;}

,"image-snapshot",unescape("saveImageAs%3A%20fileName%0D%0A%09%22%20Dump%20the%20image%20contents%20onto%20file%20at%20fileName.%20%22%0D%0A%0D%0A%09self%20current%20saveImageAs%3A%20fileName"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"saveImage","saveImage"

,function (){var self=this;self.current().saveImage();return self;}

,"image-snapshot",unescape("saveImage%0D%0A%09%22%20Dump%20the%20image%20contents%20onto%20image%20file.%20%22%0D%0A%0D%0A%09self%20current%20saveImage"));

smalltalk.bind(smalltalk.Smalltalk.$klass,"exit","exit"

,function (){var self=this;self.current().exit();return self;}

,"image-exiting",unescape("exit%0D%0A%09%22%20Exit%20to%20OS%20system.%20%22%0D%0A%0D%0A%09%0D%0A%09self%20current%20exit"));

smalltalk.bind(smalltalk.Smalltalk,"rootClasses","rootClasses"

,function (){var self=this;return self.classes().select_((function(each){return ((each.superclass() || nil) === nil);}));return self;}

,"accessing",unescape("rootClasses%0D%0A%09%22%20Return%20the%20collection%20of%20topLevel%20classes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classes%20select%3A%20%5B%3Aeach%7C%20each%20superclass%20isNil%20%5D"));

smalltalk.bind(smalltalk.Smalltalk,"implementorsOf:","implementorsOf_"

,function (aSymbol){var self=this;return self.rootClasses().inject_into_([], (function(total, each){return total._comma(each.implementorsOf_(aSymbol));}));return self;}

,"query",unescape("implementorsOf%3A%20aSymbol%0D%0A%09%22%20Return%20a%20collection%20of%20methods%20implementing%20aSymbol.%20%22%0D%0A%0D%0A%09%5Eself%20rootClasses%20inject%3A%20%23%28%29%20into%3A%20%5B%3Atotal%20%3Aeach%7C%0D%0A%09%09total%20%2C%20%28each%20implementorsOf%3A%20aSymbol%29%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Smalltalk,"objectAt:ifAbsent:","objectAt_ifAbsent_"

,function (aName,aBlock){var self=this;try{var result=nil;(function(){result=eval(aName);return result.yourself();}).on_do_(smalltalk.Error, (function(ignored){return (function(){throw({name: "stReturn", selector: "objectAt_ifAbsent_", fn: function(){return (self[aName] || aBlock.value())}})})();}));

(function(){throw({name: "stReturn", selector: "objectAt_ifAbsent_", fn: function(){return result}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "objectAt_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("objectAt%3A%20aName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20%28global%20scoped%29%20smalltalk%20object%20at%20aName%20or%20the%20result%20of%20evaluating%20aBlock%20%28if%20undefined%20or%20not%20an%20Object%20instance%29.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09%5B%09result%20%3A%3D%20%23%20%23eval%3A%20aName.%0D%0A%09%09result%20yourself%0D%0A%09%5D%20on%3A%20Error%20do%3A%20%5B%3Aignored%7C%0D%0A%09%09%5Eself%20basicAt%3A%20aName%20ifAbsent%3A%20aBlock%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Smalltalk,"jsObjectAt:ifAbsent:","jsObjectAt_ifAbsent_"

,function (aName,aBlock){var self=this;try{var result=nil;((eval("typeof "._comma(aName))._eq("undefined")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "jsObjectAt_ifAbsent_", fn: function(){return aBlock.value()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "jsObjectAt_ifAbsent_", fn: function(){return eval(aName)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "jsObjectAt_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("jsObjectAt%3A%20aName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20%28global%20scoped%29%20javascript%20object%20at%20aName%20or%20the%20result%20of%20evaluating%20aBlock%20%28if%20undefined%29.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09%28%23%20%23eval%3A%20%27typeof%20%27%2CaName%29%20%3D%20%27undefined%27%20ifTrue%3A%20%5B%20%5EaBlock%20value%20%5D.%0D%0A%09%5E%23%20%23eval%3A%20aName"));

smalltalk.bind(smalltalk.Smalltalk,"jsObjectAt:","jsObjectAt_"

,function (aName){var self=this;return self.jsObjectAt_ifAbsent_(aName, (function(){return self.error_("Undefined "._comma(aName));}));return self;}

,"accessing",unescape("jsObjectAt%3A%20aName%0D%0A%09%22%20Return%20the%20%28global%20scoped%29%20javascript%20object%20at%20aName.%20%22%0D%0A%0D%0A%09%5Eself%20jsObjectAt%3A%20aName%20ifAbsent%3A%20%5B%20self%20error%3A%20%27Undefined%20%27%2CaName%20%5D"));

smalltalk.bind(smalltalk.Smalltalk,"definePool:","definePool_"

,function (poolName){var self=this;return self.definePool_with_(poolName, smalltalk.Array.$$new());return self;}

,"accessing",unescape("definePool%3A%20poolName%0D%0A%09%22%20Define%20the%20pool%20dictionary%20%28if%20it%20is%20not%20defined%20yet%29.%20%22%0D%0A%0D%0A%09%5Eself%20definePool%3A%20poolName%20with%3A%20Array%20new"));

smalltalk.bind(smalltalk.Smalltalk,"poolDictionary:ifAbsent:","poolDictionary_ifAbsent_"

,function (aPoolName,aBlock){var self=this;return (self[aPoolName] || (function(){return aBlock.value();}).value());return self;}

,"accessing",unescape("poolDictionary%3A%20aPoolName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20pool%20dictionary%20named%20aPoolName%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20aPoolName%20ifAbsent%3A%20%5B%20aBlock%20value%20%5D"));

smalltalk.bind(smalltalk.Smalltalk,"poolDictionary:","poolDictionary_"

,function (aPoolName){var self=this;return self.poolDictionary_ifAbsent_(aPoolName, (function(){return self.definePool_(aPoolName);}));return self;}

,"accessing",unescape("poolDictionary%3A%20aPoolName%0D%0A%09%22%20Return%20the%20pool%20dictionary%20named%20aPoolName.%20%22%0D%0A%0D%0A%09%5Eself%20poolDictionary%3A%20aPoolName%20ifAbsent%3A%20%5B%0D%0A%09%09%22self%20error%3A%20%27Missing%20Pool%20dictionary%3A%20%27%2CaPoolName.%20%22%0D%0A%09%09self%20definePool%3A%20aPoolName%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Smalltalk,"debugDefinePool:with:","debugDefinePool_with_"

,function (poolName,tuples){var self=this;try{((true).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "debugDefinePool_with_", fn: function(){return self}})})();})() : nil);

self.print_(unescape("smalltalk.definePool_with_%28%22")._comma(poolName)._comma(unescape("%22%2C%5B")));

tuples.do_((function(tuple){return self.print_(unescape("%09%5B")._comma(tuple.first().printString())._comma(unescape("%2C"))._comma(tuple.last().asJavascript())._comma(unescape("%5D%2C")));}));

self.print_(unescape("%09%5D%29%3B"));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "debugDefinePool_with_"){return $$ex.fn();} throw($$ex);}}

,"compiling",unescape("debugDefinePool%3A%20poolName%20with%3A%20tuples%0D%0A%09%22%20DEBUG%20-%20Dump%20definition%20of%20the%20pool%20dictionary.%20%22%0D%0A%0D%0A%09true%20ifTrue%3A%20%5B%20%5Eself%20%5D.%20%22//Ale%20edit%20this%20method%20to%20write%20pool%20definitions%20onto%20dump%20stream.%22%0D%0A%09self%20print%3A%20%27smalltalk.definePool_with_%28%22%27%2CpoolName%2C%27%22%2C%5B%27.%0D%0A%09tuples%20do%3A%20%5B%3Atuple%7C%20self%20print%3A%20%27%09%5B%27%2Ctuple%20first%20printString%2C%27%2C%27%2Ctuple%20last%20asJavascript%2C%27%5D%2C%27%20%5D.%0D%0A%09self%20print%3A%20%27%09%5D%29%3B%27."));

smalltalk.bind(smalltalk.Smalltalk,"definePool:with:","definePool_with_"

,function (poolName,tuples){var self=this;var dictionary=nil;dictionary=(self[poolName] || (function(){return (self[poolName]=(smalltalk.Dictionary.$$new()));}).value());

tuples.do_((function(tuple){return dictionary.at_put_(tuple.first(), tuple.last());}));

self.debugDefinePool_with_(poolName, tuples);

return dictionary;return self;}

,"compiling",unescape("definePool%3A%20poolName%20with%3A%20tuples%0D%0A%09%22%20Define%20the%20pool%20dictionary.%20%22%0D%0A%0D%0A%09%7C%20dictionary%20%7C%0D%0A%09dictionary%20%3A%3D%20self%20basicAt%3A%20poolName%20ifAbsent%3A%20%5B%0D%0A%09%09self%20basicAt%3A%20poolName%20put%3A%20Dictionary%20new%0D%0A%09%5D.%0D%0A%09tuples%20do%3A%20%5B%3Atuple%7C%20dictionary%20at%3A%20tuple%20first%20put%3A%20tuple%20last%20%5D.%0D%0A%09self%20debugDefinePool%3A%20poolName%20with%3A%20tuples.%0D%0A%09%5Edictionary"));

smalltalk.bind(smalltalk.Smalltalk,"recompileAll","recompileAll"

,function (){var self=this;self.classes().do_((function(each){return each.recompile();}));return self;}

,"compiling",unescape("recompileAll%0D%0A%09%22%20Recompile%20all%20classes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20classes%20do%3A%20%5B%3Aeach%20%7C%20each%20recompile%20%5D"));

smalltalk.bind(smalltalk.Smalltalk,"readJSON:","readJSON_"

,function (anObject){var self=this;return self.readJSObject(anObject);return self;}

,"json",unescape("readJSON%3A%20anObject%0D%0A%09%22%20Return%20an%20object%20read%20from%20JSON%20map%20object%20anObject.%20%22%0D%0A%0D%0A%09%5Eself%20%23readJSObject%3A%20anObject"));

smalltalk.bind(smalltalk.Smalltalk,"shallowCopy","shallowCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Smalltalk,"deepCopy","deepCopy"

,function (){var self=this;return self;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Smalltalk,"sendersOf:","sendersOf_"

,function (selector){var self=this;return (function($rec){$rec.rootClasses_(self.rootClasses());return $rec.sendersOf_(selector);})(smalltalk.MethodReferences.$$new());return self;}

,"Compiler-query",unescape("sendersOf%3A%20selector%0D%0A%09%22%20Return%20the%20senders%20of%20message%20selector.%20%22%0D%0A%0D%0A%09%5EMethodReferences%20new%0D%0A%09%09rootClasses%3A%20self%20rootClasses%3B%0D%0A%09%09sendersOf%3A%20selector"));

smalltalk.bind(smalltalk.Smalltalk,"exit","exit"

,function (){var self=this;self.classes().do_((function(each){return each.aboutToExit_(self);}));

quit();return self;}

,"image-exiting",unescape("exit%0D%0A%09%22%20Exit%20to%20OS%20system.%20%22%0D%0A%0D%0A%09self%20classes%20do%3A%20%5B%3Aeach%7C%20each%20aboutToExit%3A%20self%20%5D.%0D%0A%09%23%20quit"));

smalltalk.bind(smalltalk.Smalltalk,"product","product"

,function (){var self=this;return "S8";return self;}

,"image-accessing",unescape("product%0D%0A%09%22%20Private%20-%20Return%20the%20name%20of%20the%20system.%20%22%0D%0A%0D%0A%09%5E%23S8"));

smalltalk.bind(smalltalk.Smalltalk,"description","description"

,function (){var self=this;return unescape("A%20modern%20Smalltalk%20environment%20running%20on%20the%20%22invisible%20machine%22.");return self;}

,"image-accessing",unescape("description%0D%0A%09%22%20Private%20-%20Return%20the%20description%20of%20the%20system.%20%22%0D%0A%0D%0A%09%5E%27A%20modern%20Smalltalk%20environment%20running%20on%20the%20%22invisible%20machine%22.%27"));

smalltalk.bind(smalltalk.Smalltalk,"licenseComment","licenseComment"

,function (){var self=this;return unescape("%0D%0AThe%20text%20you%20are%20reading%20here%20is%20only%20a%20residue%20of%20something%20that%20has%20run%20before.%0D%0AKeep%20the%20system%20running%20with%20responsibility.%20Smalltalk%20is%20not%20the%20words%2C%0D%0A%20nor%20any%20definition%2C%20nor%20it%20current%20contents...%0D%0ASmalltalk%20include%20your%20feelings%20when%20you%20see%20it%20running.%0D%0ASmalltalk%20is%20what%20happens%20when%20time%20flows%20and%20you%20%22are%22%20there.%0D%0AStop%20reading/writing%20code%20%28thinking%20you%20are%20outside%20the%20system%29%2C%0D%0A%20change%20your%20world%20with%20resposibility%2C%20one%20object%20at%20a%20time%2C%20with%20your%20hands%2C%0D%0A%20during%20all%20your%20life%2C%20in%20family.%0D%0A");return self;}

,"image-license",unescape("licenseComment%0D%0A%09%22%20Private%20-%20Comment%20note%20about%20license%20of%20this%20product.%20%22%0D%0A%0D%0A%09%5E%27%0D%0AThe%20text%20you%20are%20reading%20here%20is%20only%20a%20residue%20of%20something%20that%20has%20run%20before.%0D%0AKeep%20the%20system%20running%20with%20responsibility.%20Smalltalk%20is%20not%20the%20words%2C%0D%0A%20nor%20any%20definition%2C%20nor%20it%20current%20contents...%0D%0ASmalltalk%20include%20your%20feelings%20when%20you%20see%20it%20running.%0D%0ASmalltalk%20is%20what%20happens%20when%20time%20flows%20and%20you%20%22are%22%20there.%0D%0AStop%20reading/writing%20code%20%28thinking%20you%20are%20outside%20the%20system%29%2C%0D%0A%20change%20your%20world%20with%20resposibility%2C%20one%20object%20at%20a%20time%2C%20with%20your%20hands%2C%0D%0A%20during%20all%20your%20life%2C%20in%20family.%0D%0A%27"));

smalltalk.bind(smalltalk.Smalltalk,"licenseTerms","licenseTerms"

,function (){var self=this;return self.product()._comma(unescape("%20-%20"))._comma(self.description())._comma(unescape("%0D%0A"))._comma(self.licenseMoreHolders())._comma(unescape("%0D%0A"))._comma(self.licenseHolders())._comma(unescape("%0D%0APermission%20is%20hereby%20granted%2C%20free%20of%20charge%2C%20to%20any%20person%20obtaining%0D%0A%20a%20copy%20of%20this%20software%20and%20associated%20documentation%20files%20%28the%20%22Software%22%29%2C%0D%0A%20to%20deal%20in%20the%20Software%20without%20restriction%2C%20including%20without%20limitation%0D%0A%20the%20rights%20to%20use%2C%20copy%2C%20modify%2C%20merge%2C%20publish%2C%20distribute%2C%20sublicense%2C%0D%0A%20and/or%20sell%20copies%20of%20the%20Software%2C%20and%20to%20permit%20persons%20to%20whom%20the%0D%0A%20Software%20is%20furnished%20to%20do%20so%2C%20subject%20to%20the%20following%20conditions%3A%0D%0A%0D%0AThe%20above%20copyright%20notice%20and%20this%20permission%20notice%20shall%20be%20included%0D%0A%20in%20all%20copies%20or%20substantial%20portions%20of%20the%20Software.%0D%0A%0D%0ATHE%20SOFTWARE%20IS%20PROVIDED%20%22AS%20IS%22%2C%20WITHOUT%20WARRANTY%20OF%20ANY%20KIND%2C%0D%0A%20EXPRESS%20OR%20IMPLIED%2C%20INCLUDING%20BUT%20NOT%20LIMITED%20TO%20THE%20WARRANTIES%0D%0A%20OF%20MERCHANTABILITY%2C%20FITNESS%20FOR%20A%20PARTICULAR%20PURPOSE%20AND%20NONINFRINGEMENT.%0D%0A%20IN%20NO%20EVENT%20SHALL%20THE%20AUTHORS%20OR%20COPYRIGHT%20HOLDERS%20BE%20LIABLE%20FOR%20ANY%0D%0A%20CLAIM%2C%20DAMAGES%20OR%20OTHER%20LIABILITY%2C%20WHETHER%20IN%20AN%20ACTION%20OF%20CONTRACT%2C%0D%0A%20TORT%20OR%20OTHERWISE%2C%20ARISING%20FROM%2C%20OUT%20OF%20OR%20IN%20CONNECTION%20WITH%20THE%20SOFTWARE%0D%0A%20OR%20THE%20USE%20OR%20OTHER%20DEALINGS%20IN%20THE%20SOFTWARE.%0D%0A----------------------------------------------------------------------%0D%0A"))._comma(self.licenseComment());return self;}

,"image-license",unescape("licenseTerms%0D%0A%09%22%20Private%20-%20Return%20the%20license%20terms%20to%20use%20this%20system.%20%22%0D%0A%0D%0A%09%5Eself%20product%2C%27%20-%20%27%2Cself%20description%20%2C%27%0D%0A%27%2Cself%20licenseMoreHolders%09%2C%27%0D%0A%27%2Cself%20licenseHolders%09%09%2C%27%0D%0APermission%20is%20hereby%20granted%2C%20free%20of%20charge%2C%20to%20any%20person%20obtaining%0D%0A%20a%20copy%20of%20this%20software%20and%20associated%20documentation%20files%20%28the%20%22Software%22%29%2C%0D%0A%20to%20deal%20in%20the%20Software%20without%20restriction%2C%20including%20without%20limitation%0D%0A%20the%20rights%20to%20use%2C%20copy%2C%20modify%2C%20merge%2C%20publish%2C%20distribute%2C%20sublicense%2C%0D%0A%20and/or%20sell%20copies%20of%20the%20Software%2C%20and%20to%20permit%20persons%20to%20whom%20the%0D%0A%20Software%20is%20furnished%20to%20do%20so%2C%20subject%20to%20the%20following%20conditions%3A%0D%0A%0D%0AThe%20above%20copyright%20notice%20and%20this%20permission%20notice%20shall%20be%20included%0D%0A%20in%20all%20copies%20or%20substantial%20portions%20of%20the%20Software.%0D%0A%0D%0ATHE%20SOFTWARE%20IS%20PROVIDED%20%22AS%20IS%22%2C%20WITHOUT%20WARRANTY%20OF%20ANY%20KIND%2C%0D%0A%20EXPRESS%20OR%20IMPLIED%2C%20INCLUDING%20BUT%20NOT%20LIMITED%20TO%20THE%20WARRANTIES%0D%0A%20OF%20MERCHANTABILITY%2C%20FITNESS%20FOR%20A%20PARTICULAR%20PURPOSE%20AND%20NONINFRINGEMENT.%0D%0A%20IN%20NO%20EVENT%20SHALL%20THE%20AUTHORS%20OR%20COPYRIGHT%20HOLDERS%20BE%20LIABLE%20FOR%20ANY%0D%0A%20CLAIM%2C%20DAMAGES%20OR%20OTHER%20LIABILITY%2C%20WHETHER%20IN%20AN%20ACTION%20OF%20CONTRACT%2C%0D%0A%20TORT%20OR%20OTHERWISE%2C%20ARISING%20FROM%2C%20OUT%20OF%20OR%20IN%20CONNECTION%20WITH%20THE%20SOFTWARE%0D%0A%20OR%20THE%20USE%20OR%20OTHER%20DEALINGS%20IN%20THE%20SOFTWARE.%0D%0A----------------------------------------------------------------------%0D%0A%27%2Cself%20licenseComment"));

smalltalk.bind(smalltalk.Smalltalk,"licenseYear","licenseYear"

,function (){var self=this;return smalltalk.DateTime.today().year();return self;}

,"image-license",unescape("licenseYear%0D%0A%09%22%20Private%20-%20Return%20the%20license%20information.%20%22%0D%0A%0D%0A%09%5EDateTime%20today%20year"));

smalltalk.bind(smalltalk.Smalltalk,"licenseMoreHolders","licenseMoreHolders"

,function (){var self=this;return "";return self;}

,"image-license",unescape("licenseMoreHolders%0D%0A%09%22%20Private%20-%20Return%20additional%20license%20holders%20information.%20%22%0D%0A%0D%0A%09%5E%27%27"));

smalltalk.bind(smalltalk.Smalltalk,"licenseHolders","licenseHolders"

,function (){var self=this;return unescape("Copyright%20%28C%29%20")._comma(self.licenseYear().asString())._comma(" ")._comma(unescape("Alejandro%20F.%20Reimondo%20%3CaleReimondo@smalltalking.net%3E%20http%3A//www.aleReimondo.com%0D%0A%0D%0AParts%20of%20source%20code%20written%20for%20Jtalk%2C%20Copyright%20%28C%29%202011%20by%20Nicolas%20Petton%20%3Cpetton.nicolas@gmail.com%3E%0D%0AAlso%20code%20and%20ideas%20from%20Clamato%20%28http%3A//clamato.net%29%2C%20written%20by%20Avi%20Byrant.%0D%0AThe%20PetitParser%20library%2C%20published%20by%20Lukas%20Renggli%20%28http%3A//lukas-renggli.ch%29%20and%20released%20under%20the%20MIT%20license.%0D%0AAnd%20people%20that%20contributed%20to%20Smalltalk%20on%20diverse%20media%20years%28decades%29%20before%20this%20license%20holders%20claimed%20ownership.%0D%0A"));return self;}

,"image-license",unescape("licenseHolders%0D%0A%09%22%20Private%20-%20Return%20the%20license%20holders%20information.%20%22%0D%0A%0D%0A%09%5E%27Copyright%20%28C%29%20%27%0D%0A%09%09%2Cself%20licenseYear%20asString%20%2C%27%20%27%0D%0A%09%09%2C%27Alejandro%20F.%20Reimondo%20%3CaleReimondo@smalltalking.net%3E%20http%3A//www.aleReimondo.com%0D%0A%0D%0AParts%20of%20source%20code%20written%20for%20Jtalk%2C%20Copyright%20%28C%29%202011%20by%20Nicolas%20Petton%20%3Cpetton.nicolas@gmail.com%3E%0D%0AAlso%20code%20and%20ideas%20from%20Clamato%20%28http%3A//clamato.net%29%2C%20written%20by%20Avi%20Byrant.%0D%0AThe%20PetitParser%20library%2C%20published%20by%20Lukas%20Renggli%20%28http%3A//lukas-renggli.ch%29%20and%20released%20under%20the%20MIT%20license.%0D%0AAnd%20people%20that%20contributed%20to%20Smalltalk%20on%20diverse%20media%20years%28decades%29%20before%20this%20license%20holders%20claimed%20ownership.%0D%0A%27"));

smalltalk.bind(smalltalk.Smalltalk,"globalsDo:","globalsDo_"

,function (aBlock){var self=this;return self.globalsDo(aBlock);return self;}

,"image-evaluating",unescape("globalsDo%3A%20aBlock%0D%0A%09%22%20Private%20-%20Evaluates%20aBlock%20for%20each%20globals%20defined%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23globalsDo%3A%20aBlock"));

smalltalk.bind(smalltalk.Smalltalk,"globalsDo:separatedBy:","globalsDo_separatedBy_"

,function (aBlock,anotherBlock){var self=this;var first=nil;first=true;

return self.globalsDo((function(each){((first).mustBeBoolean()==true ? (function(){return first=false;})() : (function(){return anotherBlock.value();})());return aBlock.value_(each);}));return self;}

,"image-evaluating",unescape("globalsDo%3A%20aBlock%20separatedBy%3A%20anotherBlock%0D%0A%09%22%20Private%20-%20Evaluates%20aBlock%20for%20each%20globals%20defined%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20first%20%7C%20first%20%3A%3D%20true.%0D%0A%09%5Eself%20%23globalsDo%3A%20%5B%3Aeach%7C%0D%0A%09%20%20%20%20first%0D%0A%09%09ifTrue%3A%20%5B%20first%20%3A%3D%20false%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20anotherBlock%20value%20%5D.%0D%0A%09%20%20%20%20aBlock%20value%3A%20each%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Smalltalk,"saveImageOn:","saveImageOn_"

,function (stream){var self=this;var exporter=nil;var allClasses=nil;allClasses=self.classes().select_((function(each){return ((each.superclass() || nil) === nil);})).inject_into_(smalltalk.Array.$$new(), (function(total, each){return total._comma(each.withAllSubclasses());})).collect_((function(each){return each.aboutToSaveImage_on_(self, stream);})).select_((function(each){return ((each || nil) !== nil);}));

exporter=smalltalk.Exporter.$$new();

(function($rec){$rec.cr();$rec.nextPutAll_(unescape("//%20Smalltalk%20Classes."));return $rec.cr();})(stream);

exporter.exportClasses_on_(allClasses, stream);

(function($rec){$rec.cr();return $rec.nextPutAll_(unescape("//%20Smalltalk%20Globals%20set-up."));})(stream);

(function($rec){$rec.cr();return $rec.nextPutAll_(unescape("smalltalk.initRoots%28%29%3B"));})(stream);

self.globalsDo_((function(key){return (function($rec){$rec.cr();return $rec.nextPutAll_("smalltalk."._comma(key)._comma(unescape("%3D"))._comma(exporter.exportObject_((self[key] || nil)))._comma(unescape("%3B")));})(stream);}));

allClasses.do_((function(each){return each.imageSaved_on_(self, stream);}));return self;}

,"image-snapshot",unescape("saveImageOn%3A%20stream%0D%0A%09%22%20Dump%20the%20receiver%27s%20contents%20onto%20stream.%20%22%0D%0A%0D%0A%09%7C%20exporter%20allClasses%20%7C%0D%0A%09allClasses%20%3A%3D%20%28%28%28self%20classes%0D%0A%09%09select%3A%20%5B%3Aeach%7C%20each%20superclass%20isNil%20%5D%29%0D%0A%09%09inject%3A%20Array%20new%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%20%2C%20each%20withAllSubclasses%20%5D%29%0D%0A%09%09collect%3A%20%5B%3Aeach%7C%20each%20aboutToSaveImage%3A%20self%20on%3A%20stream%20%5D%29%0D%0A%09%09select%3A%20%5B%3Aeach%7C%20each%20notNil%20%5D.%0D%0A%09exporter%20%3A%3D%20Exporter%20new.%0D%0A%22%09stream%20nextPutAll%3A%20%27//%20Smalltalk%20Globals%20%28pre%29definition.%27%3B%20cr.%0D%0A%09self%0D%0A%09%09globalsDo%3A%20%5B%3Akey%7C%20stream%20nextPutAll%3A%20%27smalltalk.%27%2Ckey%20%5D%0D%0A%09%09separatedBy%3A%20%5B%20stream%20nextPutAll%3A%20%27%20%2C%20%27%20%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%3Dnil%3B%27%3B%20cr.%0D%0A%22%09stream%20cr%3B%20nextPutAll%3A%20%27//%20Smalltalk%20Classes.%27%3B%20cr.%0D%0A%09exporter%20exportClasses%3A%20allClasses%20on%3A%20stream.%0D%0A%09stream%20cr%3B%20nextPutAll%3A%20%27//%20Smalltalk%20Globals%20set-up.%27.%0D%0A%09stream%20cr%3B%20nextPutAll%3A%20%27smalltalk.initRoots%28%29%3B%27.%0D%0A%09self%20globalsDo%3A%20%5B%3Akey%7C%0D%0A%09%09stream%20cr%3B%20nextPutAll%3A%20%27smalltalk.%27%2Ckey%2C%27%3D%27%0D%0A%09%09%09%2C%28exporter%20exportObject%3A%20%28self%20basicAt%3A%20key%29%29%0D%0A%09%09%09%2C%27%3B%27%0D%0A%09%5D.%0D%0A%09allClasses%20do%3A%20%5B%3Aeach%7C%20each%20imageSaved%3A%20self%20on%3A%20stream%20%5D."));

smalltalk.bind(smalltalk.Smalltalk,"imageContents","imageContents"

,function (){var self=this;var stream=nil;stream=smalltalk.String.$$new().writeStream();

self.saveImageOn_(stream);

return stream.contents();return self;}

,"image-snapshot",unescape("imageContents%0D%0A%09%22%20Return%20a%20dump%20of%20the%20system%20contents.%20%22%0D%0A%0D%0A%09%7C%20stream%20%7C%0D%0A%09stream%20%3A%3D%20String%20new%20writeStream.%0D%0A%09self%20saveImageOn%3A%20stream.%0D%0A%09%5Estream%20contents"));

smalltalk.bind(smalltalk.Smalltalk,"imageFileName","imageFileName"

,function (){var self=this;return (self["$imageFileName"] || nil);return self;}

,"image-snapshot",unescape("imageFileName%0D%0A%09%22%20Return%20the%20image%20file%20name.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24imageFileName%27"));

smalltalk.bind(smalltalk.Smalltalk,"imageFileName:","imageFileName_"

,function (fileName){var self=this;return (self["$imageFileName"]=(fileName));return self;}

,"image-snapshot",unescape("imageFileName%3A%20fileName%0D%0A%09%22%20Set%20the%20image%20file%20name.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24imageFileName%27%20put%3A%20fileName"));

smalltalk.bind(smalltalk.Smalltalk,"saveImage","saveImage"

,function (){var self=this;self.saveImageAs_(self.imageFileName());return self;}

,"image-snapshot",unescape("saveImage%0D%0A%09%22%20Dump%20the%20image%20contents%20onto%20default%20image%20file.%20%22%0D%0A%0D%0A%09self%20saveImageAs%3A%20self%20imageFileName"));

smalltalk.bind(smalltalk.Smalltalk,"saveImageAs:","saveImageAs_"

,function (fileName){var self=this;self.imageContents().outputToFile_(fileName);

self.imageFileName_(fileName);return self;}

,"image-snapshot",unescape("saveImageAs%3A%20fileName%0D%0A%09%22%20Dump%20the%20image%20contents%20onto%20file%20at%20fileName.%20%22%0D%0A%0D%0A%09self%20imageContents%20outputToFile%3A%20fileName.%0D%0A%09self%20imageFileName%3A%20fileName."));

smalltalk.bind(smalltalk.Smalltalk,"launch","launch"

,function (){var self=this;var launch=nil;self.classes().do_((function(each){return each.launch();}));

launch=smalltalk.Smalltalk.at_ifAbsent_("LaunchExpression", (function(){return nil;}));

return launch.evaluate();return self;}

,"image-startup",unescape("launch%0D%0A%09%22%20The%20system%20has%20been%20launched%20and%20start%20execution.%0D%0A%09The%20default%20action%20is%20to%20propagate%20%23launch%20to%20current%20classes%20and%20evaluate%20%23LaunchExpression.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20launch%20%7C%0D%0A%09self%20classes%20do%3A%20%5B%3Aeach%7C%20each%20launch%20%5D.%0D%0A%09launch%20%3A%3D%20Smalltalk%20at%3A%20%23LaunchExpression%20ifAbsent%3A%20%5B%5D.%0D%0A%09%5Elaunch%20evaluate"));

smalltalk.bind(smalltalk.Error.$klass,"signal:","signal_"

,function (aString){var self=this;return (function($rec){$rec.messageText_(aString);return $rec.signal();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("signal%3A%20aString%0D%0A%09%22%20Signal%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09messageText%3A%20aString%3B%0D%0A%09%09signal"));

smalltalk.bind(smalltalk.MessageNotUnderstood,"message","message"

,function (){var self=this;return self['@message'];return self;}

,"accessing",unescape("message%0D%0A%09%22%20Return%20the%20message%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Emessage"));

smalltalk.bind(smalltalk.MessageNotUnderstood,"message:","message_"

,function (aMessage){var self=this;self['@message']=aMessage;return self;}

,"accessing",unescape("message%3A%20aMessage%0D%0A%09%22%20Set%20the%20message%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09message%20%3A%3D%20aMessage"));

smalltalk.bind(smalltalk.MessageNotUnderstood,"receiver","receiver"

,function (){var self=this;return self['@receiver'];return self;}

,"accessing",unescape("receiver%0D%0A%09%22%20Return%20the%20receiver%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ereceiver"));

smalltalk.bind(smalltalk.MessageNotUnderstood,"receiver:","receiver_"

,function (anObject){var self=this;self['@receiver']=anObject;return self;}

,"accessing",unescape("receiver%3A%20anObject%0D%0A%09%22%20Set%20the%20receiver%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09receiver%20%3A%3D%20anObject"));

smalltalk.bind(smalltalk.MessageNotUnderstood,"messageText","messageText"

,function (){var self=this;return self.receiver().asString()._comma(unescape("%20does%20not%20understand%20%23"))._comma(self.message().selector());return self;}

,"accessing",unescape("messageText%0D%0A%09%22%20Return%20the%20message%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20receiver%20asString%2C%20%27%20does%20not%20understand%20%23%27%2C%20self%20message%20selector"));

smalltalk.bind(smalltalk.StringStream,"next:","next_"

,function (anInteger){var self=this;var start=nil;var result=nil;var stop=nil;start=self.position();

stop=start._plus(anInteger).min_(self.readLimit());

result=self.collection().copyFrom_to_((start + (1)), stop);

self.position_(stop);

return result;return self;}

,"reading",unescape("next%3A%20anInteger%0D%0A%09%22%20Return%20the%20next%20anInteger%20elements%20read%20from%20the%20receiver.%0D%0A%09If%20the%20receiver%20reach%20its%20end%2C%20the%20returned%20collection%20has%20less%20elements.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20start%20result%20stop%20%7C%0D%0A%09start%20%3A%3D%20self%20position.%0D%0A%09stop%20%3A%3D%20start%20+%20anInteger%20min%3A%20self%20readLimit.%0D%0A%09result%20%3A%3D%20self%20collection%20copyFrom%3A%20start%20+%201%20to%3A%20stop.%0D%0A%09self%20position%3A%20stop.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.StringStream,"nextPut:","nextPut_"

,function (aString){var self=this;self.nextPutAll_(aString);return self;}

,"writing",unescape("nextPut%3A%20aString%0D%0A%09%22%20Put%20aString%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20nextPutAll%3A%20aString"));

smalltalk.bind(smalltalk.StringStream,"nextPutAll:","nextPutAll_"

,function (aString){var self=this;var result=nil;var substring=nil;substring=self.collection().copyFrom_to_((1), self.position());

result=((substring.isEmpty()).mustBeBoolean()==true ? (function(){return aString;})() : (function(){return substring._comma(aString);})());

substring=self.collection().copyFrom_to_((self.position() + (1))._plus(aString.size()), self.collection().size());

result=((substring.isEmpty()).mustBeBoolean()==true ? (function(){return result;})() : (function(){return result._comma(substring);})());

self.collection_(result);

self.position_(self.position()._plus(aString.size()));

self.readLimit_(self.readLimit().max_(self.position()));return self;}

,"writing",unescape("nextPutAll%3A%20aString%0D%0A%09%22%20Put%20aString%20onto%20the%20receiver%20at%20current%20position%3B%20expanding%20internal%20contents.%20%22%0D%0A%0D%0A%09%7C%20result%20substring%20%7C%0D%0A%09substring%20%3A%3D%20self%20collection%20copyFrom%3A%201%20to%3A%20self%20position.%0D%0A%09result%20%3A%3D%20substring%20isEmpty%20ifTrue%3A%20%5B%20aString%20%5D%20ifFalse%3A%20%5B%20substring%20%2C%20aString%20%5D.%0D%0A%09substring%20%3A%3D%20self%20collection%0D%0A%09%09copyFrom%3A%20self%20position%20+%201%20+%20aString%20size%0D%0A%09%09to%3A%20self%20collection%20size.%0D%0A%09result%20%3A%3D%20substring%20isEmpty%20ifTrue%3A%20%5B%20result%20%5D%20ifFalse%3A%20%5B%20result%20%2C%20substring%20%5D.%0D%0A%09%0D%0A%09self%20collection%3A%20result.%0D%0A%09self%20position%3A%20self%20position%20+%20aString%20size.%0D%0A%09self%20readLimit%3A%20%28self%20readLimit%20max%3A%20self%20position%29"));

smalltalk.bind(smalltalk.StringStream,"skipTo:","skipTo_"

,function (anObject){var self=this;try{var index=nil;((anObject.isString()).mustBeBoolean()==true ? nil : (function(){self.setToEnd();return (function(){throw({name: "stReturn", selector: "skipTo_", fn: function(){return false}})})();})());

index=self.collection().indexOf_startingAt_(anObject, (self.position() + (1)));

((index.between_and_((self.position() + (1)), self.readLimit())).mustBeBoolean()==true ? (function(){self.position_((index._plus(anObject.size()) - (1)));return (function(){throw({name: "stReturn", selector: "skipTo_", fn: function(){return true}})})();})() : nil);

self.setToEnd();

(function(){throw({name: "stReturn", selector: "skipTo_", fn: function(){return false}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "skipTo_"){return $$ex.fn();} throw($$ex);}}

,"reading",unescape("skipTo%3A%20anObject%0D%0A%09%22%20Advance%20the%20receiver%20upto%20anObject%20%28or%20end%29.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09anObject%20isString%20ifFalse%3A%20%5B%20self%20setToEnd.%20%5Efalse%20%5D.%0D%0A%09index%20%3A%3D%20self%20collection%20indexOf%3A%20anObject%20startingAt%3A%20self%20position%20+%201.%0D%0A%09%28index%20between%3A%20self%20position%20+%201%20and%3A%20self%20readLimit%29%20ifTrue%3A%20%5B%0D%0A%09%09self%20position%3A%20index%20+%20anObject%20size%20-%201.%0D%0A%09%09%5Etrue%0D%0A%09%5D.%0D%0A%09self%20setToEnd.%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.StringStream,"upTo:","upTo_"

,function (anObject){var self=this;try{var start=nil;var found=nil;start=(self.position() + (1));

((anObject.isString()).mustBeBoolean()==true ? nil : (function(){self.setToEnd();return (function(){throw({name: "stReturn", selector: "upTo_", fn: function(){return self.collection().copyFrom_to_(start, self.readLimit())}})})();})());

found=((self.skipTo_(anObject)).mustBeBoolean()==true ? (function(){return anObject.size();})() : (function(){return (0);})());

(function(){throw({name: "stReturn", selector: "upTo_", fn: function(){return self.collection().copyFrom_to_(start, self.position()._minus(found))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "upTo_"){return $$ex.fn();} throw($$ex);}}

,"reading",unescape("upTo%3A%20anObject%0D%0A%09%22%20Return%20the%20elements%20read%20from%20the%20receiver%20upto%20anObject%20%28or%20end%29.%20%22%0D%0A%0D%0A%09%7C%20start%20found%20%7C%0D%0A%09start%20%3A%3D%20self%20position%20+%201.%0D%0A%09anObject%20isString%20ifFalse%3A%20%5B%0D%0A%09%09self%20setToEnd.%0D%0A%09%09%5Eself%20collection%20copyFrom%3A%20start%20to%3A%20self%20readLimit%0D%0A%09%5D.%0D%0A%09found%20%3A%3D%20%28self%20skipTo%3A%20anObject%29%20ifTrue%3A%20%5B%20anObject%20size%20%5D%20ifFalse%3A%20%5B%200%20%5D.%0D%0A%09%5Eself%20collection%20copyFrom%3A%20start%20to%3A%20self%20position%20-%20found"));

smalltalk.bind(smalltalk.Message.$klass,"selector:arguments:","selector_arguments_"

,function (aString,anArray){var self=this;return (function($rec){$rec.selector_(aString);$rec.arguments_(anArray);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("selector%3A%20aString%20arguments%3A%20anArray%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09selector%3A%20aString%3B%0D%0A%09%09arguments%3A%20anArray%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Message.$klass,"receiver:selector:arguments:","receiver_selector_arguments_"

,function (anObject,aString,anArray){var self=this;return (function($rec){$rec.receiver_(anObject);$rec.selector_(aString);$rec.arguments_(anArray);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("receiver%3A%20anObject%20selector%3A%20aString%20arguments%3A%20anArray%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09receiver%3A%20anObject%3B%0D%0A%09%09selector%3A%20aString%3B%0D%0A%09%09arguments%3A%20anArray%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Message,"selector","selector"

,function (){var self=this;return self['@selector'];return self;}

,"accessing",unescape("selector%0D%0A%09%22%20Return%20the%20selector%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eselector"));

smalltalk.bind(smalltalk.Message,"selector:","selector_"

,function (aString){var self=this;self['@selector']=aString;return self;}

,"accessing",unescape("selector%3A%20aString%0D%0A%09%22%20Set%20the%20selector%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09selector%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.Message,"arguments:","arguments_"

,function (anArray){var self=this;self['@arguments']=anArray;return self;}

,"accessing",unescape("arguments%3A%20anArray%0D%0A%09%22%20Set%20the%20arguments%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09arguments%20%3A%3D%20anArray"));

smalltalk.bind(smalltalk.Message,"arguments","arguments"

,function (){var self=this;return self['@arguments'];return self;}

,"accessing",unescape("arguments%0D%0A%09%22%20Return%20the%20arguments%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Earguments"));

smalltalk.bind(smalltalk.Message,"receiver","receiver"

,function (){var self=this;return self['@receiver'];return self;}

,"accessing",unescape("receiver%0D%0A%09%22%20Return%20the%20receiver%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ereceiver"));

smalltalk.bind(smalltalk.Message,"receiver:","receiver_"

,function (anObject){var self=this;self['@receiver']=anObject;return self;}

,"accessing",unescape("receiver%3A%20anObject%0D%0A%09%22%20Set%20the%20receiver%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09receiver%20%3A%3D%20anObject"));

smalltalk.bind(smalltalk.Message,"perform","perform"

,function (){var self=this;return self.receiver().perform_withArguments_(self.selector(), self.arguments());return self;}

,"private",unescape("perform%0D%0A%09%22%20Return%20the%20result%20of%20sending%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20receiver%0D%0A%09%09perform%3A%20self%20selector%0D%0A%09%09withArguments%3A%20self%20arguments"));

smalltalk.bind(smalltalk.Message,"performDeferred","performDeferred"

,function (){var self=this;(function(){return self.perform();}).valueDeferred();return self;}

,"evaluating",unescape("performDeferred%0D%0A%09%22%20Evaluate%20the%20receiver%20deferred%20in%20time.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%5B%20self%20perform%20%5D%20valueDeferred."));

smalltalk.bind(smalltalk.Message,"evaluate","evaluate"

,function (){var self=this;return self.perform();return self;}

,"evaluating",unescape("evaluate%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20perform"));

smalltalk.bind(smalltalk.Message,"evaluateFor:","evaluateFor_"

,function (anObject){var self=this;return self.evaluateWithArguments_(smalltalk.Array.with_(anObject));return self;}

,"evaluating",unescape("evaluateFor%3A%20anObject%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%09%5Eself%20evaluateWithArguments%3A%20%28Array%20with%3A%20anObject%29"));

smalltalk.bind(smalltalk.Message,"evaluateWithArguments:","evaluateWithArguments_"

,function (anArray){var self=this;return self.receiver().perform_withArguments_(self.selector(), self.collectArguments_(anArray));return self;}

,"evaluating",unescape("evaluateWithArguments%3A%20anArray%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20receiver%0D%0A%09%09perform%3A%20self%20selector%0D%0A%09%09withArguments%3A%20%28self%20collectArguments%3A%20anArray%29"));

smalltalk.bind(smalltalk.Message,"initializeArguments","initializeArguments"

,function (){var self=this;self['@arguments']=smalltalk.Array.new_(self.selector().argumentCount());return self;}

,"private",unescape("initializeArguments%0D%0A%09%22%20Private%20-%20Initialize%20the%20arguments%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09arguments%20%3A%3D%20Array%20new%3A%20self%20selector%20argumentCount"));

smalltalk.bind(smalltalk.Message,"argumentCount","argumentCount"

,function (){var self=this;((((self['@arguments'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeArguments();})() : nil);

return self['@arguments'].size();return self;}

,"private",unescape("argumentCount%0D%0A%09%22%20Return%20the%20number%20of%20arguments%20required%20to%20evaluate%20the%20receiver.%20%22%0D%0A%0D%0A%09arguments%20isNil%20ifTrue%3A%20%5B%20self%20initializeArguments%20%5D.%0D%0A%09%5Earguments%20size"));

smalltalk.bind(smalltalk.Message,"collectArguments:","collectArguments_"

,function (evaluationArguments){var self=this;try{((self['@arguments'].size()._eq(evaluationArguments.size())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "collectArguments_", fn: function(){return evaluationArguments}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "collectArguments_", fn: function(){return evaluationArguments.copyFrom_to_((1), self.argumentCount().min_(evaluationArguments.size()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "collectArguments_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("collectArguments%3A%20evaluationArguments%0D%0A%09%22%20Private%20-%20Return%20the%20arguments%20to%20evaluate%20the%20receiver.%20%22%0D%0A%0D%0A%09arguments%20size%20%3D%20evaluationArguments%20size%20ifTrue%3A%20%5B%20%5EevaluationArguments%20%5D.%0D%0A%09%5EevaluationArguments%20copyFrom%3A%201%20to%3A%20%28self%20argumentCount%20min%3A%20evaluationArguments%20size%29"));

smalltalk.bind(smalltalk.LinkMessage,"resultAction","resultAction"

,function (){var self=this;return self['@resultAction'];return self;}

,"accessing",unescape("resultAction%0D%0A%09%22%20Return%20the%20resultAction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EresultAction"));

smalltalk.bind(smalltalk.LinkMessage,"resultAction:","resultAction_"

,function (anObject){var self=this;self['@resultAction']=anObject;return self;}

,"accessing",unescape("resultAction%3A%20anObject%0D%0A%09%22%20Set%20the%20resultAction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09resultAction%20%3A%3D%20anObject"));

smalltalk.bind(smalltalk.LinkMessage,"evaluate","evaluate"

,function (){var self=this;return self.evaluateWithArguments_([]);return self;}

,"evaluating",unescape("evaluate%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20evaluateWithArguments%3A%20%23%28%29"));

smalltalk.bind(smalltalk.LinkMessage,"collectArguments:","collectArguments_"

,function (evaluationArguments){var self=this;return self.arguments().collect_((function(each){return each.evaluateWithArguments_(evaluationArguments);}));return self;}

,"evaluating",unescape("collectArguments%3A%20evaluationArguments%0D%0A%09%22%20Private%20-%20Return%20the%20arguments%20to%20evaluate%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20arguments%20collect%3A%20%5B%3Aeach%7C%20each%20evaluateWithArguments%3A%20evaluationArguments%20%5D"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visit:","visit_"

,function (aNode){var self=this;aNode.accept_(self);return self;}

,"visiting",unescape("visit%3A%20aNode%0D%0A%09aNode%20accept%3A%20self"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"ignore:","ignore_"

,function (aNode){var self=this;return self;}

,"visiting",unescape("ignore%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitNode:","visitNode_"

,function (aNode){var self=this;self.ignore_(aNode);return self;}

,"visiting",unescape("visitNode%3A%20aNode%0D%0A%09self%20ignore%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitMethodNode:","visitMethodNode_"

,function (aNode){var self=this;self.visitNode_(aNode);return self;}

,"visiting",unescape("visitMethodNode%3A%20aNode%0D%0A%09self%20visitNode%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitSequenceNode:","visitSequenceNode_"

,function (aNode){var self=this;self.visitNode_(aNode);return self;}

,"visiting",unescape("visitSequenceNode%3A%20aNode%0D%0A%09self%20visitNode%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitBlockSequenceNode:","visitBlockSequenceNode_"

,function (aNode){var self=this;self.visitSequenceNode_(aNode);return self;}

,"visiting",unescape("visitBlockSequenceNode%3A%20aNode%0D%0A%09self%20visitSequenceNode%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitBlockNode:","visitBlockNode_"

,function (aNode){var self=this;self.visitNode_(aNode);return self;}

,"visiting",unescape("visitBlockNode%3A%20aNode%0D%0A%09self%20visitNode%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitReturnNode:","visitReturnNode_"

,function (aNode){var self=this;self.visitNode_(aNode);return self;}

,"visiting",unescape("visitReturnNode%3A%20aNode%0D%0A%09self%20visitNode%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitSendNode:","visitSendNode_"

,function (aNode){var self=this;self.visitNode_(aNode);return self;}

,"visiting",unescape("visitSendNode%3A%20aNode%0D%0A%09self%20visitNode%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitCascadeNode:","visitCascadeNode_"

,function (aNode){var self=this;self.visitNode_(aNode);return self;}

,"visiting",unescape("visitCascadeNode%3A%20aNode%0D%0A%09self%20visitNode%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitValueNode:","visitValueNode_"

,function (aNode){var self=this;self.visitNode_(aNode);return self;}

,"visiting",unescape("visitValueNode%3A%20aNode%0D%0A%09self%20visitNode%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitVariableNode:","visitVariableNode_"

,function (aNode){var self=this;self.ignore_(aNode);return self;}

,"visiting",unescape("visitVariableNode%3A%20aNode%0D%0A%09self%20ignore%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitAssignmentNode:","visitAssignmentNode_"

,function (aNode){var self=this;self.visitNode_(aNode);return self;}

,"visiting",unescape("visitAssignmentNode%3A%20aNode%0D%0A%09self%20visitNode%3A%20aNode"));

smalltalk.bind(smalltalk.CompilerNodeVisitor,"visitMacroAssignment:to:","visitMacroAssignment_to_"

,function (aVariableNode,anExpressionNode){var self=this;return false;return self;}

,"visiting",unescape("visitMacroAssignment%3A%20aVariableNode%20to%3A%20anExpressionNode%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20generated%20code%20to%20a%20macro%20assignment%20to%20aVariableNode.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.MethodReferences.$klass,"constructEventsTriggered","constructEventsTriggered"

,function (){var self=this;return ["found:", "searchStarted", "searchFinished"]._comma(smalltalk.whoImplements(smalltalk.MethodReferences.$klass,'constructEventsTriggered').$superclass.$fn.prototype['constructEventsTriggered'].apply(self, []));return self;}

,"events",unescape("constructEventsTriggered%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%23%28%09%23found%3A%0D%0A%09%09%23searchStarted%20%23searchFinished%0D%0A%09%29%20%2C%20super%20constructEventsTriggered"));

smalltalk.bind(smalltalk.MethodReferences,"rootClasses","rootClasses"

,function (){var self=this;try{((((self['@rootClasses'] || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "rootClasses", fn: function(){return smalltalk.Smalltalk.current().rootClasses()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "rootClasses", fn: function(){return self['@rootClasses']}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "rootClasses"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("rootClasses%0D%0A%09%22%20Return%20the%20rootClasses%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09rootClasses%20isNil%20ifTrue%3A%20%5B%20%5ESmalltalk%20current%20rootClasses%20%5D.%0D%0A%09%5ErootClasses"));

smalltalk.bind(smalltalk.MethodReferences,"rootClasses:","rootClasses_"

,function (anObject){var self=this;self['@rootClasses']=anObject;return self;}

,"accessing",unescape("rootClasses%3A%20anObject%0D%0A%09%22%20Set%20the%20rootClasses%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09rootClasses%20%3A%3D%20anObject"));

smalltalk.bind(smalltalk.MethodReferences,"initializeResults","initializeResults"

,function (){var self=this;self['@results']=smalltalk.Array.$$new();return self;}

,"initialize",unescape("initializeResults%0D%0A%09%22%20Private%20-%20Initialize%20the%20results%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09results%20%3A%3D%20Array%20new"));

smalltalk.bind(smalltalk.MethodReferences,"results","results"

,function (){var self=this;((((self['@results'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeResults();})() : nil);

return self['@results'];return self;}

,"accessing",unescape("results%0D%0A%09%22%20Return%20the%20results%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09results%20isNil%20ifTrue%3A%20%5B%20self%20initializeResults%5D.%0D%0A%09%5Eresults"));

smalltalk.bind(smalltalk.MethodReferences,"results:","results_"

,function (anObject){var self=this;self['@results']=anObject;return self;}

,"accessing",unescape("results%3A%20anObject%0D%0A%09%22%20Set%20the%20results%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09results%20%3A%3D%20anObject"));

smalltalk.bind(smalltalk.MethodReferences,"reset","reset"

,function (){var self=this;self.results_(nil);return self;}

,"initialize",unescape("reset%0D%0A%09%22%20Reset%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20results%3A%20nil"));

smalltalk.bind(smalltalk.MethodReferences,"search:","search_"

,function (what){var self=this;var atoms=nil;atoms=smalltalk.Array.$$new();

self.rootClasses().do_((function(root){return root.instanceClass().withAllSubclasses().do_((function(cls){cls.methodsDo_((function(each){return atoms.add_(each);}));return cls.$klass.methodsDo_((function(each){return atoms.add_(each);}));}));}));

self.triggerEvent_("searchStarted");

atoms=atoms.select_((function(aMethod){return ((aMethod.fn().toString().includes_(what)).mustBeBoolean()==true ? (function(){self.results().add_(aMethod);self.triggerEvent_with_("found:", aMethod);return true;})() : (function(){return false;})());}));

self.triggerEvent_("searchFinished");

return atoms;return self;}

,"searching",unescape("search%3A%20what%0D%0A%09%22%20Find%20%28source%29%20references%20to%20what%20starting%20from%20root%20classes.%0D%0A%09Note%3A%20search%20is%20realized%20on%20javascript%20source%20of%20native%20code%20of%20methods%20found%20from%20rootClasses.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20atoms%20%7C%0D%0A%09atoms%20%3A%3D%20Array%20new.%0D%0A%09self%20rootClasses%20do%3A%20%5B%3Aroot%7C%0D%0A%09%09root%20instanceClass%20withAllSubclasses%20do%3A%20%5B%3Acls%7C%0D%0A%09%09%09cls%20methodsDo%3A%20%5B%3Aeach%7C%20atoms%20add%3A%20each%20%5D.%0D%0A%09%09%09cls%20class%20methodsDo%3A%20%5B%3Aeach%7C%20atoms%20add%3A%20each%20%5D.%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09self%20triggerEvent%3A%20%23searchStarted.%0D%0A%09atoms%20%3A%3D%20atoms%20select%3A%20%5B%3AaMethod%7C%0D%0A%09%09%28aMethod%20fn%20toString%20includes%3A%20what%29%20ifTrue%3A%20%5B%0D%0A%09%09%09self%20results%20add%3A%20aMethod.%0D%0A%09%09%09self%20triggerEvent%3A%20%23found%3A%20with%3A%20aMethod.%0D%0A%09%09%09true%0D%0A%09%09%5D%20ifFalse%3A%20%5B%20false%20%5D%0D%0A%09%5D.%0D%0A%09self%20triggerEvent%3A%20%23searchFinished.%0D%0A%09%5Eatoms"));

smalltalk.bind(smalltalk.MethodReferences,"searchCategory:","searchCategory_"

,function (aName){var self=this;var found=nil;self.triggerEvent_("searchStarted");

found=smalltalk.Exporter.$$new().matchCategory_from_(aName, self.rootClasses());

found=found.first()._comma(found.last());

found.do_((function(each){self.results().add_(each);return self.triggerEvent_with_("found:", each);}));

self.triggerEvent_("searchFinished");

return found;return self;}

,"searching",unescape("searchCategory%3A%20aName%0D%0A%09%22%20Find%20%28source%29%20references%20to%20category%20starting%20from%20root%20classes.%20%22%0D%0A%0D%0A%09%7C%20found%20%7C%0D%0A%09self%20triggerEvent%3A%20%23searchStarted.%0D%0A%09found%20%3A%3D%20Exporter%20new%20matchCategory%3A%20aName%20from%3A%20self%20rootClasses.%0D%0A%09found%20%3A%3D%20found%20first%20%2C%20found%20last.%0D%0A%09found%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09%09self%20results%20add%3A%20each.%0D%0A%09%09%09self%20triggerEvent%3A%20%23found%3A%20with%3A%20each.%0D%0A%09%5D.%0D%0A%09self%20triggerEvent%3A%20%23searchFinished.%0D%0A%09%5Efound"));

smalltalk.bind(smalltalk.MethodReferences,"sendPatternsOf:","sendPatternsOf_"

,function (aSelector){var self=this;return smalltalk.Array.with_with_(self.normalSendPatternOf_(aSelector), self.superSendPatternOf_(aSelector));return self;}

,"patterns",unescape("sendPatternsOf%3A%20aSelector%0D%0A%09%22%20Private%20-%20Return%20the%20search%20patterns%20for%20references%20of%20aSelector.%20%22%0D%0A%0D%0A%09%5EArray%0D%0A%09%09with%3A%20%28self%20normalSendPatternOf%3A%20aSelector%29%0D%0A%09%09with%3A%20%28self%20superSendPatternOf%3A%20aSelector%29"));

smalltalk.bind(smalltalk.MethodReferences,"normalSendPatternOf:","normalSendPatternOf_"

,function (aSelector){var self=this;return "."._comma(aSelector.asSelector())._comma(unescape("%28"));return self;}

,"patterns",unescape("normalSendPatternOf%3A%20aSelector%0D%0A%09%22%20Private%20-%20Return%20the%20search%20pattern%20for%20normal%20senders%20of%20aSelector.%20%22%0D%0A%0D%0A%09%5E%27.%27%20%2CaSelector%20asSelector%20%2C%27%28%27"));

smalltalk.bind(smalltalk.MethodReferences,"superSendPatternOf:","superSendPatternOf_"

,function (aSelector){var self=this;return unescape(".%24superclass.%24fn.prototype%5B%27")._comma(aSelector.asSelector())._comma(unescape("%27%5D.apply%28"));return self;}

,"patterns",unescape("superSendPatternOf%3A%20aSelector%0D%0A%09%22%20Private%20-%20Return%20the%20search%20pattern%20for%20senders%20%28to%20super%29%20of%20aSelector.%20%22%0D%0A%0D%0A%09%5E%27.%24superclass.%24fn.prototype%5B%27%27%27%20%2CaSelector%20asSelector%20%2C%27%27%27%5D.apply%28%27"));

smalltalk.bind(smalltalk.MethodReferences,"instVarPatternOf:","instVarPatternOf_"

,function (instVarName){var self=this;return unescape("self%5B%27@")._comma(instVarName.asJavascriptName())._comma(unescape("%27%5D"));return self;}

,"patterns",unescape("instVarPatternOf%3A%20instVarName%0D%0A%09%22%20Private%20-%20Return%20the%20search%20pattern%20for%20instance%20variable%20access.%20%22%0D%0A%0D%0A%09%5E%27self%5B%27%27@%27%20%2CinstVarName%20asJavascriptName%20%2C%27%27%27%5D%27"));

smalltalk.bind(smalltalk.MethodReferences,"globalPatternOf:","globalPatternOf_"

,function (globalName){var self=this;return "smalltalk."._comma(globalName);return self;}

,"patterns",unescape("globalPatternOf%3A%20globalName%0D%0A%09%22%20Private%20-%20Return%20the%20search%20pattern%20for%20global%20variable%20access.%20%22%0D%0A%0D%0A%09%5E%27smalltalk.%27%20%2CglobalName"));

smalltalk.bind(smalltalk.MethodReferences,"types","types"

,function (){var self=this;return ["referencesOf:", "referencesOfGlobal:", "referencesOfClassVariable:", "referencesOfInstanceVariable:", "searchCategory:", "search:"];return self;}

,"types",unescape("types%0D%0A%09%22%20Private%20-%20Return%20the%20types%20of%20search%20implemented%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%23%28%09%23referencesOf%3A%20%23referencesOfGlobal%3A%0D%0A%09%09%23referencesOfClassVariable%3A%20%0D%0A%09%09%23referencesOfInstanceVariable%3A%0D%0A%09%09%23searchCategory%3A%0D%0A%09%09%23search%3A%0D%0A%09%29"));

smalltalk.bind(smalltalk.MethodReferences,"search:type:","search_type_"

,function (aName,typeSelector){var self=this;var selector=nil;selector=typeSelector.upTo_(":")._comma(":");

return ((self.respondsTo_(selector)).mustBeBoolean()==true ? (function(){return self.perform_with_(selector, aName);})() : nil);return self;}

,"searching",unescape("search%3A%20aName%20type%3A%20typeSelector%0D%0A%09%22%20Return%20the%20result%20of%20searching%20for%20aName%20as%20a%20search%20of%20specified%20type%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%7C%20selector%20%7C%0D%0A%09selector%20%3A%3D%20%28typeSelector%20upTo%3A%20%24%3A%29%20%2C%27%3A%27.%0D%0A%09%5E%28self%20respondsTo%3A%20selector%29%20ifTrue%3A%20%5B%0D%0A%09%09self%20perform%3A%20selector%20with%3A%20aName%0D%0A%09%5D"));

smalltalk.bind(smalltalk.MethodReferences,"sendersOf:","sendersOf_"

,function (aSelector){var self=this;return self.sendPatternsOf_(aSelector).inject_into_(smalltalk.Array.$$new(), (function(total, each){return total._comma(self.search_(each));}));return self;}

,"searching",unescape("sendersOf%3A%20aSelector%0D%0A%09%22%20Find%20the%20requested%20elements%20from%20root%20classes.%20%22%0D%0A%0D%0A%09%5E%28self%20sendPatternsOf%3A%20aSelector%29%20inject%3A%20Array%20new%20into%3A%20%5B%3Atotal%20%3Aeach%7C%0D%0A%09%09total%20%2C%20%28self%20search%3A%20each%29%0D%0A%09%5D"));

smalltalk.bind(smalltalk.MethodReferences,"referencesOf:","referencesOf_"

,function (aSelector){var self=this;(function($rec){$rec.add_(unescape("---%20Implementors%20of%20%23")._comma(aSelector)._comma(unescape("%20---")));$rec.addAll_(self.implementorsOf_(aSelector));return $rec.add_(unescape("---%20Senders%20of%20%23")._comma(aSelector)._comma(unescape("%20---")));})(self.results());

self.sendersOf_(aSelector);

return self['@results'];return self;}

,"searching",unescape("referencesOf%3A%20aSelector%0D%0A%09%22%20Find%20the%20references%20to%20message%20%28aSelector%29.%20%22%0D%0A%0D%0A%09self%20results%0D%0A%09%09add%3A%20%27---%20Implementors%20of%20%23%27%20%2CaSelector%20%2C%27%20---%27%3B%0D%0A%09%09addAll%3A%20%28self%20implementorsOf%3A%20aSelector%29%3B%0D%0A%09%09add%3A%20%27---%20Senders%20of%20%23%27%20%2CaSelector%20%2C%27%20---%27.%0D%0A%09self%20sendersOf%3A%20aSelector.%0D%0A%09%5Eresults"));

smalltalk.bind(smalltalk.MethodReferences,"referencesOfInstanceVariable:","referencesOfInstanceVariable_"

,function (instVarName){var self=this;return self.search_(self.instVarPatternOf_(instVarName));return self;}

,"searching",unescape("referencesOfInstanceVariable%3A%20instVarName%0D%0A%09%22%20Find%20the%20requested%20elements%20from%20root%20classes.%20%22%0D%0A%0D%0A%09%5Eself%20search%3A%20%28self%20instVarPatternOf%3A%20instVarName%29"));

smalltalk.bind(smalltalk.MethodReferences,"settersOfInstanceVariable:","settersOfInstanceVariable_"

,function (instVarName){var self=this;return self.search_(self.instVarPatternOf_(instVarName)._comma(unescape("%3D")));return self;}

,"searching",unescape("settersOfInstanceVariable%3A%20instVarName%0D%0A%09%22%20Find%20the%20requested%20elements%20from%20root%20classes.%20%22%0D%0A%0D%0A%09%5Eself%20search%3A%20%28self%20instVarPatternOf%3A%20instVarName%29%20%2C%27%3D%27"));

smalltalk.bind(smalltalk.MethodReferences,"referencesOfGlobal:","referencesOfGlobal_"

,function (globalName){var self=this;return self.search_(self.globalPatternOf_(globalName));return self;}

,"searching",unescape("referencesOfGlobal%3A%20globalName%0D%0A%09%22%20Find%20the%20requested%20elements%20from%20root%20classes.%20%22%0D%0A%0D%0A%09%5Eself%20search%3A%20%28self%20globalPatternOf%3A%20globalName%29"));

smalltalk.bind(smalltalk.MethodReferences,"settersOfGlobalVariable:","settersOfGlobalVariable_"

,function (globalName){var self=this;return self.search_(self.globalPatternOf_(globalName)._comma(unescape("%3D")));return self;}

,"searching",unescape("settersOfGlobalVariable%3A%20globalName%0D%0A%09%22%20Find%20the%20requested%20elements%20from%20root%20classes.%20%22%0D%0A%0D%0A%09%5Eself%20search%3A%20%28self%20globalPatternOf%3A%20globalName%29%20%2C%27%3D%27"));

smalltalk.bind(smalltalk.MethodReferences,"referencesOfClassVariable:","referencesOfClassVariable_"

,function (classVarName){var self=this;return self.search_(unescape(".classVariableAt_%28%22")._comma(classVarName)._comma(unescape("%22%29")));return self;}

,"searching",unescape("referencesOfClassVariable%3A%20classVarName%0D%0A%09%22%20Find%20the%20requested%20elements%20from%20root%20classes.%20%22%0D%0A%0D%0A%09%5Eself%20search%3A%20%27.classVariableAt_%28%22%27%2CclassVarName%2C%27%22%29%27"));

smalltalk.bind(smalltalk.MethodReferences,"settersOfClassVariable:","settersOfClassVariable_"

,function (classVarName){var self=this;return self.search_(unescape(".classVariableAt_put_%28%22")._comma(classVarName)._comma(unescape("%22%2C")));return self;}

,"searching",unescape("settersOfClassVariable%3A%20classVarName%0D%0A%09%22%20Find%20the%20requested%20elements%20from%20root%20classes.%20%22%0D%0A%0D%0A%09%5Eself%20search%3A%20%27.classVariableAt_put_%28%22%27%2CclassVarName%2C%27%22%2C%27"));

smalltalk.bind(smalltalk.MethodReferences,"implementorsOf:","implementorsOf_"

,function (aSelector){var self=this;return smalltalk.Smalltalk.current().implementorsOf_(aSelector);return self;}

,"private",unescape("implementorsOf%3A%20aSelector%0D%0A%09%22%20Private%20-%20Return%20the%20implementors%20of%20aSelector.%20%22%0D%0A%0D%0A%09%5ESmalltalk%20current%20implementorsOf%3A%20aSelector"));

smalltalk.bind(smalltalk.MethodReferences,"messagesOf:","messagesOf_"

,function (aCompiledMethod){var self=this;var stream=nil;var selectors=nil;var string=nil;stream=aCompiledMethod.fn().toString().stream();

stream.upTo_(unescape("%7B"));

selectors=smalltalk.Set.$$new();

(function(){while(!(function(){return stream.atEnd();})()){(function(){return selectors.add_((function($rec){$rec.upTo_(".");return $rec.upTo_(unescape("%28"));})(stream).asArrayOfSubstringsSeparatedBy_(".").last().asStSelector());})()};return nil})();

selectors.remove_ifAbsent_("", (function(){return nil;}));

return selectors.asArray().select_((function(each){return each.isLiteral();})).sorted();return self;}

,"accessing",unescape("messagesOf%3A%20aCompiledMethod%0D%0A%09%22%20Return%20all%20the%20messages%20that%20can%20be%20sent%20during%20execution%20of%20aCompiledMethod.%20%22%0D%0A%0D%0A%09%7C%20stream%20selectors%20string%20%7C%0D%0A%09stream%20%3A%3D%20aCompiledMethod%20fn%20toString%20stream.%0D%0A%09stream%20upTo%3A%20%24%7B.%0D%0A%09selectors%20%3A%3D%20Set%20new.%0D%0A%09%5Bstream%20atEnd%5D%20whileFalse%3A%20%5B%0D%0A%09%09selectors%20add%3A%20%28%28%0D%0A%09%09%09stream%20upTo%3A%20%24.%3BupTo%3A%20%24%28%0D%0A%09%09%09%29%20asArrayOfSubstringsSeparatedBy%3A%20%24.%29%0D%0A%09%09%09last%20asStSelector%0D%0A%09%5D.%0D%0A%09selectors%20remove%3A%20%27%27%20ifAbsent%3A%20%5B%5D.%0D%0A%09%5E%28selectors%20asArray%20select%3A%20%5B%3Aeach%7C%20each%20isLiteral%20%5D%29%20sorted"));

smalltalk.bind(smalltalk.SystemManager.$klass,"constructEventsTriggered","constructEventsTriggered"

,function (){var self=this;return smalltalk.whoImplements(smalltalk.SystemManager.$klass,'constructEventsTriggered').$superclass.$fn.prototype['constructEventsTriggered'].apply(self, [])._comma(["aboutToBind:to:", "methodBound:to:", "aboutToRemove:from:", "methodRemoved:from:", "aboutToChange:to:", "aboutToCreateClass:with:", "classChanged:", "classShapeChanged:"]);return self;}

,"events",unescape("constructEventsTriggered%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Esuper%20constructEventsTriggered%20%2C%23%28%0D%0A%09%09%23aboutToBind%3Ato%3A%0D%0A%09%09%23methodBound%3Ato%3A%0D%0A%09%09%23aboutToRemove%3Afrom%3A%0D%0A%09%09%23methodRemoved%3Afrom%3A%0D%0A%09%09%23aboutToChange%3Ato%3A%0D%0A%09%09%23aboutToCreateClass%3Awith%3A%0D%0A%09%09%23classChanged%3A%0D%0A%09%09%23classShapeChanged%3A%0D%0A%09%29"));

smalltalk.bind(smalltalk.SystemManager.$klass,"currentOrNil","currentOrNil"

,function (){var self=this;return self.classVariableAt_ifAbsent_("Current", (function(){return nil;}));return self;}

,unescape("current%20instance"),unescape("currentOrNil%0D%0A%09%22%20Return%20the%20current%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classVariableAt%3A%20%23Current%20ifAbsent%3A%20%5B%20nil%20%5D"));

smalltalk.bind(smalltalk.SystemManager.$klass,"current","current"

,function (){var self=this;((((smalltalk.SystemManager.classVariableAt_("Current") || nil) === nil)).mustBeBoolean()==true ? (function(){return self.current_(self.$$new());})() : nil);

return smalltalk.SystemManager.classVariableAt_("Current");return self;}

,unescape("current%20instance"),unescape("current%0D%0A%09%22%20Return%20the%20current%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09Current%20isNil%20ifTrue%3A%20%5B%20self%20current%3A%20self%20new%20%5D.%0D%0A%09%5ECurrent"));

smalltalk.bind(smalltalk.SystemManager.$klass,"current:","current_"

,function (aSystemManager){var self=this;smalltalk.SystemManager.classVariableAt_put_("Current",aSystemManager);

aSystemManager.install();return self;}

,unescape("current%20instance"),unescape("current%3A%20aSystemManager%0D%0A%09%22%20Set%20the%20current%20source%20manager%20of%20the%20system.%20%22%0D%0A%0D%0A%09Current%20%3A%3D%20aSystemManager.%0D%0A%09aSystemManager%20install."));

smalltalk.bind(smalltalk.SystemManager,"install","install"

,function (){var self=this;return self;}

,"install",unescape("install%0D%0A%09%22%20Private%20-%20Install%20the%20receiver%20as%20the%20source%20manager%20of%20the%20system.%0D%0A%09The%20default%20action%20is%20to%20do%20nothing.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses.%0D%0A%09%22"));

smalltalk.bind(smalltalk.SystemManager,"aboutToBind:to:","aboutToBind_to_"

,function (aMethod,aClass){var self=this;return self.triggerEvent_with_with_("aboutToBind:to:", aMethod, aClass);return self;}

,"tracking-methods",unescape("aboutToBind%3A%20aMethod%20to%3A%20aClass%0D%0A%09%22%20Private%20-%20The%20method%20will%20be%20bound%20to%20aClass.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20%23aboutToBind%3Ato%3A%20with%3A%20aMethod%20with%3A%20aClass%20"));

smalltalk.bind(smalltalk.SystemManager,"methodBound:to:","methodBound_to_"

,function (aMethod,aClass){var self=this;return self.triggerEvent_with_with_("methodBound:to:", aMethod, aClass);return self;}

,"tracking-methods",unescape("methodBound%3A%20aMethod%20to%3A%20aClass%0D%0A%09%22%20Private%20-%20The%20method%20has%20been%20bound%20to%20aClass.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20%23methodBound%3Ato%3A%20with%3A%20aMethod%20with%3A%20aClass%20"));

smalltalk.bind(smalltalk.SystemManager,"aboutToRemove:from:","aboutToRemove_from_"

,function (aMethod,aClass){var self=this;return self.triggerEvent_with_with_("aboutToRemove:from:", aMethod, aClass);return self;}

,"tracking-methods",unescape("aboutToRemove%3A%20aMethod%20from%3A%20aClass%0D%0A%09%22%20Private%20-%20The%20method%20will%20be%20removed%20from%20aClass.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20%23aboutToRemove%3Afrom%3A%20with%3A%20aMethod%20with%3A%20aClass%20"));

smalltalk.bind(smalltalk.SystemManager,"methodRemoved:from:","methodRemoved_from_"

,function (aMethod,aClass){var self=this;return self.triggerEvent_with_with_("methodRemoved:from:", aMethod, aClass);return self;}

,"tracking-methods",unescape("methodRemoved%3A%20aMethod%20from%3A%20aClass%0D%0A%09%22%20Private%20-%20The%20method%20has%20been%20removed%20from%20aClass.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20%23methodRemoved%3Afrom%3A%20with%3A%20aMethod%20with%3A%20aClass%20"));

smalltalk.bind(smalltalk.SystemManager,"aboutToChange:superclass:iVarNames:category:","aboutToChange_superclass_iVarNames_category_"

,function (aClass,superclass,iVarNames,category){var self=this;return self.triggerEvent_with_with_("aboutToChange:to:", aClass, smalltalk.Array.with_with_with_(superclass, iVarNames, category));return self;}

,"tracking-classes",unescape("aboutToChange%3A%20aClass%20superclass%3A%20superclass%20iVarNames%3A%20iVarNames%20category%3A%20category%0D%0A%09%22%20Private%20-%20aClass%20is%20about%20to%20be%20changed.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20%23aboutToChange%3Ato%3A%0D%0A%09%09with%3A%20aClass%0D%0A%09%09with%3A%20%28Array%20with%3A%20superclass%20with%3A%20iVarNames%20with%3A%20category%29"));

smalltalk.bind(smalltalk.SystemManager,"aboutToCreateClass:superclass:iVarNames:category:","aboutToCreateClass_superclass_iVarNames_category_"

,function (globalName,superclass,iVarNames,category){var self=this;return self.triggerEvent_with_with_("aboutToCreateClass:with:", globalName, smalltalk.Array.with_with_with_(superclass, iVarNames, category));return self;}

,"tracking-classes",unescape("aboutToCreateClass%3A%20globalName%20superclass%3A%20superclass%20iVarNames%3A%20iVarNames%20category%3A%20category%0D%0A%09%22%20Private%20-%20Attemp%20to%20create%20Class%20with%20name%20globalName.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20%23aboutToCreateClass%3Awith%3A%0D%0A%09%09with%3A%20globalName%0D%0A%09%09with%3A%20%28Array%20with%3A%20superclass%20with%3A%20iVarNames%20with%3A%20category%29"));

smalltalk.bind(smalltalk.SystemManager,"classChanged:","classChanged_"

,function (aBehavior){var self=this;return self.triggerEvent_with_("classChanged:", aBehavior);return self;}

,"tracking-classes",unescape("classChanged%3A%20aBehavior%0D%0A%09%22%20Private%20-%20aBehavior%20has%20been%20changed.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20%23classChanged%3A%20with%3A%20aBehavior%20"));

smalltalk.bind(smalltalk.SystemManager,"classShapeChanged:","classShapeChanged_"

,function (aBehavior){var self=this;return self.triggerEvent_with_ifNotHandled_("classShapeChanged:", aBehavior, (function(){return aBehavior.recompileAll();}));return self;}

,"tracking-classes",unescape("classShapeChanged%3A%20aBehavior%0D%0A%09%22%20Private%20-%20aBehavior%20has%20changed%20shape.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09triggerEvent%3A%20%23classShapeChanged%3A%0D%0A%09%09with%3A%20aBehavior%0D%0A%09%09ifNotHandled%3A%20%5B%20aBehavior%20recompileAll%20%5D"));

smalltalk.bind(smalltalk.Compiler.$klass,"evaluate:","evaluate_"

,function (smalltalkExpression){var self=this;return self.$$new().evaluate_(smalltalkExpression);return self;}

,"evaluation",unescape("evaluate%3A%20smalltalkExpression%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20smalltalk%20expression%20in%20a%20global%20context.%20%22%0D%0A%0D%0A%09%5Eself%20new%20evaluate%3A%20smalltalkExpression"));

smalltalk.bind(smalltalk.Compiler.$klass,"evaluate:in:to:","evaluate_in_to_"

,function (expression,aClass,aReceiver){var self=this;return aClass.compiler().evaluate_in_to_(expression, aClass, aReceiver);return self;}

,"evaluation",unescape("evaluate%3A%20expression%20in%3A%20aClass%20to%3A%20aReceiver%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20expression%20with%20aReceiver.%20%22%0D%0A%0D%0A%09%5EaClass%20compiler%20evaluate%3A%20expression%20in%3A%20aClass%20to%3A%20aReceiver"));

smalltalk.bind(smalltalk.Compiler.$klass,"evaluate:to:","evaluate_to_"

,function (expression,aReceiver){var self=this;return self.evaluate_in_to_(expression, aReceiver.$klass, aReceiver);return self;}

,"evaluation",unescape("evaluate%3A%20expression%20to%3A%20aReceiver%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20expression%20with%20aReceiver.%20%22%0D%0A%0D%0A%09%5Eself%20evaluate%3A%20expression%20in%3A%20aReceiver%20class%20to%3A%20aReceiver"));

smalltalk.bind(smalltalk.Compiler.$klass,"doIt:to:","doIt_to_"

,function (smalltalkExpression,aReceiver){var self=this;var result=nil;(function(){return result=((((aReceiver || nil) === nil)).mustBeBoolean()==true ? (function(){return self.evaluate_(smalltalkExpression);})() : (function(){return self.evaluate_to_(smalltalkExpression, aReceiver);})());}).on_do_(smalltalk.Error, (function(error){((smalltalk.Smalltalk.isObject_(error).not().or_((function(){return error.isString();}))).mustBeBoolean()==true ? (function(){return result=error;})() : (function(){return result=error.$klass.name()._comma(": ")._comma(error.messageText().asString());})());return self.print_(unescape("//%20")._comma(result));}));

return result;return self;}

,"evaluation",unescape("doIt%3A%20smalltalkExpression%20to%3A%20aReceiver%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20smalltalk%20expression%20in%20the%20context%20of%20aReceiver%20or%20a%20description%20of%20an%20error%20situation%20occurred%20evaluating%20the%20code.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09%5B%20result%20%3A%3D%20aReceiver%20isNil%0D%0A%09%09%09ifTrue%3A%20%20%5B%20self%20evaluate%3A%20smalltalkExpression%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20self%20evaluate%3A%20smalltalkExpression%20to%3A%20aReceiver%20%5D%0D%0A%09%5D%20on%3A%20Error%20do%3A%20%5B%3Aerror%7C%0D%0A%09%09%28%28Smalltalk%20isObject%3A%20error%29%20not%20or%3A%20%5B%20error%20isString%20%5D%29%0D%0A%09%09ifTrue%3A%20%5B%20result%20%3A%3D%20error%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20result%20%3A%3D%20error%20class%20name%2C%27%3A%20%27%2C%20error%20messageText%20asString%20%5D.%0D%0A%09%09self%20print%3A%20%27//%20%27%2C%20result%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Compiler.$klass,"doIt:","doIt_"

,function (smalltalkExpression){var self=this;return self.doIt_to_(smalltalkExpression, nil);return self;}

,"evaluation",unescape("doIt%3A%20smalltalkExpression%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20smalltalk%20expression%20in%20the%20global%20context%20or%20a%20description%20of%20an%20error%20situation%20occurred%20evaluating%20the%20code.%20%22%0D%0A%0D%0A%09%5Eself%20doIt%3A%20smalltalkExpression%20to%3A%20nil"));

smalltalk.bind(smalltalk.Compiler.$klass,"for:","for_"

,function (aBehavior){var self=this;return (function($rec){$rec.currentClass_(aBehavior);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("for%3A%20aBehavior%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09currentClass%3A%20aBehavior%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.Compiler.$klass,"smalltalkNameFor:","smalltalkNameFor_"

,function (aClass){var self=this;try{((((aClass || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "smalltalkNameFor_", fn: function(){return "undefined"}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "smalltalkNameFor_", fn: function(){return "smalltalk."._comma(((aClass.isMetaclass()).mustBeBoolean()==true ? (function(){return aClass.instanceClass().name()._comma(".$klass");})() : (function(){return aClass.name();})()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "smalltalkNameFor_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("smalltalkNameFor%3A%20aClass%0D%0A%09%22%20Private%20-%20Return%20the%20global%20name%20of%20aClass%20%28can%20be%20nil%29.%20%22%0D%0A%0D%0A%09aClass%20isNil%20ifTrue%3A%20%5B%20%5E%23undefined%20%5D.%0D%0A%09%5E%27smalltalk.%27%2C%20%28aClass%20isMetaclass%0D%0A%09%20%20%20%20ifTrue%3A%20%5B%20aClass%20instanceClass%20name%2C%20%27.%24klass%27%20%5D%0D%0A%09%20%20%20%20ifFalse%3A%20%5B%20aClass%20name%20%5D%29"));

smalltalk.bind(smalltalk.Compiler.$klass,"constructEventsTriggered","constructEventsTriggered"

,function (){var self=this;return ["needsCookie:", "startVisit:", "endVisit:", "aboutToCompile:", "setTransformers:", "needsParser", "abotToRecompile:", "recompiled:", "startCompiling:", "endCompiling:", "needsOptimizationMap", "customizeOptimizations", "unknownVariable:"]._comma(smalltalk.whoImplements(smalltalk.Compiler.$klass,'constructEventsTriggered').$superclass.$fn.prototype['constructEventsTriggered'].apply(self, []));return self;}

,"events",unescape("constructEventsTriggered%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%23%28%09%23needsCookie%3A%20%23startVisit%3A%20%23endVisit%3A%0D%0A%09%09%23aboutToCompile%3A%20%23setTransformers%3A%0D%0A%09%09%23needsParser%0D%0A%09%09%23abotToRecompile%3A%20%23recompiled%3A%0D%0A%09%09%23startCompiling%3A%20%23endCompiling%3A%0D%0A%09%09%23needsOptimizationMap%0D%0A%09%09%23customizeOptimizations%0D%0A%09%09%23unknownVariable%3A%0D%0A%09%29%20%2C%20super%20constructEventsTriggered"));

smalltalk.bind(smalltalk.Compiler.$klass,"debugInfo:","debugInfo_"

,function (aMethod){var self=this;return aMethod.basicAt_ifAbsentPut_("$debugInfo", (function(){return self.debugInfo_forClass_(aMethod.source(), aMethod.classField());}));return self;}

,"debug",unescape("debugInfo%3A%20aMethod%0D%0A%09%22%20Return%20the%20debug%20information%20of%20aMethod.%20%22%0D%0A%0D%0A%09%5EaMethod%20basicAt%3A%20%27%24debugInfo%27%20ifAbsentPut%3A%20%5B%0D%0A%09%09self%20debugInfo%3A%20aMethod%20source%20forClass%3A%20aMethod%20classField%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Compiler.$klass,"getInfo:","getInfo_"

,function (aString){var self=this;try{var stream=nil;var aClass=nil;var selector=nil;var source=nil;var aMethod=nil;stream=aString.stream();

aClass=stream.nextChunk().doIt();

selector=stream.nextChunk().doIt();

source=stream.nextChunk();

aMethod=aClass._gt_gt(selector);

((((aMethod || nil) !== nil).and_((function(){return aMethod.source()._eq(source);}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "getInfo_", fn: function(){return self.debugInfo_(aMethod)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "getInfo_", fn: function(){return self.debugInfo_forClass_(source, aClass)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "getInfo_"){return $$ex.fn();} throw($$ex);}}

,"debug",unescape("getInfo%3A%20aString%0D%0A%09%22%20Private%20-%20Return%20the%20information%20of%20compiling%20aString%20as%20a%20chunked%20spec.%20%22%0D%0A%0D%0A%09%7C%20stream%20aClass%20selector%20source%20aMethod%20%7C%0D%0A%09stream%20%3A%3D%20aString%20stream.%0D%0A%09aClass%20%3A%3D%20stream%20nextChunk%20doIt.%0D%0A%09selector%20%3A%3D%20stream%20nextChunk%20doIt.%0D%0A%09source%20%3A%3D%20stream%20nextChunk.%0D%0A%09aMethod%20%3A%3D%20aClass%20%3E%3E%20selector.%0D%0A%09%28aMethod%20notNil%20and%3A%20%5B%20aMethod%20source%20%3D%20source%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20debugInfo%3A%20aMethod%0D%0A%09%5D.%0D%0A%09%5Eself%20debugInfo%3A%20source%20forClass%3A%20aClass"));

smalltalk.bind(smalltalk.Compiler.$klass,"debugInfoFrom:","debugInfoFrom_"

,function (aString){var self=this;return self.debugInfoFromStream_(aString.stream());return self;}

,"debug",unescape("debugInfoFrom%3A%20aString%0D%0A%09%22%20Private%20-%20Return%20the%20debug%20information%20decoding%20aString%20contents.%0D%0A%09Note%3A%20aString%20must%20be%20result%20of%20sending%20%23getInfo%3A%20to%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20debugInfoFromStream%3A%20aString%20stream"));

smalltalk.bind(smalltalk.Compiler.$klass,"debugInfoFromStream:","debugInfoFromStream_"

,function (aStream){var self=this;return smalltalk.Array.with_with_with_with_(aStream.nextChunk(), aStream.nextChunk(), aStream.nextChunk(), self.debugCookiesFrom_(aStream));return self;}

,"private",unescape("debugInfoFromStream%3A%20aStream%0D%0A%09%22%20Private%20-%20Return%20the%20debug%20information%20encoded%20in%20aStream.%20%22%0D%0A%0D%0A%09%5EArray%09%22ref.%20%23debugInfo%3AforClass%3A%20%22%0D%0A%09%09with%3A%20aStream%20nextChunk%0D%0A%09%09with%3A%20aStream%20nextChunk%0D%0A%09%09with%3A%20aStream%20nextChunk%0D%0A%09%09with%3A%20%28self%20debugCookiesFrom%3A%20aStream%29"));

smalltalk.bind(smalltalk.Compiler.$klass,"debugCookiesFrom:","debugCookiesFrom_"

,function (aStream){var self=this;var result=nil;var cookie=nil;result=smalltalk.Array.$$new();

(function(){while(!(function(){return (function($rec){$rec.skipSeparators();return $rec.atEnd();})(aStream);})()){(function(){cookie=self.debugCookieFrom_(aStream);return ((((cookie || nil) !== nil)).mustBeBoolean()==true ? (function(){return result.add_(cookie);})() : nil);})()};return nil})();

return result;return self;}

,"private",unescape("debugCookiesFrom%3A%20aStream%0D%0A%09%22%20Private%20-%20Return%20the%20debug%20cookies%20encoded%20in%20aStream.%20%22%0D%0A%0D%0A%09%7C%20result%20cookie%20%7C%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09%5B%20aStream%20skipSeparators%3B%20atEnd%20%5D%20whileFalse%3A%20%5B%0D%0A%09%09cookie%20%3A%3D%20self%20debugCookieFrom%3A%20aStream.%0D%0A%09%09cookie%20notNil%20ifTrue%3A%20%5B%20result%20add%3A%20cookie%20%5D.%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Compiler.$klass,"debugCookieFrom:","debugCookieFrom_"

,function (aStream){var self=this;var nextOffset=nil;nextOffset=(function(){return aStream.nextChunk().asNumber();});

return smalltalk.Array.with_with_with_with_(aStream.nextChunk(), nextOffset.value()._at(nextOffset.value()), nextOffset.value()._at(nextOffset.value()), aStream.nextChunk().asArrayOfSubstrings());return self;}

,"private",unescape("debugCookieFrom%3A%20aStream%0D%0A%09%22%20Private%20-%20Return%20the%20next%20debug%20cookie%20encoded%20in%20aStream%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%7C%20nextOffset%20%7C%0D%0A%09nextOffset%20%3A%3D%20%5B%20aStream%20nextChunk%20asNumber%20%5D.%0D%0A%09%5EArray%09%22ref.%20%23debugInfo%3AforClass%3A%20%22%0D%0A%09%09with%3A%20aStream%20nextChunk%0D%0A%09%09with%3A%20nextOffset%20value%20@%20nextOffset%20value%0D%0A%09%09with%3A%20nextOffset%20value%20@%20nextOffset%20value%0D%0A%09%09with%3A%20aStream%20nextChunk%20asArrayOfSubstrings"));

smalltalk.bind(smalltalk.Compiler.$klass,"debugInfo:forClass:","debugInfo_forClass_"

,function (aString,aClass){var self=this;var compiler=nil;var output=nil;var cookies=nil;var aNode=nil;output="".stream();

cookies=[];

compiler=self.$$new();

(function($rec){$rec.when_do_("needsCookie:", (function(aNode){return cookies.add_(smalltalk.Array.with_with_(aNode, compiler.position()));}));return $rec.when_do_("endVisit:", (function(cookie){return cookie.add_(compiler.position());}));})(compiler);

(function($rec){$rec.nextChunkPut_(aClass.name());$rec.nextChunkPut_(aString);$rec.nextChunkPut_(compiler.compile_forClass_(aString, aClass));return $rec.yourself();})(output);

cookies.do_((function(tuple){aNode=tuple.first();(function($rec){$rec.nextChunkPut_(aNode.$klass.name());$rec.nextChunkPut_(aNode.start().asString());$rec.nextChunkPut_(aNode.end().asString());$rec.nextChunkPut_(tuple.second().asString());$rec.nextChunkPut_(tuple.third().asString());return $rec.yourself();})(output);aNode.bindings().do_((function(each){return output.nextPutAll_(" "._comma(each));}));return output.nextChunkPut_(" ");}));

return output.contents();return self;}

,"debug",unescape("debugInfo%3A%20aString%20forClass%3A%20aClass%0D%0A%09%22%20Private%20-%20Return%20aString%20with%20information%20of%20compiling%20aString%20as%20a%20method%20implemented%20in%20aClass.%20%22%0D%0A%0D%0A%09%7C%20compiler%20output%20cookies%20aNode%20%7C%0D%0A%09output%20%3A%3D%20%27%27%20stream.%0D%0A%09cookies%20%3A%3D%20%23%28%29.%0D%0A%09compiler%20%3A%3D%20self%20new.%0D%0A%09compiler%0D%0A%09%09when%3A%20%23needsCookie%3A%20do%3A%20%5B%3AaNode%7C%20cookies%20add%3A%20%28Array%20with%3A%20aNode%20with%3A%20compiler%20position%29%20%5D%3B%0D%0A%09%09when%3A%20%23endVisit%3A%20do%3A%20%5B%3Acookie%7C%20cookie%20add%3A%20compiler%20position%20%5D.%0D%0A%09output%0D%0A%09%09nextChunkPut%3A%20aClass%20name%3B%0D%0A%09%09nextChunkPut%3A%20aString%3B%0D%0A%09%09nextChunkPut%3A%20%28compiler%20compile%3A%20aString%20forClass%3A%20aClass%29%3B%0D%0A%09%09yourself.%0D%0A%09cookies%20do%3A%20%5B%3Atuple%7C%0D%0A%09%09aNode%20%3A%3D%20tuple%20first.%0D%0A%09%09output%0D%0A%09%09%09nextChunkPut%3A%20aNode%20class%20name%3B%0D%0A%09%09%09nextChunkPut%3A%20aNode%20start%20asString%3B%0D%0A%09%09%09nextChunkPut%3A%20aNode%20end%20asString%3B%0D%0A%09%09%09nextChunkPut%3A%20tuple%20second%20asString%3B%0D%0A%09%09%09nextChunkPut%3A%20tuple%20third%20asString%3B%0D%0A%09%09%09yourself.%0D%0A%09%09aNode%20bindings%20do%3A%20%5B%3Aeach%7C%20output%20nextPutAll%3A%20%27%20%27%20%2Ceach%20%5D.%0D%0A%09%09output%09nextChunkPut%3A%20%27%20%27.%0D%0A%09%5D.%0D%0A%09%5Eoutput%20contents"));

smalltalk.bind(smalltalk.Compiler,"visit:","visit_"

,function (aNode){var self=this;try{var cookie=nil;cookie=self.triggerEvent_with_ifNotHandled_("needsCookie:", aNode, (function(){return (function(){throw({name: "stReturn", selector: "visit_", fn: function(){return smalltalk.whoImplements(smalltalk.Compiler,'visit_').$superclass.$fn.prototype['visit_'].apply(self, [aNode])}})})();}));

self.triggerEvent_with_("startVisit:", cookie);

smalltalk.whoImplements(smalltalk.Compiler,'visit_').$superclass.$fn.prototype['visit_'].apply(self, [aNode]);

self.triggerEvent_with_("endVisit:", cookie);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visit_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visit%3A%20aNode%0D%0A%09%7C%20cookie%20%7C%0D%0A%09cookie%20%3A%3D%20self%0D%0A%09%09triggerEvent%3A%20%23needsCookie%3A%20with%3A%20aNode%0D%0A%09%09ifNotHandled%3A%20%5B%20%5Esuper%20visit%3A%20aNode%20%5D.%0D%0A%09self%20triggerEvent%3A%20%23startVisit%3A%20with%3A%20cookie.%0D%0A%09super%20visit%3A%20aNode.%0D%0A%09self%20triggerEvent%3A%20%23endVisit%3A%20with%3A%20cookie."));

smalltalk.bind(smalltalk.Compiler,"currentClass","currentClass"

,function (){var self=this;return self['@currentClass'];return self;}

,"accessing",unescape("currentClass%0D%0A%09%22%20Return%20the%20current%20class%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EcurrentClass"));

smalltalk.bind(smalltalk.Compiler,"currentClass:","currentClass_"

,function (aClass){var self=this;self['@currentClass']=aClass;return self;}

,"accessing",unescape("currentClass%3A%20aClass%0D%0A%09%22%20Set%20the%20current%20class%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09currentClass%20%3A%3D%20aClass"));

smalltalk.bind(smalltalk.Compiler,"transformers","transformers"

,function (){var self=this;((((self['@transformers'] || nil) === nil)).mustBeBoolean()==true ? (function(){self['@transformers']=smalltalk.Array.$$new();return self.triggerEvent_with_("setTransformers:", self['@transformers']);})() : nil);

return self['@transformers'];return self;}

,"accessing",unescape("transformers%0D%0A%09%22%20Return%20the%20node%20transformers%20installed%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09transformers%20isNil%20ifTrue%3A%20%5B%0D%0A%09%09transformers%20%3A%3D%20Array%20new.%0D%0A%09%09self%20triggerEvent%3A%20%23setTransformers%3A%20with%3A%20transformers.%0D%0A%09%5D.%0D%0A%09%5Etransformers"));

smalltalk.bind(smalltalk.Compiler,"optimizationMap:","optimizationMap_"

,function (aSpec){var self=this;self['@optimizationMap']=aSpec;return self;}

,"accessing",unescape("optimizationMap%3A%20aSpec%0D%0A%09%22%20Set%20the%20current%20optimizationMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09optimizationMap%20%3A%3D%20aSpec"));

smalltalk.bind(smalltalk.Compiler,"recompile:","recompile_"

,function (aClass){var self=this;self.triggerEvent_with_("abotToRecompile:", aClass);

aClass.methodDictionary().do_((function(each){return self.compile_forClass_category_(each.source(), aClass, each.category());}));

self.triggerEvent_with_("recompiled:", aClass);

((aClass.isMetaclass()).mustBeBoolean()==true ? nil : (function(){return self.recompile_(aClass.$klass);})());return self;}

,"compiling",unescape("recompile%3A%20aClass%0D%0A%09%22%20Re-compile%20all%20the%20methods%20defined%20by%20aClass.%20%22%0D%0A%0D%0A%09self%20triggerEvent%3A%20%23abotToRecompile%3A%20with%3A%20aClass.%0D%0A%09aClass%20methodDictionary%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%09self%20compile%3A%20each%20source%20forClass%3A%20aClass%20category%3A%20each%20category%0D%0A%09%5D.%0D%0A%09self%20triggerEvent%3A%20%23recompiled%3A%20with%3A%20aClass.%0D%0A%09aClass%20isMetaclass%20ifFalse%3A%20%5B%20self%20recompile%3A%20aClass%20class%20%5D."));

smalltalk.bind(smalltalk.Compiler,"compile:forClass:category:","compile_forClass_category_"

,function (aString,aClass,category){var self=this;try{var method=nil;((((aString || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "compile_forClass_category_", fn: function(){return nil}})})();})() : nil);

method=self.load_forClass_(aString, aClass);

method.category_(category);

aClass.addCompiledMethod_(method);

(function(){throw({name: "stReturn", selector: "compile_forClass_category_", fn: function(){return method}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "compile_forClass_category_"){return $$ex.fn();} throw($$ex);}}

,"compiling",unescape("compile%3A%20aString%20forClass%3A%20aClass%20category%3A%20category%0D%0A%09%22%20Return%20the%20compiled%20method%20result%20of%20installing%20a%20new%20method%20compiled%20from%20aString%20in%20aClass.%20%22%0D%0A%0D%0A%09%7C%20method%20%7C%0D%0A%09aString%20isNil%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09method%20%3A%3D%20self%20load%3A%20aString%20forClass%3A%20aClass.%0D%0A%09method%20category%3A%20category.%0D%0A%09aClass%20addCompiledMethod%3A%20method.%0D%0A%09%5Emethod"));

smalltalk.bind(smalltalk.Compiler,"load:forClass:","load_forClass_"

,function (aString,aClass){var self=this;var jsSource=nil;jsSource=self.compile_forClass_(aString, aClass);

return self.eval_(jsSource);return self;}

,"private-compiling",unescape("load%3A%20aString%20forClass%3A%20aClass%0D%0A%09%22%20Private%20-%20Return%20the%20CompiledMethod%20result%20of%20compiling%20aString%20as%20a%20method%20implemented%20in%20aClass.%20%22%0D%0A%0D%0A%09%7C%20jsSource%20%7C%0D%0A%09jsSource%20%3A%3D%20self%20compile%3A%20aString%20forClass%3A%20aClass.%0D%0A%09%22DEBUG%20-%20self%20print%3A%20jsSource.%22%0D%0A%09%5Eself%20eval%3A%20jsSource"));

smalltalk.bind(smalltalk.Compiler,"compile:forClass:","compile_forClass_"

,function (aString,aClass){var self=this;self.currentClass_(aClass);

return self.compile_(aString);return self;}

,"private-compiling",unescape("compile%3A%20aString%20forClass%3A%20aClass%0D%0A%09%22%20Private%20-%20Return%20the%20javascript%20code%20result%20of%20compiling%20aString%20as%20a%20method%20implemented%20in%20aClass.%20%22%0D%0A%0D%0A%09self%20currentClass%3A%20aClass.%0D%0A%09%5Eself%20compile%3A%20aString"));

smalltalk.bind(smalltalk.Compiler,"eval:","eval_"

,function (javascriptExpression){var self=this;return eval(javascriptExpression);return self;}

,"evaluation",unescape("eval%3A%20javascriptExpression%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20a%20javascript%20expression%20in%20global%20context.%20%22%0D%0A%0D%0A%09%5E%23%20%23eval%3A%20javascriptExpression"));

smalltalk.bind(smalltalk.Compiler,"parseCode:","parseCode_"

,function (aString){var self=this;return self.parser().parse_(aString.readStream());return self;}

,"parsing",unescape("parseCode%3A%20aString%0D%0A%20%20%20%20%5Eself%20parser%20parse%3A%20aString%20readStream"));

smalltalk.bind(smalltalk.Compiler,"compile:","compile_"

,function (aString){var self=this;var aNode=nil;aNode=self.parseCode_(aString);

self.triggerEvent_with_("aboutToCompile:", aNode);

return self.compileNode_(aNode);return self;}

,"private-compiling",unescape("compile%3A%20aString%0D%0A%09%22%20Private%20-%20Return%20the%20javascript%20code%20result%20of%20compiling%20aString%20for%20currentClass.%20%22%0D%0A%0D%0A%09%7C%20aNode%20%7C%0D%0A%09aNode%20%3A%3D%20self%20parseCode%3A%20aString.%0D%0A%09self%20triggerEvent%3A%20%23aboutToCompile%3A%20with%3A%20aNode.%0D%0A%09%5Eself%20compileNode%3A%20aNode"));

smalltalk.bind(smalltalk.Compiler,"initialize","initialize"

,function (){var self=this;smalltalk.whoImplements(smalltalk.Compiler,'initialize').$superclass.$fn.prototype['initialize'].apply(self, []);

self['@unknownVariables']=[];

self['@tempVariables']=[];return self;}

,"initialize",unescape("initialize%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%20%22%0D%0A%0D%0A%09super%20initialize.%0D%0A%09unknownVariables%20%3A%3D%20%23%28%29.%0D%0A%09tempVariables%20%3A%3D%20%23%28%29"));

smalltalk.bind(smalltalk.Compiler,"smalltalkNameFor:","smalltalkNameFor_"

,function (aClass){var self=this;return self.$klass.smalltalkNameFor_(aClass);return self;}

,"private",unescape("smalltalkNameFor%3A%20aClass%0D%0A%09%22%20Private%20-%20Return%20the%20global%20name%20of%20aClass%20%28can%20be%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20class%20smalltalkNameFor%3A%20aClass"));

smalltalk.bind(smalltalk.Compiler,"parser","parser"

,function (){var self=this;return self.triggerEvent_ifNotHandled_("needsParser", (function(){return smalltalk.SmalltalkParser.$$new();}));return self;}

,"private",unescape("parser%0D%0A%09%22%20Private%20-%20Return%20the%20parser%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20triggerEvent%3A%20%23needsParser%20ifNotHandled%3A%20%5B%20SmalltalkParser%20new%20%5D"));

smalltalk.bind(smalltalk.Compiler,"stream","stream"

,function (){var self=this;return self['@stream'];return self;}

,"accessing",unescape("stream%0D%0A%09%22%20Return%20the%20current%20stream%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Estream"));

smalltalk.bind(smalltalk.Compiler,"position","position"

,function (){var self=this;return self['@stream'].position()._plus(self['@startOffset']);return self;}

,"accessing",unescape("position%0D%0A%09%22%20Return%20the%20current%20position%20in%20output%20stream.%20%22%0D%0A%0D%0A%09%5Estream%20position%20+%20startOffset"));

smalltalk.bind(smalltalk.Compiler,"emmitedCode","emmitedCode"

,function (){var self=this;return ((((self['@stream'] || nil) !== nil)).mustBeBoolean()==true ? (function(){return self['@stream'].contents();})() : nil);return self;}

,"results",unescape("emmitedCode%0D%0A%09%22%20Return%20the%20emmited%20code%20during%20compilation%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Estream%20notNil%20ifTrue%3A%20%5B%20stream%20contents%20%5D"));

smalltalk.bind(smalltalk.Compiler,"startCompiling:","startCompiling_"

,function (aNode){var self=this;self['@stream']="".writeStream();

self['@startOffset']=self['@stream'].position();

self.triggerEvent_with_("startCompiling:", aNode);return self;}

,"private",unescape("startCompiling%3A%20aNode%0D%0A%09%22%20Private%20-%20Set%20the%20receiver%20to%20start%20emmiting%20code%20for%20aNode.%20%22%0D%0A%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09startOffset%20%3A%3D%20stream%20position.%0D%0A%09self%20triggerEvent%3A%20%23startCompiling%3A%20with%3A%20aNode."));

smalltalk.bind(smalltalk.Compiler,"prepare:","prepare_"

,function (aNode){var self=this;self.transformers().do_((function(each){return each.visit_(aNode);}));return self;}

,"private",unescape("prepare%3A%20aNode%0D%0A%09%22%20Private%20-%20Apply%20tranformations/optimization%20to%20aNode.%20%22%0D%0A%0D%0A%09self%20transformers%20do%3A%20%5B%3Aeach%7C%20each%20visit%3A%20aNode%20%5D."));

smalltalk.bind(smalltalk.Compiler,"endCompiling:","endCompiling_"

,function (aNode){var self=this;self.triggerEvent_with_("endCompiling:", aNode);return self;}

,"private",unescape("endCompiling%3A%20aNode%0D%0A%09%22%20Private%20-%20Finish%20emmiting%20code%20for%20aNode.%20%22%0D%0A%0D%0A%09self%20triggerEvent%3A%20%23endCompiling%3A%20with%3A%20aNode."));

smalltalk.bind(smalltalk.Compiler,"compileNode:","compileNode_"

,function (aNode){var self=this;return (function($rec){$rec.startCompiling_(aNode);$rec.prepare_(aNode);$rec.visit_(aNode);$rec.endCompiling_(aNode);return $rec.emmitedCode();})(self);return self;}

,"private",unescape("compileNode%3A%20aNode%0D%0A%09%22%20Private%20-%20Compile%20aNode.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09startCompiling%3A%20aNode%3B%0D%0A%09%09prepare%3A%20aNode%3B%0D%0A%09%09visit%3A%20aNode%3B%0D%0A%09%09endCompiling%3A%20aNode%3B%0D%0A%09%09emmitedCode"));

smalltalk.bind(smalltalk.Compiler,"localName:","localName_"

,function (aName){var self=this;try{((self.pseudoVariables().includes_(aName)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "localName_", fn: function(){return aName}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "localName_", fn: function(){return aName.asSelector()}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "localName_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("localName%3A%20aName%0D%0A%09%22%20Private%20-%20Return%20a%20valid%20%28javascript%29%20name%20for%20local%20name.%20%22%0D%0A%0D%0A%09%28self%20pseudoVariables%20includes%3A%20aName%29%20ifTrue%3A%20%5B%20%5EaName%20%5D.%0D%0A%09%5EaName%20asSelector"));

smalltalk.bind(smalltalk.Compiler,"visitLocalAssignment:","visitLocalAssignment_"

,function (aNode){var self=this;self['@stream'].nextPutAll_(unescape("%28"));

self.visit_(aNode);

self['@stream'].nextPutAll_(unescape("%29"));return self;}

,"visiting",unescape("visitLocalAssignment%3A%20aNode%0D%0A%09%22%20Private%20-%20Visit%20a%20node%20that%20is%20an%20assignment%20in%20a%20local%20expression.%20%22%0D%0A%0D%0A%09stream%20nextPutAll%3A%20%27%28%27.%0D%0A%09self%20visit%3A%20aNode.%0D%0A%09stream%20nextPutAll%3A%20%27%29%27."));

smalltalk.bind(smalltalk.Compiler,"visitArgument:","visitArgument_"

,function (aNode){var self=this;try{((aNode.isAssignment()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitArgument_", fn: function(){return self.visitLocalAssignment_(aNode)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "visitArgument_", fn: function(){return self.visit_(aNode)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitArgument_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitArgument%3A%20aNode%0D%0A%09%22%20Private%20-%20Visit%20the%20argument%20emmitting%20output.%20%22%0D%0A%0D%0A%09aNode%20isAssignment%20ifTrue%3A%20%5B%20%5Eself%20visitLocalAssignment%3A%20aNode.%20%5D.%0D%0A%09%5Eself%20visit%3A%20aNode"));

smalltalk.bind(smalltalk.Compiler,"visitReceiver:","visitReceiver_"

,function (aNode){var self=this;try{((aNode.isAssignment()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitReceiver_", fn: function(){return self.visitLocalAssignment_(aNode)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "visitReceiver_", fn: function(){return self.visit_(aNode)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitReceiver_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitReceiver%3A%20aNode%0D%0A%09%22%20Private%20-%20Visit%20the%20node%20%28as%20receiver%29%20emmitting%20output.%20%22%0D%0A%0D%0A%09aNode%20isAssignment%20ifTrue%3A%20%5B%20%5Eself%20visitLocalAssignment%3A%20aNode.%20%5D.%0D%0A%09%5Eself%20visit%3A%20aNode"));

smalltalk.bind(smalltalk.Compiler,"generatedCodeFor:","generatedCodeFor_"

,function (aBlock){var self=this;var backup=nil;var result=nil;backup=smalltalk.Array.with_with_(self['@stream'], self['@startOffset']);

self['@startOffset']=self['@stream'].position();

self['@stream']="".writeStream();

aBlock.value();

result=self['@stream'].contents();

self['@stream']=backup.first();

self['@startOffset']=backup.last();

return result;return self;}

,"generation",unescape("generatedCodeFor%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20code%20generated%20during%20evaluation%20of%20aBlock.%20%22%0D%0A%0D%0A%09%7C%20backup%20result%20%7C%0D%0A%09backup%20%3A%3D%20Array%20with%3A%20stream%20with%3A%20startOffset.%0D%0A%09startOffset%20%3A%3D%20stream%20position.%0D%0A%09stream%20%3A%3D%20%27%27%20writeStream.%0D%0A%09aBlock%20value.%0D%0A%09result%20%3A%3D%20stream%20contents.%0D%0A%09stream%20%3A%3D%20backup%20first.%0D%0A%09startOffset%20%3A%3D%20backup%20last.%0D%0A%09%5Eresult%20"));

smalltalk.bind(smalltalk.Compiler,"generateCodeFor:","generateCodeFor_"

,function (aNode){var self=this;var code=nil;self['@functionName']=aNode.selector().asSelector();

self['@stream'].nextPutAll_(unescape("function%28"));

aNode.arguments().do_separatedBy_((function(each){self['@tempVariables'].add_(each);return self['@stream'].nextPutAll_(self.localName_(each));}), (function(){return self['@stream'].nextPutAll_(unescape("%2C"));}));

self['@stream'].nextPutAll_(unescape("%29%7Bvar%20self%3Dthis%3B"));

code=self.generatedCodeFor_((function(){aNode.nodes().do_((function(each){return self.visit_(each);}));return self['@stream'].nextPutAll_(unescape("return%20self%3B"));}));

((self['@earlyReturn']).mustBeBoolean()==true ? (function(){(function($rec){$rec.nextPutAll_(unescape("try%7B"));return $rec.nextPutAll_(code);})(self['@stream']);return self['@stream'].nextPutAll_(unescape("%7D%20catch%28%24%24ex%29%20%7Bif%28%24%24ex.name%20%3D%3D%3D%20%22stReturn%22%20%26%26%20%24%24ex.selector%20%3D%3D%3D%20%22")._comma(self['@functionName'])._comma(unescape("%22%29%7Breturn%20%24%24ex.fn%28%29%3B%7D%20throw%28%24%24ex%29%3B%7D")));})() : (function(){return self['@stream'].nextPutAll_(code);})());

self['@stream'].nextPutAll_(unescape("%7D"));return self;}

,"generation",unescape("generateCodeFor%3A%20aNode%0D%0A%09%22%20Private%20-%20Generate%20code%20of%20javascript%20function%20from%20aNode%20contents.%20%22%0D%0A%0D%0A%09%7C%20code%20%7C%0D%0A%09functionName%20%3A%3D%20aNode%20selector%20asSelector.%0D%0A%09stream%20nextPutAll%3A%20%27function%28%27.%0D%0A%09aNode%20arguments%20do%3A%20%5B%3Aeach%20%7C%20%0D%0A%09%09tempVariables%20add%3A%20each.%0D%0A%09%09stream%20nextPutAll%3A%20%28self%20localName%3A%20each%29%20%5D%0D%0A%09%20%20%20%20separatedBy%3A%20%5B%20stream%20nextPutAll%3A%20%27%2C%27%20%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%29%7Bvar%20self%3Dthis%3B%27.%0D%0A%09code%20%3A%3D%20self%20generatedCodeFor%3A%20%5B%0D%0A%09%09aNode%20nodes%20do%3A%20%5B%3Aeach%20%7C%20self%20visit%3A%20each%20%5D.%0D%0A%09%09stream%20nextPutAll%3A%20%27return%20self%3B%27.%0D%0A%09%5D.%0D%0A%09earlyReturn%20ifTrue%3A%20%5B%0D%0A%09%09stream%20nextPutAll%3A%20%27try%7B%27%3B%20nextPutAll%3A%20code.%0D%0A%09%09stream%20nextPutAll%3A%20%27%7D%20catch%28%24%24ex%29%20%7Bif%28%24%24ex.name%20%3D%3D%3D%20%22stReturn%22%20%26%26%20%24%24ex.selector%20%3D%3D%3D%20%22%27%0D%0A%09%09%09%2C%20functionName%20%2C%20%27%22%29%7Breturn%20%24%24ex.fn%28%29%3B%7D%20throw%28%24%24ex%29%3B%7D%27%0D%0A%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09stream%20nextPutAll%3A%20code%0D%0A%09%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%7D%27"));

smalltalk.bind(smalltalk.Compiler,"includeSourceCode","includeSourceCode"

,function (){var self=this;return true;return self;}

,"generation",unescape("includeSourceCode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20source%20code%20is%20included%20as%20method%20argument.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Compiler,"newMethodFunctionName","newMethodFunctionName"

,function (){var self=this;return "smalltalk.newMethod";return self;}

,"generation",unescape("newMethodFunctionName%0D%0A%09%22%20Private%20-%20Return%20the%20function%20to%20call%20when%20installing%20a%20new%20method.%20%22%0D%0A%0D%0A%09%5E%27smalltalk.newMethod%27"));

smalltalk.bind(smalltalk.Compiler,"visitMethodNode:","visitMethodNode_"

,function (aNode){var self=this;self['@nestedBlocks']=(0);

self['@earlyReturn']=false;

self['@unknownVariables']=[];

self['@tempVariables']=[];

(function($rec){$rec.nextPutAll_(self.newMethodFunctionName()._comma(unescape("%28")));$rec.nextPutAll_(self.smalltalkNameFor_(self['@currentClass']));$rec.nextPutAll_(unescape("%2C%22")._comma(aNode.selector())._comma(unescape("%22%2C")));return $rec.cr();})(self['@stream']);

self.generateCodeFor_(aNode);

((self.includeSourceCode()).mustBeBoolean()==true ? (function(){return (function($rec){$rec.cr();return $rec.nextPutAll_(unescape("%2C")._comma(aNode.source().escapedCode()));})(self['@stream']);})() : nil);

self['@stream'].nextPutAll_(unescape("%29"));return self;}

,"visiting",unescape("visitMethodNode%3A%20aNode%0D%0A%09nestedBlocks%20%3A%3D%200.%0D%0A%09earlyReturn%20%3A%3D%20false.%0D%0A%09unknownVariables%20%3A%3D%20%23%28%29.%0D%0A%09tempVariables%20%3A%3D%20%23%28%29.%0D%0A%09stream%20%0D%0A%09%09nextPutAll%3A%20self%20newMethodFunctionName%2C%20%27%28%27%3B%0D%0A%09%09nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20currentClass%29%3B%0D%0A%09%09nextPutAll%3A%20%27%2C%22%27%2C%20aNode%20selector%2C%20%27%22%2C%27%3B%20cr.%0D%0A%09self%20generateCodeFor%3A%20aNode.%0D%0A%09self%20includeSourceCode%20ifTrue%3A%20%5B%0D%0A%09%09stream%09cr%3B%20%22warning%3A%20this%20cr%20is%20important%20for%20debugger%22%0D%0A%09%09%09nextPutAll%3A%20%27%2C%27%20%2CaNode%20source%20escapedCode%0D%0A%09%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%29%27"));

smalltalk.bind(smalltalk.Compiler,"visitBlockNode:","visitBlockNode_"

,function (aNode){var self=this;self['@stream'].nextPutAll_(unescape("%28function%28"));

aNode.parameters().do_separatedBy_((function(each){self['@tempVariables'].add_(each);return self['@stream'].nextPutAll_(self.localName_(each));}), (function(){return self['@stream'].nextPutAll_(unescape("%2C%20"));}));

self['@stream'].nextPutAll_(unescape("%29%7B"));

aNode.nodes().do_((function(each){return self.visit_(each);}));

self['@stream'].nextPutAll_(unescape("%7D%29"));return self;}

,"visiting",unescape("visitBlockNode%3A%20aNode%0D%0A%09stream%20nextPutAll%3A%20%27%28function%28%27.%0D%0A%09aNode%20parameters%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%09tempVariables%20add%3A%20each.%0D%0A%09%09stream%20nextPutAll%3A%20%28self%20localName%3A%20each%29%0D%0A%09%09%5D%20separatedBy%3A%20%5Bstream%20nextPutAll%3A%20%27%2C%20%27%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%29%7B%27.%0D%0A%09aNode%20nodes%20do%3A%20%5B%3Aeach%20%7C%20self%20visit%3A%20each%20%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%7D%29%27"));

smalltalk.bind(smalltalk.Compiler,"visitSequenceNode:","visitSequenceNode_"

,function (aNode){var self=this;aNode.temps().do_((function(each){self['@tempVariables'].add_(each);return self['@stream'].nextPutAll_("var "._comma(self.localName_(each))._comma(unescape("%3Dnil%3B")));}));

aNode.nodes().do_separatedBy_((function(each){self.visit_(each);return self['@stream'].nextPutAll_(unescape("%3B"));}), (function(){return self['@stream'].cr();}));return self;}

,"visiting",unescape("visitSequenceNode%3A%20aNode%0D%0A%09aNode%20temps%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%09tempVariables%20add%3A%20each.%0D%0A%09%09stream%20nextPutAll%3A%20%27var%20%27%2C%20%28self%20localName%3A%20each%29%2C%20%27%3Dnil%3B%27%0D%0A%09%5D.%0D%0A%09aNode%20nodes%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%09self%20visit%3A%20each.%0D%0A%09%09stream%20nextPutAll%3A%20%27%3B%27%0D%0A%09%5D%20separatedBy%3A%20%5Bstream%20cr%5D"));

smalltalk.bind(smalltalk.Compiler,"visitExtendedSequenceNode:","visitExtendedSequenceNode_"

,function (aNode){var self=this;((((aNode.directive() || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function($rec){$rec.nextPutAll_(aNode.directive().asJavascript_for_on_(self['@functionName'], self, self['@stream']));return $rec.cr();})(self['@stream']);})() : nil);

return self.visitSequenceNode_(aNode);return self;}

,"visiting",unescape("visitExtendedSequenceNode%3A%20aNode%0D%0A%09%22%20Private%20-%20Visit%20a%20directive%20node.%20%22%0D%0A%0D%0A%09aNode%20directive%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09stream%20nextPutAll%3A%20%28aNode%20directive%0D%0A%09%09%09asJavascript%3A%20functionName%0D%0A%09%09%09for%3A%20self%20on%3A%20stream%29%3B%20cr.%0D%0A%09%5D.%0D%0A%09%5Eself%20visitSequenceNode%3A%20aNode"));

smalltalk.bind(smalltalk.Compiler,"visitBlockSequenceNode:","visitBlockSequenceNode_"

,function (aNode){var self=this;var index=nil;self['@nestedBlocks']=(self['@nestedBlocks'] + (1));

((aNode.nodes().isEmpty()).mustBeBoolean()==true ? (function(){return self['@stream'].nextPutAll_(unescape("return%20nil%3B"));})() : (function(){aNode.temps().do_((function(each){self['@tempVariables'].add_(each);return self['@stream'].nextPutAll_("var "._comma(self.localName_(each))._comma(unescape("%3Dnil%3B")));}));index=(0);return aNode.nodes().do_((function(each){index=(index + (1));((index._eq(aNode.nodes().size())).mustBeBoolean()==true ? (function(){return self['@stream'].nextPutAll_("return ");})() : nil);self.visit_(each);return self['@stream'].nextPutAll_(unescape("%3B"));}));})());

self['@nestedBlocks']=(self['@nestedBlocks'] - (1));return self;}

,"visiting",unescape("visitBlockSequenceNode%3A%20aNode%0D%0A%09%7C%20index%20%7C%0D%0A%09nestedBlocks%20%3A%3D%20nestedBlocks%20+%201.%0D%0A%09aNode%20nodes%20isEmpty%0D%0A%09%20%20%20%20ifTrue%3A%20%5B%20stream%20nextPutAll%3A%20%27return%20nil%3B%27%20%5D%0D%0A%09%20%20%20%20ifFalse%3A%20%5B%0D%0A%09%09aNode%20temps%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%09%20%20%20%20tempVariables%20add%3A%20each.%0D%0A%09%09%20%20%20%20stream%20nextPutAll%3A%20%27var%20%27%2C%20%28self%20localName%3A%20each%29%2C%20%27%3Dnil%3B%27%0D%0A%09%09%5D.%0D%0A%09%09index%20%3A%3D%200.%0D%0A%09%09aNode%20nodes%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%09%20%20%20%20index%20%3A%3D%20index%20+%201.%0D%0A%09%09%20%20%20%20index%20%3D%20aNode%20nodes%20size%20ifTrue%3A%20%5B%20stream%20nextPutAll%3A%20%27return%20%27%5D.%0D%0A%09%09%20%20%20%20self%20visit%3A%20each.%0D%0A%09%09%20%20%20%20stream%20nextPutAll%3A%20%27%3B%27%5D%5D.%0D%0A%09nestedBlocks%20%3A%3D%20nestedBlocks%20-%201"));

smalltalk.bind(smalltalk.Compiler,"visitReturnNode:","visitReturnNode_"

,function (aNode){var self=this;(((self['@nestedBlocks'] > (0))).mustBeBoolean()==true ? (function(){return self['@earlyReturn']=true;})() : nil);

((self['@earlyReturn']).mustBeBoolean()==true ? (function(){return (function($rec){$rec.nextPutAll_(unescape("%28function%28%29%7Bthrow%28"));$rec.nextPutAll_(unescape("%7Bname%3A%20%22stReturn%22%2C%20selector%3A%20%22"));$rec.nextPutAll_(self['@functionName']);return $rec.nextPutAll_(unescape("%22%2C%20fn%3A%20function%28%29%7Breturn%20"));})(self['@stream']);})() : (function(){return self['@stream'].nextPutAll_("return ");})());

aNode.nodes().do_((function(each){return self.visit_(each);}));

((self['@earlyReturn']).mustBeBoolean()==true ? (function(){return self['@stream'].nextPutAll_(unescape("%7D%7D%29%7D%29%28%29"));})() : nil);return self;}

,"visiting",unescape("visitReturnNode%3A%20aNode%0D%0A%09nestedBlocks%20%3E%200%20ifTrue%3A%20%5B%20earlyReturn%20%3A%3D%20true%20%5D.%0D%0A%09earlyReturn%20ifTrue%3A%20%5B%0D%0A%09%09stream%0D%0A%09%09%20%20%20%20nextPutAll%3A%20%27%28function%28%29%7Bthrow%28%27%3B%0D%0A%09%09%20%20%20%20nextPutAll%3A%20%27%7Bname%3A%20%22stReturn%22%2C%20selector%3A%20%22%27%3B%0D%0A%09%09%20%20%20%20nextPutAll%3A%20functionName%3B%0D%0A%09%09%20%20%20%20nextPutAll%3A%20%27%22%2C%20fn%3A%20function%28%29%7Breturn%20%27%5D%0D%0A%09%20%20%20%20ifFalse%3A%20%5B%20stream%20nextPutAll%3A%20%27return%20%27%20%5D.%0D%0A%09aNode%20nodes%20do%3A%20%5B%3Aeach%20%7C%20self%20visit%3A%20each%20%5D.%0D%0A%09earlyReturn%20ifTrue%3A%20%5B%20stream%20nextPutAll%3A%20%27%7D%7D%29%7D%29%28%29%27%20%5D"));

smalltalk.bind(smalltalk.Compiler,"visitGlobalReferenceNode:","visitGlobalReferenceNode_"

,function (aNode){var self=this;try{var aName=nil;var aClass=nil;var lookupPools=nil;aName=aNode.value();

aClass=self.currentClass().instanceClass();

aClass.classVariableNamesDo_((function(each){return ((each._eq(aName)).mustBeBoolean()==true ? (function(){(function($rec){$rec.nextPutAll_(self.smalltalkNameFor_(aClass));$rec.nextPutAll_(unescape(".classVariableAt_%28%22"));$rec.nextPutAll_(aName);return $rec.nextPutAll_(unescape("%22%29"));})(self['@stream']);return (function(){throw({name: "stReturn", selector: "visitGlobalReferenceNode_", fn: function(){return self}})})();})() : nil);}));

aClass.sharedPoolsAndNamesDo_((function(poolName, pool){return ((pool.includesKey_(aName)).mustBeBoolean()==true ? (function(){(function($rec){$rec.nextPutAll_(unescape("smalltalk.poolDictionary_%28%22"));$rec.nextPutAll_(poolName);$rec.nextPutAll_(unescape("%22%29.at_%28%22"));$rec.nextPutAll_(aName);return $rec.nextPutAll_(unescape("%22%29"));})(self['@stream']);return (function(){throw({name: "stReturn", selector: "visitGlobalReferenceNode_", fn: function(){return self}})})();})() : nil);}));

(function($rec){$rec.nextPutAll_("smalltalk.");return $rec.nextPutAll_(aNode.value());})(self['@stream']);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitGlobalReferenceNode_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitGlobalReferenceNode%3A%20aNode%0D%0A%0D%0A%09%7C%20aName%20aClass%20lookupPools%20%7C%0D%0A%09aName%20%3A%3D%20aNode%20value.%0D%0A%09aClass%20%3A%3D%20self%20currentClass%20instanceClass.%0D%0A%09aClass%20classVariableNamesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20%3D%20aName%20ifTrue%3A%20%5B%0D%0A%09%09%09stream%0D%0A%09%09%09%09nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20aClass%29%3B%0D%0A%09%09%09%09nextPutAll%3A%20%27.classVariableAt_%28%22%27%3B%0D%0A%09%09%09%09nextPutAll%3A%20aName%3B%0D%0A%09%09%09%09nextPutAll%3A%20%27%22%29%27.%0D%0A%09%09%09%5Eself%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09aClass%20sharedPoolsAndNamesDo%3A%20%5B%3ApoolName%20%3Apool%7C%0D%0A%09%09%28pool%20includesKey%3A%20aName%29%20ifTrue%3A%20%5B%0D%0A%09%09%09stream%0D%0A%09%09%09%09nextPutAll%3A%20%27smalltalk.poolDictionary_%28%22%27%3B%0D%0A%09%09%09%09nextPutAll%3A%20poolName%3B%0D%0A%09%09%09%09nextPutAll%3A%20%27%22%29.at_%28%22%27%3B%0D%0A%09%09%09%09nextPutAll%3A%20aName%3B%0D%0A%09%09%09%09nextPutAll%3A%20%27%22%29%27.%0D%0A%09%09%09%5Eself%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09stream%20%0D%0A%09%09nextPutAll%3A%20%27smalltalk.%27%3B%0D%0A%09%09nextPutAll%3A%20aNode%20value."));

smalltalk.bind(smalltalk.Compiler,"hasBlockArguments:","hasBlockArguments_"

,function (aNode){var self=this;try{aNode.arguments().do_((function(each){return ((each.isKindOf_(smalltalk.BlockNode)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "hasBlockArguments_", fn: function(){return false}})})();})());}));

(function(){throw({name: "stReturn", selector: "hasBlockArguments_", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "hasBlockArguments_"){return $$ex.fn();} throw($$ex);}}

,"optimization",unescape("hasBlockArguments%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20arguments%20of%20aNode%20are%20blocks.%20%22%0D%0A%0D%0A%09aNode%20arguments%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09%28each%20isKindOf%3A%20BlockNode%29%20ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Compiler,"hasBlockNoArguments:","hasBlockNoArguments_"

,function (aNode){var self=this;try{((self.hasBlockArguments_(aNode)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "hasBlockNoArguments_", fn: function(){return false}})})();})());

aNode.arguments().do_((function(each){return ((each.parameters().isEmpty()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "hasBlockNoArguments_", fn: function(){return false}})})();})());}));

(function(){throw({name: "stReturn", selector: "hasBlockNoArguments_", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "hasBlockNoArguments_"){return $$ex.fn();} throw($$ex);}}

,"optimization",unescape("hasBlockNoArguments%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20arguments%20of%20aNode%20are%20blocks%20with%20no%20parameters.%20%22%0D%0A%0D%0A%09%28self%20hasBlockArguments%3A%20aNode%29%20ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09aNode%20arguments%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20parameters%20isEmpty%20ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Compiler,"hasBlockOneArguments:","hasBlockOneArguments_"

,function (aNode){var self=this;try{((self.hasBlockArguments_(aNode)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "hasBlockOneArguments_", fn: function(){return false}})})();})());

aNode.arguments().do_((function(each){return ((each.parameters().size()._eq((1))).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "hasBlockOneArguments_", fn: function(){return false}})})();})());}));

(function(){throw({name: "stReturn", selector: "hasBlockOneArguments_", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "hasBlockOneArguments_"){return $$ex.fn();} throw($$ex);}}

,"optimization",unescape("hasBlockOneArguments%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20arguments%20of%20aNode%20are%20blocks%20with%20ONE%20parameter.%20%22%0D%0A%0D%0A%09%28self%20hasBlockArguments%3A%20aNode%29%20ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09aNode%20arguments%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20parameters%20size%20%3D%201%20ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Compiler,"hasNumber:","hasNumber_"

,function (aNode){var self=this;return self.receiverHasNumber_(aNode).or_((function(){return self.argumentsHasNumber_(aNode);}));return self;}

,"optimization",unescape("hasNumber%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20the%20receiver%20or%20arguments%20in%20aNode%20has%20numeric%20value.%20%22%0D%0A%0D%0A%09%5E%28self%20receiverHasNumber%3A%20aNode%29%20or%3A%20%5B%0D%0A%09%09self%20argumentsHasNumber%3A%20aNode%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Compiler,"receiverHasNumber:","receiverHasNumber_"

,function (aNode){var self=this;return aNode.receiver().hasNumber();return self;}

,"optimization",unescape("receiverHasNumber%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20the%20receiver%20of%20aNode%20is%20a%20number.%20%22%0D%0A%0D%0A%09%5EaNode%20receiver%20hasNumber"));

smalltalk.bind(smalltalk.Compiler,"argumentsHasNumber:","argumentsHasNumber_"

,function (aNode){var self=this;try{aNode.arguments().do_((function(each){return ((each.hasNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "argumentsHasNumber_", fn: function(){return true}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "argumentsHasNumber_", fn: function(){return false}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "argumentsHasNumber_"){return $$ex.fn();} throw($$ex);}}

,"optimization",unescape("argumentsHasNumber%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20any%20argument%20of%20of%20aNode%20is%20a%20number.%20%22%0D%0A%0D%0A%09aNode%20arguments%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20hasNumber%20ifTrue%3A%20%5B%20%5Etrue%20%5D%0D%0A%09%5D.%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Compiler,"arg1HasNumber:","arg1HasNumber_"

,function (aNode){var self=this;return aNode.arguments().at_((1)).hasNumber();return self;}

,"optimization",unescape("arg1HasNumber%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20argument%20of%20aNode%20is%20a%20number.%20%22%0D%0A%0D%0A%09%5E%28aNode%20arguments%20at%3A%201%29%20hasNumber"));

smalltalk.bind(smalltalk.Compiler,"arg2HasNumber:","arg2HasNumber_"

,function (aNode){var self=this;return aNode.arguments().at_((2)).hasNumber();return self;}

,"optimization",unescape("arg2HasNumber%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20argument%20of%20aNode%20is%20a%20number.%20%22%0D%0A%0D%0A%09%5E%28aNode%20arguments%20at%3A%202%29%20hasNumber"));

smalltalk.bind(smalltalk.Compiler,"arg3HasNumber:","arg3HasNumber_"

,function (aNode){var self=this;return aNode.arguments().at_((3)).hasNumber();return self;}

,"optimization",unescape("arg3HasNumber%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20argument%20of%20aNode%20is%20a%20number.%20%22%0D%0A%0D%0A%09%5E%28aNode%20arguments%20at%3A%203%29%20hasNumber"));

smalltalk.bind(smalltalk.Compiler,"receiverIsBlockNoArguments:","receiverIsBlockNoArguments_"

,function (aNode){var self=this;return aNode.receiver().isKindOf_(smalltalk.BlockNode).and_((function(){return aNode.receiver().parameters().isEmpty();}));return self;}

,"optimization",unescape("receiverIsBlockNoArguments%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20receiver%20of%20aNode%20is%20block%20with%20no%20arguments.%20%22%0D%0A%0D%0A%09%5E%28aNode%20receiver%20isKindOf%3A%20BlockNode%29%20and%3A%20%5B%0D%0A%09%09aNode%20receiver%20parameters%20isEmpty%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Compiler,"allBlockNoArguments:","allBlockNoArguments_"

,function (aNode){var self=this;return self.receiverIsBlockNoArguments_(aNode).and_((function(){return self.hasBlockNoArguments_(aNode);}));return self;}

,"optimization",unescape("allBlockNoArguments%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20receiver%20and%20arguments%20of%20aNode%20are%20blocks%20with%20no%20arguments.%20%22%0D%0A%0D%0A%09%5E%28self%20receiverIsBlockNoArguments%3A%20aNode%29%20and%3A%20%5B%0D%0A%09%09self%20hasBlockNoArguments%3A%20aNode%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Compiler,"matchOptimizedCondition:with:","matchOptimizedCondition_with_"

,function (condition,aNode){var self=this;try{((["hasNumber:", "receiverHasNumber", "argumentsHasNumber:", "arg1HasNumber:", "arg2HasNumber:", "arg3HasNumber:", "hasBlockArguments:", "hasBlockNoArguments:", "hasBlockOneArguments:", "allBlockNoArguments:", "receiverIsBlockNoArguments:"].includes_(condition)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "matchOptimizedCondition_with_", fn: function(){return self.perform_withArguments_(condition, smalltalk.Array.with_(aNode))}})})();})() : nil);

((condition._eq("true")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "matchOptimizedCondition_with_", fn: function(){return true}})})();})() : nil);

((condition._eq("false")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "matchOptimizedCondition_with_", fn: function(){return false}})})();})() : nil);

((condition.isMemberOf_(smalltalk.Array)).mustBeBoolean()==true ? (function(){condition.detect_ifNone_((function(one){return false._eq(self.matchOptimizedCondition_with_(one, aNode));}), (function(){return (function(){throw({name: "stReturn", selector: "matchOptimizedCondition_with_", fn: function(){return true}})})();}));return (function(){throw({name: "stReturn", selector: "matchOptimizedCondition_with_", fn: function(){return false}})})();})() : nil);

self.print_(unescape("%3E%3E%3E%20unknown%20optimize-condition%3A%20")._comma(condition.asString()));

(function(){throw({name: "stReturn", selector: "matchOptimizedCondition_with_", fn: function(){return false}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "matchOptimizedCondition_with_"){return $$ex.fn();} throw($$ex);}}

,"optimization",unescape("matchOptimizedCondition%3A%20condition%20with%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20aNode%20matches%20the%20condition.%20%22%0D%0A%0D%0A%09%28%23%28%0D%0A%09%23hasNumber%3A%20%23receiverHasNumber%20%23argumentsHasNumber%3A%0D%0A%09%23arg1HasNumber%3A%20%23arg2HasNumber%3A%20%23arg3HasNumber%3A%0D%0A%09%23hasBlockArguments%3A%20%23hasBlockNoArguments%3A%20%23hasBlockOneArguments%3A%0D%0A%09%23allBlockNoArguments%3A%20%23receiverIsBlockNoArguments%3A%0D%0A%09%29%20includes%3A%20condition%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20perform%3A%20condition%20withArguments%3A%20%28Array%20with%3A%20aNode%29%0D%0A%09%5D.%0D%0A%09condition%20%3D%20%23true%20ifTrue%3A%20%5B%20%5Etrue%20%5D.%0D%0A%09condition%20%3D%20%23false%20ifTrue%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%28condition%20isMemberOf%3A%20Array%29%20ifTrue%3A%20%5B%0D%0A%09%09condition%20detect%3A%20%5B%3Aone%7C%0D%0A%09%09%09false%20%3D%20%28self%20matchOptimizedCondition%3A%20one%20with%3A%20aNode%29%0D%0A%09%09%5D%20ifNone%3A%20%5B%20%5Etrue%20%5D.%0D%0A%09%09%5Efalse%0D%0A%09%5D.%0D%0A%09self%20print%3A%20%27%3E%3E%3E%20unknown%20optimize-condition%3A%20%27%2Ccondition%20asString.%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Compiler,"defaultOptimizationMap","defaultOptimizationMap"

,function (){var self=this;return [[(0), [["class", unescape("%25receiver%25.%24klass")], ["isNil", unescape("%28%28%25receiver%25%20%7C%7C%20nil%29%20%3D%3D%3D%20nil%29")], ["notNil", unescape("%28%28%25receiver%25%20%7C%7C%20nil%29%20%21%3D%3D%20nil%29")], ["whileTrue", "receiverIsBlockNoArguments:", unescape("%28function%28%29%7Bwhile%28%25receiver%25%28%29%29%7B%7D%3Breturn%20nil%7D%29%28%29")], ["whileFalse", "receiverIsBlockNoArguments:", unescape("%28function%28%29%7Bwhile%28%21%25receiver%25%28%29%29%7B%7D%3Breturn%20nil%7D%29%28%29")]]], [(1), [["ifTrue:", "hasBlockNoArguments:", unescape("%28%28%25receiver%25%29.mustBeBoolean%28%29%3D%3Dtrue%20%3F%20%25arg1%25%28%29%20%3A%20nil%29")], ["ifFalse:", "hasBlockNoArguments:", unescape("%28%28%25receiver%25%29.mustBeBoolean%28%29%3D%3Dtrue%20%3F%20nil%20%3A%20%25arg1%25%28%29%29")], ["whileTrue:", "allBlockNoArguments:", unescape("%28function%28%29%7Bwhile%28%25receiver%25%28%29%29%7B%25arg1%25%28%29%7D%3Breturn%20nil%7D%29%28%29")], ["whileFalse:", "allBlockNoArguments:", unescape("%28function%28%29%7Bwhile%28%21%25receiver%25%28%29%29%7B%25arg1%25%28%29%7D%3Breturn%20nil%7D%29%28%29")], ["ifNil:", "hasBlockArguments:", unescape("%28function%28%29%7Bvar%20%241%24%3Breturn%20%28%28%28%241%24%20%3D%20%25receiver%25%29%7C%7Cnil%29%3D%3D%3D%20nil%29%20%3F%20%25arg1%25%28%29%20%3A%20%241%24%3B%7D%29%28%29")], ["ifNotNil:", "hasBlockArguments:", unescape("%28function%28%29%7Bvar%20%241%24%3Breturn%20%28%28%28%241%24%20%3D%20%25receiver%25%29%7C%7Cnil%29%21%3D%3D%20nil%29%20%3F%20%25arg1%25%28%29%20%3A%20%241%24%3B%7D%29%28%29")], [unescape("+"), "hasNumber:", unescape("%28%25receiver%25%20+%20%25arg1%25%29")], [unescape("-"), "hasNumber:", unescape("%28%25receiver%25%20-%20%25arg1%25%29")], [unescape("*"), "hasNumber:", unescape("%28%25receiver%25%20*%20%25arg1%25%29")], [unescape("/"), "hasNumber:", unescape("%28%25receiver%25%20/%20%25arg1%25%29")], [unescape("%3E"), "hasNumber:", unescape("%28%25receiver%25%20%3E%20%25arg1%25%29")], [unescape("%3C"), "hasNumber:", unescape("%28%25receiver%25%20%3C%20%25arg1%25%29")], [unescape("%3E%3D"), "hasNumber:", unescape("%28%25receiver%25%20%3E%3D%20%25arg1%25%29")], [unescape("%3C%3D"), "hasNumber:", unescape("%28%25receiver%25%20%3C%3D%20%25arg1%25%29")], [unescape("%3D%3D"), unescape("%28%25receiver%25%20%3D%3D%3D%20%25arg1%25%29")], [unescape("%3D%3D%3D"), unescape("%28%25receiver%25%20%3D%3D%3D%20%25arg1%25%29")], [unescape("%7C%7C"), unescape("%28%25receiver%25%20%7C%7C%20%25arg1%25%29")], ["basicAt:", unescape("%28%25receiver%25%5B%25arg1%25%5D%20%7C%7C%20nil%29")], ["timesRepeat:", "hasBlockNoArguments:", unescape("%28function%28%29%7Bfor%28var%20%241%24%3D%25receiver%25%3B%241%24%3E0%3B%241%24--%29%7B%25arg1%25%28%29%7D%3Breturn%20nil%7D%29%28%29")]]], [(2), [["ifTrue:ifFalse:", "hasBlockNoArguments:", unescape("%28%28%25receiver%25%29.mustBeBoolean%28%29%3D%3Dtrue%20%3F%20%25arg1%25%28%29%20%3A%20%25arg2%25%28%29%29")], ["ifFalse:ifTrue:", "hasBlockNoArguments:", unescape("%28%28%25receiver%25%29.mustBeBoolean%28%29%3D%3Dtrue%20%3F%20%25arg2%25%28%29%20%3A%20%25arg1%25%28%29%29")], ["ifNil:ifNotNil:", "hasBlockNoArguments:", unescape("%28%28%28%25receiver%25%29%7C%7Cnil%29%3D%3D%3D%20nil%29%20%3F%20%25arg1%25%28%29%20%3A%20%25arg2%25%28%29")], ["ifNotNil:ifNil:", "hasBlockNoArguments:", unescape("%28%28%28%25receiver%25%29%7C%7Cnil%29%21%3D%3D%20nil%29%20%3F%20%25arg1%25%28%29%20%3A%20%25arg2%25%28%29")], ["basicAt:ifAbsent:", unescape("%28%25receiver%25%5B%25arg1%25%5D%20%7C%7C%20%25arg2%25.value%28%29%29")], ["basicAt:put:", unescape("%28%25receiver%25%5B%25arg1%25%5D%3D%28%25arg2%25%29%29")]]]];return self;}

,"optimization",unescape("defaultOptimizationMap%0D%0A%09%22%20Private%20-%20Return%20the%20default%20message%20optimization%20specification.%20%22%0D%0A%0D%0A%09%5E%23%28%0D%0A%09%09%23%28%200%20%23%28%09%22selectors%20without%20arguments%22%0D%0A%09%09%09%23%28%20%23class%09%27%25receiver%25.%24klass%27%20%29%0D%0A%09%09%09%23%28%20%23isNil%09%27%28%28%25receiver%25%20%7C%7C%20nil%29%20%3D%3D%3D%20nil%29%27%20%29%0D%0A%09%09%09%23%28%20%23notNil%09%27%28%28%25receiver%25%20%7C%7C%20nil%29%20%21%3D%3D%20nil%29%27%20%29%0D%0A%09%09%09%23%28%20%23whileTrue%20%23receiverIsBlockNoArguments%3A%20%27%28function%28%29%7Bwhile%28%25receiver%25%28%29%29%7B%7D%3Breturn%20nil%7D%29%28%29%27%20%29%0D%0A%09%09%09%23%28%20%23whileFalse%20%23receiverIsBlockNoArguments%3A%20%27%28function%28%29%7Bwhile%28%21%25receiver%25%28%29%29%7B%7D%3Breturn%20nil%7D%29%28%29%27%20%29%0D%0A%09%09%29%20%29%0D%0A%09%09%23%28%201%20%23%28%20%22one%20argument%20selectors%20and%20operations%22%0D%0A%09%09%09%23%28%20%23ifTrue%3A%20%23hasBlockNoArguments%3A%20%27%28%28%25receiver%25%29.mustBeBoolean%28%29%3D%3Dtrue%20%3F%20%25arg1%25%28%29%20%3A%20nil%29%27%20%29%0D%0A%09%09%09%23%28%20%23ifFalse%3A%20%23hasBlockNoArguments%3A%20%27%28%28%25receiver%25%29.mustBeBoolean%28%29%3D%3Dtrue%20%3F%20nil%20%3A%20%25arg1%25%28%29%29%27%20%29%0D%0A%09%09%09%23%28%20%23whileTrue%3A%20%23allBlockNoArguments%3A%20%27%28function%28%29%7Bwhile%28%25receiver%25%28%29%29%7B%25arg1%25%28%29%7D%3Breturn%20nil%7D%29%28%29%27%20%29%0D%0A%09%09%09%23%28%20%23whileFalse%3A%20%23allBlockNoArguments%3A%20%27%28function%28%29%7Bwhile%28%21%25receiver%25%28%29%29%7B%25arg1%25%28%29%7D%3Breturn%20nil%7D%29%28%29%27%20%29%0D%0A%09%09%09%23%28%20%23ifNil%3A%20%23hasBlockArguments%3A%20%27%28function%28%29%7Bvar%20%241%24%3Breturn%20%28%28%28%241%24%20%3D%20%25receiver%25%29%7C%7Cnil%29%3D%3D%3D%20nil%29%20%3F%20%25arg1%25%28%29%20%3A%20%241%24%3B%7D%29%28%29%27%20%29%0D%0A%09%09%09%23%28%20%23ifNotNil%3A%20%23hasBlockArguments%3A%20%27%28function%28%29%7Bvar%20%241%24%3Breturn%20%28%28%28%241%24%20%3D%20%25receiver%25%29%7C%7Cnil%29%21%3D%3D%20nil%29%20%3F%20%25arg1%25%28%29%20%3A%20%241%24%3B%7D%29%28%29%27%20%29%0D%0A%09%09%09%23%28%20%23+%20%23hasNumber%3A%20%27%28%25receiver%25%20+%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23-%20%23hasNumber%3A%20%27%28%25receiver%25%20-%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23*%20%23hasNumber%3A%20%27%28%25receiver%25%20*%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23/%20%23hasNumber%3A%20%27%28%25receiver%25%20/%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23%3E%20%23hasNumber%3A%20%27%28%25receiver%25%20%3E%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23%3C%20%23hasNumber%3A%20%27%28%25receiver%25%20%3C%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23%3E%3D%20%23hasNumber%3A%20%27%28%25receiver%25%20%3E%3D%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23%3C%3D%20%23hasNumber%3A%20%27%28%25receiver%25%20%3C%3D%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23%3D%3D%09%27%28%25receiver%25%20%3D%3D%3D%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23%3D%3D%3D%09%27%28%25receiver%25%20%3D%3D%3D%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23%7C%7C%09%27%28%25receiver%25%20%7C%7C%20%25arg1%25%29%27%20%29%0D%0A%09%09%09%23%28%20%23basicAt%3A%09%27%28%25receiver%25%5B%25arg1%25%5D%20%7C%7C%20nil%29%27%20%29%0D%0A%09%09%09%23%28%20%23timesRepeat%3A%20%23hasBlockNoArguments%3A%20%27%28function%28%29%7Bfor%28var%20%241%24%3D%25receiver%25%3B%241%24%3E0%3B%241%24--%29%7B%25arg1%25%28%29%7D%3Breturn%20nil%7D%29%28%29%27%20%29%0D%0A%09%09%29%20%29%0D%0A%09%09%23%28%202%20%23%28%20%22two%20argument%20messages%20and%20operations%22%0D%0A%09%09%09%23%28%20%23ifTrue%3AifFalse%3A%20%23hasBlockNoArguments%3A%20%27%28%28%25receiver%25%29.mustBeBoolean%28%29%3D%3Dtrue%20%3F%20%25arg1%25%28%29%20%3A%20%25arg2%25%28%29%29%27%20%29%0D%0A%09%09%09%23%28%20%23ifFalse%3AifTrue%3A%20%23hasBlockNoArguments%3A%20%27%28%28%25receiver%25%29.mustBeBoolean%28%29%3D%3Dtrue%20%3F%20%25arg2%25%28%29%20%3A%20%25arg1%25%28%29%29%27%20%29%0D%0A%09%09%09%23%28%20%23ifNil%3AifNotNil%3A%20%23hasBlockNoArguments%3A%20%27%28%28%28%25receiver%25%29%7C%7Cnil%29%3D%3D%3D%20nil%29%20%3F%20%25arg1%25%28%29%20%3A%20%25arg2%25%28%29%27%20%29%0D%0A%09%09%09%23%28%20%23ifNotNil%3AifNil%3A%20%23hasBlockNoArguments%3A%20%27%28%28%28%25receiver%25%29%7C%7Cnil%29%21%3D%3D%20nil%29%20%3F%20%25arg1%25%28%29%20%3A%20%25arg2%25%28%29%27%20%29%0D%0A%09%09%09%23%28%20%23basicAt%3AifAbsent%3A%20%27%28%25receiver%25%5B%25arg1%25%5D%20%7C%7C%20%25arg2%25.value%28%29%29%27%20%29%0D%0A%09%09%09%23%28%20%23basicAt%3Aput%3A%20%27%28%25receiver%25%5B%25arg1%25%5D%3D%28%25arg2%25%29%29%27%20%29%0D%0A%09%09%29%20%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.Compiler,"optimizationMap","optimizationMap"

,function (){var self=this;((((self['@optimizationMap'] || nil) === nil)).mustBeBoolean()==true ? (function(){self['@optimizationMap']=self.triggerEvent_ifNotHandled_("needsOptimizationMap", (function(){return self.defaultOptimizationMap().deepCopy();}));return self.triggerEvent_("customizeOptimizations");})() : nil);

return self['@optimizationMap'];return self;}

,"accessing",unescape("optimizationMap%0D%0A%09%22%20Return%20the%20message%20send%20optiomization%20map%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09optimizationMap%20isNil%20ifTrue%3A%20%5B%0D%0A%09%09optimizationMap%20%20%3A%3D%20self%0D%0A%09%09%09triggerEvent%3A%20%23needsOptimizationMap%0D%0A%09%09%09ifNotHandled%3A%20%5B%20self%20defaultOptimizationMap%20deepCopy%20%5D.%0D%0A%09%09self%20triggerEvent%3A%20%23customizeOptimizations%0D%0A%09%5D.%0D%0A%09%5EoptimizationMap"));

smalltalk.bind(smalltalk.Compiler,"optimize:macro:","optimize_macro_"

,function (aNode,template){var self=this;var input=nil;input=template.readStream();

input.do_((function($$char){return (($$char._eq(unescape("%25"))).mustBeBoolean()==true ? (function(){return self.visitMacroIn_with_(input, aNode);})() : (function(){return self['@stream'].nextPutAll_($$char.asString());})());}));return self;}

,"optimization",unescape("optimize%3A%20aNode%20macro%3A%20template%0D%0A%09%22%20Private%20-%20Generate%20the%20code%20for%20aNode%20using%20a%20macro%20template.%0D%0A%09Dump%20code%20expanding%20variables%20in%20macro%20template.%0D%0A%09Variables%20are%20defined%20between%20%25%25%0D%0A%09%22%0D%0A%0D%0A%09%7C%20input%20%7C%0D%0A%09input%20%3A%3D%20template%20readStream.%0D%0A%09input%20do%3A%20%5B%3Achar%7C%0D%0A%09%09char%20%3D%20%24%25%0D%0A%09%09ifTrue%3A%20%5B%20self%20visitMacroIn%3A%20input%20with%3A%20aNode%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20stream%20nextPutAll%3A%20char%20asString%20%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Compiler,"isOperation:","isOperation_"

,function (aNode){var self=this;return aNode.arguments().size()._eq((1)).and_((function(){return (aNode.selector().size() > (1)).and_((function(){return aNode.selector().first()._eq(unescape("%23")).and_((function(){return unescape("%7C%26%5C%5C+*/%3D%3E%3C%2C@%25%7E-").includes_(aNode.selector().at_((2)));}));}));}));return self;}

,"operations",unescape("isOperation%3A%20aNode%0D%0A%09%22%20Private%20-%20Return%20true%20if%20aNode%20is%20an%20operation.%20%22%0D%0A%0D%0A%09%22self%20print%3A%20%27//%20isOperation%3A%20%27%2CaNode%20selector%2C%27%28%27%2CaNode%20selector%20asSelector%2C%27%29%20argSize%3D%27%2CaNode%20arguments%20size%20asString.%22%0D%0A%09%5EaNode%20arguments%20size%20%3D%201%20and%3A%20%5B%0D%0A%09%09aNode%20selector%20size%20%3E%201%20and%3A%20%5B%0D%0A%09%09aNode%20selector%20first%20%3D%20%24%23%20and%3A%20%5B%0D%0A%09%09%27%7C%26%5C%5C+*/%3D%3E%3C%2C@%25%7E-%27%20includes%3A%20%28aNode%20selector%20at%3A%202%29%0D%0A%09%09%5D%5D%5D"));

smalltalk.bind(smalltalk.Compiler,"visitNormalSend:","visitNormalSend_"

,function (aNode){var self=this;self.visitReceiver_(aNode.receiver());

(function($rec){$rec.nextPutAll_(aNode.receiver().messageSendConnector());$rec.nextPutAll_(aNode.selector().asSelector());return $rec.nextPutAll_(unescape("%28"));})(self['@stream']);

self.visitSendArguments_(aNode);

self['@stream'].nextPutAll_(unescape("%29"));return self;}

,"visiting",unescape("visitNormalSend%3A%20aNode%0D%0A%09%22%20Generate%20code%20for%20direct/inlined%20message%20send.%22%0D%0A%0D%0A%09self%20visitReceiver%3A%20aNode%20receiver.%0D%0A%09stream%0D%0A%09%09nextPutAll%3A%20aNode%20receiver%20messageSendConnector%3B%0D%0A%09%09nextPutAll%3A%20aNode%20selector%20asSelector%3B%0D%0A%09%09nextPutAll%3A%20%27%28%27.%0D%0A%09self%20visitSendArguments%3A%20aNode.%0D%0A%09stream%09nextPutAll%3A%20%27%29%27."));

smalltalk.bind(smalltalk.Compiler,"visitInlined:","visitInlined_"

,function (aNode){var self=this;try{((aNode.isKindOf_(smalltalk.BlockNode)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "visitInlined_", fn: function(){return self.error_(unescape("Invalid%20block%20node%20%28")._comma(aNode.asString())._comma(unescape("%29.")))}})})();})());

aNode.nodes().do_((function(each){return self.visit_(each);}));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitInlined_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitInlined%3A%20aNode%0D%0A%09%22%20Private%20-%20Encode%20aNode%20as%20inlined%20sequence%20of%20statements.%20%22%0D%0A%0D%0A%09%28aNode%20isKindOf%3A%20BlockNode%29%20ifFalse%3A%20%5B%0D%0A%09%09%5Eself%20error%3A%20%27Invalid%20block%20node%20%28%27%2CaNode%20asString%2C%27%29.%27%0D%0A%09%5D.%0D%0A%09aNode%20nodes%20do%3A%20%5B%3Aeach%20%7C%20self%20visit%3A%20each%20%5D."));

smalltalk.bind(smalltalk.Compiler,"visitMacroIn:with:","visitMacroIn_with_"

,function (input,aNode){var self=this;try{var varName=nil;var $$char=nil;var args=nil;varName=smalltalk.String.$$new();

(function(){while(!(function(){$$char=input.next();return $$char._eq(unescape("%25"));})()){(function(){return varName=varName._comma($$char.asString());})()};return nil})();

((varName._eq("receiver")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitMacroIn_with_", fn: function(){return self.visitReceiver_(aNode.receiver())}})})();})() : nil);

(((varName.size() > (3)).and_((function(){return varName.copyFrom_to_((1), (3))._eq("arg");}))).mustBeBoolean()==true ? (function(){args=aNode.arguments();return (1).to_do_(args.size(), (function(i){return (("arg"._comma(i.asString())._eq(varName)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitMacroIn_with_", fn: function(){return self.visit_(args.at_(i))}})})();})() : nil);}));})() : nil);

((varName._eq("inlinedReceiver")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitMacroIn_with_", fn: function(){return self.visitInlined_(aNode.receiver())}})})();})() : nil);

(((varName.size() > (7)).and_((function(){return varName.copyFrom_to_((1), (7))._eq("inlined");}))).mustBeBoolean()==true ? (function(){args=aNode.arguments();return (1).to_do_(args.size(), (function(i){return (("inlined"._comma(i.asString())._eq(varName)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitMacroIn_with_", fn: function(){return self.visitInlined_(args.at_(i))}})})();})() : nil);}));})() : nil);

(function(){throw({name: "stReturn", selector: "visitMacroIn_with_", fn: function(){return self.error_(unescape("Invalid%20macro%20variable%5B")._comma(varName)._comma(unescape("%5D.")))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitMacroIn_with_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitMacroIn%3A%20input%20with%3A%20aNode%0D%0A%09%22%20Private%20-%20Dump%20the%20value%20of%20next%20variable%20defined%20in%20input%20onto%20receiver%27s%20stream.%20%22%0D%0A%0D%0A%09%7C%20varName%20char%20args%20%7C%0D%0A%09varName%20%3A%3D%20String%20new.%0D%0A%09%5B%20char%20%3A%3D%20input%20next.%20char%20%3D%20%24%25%5D%20whileFalse%3A%20%5B%0D%0A%09%09varName%20%3A%3D%20varName%20%2C%20char%20asString%0D%0A%09%5D.%0D%0A%0D%0A%09varName%20%3D%20%27receiver%27%20ifTrue%3A%20%5B%20%5Eself%20visitReceiver%3A%20aNode%20receiver%20%5D.%0D%0A%09%28varName%20size%20%3E%203%20and%3A%20%5B%20%28varName%20copyFrom%3A%201%20to%3A%203%29%20%3D%20%27arg%27%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09args%20%3A%3D%20aNode%20arguments.%0D%0A%09%091%20to%3A%20args%20size%20do%3A%20%5B%3Ai%7C%0D%0A%09%09%09%27arg%27%2Ci%20asString%20%3D%20varName%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%5Eself%20visit%3A%20%28args%20at%3A%20i%29%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09varName%20%3D%20%27inlinedReceiver%27%20ifTrue%3A%20%5B%20%5Eself%20visitInlined%3A%20aNode%20receiver%20%5D.%0D%0A%09%28varName%20size%20%3E%207%20and%3A%20%5B%20%28varName%20copyFrom%3A%201%20to%3A%207%29%20%3D%20%27inlined%27%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09args%20%3A%3D%20aNode%20arguments.%0D%0A%09%091%20to%3A%20args%20size%20do%3A%20%5B%3Ai%7C%0D%0A%09%09%09%27inlined%27%2Ci%20asString%20%3D%20varName%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%5Eself%20visitInlined%3A%20%28args%20at%3A%20i%29%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09%5Eself%20error%3A%20%27Invalid%20macro%20variable%5B%27%2CvarName%2C%27%5D.%27"));

smalltalk.bind(smalltalk.Compiler,"visitOptimizedNode:as:","visitOptimizedNode_as_"

,function (aNode,mapping){var self=this;try{((mapping.size()._eq((2)).and_((function(){return mapping.last().isString();}))).mustBeBoolean()==true ? (function(){self.optimize_macro_(aNode, mapping.last());return (function(){throw({name: "stReturn", selector: "visitOptimizedNode_as_", fn: function(){return true}})})();})() : nil);

((mapping.size()._eq((3)).and_((function(){return mapping.last().isString();}))).mustBeBoolean()==true ? (function(){((self.matchOptimizedCondition_with_(mapping.at_((2)), aNode)).mustBeBoolean()==true ? (function(){return self.optimize_macro_(aNode, mapping.last());})() : (function(){return (function(){throw({name: "stReturn", selector: "visitOptimizedNode_as_", fn: function(){return false}})})();})());return (function(){throw({name: "stReturn", selector: "visitOptimizedNode_as_", fn: function(){return true}})})();})() : nil);

self.print_(unescape("%3E%3E%3E%20compiler%20optimization")._comma(unescape("%20for%20%23"))._comma(aNode.selector())._comma(unescape("%20-%20not%20implemented%20yet.%20Mapping%3D"))._comma(mapping.asString()));

(function(){throw({name: "stReturn", selector: "visitOptimizedNode_as_", fn: function(){return false}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitOptimizedNode_as_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitOptimizedNode%3A%20aNode%20as%3A%20mapping%0D%0A%09%22%20Private%20-%20Generate%20the%20code%20for%20aNode%20using%20custom%20mapping.%0D%0A%09Return%20true%20if%20the%20code%20can%20be%20generated.%0D%0A%09If%20the%20optimization%20fails%2C%20the%20receiver%27s%20stream%20MUST%20be%20leaved%20intact%20to%20ensure%20correct%20code%20generation.%0D%0A%09%22%0D%0A%0D%0A%09%28mapping%20size%20%3D%202%20and%3A%20%5Bmapping%20last%20isString%5D%29%20ifTrue%3A%20%5B%20%22%28selector%20macro%29%22%0D%0A%09%09self%20optimize%3A%20aNode%20macro%3A%20mapping%20last.%0D%0A%09%09%5Etrue%0D%0A%09%5D.%0D%0A%09%28mapping%20size%20%3D%203%20and%3A%20%5Bmapping%20last%20isString%5D%29%20ifTrue%3A%20%5B%22%28selector%20condition%20macro%29%22%0D%0A%09%09%28self%20matchOptimizedCondition%3A%20%28mapping%20at%3A2%29%20with%3A%20aNode%29%0D%0A%09%09%09ifTrue%3A%20%5B%20self%20optimize%3A%20aNode%20macro%3A%20mapping%20last%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%09%5Etrue%0D%0A%09%5D.%0D%0A%0D%0A%09self%20print%3A%20%27%3E%3E%3E%20compiler%20optimization%27%0D%0A%09%09%2C%27%20for%20%23%27%2CaNode%20selector%0D%0A%09%09%2C%27%20-%20not%20implemented%20yet.%20Mapping%3D%27%0D%0A%09%09%2Cmapping%20asString.%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Compiler,"visitOptimizedSend:with:","visitOptimizedSend_with_"

,function (aNode,mapping){var self=this;try{mapping.do_((function(tuple){return ((tuple.first().isNumber().and_((function(){return tuple.first()._eq(aNode.arguments().size());}))).mustBeBoolean()==true ? (function(){return ((self.visitOptimizedSend_with_(aNode, tuple.last())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitOptimizedSend_with_", fn: function(){return true}})})();})() : nil);})() : (function(){return ((tuple.first()._eq(aNode.selector())).mustBeBoolean()==true ? (function(){return ((self.visitOptimizedNode_as_(aNode, tuple)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitOptimizedSend_with_", fn: function(){return true}})})();})() : nil);})() : nil);})());}));

(function(){throw({name: "stReturn", selector: "visitOptimizedSend_with_", fn: function(){return false}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitOptimizedSend_with_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitOptimizedSend%3A%20aNode%20with%3A%20mapping%0D%0A%09%22%20Private%20-%20Generate%20optimal%20code%20for%20aNode%20using%20mapping.%0D%0A%09Return%20true%20if%20the%20code%20has%20been%20generated.%0D%0A%09Leave%20the%20code%20stream%20intact%20if%20the%20optimization%20do%20not%20apply.%0D%0A%09%22%0D%0A%0D%0A%09mapping%20do%3A%20%5B%3Atuple%7C%0D%0A%09%09%28tuple%20first%20isNumber%20and%3A%20%5B%20tuple%20first%20%3D%20aNode%20arguments%20size%20%5D%29%0D%0A%09%09ifTrue%3A%20%5B%20%22arguments%20size%20match%22%0D%0A%09%09%09%28self%20visitOptimizedSend%3A%20aNode%20with%3A%20tuple%20last%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%5Etrue%0D%0A%09%09%09%5D.%0D%0A%09%09%5D%20ifFalse%3A%20%5B%20%22selector%20match%22%0D%0A%09%09%09tuple%20first%20%3D%20aNode%20selector%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%28self%20visitOptimizedNode%3A%20aNode%20as%3A%20tuple%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%09%5Etrue%0D%0A%09%09%09%09%5D.%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Compiler,"visitOptimizedSend:","visitOptimizedSend_"

,function (aNode){var self=this;return self.visitOptimizedSend_with_(aNode, self.optimizationMap());return self;}

,"visiting",unescape("visitOptimizedSend%3A%20aNode%0D%0A%09%22%20Private%20-%20Generate%20optimal%20code%20for%20aNode%20using%20optimization%20map.%0D%0A%09Return%20true%20if%20optimization%20was%20successfull.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20visitOptimizedSend%3A%20aNode%20with%3A%20self%20optimizationMap"));

smalltalk.bind(smalltalk.Compiler,"visitSendArguments:","visitSendArguments_"

,function (aNode){var self=this;aNode.arguments().do_separatedBy_((function(each){return self.visitArgument_(each);}), (function(){return self['@stream'].nextPutAll_(unescape("%2C%20"));}));return self;}

,"visiting",unescape("visitSendArguments%3A%20aNode%0D%0A%09aNode%20arguments%20%0D%0A%09%20%20%20%20do%3A%20%5B%3Aeach%20%7C%20self%20visitArgument%3A%20each%20%5D%0D%0A%09%20%20%20%20separatedBy%3A%20%5B%20stream%20nextPutAll%3A%20%27%2C%20%27%20%5D."));

smalltalk.bind(smalltalk.Compiler,"visitSendToSuper:","visitSendToSuper_"

,function (aNode){var self=this;(function($rec){$rec.nextPutAll_(unescape("smalltalk.whoImplements%28")._comma(self.smalltalkNameFor_(self['@currentClass']))._comma(unescape("%2C%27"))._comma(aNode.selector().asSelector())._comma(unescape("%27%29.%24superclass.%24fn.prototype%5B%27")));$rec.nextPutAll_(aNode.selector().asSelector());return $rec.nextPutAll_(unescape("%27%5D.apply%28self%2C%20%5B"));})(self['@stream']);

self.visitSendArguments_(aNode);

self['@stream'].nextPutAll_(unescape("%5D%29"));return self;}

,"visiting",unescape("visitSendToSuper%3A%20aNode%0D%0A%09stream%20%0D%0A%09%09nextPutAll%3A%20%27smalltalk.whoImplements%28%27%0D%0A%09%09%09%2C%28self%20smalltalkNameFor%3A%20currentClass%29%0D%0A%09%09%09%2C%27%2C%27%27%27%2CaNode%20selector%20asSelector%0D%0A%09%09%09%2C%27%27%27%29.%24superclass.%24fn.prototype%5B%27%27%27%3B%0D%0A%09%09nextPutAll%3A%20aNode%20selector%20asSelector%3B%0D%0A%09%09nextPutAll%3A%20%27%27%27%5D.apply%28self%2C%20%5B%27.%0D%0A%09self%20visitSendArguments%3A%20aNode.%0D%0A%09stream%20nextPutAll%3A%20%27%5D%29%27."));

smalltalk.bind(smalltalk.Compiler,"visitOperation:","visitOperation_"

,function (aNode){var self=this;self['@stream'].nextPutAll_(unescape("%28"));

self.visitReceiver_(aNode.receiver());

self['@stream'].nextPutAll_(unescape("%29"));

self['@stream'].nextPutAll_(aNode.selector().asSelector());

self.visitSendArguments_(aNode);return self;}

,"visiting",unescape("visitOperation%3A%20aNode%0D%0A%09%22%20Private%20-%20aNode%20is%20an%20operation%20and%20selector%20is%20mapped%20to%20target%20operation.%20%22%0D%0A%0D%0A%09stream%20nextPutAll%3A%20%27%28%27.%0D%0A%09self%20visitReceiver%3A%20aNode%20receiver.%0D%0A%09stream%20nextPutAll%3A%20%27%29%27.%0D%0A%09stream%20nextPutAll%3A%20aNode%20selector%20asSelector.%0D%0A%09self%20visitSendArguments%3A%20aNode."));

smalltalk.bind(smalltalk.Compiler,"visitSendNode:","visitSendNode_"

,function (aNode){var self=this;try{((aNode.receiver().isSuper()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitSendNode_", fn: function(){return self.visitSendToSuper_(aNode)}})})();})() : nil);

((self.visitOptimizedSend_(aNode)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitSendNode_", fn: function(){return self}})})();})() : nil);

((self.isOperation_(aNode)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitSendNode_", fn: function(){return self.visitOperation_(aNode)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "visitSendNode_", fn: function(){return self.visitNormalSend_(aNode)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitSendNode_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitSendNode%3A%20aNode%0D%0A%09aNode%20receiver%20isSuper%20ifTrue%3A%20%5B%20%5Eself%20visitSendToSuper%3A%20aNode%20%5D.%0D%0A%09%28self%20visitOptimizedSend%3A%20aNode%29%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09%28self%20isOperation%3A%20aNode%29%20ifTrue%3A%20%5B%20%5Eself%20visitOperation%3A%20aNode%20%5D.%0D%0A%09%5Eself%20visitNormalSend%3A%20aNode"));

smalltalk.bind(smalltalk.Compiler,"visitCascadeNode:","visitCascadeNode_"

,function (aNode){var self=this;var index=nil;var rec=nil;index=(0);

((self['@tempVariables'].includes_("$rec")).mustBeBoolean()==true ? nil : (function(){return self['@tempVariables'].add_("$rec");})());

self['@stream'].nextPutAll_(unescape("%28function%28%24rec%29%7B"));

aNode.nodes().do_((function(each){index=(index + (1));((index._eq(aNode.nodes().size())).mustBeBoolean()==true ? (function(){return self['@stream'].nextPutAll_("return ");})() : nil);rec=smalltalk.VariableNode.$$new();(function($rec){$rec.value_("$rec");return $rec.start_end_(each.start(), each.start());})(rec);each.receiver_(rec);self.visit_(each);return self['@stream'].nextPutAll_(unescape("%3B"));}));

self['@stream'].nextPutAll_(unescape("%7D%29%28"));

self.visit_(aNode.receiver());

self['@stream'].nextPutAll_(unescape("%29"));return self;}

,"visiting",unescape("visitCascadeNode%3A%20aNode%0D%0A%09%7C%20index%20rec%20%7C%0D%0A%09index%20%3A%3D%200.%0D%0A%09%28tempVariables%20includes%3A%20%27%24rec%27%29%20ifFalse%3A%20%5B%20tempVariables%20add%3A%20%27%24rec%27%20%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%28function%28%24rec%29%7B%27.%0D%0A%09aNode%20nodes%20do%3A%20%5B%3Aeach%20%7C%0D%0A%09%20%20%20%20index%20%3A%3D%20index%20+%201.%0D%0A%09%20%20%20%20index%20%3D%20aNode%20nodes%20size%20ifTrue%3A%20%5B%20stream%20nextPutAll%3A%20%27return%20%27%20%5D.%0D%0A%09%20%20%20%20rec%20%3A%3D%20VariableNode%20new.%0D%0A%09%20%20%20%20rec%20value%3A%20%27%24rec%27%3B%20start%3A%20each%20start%20end%3A%20each%20start.%0D%0A%09%20%20%20%20each%20receiver%3A%20rec.%0D%0A%09%20%20%20%20self%20visit%3A%20each.%0D%0A%09%20%20%20%20stream%20nextPutAll%3A%20%27%3B%27%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%7D%29%28%27.%0D%0A%09self%20visit%3A%20aNode%20receiver.%0D%0A%09stream%20nextPutAll%3A%20%27%29%27"));

smalltalk.bind(smalltalk.Compiler,"visitValueNode:","visitValueNode_"

,function (aNode){var self=this;self['@stream'].nextPutAll_(aNode.value().asJavascript());return self;}

,"visiting",unescape("visitValueNode%3A%20aNode%0D%0A%09stream%20nextPutAll%3A%20aNode%20value%20asJavascript"));

smalltalk.bind(smalltalk.Compiler,"visitJSStatementNode:","visitJSStatementNode_"

,function (aNode){var self=this;self['@stream'].nextPutAll_(aNode.source().value().replace_with_(unescape("%27%27"), unescape("%27")));return self;}

,"visiting",unescape("visitJSStatementNode%3A%20aNode%0D%0A%09stream%20nextPutAll%3A%20%28aNode%20source%20value%20replace%3A%20%27%27%27%27%27%27%20with%3A%20%27%27%27%27%29"));

smalltalk.bind(smalltalk.Compiler,"visitMacroAssignment:","visitMacroAssignment_"

,function (aNode){var self=this;return aNode.left().acceptMacroAssignment_with_(aNode.right(), self);return self;}

,"visiting",unescape("visitMacroAssignment%3A%20aNode%0D%0A%09%5EaNode%20left%20acceptMacroAssignment%3A%20aNode%20right%20with%3A%20self"));

smalltalk.bind(smalltalk.Compiler,"visitAssignmentNode:","visitAssignmentNode_"

,function (aNode){var self=this;try{((self.visitMacroAssignment_(aNode)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitAssignmentNode_", fn: function(){return self}})})();})() : nil);

self.visit_(aNode.left());

self['@stream'].nextPutAll_(unescape("%3D"));

self.visit_(aNode.right());return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitAssignmentNode_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitAssignmentNode%3A%20aNode%0D%0A%0D%0A%09%28self%20visitMacroAssignment%3A%20aNode%29%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09self%20visit%3A%20aNode%20left.%0D%0A%09stream%20nextPutAll%3A%20%27%3D%27.%0D%0A%09self%20visit%3A%20aNode%20right."));

smalltalk.bind(smalltalk.Compiler,"visitClassVariableAssignment:in:to:","visitClassVariableAssignment_in_to_"

,function (aClassVariableName,aClass,anExpressionNode){var self=this;(function($rec){$rec.nextPutAll_(self.smalltalkNameFor_(aClass));$rec.nextPutAll_(unescape(".classVariableAt_put_%28%22"));$rec.nextPutAll_(aClassVariableName);return $rec.nextPutAll_(unescape("%22%2C"));})(self['@stream']);

self.visit_(anExpressionNode);

self['@stream'].nextPutAll_(unescape("%29"));return self;}

,"visiting",unescape("visitClassVariableAssignment%3A%20aClassVariableName%20in%3A%20aClass%20to%3A%20anExpressionNode%0D%0A%0D%0A%09stream%0D%0A%09%09nextPutAll%3A%20%28self%20smalltalkNameFor%3A%20aClass%29%3B%0D%0A%09%09nextPutAll%3A%20%27.classVariableAt_put_%28%22%27%3B%0D%0A%09%09nextPutAll%3A%20aClassVariableName%3B%20nextPutAll%3A%20%27%22%2C%27.%0D%0A%09self%20visit%3A%20anExpressionNode.%0D%0A%09stream%09nextPutAll%3A%20%27%29%27"));

smalltalk.bind(smalltalk.Compiler,"visitPoolVariableAssignment:in:to:","visitPoolVariableAssignment_in_to_"

,function (aName,poolName,anExpressionNode){var self=this;(function($rec){$rec.nextPutAll_(unescape("smalltalk.poolDictionary_%28%22"));$rec.nextPutAll_(poolName);$rec.nextPutAll_(unescape("%22%29.at_put_%28%22"));$rec.nextPutAll_(aName);return $rec.nextPutAll_(unescape("%22%2C"));})(self['@stream']);

self.visit_(anExpressionNode);

self['@stream'].nextPutAll_(unescape("%29"));return self;}

,"visiting",unescape("visitPoolVariableAssignment%3A%20aName%20in%3A%20poolName%20to%3A%20anExpressionNode%0D%0A%0D%0A%09stream%0D%0A%09%09nextPutAll%3A%20%27smalltalk.poolDictionary_%28%22%27%3B%0D%0A%09%09nextPutAll%3A%20poolName%3B%20nextPutAll%3A%20%27%22%29.at_put_%28%22%27%3B%0D%0A%09%09nextPutAll%3A%20aName%3B%20nextPutAll%3A%20%27%22%2C%27.%0D%0A%09self%20visit%3A%20anExpressionNode.%0D%0A%09stream%09nextPutAll%3A%20%27%29%27"));

smalltalk.bind(smalltalk.Compiler,"visitMacroAssignment:to:","visitMacroAssignment_to_"

,function (aVariableNode,anExpressionNode){var self=this;try{var aName=nil;var aClass=nil;((aVariableNode.indices().notEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "visitMacroAssignment_to_", fn: function(){return false}})})();})() : nil);

aName=aVariableNode.value();

aClass=self.currentClass().instanceClass();

aClass.classVariableNamesDo_((function(each){return ((each._eq(aName)).mustBeBoolean()==true ? (function(){self.visitClassVariableAssignment_in_to_(each, aClass, anExpressionNode);return (function(){throw({name: "stReturn", selector: "visitMacroAssignment_to_", fn: function(){return true}})})();})() : nil);}));

aClass.sharedPoolsAndNamesDo_((function(poolName, pool){return ((pool.includesKey_(aName)).mustBeBoolean()==true ? (function(){self.visitPoolVariableAssignment_in_to_(aName, poolName, anExpressionNode);return (function(){throw({name: "stReturn", selector: "visitMacroAssignment_to_", fn: function(){return true}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "visitMacroAssignment_to_", fn: function(){return false}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitMacroAssignment_to_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitMacroAssignment%3A%20aVariableNode%20to%3A%20anExpressionNode%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20generated%20code%20to%20a%20macro%20assignment%20to%20aVariableNode.%20%22%0D%0A%0D%0A%09%7C%20aName%20aClass%20%7C%0D%0A%09aVariableNode%20indices%20notEmpty%20ifTrue%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09aName%20%3A%3D%20aVariableNode%20value.%0D%0A%09aClass%20%3A%3D%20self%20currentClass%20instanceClass.%0D%0A%09aClass%20classVariableNamesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20%3D%20aName%20ifTrue%3A%20%5B%0D%0A%09%09%09self%20visitClassVariableAssignment%3A%20each%0D%0A%09%09%09%09in%3A%20aClass%0D%0A%09%09%09%09to%3A%20anExpressionNode.%0D%0A%09%09%09%5Etrue%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09aClass%20sharedPoolsAndNamesDo%3A%20%5B%3ApoolName%20%3Apool%7C%0D%0A%09%09%28pool%20includesKey%3A%20aName%29%20ifTrue%3A%20%5B%0D%0A%09%09%09self%20visitPoolVariableAssignment%3A%20aName%0D%0A%09%09%09%09in%3A%20poolName%0D%0A%09%09%09%09to%3A%20anExpressionNode.%0D%0A%09%09%09%5Etrue%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.Compiler,"codeToAccessProperty:","codeToAccessProperty_"

,function (aName){var self=this;return unescape("self%5B%27")._comma(aName)._comma(unescape("%27%5D"));return self;}

,"generation",unescape("codeToAccessProperty%3A%20aName%0D%0A%09%22%20Private%20-%20Return%20the%20source%20code%20to%20access%20property%20aName.%20%22%0D%0A%0D%0A%09%5E%27self%5B%27%27%27%2CaName%2C%27%27%27%5D%27"));

smalltalk.bind(smalltalk.Compiler,"codeToAccessInstanceVariable:","codeToAccessInstanceVariable_"

,function (aName){var self=this;return self.codeToAccessProperty_(unescape("@")._comma(aName));return self;}

,"generation",unescape("codeToAccessInstanceVariable%3A%20aName%0D%0A%09%22%20Private%20-%20Return%20the%20source%20code%20to%20access%20instance%20variable%20aName.%20%22%0D%0A%0D%0A%09%5Eself%20codeToAccessProperty%3A%20%27@%27%2C%20aName"));

smalltalk.bind(smalltalk.Compiler,"visitNode:index:","visitNode_index_"

,function (aNode,index){var self=this;try{var selector=nil;((index.isMemberOf_(smalltalk.ValueNode).and_((function(){return index.hasString();}))).mustBeBoolean()==true ? (function(){selector=index.value().asSelector();return ((selector.includes_(" ").or_((function(){return selector.includes_("_");}))).mustBeBoolean()==true ? nil : (function(){(function($rec){$rec.nextPutAll_(".");return $rec.nextPutAll_(selector);})(self['@stream']);return (function(){throw({name: "stReturn", selector: "visitNode_index_", fn: function(){return self}})})();})());})() : nil);

self['@stream'].nextPutAll_(unescape("%5B"));

self.visit_(index);

self['@stream'].nextPutAll_(unescape("%5D"));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "visitNode_index_"){return $$ex.fn();} throw($$ex);}}

,"visiting",unescape("visitNode%3A%20aNode%20index%3A%20index%0D%0A%09%22%20Private%20-%20Generate%20code%20for%20direct%20property%20access.%20%22%0D%0A%0D%0A%09%7C%20selector%20%7C%0D%0A%09%28%28index%20isMemberOf%3A%20ValueNode%29%20and%3A%20%5B%20index%20hasString%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09selector%20%3A%3D%20index%20value%20asSelector.%0D%0A%09%09%28%28selector%20includes%3A%20%24%20%29%20or%3A%20%5B%20selector%20includes%3A%20%24_%20%5D%29%20ifFalse%3A%20%5B%0D%0A%09%09%09stream%20nextPutAll%3A%20%27.%27%3B%20nextPutAll%3A%20selector.%0D%0A%09%09%09%5Eself%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09stream%20nextPutAll%3A%20%27%5B%27.%0D%0A%09self%20visit%3A%20index.%0D%0A%09stream%20nextPutAll%3A%20%27%5D%27."));

smalltalk.bind(smalltalk.Compiler,"visitNodeIndices:","visitNodeIndices_"

,function (aNode){var self=this;aNode.indices().do_((function(each){return self.visitNode_index_(aNode, each);}));return self;}

,"visiting",unescape("visitNodeIndices%3A%20aNode%0D%0A%09%22%20Private%20-%20Generate%20code%20for%20direct%20property%20access.%20%22%0D%0A%0D%0A%09aNode%20indices%20do%3A%20%5B%3Aeach%7C%20self%20visitNode%3A%20aNode%20index%3A%20each%20%5D."));

smalltalk.bind(smalltalk.Compiler,"visitVariableNode:","visitVariableNode_"

,function (aNode){var self=this;var code=nil;code=self.currentClass().codeFor_accessing_(self, aNode);

((((code || nil) !== nil)).mustBeBoolean()==true ? (function(){return self['@stream'].nextPutAll_(code);})() : (function(){((aNode.needsVerification()).mustBeBoolean()==true ? (function(){return ((self.knownVariables().includes_(aNode.value())).mustBeBoolean()==true ? nil : (function(){self.print_(unescape("//%3E%3E%3E%20Unknown%20variable%3A%20")._comma(aNode.value().asString()));self.triggerEvent_with_("unknownVariable:", aNode);return self['@unknownVariables'].add_(aNode.value());})());})() : nil);return self['@stream'].nextPutAll_(aNode.localNameIn_(self));})());

self.visitNodeIndices_(aNode);return self;}

,"visiting",unescape("visitVariableNode%3A%20aNode%0D%0A%09%22%20Generate%20code%20to%20access%20variable%20aNode.%20%22%0D%0A%0D%0A%09%7C%20code%20%7C%0D%0A%09code%20%3A%3D%20self%20currentClass%20codeFor%3A%20self%20accessing%3A%20aNode.%0D%0A%09code%20notNil%0D%0A%09ifTrue%3A%20%5B%20stream%20nextPutAll%3A%20code%20%5D%0D%0A%09ifFalse%3A%20%5B%0D%0A%09%09aNode%20needsVerification%20ifTrue%3A%20%5B%0D%0A%09%09%09%28self%20knownVariables%20includes%3A%20aNode%20value%29%20ifFalse%3A%20%5B%0D%0Aself%20print%3A%20%27//%3E%3E%3E%20Unknown%20variable%3A%20%27%2CaNode%20value%20asString.%0D%0A%09%09%09%09self%20triggerEvent%3A%20%23unknownVariable%3A%20with%3A%20aNode.%0D%0A%09%09%09%09unknownVariables%20add%3A%20aNode%20value.%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%09stream%20nextPutAll%3A%20%28aNode%20localNameIn%3A%20self%29%0D%0A%09%5D.%0D%0A%09self%20visitNodeIndices%3A%20aNode."));

smalltalk.bind(smalltalk.Compiler,"unknownVariables","unknownVariables"

,function (){var self=this;return self['@unknownVariables'];return self;}

,"accessing",unescape("unknownVariables%0D%0A%09%5EunknownVariables"));

smalltalk.bind(smalltalk.Compiler,"pseudoVariables","pseudoVariables"

,function (){var self=this;return ["self", "super", "true", "false", "nil", "thisContext"];return self;}

,"accessing",unescape("pseudoVariables%0D%0A%09%5E%23%28%27self%27%20%27super%27%20%27true%27%20%27false%27%20%27nil%27%20%27thisContext%27%29"));

smalltalk.bind(smalltalk.Compiler,"tempVariables","tempVariables"

,function (){var self=this;return self['@tempVariables'];return self;}

,"accessing",unescape("tempVariables%0D%0A%09%5EtempVariables%20%22copy%22"));

smalltalk.bind(smalltalk.Compiler,"knownVariables","knownVariables"

,function (){var self=this;return self.pseudoVariables()._comma(self.tempVariables());return self;}

,"accessing",unescape("knownVariables%0D%0A%09%5Eself%20pseudoVariables%20%2C%20self%20tempVariables"));

smalltalk.bind(smalltalk.Compiler,"evaluate:","evaluate_"

,function (smalltalkExpression){var self=this;var node=nil;var jsCode=nil;self.currentClass_(smalltalk.DoIt);

node=self.parseCode_(unescape("doIt%20%5E%5B")._comma(smalltalkExpression)._comma(unescape("%5D%20value")));

jsCode=self.compileNode_(node);

smalltalk.DoIt.addCompiledMethod_(self.eval_(jsCode));

return smalltalk.DoIt.$$new().doIt();return self;}

,"doIt",unescape("evaluate%3A%20smalltalkExpression%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20smalltalk%20expression%20in%20global%20context.%20%22%0D%0A%0D%0A%09%7C%20node%20jsCode%20%7C%0D%0A%09self%20currentClass%3A%20DoIt.%0D%0A%09node%20%3A%3D%20self%20parseCode%3A%20%27doIt%20%5E%5B%27%2C%20smalltalkExpression%2C%20%27%5D%20value%27.%0D%0A%09jsCode%20%3A%3D%20self%20compileNode%3A%20node.%0D%0A%09DoIt%20addCompiledMethod%3A%20%28self%20eval%3A%20jsCode%29.%0D%0A%09%5EDoIt%20new%20doIt"));

smalltalk.bind(smalltalk.Compiler,"doItSelectorFor:","doItSelectorFor_"

,function (anObject){var self=this;try{(((((anObject["doIt"] || nil) || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "doItSelectorFor_", fn: function(){return "doIt"}})})();})() : nil);

(1).to_do_((100), (function(i){var doIt=nil;doIt="doIt"._comma(i.asString());return (((((anObject[doIt] || nil) || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "doItSelectorFor_", fn: function(){return doIt}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "doItSelectorFor_", fn: function(){return "doIt"}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "doItSelectorFor_"){return $$ex.fn();} throw($$ex);}}

,"evaluation",unescape("doItSelectorFor%3A%20anObject%0D%0A%09%22%20Private%20-%20Return%20the%20doit%20selector%20to%20use%20for%20anObject.%20%22%0D%0A%0D%0A%09%28anObject%20basicAt%3A%20%23doIt%29%20isNil%20ifTrue%3A%20%5B%20%5E%23doIt%20%5D.%0D%0A%091%20to%3A%20100%20do%3A%20%5B%3Ai%7C%20%7C%20doIt%20%7C%0D%0A%09%09doIt%20%3A%3D%20%23doIt%20%2C%20i%20asString.%0D%0A%09%09%28anObject%20basicAt%3A%20doIt%29%20isNil%20ifTrue%3A%20%5B%20%5EdoIt%20%5D.%0D%0A%09%5D.%0D%0A%09%5E%23doIt"));

smalltalk.bind(smalltalk.Compiler,"evaluate:in:to:","evaluate_in_to_"

,function (smalltalkExpression,aClass,aReceiver){var self=this;var result=nil;var doIt=nil;var node=nil;var jsCode=nil;doIt=self.doItSelectorFor_(aReceiver);

self.currentClass_(aClass);

node=self.parseCode_(doIt._comma(unescape("%20%5E%5B"))._comma(smalltalkExpression)._comma(unescape("%5D%20value")));

jsCode=self.compileNode_(node);

aClass.addCompiledMethod_(self.eval_(jsCode));

result=aReceiver.perform_(doIt);

aClass.removeSelector_(doIt);

return result;return self;}

,"evaluation",unescape("evaluate%3A%20smalltalkExpression%20in%3A%20aClass%20to%3A%20aReceiver%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20smalltalk%20expression%20with%20aReceiver.%20%22%0D%0A%0D%0A%09%7C%20result%20doIt%20node%20jsCode%20%7C%0D%0A%09doIt%20%3A%3D%20self%20doItSelectorFor%3A%20aReceiver.%0D%0A%09self%20currentClass%3A%20aClass.%0D%0A%09node%20%3A%3D%20self%20parseCode%3A%20doIt%2C%27%20%5E%5B%27%2C%20smalltalkExpression%2C%20%27%5D%20value%27.%0D%0A%09jsCode%20%3A%3D%20self%20compileNode%3A%20node.%0D%0A%09aClass%20addCompiledMethod%3A%20%28self%20eval%3A%20jsCode%29.%0D%0A%09result%20%3A%3D%20aReceiver%20perform%3A%20doIt.%0D%0A%09aClass%20removeSelector%3A%20doIt.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.MethodNode,"selector","selector"

,function (){var self=this;return self['@selector'];return self;}

,"accessing",unescape("selector%0D%0A%09%5Eselector"));

smalltalk.bind(smalltalk.MethodNode,"selector:","selector_"

,function (aString){var self=this;self['@selector']=aString;return self;}

,"accessing",unescape("selector%3A%20aString%0D%0A%09selector%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.MethodNode,"arguments","arguments"

,function (){var self=this;return ((((self['@arguments'] || nil) === nil)).mustBeBoolean()==true ? (function(){return [];})() : (function(){return self['@arguments'];})());return self;}

,"accessing",unescape("arguments%0D%0A%09%5Earguments%20isNil%20ifTrue%3A%20%5B%20%23%28%29%20%5D%20ifFalse%3A%20%5B%20arguments%20%5D"));

smalltalk.bind(smalltalk.MethodNode,"arguments:","arguments_"

,function (aCollection){var self=this;self['@arguments']=aCollection;return self;}

,"accessing",unescape("arguments%3A%20aCollection%0D%0A%09arguments%20%3A%3D%20aCollection"));

smalltalk.bind(smalltalk.MethodNode,"source","source"

,function (){var self=this;return self['@source'];return self;}

,"accessing",unescape("source%0D%0A%09%5Esource"));

smalltalk.bind(smalltalk.MethodNode,"source:","source_"

,function (aString){var self=this;self['@source']=aString;return self;}

,"accessing",unescape("source%3A%20aString%0D%0A%09source%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.MethodNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitMethodNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitMethodNode%3A%20self"));

smalltalk.bind(smalltalk.SendNode,"selector","selector"

,function (){var self=this;return self['@selector'];return self;}

,"accessing",unescape("selector%0D%0A%09%5Eselector"));

smalltalk.bind(smalltalk.SendNode,"selector:","selector_"

,function (aString){var self=this;self['@selector']=aString;return self;}

,"accessing",unescape("selector%3A%20aString%0D%0A%09selector%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.SendNode,"arguments","arguments"

,function (){var self=this;return ((((self['@arguments'] || nil) === nil)).mustBeBoolean()==true ? (function(){return [];})() : (function(){return self['@arguments'];})());return self;}

,"accessing",unescape("arguments%0D%0A%09%5Earguments%20isNil%20ifTrue%3A%20%5B%20%23%28%29%20%5D%20ifFalse%3A%20%5B%20arguments%20%5D"));

smalltalk.bind(smalltalk.SendNode,"arguments:","arguments_"

,function (aCollection){var self=this;self['@arguments']=aCollection;return self;}

,"accessing",unescape("arguments%3A%20aCollection%0D%0A%09arguments%20%3A%3D%20aCollection"));

smalltalk.bind(smalltalk.SendNode,"receiver","receiver"

,function (){var self=this;return self['@receiver'];return self;}

,"accessing",unescape("receiver%0D%0A%09%5Ereceiver"));

smalltalk.bind(smalltalk.SendNode,"receiver:","receiver_"

,function (aNode){var self=this;self['@receiver']=aNode;return self;}

,"accessing",unescape("receiver%3A%20aNode%0D%0A%09receiver%20%3A%3D%20aNode"));

smalltalk.bind(smalltalk.SendNode,"valueForReceiver:","valueForReceiver_"

,function (anObject){var self=this;return (function($rec){$rec.receiver_(((((self.receiver() || nil) === nil)).mustBeBoolean()==true ? (function(){return anObject;})() : (function(){return self.receiver().valueForReceiver_(anObject);})()));$rec.selector_(self.selector());$rec.arguments_(self.arguments());$rec.start_end_(self.start(), self.end());return $rec.yourself();})(smalltalk.SendNode.$$new());return self;}

,"accessing",unescape("valueForReceiver%3A%20anObject%0D%0A%09%5ESendNode%20new%0D%0A%09%20%20%20%20receiver%3A%20%28self%20receiver%20isNil%20ifTrue%3A%20%5BanObject%5D%0D%0A%09%09ifFalse%3A%20%5Bself%20receiver%20valueForReceiver%3A%20anObject%5D%29%3B%0D%0A%09%20%20%20%20selector%3A%20self%20selector%3B%0D%0A%09%20%20%20%20arguments%3A%20self%20arguments%3B%0D%0A%09%20%20%20%20start%3A%20self%20start%20end%3A%20self%20end%3B%0D%0A%09%20%20%20%20yourself"));

smalltalk.bind(smalltalk.SendNode,"cascadeNodeWithMessages:","cascadeNodeWithMessages_"

,function (aCollection){var self=this;var first=nil;var sends=nil;first=(function($rec){$rec.selector_(self.selector());$rec.arguments_(self.arguments());$rec.start_end_(self.start(), self.end());return $rec.yourself();})(smalltalk.SendNode.$$new());

sends=smalltalk.Array.with_(first)._comma(aCollection);

return (function($rec){$rec.receiver_(self.receiver());$rec.nodes_(sends);$rec.start_end_(sends.first().start(), sends.last().end());return $rec.yourself();})(smalltalk.CascadeNode.$$new());return self;}

,"accessing",unescape("cascadeNodeWithMessages%3A%20aCollection%0D%0A%09%7C%20first%20sends%20%7C%0D%0A%09first%20%3A%3D%20SendNode%20new%0D%0A%09%20%20%20%20selector%3A%20self%20selector%3B%0D%0A%09%20%20%20%20arguments%3A%20self%20arguments%3B%0D%0A%09%20%20%20%20start%3A%20self%20start%20end%3A%20self%20end%3B%0D%0A%09%20%20%20%20yourself.%0D%0A%09sends%20%3A%3D%20%28Array%20with%3A%20first%29%2C%20aCollection.%0D%0A%09%5ECascadeNode%20new%0D%0A%09%20%20%20%20receiver%3A%20self%20receiver%3B%0D%0A%09%20%20%20%20nodes%3A%20sends%3B%0D%0A%09%20%20%20%20start%3A%20sends%20first%20start%20end%3A%20sends%20last%20end%3B%0D%0A%09%20%20%20%20yourself"));

smalltalk.bind(smalltalk.SendNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitSendNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitSendNode%3A%20self"));

smalltalk.bind(smalltalk.CascadeNode,"receiver","receiver"

,function (){var self=this;return self['@receiver'];return self;}

,"accessing",unescape("receiver%0D%0A%09%5Ereceiver"));

smalltalk.bind(smalltalk.CascadeNode,"receiver:","receiver_"

,function (aNode){var self=this;self['@receiver']=aNode;return self;}

,"accessing",unescape("receiver%3A%20aNode%0D%0A%09receiver%20%3A%3D%20aNode"));

smalltalk.bind(smalltalk.CascadeNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitCascadeNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitCascadeNode%3A%20self"));

smalltalk.bind(smalltalk.AssignmentNode,"left","left"

,function (){var self=this;return self['@left'];return self;}

,"accessing",unescape("left%0D%0A%09%5Eleft"));

smalltalk.bind(smalltalk.AssignmentNode,"left:","left_"

,function (aNode){var self=this;self['@left']=aNode;return self;}

,"accessing",unescape("left%3A%20aNode%0D%0A%09left%20%3A%3D%20aNode"));

smalltalk.bind(smalltalk.AssignmentNode,"right","right"

,function (){var self=this;return self['@right'];return self;}

,"accessing",unescape("right%0D%0A%09%5Eright"));

smalltalk.bind(smalltalk.AssignmentNode,"right:","right_"

,function (aNode){var self=this;self['@right']=aNode;return self;}

,"accessing",unescape("right%3A%20aNode%0D%0A%09right%20%3A%3D%20aNode"));

smalltalk.bind(smalltalk.AssignmentNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitAssignmentNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitAssignmentNode%3A%20self"));

smalltalk.bind(smalltalk.AssignmentNode,"isAssignment","isAssignment"

,function (){var self=this;return true;return self;}

,"testing",unescape("isAssignment%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20an%20assignment%20node.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.BlockNode,"parameters","parameters"

,function (){var self=this;((((self['@parameters'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@parameters']=smalltalk.Array.$$new();})() : nil);

return self['@parameters'];return self;}

,"accessing",unescape("parameters%0D%0A%09parameters%20isNil%20ifTrue%3A%20%5B%20parameters%20%3A%3D%20Array%20new%20%5D.%0D%0A%09%5Eparameters"));

smalltalk.bind(smalltalk.BlockNode,"parameters:","parameters_"

,function (aCollection){var self=this;self['@parameters']=aCollection;return self;}

,"accessing",unescape("parameters%3A%20aCollection%0D%0A%09parameters%20%3A%3D%20aCollection"));

smalltalk.bind(smalltalk.BlockNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitBlockNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitBlockNode%3A%20self"));

smalltalk.bind(smalltalk.BlockNode,"bindings","bindings"

,function (){var self=this;return self.parameters();return self;}

,"bindings",unescape("bindings%0D%0A%09%22%20Return%20the%20bindings%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20parameters"));

smalltalk.bind(smalltalk.SequenceNode,"temps","temps"

,function (){var self=this;return ((((self['@temps'] || nil) === nil)).mustBeBoolean()==true ? (function(){return [];})() : (function(){return self['@temps'];})());return self;}

,"accessing",unescape("temps%0D%0A%09%5Etemps%20isNil%20ifTrue%3A%20%5B%20%23%28%29%20%5D%20ifFalse%3A%20%5B%20temps%20%5D"));

smalltalk.bind(smalltalk.SequenceNode,"temps:","temps_"

,function (aCollection){var self=this;self['@temps']=aCollection;return self;}

,"accessing",unescape("temps%3A%20aCollection%0D%0A%09temps%20%3A%3D%20aCollection"));

smalltalk.bind(smalltalk.SequenceNode,"asBlockSequenceNode","asBlockSequenceNode"

,function (){var self=this;return (function($rec){$rec.nodes_(self.nodes());$rec.temps_(self.temps());$rec.start_end_(self.start(), self.end());return $rec.yourself();})(smalltalk.BlockSequenceNode.$$new());return self;}

,"converting",unescape("asBlockSequenceNode%0D%0A%09%5EBlockSequenceNode%20new%0D%0A%09%20%20%20%20nodes%3A%20self%20nodes%3B%0D%0A%09%20%20%20%20temps%3A%20self%20temps%3B%0D%0A%09%20%20%20%20start%3A%20self%20start%20end%3A%20self%20end%3B%0D%0A%09%20%20%20%20yourself"));

smalltalk.bind(smalltalk.SequenceNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitSequenceNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitSequenceNode%3A%20self"));

smalltalk.bind(smalltalk.SequenceNode,"bindings","bindings"

,function (){var self=this;return self.temps();return self;}

,"bindings",unescape("bindings%0D%0A%09%22%20Return%20the%20bindings%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20temps"));

smalltalk.bind(smalltalk.ReturnNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitReturnNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitReturnNode%3A%20self"));

smalltalk.bind(smalltalk.ValueNode,"value","value"

,function (){var self=this;return self['@value'];return self;}

,"accessing",unescape("value%0D%0A%09%5Evalue"));

smalltalk.bind(smalltalk.ValueNode,"value:","value_"

,function (anObject){var self=this;self['@value']=anObject;return self;}

,"accessing",unescape("value%3A%20anObject%0D%0A%09value%20%3A%3D%20anObject"));

smalltalk.bind(smalltalk.ValueNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitValueNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitValueNode%3A%20self"));

smalltalk.bind(smalltalk.ValueNode,"hasNumber","hasNumber"

,function (){var self=this;return self['@value'].isNumber();return self;}

,"testing",unescape("hasNumber%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20has%20a%20numeric%20literal%20value.%20%22%0D%0A%0D%0A%09%5Evalue%20isNumber"));

smalltalk.bind(smalltalk.ValueNode,"hasString","hasString"

,function (){var self=this;return self['@value'].isString();return self;}

,"testing",unescape("hasString%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20has%20a%20string%20literal%20value.%20%22%0D%0A%0D%0A%09%5Evalue%20isString"));

smalltalk.bind(smalltalk.JSStatementNode,"source","source"

,function (){var self=this;try{((((self['@source'] || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "source", fn: function(){return ""}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "source", fn: function(){return self['@source']}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "source"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("source%0D%0A%09source%20isNil%20ifTrue%3A%20%5B%20%5E%27%27%20%5D.%0D%0A%09%5Esource"));

smalltalk.bind(smalltalk.JSStatementNode,"source:","source_"

,function (aString){var self=this;self['@source']=aString;return self;}

,"accessing",unescape("source%3A%20aString%0D%0A%09source%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.JSStatementNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitJSStatementNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitJSStatementNode%3A%20self"));

smalltalk.bind(smalltalk.BlockSequenceNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitBlockSequenceNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitBlockSequenceNode%3A%20self"));

smalltalk.bind(smalltalk.ExtendedSequenceNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitExtendedSequenceNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09%22%20Accept%20aVisitor.%20%22%0D%0A%0D%0A%09aVisitor%20visitExtendedSequenceNode%3A%20self"));

smalltalk.bind(smalltalk.ExtendedSequenceNode,"directive","directive"

,function (){var self=this;return self['@directive'];return self;}

,"accessing",unescape("directive%0D%0A%09%22%20Return%20the%20directive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Edirective"));

smalltalk.bind(smalltalk.ExtendedSequenceNode,"directive:","directive_"

,function (aDirective){var self=this;self['@directive']=aDirective;return self;}

,"accessing",unescape("directive%3A%20aDirective%0D%0A%09%22%20Set%20the%20directive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09directive%20%3A%3D%20aDirective"));

smalltalk.bind(smalltalk.VariableNode,"localNameIn:","localNameIn_"

,function (aCompiler){var self=this;return aCompiler.localName_(self.value());return self;}

,"accessing",unescape("localNameIn%3A%20aCompiler%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver%20to%20be%20used%20by%20aCompiler%20locally.%20%22%0D%0A%0D%0A%09%5EaCompiler%20localName%3A%20self%20value%20"));

smalltalk.bind(smalltalk.VariableNode,"needsVerification","needsVerification"

,function (){var self=this;return false;return self;}

,"testing",unescape("needsVerification%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20need%20verification.%20%22%0D%0A%0D%0A%09%5Efalse"));

smalltalk.bind(smalltalk.VariableNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitVariableNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitVariableNode%3A%20self"));

smalltalk.bind(smalltalk.VariableNode,"isSuper","isSuper"

,function (){var self=this;return self['@value']._eq("super");return self;}

,"testing",unescape("isSuper%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20super.%20%22%0D%0A%0D%0A%09%5Evalue%20%3D%20%27super%27"));

smalltalk.bind(smalltalk.VariableNode,"indices","indices"

,function (){var self=this;return ((((self['@indices'] || nil) === nil)).mustBeBoolean()==true ? (function(){return smalltalk.Array.$$new();})() : (function(){return self['@indices'];})());return self;}

,"accessing",unescape("indices%0D%0A%09%22%20Return%20the%20indexing%20references%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eindices%20isNil%20ifTrue%3A%20%5B%20Array%20new%20%5D%20ifFalse%3A%20%5B%20indices%20%5D"));

smalltalk.bind(smalltalk.VariableNode,"indexedAs:","indexedAs_"

,function (chain){var self=this;self['@indices']=(((chain.size() > (1)).and_((function(){return chain.second().notEmpty();}))).mustBeBoolean()==true ? (function(){return chain.second().collect_((function(tuple){return ((tuple.second().isString()).mustBeBoolean()==true ? (function(){return smalltalk.ValueNode.$$new().value_(tuple.second());})() : (function(){return tuple.second();})());}));})() : nil);

return self;return self;}

,"visiting",unescape("indexedAs%3A%20chain%0D%0A%09%22%20The%20receiver%20has%20indexing%20references%20defined%20by%20chain.%20%22%0D%0A%0D%0A%09indices%20%3A%3D%20%28chain%20size%20%3E%201%20and%3A%20%5B%20chain%20second%20notEmpty%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09chain%20second%20collect%3A%20%5B%3Atuple%7C%0D%0A%09%09%09tuple%20second%20isString%0D%0A%09%09%09ifTrue%3A%20%5B%20ValueNode%20new%20value%3A%20tuple%20second%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20tuple%20second%20%5D%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09%22self%20print%3A%20%27-%27%2Cself%20value%20asString%2C%27-%3E%3E-indices%3D%27%2C%20self%20indices%20asString.%22%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.GlobalReferenceNode,"accept:","accept_"

,function (aVisitor){var self=this;aVisitor.visitGlobalReferenceNode_(self);return self;}

,"visiting",unescape("accept%3A%20aVisitor%0D%0A%09aVisitor%20visitGlobalReferenceNode%3A%20self"));

smalltalk.bind(smalltalk.NoReceiverNode,"accept:","accept_"

,function (aVisitor){var self=this;return self;}

,"visiting",unescape("accept%3A%20aVisitor"));

smalltalk.bind(smalltalk.NoReceiverNode,"messageSendConnector","messageSendConnector"

,function (){var self=this;return smalltalk.String.$$new();return self;}

,"accessing",unescape("messageSendConnector%0D%0A%09%22%20Return%20the%20binder%20used%20to%20send%20message%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EString%20new"));

smalltalk.bind(smalltalk.AlienNode,"localNameIn:","localNameIn_"

,function (aCompiler){var self=this;return self.value();return self;}

,"accessing",unescape("localNameIn%3A%20aCompiler%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver%20to%20be%20used%20by%20aCompiler%20locally.%20%22%0D%0A%0D%0A%09%5Eself%20value%20"));

smalltalk.bind(smalltalk.PPEOFParser,"parse:","parse_"

,function (aStream){var self=this;try{((aStream.atEnd()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return nil}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return smalltalk.PPFailure.reason_at_("EOF expected", aStream.position())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09aStream%20atEnd%20ifTrue%3A%20%5B%20%5Enil%20%5D%20.%0D%0A%09%5EPPFailure%20reason%3A%20%27EOF%20expected%27%20at%3A%20aStream%20position"));

smalltalk.bind(smalltalk.PPAnyParser,"parse:","parse_"

,function (aStream){var self=this;try{((aStream.atEnd()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return aStream.next()}})})();})());

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return smalltalk.PPFailure.reason_at_("End of stream", aStream.position())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09aStream%20atEnd%20ifFalse%3A%20%5B%20%5EaStream%20next%20%5D.%0D%0A%09%5EPPFailure%20reason%3A%20%27End%20of%20stream%27%20at%3A%20aStream%20position"));

smalltalk.bind(smalltalk.PPEpsilonParser,"parse:","parse_"

,function (aStream){var self=this;return nil;return self;}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.PPStringParser,"string","string"

,function (){var self=this;return self['@string'];return self;}

,"accessing",unescape("string%0D%0A%09%22%20Return%20the%20string%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Estring"));

smalltalk.bind(smalltalk.PPStringParser,"string:","string_"

,function (aString){var self=this;self['@string']=aString;return self;}

,"accessing",unescape("string%3A%20aString%0D%0A%09%22%20Set%20the%20string%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09string%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.PPStringParser,"parse:","parse_"

,function (aStream){var self=this;try{var position=nil;var result=nil;position=aStream.position();

result=aStream.next_(self.string().size());

((result._eq(self.string())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return result}})})();})() : nil);

aStream.position_(position);

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return smalltalk.PPFailure.reason_at_("Expected "._comma(self.string())._comma(" but got ")._comma(result.printString()), position)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20position%20result%20%7C%0D%0A%09position%20%3A%3D%20aStream%20position.%0D%0A%09result%20%3A%3D%20aStream%20next%3A%20self%20string%20size.%0D%0A%09result%20%3D%20self%20string%20ifTrue%3A%20%5B%20%5Eresult%20%5D.%0D%0A%09aStream%20position%3A%20position.%0D%0A%09%5EPPFailure%0D%0A%09%09reason%3A%20%27Expected%20%27%2C%20self%20string%0D%0A%09%09%09%2C%27%20but%20got%20%27%2C%20result%20printString%0D%0A%09%09at%3A%20position"));

smalltalk.bind(smalltalk.PPStStringParser,"parse:","parse_"

,function (aStream){var self=this;try{var position=nil;var result=nil;position=aStream.position();

result="";

(function(){while(!(function(){result=result._comma(aStream.upTo_(unescape("%27")));return aStream.atEnd();})()){(function(){((aStream.peek()._eq(unescape("%27"))).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return result}})})();})());return result=result._comma(aStream.next());})()};return nil})();

((aStream.position()._gt(position)).mustBeBoolean()==true ? (function(){aStream.position_((aStream.position() - (1)));return ((aStream.next()._eq(unescape("%27"))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return result}})})();})() : nil);})() : nil);

aStream.position_(position);

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return smalltalk.PPFailure.reason_at_("Unfinished String", position)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20position%20result%20%7C%0D%0A%09position%20%3A%3D%20aStream%20position.%0D%0A%09result%20%3A%3D%20%27%27.%0D%0A%09%5B%20result%20%3A%3D%20result%20%2C%20%28aStream%20upTo%3A%20%24%27%29.%0D%0A%09%20%20aStream%20atEnd%20%5D%20whileFalse%3A%20%5B%0D%0A%09%09aStream%20peek%20%3D%20%24%27%20ifFalse%3A%20%5B%20%5Eresult%20%5D.%0D%0A%09%09result%20%3A%3D%20result%20%2CaStream%20next.%0D%0A%09%5D.%0D%0A%09aStream%20position%20%3E%20position%20ifTrue%3A%20%5B%0D%0A%09%09aStream%20position%3A%20aStream%20position%20-%201.%0D%0A%09%09aStream%20next%20%3D%20%24%27%20ifTrue%3A%20%5B%20%5Eresult%20%5D.%0D%0A%09%5D.%0D%0A%09aStream%20position%3A%20position.%0D%0A%09%5EPPFailure%20reason%3A%20%27Unfinished%20String%27%20at%3A%20position"));

smalltalk.bind(smalltalk.PPCharacterParser,"string:","string_"

,function (aString){var self=this;self['@regexp']=smalltalk.RegularExpression.fromString_(unescape("%5B")._comma(aString)._comma(unescape("%5D")));return self;}

,"accessing",unescape("string%3A%20aString%0D%0A%09%22%20Set%20the%20string%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09regexp%20%3A%3D%20RegularExpression%20fromString%3A%20%27%5B%27%2C%20aString%2C%20%27%5D%27"));

smalltalk.bind(smalltalk.PPCharacterParser,"parse:","parse_"

,function (aStream){var self=this;try{((((aStream.peek() || nil) !== nil).and_((function(){return self.match_(aStream.peek());}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return aStream.next()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return smalltalk.PPFailure.reason_at_("Could not match", aStream.position())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%28aStream%20peek%20notNil%0D%0A%09and%3A%20%5B%20self%20match%3A%20aStream%20peek%20%5D%29%0D%0A%09ifTrue%3A%20%5B%20%5EaStream%20next%20%5D.%0D%0A%0D%0A%09%5EPPFailure%20reason%3A%20%27Could%20not%20match%27%20at%3A%20aStream%20position"));

smalltalk.bind(smalltalk.PPCharacterParser,"match:","match_"

,function (aString){var self=this;return aString.match_(self['@regexp']);return self;}

,"private",unescape("match%3A%20aString%0D%0A%09%22%20Match%20the%20receiver%20to%20string.%20%22%0D%0A%0D%0A%09%5EaString%20match%3A%20regexp"));

smalltalk.bind(smalltalk.PPListParser.$klass,"withAll:","withAll_"

,function (aCollection){var self=this;return (function($rec){$rec.parsers_(aCollection);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("withAll%3A%20aCollection%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%20%20%20%20%5Eself%20new%0D%0A%09%09parsers%3A%20aCollection%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.PPListParser.$klass,"with:with:","with_with_"

,function (aParser,anotherParser){var self=this;return self.withAll_(smalltalk.Array.with_with_(aParser, anotherParser));return self;}

,unescape("instance%20creation"),unescape("with%3A%20aParser%20with%3A%20anotherParser%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withAll%3A%20%28Array%20with%3A%20aParser%20with%3A%20anotherParser%29"));

smalltalk.bind(smalltalk.PPListParser,"parsers","parsers"

,function (){var self=this;try{((((self['@parsers'] || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parsers", fn: function(){return []}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "parsers", fn: function(){return self['@parsers']}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parsers"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("parsers%0D%0A%09%22%20Return%20the%20parsers%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09parsers%20isNil%20ifTrue%3A%20%5B%20%5E%23%28%29%20%5D.%0D%0A%09%5Eparsers"));

smalltalk.bind(smalltalk.PPListParser,"parsers:","parsers_"

,function (aCollection){var self=this;self['@parsers']=aCollection.collect_((function(each){return each.asParser();}));return self;}

,"accessing",unescape("parsers%3A%20aCollection%0D%0A%09%22%20Set%20the%20parsers%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09parsers%20%3A%3D%20aCollection%20collect%3A%20%5B%3Aeach%7C%20each%20asParser%20%5D"));

smalltalk.bind(smalltalk.PPListParser,"copyWith:","copyWith_"

,function (aParser){var self=this;return self.$klass.withAll_(self.parsers().copyWith_(aParser));return self;}

,"copying",unescape("copyWith%3A%20aParser%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20aParser.%20%22%0D%0A%0D%0A%09%5Eself%20class%20withAll%3A%20%28self%20parsers%20copyWith%3A%20aParser%29"));

smalltalk.bind(smalltalk.PPDelegateParser.$klass,"on:","on_"

,function (aParser){var self=this;return (function($rec){$rec.parser_(aParser);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("on%3A%20aParser%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%20%20%20%20%5Eself%20new%0D%0A%09%09parser%3A%20aParser%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.PPDelegateParser,"parser","parser"

,function (){var self=this;return self['@parser'];return self;}

,"accessing",unescape("parser%0D%0A%09%22%20Return%20the%20parser%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eparser"));

smalltalk.bind(smalltalk.PPDelegateParser,"parser:","parser_"

,function (aParser){var self=this;self['@parser']=aParser;return self;}

,"accessing",unescape("parser%3A%20aParser%0D%0A%09%22%20Set%20the%20parser%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09parser%20%3A%3D%20aParser"));

smalltalk.bind(smalltalk.PPDelegateParser,"parse:","parse_"

,function (aStream){var self=this;return self.parser().memoizedParse_(aStream);return self;}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%5Eself%20parser%20memoizedParse%3A%20aStream"));

smalltalk.bind(smalltalk.PPSequenceParser,",","_comma"

,function (aRule){var self=this;return self.copyWith_(aRule);return self;}

,"copying",unescape("%2C%20aRule%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20aRule.%20%22%0D%0A%0D%0A%09%5Eself%20copyWith%3A%20aRule"));

smalltalk.bind(smalltalk.PPSequenceParser,"parse:","parse_"

,function (aStream){var self=this;try{var start=nil;var result=nil;var element=nil;start=aStream.position();

result=[];

self.parsers().detect_ifNone_((function(each){element=each.memoizedParse_(aStream);result.add_(element);return element.isParseFailure();}), (function(){return nil;}));

((element.isParseFailure()).mustBeBoolean()==true ? (function(){aStream.position_(start);return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return element}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return result}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20start%20result%20element%20%7C%0D%0A%09start%20%3A%3D%20aStream%20position.%0D%0A%09result%20%3A%3D%20%23%28%29.%0D%0A%09self%20parsers%20detect%3A%20%5B%3Aeach%20%7C%0D%0A%09%09element%20%3A%3D%20each%20memoizedParse%3A%20aStream.%0D%0A%09%09result%20add%3A%20element.%0D%0A%09%09element%20isParseFailure%0D%0A%09%5D%20ifNone%3A%20%5B%5D.%0D%0A%09element%20isParseFailure%20ifTrue%3A%20%5B%0D%0A%09%09aStream%20position%3A%20start.%0D%0A%09%09%5Eelement%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.PPChoiceParser,"/","_slash"

,function (aRule){var self=this;return self.copyWith_(aRule);return self;}

,"copying",unescape("/%20aRule%0D%0A%09%22%20Return%20the%20receiver%20composed%20with%20aRule.%20%22%0D%0A%0D%0A%09%5Eself%20copyWith%3A%20aRule"));

smalltalk.bind(smalltalk.PPChoiceParser,"parse:","parse_"

,function (aStream){var self=this;var result=nil;self.parsers().detect_ifNone_((function(each){result=each.memoizedParse_(aStream);return result.isParseFailure().not();}), (function(){return nil;}));

return result;return self;}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09self%20parsers%20detect%3A%20%5B%3Aeach%20%7C%0D%0A%09%09result%20%3A%3D%20each%20memoizedParse%3A%20aStream.%0D%0A%09%09result%20isParseFailure%20not%0D%0A%09%5D%20ifNone%3A%20%5B%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.PPAndParser,"parse:","parse_"

,function (aStream){var self=this;return self.basicParse_(aStream);return self;}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%5Eself%20basicParse%3A%20aStream"));

smalltalk.bind(smalltalk.PPAndParser,"basicParse:","basicParse_"

,function (aStream){var self=this;var element=nil;var position=nil;position=aStream.position();

element=self.parser().memoizedParse_(aStream);

aStream.position_(position);

return element;return self;}

,"parsing",unescape("basicParse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20element%20position%20%7C%0D%0A%09position%20%3A%3D%20aStream%20position.%0D%0A%09element%20%3A%3D%20self%20parser%20memoizedParse%3A%20aStream.%0D%0A%09aStream%20position%3A%20position.%0D%0A%09%5Eelement"));

smalltalk.bind(smalltalk.PPActionParser.$klass,"on:block:","on_block_"

,function (aParser,aBlock){var self=this;return (function($rec){$rec.parser_(aParser);$rec.block_(aBlock);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("on%3A%20aParser%20block%3A%20aBlock%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09parser%3A%20aParser%3B%0D%0A%09%09block%3A%20aBlock%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.PPActionParser,"block","block"

,function (){var self=this;return self['@block'];return self;}

,"accessing",unescape("block%0D%0A%09%22%20Return%20the%20block%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eblock"));

smalltalk.bind(smalltalk.PPActionParser,"block:","block_"

,function (aBlock){var self=this;self['@block']=aBlock;return self;}

,"accessing",unescape("block%3A%20aBlock%0D%0A%09%22%20Set%20the%20block%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09block%20%3A%3D%20aBlock"));

smalltalk.bind(smalltalk.PPActionParser,"parse:","parse_"

,function (aStream){var self=this;try{var element=nil;element=self.parser().memoizedParse_(aStream);

((element.isParseFailure()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return element}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return self.block().value_(element)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20element%20%7C%0D%0A%09element%20%3A%3D%20self%20parser%20memoizedParse%3A%20aStream.%0D%0A%09element%20isParseFailure%20ifTrue%3A%20%5B%20%5Eelement%20%5D.%0D%0A%09%5Eself%20block%20value%3A%20element"));

smalltalk.bind(smalltalk.PPFlattenParser,"parse:","parse_"

,function (aStream){var self=this;try{var start=nil;var element=nil;start=aStream.position();

element=self.parser().memoizedParse_(aStream);

((element.isParseFailure()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return element}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return aStream.collection().copyFrom_to_((start + (1)), aStream.position())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20start%20element%20%7C%0D%0A%09start%20%3A%3D%20aStream%20position.%0D%0A%09element%20%3A%3D%20self%20parser%20memoizedParse%3A%20aStream.%0D%0A%09element%20isParseFailure%20ifTrue%3A%20%5B%20%5Eelement%20%5D.%0D%0A%09%5EaStream%20collection%20%0D%0A%09%09copyFrom%3A%20start%20+%201%20%0D%0A%09%09to%3A%20aStream%20position"));

smalltalk.bind(smalltalk.PPSourceParser,"parse:","parse_"

,function (aStream){var self=this;try{var start=nil;var element=nil;var result=nil;start=aStream.position();

element=self.parser().memoizedParse_(aStream);

((element.isParseFailure()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return element}})})();})() : nil);

result=aStream.collection().copyFrom_to_((start + (1)), aStream.position());

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return smalltalk.Array.with_with_(element, result)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20start%20element%20result%20%7C%0D%0A%09start%20%3A%3D%20aStream%20position.%0D%0A%09element%20%3A%3D%20self%20parser%20memoizedParse%3A%20aStream.%0D%0A%09element%20isParseFailure%20ifTrue%3A%20%5B%20%5Eelement%20%5D.%0D%0A%09result%20%3A%3D%20aStream%20collection%0D%0A%09%09copyFrom%3A%20start%20+%201%0D%0A%09%09to%3A%20aStream%20position.%0D%0A%09%5EArray%20with%3A%20element%20with%3A%20result"));

smalltalk.bind(smalltalk.PPRepeatingParser.$klass,"on:min:","on_min_"

,function (aParser,aNumber){var self=this;return (function($rec){$rec.parser_(aParser);$rec.min_(aNumber);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("on%3A%20aParser%20min%3A%20aNumber%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09parser%3A%20aParser%3B%0D%0A%09%09min%3A%20aNumber%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.PPRepeatingParser,"min","min"

,function (){var self=this;return self['@min'];return self;}

,"accessing",unescape("min%0D%0A%09%22%20Return%20the%20min%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Emin"));

smalltalk.bind(smalltalk.PPRepeatingParser,"min:","min_"

,function (aNumber){var self=this;self['@min']=aNumber;return self;}

,"accessing",unescape("min%3A%20aNumber%0D%0A%09%22%20Set%20the%20min%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09min%20%3A%3D%20aNumber"));

smalltalk.bind(smalltalk.PPRepeatingParser,"parse:","parse_"

,function (aStream){var self=this;try{var start=nil;var element=nil;var result=nil;var failure=nil;start=aStream.position();

result=smalltalk.Array.$$new();

(function(){while((function(){return result.size()._lt(self.min()).and_((function(){return ((failure || nil) === nil);}));})()){(function(){element=self.parser().memoizedParse_(aStream);return ((element.isParseFailure()).mustBeBoolean()==true ? (function(){aStream.position_(start);return failure=element;})() : (function(){return result.addLast_(element);})());})()};return nil})();

((((failure || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return failure}})})();})() : nil);

(function(){while((function(){return ((failure || nil) === nil);})()){(function(){element=self.parser().memoizedParse_(aStream);return ((element.isParseFailure()).mustBeBoolean()==true ? (function(){return failure=element;})() : (function(){return result.addLast_(element);})());})()};return nil})();

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return result}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20start%20element%20result%20failure%20%7C%0D%0A%09start%20%3A%3D%20aStream%20position.%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09%5B%20%28result%20size%20%3C%20self%20min%29%20and%3A%20%5B%20failure%20isNil%20%5D%0D%0A%09%5D%20whileTrue%3A%20%5B%0D%0A%09%20%20%20%20element%20%3A%3D%20self%20parser%20memoizedParse%3A%20aStream.%0D%0A%09%20%20%20%20element%20isParseFailure%0D%0A%09%09ifFalse%3A%20%5B%20result%20addLast%3A%20element%20%5D%0D%0A%09%09ifTrue%3A%20%5B%20aStream%20position%3A%20start.%0D%0A%09%09%09%20%20failure%20%3A%3D%20element%20%5D%0D%0A%09%5D.%0D%0A%09failure%20notNil%20ifTrue%3A%20%5B%20%5Efailure%20%5D.%0D%0A%09%5Bfailure%20isNil%5D%20whileTrue%3A%20%5B%0D%0A%09%09element%20%3A%3D%20self%20parser%20memoizedParse%3A%20aStream.%0D%0A%09%20%09element%20isParseFailure%0D%0A%09%09%09ifTrue%3A%20%5B%20failure%20%3A%3D%20element%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20result%20addLast%3A%20element%20%5D%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.PPNotParser,"parse:","parse_"

,function (aStream){var self=this;try{var element=nil;element=self.basicParse_(aStream);

((element.isParseFailure()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "parse_", fn: function(){return nil}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "parse_", fn: function(){return smalltalk.PPFailure.reason_at_(element, aStream.position())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "parse_"){return $$ex.fn();} throw($$ex);}}

,"parsing",unescape("parse%3A%20aStream%0D%0A%09%22%20Parse%20contents%20in%20stream.%20%22%0D%0A%0D%0A%09%7C%20element%20%7C%0D%0A%09element%20%3A%3D%20self%20basicParse%3A%20aStream.%0D%0A%09element%20isParseFailure%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09%5EPPFailure%20reason%3A%20element%20at%3A%20aStream%20position"));

smalltalk.bind(smalltalk.ChunkReader.$klass,"doing:until:","doing_until_"

,function (aBlock,terminationBlock){var self=this;return (function($rec){$rec.actionBlock_(aBlock);$rec.terminationBlock_(terminationBlock);return $rec.yourself();})(self.$$new());return self;}

,unescape("instance%20creation"),unescape("doing%3A%20aBlock%20until%3A%20terminationBlock%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%0D%0A%09%09actionBlock%3A%20aBlock%3B%0D%0A%09%09terminationBlock%3A%20terminationBlock%3B%0D%0A%09%09yourself"));

smalltalk.bind(smalltalk.ChunkReader.$klass,"doing:","doing_"

,function (aBlock){var self=this;return self.doing_until_(aBlock, (function(){return true;}));return self;}

,unescape("instance%20creation"),unescape("doing%3A%20aBlock%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20doing%3A%20aBlock%20until%3A%20%5B%20true%20%5D"));

smalltalk.bind(smalltalk.ChunkReader.$klass,"until:","until_"

,function (terminationBlock){var self=this;return self.doing_until_(nil, terminationBlock);return self;}

,unescape("instance%20creation"),unescape("until%3A%20terminationBlock%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20doing%3A%20nil%20until%3A%20terminationBlock"));

smalltalk.bind(smalltalk.ChunkReader.$klass,"ignore","ignore"

,function (){var self=this;return self.$$new();return self;}

,unescape("instance%20creation"),unescape("ignore%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%0D%0A%09The%20returned%20reader%20will%20ignore/absorb%20next%20chunk.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20new"));

smalltalk.bind(smalltalk.ChunkReader.$klass,"javascriptChunk","javascriptChunk"

,function (){var self=this;return self.doing_((function(aStream){return eval(aStream.nextChunk());}));return self;}

,unescape("instance%20creation"),unescape("javascriptChunk%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%0D%0A%09The%20returned%20reader%20will%20evaluate%20next%20chunk%20as%20javascript%20code%20%28in%20global%20context%29.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20doing%3A%20%5B%3AaStream%7C%20%23%20%23eval%3A%20aStream%20nextChunk%20%5D"));

smalltalk.bind(smalltalk.ChunkReader.$klass,"javascript","javascript"

,function (){var self=this;return self.doing_((function(aStream){return eval(aStream.upToEnd());}));return self;}

,unescape("instance%20creation"),unescape("javascript%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%0D%0A%09The%20returned%20reader%20will%20evaluate%20following%20contents%20as%20javascript%20code%20%28in%20global%20context%29.%0D%0A%09The%20stream%20will%20be%20consumed%20up%20to%20end.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20doing%3A%20%5B%3AaStream%7C%20%23%20%23eval%3A%20aStream%20upToEnd%20%5D"));

smalltalk.bind(smalltalk.ChunkReader,"actionBlock","actionBlock"

,function (){var self=this;return self['@actionBlock'];return self;}

,"accessing",unescape("actionBlock%0D%0A%09%22%20Return%20the%20actionBlock%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EactionBlock"));

smalltalk.bind(smalltalk.ChunkReader,"actionBlock:","actionBlock_"

,function (aBlock){var self=this;self['@actionBlock']=aBlock;return self;}

,"accessing",unescape("actionBlock%3A%20aBlock%0D%0A%09%22%20Set%20the%20actionBlock%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09actionBlock%20%3A%3D%20aBlock"));

smalltalk.bind(smalltalk.ChunkReader,"terminationBlock","terminationBlock"

,function (){var self=this;return self['@terminationBlock'];return self;}

,"accessing",unescape("terminationBlock%0D%0A%09%22%20Return%20the%20terminationBlock%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EterminationBlock"));

smalltalk.bind(smalltalk.ChunkReader,"terminationBlock:","terminationBlock_"

,function (aBlock){var self=this;self['@terminationBlock']=aBlock;return self;}

,"accessing",unescape("terminationBlock%3A%20aBlock%0D%0A%09%22%20Set%20the%20terminationBlock%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09terminationBlock%20%3A%3D%20aBlock"));

smalltalk.bind(smalltalk.ChunkReader,"scanFrom:","scanFrom_"

,function (aStream){var self=this;try{var chunk=nil;((((self.actionBlock() || nil) === nil)).mustBeBoolean()==true ? (function(){chunk=aStream.nextChunk();return ((chunk.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "scanFrom_", fn: function(){return nil}})})();})() : nil);})() : (function(){return self.actionBlock().value_(aStream);})());

((((self.terminationBlock() || nil) === nil).or_((function(){return (self.terminationBlock().value() === true);}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "scanFrom_", fn: function(){return nil}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "scanFrom_", fn: function(){return self}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "scanFrom_"){return $$ex.fn();} throw($$ex);}}

,"fileIn",unescape("scanFrom%3A%20aStream%0D%0A%09%22%20Scan%20the%20next%20chunk%20of%20data%20from%20aStream.%20%22%0D%0A%0D%0A%09%7C%20chunk%20%7C%0D%0A%09self%20actionBlock%20isNil%20ifTrue%3A%20%5B%0D%0A%09%09chunk%20%3A%3D%20aStream%20nextChunk.%0D%0A%09%09chunk%20isEmpty%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09%5D%20ifFalse%3A%20%5B%20self%20actionBlock%20value%3A%20aStream%20%5D.%0D%0A%09%28self%20terminationBlock%20isNil%0D%0A%09%09or%3A%20%5B%20self%20terminationBlock%20value%20%3D%3D%20true%20%5D%29%0D%0A%09%09ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.ClassCategoryReader,"class:category:","class_category_"

,function (aClass,aString){var self=this;self['@class']=aClass;

self['@category']=aString;return self;}

,"accessing",unescape("class%3A%20aClass%20category%3A%20aString%0D%0A%09%22%20Private%20-%20Set%20the%20class%20and%20category%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09class%20%3A%3D%20aClass.%0D%0A%09category%20%3A%3D%20aString"));

smalltalk.bind(smalltalk.ClassCategoryReader,"scanFrom:","scanFrom_"

,function (aStream){var self=this;try{var chunk=nil;chunk=aStream.nextChunk();

((chunk.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "scanFrom_", fn: function(){return nil}})})();})() : nil);

self.compileMethod_(chunk);

(function(){throw({name: "stReturn", selector: "scanFrom_", fn: function(){return self}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "scanFrom_"){return $$ex.fn();} throw($$ex);}}

,"fileIn",unescape("scanFrom%3A%20aStream%0D%0A%09%22%20Scan%20the%20next%20chunk%20of%20data%20from%20aStream.%20%22%0D%0A%0D%0A%09%7C%20chunk%20%7C%0D%0A%09chunk%20%3A%3D%20aStream%20nextChunk.%0D%0A%09chunk%20isEmpty%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09self%20compileMethod%3A%20chunk.%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.ClassCategoryReader,"compileMethod:","compileMethod_"

,function (aString){var self=this;var method=nil;method=self['@class'].compiler().load_forClass_(aString, self['@class']);

method.category_(self['@category']);

self['@class'].addCompiledMethod_(method);return self;}

,"private",unescape("compileMethod%3A%20aString%0D%0A%09%22%20Compile%20aString%20as%20a%20method%20source.%20%22%0D%0A%0D%0A%09%7C%20method%20%7C%0D%0A%09method%20%3A%3D%20class%20compiler%20load%3A%20aString%20forClass%3A%20class.%0D%0A%09method%20category%3A%20category.%0D%0A%09class%20addCompiledMethod%3A%20method"));

smalltalk.bind(smalltalk.ClassCommentReader,"class:","class_"

,function (aClass){var self=this;self['@class']=aClass;return self;}

,"accessing",unescape("class%3A%20aClass%0D%0A%09%22%20Set%20the%20destination%20class%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09class%20%3A%3D%20aClass"));

smalltalk.bind(smalltalk.ClassCommentReader,"scanFrom:","scanFrom_"

,function (aStream){var self=this;self.comment_(aStream.nextChunk());

return nil;return self;}

,"fileIn",unescape("scanFrom%3A%20aStream%0D%0A%09%22%20FileIn%20-%20Parse%20next%20chunk%20in%20aStream%20as%20a%20comment%20for%20target%20class.%20%22%0D%0A%0D%0A%09self%20comment%3A%20aStream%20nextChunk.%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.ClassCommentReader,"comment:","comment_"

,function (aString){var self=this;self['@class'].comment_(((aString.isEmpty()).mustBeBoolean()==true ? nil : (function(){return aString;})()));return self;}

,"private",unescape("comment%3A%20aString%0D%0A%09%22%20Set%20the%20comment%20of%20target%20class.%20%22%0D%0A%0D%0A%09class%20comment%3A%20%28aString%20isEmpty%20ifFalse%3A%20%5B%20aString%20%5D%29"));

smalltalk.bind(smalltalk.CancelFileInReader,"scanFrom:","scanFrom_"

,function (aStream){var self=this;aStream.setToEnd();

return nil;return self;}

,"fileIn",unescape("scanFrom%3A%20aStream%0D%0A%09%22%20Consume/Ignore%20contents%20in%20aStream.%20%22%0D%0A%0D%0A%09aStream%20setToEnd.%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.AssociationsReader,"keyFrom:","keyFrom_"

,function (aStream){var self=this;try{((aStream.peek()._eq(unescape("%23"))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "keyFrom_", fn: function(){return (function($rec){$rec.next();return $rec.upTo_(" ");})(aStream).asSymbol()}})})();})() : nil);

((aStream.peek()._eq(unescape("%27"))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "keyFrom_", fn: function(){return (function($rec){$rec.next();return $rec.upTo_(unescape("%27"));})(aStream)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "keyFrom_", fn: function(){return aStream.upTo_(" ")}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "keyFrom_"){return $$ex.fn();} throw($$ex);}}

,"reading",unescape("keyFrom%3A%20aStream%0D%0A%09%22%20Private%20-%20Return%20the%20name%20of%20the%20current%20binding%20in%20aStream.%20%22%0D%0A%0D%0A%09aStream%20peek%20%3D%20%24%23%20ifTrue%3A%20%5B%20%5E%28aStream%20next%3B%20upTo%3A%20%24%20%29%20asSymbol%20%5D.%0D%0A%09aStream%20peek%20%3D%20%24%27%20ifTrue%3A%20%5B%20%5EaStream%20next%3B%20upTo%3A%20%24%27%20%5D.%0D%0A%09%5EaStream%20upTo%3A%20%24%20"));

smalltalk.bind(smalltalk.AssociationsReader,"valueFrom:","valueFrom_"

,function (aStream){var self=this;return self.compiler().evaluate_(aStream.upToEnd());return self;}

,"reading",unescape("valueFrom%3A%20aStream%0D%0A%09%22%20Private%20-%20Return%20the%20value%20of%20the%20current%20binding%20in%20aStream.%20%22%0D%0A%0D%0A%09%5Eself%20compiler%20evaluate%3A%20aStream%20upToEnd%20"));

smalltalk.bind(smalltalk.AssociationsReader,"compiler","compiler"

,function (){var self=this;return smalltalk.Compiler;return self;}

,"evaluating",unescape("compiler%0D%0A%09%22%20Private%20-%20Return%20compiler%20in%20use%20to%20get%20values%20from%20stream.%20%22%0D%0A%0D%0A%09%5ECompiler"));

smalltalk.bind(smalltalk.AssociationsReader,"bind:","bind_"

,function (tuples){var self=this;return self.implementedBySubclass();return self;}

,"binding",unescape("bind%3A%20tuples%0D%0A%09%22%20Private%20-%20Bind%20the%20filedIn%20tuples%20to%20target.%0D%0A%09Must%20return%20the%20result%20of%20the%20fileIn/binding%20process.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20implementedBySubclass%20"));

smalltalk.bind(smalltalk.AssociationsReader,"scanFrom:","scanFrom_"

,function (aStream){var self=this;var chunk=nil;var tuples=nil;tuples=smalltalk.Array.$$new();

(function(){while((function(){return aStream.atEnd().not().and_((function(){chunk=aStream.nextChunk().trimBlanks();return chunk.notEmpty();}));})()){(function(){chunk=chunk.stream();return tuples.add_(smalltalk.Array.with_with_(self.keyFrom_(chunk), chunk.upToEnd().doIt()));})()};return nil})();

return self.bind_(tuples);return self;}

,"fileIn",unescape("scanFrom%3A%20aStream%0D%0A%09%22%20Consume%20chunks%20in%20aStream%20until%20empty%20chunk.%0D%0A%09The%20chunks%20are%20considered%20associative%20bindings%20with%20the%20syntax%3A%0D%0A%09%09%3Ckey%3E%20%3Cexpression%3E%0D%0A%09Where%0D%0A%09%09key%20is%20the%20keyword%20of%20the%20binding%20%28name%2C%20string%20or%20symbol%29.%0D%0A%09%09expression%20is%20a%20valid%20smalltalk%20expression%20that%20will%20be%20evaluated%20to%20generate%20the%20value%20of%20the%20binding.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20chunk%20tuples%20%7C%0D%0A%09tuples%20%3A%3D%20Array%20new.%0D%0A%09%5B%20aStream%20atEnd%20not%20and%3A%20%5B%0D%0A%09%20%20chunk%20%3A%3D%20aStream%20nextChunk%20trimBlanks.%0D%0A%09%20%20chunk%20notEmpty%20%5D%5D%20whileTrue%3A%20%5B%0D%0A%09%20%20chunk%20%3A%3D%20chunk%20stream.%0D%0A%09%20%20tuples%20add%3A%20%28Array%0D%0A%09%09with%3A%20%28self%20keyFrom%3A%20chunk%29%0D%0A%09%09with%3A%20chunk%20upToEnd%20doIt%29.%0D%0A%09%5D.%0D%0A%09%5Eself%20bind%3A%20tuples"));

smalltalk.bind(smalltalk.PoolDictionaryReader,"scope:","scope_"

,function (aScope){var self=this;self['@scope']=aScope;return self;}

,"accessing",unescape("scope%3A%20aScope%0D%0A%09%22%20Set%20the%20scope%20where%20the%20read%20bindings%20will%20be%20stored.%20%22%0D%0A%0D%0A%09scope%20%3A%3D%20aScope"));

smalltalk.bind(smalltalk.PoolDictionaryReader,"bind:","bind_"

,function (tuples){var self=this;try{((self['@scope'].isString()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "bind_", fn: function(){return smalltalk.Smalltalk.definePool_with_(self['@scope'], tuples)}})})();})() : nil);

((((self['@scope'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@scope']=smalltalk.Dictionary.$$new();})() : nil);

tuples.do_((function(each){return self['@scope'].at_put_(each.first(), each.last());}));

(function(){throw({name: "stReturn", selector: "bind_", fn: function(){return self['@scope']}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "bind_"){return $$ex.fn();} throw($$ex);}}

,"binding",unescape("bind%3A%20tuples%0D%0A%09%22%20Private%20-%20Bind%20the%20filedIn%20tuples%20to%20target.%0D%0A%09Must%20return%20the%20result%20of%20the%20fileIn/binding%20process.%0D%0A%09%22%0D%0A%0D%0A%09scope%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5ESmalltalk%20definePool%3A%20scope%20with%3A%20tuples%0D%0A%09%5D.%0D%0A%09scope%20isNil%20ifTrue%3A%20%5B%20scope%20%3A%3D%20Dictionary%20new%20%5D.%0D%0A%09tuples%20do%3A%20%5B%3Aeach%7C%20scope%20at%3A%20each%20first%20put%3A%20each%20last%20%5D.%0D%0A%09%5Escope"));

smalltalk.bind(smalltalk.JSReader,"bind:","bind_"

,function (tuples){var self=this;((((self['@object'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeObject();})() : nil);

tuples.do_((function(each){return (self['@object'][each.first()]=(each.last()));}));

return self['@object'];return self;}

,"binding",unescape("bind%3A%20tuples%0D%0A%09%22%20Private%20-%20Bind%20the%20filedIn%20tuples%20to%20target.%0D%0A%09Must%20return%20the%20result%20of%20the%20fileIn/binding%20process.%0D%0A%09%22%0D%0A%0D%0A%09object%20isNil%20ifTrue%3A%20%5B%20self%20initializeObject%20%5D.%0D%0A%09tuples%20do%3A%20%5B%3Aeach%7C%20object%20basicAt%3A%20each%20first%20put%3A%20each%20last%20%5D.%0D%0A%09%5Eobject"));

smalltalk.bind(smalltalk.JSReader,"object:","object_"

,function (anObject){var self=this;self['@object']=anObject;return self;}

,"accessing",unescape("object%3A%20anObject%0D%0A%09%22%20Set%20the%20object%20where%20the%20bindings%20will%20be%20stored.%20%22%0D%0A%0D%0A%09object%20%3A%3D%20anObject"));

smalltalk.bind(smalltalk.JSReader,"initializeObject","initializeObject"

,function (){var self=this;self['@object']={};return self;}

,"initialize",unescape("initializeObject%0D%0A%09%22%20Private%20-%20Initialize%20the%20object%20where%20the%20bindings%20will%20be%20stored.%20%22%0D%0A%0D%0A%09object%20%3A%3D%20%7B%27%7B%7D%27%7D"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"buildBooleanGetter:","buildBooleanGetter_"

,function (aSelector){var self=this;return self.implement_comment_as_category_(self.stMessageHeader_(aSelector), "Return the "._comma(aSelector)._comma(" of the receiver."), unescape("%5Etrue%20%3D%3D%20%28self%20handle%20basicAt%3A%20")._comma(aSelector.printString())._comma(unescape("%29")), "accessing");return self;}

,unescape("code%20generation"),unescape("buildBooleanGetter%3A%20aSelector%0D%0A%09%22%20Private%20-%20Build%20method%20to%20get%20instance%20aSelector%20%28with%20boolean%20result%29.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%0D%0A%09%09comment%3A%20%27Return%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5Etrue%20%3D%3D%20%28self%20handle%20basicAt%3A%20%27%20%2CaSelector%20printString%20%2C%27%29%27%20category%3A%20%23accessing"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"js","js"

,function (){var self=this;return smalltalk.JS._at(smalltalk.Smalltalk.jsObjectAt_ifAbsent_("PhoneGap", (function(){return nil;})));return self;}

,"accessing",unescape("js%0D%0A%09%22%20Return%20a%20wrapper%20on%20the%20javascript%20library%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5EJS%20@%20%28Smalltalk%20jsObjectAt%3A%20%27PhoneGap%27%20ifAbsent%3A%20%5B%5D%29"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"accelerometer","accelerometer"

,function (){var self=this;return smalltalk.Accelerometer.$$default();return self;}

,"accessing",unescape("accelerometer%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5EAccelerometer%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"camera","camera"

,function (){var self=this;return smalltalk.Camera.$$default();return self;}

,"accessing",unescape("camera%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5ECamera%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"captureAudio","captureAudio"

,function (){var self=this;return smalltalk.CaptureAudio.$$default();return self;}

,"accessing",unescape("captureAudio%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5ECaptureAudio%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"captureImage","captureImage"

,function (){var self=this;return smalltalk.CaptureImage.$$default();return self;}

,"accessing",unescape("captureImage%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5ECaptureImage%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"captureVideo","captureVideo"

,function (){var self=this;return smalltalk.CaptureVideo.$$default();return self;}

,"accessing",unescape("captureVideo%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5ECaptureVideo%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"compass","compass"

,function (){var self=this;return smalltalk.Compass.$$default();return self;}

,"accessing",unescape("compass%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5ECompass%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"compassFilter","compassFilter"

,function (){var self=this;return smalltalk.CompassFilter.$$default();return self;}

,"accessing",unescape("compassFilter%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5ECompassFilter%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"connection","connection"

,function (){var self=this;return smalltalk.Connection.$$default();return self;}

,"accessing",unescape("connection%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5EConnection%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"geolocation","geolocation"

,function (){var self=this;return smalltalk.Geolocation.$$default();return self;}

,"accessing",unescape("geolocation%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5EGeolocation%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"notification","notification"

,function (){var self=this;return smalltalk.Notification.$$default();return self;}

,"accessing",unescape("notification%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5ENotification%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"database","database"

,function (){var self=this;return smalltalk.PG8DataBase;return self;}

,"accessing",unescape("database%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5EPG8DataBase"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"localStorage","localStorage"

,function (){var self=this;return smalltalk.PG8LocalStorage.$$default();return self;}

,"accessing",unescape("localStorage%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5EPG8LocalStorage%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"events","events"

,function (){var self=this;return smalltalk.PhoneGapEvents.$$default();return self;}

,"accessing",unescape("events%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5EPhoneGapEvents%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"device","device"

,function (){var self=this;return smalltalk.Device.$$default();return self;}

,"accessing",unescape("device%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5EDevice%20default"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"fileSystem","fileSystem"

,function (){var self=this;return smalltalk.FileSystem.service();return self;}

,"services",unescape("fileSystem%0D%0A%09%22%20Return%20the%20fileSystem%20support%20%28it%20is%20an%20async%20service%2C%20please%20read%20class%20side%20messages%20on%20FileEntity%29.%20%22%0D%0A%0D%0A%09%5EFileSystem%20service"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"directory","directory"

,function (){var self=this;return smalltalk.DirectoryEntry.service();return self;}

,"services",unescape("directory%0D%0A%09%22%20Return%20the%20directory%20support%20%28it%20is%20an%20async%20service%2C%20please%20read%20class%20side%20messages%20on%20FileEntity%29.%20%22%0D%0A%0D%0A%09%5EDirectoryEntry%20service"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"file","file"

,function (){var self=this;return smalltalk.FileEntry.service();return self;}

,"services",unescape("file%0D%0A%09%22%20Return%20the%20file%20support%20%28it%20is%20an%20async%20service%2C%20please%20read%20class%20side%20messages%20on%20FileEntity%29.%20%22%0D%0A%0D%0A%09%5EFileEntry%20service"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"constructEventsTriggered","constructEventsTriggered"

,function (){var self=this;return smalltalk.whoImplements(smalltalk.PhoneGap.$klass,'constructEventsTriggered').$superclass.$fn.prototype['constructEventsTriggered'].apply(self, [])._comma(self.phoneGapEvents());return self;}

,"events",unescape("constructEventsTriggered%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Esuper%20constructEventsTriggered%20%2C%20self%20phoneGapEvents"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"phoneGapEvents","phoneGapEvents"

,function (){var self=this;return smalltalk.Array.$$new();return self;}

,"events",unescape("phoneGapEvents%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20PhoneGap.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses%20to%20implement%20phoneGap%20hooks.%20%22%0D%0A%0D%0A%09%5EArray%20new"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"when:do:","when_do_"

,function (eventName,aBlock){var self=this;return self.events().when_do_(eventName, aBlock);return self;}

,"events",unescape("when%3A%20eventName%20do%3A%20aBlock%0D%0A%09%22%20Return%20the%20default%20instance.%20%22%0D%0A%0D%0A%09%5Eself%20events%20when%3A%20eventName%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"errorBlock:","errorBlock_"

,function (errorBlock){var self=this;try{((((errorBlock || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "errorBlock_", fn: function(){return (function(error){return self.error_(self.name()._comma(": ")._comma(self.descriptionOf_(error)));})}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "errorBlock_", fn: function(){return errorBlock}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "errorBlock_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("errorBlock%3A%20errorBlock%0D%0A%09%22%20Private%20-%20Return%20an%20error%20handler%20for%20errorBlock.%20%22%0D%0A%0D%0A%09errorBlock%20isNil%20ifTrue%3A%20%5B%0D%0A%09%09%5E%5B%3Aerror%7C%20self%20error%3A%20self%20name%20%2C%27%3A%20%27%20%2C%28self%20descriptionOf%3A%20error%29%20%5D%0D%0A%09%5D.%0D%0A%09%5EerrorBlock"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"descriptionOf:","descriptionOf_"

,function (error){var self=this;try{var code=nil;(function(){code=error.code;((((code || nil) !== nil)).mustBeBoolean()==true ? (function(){return self.errorCodeTable().do_((function(tuple){return ((tuple.first()._eq(code)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "descriptionOf_", fn: function(){return tuple.last()._comma(" error.")}})})();})() : nil);}));})() : nil);return ((((error.message || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "descriptionOf_", fn: function(){return error.message}})})();})() : nil);}).on_do_(smalltalk.Error, (function(ex){return self.print_("Error reporting "._comma(error)._comma(unescape("%20%28"))._comma(ex)._comma(unescape("%29")));}));

(function(){throw({name: "stReturn", selector: "descriptionOf_", fn: function(){return "Unknon error "._comma(error)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "descriptionOf_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("descriptionOf%3A%20error%0D%0A%09%22%20Private%20-%20Return%20an%20error%20description%20for%20error.%20%22%0D%0A%0D%0A%09%7C%20code%20%7C%0D%0A%09%5B%09code%20%3A%3D%20error%23code.%0D%0A%09%09code%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%09self%20errorCodeTable%20do%3A%20%5B%3Atuple%7C%0D%0A%09%09%09%09tuple%20first%20%3D%20code%20ifTrue%3A%20%5B%20%5Etuple%20last%20%2C%27%20error.%27%20%5D.%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%09error%23message%20notNil%20ifTrue%3A%20%5B%20%5Eerror%23message%20%5D.%0D%0A%09%5D%20on%3A%20Error%20do%3A%20%5B%3Aex%7C%20self%20print%3A%20%27Error%20reporting%20%27%20%2Cerror%20%2C%27%20%28%27%20%2Cex%20%2C%27%29%27%20%5D.%0D%0A%09%5E%27Unknon%20error%20%27%20%2Cerror"));

smalltalk.bind(smalltalk.PhoneGap.$klass,"errorCodeTable","errorCodeTable"

,function (){var self=this;return smalltalk.Array.$$new();return self;}

,"private",unescape("errorCodeTable%0D%0A%09%22%20Private%20-%20Return%20an%20error%20code/description%20table.%20%22%0D%0A%0D%0A%09%5EArray%20new"));

smalltalk.bind(smalltalk.PhoneGap,"phoneGapEvents","phoneGapEvents"

,function (){var self=this;return self.$klass.phoneGapEvents();return self;}

,"events",unescape("phoneGapEvents%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20PhoneGap.%20%22%0D%0A%0D%0A%09%5Eself%20class%20phoneGapEvents"));

smalltalk.bind(smalltalk.PhoneGap,"when:evaluate:","when_evaluate_"

,function (anEvent,anAction){var self=this;((self.phoneGapEvents().includes_(anEvent).and_((function(){return self.hasActionForEvent_(anEvent).not();}))).mustBeBoolean()==true ? (function(){return self.whenPhoneGap_evaluate_(anEvent, anAction);})() : nil);

return smalltalk.whoImplements(smalltalk.PhoneGap,'when_evaluate_').$superclass.$fn.prototype['when_evaluate_'].apply(self, [anEvent, anAction]);return self;}

,"events",unescape("when%3A%20anEvent%20evaluate%3A%20anAction%0D%0A%09%22%20Register%20anAction%20to%20the%20be%20evaluated%20when%20the%20receiver%20triggers%20the%20event.%20%22%0D%0A%0D%0A%09%28%28self%20phoneGapEvents%20includes%3A%20anEvent%29%20and%3A%20%5B%0D%0A%09%09%28self%20hasActionForEvent%3A%20anEvent%29%20not%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09self%20whenPhoneGap%3A%20anEvent%20evaluate%3A%20anAction%0D%0A%09%5D.%0D%0A%09%5Esuper%20when%3A%20anEvent%20evaluate%3A%20anAction"));

smalltalk.bind(smalltalk.PhoneGap,"whenPhoneGap:evaluate:","whenPhoneGap_evaluate_"

,function (anEvent,anAction){var self=this;return self.implementedBySubclass();return self;}

,"private-events",unescape("whenPhoneGap%3A%20anEvent%20evaluate%3A%20anAction%0D%0A%09%22%20Private%20-%20Register%20anAction%20to%20the%20be%20evaluated%20when%20the%20receiver%20triggers%20the%20event.%20%22%0D%0A%0D%0A%09%5Eself%20implementedBySubclass"));

smalltalk.bind(smalltalk.PhoneGap,"errorBlock:","errorBlock_"

,function (errorBlock){var self=this;return self.$klass.errorBlock_(errorBlock);return self;}

,"private",unescape("errorBlock%3A%20errorBlock%0D%0A%09%22%20Private%20-%20Return%20an%20error%20handler%20for%20errorBlock.%20%22%0D%0A%0D%0A%09%5Eself%20class%20errorBlock%3A%20errorBlock"));

smalltalk.bind(smalltalk.DOM.$klass,"elementSupport","elementSupport"

,function (){var self=this;return smalltalk.DOMNode;return self;}

,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%0D%0A%09The%20default%20answer%20is%20the%20top%20node%20support.%0D%0A%09This%20method%20can%20be%20refined%20by%20concrete%20instantiation%20schemas%20%28see%20subclasses%29.%0D%0A%09%22%0D%0A%0D%0A%09%5EDOMNode"));

smalltalk.bind(smalltalk.DOM.$klass,"window","window"

,function (){var self=this;return smalltalk.BrowserWindow.$$default();return self;}

,"accessing",unescape("window%0D%0A%09%22%20Return%20the%20browser%20window.%20%22%0D%0A%0D%0A%09%5EBrowserWindow%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"document","document"

,function (){var self=this;return smalltalk.HTMLDocument.$$default();return self;}

,"accessing",unescape("document%0D%0A%09%22%20Return%20the%20browser%20document.%20%22%0D%0A%0D%0A%09%5EHTMLDocument%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"history","history"

,function (){var self=this;return smalltalk.BrowserHistory.$$default();return self;}

,"accessing",unescape("history%0D%0A%09%22%20Return%20the%20browser%20history.%20%22%0D%0A%0D%0A%09%5EBrowserHistory%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"navigator","navigator"

,function (){var self=this;return smalltalk.BrowserNavigator.$$default();return self;}

,"accessing",unescape("navigator%0D%0A%09%22%20Return%20the%20browser%20navigator.%20%22%0D%0A%0D%0A%09%5EBrowserNavigator%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"screen","screen"

,function (){var self=this;return smalltalk.BrowserScreen.$$default();return self;}

,"accessing",unescape("screen%0D%0A%09%22%20Return%20the%20browser%20history.%20%22%0D%0A%0D%0A%09%5EBrowserScreen%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"location","location"

,function (){var self=this;return smalltalk.BrowserLocation.$$default();return self;}

,"accessing",unescape("location%0D%0A%09%22%20Return%20the%20browser%20location.%20%22%0D%0A%0D%0A%09%5EBrowserLocation%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"html5Structure","html5Structure"

,function (){var self=this;return smalltalk.HTML5Structure;return self;}

,unescape("code%20generation"),unescape("html5Structure%0D%0A%09%22%20Private%20-%20Return%20the%20root%20support%20for%20IDL%20specs.%20%22%0D%0A%0D%0A%09%5EHTML5Structure"));

smalltalk.bind(smalltalk.DOM.$klass,"structurePrologue","structurePrologue"

,function (){var self=this;return "HTML5_";return self;}

,unescape("code%20generation"),unescape("structurePrologue%0D%0A%09%22%20Private%20-%20Return%20the%20prologue%20for%20structure%20names.%20%22%0D%0A%0D%0A%09%5E%23HTML5_"));

smalltalk.bind(smalltalk.DOM.$klass,"structure:is:","structure_is_"

,function (structureName,apiSpecs){var self=this;var support=nil;var code=nil;support=self.structurePrologue()._comma(structureName).asSmalltalkName_(true);

self.html5Structure().subclass_instanceVariableNames_category_(support, "", self.category());

support=smalltalk.Smalltalk.at_(support);

return support.buildAPI_(apiSpecs);return self;}

,unescape("code%20generation"),unescape("structure%3A%20structureName%20is%3A%20apiSpecs%0D%0A%09%22%20Create%20support%20for%20html5%20structure%20named%20structureName.%20%22%0D%0A%0D%0A%09%7C%20support%20code%20%7C%0D%0A%09support%20%3A%3D%20%28self%20structurePrologue%20%2C%20structureName%29%20asSmalltalkName%3A%20true.%0D%0A%09self%20html5Structure%20subclass%3A%20support%20instanceVariableNames%3A%20%27%27%20category%3A%20self%20category.%0D%0A%09support%20%3A%3D%20Smalltalk%20at%3A%20support.%0D%0A%09%5Esupport%20buildAPI%3A%20apiSpecs"));

smalltalk.bind(smalltalk.DOM,"array:of:do:","array_of_do_"

,function (nativeArray,nativeClass,aBlock){var self=this;return ((((nativeArray || nil) !== nil)).mustBeBoolean()==true ? (function(){return (0).to_((nativeArray.length - (1))).collect_((function(index){return aBlock.evaluateWith_(nativeClass._at(nativeArray[index]));}));})() : nil);return self;}

,"private",unescape("array%3A%20nativeArray%20of%3A%20nativeClass%20do%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20a%20copy%20of%20nativeArray%20as%20anArray%20of%20instances%20of%20nativeClass.%20%22%0D%0A%0D%0A%09%5EnativeArray%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%280%20to%3A%20nativeArray%23length%20-%201%29%20collect%3A%20%5B%3Aindex%7C%0D%0A%09%09%09aBlock%20evaluateWith%3A%20nativeClass%20@%20nativeArray%5Bindex%5D%0D%0A%09%09%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOM,"array:of:at:","array_of_at_"

,function (nativeArray,nativeClass,indexOrName){var self=this;return nativeClass._at(nativeArray[indexOrName]);return self;}

,"private",unescape("array%3A%20nativeArray%20of%3A%20nativeClass%20at%3A%20indexOrName%0D%0A%09%22%20Private%20-%20Return%20the%20element%20of%20class%20nativeClass%20at%20index%28or%20name%29%20position%20of%20nativeArray.%0D%0A%09WARNING%3A%20in%20case%20of%20using%20integer%20index%2C%20it%20must%20be%20zero%20indexed%20value.%0D%0A%09%22%0D%0A%0D%0A%09%5EnativeClass%20@%20nativeArray%5BindexOrName%5D"));

smalltalk.bind(smalltalk.DOM,"array:of:","array_of_"

,function (nativeArray,nativeClass){var self=this;return self.array_of_do_(nativeArray, nativeClass, (function(each){return each;}));return self;}

,"private",unescape("array%3A%20nativeArray%20of%3A%20nativeClass%0D%0A%09%22%20Private%20-%20Return%20a%20copy%20of%20nativeArray%20as%20anArray%20of%20instances%20of%20nativeClass.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20nativeArray%20of%3A%20nativeClass%20do%3A%20%5B%3Aeach%7C%20each%20%5D"));

smalltalk.bind(smalltalk.DOM,"vendorPrefixes","vendorPrefixes"

,function (){var self=this;return ["webkit", "ms", "moz", "o"];return self;}

,"private",unescape("vendorPrefixes%0D%0A%09%22%20Private%20-%20Return%20the%20collection%20of%20%28browser%29%20vendors%20that%20used%20force%20the%20use%20of%20prefixes%20for%20selectors%20for%20their%20experimental%20stuff.%20%22%0D%0A%0D%0A%09%5E%23%28%20webkit%20ms%20moz%20o%20%29"));

smalltalk.bind(smalltalk.DOM,"vendors:prefix:dash:ifAbsent:","vendors_prefix_dash_ifAbsent_"

,function (vendors,selector,dash,aBlock){var self=this;try{var result=nil;result=(self['@handle'][selector] || (function(){var epilogue=nil;epilogue=((dash).mustBeBoolean()==true ? (function(){return unescape("-")._comma(selector);})() : (function(){return selector.first().asUppercase()._comma(selector.copyFrom_to_((2), selector.size()));})());vendors.do_((function(vendor){result=(self['@handle'][vendor._comma(epilogue)] || (function(){return "none";}).value());return ((result._eq("none")).mustBeBoolean()==true ? nil : (function(){(function(){return (self['@handle'][selector]=(result));}).on_do_(smalltalk.Error, (function(ignored){return nil;}));return (function(){throw({name: "stReturn", selector: "vendors_prefix_dash_ifAbsent_", fn: function(){return result}})})();})());}));return (function(){throw({name: "stReturn", selector: "vendors_prefix_dash_ifAbsent_", fn: function(){return aBlock.value()}})})();}).value());

(function(){throw({name: "stReturn", selector: "vendors_prefix_dash_ifAbsent_", fn: function(){return result}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "vendors_prefix_dash_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("vendors%3A%20vendors%20prefix%3A%20selector%20dash%3A%20dash%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20%28potentially%20prefixed%29%20property%20of%20the%20receiver%2C%20or%20evaluate%20aBlock%20if%20it%20is%20not%20present.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20handle%20basicAt%3A%20selector%20ifAbsent%3A%20%5B%20%7C%20epilogue%20%7C%0D%0A%09%09epilogue%20%3A%3D%20dash%20ifTrue%3A%20%5B%20%24-%20%2C%20selector%20%5D%20ifFalse%3A%20%5B%0D%0A%09%09%09selector%20first%20asUppercase%20%2C%20%28selector%20copyFrom%3A%202%20to%3A%20selector%20size%29%0D%0A%09%09%5D.%0D%0A%09%09vendors%20do%3A%20%5B%3Avendor%7C%0D%0A%09%09%09result%20%3A%3D%20handle%20basicAt%3A%20vendor%20%2C%20epilogue%20ifAbsent%3A%20%5B%20%23none%20%5D.%0D%0A%09%09%09result%20%3D%20%23none%20ifFalse%3A%20%5B%0D%0A%09%09%09%09%5B%20handle%20basicAt%3A%20selector%20put%3A%20result%20%5D%20on%3A%20Error%20do%3A%20%5B%3Aignored%7C%20%5D.%0D%0A%09%09%09%09%5Eresult%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%09%5EaBlock%20value%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.DOM,"prefix:dash:ifAbsent:","prefix_dash_ifAbsent_"

,function (selector,dash,aBlock){var self=this;return self.vendors_prefix_dash_ifAbsent_(self.vendorPrefixes(), selector, dash, aBlock);return self;}

,"private",unescape("prefix%3A%20selector%20dash%3A%20dash%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20%28potentially%20prefixed%29%20property%20of%20the%20receiver%2C%20or%20evaluate%20aBlock%20if%20it%20is%20not%20present.%20%22%0D%0A%0D%0A%09%5Eself%20vendors%3A%20self%20vendorPrefixes%20prefix%3A%20selector%20dash%3A%20dash%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.DOM,"prefix:ifAbsent:","prefix_ifAbsent_"

,function (selector,aBlock){var self=this;return self.vendors_prefix_dash_ifAbsent_(self.vendorPrefixes(), selector, false, aBlock);return self;}

,"private",unescape("prefix%3A%20selector%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20%28potentially%20prefixed%29%20property%20of%20the%20receiver%2C%20or%20evaluate%20aBlock%20if%20it%20is%20not%20present.%20%22%0D%0A%0D%0A%09%5Eself%20vendors%3A%20self%20vendorPrefixes%20prefix%3A%20selector%20dash%3A%20false%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.DOM,"prefix:ifAbsentPut:","prefix_ifAbsentPut_"

,function (selector,aBlock){var self=this;return self.vendors_prefix_dash_ifAbsent_(self.vendorPrefixes(), selector, false, (function(){return (self['@handle'][selector]=(aBlock.evaluate()));}));return self;}

,"private",unescape("prefix%3A%20selector%20ifAbsentPut%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20%28potentially%20prefixed%29%20property%20of%20the%20receiver%2C%20or%20return%26store%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5Eself%20vendors%3A%20self%20vendorPrefixes%20prefix%3A%20selector%20dash%3A%20false%20ifAbsent%3A%20%5B%0D%0A%09%09handle%20basicAt%3A%20selector%20put%3A%20aBlock%20evaluate%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOM,"elementSupport","elementSupport"

,function (){var self=this;return self.$klass.elementSupport();return self;}

,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5Eself%20class%20elementSupport"));

smalltalk.bind(smalltalk.DOM,"window","window"

,function (){var self=this;return self.$klass.window();return self;}

,"accessing",unescape("window%0D%0A%09%22%20Return%20the%20browser%20window.%20%22%0D%0A%0D%0A%09%5Eself%20class%20window"));

smalltalk.bind(smalltalk.DOM,"document","document"

,function (){var self=this;return self.$klass.document();return self;}

,"accessing",unescape("document%0D%0A%09%22%20Return%20the%20browser%20document.%20%22%0D%0A%0D%0A%09%5Eself%20class%20document"));

smalltalk.bind(smalltalk.DOM,"history","history"

,function (){var self=this;return self.$klass.history();return self;}

,"accessing",unescape("history%0D%0A%09%22%20Return%20the%20browser%20history.%20%22%0D%0A%0D%0A%09%5Eself%20class%20history"));

smalltalk.bind(smalltalk.DOM,"location","location"

,function (){var self=this;return self.$klass.location();return self;}

,"accessing",unescape("location%0D%0A%09%22%20Return%20the%20browser%20location.%20%22%0D%0A%0D%0A%09%5Eself%20class%20location"));

smalltalk.bind(smalltalk.DOM,"screen","screen"

,function (){var self=this;return self.$klass.screen();return self;}

,"accessing",unescape("screen%0D%0A%09%22%20Return%20the%20browser%20screen.%20%22%0D%0A%0D%0A%09%5Eself%20class%20screen"));

smalltalk.bind(smalltalk.DOM,"navigator","navigator"

,function (){var self=this;return self.$klass.navigator();return self;}

,"accessing",unescape("navigator%0D%0A%09%22%20Return%20the%20browser%20navigator.%20%22%0D%0A%0D%0A%09%5Eself%20class%20navigator"));

smalltalk.bind(smalltalk.DOM,"addEventListener:doing:useCapture:","addEventListener_doing_useCapture_"

,function (type,aBlock,aBoolean){var self=this;return self.handle().addEventListener(type, aBlock, aBoolean);return self;}

,"DOM-Events-binding",unescape("addEventListener%3A%20type%20doing%3A%20aBlock%20useCapture%3A%20aBoolean%0D%0A%09%5Eself%20handle%20%23addEventListener%3A%20type%20doing%3A%20aBlock%20useCapture%3A%20aBoolean"));

smalltalk.bind(smalltalk.DOM,"addEventListener:doing:","addEventListener_doing_"

,function (type,aBlock){var self=this;return self.handle().addEventListener(type, aBlock);return self;}

,"DOM-Events-binding",unescape("addEventListener%3A%20type%20doing%3A%20aBlock%0D%0A%09%5Eself%20handle%20%23addEventListener%3A%20type%20doing%3A%20aBlock"));

smalltalk.bind(smalltalk.DOM,"removeEventListener:doing:useCapture:","removeEventListener_doing_useCapture_"

,function (type,aBlock,aBoolean){var self=this;return self.handle().removeEventListener(type, aBlock, aBoolean);return self;}

,"DOM-Events-binding",unescape("removeEventListener%3A%20type%20doing%3A%20aBlock%20useCapture%3A%20aBoolean%0D%0A%09%5Eself%20handle%20%23removeEventListener%3A%20type%20doing%3A%20aBlock%20useCapture%3A%20aBoolean"));

smalltalk.bind(smalltalk.DOM,"removeEventListener:doing:","removeEventListener_doing_"

,function (type,aBlock){var self=this;return self.handle().removeEventListener(type, aBlock);return self;}

,"DOM-Events-binding",unescape("removeEventListener%3A%20type%20doing%3A%20aBlock%0D%0A%09%5Eself%20handle%20%23removeEventListener%3A%20type%20doing%3A%20aBlock"));

smalltalk.bind(smalltalk.DOM,"removeEventListener:","removeEventListener_"

,function (type){var self=this;return self.handle().removeEventListener(type);return self;}

,"DOM-Events-binding",unescape("removeEventListener%3A%20type%0D%0A%09%5Eself%20handle%20%23removeEventListener%3A%20type"));

smalltalk.bind(smalltalk.DOM,"dispatchEvent:","dispatchEvent_"

,function (anEvent){var self=this;return self.handle().dispatchEvent(anEvent.handle());return self;}

,"DOM-Events-binding",unescape("dispatchEvent%3A%20anEvent%0D%0A%09%5Eself%20handle%20%23dispatchEvent%3A%20anEvent%20handle"));

smalltalk.bind(smalltalk.JS.$klass,"@","_at"

,function (jsObject){var self=this;try{((self.isObject_(jsObject).and_((function(){return jsObject.isString();}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_at", fn: function(){return smalltalk.whoImplements(smalltalk.JS.$klass,'_at').$superclass.$fn.prototype['_at'].apply(self, [smalltalk.Smalltalk.jsObjectAt_ifAbsent_(jsObject, (function(){return nil;}))])}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_at", fn: function(){return smalltalk.whoImplements(smalltalk.JS.$klass,'_at').$superclass.$fn.prototype['_at'].apply(self, [jsObject])}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_at"){return $$ex.fn();} throw($$ex);}}

,unescape("instance%20creation"),unescape("@%20jsObject%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%28%28self%20isObject%3A%20jsObject%29%20and%3A%20%5B%20jsObject%20isString%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Esuper%20@%20%28Smalltalk%20jsObjectAt%3A%20jsObject%20ifAbsent%3A%20%5B%5D%29%0D%0A%09%5D.%0D%0A%09%5Esuper%20@%20jsObject"));

smalltalk.bind(smalltalk.JS.$klass,"typeOf:","typeOf_"

,function (jsObject){var self=this;	return typeof jsObject; ;return self;}

,"utilities",unescape("typeOf%3A%20jsObject%0D%0A%09%22%20Return%20the%20type%20of%20%28javascript%29Object.%20%22%0D%0A%0D%0A%7B%27%09return%20typeof%20jsObject%3B%20%27%7D"));

smalltalk.bind(smalltalk.JS.$klass,"chunks","chunks"

,function (){var self=this;return smalltalk.JSReader.$$new();return self;}

,"utilities",unescape("chunks%0D%0A%09%22%20Return%20a%20JSReader%20to%20fileIn%20properties%20in%20new%20native%20object.%20%22%0D%0A%0D%0A%09%5EJSReader%20new"));

smalltalk.bind(smalltalk.JS,"jsObject","jsObject"

,function (){var self=this;	return Object; ;return self;}

,"private",unescape("jsObject%0D%0A%09%22%20Private%20-%20Return%20the%20%28javascript%29Object.%20%22%0D%0A%0D%0A%7B%27%09return%20Object%3B%20%27%7D"));

smalltalk.bind(smalltalk.JS,"prototype","prototype"

,function (){var self=this;return self.$klass._at(self.jsObject().getPrototypeOf(self['@handle']));return self;}

,"accessing",unescape("prototype%0D%0A%09%22%20Return%20the%20prototype%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20@%20%28self%20jsObject%20%23getPrototypeOf%3A%20handle%29"));

smalltalk.bind(smalltalk.JS,"propertyNames","propertyNames"

,function (){var self=this;return self.jsObject().keys(self['@handle']);return self;}

,"accessing",unescape("propertyNames%0D%0A%09%22%20Return%20the%20property%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20jsObject%20%23keys%3A%20handle"));

smalltalk.bind(smalltalk.JS,"keys","keys"

,function (){var self=this;return self.propertyNames().sorted();return self;}

,"accessing",unescape("keys%0D%0A%09%22%20Return%20the%20sorted%20property%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20propertyNames%20sorted"));

smalltalk.bind(smalltalk.JS,"properties","properties"

,function (){var self=this;return self.keys().collect_((function(each){return smalltalk.Array.with_with_(each, (self.handle()[each] || nil));}));return self;}

,"accessing",unescape("properties%0D%0A%09%22%20Return%20an%20array%20with%20property%20name%20and%20values.%20%22%0D%0A%0D%0A%09%5Eself%20keys%20collect%3A%20%5B%3Aeach%7C%0D%0A%09%09Array%20with%3A%20each%20with%3A%20%28self%20handle%20basicAt%3A%20each%29%0D%0A%09%5D"));

smalltalk.bind(smalltalk.JS,"description","description"

,function (){var self=this;var text=nil;text=(function(js){return ((((js || nil) === nil)).mustBeBoolean()==true ? (function(){return js;})() : (function(){return ((self.isObject_(js)).mustBeBoolean()==true ? (function(){return (((smalltalk.JS.typeOf_(js) === "function")).mustBeBoolean()==true ? (function(){return js.toString().upTo_(unescape("%7B"))._comma(unescape("%7B...%7D"));})() : (function(){return js.asString();})());})() : (function(){return js.toString();})());})());});

return self.properties().inject_into_(unescape("%7B"), (function(total, each){return total._comma(unescape("%0D%0A%20"))._comma(each.first())._comma(": ")._comma(text.value_(each.last()));}))._comma(unescape("%0D%0A%7D"));return self;}

,"debug",unescape("description%0D%0A%09%22%20Return%20a%20string%20description%20from%20receiver%27s%20properties.%20%22%0D%0A%0D%0A%09%7C%20text%20%7C%0D%0A%09text%20%3A%3D%20%5B%3Ajs%7C%0D%0A%09%09js%20isNil%20ifTrue%3A%20%5B%20js%20%5D%20ifFalse%3A%20%5B%0D%0A%09%09%09%28self%20isObject%3A%20js%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%28JS%20typeOf%3A%20js%29%20%3D%3D%20%23function%0D%0A%09%09%09%09ifTrue%3A%20%5B%20%28js%20toString%20upTo%3A%20%24%7B%29%20%2C%27%7B...%7D%27%20%5D%0D%0A%09%09%09%09ifFalse%3A%20%5B%20js%20asString%20%5D%0D%0A%09%09%09%5D%20ifFalse%3A%20%5B%20js%20toString%20%5D%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09%5E%28self%20properties%20inject%3A%20%27%7B%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%2C%27%0D%0A%20%27%20%2Ceach%20first%20%2C%27%3A%20%27%20%2C%20%28text%20value%3A%20each%20last%29%20%5D%29%20%2C%27%0D%0A%7D%27"));

smalltalk.bind(smalltalk.JS,"functionNames","functionNames"

,function (){var self=this;return self.propertyNames().select_((function(each){return (smalltalk.JS.typeOf_(self['@handle'][each]) === "function");}));return self;}

,"accessing",unescape("functionNames%0D%0A%09%22%20Return%20the%20names%20of%20property%20of%20the%20receiver%20of%20type%20function.%20%22%0D%0A%0D%0A%09%5Eself%20propertyNames%20select%3A%20%5B%3Aeach%7C%20%28JS%20typeOf%3A%20handle%5Beach%5D%29%20%3D%3D%20%23function%20%5D"));

smalltalk.bind(smalltalk.JS,"functions","functions"

,function (){var self=this;return self.functionNames().collect_((function(each){return smalltalk.Array.with_with_(each, self['@handle'][each]);}));return self;}

,"accessing",unescape("functions%0D%0A%09%22%20Return%20the%20functions%20of%20the%20receiver%20as%20a%20collection%20of%20tuples%20%23%28functionName%20aClosure%29.%20%22%0D%0A%0D%0A%09%5Eself%20functionNames%20collect%3A%20%5B%3Aeach%7C%20Array%20with%3A%20each%20with%3A%20handle%5Beach%5D%20%5D"));

smalltalk.bind(smalltalk.JS,"functionNamesAndArguments","functionNamesAndArguments"

,function (){var self=this;var argList=nil;argList=(function(source){return (function($rec){$rec.upTo_(unescape("%28"));return $rec.upTo_(unescape("%29"));})(source).asArrayOfSubstringsSeparatedBy_(unescape("%2C")).collect_((function(arg){return arg.trimBlanks();}));});

return self.functions().collect_((function(tuple){return smalltalk.Array.with_with_(tuple.first(), argList.value_(tuple.last().toString().stream()));}));return self;}

,"accessing",unescape("functionNamesAndArguments%0D%0A%09%22%20Return%20the%20functions%20of%20the%20receiver%20as%20a%20collection%20of%20tuples%20%23%28functionName%20argumentsArray%29.%20%22%0D%0A%0D%0A%09%7C%20argList%20%7C%0D%0A%09argList%20%3A%3D%20%5B%3Asource%7C%0D%0A%09%09%28%28source%20upTo%3A%20%24%28%3B%20upTo%3A%20%24%29%29%20asArrayOfSubstringsSeparatedBy%3A%20%24%2C%29%0D%0A%09%09%09collect%3A%20%5B%3Aarg%7C%20arg%20trimBlanks%20%5D%0D%0A%09%5D.%0D%0A%09%5Eself%20functions%20collect%3A%20%5B%3Atuple%7C%20Array%20with%3A%20tuple%20first%20with%3A%20%28argList%20value%3A%20tuple%20last%20toString%20stream%29%20%5D"));

smalltalk.bind(smalltalk.JS,"ownPropertyNames","ownPropertyNames"

,function (){var self=this;return self.jsObject().getOwnPropertyNames(self['@handle']);return self;}

,"accessing",unescape("ownPropertyNames%0D%0A%09%22%20Return%20the%20owned%20property%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20jsObject%20%23getOwnPropertyNames%3A%20handle"));

smalltalk.bind(smalltalk.JS,"ownFunctionNames","ownFunctionNames"

,function (){var self=this;return self.ownPropertyNames().select_((function(each){return (smalltalk.JS.typeOf_(self['@handle'][each]) === "function");}));return self;}

,"accessing",unescape("ownFunctionNames%0D%0A%09%22%20Return%20the%20names%20of%20functions%20owned/implemented%20by%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20ownPropertyNames%20select%3A%20%5B%3Aeach%7C%20%28JS%20typeOf%3A%20handle%5Beach%5D%29%20%3D%3D%20%23function%20%5D"));

smalltalk.bind(smalltalk.JS,"hasOwnProperty:","hasOwnProperty_"

,function (aName){var self=this;return self.jsObject().hasOwnProperty(self['@handle'], aName);return self;}

,"query",unescape("hasOwnProperty%3A%20aName%0D%0A%09%22%20Return%20true%20if%20receiver%20own%20a%20property%20named%20aName.%20%22%0D%0A%0D%0A%09%5Eself%20jsObject%20%23hasOwnProperty%3A%20handle%20named%3A%20aName"));

smalltalk.bind(smalltalk.JS,"delete:","delete_"

,function (aName){var self=this;	delete handle[aName];	;return self;}

,"actions",unescape("delete%3A%20aName%0D%0A%09%22%20Delete%20the%20property%20named%20aName%20in%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09delete%20handle%5BaName%5D%3B%09%27%7D"));

smalltalk.bind(smalltalk.JS,"defineProperty:value:writable:enumerable:configurable:","defineProperty_value_writable_enumerable_configurable_"

,function (aName,aValue,writable,enumerable,configurable){var self=this;return self.defineProperty_as_(aName, smalltalk.Array.with_with_with_with_(smalltalk.Array.with_with_("value", aValue), smalltalk.Array.with_with_("writable", writable), smalltalk.Array.with_with_("enumerable", enumerable), smalltalk.Array.with_with_("configurable", configurable)));return self;}

,"properties",unescape("defineProperty%3A%20aName%0D%0A%09value%3A%20aValue%0D%0A%09writable%3A%20writable%0D%0A%09enumerable%3A%20enumerable%0D%0A%09configurable%3A%20configurable%0D%0A%09%22%20Define%20the%20property%20named%20aName%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20defineProperty%3A%20aName%20as%3A%20%28%20Array%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23value%20with%3A%20aValue%29%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23writable%20with%3A%20writable%29%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23enumerable%20with%3A%20enumerable%29%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23configurable%20with%3A%20configurable%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.JS,"defineAccessor:get:set:enumerable:configurable:","defineAccessor_get_set_enumerable_configurable_"

,function (aName,aBlock,oneArgumentBlock,enumerable,configurable){var self=this;return self.defineProperty_as_(aName, smalltalk.Array.with_with_with_with_(smalltalk.Array.with_with_("get", aBlock), smalltalk.Array.with_with_("set", oneArgumentBlock), smalltalk.Array.with_with_("enumerable", enumerable), smalltalk.Array.with_with_("configurable", configurable)));return self;}

,"properties",unescape("defineAccessor%3A%20aName%0D%0A%09get%3A%20aBlock%0D%0A%09set%3A%20oneArgumentBlock%0D%0A%09enumerable%3A%20enumerable%0D%0A%09configurable%3A%20configurable%0D%0A%09%22%20Define%20the%20Accessor%20property%20named%20aName%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20defineProperty%3A%20aName%20as%3A%20%28%20Array%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23get%20with%3A%20aBlock%29%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23set%20with%3A%20oneArgumentBlock%29%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23enumerable%20with%3A%20enumerable%29%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23configurable%20with%3A%20configurable%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.JS,"defineProperty:value:writable:enumerable:","defineProperty_value_writable_enumerable_"

,function (aName,aValue,writable,enumerable){var self=this;return self.defineProperty_as_(aName, smalltalk.Array.with_with_with_(smalltalk.Array.with_with_("value", aValue), smalltalk.Array.with_with_("writable", writable), smalltalk.Array.with_with_("enumerable", enumerable)));return self;}

,"properties",unescape("defineProperty%3A%20aName%0D%0A%09value%3A%20aValue%0D%0A%09writable%3A%20writable%0D%0A%09enumerable%3A%20enumerable%0D%0A%09%22%20Define%20the%20property%20named%20aName%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20defineProperty%3A%20aName%20as%3A%20%28%20Array%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23value%20with%3A%20aValue%29%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23writable%20with%3A%20writable%29%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23enumerable%20with%3A%20enumerable%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.JS,"defineProperty:value:writable:","defineProperty_value_writable_"

,function (aName,aValue,writable){var self=this;return self.defineProperty_as_(aName, smalltalk.Array.with_with_(smalltalk.Array.with_with_("value", aValue), smalltalk.Array.with_with_("writable", writable)));return self;}

,"properties",unescape("defineProperty%3A%20aName%0D%0A%09value%3A%20aValue%0D%0A%09writable%3A%20writable%0D%0A%09%22%20Define%20the%20property%20named%20aName%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20defineProperty%3A%20aName%20as%3A%20%28%20Array%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23value%20with%3A%20aValue%29%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23writable%20with%3A%20writable%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.JS,"defineProperty:value:","defineProperty_value_"

,function (aName,aValue){var self=this;return self.defineProperty_as_(aName, smalltalk.Array.with_(smalltalk.Array.with_with_("value", aValue)));return self;}

,"properties",unescape("defineProperty%3A%20aName%20value%3A%20aValue%0D%0A%09%22%20Define%20the%20property%20named%20aName%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20defineProperty%3A%20aName%20as%3A%20%28%20Array%0D%0A%09%09with%3A%20%28Array%20with%3A%20%23value%20with%3A%20aValue%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.JS,"defineProperty:","defineProperty_"

,function (aName){var self=this;return self.defineProperty_as_(aName, smalltalk.Object.$$new());return self;}

,"properties",unescape("defineProperty%3A%20aName%0D%0A%09%22%20Define%20the%20property%20named%20aName%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20defineProperty%3A%20aName%20as%3A%20Object%20new"));

smalltalk.bind(smalltalk.JS,"defineProperty:as:","defineProperty_as_"

,function (aName,descriptor){var self=this;try{((descriptor.isArray()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "defineProperty_as_", fn: function(){return self.defineProperty_as_(aName, descriptor.inject_into_(smalltalk.Object.$$new(), (function(result, tuple){((((tuple.last() || nil) !== nil)).mustBeBoolean()==true ? (function(){return (result[tuple.first()]=(tuple.last()));})() : nil);return result;})))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "defineProperty_as_", fn: function(){return self.jsObject().defineProperty(self['@handle'], aName, descriptor)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "defineProperty_as_"){return $$ex.fn();} throw($$ex);}}

,"properties",unescape("defineProperty%3A%20aName%20as%3A%20descriptor%0D%0A%09%22%20Define%20the%20property%20named%20aName%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09descriptor%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20defineProperty%3A%20aName%20as%3A%20%28descriptor%0D%0A%09%09%09inject%3A%20Object%20new%20into%3A%20%5B%3Aresult%20%3Atuple%7C%0D%0A%09%09%09%09tuple%20last%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%09result%20basicAt%3A%20tuple%20first%20put%3A%20tuple%20last%0D%0A%09%09%09%09%5D.%0D%0A%09%09%09%09result%0D%0A%09%09%09%5D%29%0D%0A%09%5D.%0D%0A%09%0D%0A%09%5Eself%20jsObject%20%23defineProperty%3A%20handle%20named%3A%20aName%20as%3A%20descriptor"));

smalltalk.bind(smalltalk.JS,"defineProperties:","defineProperties_"

,function (descriptors){var self=this;self.jsObject().defineProperties(self['@handle'], descriptors);return self;}

,"properties",unescape("defineProperties%3A%20descriptors%0D%0A%09%22%20Define%20the%20properties%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20jsObject%20%23defineProperties%3A%20handle%20as%3A%20descriptors"));

smalltalk.bind(smalltalk.JS,"preventExtensions","preventExtensions"

,function (){var self=this;self.jsObject().preventExtensions(self['@handle']);return self;}

,"actions",unescape("preventExtensions%0D%0A%09%22%20Set%20the%20receiver%20as%20non-extensible.%20%22%0D%0A%0D%0A%09self%20jsObject%20%23preventExtensions%3A%20handle"));

smalltalk.bind(smalltalk.JS,"freeze","freeze"

,function (){var self=this;self.jsObject().freeze(self['@handle']);return self;}

,"actions",unescape("freeze%0D%0A%09%22%20Prevents%20the%20modification%20of%20existing%20property%20attributes%20and%20values%2C%20and%20prevents%20the%20addition%20of%20new%20properties.%20%22%0D%0A%0D%0A%09self%20jsObject%20%23freeze%3A%20handle"));

smalltalk.bind(smalltalk.JS,"seal","seal"

,function (){var self=this;self.jsObject().seal(self['@handle']);return self;}

,"actions",unescape("seal%0D%0A%09%22%20Prevents%20the%20modification%20of%20attributes%20of%20existing%20properties%2C%20and%20prevents%20the%20addition%20of%20new%20properties.%20%22%0D%0A%0D%0A%09self%20jsObject%20%23seal%3A%20handle"));

smalltalk.bind(smalltalk.JS,"isExtensible","isExtensible"

,function (){var self=this;self.jsObject().isExtensible(self['@handle']);return self;}

,"query",unescape("isExtensible%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20extensible.%20%22%0D%0A%0D%0A%09self%20jsObject%20%23isExtensible%3A%20handle"));

smalltalk.bind(smalltalk.JS,"isSealed","isSealed"

,function (){var self=this;self.jsObject().isSealed(self['@handle']);return self;}

,"query",unescape("isSealed%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20sealed.%20%22%0D%0A%0D%0A%09self%20jsObject%20%23isSealed%3A%20handle"));

smalltalk.bind(smalltalk.JS,"isFrozen","isFrozen"

,function (){var self=this;self.jsObject().isFrozen(self['@handle']);return self;}

,"query",unescape("isFrozen%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20frozen.%20%22%0D%0A%0D%0A%09self%20jsObject%20%23isFrozen%3A%20handle"));

smalltalk.bind(smalltalk.JS,"create:with:","create_with_"

,function (prototype,descriptors){var self=this;return self.$klass._at(self.jsObject().create(prototype, descriptors));return self;}

,"creation",unescape("create%3A%20prototype%20with%3A%20descriptors%0D%0A%09%22%20Return%20a%20JS%20object%20that%20has%20been%20created%20with%20the%20specified%20prototype%2C%20and%20that%20optionally%20contains%20specified%20properties.%20%22%0D%0A%0D%0A%09%5Eself%20class%20@%20%28self%20jsObject%20%23create%3A%20prototype%20with%3A%20descriptors%29"));

smalltalk.bind(smalltalk.JS,"createWith:","createWith_"

,function (descriptors){var self=this;return self.create_with_(self['@handle'], descriptors);return self;}

,"creation",unescape("createWith%3A%20descriptors%0D%0A%09%22%20Return%20a%20JS%20object%20that%20has%20been%20created%20with%20the%20handle%20prototype%2C%20and%20that%20optionally%20contains%20specified%20properties.%20%22%0D%0A%0D%0A%09%5Eself%20create%3A%20handle%20with%3A%20descriptors"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"globalName","globalName"

,function (){var self=this;return self.implementedBySubclass();return self;}

,"private",unescape("globalName%0D%0A%09%22%20Private%20-%20Return%20the%20name%20of%20the%20global%20to%20detect/access%20the%20library%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20implementedBySubclass"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"topGlobal","topGlobal"

,function (){var self=this;return smalltalk.Smalltalk.jsObjectAt_ifAbsent_("window", (function(){return self.error_("Missing window support");}));return self;}

,"private",unescape("topGlobal%0D%0A%09%22%20Private%20-%20Return%20the%20object%20to%20access%20the%20global%20during%20detection%20stage.%0D%0A%09The%20default%20implementation%20return%20window%20global%20%28present%20when%20running%20in%20a%20web%20browser%29.%0D%0A%09This%20method%20must%20be%20refined%20by%20the%20subclasses%20requiring%20other%20root%20dependences.%0D%0A%09Can%20return%20nil%20to%20do%20not%20check%20dependents.%0D%0A%09%22%0D%0A%0D%0A%09%5ESmalltalk%20jsObjectAt%3A%20%23window%20ifAbsent%3A%20%5B%20self%20error%3A%20%27Missing%20window%20support%27%20%5D."));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"requiredFeatures","requiredFeatures"

,function (){var self=this;return [];return self;}

,"private",unescape("requiredFeatures%0D%0A%09%22%20Private%20-%20Return%20the%20names%20of%20the%20required%20properties/features%20to%20execute%20the%20receiver.%0D%0A%09The%20default%20implementation%20do%20not%20check%20dependents.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses%20to%20ensure%20features%20to%20run%20the%20receiver%20are%20present%20in%20this%20system.%0D%0A%09%22%0D%0A%0D%0A%09%5E%23%28%29"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"classNamed:","classNamed_"

,function (className){var self=this;var library=nil;library=self.library();

return library[className];return self;}

,"private",unescape("classNamed%3A%20className%0D%0A%09%22%20Private%20-%20Return%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%0D%0A%09The%20default%20implementation%20get%20the%20class%20from%20library.%0D%0A%09Subclasses%20can%20refine%20to%20obtain%20classes%20from%20anywhere%0D%0A%09%09e.g.%20global%20scope%20with%3A%20%5Eself%20global%3A%20className.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20library%20%7C%0D%0A%09library%20%3A%3D%20self%20library.%0D%0A%09%5Elibrary%5BclassName%5D"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"sourceCode","sourceCode"

,function (){var self=this;return self.implementedBySubclass();return self;}

,unescape("source%20code"),unescape("sourceCode%0D%0A%09%22%20Private%20-%20Return%20the%20%28javascript%29%20source%20code%20of%20the%20library%20as%20a%20String.%0D%0A%09This%20method%20can%20be%20implemented%20by%20subclasses%20loading%20sources%20from%20external%20media%20or%20simply%20returning%20aString%20embedded%20in%20this%20method.%0D%0A%09A%20reference/link%20to%20source%20origin%20is%20appreciated%20by%20users.%0D%0A%09CAUTION%3A%20S8%20is%20MIT%2C%20so%20you%20MUST%20embedd%20here%20MIT%20compatible%20sources.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20implementedBySubclass"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"libraryBound:","libraryBound_"

,function (aClassName){var self=this;self.bindingListeners().do_((function(each){return each.libraryBound_(aClassName);}));return self;}

,"binding",unescape("libraryBound%3A%20aClassName%0D%0A%09%22%20Private%20-%20The%20library%20of%20aClassName%20has%20just%20been%20bound%20to%20this%20system.%20%22%0D%0A%0D%0A%09self%20bindingListeners%20do%3A%20%5B%3Aeach%7C%20each%20libraryBound%3A%20aClassName%20%5D"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"bindingListeners","bindingListeners"

,function (){var self=this;((((smalltalk.NativeLibraryObject.classVariableAt_("BindingListeners") || nil) === nil)).mustBeBoolean()==true ? (function(){return smalltalk.NativeLibraryObject.classVariableAt_put_("BindingListeners",smalltalk.Array.$$new());})() : nil);

return smalltalk.NativeLibraryObject.classVariableAt_("BindingListeners");return self;}

,"binding",unescape("bindingListeners%0D%0A%09%22%20Private%20-%20Return%20the%20collection%20of%20listeners%20to%20library%20binding%20notifications%20of%20this%20system.%20%22%0D%0A%0D%0A%09BindingListeners%20isNil%20ifTrue%3A%20%5B%20BindingListeners%20%3A%3D%20Array%20new%20%5D.%0D%0A%09%5EBindingListeners"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"globalName:","globalName_"

,function (aName){var self=this;return self.$klass.implement_comment_as_category_("globalName", unescape("Private%20-%20Return%20the%20name%20of%20the%20global%20to%20detect/access%20the%20library%20of%20the%20receiver."), unescape("%5E")._comma(aName.printString()), "private");return self;}

,unescape("code%20generation"),unescape("globalName%3A%20aName%0D%0A%09%22%20Generate%20code%20to%20return%20the%20name%20of%20the%20global%20to%20detect/access%20the%20library%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%0D%0A%09%09implement%3A%20%23globalName%0D%0A%09%09comment%3A%20%27Private%20-%20Return%20the%20name%20of%20the%20global%20to%20detect/access%20the%20library%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5E%27%20%2CaName%20printString%0D%0A%09%09category%3A%20%23private"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"libraryURL:","libraryURL_"

,function (anURL){var self=this;return self.$klass.implement_comment_as_category_("libraryURL", unescape("Private%20-%20Return%20the%20URL%20to%20use%20when%20loading%20library%20of%20the%20receiver."), unescape("%5E")._comma(anURL.printString()), "private");return self;}

,unescape("code%20generation"),unescape("libraryURL%3A%20anURL%0D%0A%09%22%20Generate%20the%20method%20to%20return%20libraryURL.%20%22%0D%0A%0D%0A%09%5Eself%20class%0D%0A%09%09implement%3A%20%23libraryURL%0D%0A%09%09comment%3A%20%27Private%20-%20Return%20the%20URL%20to%20use%20when%20loading%20library%20of%20the%20receiver.%27%0D%0A%09%09as%3A%20%27%5E%27%20%2CanURL%20printString%0D%0A%09%09category%3A%20%23private"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"globalClassNameFrom:","globalClassNameFrom_"

,function (globalClassName){var self=this;return globalClassName;return self;}

,"private",unescape("globalClassNameFrom%3A%20globalClassName%0D%0A%09%22%20Private%20-%20Return%20the%20global%20class%20name%20for%20global%20globalClassName.%0D%0A%09It%20must%20return%20the%20%28global%29%20name%20of%20the%20constructor%20used%20to%20instantiate%20instance%20handles.%0D%0A%09The%20default%20action%20is%20to%20return%20the%20globalClassName.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses%20to%20adapt%20name%20to%20%28case%20sensitive%29%20library%20constructor%20names.%0D%0A%09%22%0D%0A%0D%0A%09%5EglobalClassName"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"selectorForConstantNamed:","selectorForConstantNamed_"

,function (aName){var self=this;try{aName.detect_ifNone_((function(c){return c.isLowercase();}), (function(){return (function(){throw({name: "stReturn", selector: "selectorForConstantNamed_", fn: function(){return aName.asLowercase().asSmalltalkName_(false)}})})();}));

(function(){throw({name: "stReturn", selector: "selectorForConstantNamed_", fn: function(){return aName.asSmalltalkName_(false)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "selectorForConstantNamed_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("selectorForConstantNamed%3A%20aName%0D%0A%09%22%20Private%20-%20Return%20the%20selector%20to%20use%20for%20constant%20aName.%20%22%0D%0A%0D%0A%09aName%20detect%3A%20%5B%3Ac%7C%20c%20isLowercase%20%5D%20ifNone%3A%20%5B%0D%0A%09%09%5EaName%20asLowercase%20asSmalltalkName%3A%20false%0D%0A%09%5D.%0D%0A%09%5EaName%20asSmalltalkName%3A%20false"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"constants:","constants_"

,function (names){var self=this;names.do_((function(each){return self.$klass.implement_comment_as_category_(self.selectorForConstantNamed_(each), "Return the value of "._comma(each), unescape("%5Eself%20library%20basicAt%3A%20%23")._comma(each), "accessing");}));return self;}

,unescape("code%20generation"),unescape("constants%3A%20names%0D%0A%09%22%20Private%20-%20Build%20methods%20to%20access%20library%20globals.%20%22%0D%0A%0D%0A%09names%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09self%20class%0D%0A%09%09%09implement%3A%20%28self%20selectorForConstantNamed%3A%20each%29%0D%0A%09%09%09comment%3A%20%27Return%20the%20value%20of%20%27%2Ceach%0D%0A%09%09%09as%3A%20%27%5Eself%20library%20basicAt%3A%20%23%27%2Ceach%0D%0A%09%09%09category%3A%20%23accessing%0D%0A%09%5D."));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"buildSubclass:arguments:typed:","buildSubclass_arguments_typed_"

,function (globalClassName,argList,typedArguments){var self=this;try{var cls=nil;var clsName=nil;clsName=globalClassName.first().asUppercase()._comma(globalClassName.copyFrom_to_((2), globalClassName.size()));

clsName=self.classToken()._comma(clsName);

self.subclass_instanceVariableNames_category_(clsName, "", self.category());

((((argList || nil) === nil).or_((function(){return argList._eq("nil");}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "buildSubclass_arguments_typed_", fn: function(){return self}})})();})() : nil);

cls=smalltalk.Smalltalk.at_(clsName);

cls.$klass.implement_comment_as_category_("globalClassName", unescape("Private%20-%20Return%20the%20internal%20class%20name."), unescape("%5Eself%20globalClassNameFrom%3A%20%23")._comma(globalClassName), "private");

((argList.isEmpty()).mustBeBoolean()==true ? (function(){return cls.implement_comment_as_category_("initializeHandle", unescape("Private%20-%20Initialize%20the%20receiver%27s%20handle."), unescape("self%20handle%3A%20%28self%20newHandleOf%3A%20self%20class%20globalClassName%29"), "initialize");})() : (function(){var selector=nil;var args=nil;var current=nil;selector=argList.inject_into_("", (function(total, each){return total._comma(each)._comma(": ")._comma(each)._comma(" ");}));args=argList.inject_into_("", (function(total, each){((typedArguments._eq("all").or_((function(){return typedArguments.includes_(each);}))).mustBeBoolean()==true ? (function(){return current=" handle ";})() : (function(){return current=" ";})());return total._comma("with: ")._comma(each)._comma(current);}));cls.$klass.implement_comment_as_category_(selector, "Return an instance of the receiver.", unescape("%5Eself%20basicNew%20")._comma(selector), "instance creation");return cls.implement_comment_as_category_(selector, unescape("Private%20-%20Initialize%20the%20receiver."), unescape("self%20handle%3A%20%28self%20newHandleOf%3A%20self%20class%20globalClassName%20")._comma(args)._comma(unescape("%29")), "initialize");})());return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "buildSubclass_arguments_typed_"){return $$ex.fn();} throw($$ex);}}

,unescape("code%20generation"),unescape("buildSubclass%3A%20globalClassName%20arguments%3A%20argList%20typed%3A%20typedArguments%0D%0A%09%22%20Private%20-%20Build%20a%20subclass%20of%20the%20receiver%20implementing%20a%20wrapper%20to%20the%20library.%20%22%0D%0A%0D%0A%09%7C%20cls%20clsName%20%7C%0D%0A%09clsName%20%3A%3D%20globalClassName%20first%20asUppercase%0D%0A%09%09%09%2C%28globalClassName%20copyFrom%3A%202%20to%3A%20globalClassName%20size%29.%0D%0A%09clsName%20%3A%3D%20self%20classToken%20%2CclsName.%0D%0A%09self%0D%0A%09%09subclass%3A%20clsName%0D%0A%09%09instanceVariableNames%3A%20%27%27%0D%0A%09%09category%3A%20self%20category.%0D%0A%09%28argList%20isNil%20or%3A%20%5B%20argList%20%3D%20%23nil%20%5D%29%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%0D%0A%09cls%20%3A%3D%20Smalltalk%20at%3A%20clsName.%0D%0A%09cls%20class%0D%0A%09%09implement%3A%20%23globalClassName%0D%0A%09%09comment%3A%20%27Private%20-%20Return%20the%20internal%20class%20name.%27%0D%0A%09%09as%3A%20%27%5Eself%20globalClassNameFrom%3A%20%23%27%20%2CglobalClassName%0D%0A%09%09category%3A%20%23private.%0D%0A%09argList%20isEmpty%20ifTrue%3A%20%5B%0D%0A%09%09cls%0D%0A%09%09%09implement%3A%20%23initializeHandle%0D%0A%09%09%09comment%3A%20%27Private%20-%20Initialize%20the%20receiver%27%27s%20handle.%27%0D%0A%09%09%09as%3A%20%27self%20handle%3A%20%28self%20newHandleOf%3A%20self%20class%20globalClassName%29%27%0D%0A%09%09%09category%3A%20%23initialize.%0D%0A%09%5D%20ifFalse%3A%20%5B%20%7C%20selector%20args%20current%20%7C%0D%0A%09%09selector%20%3A%3D%20argList%20inject%3A%20%27%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%0D%0A%09%09%09total%20%2Ceach%2C%27%3A%20%27%2Ceach%2C%27%20%27%0D%0A%09%09%5D.%0D%0A%09%09args%20%3A%3D%20argList%20inject%3A%20%27%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%0D%0A%09%09%09%28typedArguments%20%3D%20%23all%0D%0A%09%09%09%20%20or%3A%20%5B%20typedArguments%20includes%3A%20each%20%5D%29%0D%0A%09%09%09%20%20ifTrue%3A%20%5B%20current%20%3A%3D%20%27%20handle%20%27%20%5D%0D%0A%09%09%09%20%20ifFalse%3A%20%5B%20current%20%3A%3D%20%27%20%27%20%5D.%0D%0A%09%09%09total%20%2C%27with%3A%20%27%2Ceach%2C%20current%0D%0A%09%09%5D.%0D%0A%09%09cls%20class%0D%0A%09%09%09implement%3A%20selector%0D%0A%09%09%09comment%3A%20%27Return%20an%20instance%20of%20the%20receiver.%27%0D%0A%09%09%09as%3A%20%27%5Eself%20basicNew%20%27%2Cselector%0D%0A%09%09%09category%3A%20%27instance%20creation%27.%0D%0A%09%09cls%0D%0A%09%09%09implement%3A%20selector%0D%0A%09%09%09comment%3A%20%27Private%20-%20Initialize%20the%20receiver.%27%0D%0A%09%09%09as%3A%20%27self%20handle%3A%20%28self%20newHandleOf%3A%20self%20class%20globalClassName%20%27%20%2Cargs%20%2C%27%29%27%0D%0A%09%09%09category%3A%20%23initialize.%0D%0A%09%5D."));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"global:","global_"

,function (globalName){var self=this;try{var result=nil;result=smalltalk.Smalltalk.jsObjectAt_ifAbsent_(globalName, (function(){return nil;}));

((((result || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "global_", fn: function(){return result}})})();})() : nil);

((self.isValid()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "global_", fn: function(){return nil}})})();})());

self.libraryLoaded_(self.loadLibrary());

(function(){throw({name: "stReturn", selector: "global_", fn: function(){return smalltalk.Smalltalk.jsObjectAt_ifAbsent_(globalName, (function(){return nil;}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "global_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("global%3A%20globalName%0D%0A%09%22%20Private%20-%20Return%20the%20native%20library%20global%20object%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20Smalltalk%20jsObjectAt%3A%20globalName%20ifAbsent%3A%20%5B%20nil%20%5D.%0D%0A%09result%20notNil%20ifTrue%3A%20%5B%20%5Eresult%20%5D.%0D%0A%09self%20isValid%20ifFalse%3A%20%5B%20%5Enil%20%5D.%0D%0A%09self%20libraryLoaded%3A%20self%20loadLibrary.%0D%0A%09%5ESmalltalk%20jsObjectAt%3A%20globalName%20ifAbsent%3A%20%5B%20nil%20%5D"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"library","library"

,function (){var self=this;return self.global_(self.globalName());return self;}

,"validation",unescape("library%0D%0A%09%22%20Check%20support%20to%20run%20this%20framework%20and%20try%20to%20load%20the%20library%20implementation.%0D%0A%09Return%20the%20native%20library%20object%20if%20success.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20global%3A%20self%20globalName"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"libraryOrNil","libraryOrNil"

,function (){var self=this;return smalltalk.Smalltalk.jsObjectAt_ifAbsent_(self.globalName(), (function(){return nil;}));return self;}

,"validation",unescape("libraryOrNil%0D%0A%09%22%20Quick%20Check%20-%20Return%20true%20if%20the%20library%20is%20already%20bound.%20%22%0D%0A%0D%0A%09%5ESmalltalk%20jsObjectAt%3A%20self%20globalName%20ifAbsent%3A%20%5B%20nil%20%5D"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"libraryURLs","libraryURLs"

,function (){var self=this;return smalltalk.Array.with_(self.libraryURL()).select_((function(each){return ((each || nil) !== nil);}));return self;}

,"private",unescape("libraryURLs%0D%0A%09%22%20Private%20-%20Return%20a%20collection%20of%20URL%20to%20load%20library%20of%20the%20receiver.%0D%0A%09Return%20an%20empty%20collection%2C%20the%20subclasses%20can%20complement%20addresses%20to%20load%20library%20from%20external%20resources.%0D%0A%09%22%0D%0A%0D%0A%09%5E%28Array%20with%3A%20self%20libraryURL%29%20select%3A%20%5B%3Aeach%7C%20each%20notNil%20%5D"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"libraryURL","libraryURL"

,function (){var self=this;return nil;return self;}

,"private",unescape("libraryURL%0D%0A%09%22%20Private%20-%20Return%20the%20URL%20to%20use%20when%20loading%20library%20of%20the%20receiver.%0D%0A%09Default%20implementation%20do%20not%20provide%20support%20to%20load%20library.%0D%0A%09%22%0D%0A%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"onLoad:","onLoad_"

,function (aBlock){var self=this;try{((((self.libraryOrNil() || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "onLoad_", fn: function(){return aBlock.value_(self.library())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "onLoad_", fn: function(){return smalltalk.DOM.document().loadAll_onLoad_(self.libraryURLs(), (function(){smalltalk.NativeLibraryObject.libraryBound_(self.name());return aBlock.value_(library);}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "onLoad_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("onLoad%3A%20aBlock%0D%0A%09%22%20Private%20-%20Load%20the%20library%20of%20the%20receiver%20and%20evaluates%20aBlock.%20%22%0D%0A%0D%0A%09self%20libraryOrNil%20notNil%20ifTrue%3A%20%5B%20%5EaBlock%20value%3A%20self%20library%20%5D.%0D%0A%09%5EDOM%20document%0D%0A%09%09loadAll%3A%20self%20libraryURLs%0D%0A%09%09onLoad%3A%20%5B%0D%0A%09%09%09NativeLibraryObject%20libraryBound%3A%20self%20name.%0D%0A%09%09%09aBlock%20value%3A%20library%0D%0A%09%09%5D"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"loadLibrary","loadLibrary"

,function (){var self=this;try{((self.libraryURLs().notEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "loadLibrary", fn: function(){return self.onLoad_((function(ignored){return nil;}))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "loadLibrary", fn: function(){return eval(self.sourceCode())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "loadLibrary"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("loadLibrary%0D%0A%09%22%20Private%20-%20Load%20the%20library%20of%20the%20receiver.%0D%0A%09Default%20implementation%20load%20the%20library%20from%20remote%20URL%20or%20sourceCode.%0D%0A%09%22%0D%0A%0D%0A%09self%20libraryURLs%20notEmpty%20ifTrue%3A%20%5B%20%5Eself%20onLoad%3A%20%5B%3Aignored%7C%20%5D%20%5D.%0D%0A%09%5E%23%20%23eval%3A%20self%20sourceCode"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"libraryLoaded:","libraryLoaded_"

,function (loadResult){var self=this;return self;}

,"private",unescape("libraryLoaded%3A%20loadResult%0D%0A%09%22%20Private%20-%20The%20library%20of%20the%20receiver%20has%20been%20loaded.%0D%0A%09Default%20implementation%20do%20nothing.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses%20to%20perform%20postLoading%20actions.%0D%0A%09The%20loadResult%20argument%20is%20the%20result%20of%20the%20just%20evaluated%20load%20process.%0D%0A%09%22"));

smalltalk.bind(smalltalk.NativeLibraryObject.$klass,"isValid","isValid"

,function (){var self=this;try{var global=nil;global=self.topGlobal();

((((global || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "isValid", fn: function(){return true}})})();})() : nil);

self.requiredFeatures().do_((function(each){return ((((global[each] || nil) === nil)).mustBeBoolean()==true ? (function(){return self.error_("Missing support for "._comma(each));})() : nil);}));

(function(){throw({name: "stReturn", selector: "isValid", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "isValid"){return $$ex.fn();} throw($$ex);}}

,"validation",unescape("isValid%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20valid%20in%20this%20%28browser%29%20context.%0D%0A%09Generate%20error%20if%20the%20minimum%20support%20to%20run%20the%20library%20is%20not%20available.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20global%20%7C%0D%0A%09global%20%3A%3D%20self%20topGlobal.%0D%0A%09global%20isNil%20ifTrue%3A%20%5B%20%5Etrue%20%5D.%20%22always%20valid%22%0D%0A%09self%20requiredFeatures%20do%3A%20%5B%3Aeach%7C%0D%0A%09%20%20global%5Beach%5D%20isNil%20ifTrue%3A%20%5B%0D%0A%09%20%20%20%20self%20error%3A%20%27Missing%20support%20for%20%27%2Ceach%0D%0A%09%20%20%5D.%0D%0A%09%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.NativeLibraryObject,"library","library"

,function (){var self=this;return self.$klass.library();return self;}

,"private",unescape("library%0D%0A%09%22%20Private%20-%20Return%20the%20library%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20library"));

smalltalk.bind(smalltalk.NativeLibraryObject,"classNamed:","classNamed_"

,function (className){var self=this;return self.$klass.classNamed_(className);return self;}

,"private",unescape("classNamed%3A%20className%0D%0A%09%22%20Private%20-%20Return%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%5Eself%20class%20classNamed%3A%20className"));

smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:","newHandleOf_"

,function (className){var self=this;var result=nil;var aConstructor=nil;aConstructor=self.classNamed_(className);

result= new aConstructor() ;

return result;return self;}

,"private",unescape("newHandleOf%3A%20className%0D%0A%09%22%20Private%20-%20Return%20a%20new%20instance%20of%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%7C%20result%20aConstructor%20%7C%0D%0A%09aConstructor%20%3A%3D%20self%20classNamed%3A%20className.%0D%0A%09result%20%3A%3D%20%7B%27%20new%20aConstructor%28%29%20%27%7D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:","newHandleOf_with_"

,function (className,arg1){var self=this;var result=nil;var aConstructor=nil;aConstructor=self.classNamed_(className);

result= new aConstructor(arg1) ;

return result;return self;}

,"private",unescape("newHandleOf%3A%20className%20with%3A%20arg1%0D%0A%09%22%20Private%20-%20Return%20a%20new%20instance%20of%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%7C%20result%20aConstructor%20%7C%0D%0A%09aConstructor%20%3A%3D%20self%20classNamed%3A%20className.%0D%0A%09result%20%3A%3D%20%7B%27%20new%20aConstructor%28arg1%29%20%27%7D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:","newHandleOf_with_with_"

,function (className,arg1,arg2){var self=this;var result=nil;var aConstructor=nil;aConstructor=self.classNamed_(className);

result= new aConstructor(arg1,arg2) ;

return result;return self;}

,"private",unescape("newHandleOf%3A%20className%20with%3A%20arg1%20with%3A%20arg2%0D%0A%09%22%20Private%20-%20Return%20a%20new%20instance%20of%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%7C%20result%20aConstructor%20%7C%0D%0A%09aConstructor%20%3A%3D%20self%20classNamed%3A%20className.%0D%0A%09result%20%3A%3D%20%7B%27%20new%20aConstructor%28arg1%2Carg2%29%20%27%7D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:","newHandleOf_with_with_with_"

,function (className,arg1,arg2,arg3){var self=this;var result=nil;var aConstructor=nil;aConstructor=self.classNamed_(className);

result= new aConstructor(arg1,arg2,arg3) ;

return result;return self;}

,"private",unescape("newHandleOf%3A%20className%20with%3A%20arg1%20with%3A%20arg2%20with%3A%20arg3%0D%0A%09%22%20Private%20-%20Return%20a%20new%20instance%20of%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%7C%20result%20aConstructor%20%7C%0D%0A%09aConstructor%20%3A%3D%20self%20classNamed%3A%20className.%0D%0A%09result%20%3A%3D%20%7B%27%20new%20aConstructor%28arg1%2Carg2%2Carg3%29%20%27%7D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:","newHandleOf_with_with_with_with_"

,function (className,arg1,arg2,arg3,arg4){var self=this;var result=nil;var aConstructor=nil;aConstructor=self.classNamed_(className);

result= new aConstructor(arg1,arg2,arg3,arg4) ;

return result;return self;}

,"private",unescape("newHandleOf%3A%20className%20with%3A%20arg1%20with%3A%20arg2%20with%3A%20arg3%20with%3A%20arg4%0D%0A%09%22%20Private%20-%20Return%20a%20new%20instance%20of%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%7C%20result%20aConstructor%20%7C%0D%0A%09aConstructor%20%3A%3D%20self%20classNamed%3A%20className.%0D%0A%09result%20%3A%3D%20%7B%27%20new%20aConstructor%28arg1%2Carg2%2Carg3%2Carg4%29%20%27%7D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:","newHandleOf_with_with_with_with_with_"

,function (className,arg1,arg2,arg3,arg4,arg5){var self=this;var result=nil;var aConstructor=nil;aConstructor=self.classNamed_(className);

result= new aConstructor(arg1,arg2,arg3,arg4,arg5) ;

return result;return self;}

,"private",unescape("newHandleOf%3A%20className%20with%3A%20arg1%20with%3A%20arg2%20with%3A%20arg3%20with%3A%20arg4%20with%3A%20arg5%0D%0A%09%22%20Private%20-%20Return%20a%20new%20instance%20of%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%7C%20result%20aConstructor%20%7C%0D%0A%09aConstructor%20%3A%3D%20self%20classNamed%3A%20className.%0D%0A%09result%20%3A%3D%20%7B%27%20new%20aConstructor%28arg1%2Carg2%2Carg3%2Carg4%2Carg5%29%20%27%7D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:with:","newHandleOf_with_with_with_with_with_with_"

,function (className,arg1,arg2,arg3,arg4,arg5,arg6){var self=this;var result=nil;var aConstructor=nil;aConstructor=self.classNamed_(className);

result= new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6) ;

return result;return self;}

,"private",unescape("newHandleOf%3A%20className%20with%3A%20arg1%20with%3A%20arg2%20with%3A%20arg3%20with%3A%20arg4%20with%3A%20arg5%20with%3A%20arg6%0D%0A%09%22%20Private%20-%20Return%20a%20new%20instance%20of%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%7C%20result%20aConstructor%20%7C%0D%0A%09aConstructor%20%3A%3D%20self%20classNamed%3A%20className.%0D%0A%09result%20%3A%3D%20%7B%27%20new%20aConstructor%28arg1%2Carg2%2Carg3%2Carg4%2Carg5%2Carg6%29%20%27%7D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:with:with:","newHandleOf_with_with_with_with_with_with_with_"

,function (className,arg1,arg2,arg3,arg4,arg5,arg6,arg7){var self=this;var result=nil;var aConstructor=nil;aConstructor=self.classNamed_(className);

result= new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7) ;

return result;return self;}

,"private",unescape("newHandleOf%3A%20className%20with%3A%20arg1%20with%3A%20arg2%20with%3A%20arg3%20with%3A%20arg4%20with%3A%20arg5%20with%3A%20arg6%20with%3A%20arg7%0D%0A%09%22%20Private%20-%20Return%20a%20new%20instance%20of%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%7C%20result%20aConstructor%20%7C%0D%0A%09aConstructor%20%3A%3D%20self%20classNamed%3A%20className.%0D%0A%09result%20%3A%3D%20%7B%27%20new%20aConstructor%28arg1%2Carg2%2Carg3%2Carg4%2Carg5%2Carg6%2Carg7%29%20%27%7D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:with:with:with:","newHandleOf_with_with_with_with_with_with_with_with_"

,function (className,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8){var self=this;var result=nil;var aConstructor=nil;aConstructor=self.classNamed_(className);

result= new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8) ;

return result;return self;}

,"private",unescape("newHandleOf%3A%20className%20with%3A%20arg1%20with%3A%20arg2%20with%3A%20arg3%20with%3A%20arg4%20with%3A%20arg5%20with%3A%20arg6%20with%3A%20arg7%20with%3A%20arg8%0D%0A%09%22%20Private%20-%20Return%20a%20new%20instance%20of%20the%20class%20named%20className%20in%20the%20receiver%27s%20library.%20%22%0D%0A%0D%0A%09%7C%20result%20aConstructor%20%7C%0D%0A%09aConstructor%20%3A%3D%20self%20classNamed%3A%20className.%0D%0A%09result%20%3A%3D%20%7B%27%20new%20aConstructor%28arg1%2Carg2%2Carg3%2Carg4%2Carg5%2Carg6%2Carg7%2Carg8%29%20%27%7D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.PG8LocalStorage.$klass,"default","$$default"

,function (){var self=this;return self._at(window.localStorage);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bwindow%7D%23localStorage"));

smalltalk.bind(smalltalk.PG8LocalStorage,"key:","key_"

,function (offset){var self=this;return self.handle().key(offset);return self;}

,"accessing",unescape("key%3A%20offset%0D%0A%09%22%20Return%20the%20name%20of%20the%20key%20at%20the%20position%20specified.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23key%3A%20offset"));

smalltalk.bind(smalltalk.PG8LocalStorage,"keyAt:","keyAt_"

,function (index){var self=this;return self.key_((index - (1)));return self;}

,"accessing",unescape("keyAt%3A%20index%0D%0A%09%22%20Return%20the%20name%20of%20the%20key%20at%20index%20%28ONE%20indexed%29.%20%22%0D%0A%0D%0A%09%5Eself%20key%3A%20index%20-%201"));

smalltalk.bind(smalltalk.PG8LocalStorage,"keysDo:","keysDo_"

,function (aBlock){var self=this;var key=nil;var index=nil;index=(0);

(function(){while((function(){key=self.key_(index);return ((key || nil) !== nil);})()){(function(){aBlock.value_(key);return index=(index + (1));})()};return nil})();return self;}

,"accessing",unescape("keysDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20keys%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20key%20index%20%7C%0D%0A%09index%20%3A%3D%200.%0D%0A%09%5B%09key%20%3A%3D%20self%20key%3A%20index.%0D%0A%09%09key%20notNil%20%5D%20whileTrue%3A%20%5B%0D%0A%09%09aBlock%20value%3A%20key.%0D%0A%09%09index%20%3A%3D%20index%20+%201.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.PG8LocalStorage,"keys","keys"

,function (){var self=this;var result=nil;result=smalltalk.Array.$$new();

self.keysDo_((function(each){return result.add_(each);}));

return result;return self;}

,"accessing",unescape("keys%0D%0A%09%22%20Return%20the%20keys%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09self%20keysDo%3A%20%5B%3Aeach%7C%20result%20add%3A%20each%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.PG8LocalStorage,"isEmpty","isEmpty"

,function (){var self=this;try{self.keysDo_((function(each){return (function(){throw({name: "stReturn", selector: "isEmpty", fn: function(){return false}})})();}));

(function(){throw({name: "stReturn", selector: "isEmpty", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "isEmpty"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("isEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%09self%20keysDo%3A%20%5B%3Aeach%7C%20%5Efalse%20%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.PG8LocalStorage,"notEmpty","notEmpty"

,function (){var self=this;return self.isEmpty().not();return self;}

,"accessing",unescape("notEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20has%20at%20least%20one%20key.%20%22%0D%0A%0D%0A%09%5Eself%20isEmpty%20not"));

smalltalk.bind(smalltalk.PG8LocalStorage,"do:","do_"

,function (aBlock){var self=this;self.keysDo_((function(key){return aBlock.value_(self.at_(key));}));return self;}

,"accessing",unescape("do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20values%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20keysDo%3A%20%5B%3Akey%7C%20aBlock%20value%3A%20%28self%20at%3A%20key%29%20%5D"));

smalltalk.bind(smalltalk.PG8LocalStorage,"associationsDo:","associationsDo_"

,function (aBlock){var self=this;self.keysDo_((function(key){return aBlock.value_(smalltalk.Association.key_value_(key, self.at_(key)));}));return self;}

,"accessing",unescape("associationsDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20key/value%20associations%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20keysDo%3A%20%5B%3Akey%7C%20aBlock%20value%3A%20%28Association%20key%3A%20key%20value%3A%20%28self%20at%3A%20key%29%29%20%5D"));

smalltalk.bind(smalltalk.PG8LocalStorage,"at:","at_"

,function (key){var self=this;return self.handle().getItem(key);return self;}

,"accessing",unescape("at%3A%20key%0D%0A%09%22%20Return%20the%20value%20at%20key.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23getItem%3A%20key"));

smalltalk.bind(smalltalk.PG8LocalStorage,"at:put:","at_put_"

,function (key,value){var self=this;return self.handle().setItem(key, value);return self;}

,"accessing",unescape("at%3A%20key%20put%3A%20value%0D%0A%09%22%20Set%20the%20value%20at%20key.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23setItem%3A%20key%20value%3A%20value"));

smalltalk.bind(smalltalk.PG8LocalStorage,"remove:","remove_"

,function (key){var self=this;return self.handle().removeItem(key);return self;}

,"accessing",unescape("remove%3A%20key%0D%0A%09%22%20Remove%20the%20value%20at%20key.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23removeItem%3A%20key"));

smalltalk.bind(smalltalk.PG8LocalStorage,"clear","clear"

,function (){var self=this;return self.handle().clear();return self;}

,"reset",unescape("clear%0D%0A%09%22%20Clear%20the%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20clear"));

smalltalk.bind(smalltalk.PG8SQLResultSet,"insertId","insertId"

,function (){var self=this;return (self.handle()["insertId"] || nil);return self;}

,"accessing",unescape("insertId%0D%0A%09%22%20Return%20the%20insertId%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27insertId%27"));

smalltalk.bind(smalltalk.PG8SQLResultSet,"rowAffected","rowAffected"

,function (){var self=this;return (self.handle()["rowAffected"] || nil);return self;}

,"accessing",unescape("rowAffected%0D%0A%09%22%20Return%20the%20rowAffected%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27rowAffected%27"));

smalltalk.bind(smalltalk.PG8SQLResultSet,"rowsDo:","rowsDo_"

,function (aBlock){var self=this;var rows=nil;rows=self['@handle'].rows;

return ((((rows || nil) !== nil)).mustBeBoolean()==true ? (function(){return (0).to_((rows.length - (1))).collect_((function(index){return aBlock.evaluateWith_(rows.item(index));}));})() : nil);return self;}

,"private",unescape("rowsDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20rows%20of%20results%20in%20the%20receiver.%0D%0A%09Return%20a%20collection%20with%20the%20results%20of%20evaluation.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20rows%20%7C%0D%0A%09rows%20%3A%3D%20handle%23rows.%0D%0A%09%5Erows%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%280%20to%3A%20rows%23length%20-%201%29%20collect%3A%20%5B%3Aindex%7C%0D%0A%09%09%09aBlock%20evaluateWith%3A%20%28rows%20%23item%3A%20index%29%0D%0A%09%09%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.PG8SQLResultSet,"rows","rows"

,function (){var self=this;return self.rowsDo_((function(row){return row;}));return self;}

,"private",unescape("rows%0D%0A%09%22%20Return%20a%20collection%20with%20the%20results%20of%20evaluation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20rowsDo%3A%20%5B%3Arow%7C%20row%20%5D"));

smalltalk.bind(smalltalk.PG8SQLTransaction.$klass,"errorCodeTable","errorCodeTable"

,function (){var self=this;return [[(0), "Internal"], [(1), "Version"], [(2), "Too large"], [(3), "Quota"], [(4), "Syntax"], [(5), "Constraint"], [(6), "Timeout"]];return self;}

,"private",unescape("errorCodeTable%0D%0A%09%22%20Private%20-%20Return%20an%20error%20code/description%20table.%20%22%0D%0A%0D%0A%09%5E%23%28%0D%0A%09%09%23%28%20%200%20%27Internal%27%20%29%0D%0A%09%09%23%28%20%201%20%27Version%27%20%29%0D%0A%09%09%23%28%20%202%20%27Too%20large%27%20%29%0D%0A%09%09%23%28%20%203%20%27Quota%27%20%29%0D%0A%09%09%23%28%20%204%20%27Syntax%27%20%29%0D%0A%09%09%23%28%20%205%20%27Constraint%27%20%29%0D%0A%09%09%23%28%20%206%20%27Timeout%27%20%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.PG8SQLTransaction,"executeSql:parameters:onResult:onError:","executeSql_parameters_onResult_onError_"

,function (sqlString,parameters,aBlock,errorBlock){var self=this;return self.handle().executeSql(sqlString, parameters, (function(data){return aBlock.value_(self.valueFromData_(data));}), self.errorBlock_(errorBlock));return self;}

,"evaluation",unescape("executeSql%3A%20sqlString%20parameters%3A%20parameters%20onResult%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Execute%20the%20SQL%20string%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23executeSql%3A%20sqlString%0D%0A%09%09parameters%3A%20parameters%0D%0A%09%09value%3A%20%5B%3Adata%7C%20aBlock%20value%3A%20%28self%20valueFromData%3A%20data%29%20%5D%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.PG8SQLTransaction,"executeSql:","executeSql_"

,function (sqlString){var self=this;return self.executeSql_parameters_onResult_onError_(sqlString, [], (function(ignored){return nil;}), errorBlock);return self;}

,"evaluation",unescape("executeSql%3A%20sqlString%0D%0A%09%22%20Execute%20the%20SQL%20string%20in%20the%20receiver.%20%22%0D%0A%0D%0A%22%09%5Eself%20handle%20%23executeSql%3A%20sqlString%0D%0A%22%09%5Eself%09executeSql%3A%20sqlString%20parameters%3A%20%23%28%29%0D%0A%09%09onResult%3A%20%5B%3Aignored%7C%20%5D%20onError%3A%20errorBlock"));

smalltalk.bind(smalltalk.PG8SQLTransaction,"execute:","execute_"

,function (sqlString){var self=this;return self.executeSql_(sqlString);return self;}

,"evaluation",unescape("execute%3A%20sqlString%0D%0A%09%22%20Execute%20the%20SQL%20string%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20executeSql%3A%20sqlString"));

smalltalk.bind(smalltalk.PG8SQLTransaction,",","_comma"

,function (sqlString){var self=this;return self.executeSql_(sqlString);return self;}

,"evaluation",unescape("%2C%20sqlString%0D%0A%09%22%20Execute%20the%20SQL%20string%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20executeSql%3A%20sqlString"));

smalltalk.bind(smalltalk.PG8SQLTransaction,"executeAll:","executeAll_"

,function (sqlStrings){var self=this;sqlStrings.do_((function(each){return self.execute_(each);}));return self;}

,"evaluation",unescape("executeAll%3A%20sqlStrings%0D%0A%09%22%20Execute%20the%20SQL%20strings%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09sqlStrings%20do%3A%20%5B%3Aeach%7C%20self%20execute%3A%20each%20%5D"));

smalltalk.bind(smalltalk.PG8SQLTransaction,"valueFromData:","valueFromData_"

,function (data){var self=this;return smalltalk.PG8SQLResultSet._at(data);return self;}

,"accessing",unescape("valueFromData%3A%20data%0D%0A%09%22%20Return%20the%20value%20%28anObject%29computed%20from%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPG8SQLResultSet%20@%20data"));

smalltalk.bind(smalltalk.Notification.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator.notification);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D%23notification"));

smalltalk.bind(smalltalk.Notification,"alert:","alert_"

,function (message){var self=this;return self.handle().alert(message.asString());return self;}

,"alert",unescape("alert%3A%20message%0D%0A%09%22%20Show%20a%20custom%20alert%20or%20dialog%20box.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23alert%3A%20message%20asString"));

smalltalk.bind(smalltalk.Notification,"alert:doing:","alert_doing_"

,function (message,dissmissAction){var self=this;return self.handle().alert(message.asString(), dissmissAction);return self;}

,"alert",unescape("alert%3A%20message%20doing%3A%20dissmissAction%0D%0A%09%22%20Show%20a%20custom%20alert%20or%20dialog%20box.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23alert%3A%20message%20asString%20doing%3A%20dissmissAction"));

smalltalk.bind(smalltalk.Notification,"alert:doing:title:buttonName:","alert_doing_title_buttonName_"

,function (message,dissmissAction,title,buttonName){var self=this;return self.handle().alert(message.asString(), dissmissAction, title, buttonName);return self;}

,"alert",unescape("alert%3A%20message%20doing%3A%20dissmissAction%20title%3A%20title%20buttonName%3A%20buttonName%0D%0A%09%22%20Show%20a%20custom%20alert%20or%20dialog%20box.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23alert%3A%20message%20asString%20doing%3A%20dissmissAction%20title%3A%20title%20buttonName%3A%20buttonName"));

smalltalk.bind(smalltalk.Notification,"alert:doing:title:","alert_doing_title_"

,function (message,dissmissAction,title){var self=this;return self.handle().alert(message.asString(), dissmissAction, title);return self;}

,"alert",unescape("alert%3A%20message%20doing%3A%20dissmissAction%20title%3A%20title%0D%0A%09%22%20Show%20a%20custom%20alert%20or%20dialog%20box.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23alert%3A%20message%20asString%20doing%3A%20dissmissAction%20title%3A%20title"));

smalltalk.bind(smalltalk.Notification,"alert:title:buttonName:","alert_title_buttonName_"

,function (message,title,buttonName){var self=this;return self.handle().alert(message.asString(), (function(){return nil;}), title, buttonName);return self;}

,"alert",unescape("alert%3A%20message%20title%3A%20title%20buttonName%3A%20buttonName%0D%0A%09%22%20Show%20a%20custom%20alert%20or%20dialog%20box.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23alert%3A%20message%20asString%20doing%3A%20%5B%5D%20title%3A%20title%20buttonName%3A%20buttonName"));

smalltalk.bind(smalltalk.Notification,"alert:title:","alert_title_"

,function (message,title){var self=this;return self.handle().alert(message.asString(), (function(){return nil;}), title);return self;}

,"alert",unescape("alert%3A%20message%20title%3A%20title%0D%0A%09%22%20Show%20a%20custom%20alert%20or%20dialog%20box.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23alert%3A%20message%20asString%20doing%3A%20%5B%5D%20title%3A%20title"));

smalltalk.bind(smalltalk.Notification,"confirm:doing:title:buttonNames:","confirm_doing_title_buttonNames_"

,function (message,oneArgumentBlock,title,buttonNames){var self=this;return self.handle().confirm(message, oneArgumentBlock, title, buttonNames);return self;}

,"confirmation",unescape("confirm%3A%20message%20doing%3A%20oneArgumentBlock%20title%3A%20title%20buttonNames%3A%20buttonNames%0D%0A%09%22%20Show%20a%20custom%20confirmation%20dialog%20box.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23confirm%3A%20message%20doing%3A%20oneArgumentBlock%20title%3A%20title%20buttonNames%3A%20buttonNames"));

smalltalk.bind(smalltalk.Notification,"confirm:doing:title:","confirm_doing_title_"

,function (message,oneArgumentBlock,title){var self=this;return self.handle().confirm(message, oneArgumentBlock, title);return self;}

,"confirmation",unescape("confirm%3A%20message%20doing%3A%20oneArgumentBlock%20title%3A%20title%0D%0A%09%22%20Show%20a%20custom%20confirmation%20dialog%20box.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23confirm%3A%20message%20doing%3A%20oneArgumentBlock%20title%3A%20title"));

smalltalk.bind(smalltalk.Notification,"confirm:doing:","confirm_doing_"

,function (message,oneArgumentBlock){var self=this;return self.handle().confirm(message, oneArgumentBlock);return self;}

,"confirmation",unescape("confirm%3A%20message%20doing%3A%20oneArgumentBlock%0D%0A%09%22%20Show%20a%20custom%20confirmation%20dialog%20box.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23confirm%3A%20message%20doing%3A%20oneArgumentBlock"));

smalltalk.bind(smalltalk.Notification,"beep:","beep_"

,function (times){var self=this;return self.handle().beep(times);return self;}

,"beep",unescape("beep%3A%20times%0D%0A%09%22%20The%20device%20will%20play%20beep%20sound.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23beep%3A%20times"));

smalltalk.bind(smalltalk.Notification,"beep","beep"

,function (){var self=this;return self.beep_((1));return self;}

,"beep",unescape("beep%0D%0A%09%22%20The%20device%20will%20play%20beep%20sound.%20%22%0D%0A%0D%0A%09%5Eself%20beep%3A%201"));

smalltalk.bind(smalltalk.Notification,"vibrate:","vibrate_"

,function (milliseconds){var self=this;return self.handle().vibrate(milliseconds);return self;}

,"vibration",unescape("vibrate%3A%20milliseconds%0D%0A%09%22%20Vibrates%20the%20device%20for%20the%20specified%20amount%20of%20time.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23vibrate%3A%20milliseconds"));

smalltalk.bind(smalltalk.Notification,"vibrate","vibrate"

,function (){var self=this;return self.vibrate_((1000));return self;}

,"vibration",unescape("vibrate%0D%0A%09%22%20Vibrates%20the%20device%20during%201%20second.%20%22%0D%0A%0D%0A%09%5Eself%20vibrate%3A%201000"));

smalltalk.bind(smalltalk.GeoCoordinates,"latitude","latitude"

,function (){var self=this;return (self.handle()["latitude"] || nil);return self;}

,"accessing",unescape("latitude%0D%0A%09%22%20Return%20the%20latitude%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27latitude%27"));

smalltalk.bind(smalltalk.GeoCoordinates,"latitude:","latitude_"

,function (anObject){var self=this;(self.handle()["latitude"]=(anObject));return self;}

,"accessing",unescape("latitude%3A%20anObject%0D%0A%09%22%20Set%20the%20latitude%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27latitude%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.GeoCoordinates,"longitude","longitude"

,function (){var self=this;return (self.handle()["longitude"] || nil);return self;}

,"accessing",unescape("longitude%0D%0A%09%22%20Return%20the%20longitude%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27longitude%27"));

smalltalk.bind(smalltalk.GeoCoordinates,"longitude:","longitude_"

,function (anObject){var self=this;(self.handle()["longitude"]=(anObject));return self;}

,"accessing",unescape("longitude%3A%20anObject%0D%0A%09%22%20Set%20the%20longitude%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27longitude%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.GeoCoordinates,"altitude","altitude"

,function (){var self=this;return (self.handle()["altitude"] || nil);return self;}

,"accessing",unescape("altitude%0D%0A%09%22%20Return%20the%20altitude%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27altitude%27"));

smalltalk.bind(smalltalk.GeoCoordinates,"altitude:","altitude_"

,function (anObject){var self=this;(self.handle()["altitude"]=(anObject));return self;}

,"accessing",unescape("altitude%3A%20anObject%0D%0A%09%22%20Set%20the%20altitude%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27altitude%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.GeoCoordinates,"accuracy","accuracy"

,function (){var self=this;return (self.handle()["accuracy"] || nil);return self;}

,"accessing",unescape("accuracy%0D%0A%09%22%20Return%20the%20accuracy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27accuracy%27"));

smalltalk.bind(smalltalk.GeoCoordinates,"accuracy:","accuracy_"

,function (anObject){var self=this;(self.handle()["accuracy"]=(anObject));return self;}

,"accessing",unescape("accuracy%3A%20anObject%0D%0A%09%22%20Set%20the%20accuracy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27accuracy%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.GeoCoordinates,"altitudeAccuracy","altitudeAccuracy"

,function (){var self=this;return (self.handle()["altitudeAccuracy"] || nil);return self;}

,"accessing",unescape("altitudeAccuracy%0D%0A%09%22%20Return%20the%20altitudeAccuracy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27altitudeAccuracy%27"));

smalltalk.bind(smalltalk.GeoCoordinates,"altitudeAccuracy:","altitudeAccuracy_"

,function (anObject){var self=this;(self.handle()["altitudeAccuracy"]=(anObject));return self;}

,"accessing",unescape("altitudeAccuracy%3A%20anObject%0D%0A%09%22%20Set%20the%20altitudeAccuracy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27altitudeAccuracy%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.GeoCoordinates,"heading","heading"

,function (){var self=this;return (self.handle()["heading"] || nil);return self;}

,"accessing",unescape("heading%0D%0A%09%22%20Return%20the%20heading%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27heading%27"));

smalltalk.bind(smalltalk.GeoCoordinates,"heading:","heading_"

,function (anObject){var self=this;(self.handle()["heading"]=(anObject));return self;}

,"accessing",unescape("heading%3A%20anObject%0D%0A%09%22%20Set%20the%20heading%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27heading%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.GeoCoordinates,"speed","speed"

,function (){var self=this;return (self.handle()["speed"] || nil);return self;}

,"accessing",unescape("speed%0D%0A%09%22%20Return%20the%20speed%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27speed%27"));

smalltalk.bind(smalltalk.GeoCoordinates,"speed:","speed_"

,function (anObject){var self=this;(self.handle()["speed"]=(anObject));return self;}

,"accessing",unescape("speed%3A%20anObject%0D%0A%09%22%20Set%20the%20speed%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27speed%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.GeoPosition,"timestamp","timestamp"

,function (){var self=this;return (self.handle()["timestamp"] || nil);return self;}

,"accessing",unescape("timestamp%0D%0A%09%22%20Return%20the%20timestamp%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27timestamp%27"));

smalltalk.bind(smalltalk.GeoPosition,"coordinates","coordinates"

,function (){var self=this;return smalltalk.GeoCoordinates._at(self['@handle'].coords);return self;}

,"accessing",unescape("coordinates%0D%0A%09%22%20Return%20the%20geographic%20coordinates%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EGeoCoordinates%20@%20handle%23coords"));

smalltalk.bind(smalltalk.GeoPosition,"coords","coords"

,function (){var self=this;return self.coordinates();return self;}

,"accessing",unescape("coords%0D%0A%09%22%20Return%20the%20geographic%20coordinates%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20coordinates"));

smalltalk.bind(smalltalk.FileUploadResult,"bytesSent","bytesSent"

,function (){var self=this;return (self.handle()["bytesSent"] || nil);return self;}

,"accessing",unescape("bytesSent%0D%0A%09%22%20Return%20the%20bytesSent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27bytesSent%27"));

smalltalk.bind(smalltalk.FileUploadResult,"responseCode","responseCode"

,function (){var self=this;return (self.handle()["responseCode"] || nil);return self;}

,"accessing",unescape("responseCode%0D%0A%09%22%20Return%20the%20responseCode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27responseCode%27"));

smalltalk.bind(smalltalk.FileUploadResult,"response","response"

,function (){var self=this;return (self.handle()["response"] || nil);return self;}

,"accessing",unescape("response%0D%0A%09%22%20Return%20the%20response%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27response%27"));

smalltalk.bind(smalltalk.FileUploadOptions.$klass,"fromArray:","fromArray_"

,function (options){var self=this;return self.$$new().initialize_(options);return self;}

,unescape("instance%20creation"),unescape("fromArray%3A%20options%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%20initialize%3A%20options"));

smalltalk.bind(smalltalk.FileUploadOptions,"fileKey","fileKey"

,function (){var self=this;return (self.handle()["fileKey"] || nil);return self;}

,"accessing",unescape("fileKey%0D%0A%09%22%20Return%20the%20fileKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27fileKey%27"));

smalltalk.bind(smalltalk.FileUploadOptions,"fileKey:","fileKey_"

,function (anObject){var self=this;(self.handle()["fileKey"]=(anObject));return self;}

,"accessing",unescape("fileKey%3A%20anObject%0D%0A%09%22%20Set%20the%20fileKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fileKey%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileUploadOptions,"fileName","fileName"

,function (){var self=this;return (self.handle()["fileName"] || nil);return self;}

,"accessing",unescape("fileName%0D%0A%09%22%20Return%20the%20fileName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27fileName%27"));

smalltalk.bind(smalltalk.FileUploadOptions,"fileName:","fileName_"

,function (anObject){var self=this;(self.handle()["fileName"]=(anObject));return self;}

,"accessing",unescape("fileName%3A%20anObject%0D%0A%09%22%20Set%20the%20fileName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fileName%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileUploadOptions,"mimeType","mimeType"

,function (){var self=this;return (self.handle()["mimeType"] || nil);return self;}

,"accessing",unescape("mimeType%0D%0A%09%22%20Return%20the%20mimeType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27mimeType%27"));

smalltalk.bind(smalltalk.FileUploadOptions,"mimeType:","mimeType_"

,function (anObject){var self=this;(self.handle()["mimeType"]=(anObject));return self;}

,"accessing",unescape("mimeType%3A%20anObject%0D%0A%09%22%20Set%20the%20mimeType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27mimeType%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileUploadOptions,"params","params"

,function (){var self=this;return (self.handle()["params"] || nil);return self;}

,"accessing",unescape("params%0D%0A%09%22%20Return%20the%20params%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27params%27"));

smalltalk.bind(smalltalk.FileUploadOptions,"params:","params_"

,function (anObject){var self=this;(self.handle()["params"]=(anObject));return self;}

,"accessing",unescape("params%3A%20anObject%0D%0A%09%22%20Set%20the%20params%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27params%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileUploadOptions,"chunkedMode","chunkedMode"

,function (){var self=this;return (self.handle()["chunkedMode"] || nil);return self;}

,"accessing",unescape("chunkedMode%0D%0A%09%22%20Return%20the%20chunkedMode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27chunkedMode%27"));

smalltalk.bind(smalltalk.FileUploadOptions,"chunkedMode:","chunkedMode_"

,function (anObject){var self=this;(self.handle()["chunkedMode"]=(anObject));return self;}

,"accessing",unescape("chunkedMode%3A%20anObject%0D%0A%09%22%20Set%20the%20chunkedMode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27chunkedMode%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileUploadOptions,"initializeHandle","initializeHandle"

,function (){var self=this;self['@handle']=smalltalk.Object.$$new();return self;}

,"initialize/release",unescape("initializeHandle%0D%0A%09%22%20Private%20-%20Initialize%20the%20native%20handle.%20%22%0D%0A%0D%0A%09handle%20%3A%3D%20Object%20new."));

smalltalk.bind(smalltalk.FileUploadOptions,"initialize:","initialize_"

,function (options){var self=this;self.set_with_(self.handle(), options);return self;}

,"initialize/release",unescape("initialize%3A%20options%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20set%3A%20self%20handle%20with%3A%20options."));

smalltalk.bind(smalltalk.FileUploadOptions,"set:with:","set_with_"

,function (anObject,array){var self=this;array.do_((function(tuple){return (anObject[tuple.first()]=(((tuple.last().isArray()).mustBeBoolean()==true ? (function(){return self.set_with_(smalltalk.Object.$$new(), tuple.last());})() : (function(){return tuple.last();})())));}));

return anObject;return self;}

,"private",unescape("set%3A%20anObject%20with%3A%20array%0D%0A%09%22%20Private%20-%20Set%20anObject%20with%20tuples%20in%20array.%0D%0A%09Return%20anObject.%0D%0A%09%22%0D%0A%0D%0A%09array%20do%3A%20%5B%3Atuple%7C%0D%0A%09%09anObject%0D%0A%09%09%09basicAt%3A%20tuple%20first%0D%0A%09%09%09put%3A%20%28tuple%20last%20isArray%0D%0A%09%09%09%09ifTrue%3A%20%5B%20self%20set%3A%20Object%20new%20with%3A%20tuple%20last%20%5D%0D%0A%09%09%09%09ifFalse%3A%20%5B%20tuple%20last%20%5D%29%0D%0A%09%5D.%0D%0A%09%5EanObject"));

smalltalk.bind(smalltalk.FileTransfer.$klass,"errorCodeTable","errorCodeTable"

,function (){var self=this;return [[(1), "File not found"], [(2), "Invalid URL"], [(3), "Connection"]];return self;}

,"private",unescape("errorCodeTable%0D%0A%09%22%20Private%20-%20Return%20an%20error%20code/description%20table.%20%22%0D%0A%0D%0A%09%5E%23%28%0D%0A%09%09%23%28%20%201%20%27File%20not%20found%27%20%29%0D%0A%09%09%23%28%20%202%20%27Invalid%20URL%27%20%29%0D%0A%09%09%23%28%20%203%20%27Connection%27%20%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.FileTransfer,"upload:to:doing:onError:options:","upload_to_doing_onError_options_"

,function (fileURI,serverURL,aBlock,errorBlock,options){var self=this;var action=nil;action=(function(data){return aBlock.value_(smalltalk.FileUploadResult._at(data));});

self.handle().upload(fileURI, serverURL, action, self.errorBlock_(errorBlock), self.optionsFrom_(options));return self;}

,"actions",unescape("upload%3A%20fileURI%20to%3A%20serverURL%20doing%3A%20aBlock%20onError%3A%20errorBlock%20options%3A%20options%0D%0A%09%22%20Provides%20a%20way%20to%20upload%20files%20to%20a%20remote%20server%20using%20an%20HTTP%20multi-part%20POST%20request.%0D%0A%09Both%20HTTP%20and%20HTTPS%20protocols%20are%20supported.%0D%0A%09Optional%20parameters%20can%20be%20specified%20by%20passing%20aFileUploadOptions%20to%20the%20upload%20method.%0D%0A%09On%20successful%20upload%2C%20aBlock%20with%20aFileUploadResult.%0D%0A%09If%20an%20error%20occurs%2C%20the%20errorBlock%20is%20evaluated%20with%20aFileTransferError.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20FileUploadResult%20@%20data%20%5D.%0D%0A%09self%20handle%0D%0A%09%09%23upload%3A%20fileURI%20to%3A%20serverURL%20doing%3A%20action%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29%0D%0A%09%09options%3A%20%28self%20optionsFrom%3A%20options%29"));

smalltalk.bind(smalltalk.FileTransfer,"upload:to:doing:onError:","upload_to_doing_onError_"

,function (fileURI,serverURL,aBlock,errorBlock){var self=this;return self.upload_to_doing_onError_options_(fileURI, serverURL, aBlock, errorBlock, nil);return self;}

,"actions",unescape("upload%3A%20fileURI%20to%3A%20serverURL%20doing%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Provides%20a%20way%20to%20upload%20files%20to%20a%20remote%20server%20using%20an%20HTTP%20multi-part%20POST%20request.%20%22%0D%0A%0D%0A%09%5Eself%20upload%3A%20fileURI%20to%3A%20serverURL%20doing%3A%20aBlock%20onError%3A%20errorBlock%20options%3A%20nil"));

smalltalk.bind(smalltalk.FileTransfer,"upload:to:doing:options:","upload_to_doing_options_"

,function (fileURI,serverURL,aBlock,options){var self=this;return self.upload_to_doing_onError_options_(fileURI, serverURL, aBlock, nil, options);return self;}

,"actions",unescape("upload%3A%20fileURI%20to%3A%20serverURL%20doing%3A%20aBlock%20options%3A%20options%0D%0A%09%22%20Provides%20a%20way%20to%20upload%20files%20to%20a%20remote%20server%20using%20an%20HTTP%20multi-part%20POST%20request.%20%22%0D%0A%0D%0A%09%5Eself%20upload%3A%20fileURI%20to%3A%20serverURL%20doing%3A%20aBlock%20onError%3A%20nil%20options%3A%20options"));

smalltalk.bind(smalltalk.FileTransfer,"upload:to:doing:","upload_to_doing_"

,function (fileURI,serverURL,aBlock){var self=this;return self.upload_to_doing_onError_options_(fileURI, serverURL, aBlock, nil, nil);return self;}

,"actions",unescape("upload%3A%20fileURI%20to%3A%20serverURL%20doing%3A%20aBlock%0D%0A%09%22%20Provides%20a%20way%20to%20upload%20files%20to%20a%20remote%20server%20using%20an%20HTTP%20multi-part%20POST%20request.%20%22%0D%0A%0D%0A%09%5Eself%20upload%3A%20fileURI%20to%3A%20serverURL%20doing%3A%20aBlock%20onError%3A%20nil%20options%3A%20nil"));

smalltalk.bind(smalltalk.FileTransfer,"optionsFrom:","optionsFrom_"

,function (options){var self=this;try{((((options || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "optionsFrom_", fn: function(){return null}})})();})() : nil);

((options.isArray()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "optionsFrom_", fn: function(){return smalltalk.FileUploadOptions.fromArray_(options).handle()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "optionsFrom_", fn: function(){return options}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "optionsFrom_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("optionsFrom%3A%20options%0D%0A%09%22%20Private%20-%20Return%20a%20FileUploadOptions%20from%20options.%20%22%0D%0A%0D%0A%09options%20isNil%20ifTrue%3A%20%5B%20%5E%23%7Bnull%7D%20%5D.%0D%0A%09options%20isArray%20ifTrue%3A%20%5B%20%5E%28FileUploadOptions%20fromArray%3A%20options%29%20handle%20%5D.%0D%0A%09%5Eoptions"));

smalltalk.bind(smalltalk.DirectoryReader,"entriesDo:onError:","entriesDo_onError_"

,function (aBlock,errorBlock){var self=this;var action=nil;action=(function(entries){return aBlock.value_(entries.collect_((function(each){return smalltalk.FileSystemElement.entryFrom_(each);})));});

self.handle().readEntries(action, self.errorBlock_(errorBlock));return self;}

,"accessing",unescape("entriesDo%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20entries%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20%5B%3Aentries%7C%20aBlock%20value%3A%20%28entries%20collect%3A%20%5B%3Aeach%7C%20FileSystemElement%20entryFrom%3A%20each%20%5D%29%20%5D.%0D%0A%09self%20handle%0D%0A%09%09%23readEntries%3A%20action%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.DirectoryReader,"entriesDo:","entriesDo_"

,function (aBlock){var self=this;return self.entriesDo_onError_(aBlock, nil);return self;}

,"accessing",unescape("entriesDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20entries%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20entriesDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.DirectoryReader,"withEntriesDo:","withEntriesDo_"

,function (aBlock){var self=this;return self.entriesDo_onError_(aBlock, nil);return self;}

,"accessing",unescape("withEntriesDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20entries%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20entriesDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.PG8File,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.PG8File,"fullPath","fullPath"

,function (){var self=this;return (self.handle()["fullPath"] || nil);return self;}

,"accessing",unescape("fullPath%0D%0A%09%22%20Return%20the%20fullPath%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27fullPath%27"));

smalltalk.bind(smalltalk.PG8File,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.PG8File,"lastModifiedDate","lastModifiedDate"

,function (){var self=this;return (self.handle()["lastModifiedDate"] || nil);return self;}

,"accessing",unescape("lastModifiedDate%0D%0A%09%22%20Return%20the%20lastModifiedDate%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27lastModifiedDate%27"));

smalltalk.bind(smalltalk.PG8File,"size","size"

,function (){var self=this;return (self.handle()["size"] || nil);return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27size%27"));

smalltalk.bind(smalltalk.Metadata,"modificationTime","modificationTime"

,function (){var self=this;return (self.handle()["modificationTime"] || nil);return self;}

,"accessing",unescape("modificationTime%0D%0A%09%22%20Return%20the%20modificationTime%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27modificationTime%27"));

smalltalk.bind(smalltalk.FileAccessor.$klass,"phoneGapEvents","phoneGapEvents"

,function (){var self=this;return ["progress:", "progress", "onProgress:", "onProgress", "onprogress", "abort", "onAbort", "onabort", "error", "error:", "onError:", "onError", "onerror"];return self;}

,"events",unescape("phoneGapEvents%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20PhoneGap.%20%22%0D%0A%0D%0A%09%5E%23%28%09%23progress%3A%20%23progress%20%23onProgress%3A%20%23onProgress%20%23onprogress%0D%0A%09%09%23abort%20%23onAbort%20%23onabort%0D%0A%09%09%23error%20%23error%3A%20%23onError%3A%20%23onError%20%23onerror%0D%0A%09%29"));

smalltalk.bind(smalltalk.FileAccessor,"readyState","readyState"

,function (){var self=this;return (self.handle()["readyState"] || nil);return self;}

,"accessing",unescape("readyState%0D%0A%09%22%20Return%20the%20readyState%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27readyState%27"));

smalltalk.bind(smalltalk.FileAccessor,"readyState:","readyState_"

,function (anObject){var self=this;(self.handle()["readyState"]=(anObject));return self;}

,"accessing",unescape("readyState%3A%20anObject%0D%0A%09%22%20Set%20the%20readyState%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27readyState%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileAccessor,"error","error"

,function (){var self=this;return (self.handle()["error"] || nil);return self;}

,"accessing",unescape("error%0D%0A%09%22%20Return%20the%20error%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27error%27"));

smalltalk.bind(smalltalk.FileAccessor,"error:","error_"

,function (anObject){var self=this;(self.handle()["error"]=(anObject));return self;}

,"accessing",unescape("error%3A%20anObject%0D%0A%09%22%20Set%20the%20error%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27error%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileAccessor,"onprogress","onprogress"

,function (){var self=this;return (self.handle()["onprogress"] || nil);return self;}

,"accessing",unescape("onprogress%0D%0A%09%22%20Return%20the%20onprogress%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onprogress%27"));

smalltalk.bind(smalltalk.FileAccessor,"onprogress:","onprogress_"

,function (anObject){var self=this;(self.handle()["onprogress"]=(anObject));return self;}

,"accessing",unescape("onprogress%3A%20anObject%0D%0A%09%22%20Set%20the%20onprogress%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onprogress%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileAccessor,"onabort","onabort"

,function (){var self=this;return (self.handle()["onabort"] || nil);return self;}

,"accessing",unescape("onabort%0D%0A%09%22%20Return%20the%20onabort%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onabort%27"));

smalltalk.bind(smalltalk.FileAccessor,"onabort:","onabort_"

,function (anObject){var self=this;(self.handle()["onabort"]=(anObject));return self;}

,"accessing",unescape("onabort%3A%20anObject%0D%0A%09%22%20Set%20the%20onabort%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onabort%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileAccessor,"onerror","onerror"

,function (){var self=this;return (self.handle()["onerror"] || nil);return self;}

,"accessing",unescape("onerror%0D%0A%09%22%20Return%20the%20onerror%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onerror%27"));

smalltalk.bind(smalltalk.FileAccessor,"onerror:","onerror_"

,function (anObject){var self=this;(self.handle()["onerror"]=(anObject));return self;}

,"accessing",unescape("onerror%3A%20anObject%0D%0A%09%22%20Set%20the%20onerror%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onerror%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileAccessor,"onEventName:","onEventName_"

,function (anEvent){var self=this;try{var selector=nil;selector=anEvent.upTo_(":").asLowercase();

((selector.copyFrom_to_((1), (2))._eq("on")).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "onEventName_", fn: function(){return "on"._comma(selector)}})})();})());

(function(){throw({name: "stReturn", selector: "onEventName_", fn: function(){return selector}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "onEventName_"){return $$ex.fn();} throw($$ex);}}

,"private-events",unescape("onEventName%3A%20anEvent%0D%0A%09%22%20Private%20-%20Return%20the%20phoneGap%20name%20for%20onxxx%20event.%20%22%0D%0A%0D%0A%09%7C%20selector%20%7C%0D%0A%09selector%20%3A%3D%20%28anEvent%20upTo%3A%20%24%3A%29%20asLowercase.%0D%0A%09%28selector%20copyFrom%3A%201%20to%3A%202%29%20%3D%20%23on%20ifFalse%3A%20%5B%20%5E%23on%20%2C%20selector%20%5D.%0D%0A%09%5Eselector"));

smalltalk.bind(smalltalk.FileAccessor,"whenPhoneGap:evaluate:","whenPhoneGap_evaluate_"

,function (anEvent,anAction){var self=this;var action=nil;action=((anEvent.includes_(":")).mustBeBoolean()==true ? (function(){return (function(argument){return self.triggerEvent_with_(anEvent, argument);});})() : (function(){return (function(){return self.triggerEvent_(anEvent);});})());

(self.handle()[self.onEventName_(anEvent)]=(action));return self;}

,"private-events",unescape("whenPhoneGap%3A%20anEvent%20evaluate%3A%20anAction%0D%0A%09%22%20Private%20-%20Register%20anAction%20to%20the%20be%20evaluated%20when%20the%20receiver%20triggers%20the%20event.%20%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20%28anEvent%20includes%3A%20%24%3A%29%0D%0A%09%09ifTrue%3A%20%5B%20%5B%3Aargument%7C%20self%20triggerEvent%3A%20anEvent%20with%3A%20argument%20%5D%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20%5B%20self%20triggerEvent%3A%20anEvent%20%5D%20%5D.%0D%0A%09self%20handle%20basicAt%3A%20%28self%20onEventName%3A%20anEvent%29%20put%3A%20action."));

smalltalk.bind(smalltalk.FileAccessor,"abort","abort"

,function (){var self=this;self.handle().abort();return self;}

,"actions",unescape("abort%0D%0A%09%22%20Abort%20operation.%20%22%0D%0A%0D%0A%09self%20handle%20abort"));

smalltalk.bind(smalltalk.FileEntity.$klass,"service","service"

,function (){var self=this;return self;return self;}

,"accessing",unescape("service%0D%0A%09%22%20Return%20the%20%28async%29service%20to%20access%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.FileEntity.$klass,"with:do:onError:","with_do_onError_"

,function (uri,aBlock,errorBlock){var self=this;var action=nil;action=(function(data){return aBlock.value_(self._at(data));});

window.resolveLocalFileSystemURI(uri, action, self.errorBlock_(errorBlock));return self;}

,"service",unescape("with%3A%20uri%20do%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%0D%0A%09Evaluate%20errorBlock%20in%20case%20on%20error%20accessing%20the%20resource.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20self%20@%20data%20%5D.%0D%0A%09%23%7Bwindow%7D%20%23resolveLocalFileSystemURI%3A%20uri%0D%0A%09%09onSuccess%3A%20action%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.FileEntity.$klass,"with:do:","with_do_"

,function (uri,aBlock){var self=this;return self.with_do_onError_(uri, aBlock, nil);return self;}

,"service",unescape("with%3A%20uri%20do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%20%22%0D%0A%0D%0A%09%5Eself%20with%3A%20uri%20do%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileEntity.$klass,"errorCodeTable","errorCodeTable"

,function (){var self=this;return [[(1), "Entry not found"], [(2), "Security"], [(3), "Abort"], [(4), "Not readable"], [(5), "Encoding"], [(6), "No modification allowed"], [(7), "Invalid state"], [(8), "Syntax"], [(9), "Invalid modification"], [(10), "Quota exceeded"], [(11), "Type mismatch"], [(11), "Path exists"]];return self;}

,"private",unescape("errorCodeTable%0D%0A%09%22%20Private%20-%20Return%20an%20error%20code/description%20table.%20%22%0D%0A%0D%0A%09%5E%23%28%09%23%28%20%201%20%27Entry%20not%20found%27%20%29%0D%0A%09%09%23%28%20%202%20%27Security%27%20%29%0D%0A%09%09%23%28%20%203%20%27Abort%27%20%29%0D%0A%09%09%23%28%20%204%20%27Not%20readable%27%20%29%0D%0A%09%09%23%28%20%205%20%27Encoding%27%20%29%0D%0A%09%09%23%28%20%206%20%27No%20modification%20allowed%27%20%29%0D%0A%09%09%23%28%20%207%20%27Invalid%20state%27%20%29%0D%0A%09%09%23%28%20%208%20%27Syntax%27%20%29%0D%0A%09%09%23%28%20%209%20%27Invalid%20modification%27%20%29%0D%0A%09%09%23%28%2010%20%27Quota%20exceeded%27%20%29%0D%0A%09%09%23%28%2011%20%27Type%20mismatch%27%20%29%0D%0A%09%09%23%28%2011%20%27Path%20exists%27%20%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.FileEntity,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.FileEntity,"fullPath","fullPath"

,function (){var self=this;return (self.handle()["fullPath"] || nil);return self;}

,"accessing",unescape("fullPath%0D%0A%09%22%20Return%20the%20fullPath%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27fullPath%27"));

smalltalk.bind(smalltalk.ContactOrganization,"pref","pref"

,function (){var self=this;return (self.handle()["pref"] || nil);return self;}

,"accessing",unescape("pref%0D%0A%09%22%20Return%20the%20pref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27pref%27"));

smalltalk.bind(smalltalk.ContactOrganization,"pref:","pref_"

,function (anObject){var self=this;(self.handle()["pref"]=(anObject));return self;}

,"accessing",unescape("pref%3A%20anObject%0D%0A%09%22%20Set%20the%20pref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27pref%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactOrganization,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.ContactOrganization,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactOrganization,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.ContactOrganization,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactOrganization,"department","department"

,function (){var self=this;return (self.handle()["department"] || nil);return self;}

,"accessing",unescape("department%0D%0A%09%22%20Return%20the%20department%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27department%27"));

smalltalk.bind(smalltalk.ContactOrganization,"department:","department_"

,function (anObject){var self=this;(self.handle()["department"]=(anObject));return self;}

,"accessing",unescape("department%3A%20anObject%0D%0A%09%22%20Set%20the%20department%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27department%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactOrganization,"title","title"

,function (){var self=this;return (self.handle()["title"] || nil);return self;}

,"accessing",unescape("title%0D%0A%09%22%20Return%20the%20title%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27title%27"));

smalltalk.bind(smalltalk.ContactOrganization,"title:","title_"

,function (anObject){var self=this;(self.handle()["title"]=(anObject));return self;}

,"accessing",unescape("title%3A%20anObject%0D%0A%09%22%20Set%20the%20title%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27title%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactName,"formatted","formatted"

,function (){var self=this;return (self.handle()["formatted"] || nil);return self;}

,"accessing",unescape("formatted%0D%0A%09%22%20Return%20the%20formatted%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27formatted%27"));

smalltalk.bind(smalltalk.ContactName,"formatted:","formatted_"

,function (anObject){var self=this;(self.handle()["formatted"]=(anObject));return self;}

,"accessing",unescape("formatted%3A%20anObject%0D%0A%09%22%20Set%20the%20formatted%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27formatted%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactName,"familyName","familyName"

,function (){var self=this;return (self.handle()["familyName"] || nil);return self;}

,"accessing",unescape("familyName%0D%0A%09%22%20Return%20the%20familyName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27familyName%27"));

smalltalk.bind(smalltalk.ContactName,"familyName:","familyName_"

,function (anObject){var self=this;(self.handle()["familyName"]=(anObject));return self;}

,"accessing",unescape("familyName%3A%20anObject%0D%0A%09%22%20Set%20the%20familyName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27familyName%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactName,"givenName","givenName"

,function (){var self=this;return (self.handle()["givenName"] || nil);return self;}

,"accessing",unescape("givenName%0D%0A%09%22%20Return%20the%20givenName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27givenName%27"));

smalltalk.bind(smalltalk.ContactName,"givenName:","givenName_"

,function (anObject){var self=this;(self.handle()["givenName"]=(anObject));return self;}

,"accessing",unescape("givenName%3A%20anObject%0D%0A%09%22%20Set%20the%20givenName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27givenName%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactName,"middleName","middleName"

,function (){var self=this;return (self.handle()["middleName"] || nil);return self;}

,"accessing",unescape("middleName%0D%0A%09%22%20Return%20the%20middleName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27middleName%27"));

smalltalk.bind(smalltalk.ContactName,"middleName:","middleName_"

,function (anObject){var self=this;(self.handle()["middleName"]=(anObject));return self;}

,"accessing",unescape("middleName%3A%20anObject%0D%0A%09%22%20Set%20the%20middleName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27middleName%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactName,"honorificPrefix","honorificPrefix"

,function (){var self=this;return (self.handle()["honorificPrefix"] || nil);return self;}

,"accessing",unescape("honorificPrefix%0D%0A%09%22%20Return%20the%20honorificPrefix%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27honorificPrefix%27"));

smalltalk.bind(smalltalk.ContactName,"honorificPrefix:","honorificPrefix_"

,function (anObject){var self=this;(self.handle()["honorificPrefix"]=(anObject));return self;}

,"accessing",unescape("honorificPrefix%3A%20anObject%0D%0A%09%22%20Set%20the%20honorificPrefix%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27honorificPrefix%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactName,"honorificSuffix","honorificSuffix"

,function (){var self=this;return (self.handle()["honorificSuffix"] || nil);return self;}

,"accessing",unescape("honorificSuffix%0D%0A%09%22%20Return%20the%20honorificSuffix%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27honorificSuffix%27"));

smalltalk.bind(smalltalk.ContactName,"honorificSuffix:","honorificSuffix_"

,function (anObject){var self=this;(self.handle()["honorificSuffix"]=(anObject));return self;}

,"accessing",unescape("honorificSuffix%3A%20anObject%0D%0A%09%22%20Set%20the%20honorificSuffix%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27honorificSuffix%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactField,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.ContactField,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactField,"value","value"

,function (){var self=this;return (self.handle()["value"] || nil);return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27value%27"));

smalltalk.bind(smalltalk.ContactField,"value:","value_"

,function (anObject){var self=this;(self.handle()["value"]=(anObject));return self;}

,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27value%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactField,"pref","pref"

,function (){var self=this;return (self.handle()["pref"] || nil);return self;}

,"accessing",unescape("pref%0D%0A%09%22%20Return%20the%20pref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27pref%27"));

smalltalk.bind(smalltalk.ContactField,"pref:","pref_"

,function (anObject){var self=this;(self.handle()["pref"]=(anObject));return self;}

,"accessing",unescape("pref%3A%20anObject%0D%0A%09%22%20Set%20the%20pref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27pref%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactAddress,"pref","pref"

,function (){var self=this;return (self.handle()["pref"] || nil);return self;}

,"accessing",unescape("pref%0D%0A%09%22%20Return%20the%20pref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27pref%27"));

smalltalk.bind(smalltalk.ContactAddress,"pref:","pref_"

,function (anObject){var self=this;(self.handle()["pref"]=(anObject));return self;}

,"accessing",unescape("pref%3A%20anObject%0D%0A%09%22%20Set%20the%20pref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27pref%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactAddress,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.ContactAddress,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactAddress,"formatted","formatted"

,function (){var self=this;return (self.handle()["formatted"] || nil);return self;}

,"accessing",unescape("formatted%0D%0A%09%22%20Return%20the%20formatted%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27formatted%27"));

smalltalk.bind(smalltalk.ContactAddress,"formatted:","formatted_"

,function (anObject){var self=this;(self.handle()["formatted"]=(anObject));return self;}

,"accessing",unescape("formatted%3A%20anObject%0D%0A%09%22%20Set%20the%20formatted%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27formatted%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactAddress,"streetAddress","streetAddress"

,function (){var self=this;return (self.handle()["streetAddress"] || nil);return self;}

,"accessing",unescape("streetAddress%0D%0A%09%22%20Return%20the%20streetAddress%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27streetAddress%27"));

smalltalk.bind(smalltalk.ContactAddress,"streetAddress:","streetAddress_"

,function (anObject){var self=this;(self.handle()["streetAddress"]=(anObject));return self;}

,"accessing",unescape("streetAddress%3A%20anObject%0D%0A%09%22%20Set%20the%20streetAddress%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27streetAddress%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactAddress,"locality","locality"

,function (){var self=this;return (self.handle()["locality"] || nil);return self;}

,"accessing",unescape("locality%0D%0A%09%22%20Return%20the%20locality%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27locality%27"));

smalltalk.bind(smalltalk.ContactAddress,"locality:","locality_"

,function (anObject){var self=this;(self.handle()["locality"]=(anObject));return self;}

,"accessing",unescape("locality%3A%20anObject%0D%0A%09%22%20Set%20the%20locality%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27locality%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactAddress,"region","region"

,function (){var self=this;return (self.handle()["region"] || nil);return self;}

,"accessing",unescape("region%0D%0A%09%22%20Return%20the%20region%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27region%27"));

smalltalk.bind(smalltalk.ContactAddress,"region:","region_"

,function (anObject){var self=this;(self.handle()["region"]=(anObject));return self;}

,"accessing",unescape("region%3A%20anObject%0D%0A%09%22%20Set%20the%20region%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27region%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactAddress,"postalCode","postalCode"

,function (){var self=this;return (self.handle()["postalCode"] || nil);return self;}

,"accessing",unescape("postalCode%0D%0A%09%22%20Return%20the%20postalCode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27postalCode%27"));

smalltalk.bind(smalltalk.ContactAddress,"postalCode:","postalCode_"

,function (anObject){var self=this;(self.handle()["postalCode"]=(anObject));return self;}

,"accessing",unescape("postalCode%3A%20anObject%0D%0A%09%22%20Set%20the%20postalCode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27postalCode%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ContactAddress,"country","country"

,function (){var self=this;return (self.handle()["country"] || nil);return self;}

,"accessing",unescape("country%0D%0A%09%22%20Return%20the%20country%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27country%27"));

smalltalk.bind(smalltalk.ContactAddress,"country:","country_"

,function (anObject){var self=this;(self.handle()["country"]=(anObject));return self;}

,"accessing",unescape("country%3A%20anObject%0D%0A%09%22%20Set%20the%20country%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27country%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"id","id"

,function (){var self=this;return (self.handle()["id"] || nil);return self;}

,"accessing",unescape("id%0D%0A%09%22%20Return%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27id%27"));

smalltalk.bind(smalltalk.Contact,"id:","id_"

,function (anObject){var self=this;(self.handle()["id"]=(anObject));return self;}

,"accessing",unescape("id%3A%20anObject%0D%0A%09%22%20Set%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27id%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"displayName","displayName"

,function (){var self=this;return (self.handle()["displayName"] || nil);return self;}

,"accessing",unescape("displayName%0D%0A%09%22%20Return%20the%20displayName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27displayName%27"));

smalltalk.bind(smalltalk.Contact,"displayName:","displayName_"

,function (anObject){var self=this;(self.handle()["displayName"]=(anObject));return self;}

,"accessing",unescape("displayName%3A%20anObject%0D%0A%09%22%20Set%20the%20displayName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27displayName%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.Contact,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"nickname","nickname"

,function (){var self=this;return (self.handle()["nickname"] || nil);return self;}

,"accessing",unescape("nickname%0D%0A%09%22%20Return%20the%20nickname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27nickname%27"));

smalltalk.bind(smalltalk.Contact,"nickname:","nickname_"

,function (anObject){var self=this;(self.handle()["nickname"]=(anObject));return self;}

,"accessing",unescape("nickname%3A%20anObject%0D%0A%09%22%20Set%20the%20nickname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27nickname%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"phoneNumbers","phoneNumbers"

,function (){var self=this;return (self.handle()["phoneNumbers"] || nil);return self;}

,"accessing",unescape("phoneNumbers%0D%0A%09%22%20Return%20the%20phoneNumbers%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27phoneNumbers%27"));

smalltalk.bind(smalltalk.Contact,"phoneNumbers:","phoneNumbers_"

,function (anObject){var self=this;(self.handle()["phoneNumbers"]=(anObject));return self;}

,"accessing",unescape("phoneNumbers%3A%20anObject%0D%0A%09%22%20Set%20the%20phoneNumbers%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27phoneNumbers%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"emails","emails"

,function (){var self=this;return (self.handle()["emails"] || nil);return self;}

,"accessing",unescape("emails%0D%0A%09%22%20Return%20the%20emails%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27emails%27"));

smalltalk.bind(smalltalk.Contact,"emails:","emails_"

,function (anObject){var self=this;(self.handle()["emails"]=(anObject));return self;}

,"accessing",unescape("emails%3A%20anObject%0D%0A%09%22%20Set%20the%20emails%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27emails%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"addresses","addresses"

,function (){var self=this;return (self.handle()["addresses"] || nil);return self;}

,"accessing",unescape("addresses%0D%0A%09%22%20Return%20the%20addresses%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27addresses%27"));

smalltalk.bind(smalltalk.Contact,"addresses:","addresses_"

,function (anObject){var self=this;(self.handle()["addresses"]=(anObject));return self;}

,"accessing",unescape("addresses%3A%20anObject%0D%0A%09%22%20Set%20the%20addresses%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27addresses%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"ims","ims"

,function (){var self=this;return (self.handle()["ims"] || nil);return self;}

,"accessing",unescape("ims%0D%0A%09%22%20Return%20the%20ims%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27ims%27"));

smalltalk.bind(smalltalk.Contact,"ims:","ims_"

,function (anObject){var self=this;(self.handle()["ims"]=(anObject));return self;}

,"accessing",unescape("ims%3A%20anObject%0D%0A%09%22%20Set%20the%20ims%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27ims%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"organizations","organizations"

,function (){var self=this;return (self.handle()["organizations"] || nil);return self;}

,"accessing",unescape("organizations%0D%0A%09%22%20Return%20the%20organizations%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27organizations%27"));

smalltalk.bind(smalltalk.Contact,"organizations:","organizations_"

,function (anObject){var self=this;(self.handle()["organizations"]=(anObject));return self;}

,"accessing",unescape("organizations%3A%20anObject%0D%0A%09%22%20Set%20the%20organizations%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27organizations%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"birthday","birthday"

,function (){var self=this;return (self.handle()["birthday"] || nil);return self;}

,"accessing",unescape("birthday%0D%0A%09%22%20Return%20the%20birthday%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27birthday%27"));

smalltalk.bind(smalltalk.Contact,"birthday:","birthday_"

,function (anObject){var self=this;(self.handle()["birthday"]=(anObject));return self;}

,"accessing",unescape("birthday%3A%20anObject%0D%0A%09%22%20Set%20the%20birthday%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27birthday%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"note","note"

,function (){var self=this;return (self.handle()["note"] || nil);return self;}

,"accessing",unescape("note%0D%0A%09%22%20Return%20the%20note%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27note%27"));

smalltalk.bind(smalltalk.Contact,"note:","note_"

,function (anObject){var self=this;(self.handle()["note"]=(anObject));return self;}

,"accessing",unescape("note%3A%20anObject%0D%0A%09%22%20Set%20the%20note%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27note%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"photos","photos"

,function (){var self=this;return (self.handle()["photos"] || nil);return self;}

,"accessing",unescape("photos%0D%0A%09%22%20Return%20the%20photos%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27photos%27"));

smalltalk.bind(smalltalk.Contact,"photos:","photos_"

,function (anObject){var self=this;(self.handle()["photos"]=(anObject));return self;}

,"accessing",unescape("photos%3A%20anObject%0D%0A%09%22%20Set%20the%20photos%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27photos%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"categories","categories"

,function (){var self=this;return (self.handle()["categories"] || nil);return self;}

,"accessing",unescape("categories%0D%0A%09%22%20Return%20the%20categories%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27categories%27"));

smalltalk.bind(smalltalk.Contact,"categories:","categories_"

,function (anObject){var self=this;(self.handle()["categories"]=(anObject));return self;}

,"accessing",unescape("categories%3A%20anObject%0D%0A%09%22%20Set%20the%20categories%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27categories%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"urls","urls"

,function (){var self=this;return (self.handle()["urls"] || nil);return self;}

,"accessing",unescape("urls%0D%0A%09%22%20Return%20the%20urls%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27urls%27"));

smalltalk.bind(smalltalk.Contact,"urls:","urls_"

,function (anObject){var self=this;(self.handle()["urls"]=(anObject));return self;}

,"accessing",unescape("urls%3A%20anObject%0D%0A%09%22%20Set%20the%20urls%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27urls%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Contact,"clone","clone"

,function (){var self=this;return self.$klass.$$new()._at(self.handle().clone());return self;}

,"copying",unescape("clone%0D%0A%09%22%20Return%20a%20new%20contact%20that%20is%20a%20deep%20copy%20of%20the%20receiver%2C%20with%20id%20set%20to%20null.%20%22%0D%0A%0D%0A%09%5Eself%20class%20new%20@%20self%20handle%20clone"));

smalltalk.bind(smalltalk.Contact,"remove","remove"

,function (){var self=this;self.handle().remove();return self;}

,"copying",unescape("remove%0D%0A%09%22%20Remove%20the%20receiver%20from%20device%20database.%20%22%0D%0A%0D%0A%09self%20handle%20remove"));

smalltalk.bind(smalltalk.Contact,"save","save"

,function (){var self=this;self.handle().save();return self;}

,"copying",unescape("save%0D%0A%09%22%20Save%20the%20receiver%20to%20device%20database.%0D%0A%09Saves%20a%20new%20contact%20to%20the%20device%20contacts%20database%2C%20or%20updates%20an%20existing%20contact%20if%20a%20contact%20with%20the%20same%20id%20already%20exists.%20%22%0D%0A%0D%0A%09self%20handle%20save"));

smalltalk.bind(smalltalk.CompassHeading,"magneticHeading","magneticHeading"

,function (){var self=this;return self['@handle'].magneticHeading;return self;}

,"accessing",unescape("magneticHeading%0D%0A%09%22%20Return%20the%20heading%20of%20the%20receiver.%0D%0A%09The%20heading%20in%20degrees%20from%200%20-%20359.99%20at%20a%20single%20moment%20in%20time.%20%28Number%29%20%22%0D%0A%0D%0A%09%5Ehandle%23magneticHeading"));

smalltalk.bind(smalltalk.CompassHeading,"trueHeading","trueHeading"

,function (){var self=this;return self['@handle'].trueHeading;return self;}

,"accessing",unescape("trueHeading%0D%0A%09%22%20Return%20the%20heading%20of%20the%20receiver.%0D%0A%09The%20heading%20relative%20to%20the%20geographic%20North%20Pole%20in%20degrees%200%20-%20359.99%20at%20a%20single%20moment%20in%20time.%0D%0A%09A%20negative%20value%20indicates%20that%20the%20true%20heading%20could%20not%20be%20determined.%20%28Number%29%20%22%0D%0A%0D%0A%09%5Ehandle%23trueHeading"));

smalltalk.bind(smalltalk.CompassHeading,"headingAccuracy","headingAccuracy"

,function (){var self=this;return self['@handle'].headingAccuracy;return self;}

,"accessing",unescape("headingAccuracy%0D%0A%09%22%20Return%20the%20heading%20accuracy%20of%20the%20receiver.%0D%0A%09The%20deviation%20in%20degrees%20between%20the%20reported%20heading%20and%20the%20true%20heading.%20%28Number%29%20%22%0D%0A%0D%0A%09%5Ehandle%23headingAccuracy"));

smalltalk.bind(smalltalk.CompassHeading,"timeStamp","timeStamp"

,function (){var self=this;return self['@handle'].timestamp;return self;}

,"accessing",unescape("timeStamp%0D%0A%09%22%20Return%20the%20timeStamp%20of%20the%20receiver.%0D%0A%09The%20time%20at%20which%20this%20heading%20was%20determined.%20%28milliseconds%29%20%22%0D%0A%0D%0A%09%5Ehandle%23timestamp"));

smalltalk.bind(smalltalk.MediaFileData,"height","height"

,function (){var self=this;return (self.handle()["height"] || nil);return self;}

,"accessing",unescape("height%0D%0A%09%22%20Return%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27height%27"));

smalltalk.bind(smalltalk.MediaFileData,"width","width"

,function (){var self=this;return (self.handle()["width"] || nil);return self;}

,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27width%27"));

smalltalk.bind(smalltalk.MediaFileData,"codecs","codecs"

,function (){var self=this;return (self.handle()["codecs"] || nil);return self;}

,"accessing",unescape("codecs%0D%0A%09%22%20Return%20the%20codecs%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27codecs%27"));

smalltalk.bind(smalltalk.MediaFileData,"bitrate","bitrate"

,function (){var self=this;return (self.handle()["bitrate"] || nil);return self;}

,"accessing",unescape("bitrate%0D%0A%09%22%20Return%20the%20bitrate%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27bitrate%27"));

smalltalk.bind(smalltalk.MediaFileData,"duration","duration"

,function (){var self=this;return (self.handle()["duration"] || nil);return self;}

,"accessing",unescape("duration%0D%0A%09%22%20Return%20the%20duration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27duration%27"));

smalltalk.bind(smalltalk.MediaFileData,"extent","extent"

,function (){var self=this;return self.width()._at(self.height());return self;}

,"accessing",unescape("extent%0D%0A%09%22%20Return%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.PhoneGapEvents.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D"));

smalltalk.bind(smalltalk.PhoneGapEvents.$klass,"phoneGapEvents","phoneGapEvents"

,function (){var self=this;return ["deviceReady", "deviceready", "pause", "resume", "online", "offline", "backButton", "backbutton", "menuButton", "menubutton", "searchButton", "searchbutton", "startCallButton", "startcallbutton", "endCallButton", "endcallbutton", "volumeDownButton", "volumedownbutton", "volumeUpButton", "volumeupbutton"];return self;}

,"events",unescape("phoneGapEvents%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20PhoneGap.%20%22%0D%0A%0D%0A%09%5E%23%28%09%23deviceReady%20%23deviceready%0D%0A%09%09%23pause%20%23resume%0D%0A%09%09%23online%20%23offline%0D%0A%09%09%23backButton%20%23backbutton%0D%0A%09%09%23menuButton%20%23menubutton%0D%0A%09%09%23searchButton%20%23searchbutton%0D%0A%09%09%23startCallButton%20%23startcallbutton%0D%0A%09%09%23endCallButton%20%23endcallbutton%0D%0A%09%09%23volumeDownButton%20%23volumedownbutton%0D%0A%09%09%23volumeUpButton%20%23volumeupbutton%0D%0A%09%29"));

smalltalk.bind(smalltalk.PhoneGapEvents,"whenPhoneGap:evaluate:","whenPhoneGap_evaluate_"

,function (anEvent,anAction){var self=this;document.addEventListener(anEvent.asLowercase(), (function(){return self.triggerEvent_(anEvent);}), false);return self;}

,"private-events",unescape("whenPhoneGap%3A%20anEvent%20evaluate%3A%20anAction%0D%0A%09%22%20Private%20-%20Register%20anAction%20to%20the%20be%20evaluated%20when%20the%20receiver%20triggers%20the%20event.%20%22%0D%0A%0D%0A%09%23%7Bdocument%7D%0D%0A%09%09%23addEventListener%3A%20anEvent%20asLowercase%0D%0A%09%09doing%3A%20%5B%20self%20triggerEvent%3A%20anEvent.%20%5D%0D%0A%09%09useCapture%3A%20false"));

smalltalk.bind(smalltalk.PhoneGapEvents,"initializeHandle","initializeHandle"

,function (){var self=this;self['@handle']="unused";return self;}

,"initialize/release",unescape("initializeHandle%0D%0A%09%22%20Private%20-%20Initialize%20the%20native%20handle.%20%22%0D%0A%0D%0A%09handle%20%3A%3D%20%23unused"));

smalltalk.bind(smalltalk.Device.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator.device);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D%23device"));

smalltalk.bind(smalltalk.Device,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.Device,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Device,"phonegap","phonegap"

,function (){var self=this;return (self.handle()["phonegap"] || nil);return self;}

,"accessing",unescape("phonegap%0D%0A%09%22%20Return%20the%20phonegap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27phonegap%27"));

smalltalk.bind(smalltalk.Device,"phonegap:","phonegap_"

,function (anObject){var self=this;(self.handle()["phonegap"]=(anObject));return self;}

,"accessing",unescape("phonegap%3A%20anObject%0D%0A%09%22%20Set%20the%20phonegap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27phonegap%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Device,"platform","platform"

,function (){var self=this;return (self.handle()["platform"] || nil);return self;}

,"accessing",unescape("platform%0D%0A%09%22%20Return%20the%20platform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27platform%27"));

smalltalk.bind(smalltalk.Device,"platform:","platform_"

,function (anObject){var self=this;(self.handle()["platform"]=(anObject));return self;}

,"accessing",unescape("platform%3A%20anObject%0D%0A%09%22%20Set%20the%20platform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27platform%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Device,"uuid","uuid"

,function (){var self=this;return (self.handle()["uuid"] || nil);return self;}

,"accessing",unescape("uuid%0D%0A%09%22%20Return%20the%20uuid%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27uuid%27"));

smalltalk.bind(smalltalk.Device,"uuid:","uuid_"

,function (anObject){var self=this;(self.handle()["uuid"]=(anObject));return self;}

,"accessing",unescape("uuid%3A%20anObject%0D%0A%09%22%20Set%20the%20uuid%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27uuid%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Device,"version","version"

,function (){var self=this;return (self.handle()["version"] || nil);return self;}

,"accessing",unescape("version%0D%0A%09%22%20Return%20the%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27version%27"));

smalltalk.bind(smalltalk.Device,"version:","version_"

,function (anObject){var self=this;(self.handle()["version"]=(anObject));return self;}

,"accessing",unescape("version%3A%20anObject%0D%0A%09%22%20Set%20the%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27version%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.Acceleration,"x","x"

,function (){var self=this;return self['@handle'].x;return self;}

,"accessing",unescape("x%0D%0A%09%22%20Return%20the%20coordinate%20of%20the%20receiver.%0D%0A%09Amount%20of%20motion%20on%20the%20x-axis.%20Range%20%5B0%2C%201%5D%20%22%0D%0A%0D%0A%09%5Ehandle%23x"));

smalltalk.bind(smalltalk.Acceleration,"y","y"

,function (){var self=this;return self['@handle'].y;return self;}

,"accessing",unescape("y%0D%0A%09%22%20Return%20the%20coordinate%20of%20the%20receiver.%0D%0A%09Amount%20of%20motion%20on%20the%20y-axis.%20Range%20%5B0%2C%201%5D%20%22%0D%0A%0D%0A%09%5Ehandle%23y"));

smalltalk.bind(smalltalk.Acceleration,"z","z"

,function (){var self=this;return self['@handle'].z;return self;}

,"accessing",unescape("z%0D%0A%09%22%20Return%20the%20coordinate%20of%20the%20receiver.%0D%0A%09Amount%20of%20motion%20on%20the%20z-axis.%20Range%20%5B0%2C%201%5D%20%22%0D%0A%0D%0A%09%5Ehandle%23z"));

smalltalk.bind(smalltalk.Acceleration,"timeStamp","timeStamp"

,function (){var self=this;return self['@handle'].timestamp;return self;}

,"accessing",unescape("timeStamp%0D%0A%09%22%20Return%20the%20timeStamp%20of%20the%20receiver.%0D%0A%09Creation%20timestamp%20in%20milliseconds.%20%28DOMTimeStamp%29%20%22%0D%0A%0D%0A%09%5Ehandle%23timestamp"));

smalltalk.bind(smalltalk.PG8AsyncObject.$klass,"constructEventsTriggered","constructEventsTriggered"

,function (){var self=this;return smalltalk.whoImplements(smalltalk.PG8AsyncObject.$klass,'constructEventsTriggered').$superclass.$fn.prototype['constructEventsTriggered'].apply(self, [])._comma(["value:", "error"]);return self;}

,"events",unescape("constructEventsTriggered%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Esuper%20constructEventsTriggered%20%2C%20%23%28%0D%0A%09%09%23value%3A%0D%0A%09%09%23error%0D%0A%09%29"));

smalltalk.bind(smalltalk.PG8AsyncObject.$klass,"do:onError:with:","do_onError_with_"

,function (aBlock,errorBlock,options){var self=this;return self.$$default().do_onError_with_(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("do%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20default%20instance%20of%20the%20receiver.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%20%22%0D%0A%0D%0A%09%5Eself%20default%20do%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.PG8AsyncObject.$klass,"do:onError:","do_onError_"

,function (aBlock,errorBlock){var self=this;return self.$$default().do_onError_(aBlock, errorBlock);return self;}

,"evaluation",unescape("do%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20default%20instance%20of%20the%20receiver.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%20%22%0D%0A%0D%0A%09%5Eself%20default%20do%3A%20aBlock%20onError%3A%20errorBlock"));

smalltalk.bind(smalltalk.PG8AsyncObject.$klass,"watch:","watch_"

,function (aBlock){var self=this;return self.$$default().watch_(aBlock);return self;}

,"evaluation",unescape("watch%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20default%20instance%20of%20the%20receiver%20at%20regular%20interval.%20%22%0D%0A%0D%0A%09%5Eself%20default%20watch%3A%20aBlock"));

smalltalk.bind(smalltalk.PG8AsyncObject.$klass,"watch:onError:with:","watch_onError_with_"

,function (aBlock,errorBlock,options){var self=this;return self.$$default().watch_onError_with_(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("watch%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20default%20instance%20of%20the%20receiver%20at%20regular%20interval.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%20%22%0D%0A%0D%0A%09%5Eself%20default%20watch%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.PG8AsyncObject.$klass,"watch:onError:","watch_onError_"

,function (aBlock,errorBlock){var self=this;return self.$$default().watch_onError_(aBlock, errorBlock);return self;}

,"evaluation",unescape("watch%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20default%20instance%20of%20the%20receiver%20at%20regular%20interval.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%20%22%0D%0A%0D%0A%09%5Eself%20default%20watch%3A%20aBlock%20onError%3A%20errorBlock"));

smalltalk.bind(smalltalk.PG8AsyncObject,"do:","do_"

,function (aBlock){var self=this;return self.do_onError_(aBlock, nil);return self;}

,"evaluation",unescape("do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20do%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.PG8AsyncObject,"id","id"

,function (){var self=this;return self['@id'];return self;}

,"accessing",unescape("id%0D%0A%09%22%20Private%20-%20Return%20the%20current%20instance%20id%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eid"));

smalltalk.bind(smalltalk.PG8AsyncObject,"id:","id_"

,function (anID){var self=this;self.stop();

self['@id']=anID;return self;}

,"accessing",unescape("id%3A%20anID%0D%0A%09%22%20Private%20-%20Set%20the%20current%20instance%20id%20%28or%20nil%29.%0D%0A%09Stop%20the%20receiver%20if%20currently%20running.%0D%0A%09%22%0D%0A%0D%0A%09self%20stop.%0D%0A%09id%20%3A%3D%20anID."));

smalltalk.bind(smalltalk.PG8AsyncObject,"isWorking","isWorking"

,function (){var self=this;return ((self['@id'] || nil) !== nil);return self;}

,"accessing",unescape("isWorking%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20working.%20%22%0D%0A%0D%0A%09%5Eid%20notNil"));

smalltalk.bind(smalltalk.PG8AsyncObject,"release","release"

,function (){var self=this;self.stop();

return smalltalk.whoImplements(smalltalk.PG8AsyncObject,'release').$superclass.$fn.prototype['release'].apply(self, []);return self;}

,"initialize/release",unescape("release%0D%0A%09%22%20Release%20the%20allocated%20resources%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20stop.%0D%0A%09%5Esuper%20release"));

smalltalk.bind(smalltalk.PG8AsyncObject,"stop","stop"

,function (){var self=this;((self.isWorking()).mustBeBoolean()==true ? (function(){return self.releaseID();})() : nil);return self;}

,"actions",unescape("stop%0D%0A%09%22%20Stop%20the%20receiver%20%28if%20actually%20working%29.%20%22%0D%0A%0D%0A%09self%20isWorking%20ifTrue%3A%20%5B%20self%20releaseID%20%5D"));

smalltalk.bind(smalltalk.PG8AsyncObject,"releaseID","releaseID"

,function (){var self=this;var old=nil;old=self.id();

ifd=nil;

self.clearID_(old);return self;}

,"private",unescape("releaseID%0D%0A%09%22%20Release%20internal%20resources%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20old%20%7C%0D%0A%09old%20%3A%3D%20self%20id.%0D%0A%09ifd%20%3A%3D%20nil.%0D%0A%09self%20clearID%3A%20old."));

smalltalk.bind(smalltalk.PG8AsyncObject,"clearID:","clearID_"

,function (anId){var self=this;return self.implementedBySubclass();return self;}

,"private",unescape("clearID%3A%20anId%0D%0A%09%22%20Private%20-%20Release%20internal%20resource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20implementedBySubclass"));

smalltalk.bind(smalltalk.PG8AsyncObject,"defaultValueBlock","defaultValueBlock"

,function (){var self=this;return (function(anObject){return self.triggerEvent_with_("value:", anObject);});return self;}

,"accessing",unescape("defaultValueBlock%0D%0A%09%22%20Return%20the%20default%20block%20for%20processing%20data%20obtained%20from%20the%20receiver.%0D%0A%09Default%20implementation%20trigger%20events.%0D%0A%09%22%0D%0A%0D%0A%09%5E%5B%3AanObject%7C%20self%20triggerEvent%3A%20%23value%3A%20with%3A%20anObject%20%5D"));

smalltalk.bind(smalltalk.PG8AsyncObject,"defaultErrorBlock","defaultErrorBlock"

,function (){var self=this;return (function(){return self.triggerEvent_("error");});return self;}

,"accessing",unescape("defaultErrorBlock%0D%0A%09%22%20Return%20the%20default%20error%20block%20to%20evaluate%20when%20error%20was%20detected%20while%20obtaining%20data%20from%20the%20receiver.%0D%0A%09Default%20implementation%20trigger%20events.%0D%0A%09%22%0D%0A%0D%0A%09%5E%5B%20self%20triggerEvent%3A%20%23error%20%5D"));

smalltalk.bind(smalltalk.PG8AsyncObject,"valueFromData:","valueFromData_"

,function (data){var self=this;return data;return self;}

,"accessing",unescape("valueFromData%3A%20data%0D%0A%09%22%20Return%20the%20value%20%28anObject%29computed%20from%20data%20of%20the%20receiver.%0D%0A%09Default%20implementation%20return%20the%20raw%20data%20object%20%28jsObject%29.%0D%0A%09This%20method%20can%20be%20refined%20by%20the%20subclasses.%0D%0A%09%22%0D%0A%0D%0A%09%5Edata"));

smalltalk.bind(smalltalk.PG8AsyncObject,"defaultOptions","defaultOptions"

,function (){var self=this;return null;return self;}

,"accessing",unescape("defaultOptions%0D%0A%09%22%20Return%20default%20options%20to%20get%20data%20with%20the%20receiver.%0D%0A%09The%20default%20implementation%20return%20nul.%0D%0A%09This%20method%20MUST%20be%20reimplemented%20when%20library%20need%20custom%20defaults.%0D%0A%09%22%0D%0A%0D%0A%09%5E%23%7Bnull%7D"));

smalltalk.bind(smalltalk.PG8AsyncObject,"optionsFrom:","optionsFrom_"

,function (options){var self=this;try{(function(){((((options || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "optionsFrom_", fn: function(){return self.defaultOptions()}})})();})() : nil);return ((options.isKindOf_(smalltalk.Array)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "optionsFrom_", fn: function(){return self.optionsFromArray_(options)}})})();})() : nil);}).on_do_(smalltalk.Error, (function(){return (function(){throw({name: "stReturn", selector: "optionsFrom_", fn: function(){return options}})})();}));

(function(){throw({name: "stReturn", selector: "optionsFrom_", fn: function(){return options}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "optionsFrom_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("optionsFrom%3A%20options%0D%0A%09%22%20Return%20the%20options%20data%20object%20%28jsObject%29.%0D%0A%09The%20default%20action%20return%20the%20argument.%0D%0A%09This%20method%20can%20be%20refined%20by%20subclasses%20to%20handle%20weak%20options.%0D%0A%09%22%0D%0A%0D%0A%5B%09options%20isNil%20ifTrue%3A%20%5B%20%5Eself%20defaultOptions%20%5D.%0D%0A%09%28options%20isKindOf%3A%20Array%29%20ifTrue%3A%20%5B%20%5Eself%20optionsFromArray%3A%20options%20%5D.%0D%0A%5D%20on%3A%20Error%20do%3A%20%5B%20%5Eoptions%20%5D.%20%22can%20be%20a%20javascript%20Object%22%0D%0A%09%5Eoptions"));

smalltalk.bind(smalltalk.PG8AsyncObject,"optionsFromArray:","optionsFromArray_"

,function (anArray){var self=this;var result=nil;result=smalltalk.Object.$$new();

anArray.do_((function(tuple){return (result[tuple.first()]=(tuple.last()));}));

return result;return self;}

,"options",unescape("optionsFromArray%3A%20anArray%0D%0A%09%22%20Return%20the%20options%20data%20object%20from%20anArray%20literal.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20Object%20new.%0D%0A%09anArray%20do%3A%20%5B%3Atuple%7C%0D%0A%09%09result%20basicAt%3A%20tuple%20first%20put%3A%20tuple%20last%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.PG8AsyncObject,"do:onError:","do_onError_"

,function (aBlock,errorBlock){var self=this;return self.do_onError_with_(aBlock, errorBlock, nil);return self;}

,"evaluation",unescape("do%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%0D%0A%09Return%20the%20receiver%20and%20trigger%20threads%20to%20compute%20the%20value.%0D%0A%09The%20default%20action%20for%20block%20and%20error%20will%20trigger%20events%20when%20appropiate.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20do%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20nil"));

smalltalk.bind(smalltalk.PG8AsyncObject,"do:onError:with:","do_onError_with_"

,function (aBlock,errorBlock,options){var self=this;try{((((aBlock || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "do_onError_with_", fn: function(){return self.do_onError_with_(self.defaultValueBlock(), errorBlock, options)}})})();})() : nil);

((((errorBlock || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "do_onError_with_", fn: function(){return self.do_onError_with_(aBlock, self.defaultErrorBlock(), options)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "do_onError_with_", fn: function(){return self.valueDoing_onError_with_((function(data){return aBlock.value_(self.valueFromData_(data));}), self.errorBlock_(errorBlock), self.optionsFrom_(options))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "do_onError_with_"){return $$ex.fn();} throw($$ex);}}

,"evaluation",unescape("do%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%0D%0A%09Return%20the%20receiver%20and%20trigger%20threads%20to%20compute%20the%20value.%0D%0A%09The%20default%20action%20for%20block%20and%20error%20will%20trigger%20events%20when%20appropiate.%0D%0A%09%22%0D%0A%0D%0A%09aBlock%20isNil%20ifTrue%3A%20%5B%20%5Eself%20do%3A%20self%20defaultValueBlock%20onError%3A%20errorBlock%20with%3A%20options%20%5D.%0D%0A%09errorBlock%20isNil%20ifTrue%3A%20%5B%20%5Eself%20do%3A%20aBlock%20onError%3A%20self%20defaultErrorBlock%20with%3A%20options%20%5D.%0D%0A%09%5Eself%0D%0A%09%09valueDoing%3A%20%5B%3Adata%7C%20aBlock%20value%3A%20%28self%20valueFromData%3A%20data%29%20%5D%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29%0D%0A%09%09with%3A%20%28self%20optionsFrom%3A%20options%29"));

smalltalk.bind(smalltalk.PG8AsyncObject,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;return self.implementedBySubclass();return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%0D%0A%09Return%20the%20receiver%20and%20trigger%20threads%20to%20compute%20the%20value.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20implementedBySubclass"));

smalltalk.bind(smalltalk.PG8AsyncObject,"watch:onError:with:","watch_onError_with_"

,function (aBlock,errorBlock,options){var self=this;try{((((aBlock || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "watch_onError_with_", fn: function(){return self.watch_onError_with_(self.defaultValueBlock(), errorBlock, options)}})})();})() : nil);

((((errorBlock || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "watch_onError_with_", fn: function(){return self.watch_onError_with_(aBlock, self.defaultErrorBlock(), options)}})})();})() : nil);

self.id_(self.watchDoing_onError_with_((function(data){return aBlock.value_(self.valueFromData_(data));}), self.errorBlock_(errorBlock), self.optionsFrom_(options)));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "watch_onError_with_"){return $$ex.fn();} throw($$ex);}}

,"evaluation",unescape("watch%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%0D%0A%09The%20default%20action%20for%20block%20and%20error%20will%20trigger%20events%20when%20appropiate.%0D%0A%09%22%0D%0A%0D%0A%09aBlock%20isNil%20ifTrue%3A%20%5B%20%5Eself%20watch%3A%20self%20defaultValueBlock%20onError%3A%20errorBlock%20with%3A%20options%20%5D.%0D%0A%09errorBlock%20isNil%20ifTrue%3A%20%5B%20%5Eself%20watch%3A%20aBlock%20onError%3A%20self%20defaultErrorBlock%20with%3A%20options%20%5D.%0D%0A%09self%20id%3A%20%28self%0D%0A%09%09watchDoing%3A%20%5B%3Adata%7C%20aBlock%20value%3A%20%28self%20valueFromData%3A%20data%29%20%5D%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29%0D%0A%09%09with%3A%20%28self%20optionsFrom%3A%20options%29%29"));

smalltalk.bind(smalltalk.PG8AsyncObject,"watch:onError:","watch_onError_"

,function (aBlock,errorBlock){var self=this;return self.watch_onError_with_(aBlock, errorBlock, nil);return self;}

,"evaluation",unescape("watch%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%0D%0A%09The%20default%20action%20for%20block%20and%20error%20will%20trigger%20events%20when%20appropiate.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20watch%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20nil"));

smalltalk.bind(smalltalk.PG8AsyncObject,"watch:","watch_"

,function (aBlock){var self=this;return self.watch_onError_(aBlock, nil);return self;}

,"evaluation",unescape("watch%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%0D%0A%09The%20default%20action%20for%20block%20and%20error%20will%20trigger%20events%20when%20appropiate.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20watch%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.PG8AsyncObject,"watchDoing:onError:with:","watchDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;return self.implementedBySubclass();return self;}

,"evaluation",unescape("watchDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%0D%0A%09In%20case%20of%20error%2C%20the%20error%20block%20will%20be%20evaluated.%0D%0A%09Must%20return%20the%20watch%20ID%20needed%20to%20track/release%20watch%20thread.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20implementedBySubclass"));

smalltalk.bind(smalltalk.PG8AsyncObject,"watchDoing:","watchDoing_"

,function (aBlock){var self=this;return self.watchDoing_onError_(aBlock, nil);return self;}

,"evaluation",unescape("watchDoing%3A%20aBlock%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%20%22%0D%0A%0D%0A%09%5Eself%20watchDoing%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileWriter.$klass,"phoneGapEvents","phoneGapEvents"

,function (){var self=this;return ["writeStart:", "writeStart", "onWriteStart:", "onWriteStart", "onwritestart", "write:", "write", "onWrite:", "onWrite", "onwrite", "writeEnd:", "writeEnd", "onWriteEnd:", "onWriteEnd", "onwriteend"]._comma(smalltalk.whoImplements(smalltalk.FileWriter.$klass,'phoneGapEvents').$superclass.$fn.prototype['phoneGapEvents'].apply(self, []));return self;}

,"events",unescape("phoneGapEvents%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20PhoneGap.%20%22%0D%0A%0D%0A%09%5E%23%28%09%23writeStart%3A%20%23writeStart%20%23onWriteStart%3A%20%23onWriteStart%20%23onwritestart%0D%0A%09%09%23write%3A%20%23write%20%23onWrite%3A%20%23onWrite%20%23onwrite%0D%0A%09%09%23writeEnd%3A%20%23writeEnd%20%23onWriteEnd%3A%20%23onWriteEnd%20%23onwriteend%0D%0A%09%29%2C%20super%20phoneGapEvents"));

smalltalk.bind(smalltalk.FileWriter,"fileName","fileName"

,function (){var self=this;return (self.handle()["fileName"] || nil);return self;}

,"accessing",unescape("fileName%0D%0A%09%22%20Return%20the%20fileName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27fileName%27"));

smalltalk.bind(smalltalk.FileWriter,"fileName:","fileName_"

,function (anObject){var self=this;(self.handle()["fileName"]=(anObject));return self;}

,"accessing",unescape("fileName%3A%20anObject%0D%0A%09%22%20Set%20the%20fileName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fileName%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileWriter,"length","length"

,function (){var self=this;return (self.handle()["length"] || nil);return self;}

,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27length%27"));

smalltalk.bind(smalltalk.FileWriter,"length:","length_"

,function (anObject){var self=this;(self.handle()["length"]=(anObject));return self;}

,"accessing",unescape("length%3A%20anObject%0D%0A%09%22%20Set%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27length%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileWriter,"position","position"

,function (){var self=this;return (self.handle()["position"] || nil);return self;}

,"accessing",unescape("position%0D%0A%09%22%20Return%20the%20position%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27position%27"));

smalltalk.bind(smalltalk.FileWriter,"position:","position_"

,function (anObject){var self=this;(self.handle()["position"]=(anObject));return self;}

,"accessing",unescape("position%3A%20anObject%0D%0A%09%22%20Set%20the%20position%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27position%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileWriter,"onwritestart","onwritestart"

,function (){var self=this;return (self.handle()["onwritestart"] || nil);return self;}

,"accessing",unescape("onwritestart%0D%0A%09%22%20Return%20the%20onwritestart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onwritestart%27"));

smalltalk.bind(smalltalk.FileWriter,"onwritestart:","onwritestart_"

,function (anObject){var self=this;(self.handle()["onwritestart"]=(anObject));return self;}

,"accessing",unescape("onwritestart%3A%20anObject%0D%0A%09%22%20Set%20the%20onwritestart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onwritestart%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileWriter,"onwrite","onwrite"

,function (){var self=this;return (self.handle()["onwrite"] || nil);return self;}

,"accessing",unescape("onwrite%0D%0A%09%22%20Return%20the%20onwrite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onwrite%27"));

smalltalk.bind(smalltalk.FileWriter,"onwrite:","onwrite_"

,function (anObject){var self=this;(self.handle()["onwrite"]=(anObject));return self;}

,"accessing",unescape("onwrite%3A%20anObject%0D%0A%09%22%20Set%20the%20onwrite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onwrite%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileWriter,"onwriteend","onwriteend"

,function (){var self=this;return (self.handle()["onwriteend"] || nil);return self;}

,"accessing",unescape("onwriteend%0D%0A%09%22%20Return%20the%20onwriteend%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onwriteend%27"));

smalltalk.bind(smalltalk.FileWriter,"onwriteend:","onwriteend_"

,function (anObject){var self=this;(self.handle()["onwriteend"]=(anObject));return self;}

,"accessing",unescape("onwriteend%3A%20anObject%0D%0A%09%22%20Set%20the%20onwriteend%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onwriteend%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileWriter,"write:","write_"

,function (aString){var self=this;self.handle().write(aString);return self;}

,"actions",unescape("write%3A%20aString%0D%0A%09%22%20Write%20aString%20onto%20destination%20file.%20%22%0D%0A%0D%0A%09self%20handle%20%23write%3A%20aString"));

smalltalk.bind(smalltalk.FileWriter,"seek:","seek_"

,function (offset){var self=this;self.handle().seek(offset);return self;}

,"actions",unescape("seek%3A%20offset%0D%0A%09%22%20Seek%20destination%20file%20to%20offset%20%28zero%20indexed%29.%20%22%0D%0A%0D%0A%09self%20handle%20%23seek%3A%20offset"));

smalltalk.bind(smalltalk.FileWriter,"truncate:","truncate_"

,function (offset){var self=this;self.handle().truncate(offset);return self;}

,"actions",unescape("truncate%3A%20offset%0D%0A%09%22%20Truncate%20destination%20file%20to%20offset%20%28zero%20indexed%29.%20%22%0D%0A%0D%0A%09self%20handle%20%23truncate%3A%20offset"));

smalltalk.bind(smalltalk.FileReader.$klass,"phoneGapEvents","phoneGapEvents"

,function (){var self=this;return ["loadStart:", "loadStart", "onLoadStart:", "onLoadStart", "onloadstart", "load:", "load", "onLoad:", "onLoad", "onload", "loadEnd:", "loadEnd", "onLoadEnd:", "onLoadEnd", "onloadend"]._comma(smalltalk.whoImplements(smalltalk.FileReader.$klass,'phoneGapEvents').$superclass.$fn.prototype['phoneGapEvents'].apply(self, []));return self;}

,"events",unescape("phoneGapEvents%0D%0A%09%22%20Private%20-%20Return%20the%20events%20managed%20by%20PhoneGap.%20%22%0D%0A%0D%0A%09%5E%23%28%09%23loadStart%3A%20%23loadStart%20%23onLoadStart%3A%20%23onLoadStart%20%23onloadstart%0D%0A%09%09%23load%3A%20%23load%20%23onLoad%3A%20%23onLoad%20%23onload%0D%0A%09%09%23loadEnd%3A%20%23loadEnd%20%23onLoadEnd%3A%20%23onLoadEnd%20%23onloadend%0D%0A%09%29%2C%20super%20phoneGapEvents"));

smalltalk.bind(smalltalk.FileReader,"result","result"

,function (){var self=this;return (self.handle()["result"] || nil);return self;}

,"accessing",unescape("result%0D%0A%09%22%20Return%20the%20result%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27result%27"));

smalltalk.bind(smalltalk.FileReader,"result:","result_"

,function (anObject){var self=this;(self.handle()["result"]=(anObject));return self;}

,"accessing",unescape("result%3A%20anObject%0D%0A%09%22%20Set%20the%20result%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27result%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"onloadstart","onloadstart"

,function (){var self=this;return (self.handle()["onloadstart"] || nil);return self;}

,"accessing",unescape("onloadstart%0D%0A%09%22%20Return%20the%20onloadstart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onloadstart%27"));

smalltalk.bind(smalltalk.FileReader,"onloadstart:","onloadstart_"

,function (anObject){var self=this;(self.handle()["onloadstart"]=(anObject));return self;}

,"accessing",unescape("onloadstart%3A%20anObject%0D%0A%09%22%20Set%20the%20onloadstart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onloadstart%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"onload","onload"

,function (){var self=this;return (self.handle()["onload"] || nil);return self;}

,"accessing",unescape("onload%0D%0A%09%22%20Return%20the%20onload%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onload%27"));

smalltalk.bind(smalltalk.FileReader,"onload:","onload_"

,function (anObject){var self=this;(self.handle()["onload"]=(anObject));return self;}

,"accessing",unescape("onload%3A%20anObject%0D%0A%09%22%20Set%20the%20onload%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onload%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"onloadend","onloadend"

,function (){var self=this;return (self.handle()["onloadend"] || nil);return self;}

,"accessing",unescape("onloadend%0D%0A%09%22%20Return%20the%20onloadend%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onloadend%27"));

smalltalk.bind(smalltalk.FileReader,"onloadend:","onloadend_"

,function (anObject){var self=this;(self.handle()["onloadend"]=(anObject));return self;}

,"accessing",unescape("onloadend%3A%20anObject%0D%0A%09%22%20Set%20the%20onloadend%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onloadend%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"initializeHandle","initializeHandle"

,function (){var self=this;self['@handle']=new FileReader();return self;}

,"initialize/release",unescape("initializeHandle%0D%0A%09%22%20Private%20-%20Initialize%20the%20native%20handle.%20%22%0D%0A%0D%0A%09handle%20%3A%3D%20%7B%27new%20FileReader%28%29%27%7D"));

smalltalk.bind(smalltalk.FileReader,"readAsDataURL:","readAsDataURL_"

,function (file){var self=this;self.handle().readAsDataURL(file);return self;}

,"actions",unescape("readAsDataURL%3A%20file%0D%0A%09%22%20Start%20a%20read%20operation%20on%20file%20as%20a%20data%20URL%20encoded.%20%22%0D%0A%0D%0A%09self%20handle%20%23readAsDataURL%3A%20file"));

smalltalk.bind(smalltalk.FileReader,"readAsText:","readAsText_"

,function (file){var self=this;self.handle().readAsText(file);return self;}

,"actions",unescape("readAsText%3A%20file%0D%0A%09%22%20Start%20a%20read%20text%20operation%20on%20file.%20%22%0D%0A%0D%0A%09self%20handle%20%23readAsText%3A%20file"));

smalltalk.bind(smalltalk.FileReader,"readAsText:encode:","readAsText_encode_"

,function (file,encode){var self=this;self.handle().readAsText(file, encode);return self;}

,"actions",unescape("readAsText%3A%20file%20encode%3A%20encode%0D%0A%09%22%20Start%20a%20read%20text%20operation%20on%20file.%0D%0A%09encoding%20is%20the%20encoding%20to%20use%20to%20encode%20the%20file%20content.%0D%0A%09Default%20is%20UTF8.%0D%0A%09%22%0D%0A%0D%0A%09self%20handle%20%23readAsText%3A%20file%20encode%3A%20encode"));

smalltalk.bind(smalltalk.FileSystemElement.$klass,"entryFrom:","entryFrom_"

,function (anEntryHandle){var self=this;try{(((anEntryHandle.isFile === true)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "entryFrom_", fn: function(){return smalltalk.FileEntry._at(anEntryHandle)}})})();})() : nil);

(((anEntryHandle.isDirectory === true)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "entryFrom_", fn: function(){return smalltalk.DirectoryEntry._at(anEntryHandle)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "entryFrom_", fn: function(){return self.error_("Invalid handle")}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "entryFrom_"){return $$ex.fn();} throw($$ex);}}

,unescape("instance%20creation"),unescape("entryFrom%3A%20anEntryHandle%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09anEntryHandle%23isFile%20%3D%3D%20true%20ifTrue%3A%20%5B%20%5EFileEntry%20@%20anEntryHandle%20%5D.%0D%0A%09anEntryHandle%23isDirectory%20%3D%3D%20true%20ifTrue%3A%20%5B%20%5EDirectoryEntry%20@%20anEntryHandle%20%5D.%0D%0A%09%5Eself%20error%3A%20%27Invalid%20handle%27"));

smalltalk.bind(smalltalk.FileSystemElement,"isFile","isFile"

,function (){var self=this;return (true === (self.handle()["isFile"] || nil));return self;}

,"accessing",unescape("isFile%0D%0A%09%22%20Return%20the%20isFile%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20%28self%20handle%20basicAt%3A%20%27isFile%27%29"));

smalltalk.bind(smalltalk.FileSystemElement,"isDirectory","isDirectory"

,function (){var self=this;return (true === (self.handle()["isDirectory"] || nil));return self;}

,"accessing",unescape("isDirectory%0D%0A%09%22%20Return%20the%20isDirectory%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20%28self%20handle%20basicAt%3A%20%27isDirectory%27%29"));

smalltalk.bind(smalltalk.FileSystemElement,"withMetadataDo:onError:","withMetadataDo_onError_"

,function (aBlock,errorBlock){var self=this;var action=nil;action=(function(data){return aBlock.value_(smalltalk.Metadata._at(data));});

self.handle().getMetadata(action, self.errorBlock_(errorBlock));return self;}

,"actions",unescape("withMetadataDo%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20on%20metadata%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20Metadata%20@%20data%20%5D.%0D%0A%09self%20handle%0D%0A%09%09%23getMetadata%3A%20action%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.FileSystemElement,"withMetadataDo:","withMetadataDo_"

,function (aBlock){var self=this;return self.withMetadataDo_onError_(aBlock, nil);return self;}

,"actions",unescape("withMetadataDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20on%20metadata%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withMetadataDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileSystemElement,"moveTo:as:doing:onError:","moveTo_as_doing_onError_"

,function (parent,newName,aBlock,errorBlock){var self=this;var action=nil;var target=nil;((((newName || nil) !== nil)).mustBeBoolean()==true ? (function(){return target=newName;})() : (function(){return null;})());

action=(function(data){return aBlock.value_(smalltalk.FileEntry._at(data));});

self.handle().moveTo(parent, target, action, self.errorBlock_(errorBlock));return self;}

,"actions",unescape("moveTo%3A%20parent%20as%3A%20newName%20doing%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Move%20the%20receiver%20to%20new%20location.%20%22%0D%0A%0D%0A%09%7C%20action%20target%20%7C%0D%0A%09newName%20notNil%0D%0A%09%09ifTrue%3A%20%5B%20target%20%3A%3D%20newName%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20%23%7Bnull%7D%20%5D.%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20FileEntry%20@%20data%20%5D.%0D%0A%09self%20handle%0D%0A%09%09%23moveTo%3A%20parent%20as%3A%20target%0D%0A%09%09doing%3A%20action%20onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.FileSystemElement,"moveTo:as:doing:","moveTo_as_doing_"

,function (parent,newName,aBlock){var self=this;return self.moveTo_as_doing_onError_(parent, newName, aBlock, nil);return self;}

,"actions",unescape("moveTo%3A%20parent%20as%3A%20newName%20doing%3A%20aBlock%0D%0A%09%22%20Move%20the%20receiver%20to%20new%20location.%20%22%0D%0A%0D%0A%09%5Eself%20moveTo%3A%20parent%20as%3A%20newName%20doing%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileSystemElement,"copyTo:as:doing:onError:","copyTo_as_doing_onError_"

,function (parent,newName,aBlock,errorBlock){var self=this;var action=nil;var target=nil;((((newName || nil) !== nil)).mustBeBoolean()==true ? (function(){return target=newName;})() : (function(){return null;})());

action=(function(data){return aBlock.value_(smalltalk.FileEntry._at(data));});

self.handle().copyTo(parent, target, action, self.errorBlock_(errorBlock));return self;}

,"actions",unescape("copyTo%3A%20parent%20as%3A%20newName%20doing%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Copy%20the%20receiver%20to%20new%20location.%20%22%0D%0A%0D%0A%09%7C%20action%20target%20%7C%0D%0A%09newName%20notNil%0D%0A%09%09ifTrue%3A%20%5B%20target%20%3A%3D%20newName%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20%23%7Bnull%7D%20%5D.%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20FileEntry%20@%20data%20%5D.%0D%0A%09self%20handle%0D%0A%09%09%23copyTo%3A%20parent%20as%3A%20target%0D%0A%09%09doing%3A%20action%20onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.FileSystemElement,"copyTo:as:doing:","copyTo_as_doing_"

,function (parent,newName,aBlock){var self=this;return self.copyTo_as_doing_onError_(parent, newName, aBlock, nil);return self;}

,"actions",unescape("copyTo%3A%20parent%20as%3A%20newName%20doing%3A%20aBlock%0D%0A%09%22%20Copy%20the%20receiver%20to%20new%20location.%20%22%0D%0A%0D%0A%09%5Eself%20copyTo%3A%20parent%20as%3A%20newName%20doing%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileSystemElement,"uri","uri"

,function (){var self=this;return self.handle().toURI();return self;}

,"accessing",unescape("uri%0D%0A%09%22%20Return%20a%20URI%20that%20can%20be%20used%20to%20locate%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20toURI"));

smalltalk.bind(smalltalk.FileSystemElement,"parent","parent"

,function (){var self=this;return smalltalk.DirectoryEntry._at(self.handle().getParent());return self;}

,"accessing",unescape("parent%0D%0A%09%22%20Return%20the%20parent%20directory%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDirectoryEntry%20@%20self%20handle%20getParent"));

smalltalk.bind(smalltalk.FileSystem.$klass,"temporaryDo:onError:","temporaryDo_onError_"

,function (aBlock,errorBlock){var self=this;self.type_do_onError_((0), aBlock, errorBlock);return self;}

,"service",unescape("temporaryDo%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%0D%0A%09Evaluate%20errorBlock%20in%20case%20on%20error%20accessing%20file%20system.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09self%20type%3A%200%20do%3A%20aBlock%20onError%3A%20errorBlock."));

smalltalk.bind(smalltalk.FileSystem.$klass,"temporaryDo:","temporaryDo_"

,function (aBlock){var self=this;return self.temporaryDo_onError_(aBlock, nil);return self;}

,"service",unescape("temporaryDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%20%22%0D%0A%0D%0A%09%5Eself%20temporaryDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileSystem.$klass,"persistentDo:onError:","persistentDo_onError_"

,function (aBlock,errorBlock){var self=this;self.type_do_onError_((1), aBlock, errorBlock);return self;}

,"service",unescape("persistentDo%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%0D%0A%09Evaluate%20errorBlock%20in%20case%20on%20error%20accessing%20file%20system.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09self%20type%3A%201%20do%3A%20aBlock%20onError%3A%20errorBlock."));

smalltalk.bind(smalltalk.FileSystem.$klass,"persistentDo:","persistentDo_"

,function (aBlock){var self=this;return self.persistentDo_onError_(aBlock, nil);return self;}

,"service",unescape("persistentDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%20%22%0D%0A%0D%0A%09%5Eself%20persistentDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileSystem.$klass,"resourceDo:onError:","resourceDo_onError_"

,function (aBlock,errorBlock){var self=this;self.type_do_onError_((2), aBlock, errorBlock);return self;}

,"service",unescape("resourceDo%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%0D%0A%09Evaluate%20errorBlock%20in%20case%20on%20error%20accessing%20file%20system.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09self%20type%3A%202%20do%3A%20aBlock%20onError%3A%20errorBlock."));

smalltalk.bind(smalltalk.FileSystem.$klass,"resourceDo:","resourceDo_"

,function (aBlock){var self=this;return self.resourceDo_onError_(aBlock, nil);return self;}

,"service",unescape("resourceDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%20%22%0D%0A%0D%0A%09%5Eself%20resourceDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileSystem.$klass,"applicationDo:onError:","applicationDo_onError_"

,function (aBlock,errorBlock){var self=this;self.type_do_onError_((3), aBlock, errorBlock);return self;}

,"service",unescape("applicationDo%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%0D%0A%09Evaluate%20errorBlock%20in%20case%20on%20error%20accessing%20file%20system.%0D%0A%09Return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09self%20type%3A%203%20do%3A%20aBlock%20onError%3A%20errorBlock."));

smalltalk.bind(smalltalk.FileSystem.$klass,"applicationDo:","applicationDo_"

,function (aBlock){var self=this;return self.applicationDo_onError_(aBlock, nil);return self;}

,"service",unescape("applicationDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%20%22%0D%0A%0D%0A%09%5Eself%20applicationDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileSystem.$klass,"type:do:onError:","type_do_onError_"

,function (aConstant,aBlock,errorBlock){var self=this;var action=nil;action=(function(data){return aBlock.value_(self._at(data));});

window.requestFileSystem(aConstant, (0), action, self.errorBlock_(errorBlock));return self;}

,"private",unescape("type%3A%20aConstant%20do%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20with%20an%20instance%20of%20the%20receiver%2C%20when%20succeding%20access.%20%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20self%20@%20data%20%5D.%0D%0A%09%23%7Bwindow%7D%20%23requestFileSystem%3A%20aConstant%0D%0A%09%09requiredSize%3A%200%0D%0A%09%09onSuccess%3A%20action%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.FileSystem,"root","root"

,function (){var self=this;return smalltalk.DirectoryEntry._at(self['@handle'].root);return self;}

,"accessing",unescape("root%0D%0A%09%22%20Return%20the%20root%20directory%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDirectoryEntry%20@%20handle%23root"));

smalltalk.bind(smalltalk.FileEntry,"withWriterDo:onError:","withWriterDo_onError_"

,function (aBlock,errorBlock){var self=this;var action=nil;action=(function(data){return aBlock.value_(smalltalk.FileWriter._at(data));});

self.handle().createWriter(action, self.errorBlock_(errorBlock));return self;}

,"accessing",unescape("withWriterDo%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20a%20FileWriter%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20FileWriter%20@%20data%20%5D.%0D%0A%09self%20handle%0D%0A%09%09%23createWriter%3A%20action%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.FileEntry,"withWriterDo:","withWriterDo_"

,function (aBlock){var self=this;return self.withWriterDo_onError_(aBlock, nil);return self;}

,"accessing",unescape("withWriterDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20a%20FileWriter%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withWriterDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileEntry,"writerDo:","writerDo_"

,function (aBlock){var self=this;return self.withWriterDo_onError_(aBlock, nil);return self;}

,"accessing",unescape("writerDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20a%20FileWriter%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withWriterDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileEntry,"withFileDo:onError:","withFileDo_onError_"

,function (aBlock,errorBlock){var self=this;var action=nil;action=(function(data){return aBlock.value_(smalltalk.PG8File._at(data));});

self.handle().file(action, self.errorBlock_(errorBlock));return self;}

,"accessing",unescape("withFileDo%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20a%20File%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20PG8File%20@%20data%20%5D.%0D%0A%09self%20handle%0D%0A%09%09%23file%3A%20action%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.FileEntry,"withFileDo:","withFileDo_"

,function (aBlock){var self=this;return self.withFileDo_onError_(aBlock, nil);return self;}

,"accessing",unescape("withFileDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20a%20File%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withFileDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileEntry,"fileDo:","fileDo_"

,function (aBlock){var self=this;return self.withFileDo_onError_(aBlock, nil);return self;}

,"accessing",unescape("fileDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20a%20File%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withFileDo%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.FileEntry,"fileDo:onError:","fileDo_onError_"

,function (aBlock,errorBlock){var self=this;return self.withFileDo_onError_(aBlock, errorBlock);return self;}

,"accessing",unescape("fileDo%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20a%20File%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withFileDo%3A%20aBlock%20onError%3A%20errorBlock"));

smalltalk.bind(smalltalk.DirectoryEntry,"removeDoing:onError:","removeDoing_onError_"

,function (aZeroArgumentBlock,errorBlock){var self=this;self.handle().remove(aZeroArgumentBlock, self.errorBlock_(errorBlock));return self;}

,"accessing",unescape("removeDoing%3A%20aZeroArgumentBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Remove%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%0D%0A%09%09%23remove%3A%20aZeroArgumentBlock%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.DirectoryEntry,"removeDoing:","removeDoing_"

,function (aZeroArgumentBlock){var self=this;return self.removeDoing_onError_(aZeroArgumentBlock, nil);return self;}

,"accessing",unescape("removeDoing%3A%20aZeroArgumentBlock%0D%0A%09%22%20Remove%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20removeDoing%3A%20aZeroArgumentBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.DirectoryEntry,"removeRecursivelyDoing:onError:","removeRecursivelyDoing_onError_"

,function (aZeroArgumentBlock,errorBlock){var self=this;self.handle().removeRecursively(aZeroArgumentBlock, self.errorBlock_(errorBlock));return self;}

,"accessing",unescape("removeRecursivelyDoing%3A%20aZeroArgumentBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Delete%20the%20receiver%20and%20all%20of%20its%20contents.%0D%0A%09In%20the%20event%20of%20an%20error%20%28e.g.%20trying%20to%20delete%20a%20directory%20that%20contains%20a%20file%20that%20cannot%20be%20removed%29%2C%20some%20of%20the%20contents%20of%20the%20directory%20may%20be%20deleted.%0D%0A%09It%20is%20an%20error%20to%20attempt%20to%20delete%20the%20root%20directory%20of%20a%20filesystem.%0D%0A%09%22%0D%0A%0D%0A%09self%20handle%0D%0A%09%09%23removeRecursively%3A%20aZeroArgumentBlock%0D%0A%09%09onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.DirectoryEntry,"removeRecursivelyDoing:","removeRecursivelyDoing_"

,function (aZeroArgumentBlock){var self=this;return self.removeRecursivelyDoing_onError_(aZeroArgumentBlock, nil);return self;}

,"accessing",unescape("removeRecursivelyDoing%3A%20aZeroArgumentBlock%0D%0A%09%22%20Delete%20the%20receiver%20and%20all%20of%20its%20contents.%20%22%0D%0A%0D%0A%09%5Eself%20removeRecursivelyDoing%3A%20aZeroArgumentBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.DirectoryEntry,"reader","reader"

,function (){var self=this;return smalltalk.DirectoryReader._at(self.handle().createReader());return self;}

,"accessing",unescape("reader%0D%0A%09%22%20Return%20a%20reader%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDirectoryReader%20@%20self%20handle%20createReader"));

smalltalk.bind(smalltalk.DirectoryEntry,"withDirectory:options:do:onError:","withDirectory_options_do_onError_"

,function (pathName,options,aBlock,errorBlock){var self=this;try{var action=nil;((options.isArray()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "withDirectory_options_do_onError_", fn: function(){return self.withDirectory_options_do_onError_(pathName, options.inject_into_(smalltalk.Object.$$new(), (function(result, tuple){return (function($rec){($rec[tuple.first()]=(tuple.last()));return $rec.yourself();})(result);})), aBlock, errorBlock)}})})();})() : nil);

action=(function(data){return aBlock.value_(self.$klass._at(data));});

self.handle().getDirectory(pathName, ((((options || nil) === nil)).mustBeBoolean()==true ? (function(){return null;})() : (function(){return options;})()), action, self.errorBlock_(errorBlock));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "withDirectory_options_do_onError_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("withDirectory%3A%20pathName%20options%3A%20options%20do%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Creates%20or%20looks%20up%20an%20existing%20directory.%0D%0A%09It%20is%20an%20error%20to%20attempt%20to%20create%20a%20directory%20whose%20immediate%20parent%20does%20not%20yet%20exist.%0D%0A%09pathName%20is%20the%20path%20to%20the%20directory%20to%20be%20looked%20up%20or%20created.%0D%0A%09Either%20an%20absolute%20path%2C%20or%20a%20relative%20path%20from%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09options%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20withDirectory%3A%20pathName%0D%0A%09%09%09options%3A%20%28options%20inject%3A%20Object%20new%20into%3A%20%5B%3Aresult%20%3Atuple%7C%0D%0A%09%09%09%09result%20basicAt%3A%20tuple%20first%20put%3A%20tuple%20last%3B%20yourself%0D%0A%09%09%09%5D%29%20do%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%5D.%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20self%20class%20@%20data%20%5D.%0D%0A%09self%20handle%0D%0A%09%09%23getDirectory%3A%20pathName%0D%0A%09%09with%3A%20%28options%20isNil%20ifTrue%3A%20%5B%23%7Bnull%7D%5D%20ifFalse%3A%20%5Boptions%5D%29%0D%0A%09%09doing%3A%20action%20onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.DirectoryEntry,"withDirectory:options:do:","withDirectory_options_do_"

,function (pathName,options,aBlock){var self=this;return self.withDirectory_options_do_onError_(pathName, options, aBlock, nil);return self;}

,"accessing",unescape("withDirectory%3A%20pathName%20options%3A%20options%20do%3A%20aBlock%0D%0A%09%22%20Creates%20or%20looks%20up%20an%20existing%20directory.%0D%0A%09pathName%20is%20the%20path%20to%20the%20directory%20to%20be%20looked%20up%20or%20created.%0D%0A%09Either%20an%20absolute%20path%2C%20or%20a%20relative%20path%20from%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20withDirectory%3A%20pathName%20options%3A%20options%20do%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.DirectoryEntry,"withDirectory:do:","withDirectory_do_"

,function (pathName,aBlock){var self=this;return self.withDirectory_options_do_onError_(pathName, nil, aBlock, nil);return self;}

,"accessing",unescape("withDirectory%3A%20pathName%20do%3A%20aBlock%0D%0A%09%22%20Creates%20or%20looks%20up%20an%20existing%20directory.%0D%0A%09pathName%20is%20the%20path%20to%20the%20directory%20to%20be%20looked%20up%20or%20created.%0D%0A%09Either%20an%20absolute%20path%2C%20or%20a%20relative%20path%20from%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20withDirectory%3A%20pathName%20options%3A%20nil%20do%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.DirectoryEntry,"withFile:options:do:onError:","withFile_options_do_onError_"

,function (pathName,options,aBlock,errorBlock){var self=this;try{var action=nil;((options.isArray()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "withFile_options_do_onError_", fn: function(){return self.withFile_options_do_onError_(pathName, options.inject_into_(smalltalk.Object.$$new(), (function(result, tuple){return (function($rec){($rec[tuple.first()]=(tuple.last()));return $rec.yourself();})(result);})), aBlock, errorBlock)}})})();})() : nil);

action=(function(data){return aBlock.value_(smalltalk.FileEntry._at(data));});

self.handle().getFile(pathName, ((((options || nil) === nil)).mustBeBoolean()==true ? (function(){return null;})() : (function(){return options;})()), action, self.errorBlock_(errorBlock));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "withFile_options_do_onError_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("withFile%3A%20pathName%20options%3A%20options%20do%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Creates%20or%20looks%20up%20a%20file%20in%20the%20receiver.%0D%0A%09It%20is%20an%20error%20to%20attempt%20to%20create%20a%20file%20whose%20immediate%20parent%20does%20not%20yet%20exist.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20action%20%7C%0D%0A%09options%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20withFile%3A%20pathName%0D%0A%09%09%09options%3A%20%28options%20inject%3A%20Object%20new%20into%3A%20%5B%3Aresult%20%3Atuple%7C%0D%0A%09%09%09%09result%20basicAt%3A%20tuple%20first%20put%3A%20tuple%20last%3B%20yourself%0D%0A%09%09%09%5D%29%20do%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%5D.%0D%0A%09action%20%3A%3D%20%5B%3Adata%7C%20aBlock%20value%3A%20FileEntry%20@%20data%20%5D.%0D%0A%09self%20handle%0D%0A%09%09%23getFile%3A%20pathName%0D%0A%09%09with%3A%20%28options%20isNil%20ifTrue%3A%20%5B%23%7Bnull%7D%5D%20ifFalse%3A%20%5Boptions%5D%29%0D%0A%09%09doing%3A%20action%20onError%3A%20%28self%20errorBlock%3A%20errorBlock%29"));

smalltalk.bind(smalltalk.DirectoryEntry,"withFile:options:do:","withFile_options_do_"

,function (pathName,options,aBlock){var self=this;return self.withFile_options_do_onError_(pathName, options, aBlock, nil);return self;}

,"accessing",unescape("withFile%3A%20pathName%20options%3A%20options%20do%3A%20aBlock%0D%0A%09%22%20Creates%20or%20looks%20up%20a%20file%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withFile%3A%20pathName%20options%3A%20options%20do%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.DirectoryEntry,"withFile:do:","withFile_do_"

,function (pathName,aBlock){var self=this;return self.withFile_options_do_onError_(pathName, nil, aBlock, nil);return self;}

,"accessing",unescape("withFile%3A%20pathName%20do%3A%20aBlock%0D%0A%09%22%20Creates%20or%20looks%20up%20a%20file%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20withFile%3A%20pathName%20options%3A%20nil%20do%3A%20aBlock%20onError%3A%20nil"));

smalltalk.bind(smalltalk.Contacts.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator.contacts);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D%23contacts"));

smalltalk.bind(smalltalk.Contacts.$klass,"errorCodeTable","errorCodeTable"

,function (){var self=this;return [[(0), "Unknown"], [(1), "Invalid argument"], [(2), "Timeout"], [(3), "Pending operation"], [(4), "IO"], [(5), "Not supported"], [(20), "Permission denied"]];return self;}

,"private",unescape("errorCodeTable%0D%0A%09%22%20Private%20-%20Return%20an%20error%20code/description%20table.%20%22%0D%0A%0D%0A%09%5E%23%28%09%23%28%20%200%20%27Unknown%27%20%29%0D%0A%09%09%23%28%20%201%20%27Invalid%20argument%27%20%29%0D%0A%09%09%23%28%20%202%20%27Timeout%27%20%29%0D%0A%09%09%23%28%20%203%20%27Pending%20operation%27%20%29%0D%0A%09%09%23%28%20%204%20%27IO%27%20%29%0D%0A%09%09%23%28%20%205%20%27Not%20supported%27%20%29%0D%0A%09%09%23%28%20%2020%20%27Permission%20denied%27%20%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.Contacts,"watchDoing:onError:with:","watchDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;return self.invalidMessage();return self;}

,"evaluation",unescape("watchDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%20%22%0D%0A%0D%0A%09%5Eself%20invalidMessage"));

smalltalk.bind(smalltalk.Contacts,"valueFromData:","valueFromData_"

,function (data){var self=this;return data.collect_((function(each){return smalltalk.Contact._at(each);}));return self;}

,"accessing",unescape("valueFromData%3A%20data%0D%0A%09%22%20Return%20the%20value%20%28anObject%29computed%20from%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Edata%20collect%3A%20%5B%3Aeach%7C%20Contact%20@%20each%20%5D"));

smalltalk.bind(smalltalk.Contacts,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().find(self.fields(), aBlock, errorBlock, options);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23find%3A%20self%20fields%20onSuccess%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.Contacts,"fields","fields"

,function (){var self=this;((((self['@fields'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeFields();})() : nil);

return self['@fields'];return self;}

,"accessing",unescape("fields%0D%0A%09%22%20Return%20the%20fields%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09fields%20isNil%20ifTrue%3A%20%5B%20self%20initializeFields%20%5D.%0D%0A%09%5Efields"));

smalltalk.bind(smalltalk.Contacts,"fields:","fields_"

,function (anArray){var self=this;self['@fields']=anArray;return self;}

,"accessing",unescape("fields%3A%20anArray%0D%0A%09%22%20Set%20the%20fields%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09fields%20%3A%3D%20anArray"));

smalltalk.bind(smalltalk.Contacts,"initializeFields","initializeFields"

,function (){var self=this;self.fields_(smalltalk.Array.with_(unescape("*")));return self;}

,"initialize",unescape("initializeFields%0D%0A%09%22%20Private%20-%20Initialize%20the%20fields%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20fields%3A%20%28Array%20with%3A%20%27*%27%29%20%22default%20will%20find%20all%20fields%22"));

smalltalk.bind(smalltalk.Contacts,"newContact:","newContact_"

,function (properties){var self=this;return smalltalk.Contact._at(self.handle().create(properties));return self;}

,unescape("contact%20creation"),unescape("newContact%3A%20properties%0D%0A%09%22%20Return%20a%20new%20contact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EContact%20@%20%28self%20handle%20%23create%3A%20properties%29"));

smalltalk.bind(smalltalk.Contacts,"filter:multiple:","filter_multiple_"

,function (filter,multiple){var self=this;var tuples=nil;var add=nil;tuples=smalltalk.Array.$$new();

add=(function(aName, aValue){return ((((aValue || nil) !== nil)).mustBeBoolean()==true ? (function(){return tuples.add_(smalltalk.Array.with_with_(aName, aValue));})() : nil);});

(function($rec){$rec.value_value_("filter", filter);$rec.value_value_("multiple", multiple);return $rec.yourself();})(add);

return self.optionsFromArray_(tuples);return self;}

,"options",unescape("filter%3A%20filter%0D%0Amultiple%3A%20multiple%0D%0A%09%22%20Return%20a%20set%20of%20options%20for%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20tuples%20add%20%7C%0D%0A%09tuples%20%3A%3D%20Array%20new.%0D%0A%09add%20%3A%3D%20%5B%3AaName%20%3AaValue%7C%20aValue%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09tuples%20add%3A%20%28Array%20with%3A%20aName%20with%3A%20aValue%29%0D%0A%09%09%5D%20%5D.%0D%0A%09add%0D%0A%09%09value%3A%20%23filter%20value%3A%20filter%3B%0D%0A%09%09value%3A%20%23multiple%20value%3A%20multiple%3B%0D%0A%09%09yourself.%0D%0A%09%5Eself%20optionsFromArray%3A%20tuples"));

smalltalk.bind(smalltalk.Contacts,"defaultOptions","defaultOptions"

,function (){var self=this;return self.filter_multiple_(nil, false);return self;}

,"accessing",unescape("defaultOptions%0D%0A%09%22%20Return%20default%20options%20to%20get%20data%20with%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20filter%3A%20nil%20multiple%3A%20false"));

smalltalk.bind(smalltalk.PG8DataBase.$klass,"open:version:displayName:size:","open_version_displayName_size_"

,function (name,version,displayName,size){var self=this;return self._at(window.openDatabase(name, version, displayName, size));return self;}

,"open",unescape("open%3A%20name%20version%3A%20version%20displayName%3A%20displayName%20size%3A%20size%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver%20%22%0D%0A%0D%0A%09%5Eself%20@%20%28%23%7Bwindow%7D%20%23openDatabase%3A%20name%20version%3A%20version%20displayName%3A%20displayName%20size%3A%20size%29"));

smalltalk.bind(smalltalk.PG8DataBase,"changeVersion:to:","changeVersion_to_"

,function (from,to){var self=this;self.handle().changeVersion(from, to);return self;}

,"database",unescape("changeVersion%3A%20from%20to%3A%20to%0D%0A%09%22%20Change%20the%20version%20of%20the%20receiver%20%22%0D%0A%0D%0A%09self%20handle%20%23changeVersion%3A%20from%20to%3A%20to"));

smalltalk.bind(smalltalk.PG8DataBase,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().transaction(aBlock, errorBlock);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23transaction%3A%20aBlock%20onError%3A%20errorBlock"));

smalltalk.bind(smalltalk.PG8DataBase,"transaction:onError:","transaction_onError_"

,function (aBlock,errorBlock){var self=this;return self.do_onError_(aBlock, errorBlock);return self;}

,"evaluation",unescape("transaction%3A%20aBlock%20onError%3A%20errorBlock%0D%0A%09%22%20Evaluate%20aBlock%20to%20execute%20a%20transaction%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20do%3A%20aBlock%20onError%3A%20errorBlock"));

smalltalk.bind(smalltalk.PG8DataBase,"valueFromData:","valueFromData_"

,function (data){var self=this;return smalltalk.PG8SQLTransaction._at(data);return self;}

,"accessing",unescape("valueFromData%3A%20data%0D%0A%09%22%20Return%20the%20value%20%28anObject%29computed%20from%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPG8SQLTransaction%20@%20data"));

smalltalk.bind(smalltalk.MediaFile,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.MediaFile,"fullPath","fullPath"

,function (){var self=this;return (self.handle()["fullPath"] || nil);return self;}

,"accessing",unescape("fullPath%0D%0A%09%22%20Return%20the%20fullPath%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27fullPath%27"));

smalltalk.bind(smalltalk.MediaFile,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.MediaFile,"lastModifiedDate","lastModifiedDate"

,function (){var self=this;return (self.handle()["lastModifiedDate"] || nil);return self;}

,"accessing",unescape("lastModifiedDate%0D%0A%09%22%20Return%20the%20lastModifiedDate%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27lastModifiedDate%27"));

smalltalk.bind(smalltalk.MediaFile,"size","size"

,function (){var self=this;return (self.handle()["size"] || nil);return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27size%27"));

smalltalk.bind(smalltalk.MediaFile,"valueFromData:","valueFromData_"

,function (data){var self=this;return data.collect_((function(each){return smalltalk.MediaFileData._at(each);}));return self;}

,"accessing",unescape("valueFromData%3A%20data%0D%0A%09%22%20Return%20the%20value%20%28anObject%29computed%20from%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Edata%20collect%3A%20%5B%3Aeach%7C%20MediaFileData%20@%20each%20%5D"));

smalltalk.bind(smalltalk.MediaFile,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().getFormatData(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23getFormatData%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.Geolocation.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator.geolocation);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D%23geolocation"));

smalltalk.bind(smalltalk.Geolocation.$klass,"errorCodeTable","errorCodeTable"

,function (){var self=this;return [[(1), "Permission denied"], [(2), "Position unavailable"], [(3), "Timeout"]];return self;}

,"private",unescape("errorCodeTable%0D%0A%09%22%20Private%20-%20Return%20an%20error%20code/description%20table.%20%22%0D%0A%0D%0A%09%5E%23%28%0D%0A%09%09%23%28%20%201%20%27Permission%20denied%27%20%29%0D%0A%09%09%23%28%20%202%20%27Position%20unavailable%27%20%29%0D%0A%09%09%23%28%20%203%20%27Timeout%27%20%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.Geolocation,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().getCurrentPosition(aBlock, errorBlock);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23getCurrentPosition%3A%20aBlock%20onError%3A%20errorBlock"));

smalltalk.bind(smalltalk.Geolocation,"watchDoing:onError:with:","watchDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().watchPosition(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("watchDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%20%22%0D%0A%0D%0A%09self%20handle%20%23watchPosition%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.Geolocation,"clearID:","clearID_"

,function (anId){var self=this;return self.handle().clearWatch(anId);return self;}

,"private",unescape("clearID%3A%20anId%0D%0A%09%22%20Private%20-%20Release%20internal%20resource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23clearWatch%3A%20anId"));

smalltalk.bind(smalltalk.Geolocation,"valueFromData:","valueFromData_"

,function (data){var self=this;return smalltalk.GeoPosition._at(data);return self;}

,"accessing",unescape("valueFromData%3A%20data%0D%0A%09%22%20Return%20the%20value%20%28anObject%29computed%20from%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EGeoPosition%20@%20data"));

smalltalk.bind(smalltalk.Geolocation,"defaultOptions","defaultOptions"

,function (){var self=this;return self.optionsFromArray_([["maximumAge", (3000)], ["timeout", (5000)]]._comma(smalltalk.Array.with_(smalltalk.Array.with_with_("enableHighAccuracy", true))));return self;}

,"accessing",unescape("defaultOptions%0D%0A%09%22%20Return%20default%20options%20to%20get%20data%20with%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20optionsFromArray%3A%20%23%28%0D%0A%09%09%23%28%20%23maximumAge%203000%20%29%0D%0A%09%09%23%28%20%23timeout%205000%20%29%0D%0A%09%29%2C%28Array%20with%3A%20%28Array%20with%3A%20%23enableHighAccuracy%20with%3A%20true%29%29"));

smalltalk.bind(smalltalk.Connection.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator.network.connection);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D%23network%23connection"));

smalltalk.bind(smalltalk.Connection,"type","type"

,function (){var self=this;return self['@handle'].type;return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23type"));

smalltalk.bind(smalltalk.Compass.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator.compass);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D%23compass"));

smalltalk.bind(smalltalk.Compass.$klass,"errorCodeTable","errorCodeTable"

,function (){var self=this;return [[(0), "Internal"], [(20), "Not supported"]];return self;}

,"private",unescape("errorCodeTable%0D%0A%09%22%20Private%20-%20Return%20an%20error%20code/description%20table.%20%22%0D%0A%0D%0A%09%5E%23%28%0D%0A%09%09%23%28%20%200%20%27Internal%27%20%29%0D%0A%09%09%23%28%2020%20%27Not%20supported%27%20%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.Compass,"valueFromData:","valueFromData_"

,function (data){var self=this;return smalltalk.CompassHeading._at(data);return self;}

,"accessing",unescape("valueFromData%3A%20data%0D%0A%09%22%20Return%20the%20value%20%28anObject%29computed%20from%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ECompassHeading%20@%20data"));

smalltalk.bind(smalltalk.Compass,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().getCurrentHeading(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23getCurrentHeading%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.Compass,"watchDoing:onError:with:","watchDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().watchHeading(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("watchDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%20%22%0D%0A%0D%0A%09self%20handle%20%23watchHeading%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.Compass,"clearID:","clearID_"

,function (anId){var self=this;self.handle().clearWatch(anId);return self;}

,"private",unescape("clearID%3A%20anId%0D%0A%09%22%20Private%20-%20Release%20internal%20resource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23clearWatch%3A%20anId"));

smalltalk.bind(smalltalk.Compass,"frequency:filter:","frequency_filter_"

,function (frequency,filter){var self=this;var tuples=nil;var add=nil;tuples=smalltalk.Array.$$new();

add=(function(aName, aValue){return ((((aValue || nil) !== nil)).mustBeBoolean()==true ? (function(){return tuples.add_(smalltalk.Array.with_with_(aName, aValue));})() : nil);});

(function($rec){$rec.value_value_("frequency", frequency);$rec.value_value_("filter", filter);return $rec.yourself();})(add);

return self.optionsFromArray_(tuples);return self;}

,"options",unescape("frequency%3A%20frequency%0D%0Afilter%3A%20filter%0D%0A%09%22%20Return%20a%20set%20of%20options%20for%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20tuples%20add%20%7C%0D%0A%09tuples%20%3A%3D%20Array%20new.%0D%0A%09add%20%3A%3D%20%5B%3AaName%20%3AaValue%7C%20aValue%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09tuples%20add%3A%20%28Array%20with%3A%20aName%20with%3A%20aValue%29%0D%0A%09%09%5D%20%5D.%0D%0A%09add%0D%0A%09%09value%3A%20%23frequency%20value%3A%20frequency%3B%0D%0A%09%09value%3A%20%23filter%20value%3A%20filter%3B%0D%0A%09%09yourself.%0D%0A%09%5Eself%20optionsFromArray%3A%20tuples"));

smalltalk.bind(smalltalk.Compass,"defaultOptions","defaultOptions"

,function (){var self=this;return self.frequency_filter_((100), nil);return self;}

,"accessing",unescape("defaultOptions%0D%0A%09%22%20Return%20default%20options%20to%20get%20data%20with%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20frequency%3A%20100%20filter%3A%20nil"));

smalltalk.bind(smalltalk.Capture.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator.device.capture);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D%23device%23capture"));

smalltalk.bind(smalltalk.Capture.$klass,"errorCodeTable","errorCodeTable"

,function (){var self=this;return [[(0), "Internal"], [(1), "Application busy"], [(2), "Invalid argument"], [(3), "No media files"], [(4), "Not supported"]];return self;}

,"private",unescape("errorCodeTable%0D%0A%09%22%20Private%20-%20Return%20an%20error%20code/description%20table.%20%22%0D%0A%0D%0A%09%5E%23%28%0D%0A%09%09%23%28%20%200%20%27Internal%27%20%29%0D%0A%09%09%23%28%20%201%20%27Application%20busy%27%20%29%0D%0A%09%09%23%28%20%202%20%27Invalid%20argument%27%20%29%0D%0A%09%09%23%28%20%203%20%27No%20media%20files%27%20%29%0D%0A%09%09%23%28%20%204%20%27Not%20supported%27%20%29%0D%0A%09%29"));

smalltalk.bind(smalltalk.Capture,"watchDoing:onError:with:","watchDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;return self.invalidMessage();return self;}

,"evaluation",unescape("watchDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%20%22%0D%0A%0D%0A%09%5Eself%20invalidMessage"));

smalltalk.bind(smalltalk.Capture,"clearID:","clearID_"

,function (anId){var self=this;return self.invalidMessage();return self;}

,"private",unescape("clearID%3A%20anId%0D%0A%09%22%20Private%20-%20Release%20internal%20resource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20invalidMessage"));

smalltalk.bind(smalltalk.Capture,"limit:duration:mode:","limit_duration_mode_"

,function (limit,duration,mode){var self=this;var tuples=nil;var add=nil;tuples=smalltalk.Array.$$new();

add=(function(aName, aValue){return ((((aValue || nil) !== nil)).mustBeBoolean()==true ? (function(){return tuples.add_(smalltalk.Array.with_with_(aName, aValue));})() : nil);});

(function($rec){$rec.value_value_("limit", limit);$rec.value_value_("duration", duration);$rec.value_value_("mode", mode);return $rec.yourself();})(add);

return self.optionsFromArray_(tuples);return self;}

,"options",unescape("limit%3A%20limit%0D%0Aduration%3A%20duration%0D%0Amode%3A%20mode%0D%0A%09%22%20Return%20a%20set%20of%20options%20for%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20tuples%20add%20%7C%0D%0A%09tuples%20%3A%3D%20Array%20new.%0D%0A%09add%20%3A%3D%20%5B%3AaName%20%3AaValue%7C%20aValue%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09tuples%20add%3A%20%28Array%20with%3A%20aName%20with%3A%20aValue%29%0D%0A%09%09%5D%20%5D.%0D%0A%09add%0D%0A%09%09value%3A%20%23limit%20value%3A%20limit%3B%0D%0A%09%09value%3A%20%23duration%20value%3A%20duration%3B%0D%0A%09%09value%3A%20%23mode%20value%3A%20mode%3B%0D%0A%09%09yourself.%0D%0A%09%5Eself%20optionsFromArray%3A%20tuples"));

smalltalk.bind(smalltalk.Capture,"limit:mode:","limit_mode_"

,function (limit,mode){var self=this;return self.limit_duration_mode_(limit, nil, mode);return self;}

,"options",unescape("limit%3A%20limit%20mode%3A%20mode%0D%0A%09%22%20Return%20a%20set%20of%20options%20for%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20limit%3A%20limit%20duration%3A%20nil%20mode%3A%20mode"));

smalltalk.bind(smalltalk.Capture,"valueFromData:","valueFromData_"

,function (data){var self=this;return data.collect_((function(each){return smalltalk.MediaFile._at(each);}));return self;}

,"accessing",unescape("valueFromData%3A%20data%0D%0A%09%22%20Return%20the%20value%20%28anObject%29computed%20from%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Edata%20collect%3A%20%5B%3Aeach%7C%20MediaFile%20@%20each%20%5D"));

smalltalk.bind(smalltalk.Camera.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator.camera);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D%23camera"));

smalltalk.bind(smalltalk.Camera,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().getPicture(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23getPicture%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.Camera,"watchDoing:onError:with:","watchDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;return self.invalidMessage();return self;}

,"evaluation",unescape("watchDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%20%22%0D%0A%0D%0A%09%5Eself%20invalidMessage"));

smalltalk.bind(smalltalk.Camera,"clearID:","clearID_"

,function (anId){var self=this;return self.invalidMessage();return self;}

,"private",unescape("clearID%3A%20anId%0D%0A%09%22%20Private%20-%20Release%20internal%20resource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20invalidMessage"));

smalltalk.bind(smalltalk.Camera,"quality:destinationType:sourceType:allowEdit:encodingType:targetWidth:targetHeight:","quality_destinationType_sourceType_allowEdit_encodingType_targetWidth_targetHeight_"

,function (quality,destinationType,sourceType,allowEdit,encodingType,targetWidth,targetHeight){var self=this;var tuples=nil;var add=nil;tuples=smalltalk.Array.$$new();

add=(function(aName, aValue){return ((((aValue || nil) !== nil)).mustBeBoolean()==true ? (function(){return tuples.add_(smalltalk.Array.with_with_(aName, aValue));})() : nil);});

(function($rec){$rec.value_value_("quality", quality);$rec.value_value_("destinationType", destinationType);$rec.value_value_("sourceType", sourceType);$rec.value_value_("allowEdit", allowEdit);$rec.value_value_("encodingType", encodingType);$rec.value_value_("targetWidth", targetWidth);$rec.value_value_(targetHeight, targetHeight);return $rec.yourself();})(add);

return self.optionsFromArray_(tuples);return self;}

,"options",unescape("quality%3A%20quality%0D%0AdestinationType%3A%20destinationType%0D%0AsourceType%3A%20sourceType%0D%0AallowEdit%3A%20allowEdit%0D%0AencodingType%3A%20encodingType%0D%0AtargetWidth%3A%20targetWidth%0D%0AtargetHeight%3A%20targetHeight%0D%0A%09%22%20Return%20a%20set%20of%20options%20for%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20tuples%20add%20%7C%0D%0A%09tuples%20%3A%3D%20Array%20new.%0D%0A%09add%20%3A%3D%20%5B%3AaName%20%3AaValue%7C%20aValue%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09tuples%20add%3A%20%28Array%20with%3A%20aName%20with%3A%20aValue%29%0D%0A%09%09%5D%20%5D.%0D%0A%09add%0D%0A%09%09value%3A%20%23quality%20value%3A%20quality%3B%0D%0A%09%09value%3A%20%23destinationType%20value%3A%20destinationType%3B%0D%0A%09%09value%3A%20%23sourceType%20value%3A%20sourceType%3B%0D%0A%09%09value%3A%20%23allowEdit%20value%3A%20allowEdit%3B%0D%0A%09%09value%3A%20%23encodingType%20value%3A%20encodingType%3B%0D%0A%09%09value%3A%20%23targetWidth%20value%3A%20targetWidth%3B%0D%0A%09%09value%3A%20targetHeight%20value%3A%20targetHeight%3B%0D%0A%09%09yourself.%0D%0A%09%5Eself%20optionsFromArray%3A%20tuples"));

smalltalk.bind(smalltalk.Camera,"defaultOptions","defaultOptions"

,function (){var self=this;return self.quality_destinationType_sourceType_allowEdit_encodingType_targetWidth_targetHeight_((75), (0), (1), false, (0), (100), (100));return self;}

,"accessing",unescape("defaultOptions%0D%0A%09%22%20Return%20default%20options%20to%20get%20data%20with%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09quality%3A%2075%20destinationType%3A%200%0D%0A%09%09sourceType%3A%201%20allowEdit%3A%20false%0D%0A%09%09encodingType%3A%200%0D%0A%09%09targetWidth%3A%20100%20targetHeight%3A%20100"));

smalltalk.bind(smalltalk.Accelerometer.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator.accelerometer);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D%23accelerometer"));

smalltalk.bind(smalltalk.Accelerometer,"defaultOptions","defaultOptions"

,function (){var self=this;return self.optionsFromArray_([["frequency", (10000)]]);return self;}

,"accessing",unescape("defaultOptions%0D%0A%09%22%20Return%20default%20options%20to%20get%20data%20with%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20optionsFromArray%3A%20%23%28%20%23%28%20%23frequency%2010000%20%29%20%29"));

smalltalk.bind(smalltalk.Accelerometer,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().getCurrentAcceleration(aBlock, errorBlock);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23getCurrentAcceleration%3A%20aBlock%20onError%3A%20errorBlock"));

smalltalk.bind(smalltalk.Accelerometer,"watchDoing:onError:with:","watchDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().watchAcceleration(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("watchDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%20%22%0D%0A%0D%0A%09self%20handle%20%23watchAcceleration%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.Accelerometer,"valueFromData:","valueFromData_"

,function (data){var self=this;return smalltalk.Acceleration._at(data);return self;}

,"accessing",unescape("valueFromData%3A%20data%0D%0A%09%22%20Return%20the%20value%20%28anObject%29computed%20from%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EAcceleration%20@%20data"));

smalltalk.bind(smalltalk.Accelerometer,"optionsFrom:","optionsFrom_"

,function (options){var self=this;try{((options.isNumber()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "optionsFrom_", fn: function(){return self.optionFrom_(smalltalk.Array.with_with_("frequency", options))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "optionsFrom_", fn: function(){return smalltalk.whoImplements(smalltalk.Accelerometer,'optionsFrom_').$superclass.$fn.prototype['optionsFrom_'].apply(self, [options])}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "optionsFrom_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("optionsFrom%3A%20options%0D%0A%09%22%20Return%20the%20options%20data%20object%20%28jsObject%29.%20%22%0D%0A%0D%0A%09options%20isNumber%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20optionFrom%3A%20%28Array%20with%3A%20%23frequency%20with%3A%20options%29%0D%0A%09%5D.%0D%0A%09%5Esuper%20optionsFrom%3A%20options"));

smalltalk.bind(smalltalk.Accelerometer,"clearID:","clearID_"

,function (anId){var self=this;return self.handle().clearWatch(anId);return self;}

,"private",unescape("clearID%3A%20anId%0D%0A%09%22%20Private%20-%20Release%20internal%20resource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23clearWatch%3A%20anId"));

smalltalk.bind(smalltalk.CompassFilter,"watchDoing:onError:with:","watchDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().watchHeadingFilter(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("watchDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver%20at%20regular%20interval.%20%22%0D%0A%0D%0A%09self%20handle%20%23watchHeadingFilter%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.CompassFilter,"clearID:","clearID_"

,function (anId){var self=this;self.handle().clearWatchFilter(anId);return self;}

,"private",unescape("clearID%3A%20anId%0D%0A%09%22%20Private%20-%20Release%20internal%20resource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23clearWatchFilter%3A%20anId"));

smalltalk.bind(smalltalk.CaptureVideo,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().captureVideo(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23captureVideo%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.CaptureVideo,"defaultOptions","defaultOptions"

,function (){var self=this;return self.limit_duration_mode_((3), nil, nil);return self;}

,"accessing",unescape("defaultOptions%0D%0A%09%22%20Return%20default%20options%20to%20get%20data%20with%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20limit%3A%203%20duration%3A%20nil%20mode%3A%20nil"));

smalltalk.bind(smalltalk.CaptureImage,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().captureImage(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23captureImage%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.CaptureImage,"defaultOptions","defaultOptions"

,function (){var self=this;return self.limit_duration_mode_((3), nil, nil);return self;}

,"accessing",unescape("defaultOptions%0D%0A%09%22%20Return%20default%20options%20to%20get%20data%20with%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20limit%3A%203%20duration%3A%20nil%20mode%3A%20nil"));

smalltalk.bind(smalltalk.CaptureAudio,"valueDoing:onError:with:","valueDoing_onError_with_"

,function (aBlock,errorBlock,options){var self=this;self.handle().captureAudio(aBlock, errorBlock, options);return self;}

,"evaluation",unescape("valueDoing%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20when%20async%20data%20is%20obtained%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20%23captureAudio%3A%20aBlock%20onError%3A%20errorBlock%20with%3A%20options"));

smalltalk.bind(smalltalk.CaptureAudio,"defaultOptions","defaultOptions"

,function (){var self=this;return self.limit_duration_mode_((3), (10), nil);return self;}

,"accessing",unescape("defaultOptions%0D%0A%09%22%20Return%20default%20options%20to%20get%20data%20with%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20limit%3A%203%20duration%3A%2010%20mode%3A%20nil"));

smalltalk.bind(smalltalk.DOMNode,"firstChild","firstChild"

,function (){var self=this;return (self.handle()["firstChild"] || nil);return self;}

,"accessing",unescape("firstChild%0D%0A%09%22%20Return%20the%20firstChild%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27firstChild%27"));

smalltalk.bind(smalltalk.DOMNode,"lastChild","lastChild"

,function (){var self=this;return (self.handle()["lastChild"] || nil);return self;}

,"accessing",unescape("lastChild%0D%0A%09%22%20Return%20the%20lastChild%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27lastChild%27"));

smalltalk.bind(smalltalk.DOMNode,"nodeName","nodeName"

,function (){var self=this;return (self.handle()["nodeName"] || nil);return self;}

,"accessing",unescape("nodeName%0D%0A%09%22%20Return%20the%20nodeName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27nodeName%27"));

smalltalk.bind(smalltalk.DOMNode,"nodeType","nodeType"

,function (){var self=this;return (self.handle()["nodeType"] || nil);return self;}

,"accessing",unescape("nodeType%0D%0A%09%22%20Return%20the%20nodeType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27nodeType%27"));

smalltalk.bind(smalltalk.DOMNode,"nodeValue","nodeValue"

,function (){var self=this;return (self.handle()["nodeValue"] || nil);return self;}

,"accessing",unescape("nodeValue%0D%0A%09%22%20Return%20the%20nodeValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27nodeValue%27"));

smalltalk.bind(smalltalk.DOMNode,"attributes","attributes"

,function (){var self=this;return self.array_of_(self['@handle'].attributes, smalltalk.DOMAttribute);return self;}

,"accessing",unescape("attributes%0D%0A%09%22%20Return%20the%20attributes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23attributes%20of%3A%20DOMAttribute"));

smalltalk.bind(smalltalk.DOMNode,"attributeAt:","attributeAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].attributes, smalltalk.DOMAttribute, index);return self;}

,"accessing",unescape("attributeAt%3A%20index%0D%0A%09%22%20Return%20the%20attribute%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23attributes%20of%3A%20DOMAttribute%20at%3A%20index"));

smalltalk.bind(smalltalk.DOMNode,"attributesDo:","attributesDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].attributes, smalltalk.DOMAttribute, aBlock);return self;}

,"accessing",unescape("attributesDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20attributes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23attributes%20of%3A%20DOMAttribute%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMNode,"childNodes","childNodes"

,function (){var self=this;return self.array_of_(self['@handle'].childNodes, self.elementSupport());return self;}

,"accessing",unescape("childNodes%0D%0A%09%22%20Return%20the%20childNodes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23childNodes%20of%3A%20self%20elementSupport"));

smalltalk.bind(smalltalk.DOMNode,"childNodesDo:","childNodesDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].childNodes, self.elementSupport(), aBlock);return self;}

,"accessing",unescape("childNodesDo%3A%20aBlock%0D%0A%09%22%20Evaluates%20aBlock%20with%20the%20childNodes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23childNodes%20of%3A%20self%20elementSupport%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMNode,"childNodeAt:","childNodeAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].childNodes, self.elementSupport(), index);return self;}

,"accessing",unescape("childNodeAt%3A%20index%0D%0A%09%22%20Return%20the%20childNode%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23childNodes%20of%3A%20self%20elementSupport%20at%3A%20index"));

smalltalk.bind(smalltalk.DOMNode,"appendChild:","appendChild_"

,function (aDOMNode){var self=this;return self['@handle'].appendChild(self.asJson_(aDOMNode));return self;}

,"actions",unescape("appendChild%3A%20aDOMNode%0D%0A%09%22%20Adds%20a%20new%20element%20to%20the%20end%20of%20the%20children%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23appendChild%3A%20%28self%20asJson%3A%20aDOMNode%29"));

smalltalk.bind(smalltalk.DOMNode,"cloneNode:","cloneNode_"

,function (includeAll){var self=this;return self.$klass._at(self['@handle'].cloneNode(includeAll));return self;}

,"actions",unescape("cloneNode%3A%20includeAll%0D%0A%09%22%20If%20the%20Boolean%20parameter%20is%20set%20to%20true%2C%20the%20cloned%20node%20clones%20all%20the%20child%20nodes%20of%20the%20original%20node%20as%20well.%20%22%0D%0A%0D%0A%09%5Eself%20class%20@%20%28handle%20%23cloneNode%3A%20includeAll%29"));

smalltalk.bind(smalltalk.DOMNode,"hasChildNodes","hasChildNodes"

,function (){var self=this;return self['@handle'].hasChildNodes();return self;}

,"accessing",unescape("hasChildNodes%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20hasChildNodes.%20%22%0D%0A%0D%0A%09%5Ehandle%20hasChildNodes"));

smalltalk.bind(smalltalk.DOMNode,"insert:before:","insert_before_"

,function (newChild,refChild){var self=this;self['@handle'].insertBefore(self.asJson_(newChild), self.asJson_(refChild));return self;}

,"actions",unescape("insert%3A%20newChild%20before%3A%20refChild%0D%0A%09%22%20Insert%20new%20child%20element%20in%20the%20receiver%20just%20before%20reference.%20%22%0D%0A%0D%0A%09handle%0D%0A%09%09%23insertBefore%3A%20%28self%20asJson%3A%20newChild%29%0D%0A%09%09with%3A%20%28self%20asJson%3A%20refChild%29"));

smalltalk.bind(smalltalk.DOMNode,"removeChild:","removeChild_"

,function (aDOMNode){var self=this;return self['@handle'].removeChild(self.asJson_(aDOMNode));return self;}

,"accessing",unescape("removeChild%3A%20aDOMNode%0D%0A%09%22%20Remove%20the%20node%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23removeChild%3A%20%28self%20asJson%3A%20aDOMNode%29"));

smalltalk.bind(smalltalk.DOMNode,"removeNode:","removeNode_"

,function (aDOMNode){var self=this;return self['@handle'].removeNode(self.asJson_(aDOMNode));return self;}

,"accessing",unescape("removeNode%3A%20aDOMNode%0D%0A%09%22%20Remove%20the%20node%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23removeNode%3A%20%28self%20asJson%3A%20aDOMNode%29"));

smalltalk.bind(smalltalk.DOMNode,"replace:child:","replace_child_"

,function (newNode,oldNode){var self=this;return self['@handle'].replaceChild(self.asJson_(newNode), self.asJson_(oldNode));return self;}

,"accessing",unescape("replace%3A%20newNode%20child%3A%20oldNode%0D%0A%09%22%20Replace%20the%20node%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%0D%0A%09%09%23replaceChild%3A%20%28self%20asJson%3A%20newNode%29%0D%0A%09%09old%3A%20%28self%20asJson%3A%20oldNode%29"));

smalltalk.bind(smalltalk.DOMNode,"replace:with:","replace_with_"

,function (oldNode,newNode){var self=this;return self['@handle'].replaceChild(self.asJson_(newNode), self.asJson_(oldNode));return self;}

,"accessing",unescape("replace%3A%20oldNode%20with%3A%20newNode%0D%0A%09%22%20Replace%20the%20node%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%0D%0A%09%09%23replaceChild%3A%20%28self%20asJson%3A%20newNode%29%0D%0A%09%09old%3A%20%28self%20asJson%3A%20oldNode%29"));

smalltalk.bind(smalltalk.DOMDocument.$klass,"elementSupport","elementSupport"

,function (){var self=this;return smalltalk.DOMElement;return self;}

,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5EDOMElement"));

smalltalk.bind(smalltalk.DOMDocument,"get:byId:","get_byId_"

,function (aDOMElementClass,id){var self=this;return aDOMElementClass._at(self['@handle'].getElementById(id));return self;}

,"accessing",unescape("get%3A%20aDOMElementClass%20byId%3A%20id%0D%0A%09%22%20Return%20the%20first%20element%20in%20the%20receiver%20with%20id%20as%20an%20instance%20of%20aDOMElementClass.%20%22%0D%0A%0D%0A%09%5EaDOMElementClass%20@%20%28handle%20%23getElementById%3A%20id%29"));

smalltalk.bind(smalltalk.DOMDocument,"getElementById:","getElementById_"

,function (id){var self=this;return self.get_byId_(self.elementSupport(), id);return self;}

,"accessing",unescape("getElementById%3A%20id%0D%0A%09%22%20Return%20the%20first%20element%20in%20the%20receiver%20with%20id.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byId%3A%20id"));

smalltalk.bind(smalltalk.DOMDocument,"@","_at"

,function (id){var self=this;return self.getElementById_(id);return self;}

,"accessing",unescape("@%20id%0D%0A%09%22%20Return%20the%20element%20in%20the%20receiver%20with%20id.%20%22%0D%0A%0D%0A%09%5Eself%20getElementById%3A%20id"));

smalltalk.bind(smalltalk.DOMDocument,"get:byName:","get_byName_"

,function (aDOMElementClass,aName){var self=this;return aDOMElementClass._at(self['@handle'].getElementByName(aName));return self;}

,"accessing",unescape("get%3A%20aDOMElementClass%20byName%3A%20aName%0D%0A%09%22%20Return%20the%20first%20element%20in%20the%20receiver%20with%20name%20aName%20as%20an%20instance%20of%20aDOMElementClass.%20%22%0D%0A%0D%0A%09%5EaDOMElementClass%20@%20%28handle%20%23getElementByName%3A%20aName%29"));

smalltalk.bind(smalltalk.DOMDocument,"get:byTagName:do:","get_byTagName_do_"

,function (aDOMElementClass,tagName,aBlock){var self=this;return self.array_of_do_(self['@handle'].getElementsByTagName(tagName), aDOMElementClass, aBlock);return self;}

,"accessing",unescape("get%3A%20aDOMElementClass%20byTagName%3A%20tagName%20do%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20elements%20collection%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09array%3A%20%28handle%20%23getElementsByTagName%3A%20tagName%29%0D%0A%09%09of%3A%20aDOMElementClass%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMDocument,"get:byTagName:","get_byTagName_"

,function (aDOMElementClass,tagName){var self=this;return self.array_of_(self['@handle'].getElementsByTagName(tagName), aDOMElementClass);return self;}

,"accessing",unescape("get%3A%20aDOMElementClass%20byTagName%3A%20tagName%0D%0A%09%22%20Private%20-%20Return%20the%20elements%20collection%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09array%3A%20%28handle%20%23getElementsByTagName%3A%20tagName%29%0D%0A%09%09of%3A%20aDOMElementClass"));

smalltalk.bind(smalltalk.DOMDocument,"getElementsByTagName:","getElementsByTagName_"

,function (tagName){var self=this;return self.get_byTagName_(self.elementSupport(), tagName);return self;}

,"accessing",unescape("getElementsByTagName%3A%20tagName%0D%0A%09%22%20Return%20anArray%20with%20the%20elements%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byTagName%3A%20tagName"));

smalltalk.bind(smalltalk.DOMDocument,"withElementsTagged:do:","withElementsTagged_do_"

,function (tagName,aBlock){var self=this;return self.get_byTagName_do_(self.elementSupport(), tagName, aBlock);return self;}

,"accessing",unescape("withElementsTagged%3A%20tagName%20do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20elements%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byTagName%3A%20tagName%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMDocument,"createAttribute:","createAttribute_"

,function (aName){var self=this;return smalltalk.DOMAttribute._at(self['@handle'].createAttribute(aName));return self;}

,"creation",unescape("createAttribute%3A%20aName%0D%0A%09%22%20Return%20a%20DOMAttribute%20of%20given%20name%20aName.%20%22%0D%0A%0D%0A%09%5EDOMAttribute%20@%20%28handle%20%23createAttribute%3A%20aName%29"));

smalltalk.bind(smalltalk.DOMDocument,"createCDATASection:","createCDATASection_"

,function (data){var self=this;return self.elementSupport()._at(self['@handle'].createCDATASection(data));return self;}

,"creation",unescape("createCDATASection%3A%20data%0D%0A%09%22%20Return%20a%20data%20section%20with%20data.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20%23createCDATASection%3A%20data%29"));

smalltalk.bind(smalltalk.DOMDocument,"createComment:","createComment_"

,function (data){var self=this;return self.elementSupport()._at(self['@handle'].createComment(data));return self;}

,"creation",unescape("createComment%3A%20data%0D%0A%09%22%20Return%20a%20comment%20with%20data.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20%23createComment%3A%20data%29"));

smalltalk.bind(smalltalk.DOMDocument,"createDocumentFragment","createDocumentFragment"

,function (){var self=this;return self.elementSupport()._at(self['@handle'].createDocumentFragment());return self;}

,"creation",unescape("createDocumentFragment%0D%0A%09%22%20Return%20a%20new%20document%20fragment.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%20createDocumentFragment"));

smalltalk.bind(smalltalk.DOMDocument,"createElement:","createElement_"

,function (tagName){var self=this;return self.elementSupport()._at(self.createElementHandle_(tagName));return self;}

,"creation",unescape("createElement%3A%20tagName%0D%0A%09%22%20Return%20a%20DOMElement%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28self%20createElementHandle%3A%20tagName%29"));

smalltalk.bind(smalltalk.DOMDocument,"createTextElement:","createTextElement_"

,function (aString){var self=this;return smalltalk.DOMText._at(self.createTextElement_(aString));return self;}

,"creation",unescape("createTextElement%3A%20aString%0D%0A%09%22%20Return%20a%20DOMText%20with%20aString.%20%22%0D%0A%0D%0A%09%5EDOMText%20@%20%28self%20createTextElement%3A%20aString%29"));

smalltalk.bind(smalltalk.DOMDocument,"createElementHandle:","createElementHandle_"

,function (tagName){var self=this;return self['@handle'].createElement(tagName);return self;}

,"creation",unescape("createElementHandle%3A%20tagName%0D%0A%09%22%20Private%20-%20Return%20a%20DOMElement%20handle%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23createElement%3A%20tagName"));

smalltalk.bind(smalltalk.DOMDocument,"elementFromPoint:y:","elementFromPoint_y_"

,function (x,y){var self=this;return self.elementSupport()._at(self['@handle'].elementFromPoint(x, y));return self;}

,"accessing",unescape("elementFromPoint%3A%20x%20y%3A%20y%0D%0A%09%22%20Return%20a%20DOMElement%20at%20coordinates%20x%2Cy%20in%20the%20viewport%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20%23elementFromPoint%3A%20x%20y%3A%20y%29"));

smalltalk.bind(smalltalk.DOMDocument,"elementFromPoint:","elementFromPoint_"

,function (aPoint){var self=this;return self.elementFromPoint_y_(aPoint.x(), aPoint.y());return self;}

,"accessing",unescape("elementFromPoint%3A%20aPoint%0D%0A%09%22%20Return%20a%20DOMElement%20at%20coordinates%20x%2Cy%20in%20the%20viewport%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20elementFromPoint%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.DOMDocument,"caretPositionFromPoint:y:","caretPositionFromPoint_y_"

,function (x,y){var self=this;return self['@handle'].caretPositionFromPoint(x, y);return self;}

,"accessing",unescape("caretPositionFromPoint%3A%20x%20y%3A%20y%0D%0A%09%22%20Return%20a%20caret%20position%20with%20the%20position%20of%20a%20text%20insertion%20point%20indicator%20%28or%20nil%29.%0D%0A%09It%20always%20has%20an%20associated%20caret%23offsetNode%20and%20caret%23offset.%0D%0A%09%22%0D%0A%0D%0A%09%5Ehandle%20%23caretPositionFromPoint%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.DOMDocument,"caretPositionFromPoint:","caretPositionFromPoint_"

,function (aPoint){var self=this;return self.caretPositionFromPoint_y_(aPoint.x(), aPoint.y());return self;}

,"accessing",unescape("caretPositionFromPoint%3A%20aPoint%0D%0A%09%22%20Return%20a%20caret%20position%20with%20the%20position%20of%20a%20text%20insertion%20point%20indicator%20%28or%20nil%29.%0D%0A%09It%20always%20has%20an%20associated%20caret%23offsetNode%20and%20caret%23offset.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20caretPositionFromPoint%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.DOMDocument,"createEvent:","createEvent_"

,function (type){var self=this;return smalltalk.DOMEvent._at(self.handle().createEvent(type));return self;}

,"DOM-Events-creating",unescape("createEvent%3A%20type%0D%0A%09%5EDOMEvent%20@%20%28self%20handle%20%23createEvent%3A%20type%29"));

smalltalk.bind(smalltalk.DOMDocument,"createTouch:target:identifier:pageX:pageY:screenX:screenY:","createTouch_target_identifier_pageX_pageY_screenX_screenY_"

,function (view,target,identifier,pageX,pageY,screenX,screenY){var self=this;return smalltalk.Touch._at(self.handle().createTouch(view, target, identifier, pageX, pageY, screenX, screenY));return self;}

,"DOM-Events-creating",unescape("createTouch%3A%20view%20target%3A%20target%20identifier%3A%20identifier%0D%0A%09pageX%3A%20pageX%20pageY%3A%20pageY%20screenX%3A%20screenX%20screenY%3A%20screenY%0D%0A%09%5ETouch%20@%20%28self%20handle%20%23createTouch%3A%20view%20target%3A%20target%20identifier%3A%20identifier%20pageX%3A%20pageX%20pageY%3A%20pageY%20screenX%3A%20screenX%20screenY%3A%20screenY%29"));

smalltalk.bind(smalltalk.DOMDocument,"createTouchList:","createTouchList_"

,function (touchOrTouchesArray){var self=this;var arg=nil;arg=((touchOrTouchesArray.isArray().or_((function(){return self.isObject_(touchOrTouchesArray).not();}))).mustBeBoolean()==true ? (function(){return touchOrTouchesArray;})() : (function(){return touchOrTouchesArray.handle();})());

return smalltalk.TouchList._at(self.handle().createTouchList(arg));return self;}

,"DOM-Events-creating",unescape("createTouchList%3A%20touchOrTouchesArray%0D%0A%09%7C%20arg%20%7C%0D%0A%09arg%20%3A%3D%20%28touchOrTouchesArray%20isArray%20or%3A%20%5B%20%28self%20isObject%3A%20touchOrTouchesArray%29%20not%20%5D%29%0D%0A%09%09ifTrue%3A%20%5B%20touchOrTouchesArray%20%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20touchOrTouchesArray%20handle%20%5D.%0D%0A%09%5ETouchList%20@%20%28self%20handle%20%23createTouchList%3A%20arg%29"));

smalltalk.bind(smalltalk.DOMDocument,"querySelector:","querySelector_"

,function (selectors){var self=this;return self.elementSupport()._at(self['@handle'].querySelectorAll_(selectors));return self;}

,"accessing",unescape("querySelector%3A%20selectors%0D%0A%09%22%20Return%20the%20first%20matching%20node%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20querySelectorAll%3A%20selectors%29"));

smalltalk.bind(smalltalk.DOMDocument,"querySelectorAll:","querySelectorAll_"

,function (selectors){var self=this;return self.array_of_(self['@handle'].querySelectorAll_(selectors), self.elementSupport());return self;}

,"accessing",unescape("querySelectorAll%3A%20selectors%0D%0A%09%22%20Return%20all%20of%20the%20matching%20nodes%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20%28handle%20querySelectorAll%3A%20selectors%29%20of%3A%20self%20elementSupport"));

smalltalk.bind(smalltalk.DOMDocument,"querySelectorAll:doing:","querySelectorAll_doing_"

,function (selectors,aBlock){var self=this;return self.array_of_do_(self['@handle'].querySelectorAll_(selectors), self.elementSupport(), aBlock);return self;}

,"accessing",unescape("querySelectorAll%3A%20selectors%20doing%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20of%20the%20matching%20nodes%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20%28handle%20querySelectorAll%3A%20selectors%29%20of%3A%20self%20elementSupport%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTML5.$klass,"selectorForHTML5Event:","selectorForHTML5Event_"

,function (anEvent){var self=this;return "on"._comma(anEvent.upTo_(":").asLowercase());return self;}

,"events",unescape("selectorForHTML5Event%3A%20anEvent%0D%0A%09%22%20Private%20-%20Return%20the%20on...%20selector%20to%20use%20to%20register%20binding%20to%20anEvent.%20%22%0D%0A%0D%0A%09%5E%23on%20%2C%20%28anEvent%20upTo%3A%20%24%3A%29%20asLowercase"));

smalltalk.bind(smalltalk.TouchList,"length","length"

,function (){var self=this;return (self.handle()["length"] || nil);return self;}

,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27length%27"));

smalltalk.bind(smalltalk.TouchList,"item:","item_"

,function (offset){var self=this;return smalltalk.Touch._at(self.handle().item(offset));return self;}

,"wrappers",unescape("item%3A%20offset%20%0D%0A%09%22%20Wrap%20method%20delegating%20item%3A%20to%20handle.%20%22%0D%0A%0D%0A%09%5ETouch%20@%20%28self%20handle%20%23item%3A%20offset%20%29"));

smalltalk.bind(smalltalk.TouchList,"identifiedTouch:","identifiedTouch_"

,function (identifier){var self=this;return smalltalk.Touch._at(self.handle().identifiedTouch(identifier));return self;}

,"wrappers",unescape("identifiedTouch%3A%20identifier%20%0D%0A%09%22%20Wrap%20method%20delegating%20identifiedTouch%3A%20to%20handle.%20%22%0D%0A%0D%0A%09%5ETouch%20@%20%28self%20handle%20%23identifiedTouch%3A%20identifier%20%29"));

smalltalk.bind(smalltalk.TouchList,"size","size"

,function (){var self=this;return self.length();return self;}

,"accessing",unescape("size%0D%0A%09%5Eself%20length"));

smalltalk.bind(smalltalk.TouchList,"at:","at_"

,function (index){var self=this;return self.item_((index + (1)));return self;}

,"accessing",unescape("at%3A%20index%0D%0A%09%5Eself%20item%3A%20index%20+%201"));

smalltalk.bind(smalltalk.TouchList,"id:","id_"

,function (identifier){var self=this;return self.identifiedTouch_(id);return self;}

,"accessing",unescape("id%3A%20identifier%0D%0A%09%5Eself%20identifiedTouch%3A%20id"));

smalltalk.bind(smalltalk.TouchList,"first","first"

,function (){var self=this;return self.item_((0));return self;}

,"accessing",unescape("first%0D%0A%09%5Eself%20item%3A%200"));

smalltalk.bind(smalltalk.TouchList,"last","last"

,function (){var self=this;return self.at_(self.size());return self;}

,"accessing",unescape("last%0D%0A%09%5Eself%20at%3A%20self%20size"));

smalltalk.bind(smalltalk.TouchList,"asArray","asArray"

,function (){var self=this;return (0).to_((self.length() - (1))).collect_((function(offset){return self.item_(offset);}));return self;}

,"converting",unescape("asArray%0D%0A%09%5E%280%20to%3A%20self%20length%20-%201%29%20collect%3A%20%5B%3Aoffset%7C%20self%20item%3A%20offset%20%5D"));

smalltalk.bind(smalltalk.TouchList,"isEmpty","isEmpty"

,function (){var self=this;return self.length()._eq((0));return self;}

,"query",unescape("isEmpty%0D%0A%09%5Eself%20length%20%3D%200"));

smalltalk.bind(smalltalk.TouchList,"notEmpty","notEmpty"

,function (){var self=this;return (self.length() > (0));return self;}

,"query",unescape("notEmpty%0D%0A%09%5Eself%20length%20%3E%200"));

smalltalk.bind(smalltalk.TouchList,"do:","do_"

,function (aBlock){var self=this;return self.asArray().do_(aBlock);return self;}

,"iteration",unescape("do%3A%20aBlock%0D%0A%09%5Eself%20asArray%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.Touch,"identifier","identifier"

,function (){var self=this;return (self.handle()["identifier"] || nil);return self;}

,"accessing",unescape("identifier%0D%0A%09%22%20Return%20the%20identifier%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27identifier%27"));

smalltalk.bind(smalltalk.Touch,"screenX","screenX"

,function (){var self=this;return (self.handle()["screenX"] || nil);return self;}

,"accessing",unescape("screenX%0D%0A%09%22%20Return%20the%20screenX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27screenX%27"));

smalltalk.bind(smalltalk.Touch,"screenY","screenY"

,function (){var self=this;return (self.handle()["screenY"] || nil);return self;}

,"accessing",unescape("screenY%0D%0A%09%22%20Return%20the%20screenY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27screenY%27"));

smalltalk.bind(smalltalk.Touch,"clientX","clientX"

,function (){var self=this;return (self.handle()["clientX"] || nil);return self;}

,"accessing",unescape("clientX%0D%0A%09%22%20Return%20the%20clientX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27clientX%27"));

smalltalk.bind(smalltalk.Touch,"clientY","clientY"

,function (){var self=this;return (self.handle()["clientY"] || nil);return self;}

,"accessing",unescape("clientY%0D%0A%09%22%20Return%20the%20clientY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27clientY%27"));

smalltalk.bind(smalltalk.Touch,"pageX","pageX"

,function (){var self=this;return (self.handle()["pageX"] || nil);return self;}

,"accessing",unescape("pageX%0D%0A%09%22%20Return%20the%20pageX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27pageX%27"));

smalltalk.bind(smalltalk.Touch,"pageY","pageY"

,function (){var self=this;return (self.handle()["pageY"] || nil);return self;}

,"accessing",unescape("pageY%0D%0A%09%22%20Return%20the%20pageY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27pageY%27"));

smalltalk.bind(smalltalk.Touch,"target","target"

,function (){var self=this;return smalltalk.DOMElement._at((self.handle()["target"] || nil));return self;}

,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMElement%20@%20%28self%20handle%20basicAt%3A%20%27target%27%29"));

smalltalk.bind(smalltalk.Touch,"target:","target_"

,function (anObject){var self=this;(self.handle()["target"]=(anObject.handle()));return self;}

,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27target%27%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.Touch,"=","_eq"

,function (aTouch){var self=this;return (self.handle() === aTouch.handle());return self;}

,"comparing",unescape("%3D%20aTouch%0D%0A%09%5Eself%20handle%20%3D%3D%20aTouch%20handle"));

smalltalk.bind(smalltalk.Touch,"page","page"

,function (){var self=this;return self.pageX()._at(self.pageY());return self;}

,"accessing",unescape("page%0D%0A%09%5Eself%20pageX%20@%20self%20pageY"));

smalltalk.bind(smalltalk.Touch,"screen","screen"

,function (){var self=this;return self.screenX()._at(self.screenY());return self;}

,"accessing",unescape("screen%0D%0A%09%5Eself%20screenX%20@%20self%20screenY"));

smalltalk.bind(smalltalk.Touch,"client","client"

,function (){var self=this;return self.clientX()._at(self.clientY());return self;}

,"accessing",unescape("client%0D%0A%09%5Eself%20clientX%20@%20self%20clientY"));

smalltalk.bind(smalltalk.DOMEventListener,"handleEvent:","handleEvent_"

,function (event){var self=this;return self.handle().handleEvent(event);return self;}

,"wrappers",unescape("handleEvent%3A%20event%20%0D%0A%09%22%20Wrap%20method%20delegating%20handleEvent%3A%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23handleEvent%3A%20event%20"));

smalltalk.bind(smalltalk.DOMEvent.$klass,"capturingPhase","capturingPhase"

,function (){var self=this;return (1);return self;}

,"constants",unescape("capturingPhase%0D%0A%09%5E1"));

smalltalk.bind(smalltalk.DOMEvent.$klass,"atTarget","atTarget"

,function (){var self=this;return (2);return self;}

,"constants",unescape("atTarget%0D%0A%09%5E2"));

smalltalk.bind(smalltalk.DOMEvent.$klass,"bubblingPhase","bubblingPhase"

,function (){var self=this;return (3);return self;}

,"constants",unescape("bubblingPhase%0D%0A%09%5E3"));

smalltalk.bind(smalltalk.DOMEvent,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.DOMEvent,"eventPhase","eventPhase"

,function (){var self=this;return (self.handle()["eventPhase"] || nil);return self;}

,"accessing",unescape("eventPhase%0D%0A%09%22%20Return%20the%20eventPhase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27eventPhase%27"));

smalltalk.bind(smalltalk.DOMEvent,"bubbles","bubbles"

,function (){var self=this;return (self.handle()["bubbles"] || nil);return self;}

,"accessing",unescape("bubbles%0D%0A%09%22%20Return%20the%20bubbles%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27bubbles%27"));

smalltalk.bind(smalltalk.DOMEvent,"cancelable","cancelable"

,function (){var self=this;return (self.handle()["cancelable"] || nil);return self;}

,"accessing",unescape("cancelable%0D%0A%09%22%20Return%20the%20cancelable%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27cancelable%27"));

smalltalk.bind(smalltalk.DOMEvent,"timeStamp","timeStamp"

,function (){var self=this;return (self.handle()["timeStamp"] || nil);return self;}

,"accessing",unescape("timeStamp%0D%0A%09%22%20Return%20the%20timeStamp%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27timeStamp%27"));

smalltalk.bind(smalltalk.DOMEvent,"target","target"

,function (){var self=this;return smalltalk.DOMElement._at((self.handle()["target"] || nil));return self;}

,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMElement%20@%20%28self%20handle%20basicAt%3A%20%27target%27%29"));

smalltalk.bind(smalltalk.DOMEvent,"target:","target_"

,function (anObject){var self=this;(self.handle()["target"]=(anObject.handle()));return self;}

,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27target%27%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.DOMEvent,"currentTarget","currentTarget"

,function (){var self=this;return smalltalk.DOMElement._at((self.handle()["currentTarget"] || nil));return self;}

,"accessing",unescape("currentTarget%0D%0A%09%22%20Return%20the%20currentTarget%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMElement%20@%20%28self%20handle%20basicAt%3A%20%27currentTarget%27%29"));

smalltalk.bind(smalltalk.DOMEvent,"currentTarget:","currentTarget_"

,function (anObject){var self=this;(self.handle()["currentTarget"]=(anObject.handle()));return self;}

,"accessing",unescape("currentTarget%3A%20anObject%0D%0A%09%22%20Set%20the%20currentTarget%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27currentTarget%27%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.DOMEvent,"stopPropagation","stopPropagation"

,function (){var self=this;return self.handle().stopPropagation();return self;}

,"wrappers",unescape("stopPropagation%0D%0A%09%22%20Wrap%20method%20delegating%20stopPropagation%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23stopPropagation"));

smalltalk.bind(smalltalk.DOMEvent,"preventDefault","preventDefault"

,function (){var self=this;return self.handle().preventDefault();return self;}

,"wrappers",unescape("preventDefault%0D%0A%09%22%20Wrap%20method%20delegating%20preventDefault%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23preventDefault"));

smalltalk.bind(smalltalk.DOMEvent,"initEvent:canBubble:cancelable:","initEvent_canBubble_cancelable_"

,function (type,canBubble,cancelable){var self=this;return self.handle().initEvent(type, canBubble, cancelable);return self;}

,"wrappers",unescape("initEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20%0D%0A%09%22%20Wrap%20method%20delegating%20initEvent%3AcanBubble%3Acancelable%3A%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23initEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20"));

smalltalk.bind(smalltalk.HTML5EventModel.$klass,"selectorForHTML5Event:","selectorForHTML5Event_"

,function (anEvent){var self=this;return smalltalk.HTML5.selectorForHTML5Event_(anEvent);return self;}

,"events",unescape("selectorForHTML5Event%3A%20anEvent%0D%0A%09%22%20Private%20-%20Return%20the%20on...%20selector%20to%20use%20to%20register%20binding%20to%20anEvent.%20%22%0D%0A%0D%0A%09%5EHTML5%20selectorForHTML5Event%3A%20anEvent"));

smalltalk.bind(smalltalk.MessageEvent,"data","data"

,function (){var self=this;return (self.handle()["data"] || nil);return self;}

,"accessing",unescape("data%0D%0A%09%22%20Return%20the%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27data%27"));

smalltalk.bind(smalltalk.MessageEvent,"origin","origin"

,function (){var self=this;return (self.handle()["origin"] || nil);return self;}

,"accessing",unescape("origin%0D%0A%09%22%20Return%20the%20origin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27origin%27"));

smalltalk.bind(smalltalk.MessageEvent,"lastEventId","lastEventId"

,function (){var self=this;return (self.handle()["lastEventId"] || nil);return self;}

,"accessing",unescape("lastEventId%0D%0A%09%22%20Return%20the%20lastEventId%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27lastEventId%27"));

smalltalk.bind(smalltalk.MessageEvent,"source","source"

,function (){var self=this;return (self.handle()["source"] || nil);return self;}

,"accessing",unescape("source%0D%0A%09%22%20Return%20the%20source%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27source%27"));

smalltalk.bind(smalltalk.MessageEvent,"ports","ports"

,function (){var self=this;return (self.handle()["ports"] || nil);return self;}

,"accessing",unescape("ports%0D%0A%09%22%20Return%20the%20ports%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27ports%27"));

smalltalk.bind(smalltalk.MessageEvent,"messagePorts","messagePorts"

,function (){var self=this;try{((((self.ports() || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "messagePorts", fn: function(){return []}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "messagePorts", fn: function(){return self.ports().collect_((function(each){return smalltalk.MessagePort.at_(each);}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "messagePorts"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("messagePorts%0D%0A%09%22%20Return%20the%20collection%20of%20MessagePorts%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20ports%20isNil%20ifTrue%3A%20%5B%20%5E%23%28%29%20%5D.%0D%0A%09%5Eself%20ports%20collect%3A%20%5B%3Aeach%7C%20MessagePort%20at%3A%20each%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"ctrlKey","ctrlKey"

,function (){var self=this;var result=nil;result=(self.handle()["ctrlKey"] || nil);

return ((result || nil) !== nil).and_((function(){return result;}));return self;}

,"accessing",unescape("ctrlKey%0D%0A%09%22%20Return%20the%20ctrlKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23ctrlKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"shiftKey","shiftKey"

,function (){var self=this;var result=nil;result=(self.handle()["shiftKey"] || nil);

return ((result || nil) !== nil).and_((function(){return result;}));return self;}

,"accessing",unescape("shiftKey%0D%0A%09%22%20Return%20the%20shiftKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23shiftKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"altKey","altKey"

,function (){var self=this;var result=nil;result=(self.handle()["altKey"] || nil);

return ((result || nil) !== nil).and_((function(){return result;}));return self;}

,"accessing",unescape("altKey%0D%0A%09%22%20Return%20the%20altKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23altKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"metaKey","metaKey"

,function (){var self=this;var result=nil;result=(self.handle()["metaKey"] || nil);

return ((result || nil) !== nil).and_((function(){return result;}));return self;}

,"accessing",unescape("metaKey%0D%0A%09%22%20Return%20the%20metaKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23metaKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"touches","touches"

,function (){var self=this;return smalltalk.TouchList._at((self.handle()["touches"] || nil));return self;}

,"accessing",unescape("touches%0D%0A%09%22%20Return%20the%20touches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ETouchList%20@%20%28self%20handle%20basicAt%3A%20%27touches%27%29"));

smalltalk.bind(smalltalk.TouchEvent,"touches:","touches_"

,function (anObject){var self=this;(self.handle()["touches"]=(anObject.handle()));return self;}

,"accessing",unescape("touches%3A%20anObject%0D%0A%09%22%20Set%20the%20touches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27touches%27%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.TouchEvent,"targetTouches","targetTouches"

,function (){var self=this;return smalltalk.TouchList._at((self.handle()["targetTouches"] || nil));return self;}

,"accessing",unescape("targetTouches%0D%0A%09%22%20Return%20the%20targetTouches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ETouchList%20@%20%28self%20handle%20basicAt%3A%20%27targetTouches%27%29"));

smalltalk.bind(smalltalk.TouchEvent,"targetTouches:","targetTouches_"

,function (anObject){var self=this;(self.handle()["targetTouches"]=(anObject.handle()));return self;}

,"accessing",unescape("targetTouches%3A%20anObject%0D%0A%09%22%20Set%20the%20targetTouches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27targetTouches%27%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.TouchEvent,"changedTouches","changedTouches"

,function (){var self=this;return smalltalk.TouchList._at((self.handle()["changedTouches"] || nil));return self;}

,"accessing",unescape("changedTouches%0D%0A%09%22%20Return%20the%20changedTouches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ETouchList%20@%20%28self%20handle%20basicAt%3A%20%27changedTouches%27%29"));

smalltalk.bind(smalltalk.TouchEvent,"changedTouches:","changedTouches_"

,function (anObject){var self=this;(self.handle()["changedTouches"]=(anObject.handle()));return self;}

,"accessing",unescape("changedTouches%3A%20anObject%0D%0A%09%22%20Set%20the%20changedTouches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27changedTouches%27%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.DOMMouseEvent,"screenX","screenX"

,function (){var self=this;return (self.handle()["screenX"] || nil);return self;}

,"accessing",unescape("screenX%0D%0A%09%22%20Return%20the%20screenX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27screenX%27"));

smalltalk.bind(smalltalk.DOMMouseEvent,"screenY","screenY"

,function (){var self=this;return (self.handle()["screenY"] || nil);return self;}

,"accessing",unescape("screenY%0D%0A%09%22%20Return%20the%20screenY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27screenY%27"));

smalltalk.bind(smalltalk.DOMMouseEvent,"clientX","clientX"

,function (){var self=this;return (self.handle()["clientX"] || nil);return self;}

,"accessing",unescape("clientX%0D%0A%09%22%20Return%20the%20clientX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27clientX%27"));

smalltalk.bind(smalltalk.DOMMouseEvent,"clientY","clientY"

,function (){var self=this;return (self.handle()["clientY"] || nil);return self;}

,"accessing",unescape("clientY%0D%0A%09%22%20Return%20the%20clientY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27clientY%27"));

smalltalk.bind(smalltalk.DOMMouseEvent,"button","button"

,function (){var self=this;return (self.handle()["button"] || nil);return self;}

,"accessing",unescape("button%0D%0A%09%22%20Return%20the%20button%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27button%27"));

smalltalk.bind(smalltalk.DOMMouseEvent,"relatedTarget","relatedTarget"

,function (){var self=this;return smalltalk.DOMElement._at((self.handle()["relatedTarget"] || nil));return self;}

,"accessing",unescape("relatedTarget%0D%0A%09%22%20Return%20the%20relatedTarget%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMElement%20@%20%28self%20handle%20basicAt%3A%20%27relatedTarget%27%29"));

smalltalk.bind(smalltalk.DOMMouseEvent,"relatedTarget:","relatedTarget_"

,function (anObject){var self=this;(self.handle()["relatedTarget"]=(anObject.handle()));return self;}

,"accessing",unescape("relatedTarget%3A%20anObject%0D%0A%09%22%20Set%20the%20relatedTarget%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27relatedTarget%27%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.DOMMouseEvent,"initMouseEvent:canBubble:cancelable:view:detail:screenX:screenY:clientX:clientY:ctrlKey:shiftKey:altKey:metaKey:button:relatedTarget:","initMouseEvent_canBubble_cancelable_view_detail_screenX_screenY_clientX_clientY_ctrlKey_shiftKey_altKey_metaKey_button_relatedTarget_"

,function (type,canBubble,cancelable,view,detail,screenX,screenY,clientX,clientY,ctrlKey,shiftKey,altKey,metaKey,button,relatedTarget){var self=this;return self.handle().initMouseEvent(type, canBubble, cancelable, view, detail, screenX, screenY, clientX, clientY, ctrlKey, shiftKey, altKey, metaKey, button, relatedTarget);return self;}

,"wrappers",unescape("initMouseEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20view%3A%20view%20detail%3A%20detail%20screenX%3A%20screenX%20screenY%3A%20screenY%20clientX%3A%20clientX%20clientY%3A%20clientY%20ctrlKey%3A%20ctrlKey%20shiftKey%3A%20shiftKey%20altKey%3A%20altKey%20metaKey%3A%20metaKey%20button%3A%20button%20relatedTarget%3A%20relatedTarget%20%0D%0A%09%22%20Wrap%20method%20delegating%20initMouseEvent%3AcanBubble%3Acancelable%3Aview%3Adetail%3AscreenX%3AscreenY%3AclientX%3AclientY%3ActrlKey%3AshiftKey%3AaltKey%3AmetaKey%3Abutton%3ArelatedTarget%3A%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23initMouseEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20view%3A%20view%20detail%3A%20detail%20screenX%3A%20screenX%20screenY%3A%20screenY%20clientX%3A%20clientX%20clientY%3A%20clientY%20ctrlKey%3A%20ctrlKey%20shiftKey%3A%20shiftKey%20altKey%3A%20altKey%20metaKey%3A%20metaKey%20button%3A%20button%20relatedTarget%3A%20relatedTarget%20"));

smalltalk.bind(smalltalk.DOMMouseEvent,"screen","screen"

,function (){var self=this;return self.screenX()._at(self.screenY());return self;}

,"accessing",unescape("screen%0D%0A%09%5Eself%20screenX%20@%20self%20screenY"));

smalltalk.bind(smalltalk.DOMMouseEvent,"client","client"

,function (){var self=this;return self.clientX()._at(self.clientY());return self;}

,"accessing",unescape("client%0D%0A%09%5Eself%20clientX%20@%20self%20clientY"));

smalltalk.bind(smalltalk.DOMMouseEvent,"keys","keys"

,function (){var self=this;return smalltalk.Array.with_with_with_with_(self.ctrlKey(), self.shiftKey(), self.altKey(), self.metaKey());return self;}

,"accessing",unescape("keys%0D%0A%09%5EArray%09with%3A%20self%20ctrlKey%0D%0A%09%09with%3A%20self%20shiftKey%0D%0A%09%09with%3A%20self%20altKey%0D%0A%09%09with%3A%20self%20metaKey"));

smalltalk.bind(smalltalk.DOMMouseEvent,"ctrlKey","ctrlKey"

,function (){var self=this;var result=nil;result=(self.handle()["ctrlKey"] || nil);

return ((result || nil) !== nil).and_((function(){return result;}));return self;}

,"accessing",unescape("ctrlKey%0D%0A%09%22%20Return%20the%20ctrlKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23ctrlKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.DOMMouseEvent,"shiftKey","shiftKey"

,function (){var self=this;var result=nil;result=(self.handle()["shiftKey"] || nil);

return ((result || nil) !== nil).and_((function(){return result;}));return self;}

,"accessing",unescape("shiftKey%0D%0A%09%22%20Return%20the%20shiftKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23shiftKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.DOMMouseEvent,"altKey","altKey"

,function (){var self=this;var result=nil;result=(self.handle()["altKey"] || nil);

return ((result || nil) !== nil).and_((function(){return result;}));return self;}

,"accessing",unescape("altKey%0D%0A%09%22%20Return%20the%20altKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23altKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.DOMMouseEvent,"metaKey","metaKey"

,function (){var self=this;var result=nil;result=(self.handle()["metaKey"] || nil);

return ((result || nil) !== nil).and_((function(){return result;}));return self;}

,"accessing",unescape("metaKey%0D%0A%09%22%20Return%20the%20metaKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23metaKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.DOMMutationEvent.$klass,"modification","modification"

,function (){var self=this;return (1);return self;}

,"constants",unescape("modification%0D%0A%09%5E1"));

smalltalk.bind(smalltalk.DOMMutationEvent.$klass,"addition","addition"

,function (){var self=this;return (2);return self;}

,"constants",unescape("addition%0D%0A%09%5E2"));

smalltalk.bind(smalltalk.DOMMutationEvent.$klass,"removal","removal"

,function (){var self=this;return (3);return self;}

,"constants",unescape("removal%0D%0A%09%5E3"));

smalltalk.bind(smalltalk.DOMMutationEvent,"prevValue","prevValue"

,function (){var self=this;return (self.handle()["prevValue"] || nil);return self;}

,"accessing",unescape("prevValue%0D%0A%09%22%20Return%20the%20prevValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27prevValue%27"));

smalltalk.bind(smalltalk.DOMMutationEvent,"newValue","newValue"

,function (){var self=this;return (self.handle()["newValue"] || nil);return self;}

,"accessing",unescape("newValue%0D%0A%09%22%20Return%20the%20newValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27newValue%27"));

smalltalk.bind(smalltalk.DOMMutationEvent,"attrName","attrName"

,function (){var self=this;return (self.handle()["attrName"] || nil);return self;}

,"accessing",unescape("attrName%0D%0A%09%22%20Return%20the%20attrName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27attrName%27"));

smalltalk.bind(smalltalk.DOMMutationEvent,"attrChange","attrChange"

,function (){var self=this;return (self.handle()["attrChange"] || nil);return self;}

,"accessing",unescape("attrChange%0D%0A%09%22%20Return%20the%20attrChange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27attrChange%27"));

smalltalk.bind(smalltalk.DOMMutationEvent,"relatedNode","relatedNode"

,function (){var self=this;return smalltalk.DOMNode._at((self.handle()["relatedNode"] || nil));return self;}

,"accessing",unescape("relatedNode%0D%0A%09%22%20Return%20the%20relatedNode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMNode%20@%20%28self%20handle%20basicAt%3A%20%27relatedNode%27%29"));

smalltalk.bind(smalltalk.DOMMutationEvent,"relatedNode:","relatedNode_"

,function (anObject){var self=this;(self.handle()["relatedNode"]=(anObject.handle()));return self;}

,"accessing",unescape("relatedNode%3A%20anObject%0D%0A%09%22%20Set%20the%20relatedNode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27relatedNode%27%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.DOMMutationEvent,"initMutationEvent:canBubble:cancelable:relatedNode:prevValue:newValue:attrName:attrChange:","initMutationEvent_canBubble_cancelable_relatedNode_prevValue_newValue_attrName_attrChange_"

,function (type,canBubble,cancelable,relatedNode,prevValue,newValue,attrName,attrChange){var self=this;return self.handle().initMutationEvent(type, canBubble, cancelable, relatedNode, prevValue, newValue, attrName, attrChange);return self;}

,"wrappers",unescape("initMutationEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20relatedNode%3A%20relatedNode%20prevValue%3A%20prevValue%20newValue%3A%20newValue%20attrName%3A%20attrName%20attrChange%3A%20attrChange%20%0D%0A%09%22%20Wrap%20method%20delegating%20initMutationEvent%3AcanBubble%3Acancelable%3ArelatedNode%3AprevValue%3AnewValue%3AattrName%3AattrChange%3A%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23initMutationEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20relatedNode%3A%20relatedNode%20prevValue%3A%20prevValue%20newValue%3A%20newValue%20attrName%3A%20attrName%20attrChange%3A%20attrChange%20"));

smalltalk.bind(smalltalk.DOMUIEvent,"view","view"

,function (){var self=this;return (self.handle()["view"] || nil);return self;}

,"accessing",unescape("view%0D%0A%09%22%20Return%20the%20view%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27view%27"));

smalltalk.bind(smalltalk.DOMUIEvent,"detail","detail"

,function (){var self=this;return (self.handle()["detail"] || nil);return self;}

,"accessing",unescape("detail%0D%0A%09%22%20Return%20the%20detail%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27detail%27"));

smalltalk.bind(smalltalk.DOMUIEvent,"initUIEvent:canBubble:cancelable:view:detail:","initUIEvent_canBubble_cancelable_view_detail_"

,function (type,canBubble,cancelable,view,detail){var self=this;return self.handle().initUIEvent(type, canBubble, cancelable, view, detail);return self;}

,"wrappers",unescape("initUIEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20view%3A%20view%20detail%3A%20detail%20%0D%0A%09%22%20Wrap%20method%20delegating%20initUIEvent%3AcanBubble%3Acancelable%3Aview%3Adetail%3A%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23initUIEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20view%3A%20view%20detail%3A%20detail%20"));

smalltalk.bind(smalltalk.MessagePort.$klass,"html5Events","html5Events"

,function (){var self=this;return ["message:"]._comma(smalltalk.whoImplements(smalltalk.MessagePort.$klass,'html5Events').$superclass.$fn.prototype['html5Events'].apply(self, []));return self;}

,"events",unescape("html5Events%0D%0A%09%22%20Private%20-%20Return%20the%20html5%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%23%28%20%23message%3A%20%29%20%2C%20super%20html5Events"));

smalltalk.bind(smalltalk.MessagePort,"postMessage:transfer:","postMessage_transfer_"

,function (contents,transfer){var self=this;return self.handle().postMessage(contents, transfer);return self;}

,"wrappers",unescape("postMessage%3A%20contents%20transfer%3A%20transfer%20%0D%0A%09%22%20Wrap%20method%20delegating%20postMessage%3Atransfer%3A%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23postMessage%3A%20contents%20transfer%3A%20transfer%20"));

smalltalk.bind(smalltalk.MessagePort,"postMessage:","postMessage_"

,function (contents){var self=this;return self.handle().postMessage(contents);return self;}

,"wrappers",unescape("postMessage%3A%20contents%20%0D%0A%09%22%20Wrap%20method%20delegating%20postMessage%3A%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23postMessage%3A%20contents%20"));

smalltalk.bind(smalltalk.MessagePort,"start","start"

,function (){var self=this;return self.handle().start();return self;}

,"wrappers",unescape("start%0D%0A%09%22%20Wrap%20method%20delegating%20start%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23start"));

smalltalk.bind(smalltalk.MessagePort,"close","close"

,function (){var self=this;return self.handle().close();return self;}

,"wrappers",unescape("close%0D%0A%09%22%20Wrap%20method%20delegating%20close%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23close"));

smalltalk.bind(smalltalk.MessagePort,"onmessage","onmessage"

,function (){var self=this;return (self.handle()["onmessage"] || nil);return self;}

,"accessing",unescape("onmessage%0D%0A%09%22%20Return%20the%20onmessage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onmessage%27"));

smalltalk.bind(smalltalk.DOMAttribute,"baseURI","baseURI"

,function (){var self=this;return (self.handle()["baseURI"] || nil);return self;}

,"accessing",unescape("baseURI%0D%0A%09%22%20Return%20the%20baseURI%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27baseURI%27"));

smalltalk.bind(smalltalk.DOMAttribute,"isId","isId"

,function (){var self=this;return (self.handle()["isId"] || nil);return self;}

,"accessing",unescape("isId%0D%0A%09%22%20Return%20the%20isId%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27isId%27"));

smalltalk.bind(smalltalk.DOMAttribute,"localName","localName"

,function (){var self=this;return (self.handle()["localName"] || nil);return self;}

,"accessing",unescape("localName%0D%0A%09%22%20Return%20the%20localName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27localName%27"));

smalltalk.bind(smalltalk.DOMAttribute,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.DOMAttribute,"namespaceURI","namespaceURI"

,function (){var self=this;return (self.handle()["namespaceURI"] || nil);return self;}

,"accessing",unescape("namespaceURI%0D%0A%09%22%20Return%20the%20namespaceURI%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27namespaceURI%27"));

smalltalk.bind(smalltalk.DOMAttribute,"ownerDocument","ownerDocument"

,function (){var self=this;return (self.handle()["ownerDocument"] || nil);return self;}

,"accessing",unescape("ownerDocument%0D%0A%09%22%20Return%20the%20ownerDocument%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27ownerDocument%27"));

smalltalk.bind(smalltalk.DOMAttribute,"ownerElement","ownerElement"

,function (){var self=this;return (self.handle()["ownerElement"] || nil);return self;}

,"accessing",unescape("ownerElement%0D%0A%09%22%20Return%20the%20ownerElement%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27ownerElement%27"));

smalltalk.bind(smalltalk.DOMAttribute,"prefix","prefix"

,function (){var self=this;return (self.handle()["prefix"] || nil);return self;}

,"accessing",unescape("prefix%0D%0A%09%22%20Return%20the%20prefix%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27prefix%27"));

smalltalk.bind(smalltalk.DOMAttribute,"specified","specified"

,function (){var self=this;return (self.handle()["specified"] || nil);return self;}

,"accessing",unescape("specified%0D%0A%09%22%20Return%20the%20specified%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27specified%27"));

smalltalk.bind(smalltalk.DOMAttribute,"textContent","textContent"

,function (){var self=this;return (self.handle()["textContent"] || nil);return self;}

,"accessing",unescape("textContent%0D%0A%09%22%20Return%20the%20textContent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27textContent%27"));

smalltalk.bind(smalltalk.DOMAttribute,"value","value"

,function (){var self=this;return (self.handle()["value"] || nil);return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27value%27"));

smalltalk.bind(smalltalk.DOMElement.$klass,"elementSupport","elementSupport"

,function (){var self=this;return smalltalk.DOMElement;return self;}

,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5EDOMElement"));

smalltalk.bind(smalltalk.DOMElement.$klass,"supportFor:tagged:","supportFor_tagged_"

,function (handle,tagName){var self=this;try{var support=nil;support=self.elementSupport();

((((tagName || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "supportFor_tagged_", fn: function(){return support}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "supportFor_tagged_", fn: function(){return self.tagMap().at_ifAbsentPut_(tagName, (function(){return support.allSubclasses().detect_ifNone_((function(one){return one.canHandle_tagged_(handle, tagName);}), (function(){return support;}));}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "supportFor_tagged_"){return $$ex.fn();} throw($$ex);}}

,"private-mapping",unescape("supportFor%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Private%20-%20Return%20the%20support%20for%20element%20tagged%20with%20tagName.%0D%0A%09We%20use%20internal%20map%20cache%20to%20make%20concrete%20instantiation%20faster.%0D%0A%09Return%20a%20concrete%20class%20to%20wrap%20handle%2C%20or%20DOMElement%20in%20case%20of%20unknown%20tagName.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20support%20%7C%0D%0A%09support%20%3A%3D%20self%20elementSupport.%0D%0A%09tagName%20isNil%20ifTrue%3A%20%5B%20%5Esupport%20%5D.%0D%0A%09%5Eself%20tagMap%20at%3A%20tagName%20ifAbsentPut%3A%20%5B%0D%0A%09%09support%20allSubclasses%0D%0A%09%09%09detect%3A%20%5B%3Aone%7C%20one%20canHandle%3A%20handle%20tagged%3A%20tagName%20%5D%0D%0A%09%09%09ifNone%3A%20%5B%20support%20%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOMElement.$klass,"isTagged","isTagged"

,function (){var self=this;return ((self.tagName() || nil) !== nil);return self;}

,"HTML",unescape("isTagged%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20handle%20tagged%20elements.%20%22%0D%0A%0D%0A%09%5Eself%20tagName%20notNil"));

smalltalk.bind(smalltalk.DOMElement.$klass,"tagName","tagName"

,function (){var self=this;return nil;return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver%20%28or%20nil%29.%0D%0A%09Return%20nil%20by%20default.%0D%0A%09This%20method%20must%20be%20refined%20by%20concrete%20subclasses.%0D%0A%09%22%0D%0A%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.DOMElement.$klass,"canHandle:tagged:","canHandle_tagged_"

,function (handle,tagName){var self=this;return self.isTagged().and_((function(){return tagName._eq(self.tagName());}));return self;}

,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%0D%0A%09This%20method%20can%20be%20refined%20in%20concrete%20subclasses%20to%20implement%20custom%20handling%20of%20HTML%20elements.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20isTagged%20and%3A%20%5B%20tagName%20%3D%20self%20tagName%20%5D"));

smalltalk.bind(smalltalk.DOMElement.$klass,"tagMap","tagMap"

,function (){var self=this;((((smalltalk.DOMElement.classVariableAt_("TagMap") || nil) === nil)).mustBeBoolean()==true ? (function(){return smalltalk.DOMElement.classVariableAt_put_("TagMap",smalltalk.Dictionary.$$new());})() : nil);

return smalltalk.DOMElement.classVariableAt_("TagMap");return self;}

,"private-mapping",unescape("tagMap%0D%0A%09%22%20Private%20-%20Return%20the%20map%20to%20use%20to%20create%20concrete%20instances%20from%20handles.%20%22%0D%0A%0D%0A%09TagMap%20isNil%20ifTrue%3A%20%5B%20TagMap%20%3A%3D%20Dictionary%20new%20%5D.%0D%0A%09%5ETagMap"));

smalltalk.bind(smalltalk.DOMElement,"tagName","tagName"

,function (){var self=this;return (self.handle()["tagName"] || nil);return self;}

,"accessing",unescape("tagName%0D%0A%09%22%20Return%20the%20tagName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27tagName%27"));

smalltalk.bind(smalltalk.DOMElement,"firstChild","firstChild"

,function (){var self=this;return self.elementSupport()._at(self['@handle'].firstChild);return self;}

,"accessing",unescape("firstChild%0D%0A%09%22%20Return%20the%20first%20child%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23firstChild"));

smalltalk.bind(smalltalk.DOMElement,"lastChild","lastChild"

,function (){var self=this;return self.elementSupport()._at(self['@handle'].lastChild);return self;}

,"accessing",unescape("lastChild%0D%0A%09%22%20Return%20the%20last%20child%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23lastChild"));

smalltalk.bind(smalltalk.DOMElement,"nextSibling","nextSibling"

,function (){var self=this;return self.elementSupport()._at(self['@handle'].nextSibling);return self;}

,"accessing",unescape("nextSibling%0D%0A%09%22%20Return%20the%20next%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23nextSibling"));

smalltalk.bind(smalltalk.DOMElement,"previousSibling","previousSibling"

,function (){var self=this;return self.elementSupport()._at(self['@handle'].previousSibling);return self;}

,"accessing",unescape("previousSibling%0D%0A%09%22%20Return%20the%20previous%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23previousSibling"));

smalltalk.bind(smalltalk.DOMElement,"parentNode","parentNode"

,function (){var self=this;return self.elementSupport()._at(self['@handle'].parentNode);return self;}

,"accessing",unescape("parentNode%0D%0A%09%22%20Return%20the%20parent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23parentNode"));

smalltalk.bind(smalltalk.DOMElement,"ownerDocument","ownerDocument"

,function (){var self=this;return smalltalk.HTMLDocument._at(self['@handle'].ownerDocument);return self;}

,"accessing",unescape("ownerDocument%0D%0A%09%22%20Return%20the%20root%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLDocument%20@%20handle%23ownerDocument"));

smalltalk.bind(smalltalk.DOMElement,"toString","toString"

,function (){var self=this;return self.$klass.name()._comma(unescape("@"))._comma(self['@handle'].toString());return self;}

,"converting",unescape("toString%0D%0A%09%22%20Return%20a%20string%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20name%2C%27@%27%2Chandle%20toString"));

smalltalk.bind(smalltalk.DOMElement,"get:byTagName:do:","get_byTagName_do_"

,function (aDOMElementClass,tagName,aBlock){var self=this;return self.array_of_do_(self['@handle'].getElementsByTagName(tagName), aDOMElementClass, aBlock);return self;}

,"accessing",unescape("get%3A%20aDOMElementClass%20byTagName%3A%20tagName%20do%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20elements%20collection%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09array%3A%20%28handle%20%23getElementsByTagName%3A%20tagName%29%0D%0A%09%09of%3A%20aDOMElementClass%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMElement,"get:byTagName:","get_byTagName_"

,function (aDOMElementClass,tagName){var self=this;return self.array_of_(self['@handle'].getElementsByTagName(tagName), aDOMElementClass);return self;}

,"accessing",unescape("get%3A%20aDOMElementClass%20byTagName%3A%20tagName%0D%0A%09%22%20Private%20-%20Return%20the%20elements%20collection%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09array%3A%20%28handle%20%23getElementsByTagName%3A%20tagName%29%0D%0A%09%09of%3A%20aDOMElementClass"));

smalltalk.bind(smalltalk.DOMElement,"getElementsByTagName:","getElementsByTagName_"

,function (tagName){var self=this;return self.get_byTagName_(self.elementSupport(), tagName);return self;}

,"accessing",unescape("getElementsByTagName%3A%20tagName%0D%0A%09%22%20Return%20anArray%20with%20the%20elements%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byTagName%3A%20tagName"));

smalltalk.bind(smalltalk.DOMElement,"withElementsTagged:do:","withElementsTagged_do_"

,function (tagName,aBlock){var self=this;return self.get_byTagName_do_(self.elementSupport(), tagName, aBlock);return self;}

,"accessing",unescape("withElementsTagged%3A%20tagName%20do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20elements%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byTagName%3A%20tagName%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMElement,"item:","item_"

,function (index){var self=this;return self.elementSupport()._at(self['@handle'].item(index));return self;}

,"accessing",unescape("item%3A%20index%0D%0A%09%22%20Return%20item%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20%23item%3A%20index%29"));

smalltalk.bind(smalltalk.DOMElement,"item:as:","item_as_"

,function (index,aDOMElementClass){var self=this;return aDOMElementClass._at(self['@handle'].item(index));return self;}

,"accessing",unescape("item%3A%20index%20as%3A%20aDOMElementClass%0D%0A%09%22%20Return%20item%20at%20index%20in%20the%20receiver%20as%20an%20instance%20of%20aDOMElementClass.%20%22%0D%0A%0D%0A%09%5EaDOMElementClass%20@%20%28handle%20%23item%3A%20index%29"));

smalltalk.bind(smalltalk.DOMElement,"normalize","normalize"

,function (){var self=this;self['@handle'].normalize();return self;}

,"actions",unescape("normalize%0D%0A%09%22%20Puts%20all%20text%20nodes%20underneath%20this%20element%20%28including%20attributes%29%20into%20a%20normal%20form%20where%20only%20structure%20%28e.g.%2C%20elements%2C%20comments%2C%20processing%20instructions%2C%20CDATA%20sections%2C%20and%20entity%20references%29%20separates%20Text%20nodes%2C%20i.e.%2C%20there%20are%20neither%20adjacent%20Text%20nodes%20nor%20empty%20Text%20nodes.%20%22%0D%0A%0D%0A%09handle%20normalize"));

smalltalk.bind(smalltalk.DOMElement,"getAttribute:","getAttribute_"

,function (aName){var self=this;return self['@handle'].getAttribute(aName);return self;}

,"accessing",unescape("getAttribute%3A%20aName%0D%0A%09%22%20Return%20the%20value%20of%20an%20attribute.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23getAttribute%3A%20aName"));

smalltalk.bind(smalltalk.DOMElement,"setAttribute:to:","setAttribute_to_"

,function (aName,value){var self=this;return self['@handle'].setAttribute(aName, value);return self;}

,"accessing",unescape("setAttribute%3A%20aName%20to%3A%20value%0D%0A%09%22%20Set%20the%20value%20of%20an%20attribute.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setAttribute%3A%20aName%20to%3A%20value"));

smalltalk.bind(smalltalk.DOMElement,"removeAttribute:","removeAttribute_"

,function (aName){var self=this;return self['@handle'].removeAttribute(aName);return self;}

,"accessing",unescape("removeAttribute%3A%20aName%0D%0A%09%22%20Remove%20the%20attribute%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23removeAttribute%3A%20aName"));

smalltalk.bind(smalltalk.DOMElement,"querySelector:","querySelector_"

,function (selectors){var self=this;return self.elementSupport()._at(self['@handle'].querySelectorAll_(selectors));return self;}

,"accessing",unescape("querySelector%3A%20selectors%0D%0A%09%22%20Return%20the%20first%20matching%20node%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20querySelectorAll%3A%20selectors%29"));

smalltalk.bind(smalltalk.DOMElement,"querySelectorAll:","querySelectorAll_"

,function (selectors){var self=this;return self.array_of_(self['@handle'].querySelectorAll_(selectors), self.elementSupport());return self;}

,"accessing",unescape("querySelectorAll%3A%20selectors%0D%0A%09%22%20Return%20all%20of%20the%20matching%20nodes%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20%28handle%20querySelectorAll%3A%20selectors%29%20of%3A%20self%20elementSupport"));

smalltalk.bind(smalltalk.DOMElement,"querySelectorAll:doing:","querySelectorAll_doing_"

,function (selectors,aBlock){var self=this;return self.array_of_do_(self['@handle'].querySelectorAll_(selectors), self.elementSupport(), aBlock);return self;}

,"accessing",unescape("querySelectorAll%3A%20selectors%20doing%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20of%20the%20matching%20nodes%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20%28handle%20querySelectorAll%3A%20selectors%29%20of%3A%20self%20elementSupport%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMCharacterData,"data","data"

,function (){var self=this;return (self.handle()["data"] || nil);return self;}

,"accessing",unescape("data%0D%0A%09%22%20Return%20the%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27data%27"));

smalltalk.bind(smalltalk.DOMCharacterData,"length","length"

,function (){var self=this;return (self.handle()["length"] || nil);return self;}

,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27length%27"));

smalltalk.bind(smalltalk.DOMCharacterData,"appendData:","appendData_"

,function (aString){var self=this;self['@handle'].appendData(aString);return self;}

,"actions",unescape("appendData%3A%20aString%0D%0A%0D%0A%09handle%20%23appendData%3A%20aString"));

smalltalk.bind(smalltalk.DOMCharacterData,"deleteData:count:","deleteData_count_"

,function (offset,count){var self=this;self['@handle'].deleteData(offset, count);return self;}

,"actions",unescape("deleteData%3A%20offset%20count%3A%20count%0D%0A%0D%0A%09handle%20%23deleteData%3A%20offset%20count%3A%20count"));

smalltalk.bind(smalltalk.DOMCharacterData,"insert:data:","insert_data_"

,function (offset,aString){var self=this;self['@handle'].insertData(offset, aString);return self;}

,"actions",unescape("insert%3A%20offset%20data%3A%20aString%0D%0A%0D%0A%09handle%20%23insertData%3A%20offset%20data%3A%20aString"));

smalltalk.bind(smalltalk.DOMCharacterData,"replace:count:data:","replace_count_data_"

,function (offset,count,aString){var self=this;self['@handle'].replaceData(offset, count, aString);return self;}

,"actions",unescape("replace%3A%20offset%20count%3A%20count%20data%3A%20aString%0D%0A%0D%0A%09handle%20%23replaceData%3A%20offset%20count%3A%20count%20data%3A%20aString"));

smalltalk.bind(smalltalk.DOMCharacterData,"substringData:count:","substringData_count_"

,function (offset,count){var self=this;return self['@handle'].substringData(offset, count);return self;}

,"actions",unescape("substringData%3A%20offset%20count%3A%20count%0D%0A%09%22%20Return%20a%20String%20from%20offset%20of%20size%20count.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23substringData%3A%20offset%20count%3A%20count"));

smalltalk.bind(smalltalk.HTMLElement.$klass,"elementSupport","elementSupport"

,function (){var self=this;return smalltalk.HTMLElement;return self;}

,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5EHTMLElement"));

smalltalk.bind(smalltalk.HTMLElement.$klass,"@","_at"

,function (handle){var self=this;try{var tagName=nil;var support=nil;((((handle || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_at", fn: function(){return nil}})})();})() : nil);

tagName=handle.tagName;

((((tagName || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_at", fn: function(){return self.for_(handle)}})})();})() : nil);

(((self === smalltalk.DOMElement).or_((function(){return (self === smalltalk.HTMLElement);}))).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_at", fn: function(){return self.for_(handle)}})})();})());

support=self.supportFor_tagged_(handle, tagName);

(((support === smalltalk.HTMLInput)).mustBeBoolean()==true ? (function(){return support.allSubclasses().do_((function(each){return ((each.canHandle_tagged_(handle, tagName)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_at", fn: function(){return each.for_(handle)}})})();})() : nil);}));})() : nil);

(function(){throw({name: "stReturn", selector: "_at", fn: function(){return support.for_(handle)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_at"){return $$ex.fn();} throw($$ex);}}

,unescape("instance%20creation"),unescape("@%20handle%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%0D%0A%09A%20concrete%20implementation%20for%20tag%20%28in%20handle%29%20will%20be%20used%20if%20appropiate.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20tagName%20support%20%7C%0D%0A%09handle%20isNil%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09tagName%20%3A%3D%20handle%23tagName.%0D%0A%09tagName%20isNil%20ifTrue%3A%20%5B%20%5Eself%20for%3A%20handle%20%5D.%0D%0A%09%28self%20%3D%3D%20DOMElement%20or%3A%20%5B%20self%20%3D%3D%20HTMLElement%20%5D%29%20ifFalse%3A%20%5B%20%5Eself%20for%3A%20handle%20%5D.%0D%0A%09support%20%3A%3D%20self%20supportFor%3A%20handle%20tagged%3A%20tagName.%0D%0A%09support%20%3D%3D%20HTMLInput%20ifTrue%3A%20%5B%20%22we%20need%20more%20concrete%20instance%22%0D%0A%09%09support%20allSubclasses%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09%09%28each%20canHandle%3A%20handle%20tagged%3A%20tagName%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%5Eeach%20for%3A%20handle%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09%5Esupport%20for%3A%20handle"));

smalltalk.bind(smalltalk.HTMLElement,"accessKey","accessKey"

,function (){var self=this;return (self.handle()["accessKey"] || nil);return self;}

,"accessing",unescape("accessKey%0D%0A%09%22%20Return%20the%20accessKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27accessKey%27"));

smalltalk.bind(smalltalk.HTMLElement,"accessKey:","accessKey_"

,function (anObject){var self=this;(self.handle()["accessKey"]=(anObject));return self;}

,"accessing",unescape("accessKey%3A%20anObject%0D%0A%09%22%20Set%20the%20accessKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27accessKey%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"className","className"

,function (){var self=this;return (self.handle()["className"] || nil);return self;}

,"accessing",unescape("className%0D%0A%09%22%20Return%20the%20className%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27className%27"));

smalltalk.bind(smalltalk.HTMLElement,"className:","className_"

,function (anObject){var self=this;(self.handle()["className"]=(anObject));return self;}

,"accessing",unescape("className%3A%20anObject%0D%0A%09%22%20Set%20the%20className%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27className%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"dir","dir"

,function (){var self=this;return (self.handle()["dir"] || nil);return self;}

,"accessing",unescape("dir%0D%0A%09%22%20Return%20the%20dir%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27dir%27"));

smalltalk.bind(smalltalk.HTMLElement,"dir:","dir_"

,function (anObject){var self=this;(self.handle()["dir"]=(anObject));return self;}

,"accessing",unescape("dir%3A%20anObject%0D%0A%09%22%20Set%20the%20dir%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27dir%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"disabled","disabled"

,function (){var self=this;return (self.handle()["disabled"] || nil);return self;}

,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27disabled%27"));

smalltalk.bind(smalltalk.HTMLElement,"disabled:","disabled_"

,function (anObject){var self=this;(self.handle()["disabled"]=(anObject));return self;}

,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27disabled%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"id","id"

,function (){var self=this;return (self.handle()["id"] || nil);return self;}

,"accessing",unescape("id%0D%0A%09%22%20Return%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27id%27"));

smalltalk.bind(smalltalk.HTMLElement,"id:","id_"

,function (anObject){var self=this;(self.handle()["id"]=(anObject));return self;}

,"accessing",unescape("id%3A%20anObject%0D%0A%09%22%20Set%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27id%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"innerHTML","innerHTML"

,function (){var self=this;return (self.handle()["innerHTML"] || nil);return self;}

,"accessing",unescape("innerHTML%0D%0A%09%22%20Return%20the%20innerHTML%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27innerHTML%27"));

smalltalk.bind(smalltalk.HTMLElement,"innerHTML:","innerHTML_"

,function (anObject){var self=this;(self.handle()["innerHTML"]=(anObject));return self;}

,"accessing",unescape("innerHTML%3A%20anObject%0D%0A%09%22%20Set%20the%20innerHTML%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27innerHTML%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"lang","lang"

,function (){var self=this;return (self.handle()["lang"] || nil);return self;}

,"accessing",unescape("lang%0D%0A%09%22%20Return%20the%20lang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27lang%27"));

smalltalk.bind(smalltalk.HTMLElement,"lang:","lang_"

,function (anObject){var self=this;(self.handle()["lang"]=(anObject));return self;}

,"accessing",unescape("lang%3A%20anObject%0D%0A%09%22%20Set%20the%20lang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27lang%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"title","title"

,function (){var self=this;return (self.handle()["title"] || nil);return self;}

,"accessing",unescape("title%0D%0A%09%22%20Return%20the%20title%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27title%27"));

smalltalk.bind(smalltalk.HTMLElement,"title:","title_"

,function (anObject){var self=this;(self.handle()["title"]=(anObject));return self;}

,"accessing",unescape("title%3A%20anObject%0D%0A%09%22%20Set%20the%20title%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27title%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"uniqueID","uniqueID"

,function (){var self=this;return (self.handle()["uniqueID"] || nil);return self;}

,"accessing",unescape("uniqueID%0D%0A%09%22%20Return%20the%20uniqueID%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27uniqueID%27"));

smalltalk.bind(smalltalk.HTMLElement,"uniqueID:","uniqueID_"

,function (anObject){var self=this;(self.handle()["uniqueID"]=(anObject));return self;}

,"accessing",unescape("uniqueID%3A%20anObject%0D%0A%09%22%20Set%20the%20uniqueID%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27uniqueID%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"draggable","draggable"

,function (){var self=this;return (self.handle()["draggable"] || nil);return self;}

,"accessing",unescape("draggable%0D%0A%09%22%20Return%20the%20draggable%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27draggable%27"));

smalltalk.bind(smalltalk.HTMLElement,"draggable:","draggable_"

,function (anObject){var self=this;(self.handle()["draggable"]=(anObject));return self;}

,"accessing",unescape("draggable%3A%20anObject%0D%0A%09%22%20Set%20the%20draggable%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27draggable%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"clientWidth","clientWidth"

,function (){var self=this;return (self['@handle'].clientWidth || (0));return self;}

,"accessing",unescape("clientWidth%0D%0A%09%22%20Return%20the%20clientWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23clientWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"clientWidth:","clientWidth_"

,function (anObject){var self=this;(self.handle()["clientWidth"]=(anObject));return self;}

,"accessing",unescape("clientWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20clientWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27clientWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"clientHeight","clientHeight"

,function (){var self=this;return (self['@handle'].clientHeight || (0));return self;}

,"accessing",unescape("clientHeight%0D%0A%09%22%20Return%20the%20clientHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23clientHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"clientHeight:","clientHeight_"

,function (anObject){var self=this;(self.handle()["clientHeight"]=(anObject));return self;}

,"accessing",unescape("clientHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20clientHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27clientHeight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"height","height"

,function (){var self=this;return (self['@handle'].height || (0));return self;}

,"accessing",unescape("height%0D%0A%09%22%20Return%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23height%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"height:","height_"

,function (anObject){var self=this;(self.handle()["height"]=(anObject));return self;}

,"accessing",unescape("height%3A%20anObject%0D%0A%09%22%20Set%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27height%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"width","width"

,function (){var self=this;return (self['@handle'].width || (0));return self;}

,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23width%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"width:","width_"

,function (anObject){var self=this;(self.handle()["width"]=(anObject));return self;}

,"accessing",unescape("width%3A%20anObject%0D%0A%09%22%20Set%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27width%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"tabIndex","tabIndex"

,function (){var self=this;return (self['@handle'].tabIndex || (0));return self;}

,"accessing",unescape("tabIndex%0D%0A%09%22%20Return%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tabIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"tabIndex:","tabIndex_"

,function (anObject){var self=this;(self.handle()["tabIndex"]=(anObject));return self;}

,"accessing",unescape("tabIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27tabIndex%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"length","length"

,function (){var self=this;return (self['@handle'].length || (0));return self;}

,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetParent","offsetParent"

,function (){var self=this;return (self['@handle'].offsetParent || (0));return self;}

,"accessing",unescape("offsetParent%0D%0A%09%22%20Return%20the%20offsetParent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetParent%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetLeft","offsetLeft"

,function (){var self=this;return (self['@handle'].offsetLeft || (0));return self;}

,"accessing",unescape("offsetLeft%0D%0A%09%22%20Return%20the%20offsetLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetTop","offsetTop"

,function (){var self=this;return (self['@handle'].offsetTop || (0));return self;}

,"accessing",unescape("offsetTop%0D%0A%09%22%20Return%20the%20offsetTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetWidth","offsetWidth"

,function (){var self=this;return (self['@handle'].offsetWidth || (0));return self;}

,"accessing",unescape("offsetWidth%0D%0A%09%22%20Return%20the%20offsetWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetHeight","offsetHeight"

,function (){var self=this;return (self['@handle'].offsetHeight || (0));return self;}

,"accessing",unescape("offsetHeight%0D%0A%09%22%20Return%20the%20offsetHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"scrollLeft","scrollLeft"

,function (){var self=this;return (self['@handle'].scrollLeft || (0));return self;}

,"accessing",unescape("scrollLeft%0D%0A%09%22%20Return%20the%20scrollLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"scrollTop","scrollTop"

,function (){var self=this;return (self['@handle'].scrollTop || (0));return self;}

,"accessing",unescape("scrollTop%0D%0A%09%22%20Return%20the%20scrollTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"scrollWidth","scrollWidth"

,function (){var self=this;return (self['@handle'].scrollWidth || (0));return self;}

,"accessing",unescape("scrollWidth%0D%0A%09%22%20Return%20the%20scrollWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"scrollHeight","scrollHeight"

,function (){var self=this;return (self['@handle'].scrollHeight || (0));return self;}

,"accessing",unescape("scrollHeight%0D%0A%09%22%20Return%20the%20scrollHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"clientExtent","clientExtent"

,function (){var self=this;return self.clientWidth()._at(self.clientHeight());return self;}

,"accessing",unescape("clientExtent%0D%0A%09%22%20Return%20the%20viewable%20extent%20of%20the%20receiver%20on%20a%20page%20%28not%20including%20borders%2C%20margins%2C%20or%20scrollbars%29.%20%22%0D%0A%0D%0A%09%5Eself%20clientWidth%20@%20self%20clientHeight"));

smalltalk.bind(smalltalk.HTMLElement,"scroll","scroll"

,function (){var self=this;return self.scrollLeftTop().extent_(self.scrollExtent());return self;}

,"accessing",unescape("scroll%0D%0A%09%22%20Return%20the%20scroll%20rectangle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollLeftTop%20extent%3A%20self%20scrollExtent"));

smalltalk.bind(smalltalk.HTMLElement,"scrollLeftTop","scrollLeftTop"

,function (){var self=this;return self.scrollLeft()._at(self.scrollTop());return self;}

,"accessing",unescape("scrollLeftTop%0D%0A%09%22%20Return%20the%20scroll%20leftTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollLeft%20@%20self%20scrollTop"));

smalltalk.bind(smalltalk.HTMLElement,"scrollExtent","scrollExtent"

,function (){var self=this;return self.scrollWidth()._at(self.scrollHeight());return self;}

,"accessing",unescape("scrollExtent%0D%0A%09%22%20Return%20the%20scroll%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollWidth%20@%20self%20scrollHeight"));

smalltalk.bind(smalltalk.HTMLElement,"extent","extent"

,function (){var self=this;return self.width()._at(self.height());return self;}

,"accessing",unescape("extent%0D%0A%09%22%20Return%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.HTMLElement,"offset","offset"

,function (){var self=this;return self.offsetLeftTop().extent_(self.offsetExtent());return self;}

,"accessing",unescape("offset%0D%0A%09%22%20Return%20the%20offset%20rectangle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20offsetLeftTop%20extent%3A%20self%20offsetExtent"));

smalltalk.bind(smalltalk.HTMLElement,"offsetLeftTop","offsetLeftTop"

,function (){var self=this;return self.offsetLeft()._at(self.offsetTop());return self;}

,"accessing",unescape("offsetLeftTop%0D%0A%09%22%20Return%20the%20offset%20leftTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20offsetLeft%20@%20self%20offsetTop"));

smalltalk.bind(smalltalk.HTMLElement,"offsetExtent","offsetExtent"

,function (){var self=this;return self.offsetWidth()._at(self.offsetHeight());return self;}

,"accessing",unescape("offsetExtent%0D%0A%09%22%20Return%20the%20offset%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20offsetWidth%20@%20self%20offsetHeight"));

smalltalk.bind(smalltalk.HTMLElement,"scrollIntoView:","scrollIntoView_"

,function (aBoolean){var self=this;return self.handle().scrollIntoView(aBoolean);return self;}

,"scrolling",unescape("scrollIntoView%3A%20aBoolean%0D%0A%09%22%20Scroll%20the%20view%20to%20show%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23scrollIntoView%3A%20aBoolean"));

smalltalk.bind(smalltalk.HTMLElement,"getClientRects","getClientRects"

,function (){var self=this;return self.handle().getClientRects();return self;}

,"bounds",unescape("getClientRects%0D%0A%09%22%20Return%20a%20LIST%20with%20the%20position%20of%20the%20border%20box%20edges%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20getClientRects"));

smalltalk.bind(smalltalk.HTMLElement,"clientRects","clientRects"

,function (){var self=this;var list=nil;var result=nil;var item=nil;list=self.getClientRects();

result=smalltalk.Array.$$new();

((((list || nil) !== nil)).mustBeBoolean()==true ? (function(){return (0).to_do_((list.length - (1)), (function(index){item=list.item(index);return result.at_put_(index, item.left._at(item.top).rightBottom_(item.right._at(item.bottom)));}));})() : nil);

return result;return self;}

,"bounds",unescape("clientRects%0D%0A%09%22%20Return%20an%20array%20of%20rectangles%20with%20the%20position%20of%20the%20border%20box%20edges%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%7C%20list%20result%20item%20%7C%0D%0A%09list%20%3A%3D%20self%20getClientRects.%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09list%20notNil%20ifTrue%3A%20%5B%0D%0A%09%090%20to%3A%20list%23length%20-%201%20do%3A%20%5B%3Aindex%7C%0D%0A%09%09%09item%20%3A%3D%20list%20%23item%3A%20index.%0D%0A%09%09%09result%20at%3A%20index%20put%3A%20%28item%23left%20@%20item%23top%20rightBottom%3A%20item%23right%20@%20item%23bottom%29%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.HTMLElement,"getBoundingClientRect","getBoundingClientRect"

,function (){var self=this;return self.handle().getBoundingClientRect();return self;}

,"bounds",unescape("getBoundingClientRect%0D%0A%09%22%20Return%20the%20position%20of%20the%20border%20box%20edges%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20getBoundingClientRect"));

smalltalk.bind(smalltalk.HTMLElement,"boundingClientRect","boundingClientRect"

,function (){var self=this;var item=nil;item=self.getBoundingClientRect();

return item.left._at(item.top).rightBottom_(item.right._at(item.bottom));return self;}

,"bounds",unescape("boundingClientRect%0D%0A%09%22%20Return%20the%20rectangle%20of%20the%20border%20box%20edges%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%7C%20item%20%7C%0D%0A%09item%20%3A%3D%20self%20getBoundingClientRect.%0D%0A%09%5Eitem%23left%20@%20item%23top%20rightBottom%3A%20item%23right%20@%20item%23bottom"));

smalltalk.bind(smalltalk.HTMLElement,"boundingBox","boundingBox"

,function (){var self=this;return self.boundingClientRect();return self;}

,"bounds",unescape("boundingBox%0D%0A%09%22%20Return%20the%20bounds%20of%20the%20receiver%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%5Eself%20boundingClientRect"));

smalltalk.bind(smalltalk.HTMLElement,"insertAdjacentHTML:text:","insertAdjacentHTML_text_"

,function (where,htmlText){var self=this;return self.handle().insertAdjacentHTML_text_(where, htmlText);return self;}

,"inserting",unescape("insertAdjacentHTML%3A%20where%20text%3A%20htmlText%0D%0A%09%22%20Insert%20a%20HTML%20text.%0D%0A%09where%20can%20be%20one%20of%0D%0A%09%09%23BeforeBegin%20%23AfterBegin%0D%0A%09%09%23BeforeEnd%20%23AfterEnd%0D%0A%09%22%0D%0A%09%5Eself%20handle%20insertAdjacentHTML%3A%20where%20text%3A%20htmlText"));

smalltalk.bind(smalltalk.HTMLElement,"innerHtml:","innerHtml_"

,function (text){var self=this;return self.innerHTML_(text);return self;}

,"inserting",unescape("innerHtml%3A%20text%0D%0A%09%22%20Set%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20innerHTML%3A%20text"));

smalltalk.bind(smalltalk.HTMLElement,"innerHtml","innerHtml"

,function (){var self=this;return self.innerHTML();return self;}

,"inserting",unescape("innerHtml%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20innerHTML"));

smalltalk.bind(smalltalk.HTMLElement,"classNames","classNames"

,function (){var self=this;return self.className().asArrayOfSubstrings();return self;}

,"classNames",unescape("classNames%0D%0A%09%22%20Return%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20className%20asArrayOfSubstrings"));

smalltalk.bind(smalltalk.HTMLElement,"classNames:","classNames_"

,function (anArray){var self=this;return self.className_(anArray.inject_into_("", (function(total, each){return total._comma(" ")._comma(each);})));return self;}

,"classNames",unescape("classNames%3A%20anArray%0D%0A%09%22%20Set%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20className%3A%20%28anArray%20inject%3A%20%27%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%20%2C%27%20%27%20%2Ceach%20%5D%29"));

smalltalk.bind(smalltalk.HTMLElement,"addClassName:","addClassName_"

,function (aClassName){var self=this;return self.classNames_((function($rec){$rec.add_(aClassName);return $rec.yourself();})(self.classNames().asSet()));return self;}

,"classNames",unescape("addClassName%3A%20aClassName%0D%0A%09%22%20Add%20aClassName%20to%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classNames%3A%20%28self%20classNames%20asSet%20add%3A%20aClassName%3B%20yourself%29"));

smalltalk.bind(smalltalk.HTMLElement,"addClassNames:","addClassNames_"

,function (anArray){var self=this;return self.classNames_((function($rec){$rec.addAll_(anArray);return $rec.yourself();})(self.classNames().asSet()));return self;}

,"classNames",unescape("addClassNames%3A%20anArray%0D%0A%09%22%20Add%20anArray%20to%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classNames%3A%20%28self%20classNames%20asSet%20addAll%3A%20anArray%3B%20yourself%29"));

smalltalk.bind(smalltalk.HTMLElement,"removeClassName:ifAbsent:","removeClassName_ifAbsent_"

,function (aClassName,aBlock){var self=this;return self.classNames_((function($rec){$rec.remove_ifAbsent_(aClassName, aBlock);return $rec.yourself();})(self.classNames().asSet()));return self;}

,"classNames",unescape("removeClassName%3A%20aClassName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Remove%20aClassName%20from%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classNames%3A%20%28self%20classNames%20asSet%20remove%3A%20aClassName%20ifAbsent%3A%20aBlock%3B%20yourself%29"));

smalltalk.bind(smalltalk.HTMLElement,"removeClassName:","removeClassName_"

,function (aClassName){var self=this;return self.removeClassName_ifAbsent_(aClassName, (function(){return nil;}));return self;}

,"classNames",unescape("removeClassName%3A%20aClassName%0D%0A%09%22%20Remove%20aClassName%20from%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20removeClassName%3A%20aClassName%20ifAbsent%3A%20%5B%20%5D"));

smalltalk.bind(smalltalk.HTMLElement,"removeClassNames:","removeClassNames_"

,function (anArray){var self=this;return self.classNames_((function($rec){$rec.removeAll_(anArray);return $rec.yourself();})(self.classNames().asSet()));return self;}

,"classNames",unescape("removeClassNames%3A%20anArray%0D%0A%09%22%20Remove%20anArray%20from%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classNames%3A%20%28self%20classNames%20asSet%20removeAll%3A%20anArray%3B%20yourself%29"));

smalltalk.bind(smalltalk.HTMLElement,"style","style"

,function (){var self=this;return smalltalk.HTMLStyle._at(self['@handle'].style);return self;}

,"accessing",unescape("style%0D%0A%09%22%20Return%20the%20style%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLStyle%20@%20handle%23style"));

smalltalk.bind(smalltalk.HTMLElement,"style:","style_"

,function (aDOMStyle){var self=this;self['@handle'].style=aDOMStyle.handle();return self;}

,"accessing",unescape("style%3A%20aDOMStyle%0D%0A%09%22%20Set%20the%20style%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%23style%20%3A%3D%20aDOMStyle%20handle"));

smalltalk.bind(smalltalk.HTMLUList.$klass,"tagName","tagName"

,function (){var self=this;return "UL";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27UL%27"));

smalltalk.bind(smalltalk.HTMLTitle.$klass,"tagName","tagName"

,function (){var self=this;return "TITLE";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TITLE%27"));

smalltalk.bind(smalltalk.HTMLTitle,"text","text"

,function (){var self=this;return (self.handle()["text"] || nil);return self;}

,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27text%27"));

smalltalk.bind(smalltalk.HTMLTitle,"text:","text_"

,function (anObject){var self=this;(self.handle()["text"]=(anObject));return self;}

,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27text%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea.$klass,"tagName","tagName"

,function (){var self=this;return "TEXTAREA";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TEXTAREA%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"cols","cols"

,function (){var self=this;return (self['@handle'].cols || (0));return self;}

,"accessing",unescape("cols%0D%0A%09%22%20Return%20the%20cols%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cols%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTextarea,"cols:","cols_"

,function (anObject){var self=this;(self.handle()["cols"]=(anObject));return self;}

,"accessing",unescape("cols%3A%20anObject%0D%0A%09%22%20Set%20the%20cols%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cols%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"rows","rows"

,function (){var self=this;return (self['@handle'].rows || (0));return self;}

,"accessing",unescape("rows%0D%0A%09%22%20Return%20the%20rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTextarea,"rows:","rows_"

,function (anObject){var self=this;(self.handle()["rows"]=(anObject));return self;}

,"accessing",unescape("rows%3A%20anObject%0D%0A%09%22%20Set%20the%20rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rows%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"disabled","disabled"

,function (){var self=this;return (self.handle()["disabled"] || nil);return self;}

,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27disabled%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"disabled:","disabled_"

,function (anObject){var self=this;(self.handle()["disabled"]=(anObject));return self;}

,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27disabled%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"hash","hash"

,function (){var self=this;return (self.handle()["hash"] || nil);return self;}

,"accessing",unescape("hash%0D%0A%09%22%20Return%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hash%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"hash:","hash_"

,function (anObject){var self=this;(self.handle()["hash"]=(anObject));return self;}

,"accessing",unescape("hash%3A%20anObject%0D%0A%09%22%20Set%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hash%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"host","host"

,function (){var self=this;return (self.handle()["host"] || nil);return self;}

,"accessing",unescape("host%0D%0A%09%22%20Return%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27host%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"host:","host_"

,function (anObject){var self=this;(self.handle()["host"]=(anObject));return self;}

,"accessing",unescape("host%3A%20anObject%0D%0A%09%22%20Set%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27host%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"hostname","hostname"

,function (){var self=this;return (self.handle()["hostname"] || nil);return self;}

,"accessing",unescape("hostname%0D%0A%09%22%20Return%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hostname%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"hostname:","hostname_"

,function (anObject){var self=this;(self.handle()["hostname"]=(anObject));return self;}

,"accessing",unescape("hostname%3A%20anObject%0D%0A%09%22%20Set%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hostname%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"href","href"

,function (){var self=this;return (self.handle()["href"] || nil);return self;}

,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27href%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"href:","href_"

,function (anObject){var self=this;(self.handle()["href"]=(anObject));return self;}

,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27href%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"pathname","pathname"

,function (){var self=this;return (self.handle()["pathname"] || nil);return self;}

,"accessing",unescape("pathname%0D%0A%09%22%20Return%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27pathname%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"pathname:","pathname_"

,function (anObject){var self=this;(self.handle()["pathname"]=(anObject));return self;}

,"accessing",unescape("pathname%3A%20anObject%0D%0A%09%22%20Set%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27pathname%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"port","port"

,function (){var self=this;return (self.handle()["port"] || nil);return self;}

,"accessing",unescape("port%0D%0A%09%22%20Return%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27port%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"port:","port_"

,function (anObject){var self=this;(self.handle()["port"]=(anObject));return self;}

,"accessing",unescape("port%3A%20anObject%0D%0A%09%22%20Set%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27port%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"protocol","protocol"

,function (){var self=this;return (self.handle()["protocol"] || nil);return self;}

,"accessing",unescape("protocol%0D%0A%09%22%20Return%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27protocol%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"protocol:","protocol_"

,function (anObject){var self=this;(self.handle()["protocol"]=(anObject));return self;}

,"accessing",unescape("protocol%3A%20anObject%0D%0A%09%22%20Set%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27protocol%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"defaultValue","defaultValue"

,function (){var self=this;return (self.handle()["defaultValue"] || nil);return self;}

,"accessing",unescape("defaultValue%0D%0A%09%22%20Return%20the%20defaultValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27defaultValue%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"defaultValue:","defaultValue_"

,function (anObject){var self=this;(self.handle()["defaultValue"]=(anObject));return self;}

,"accessing",unescape("defaultValue%3A%20anObject%0D%0A%09%22%20Set%20the%20defaultValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27defaultValue%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"readOnly","readOnly"

,function (){var self=this;return (self.handle()["readOnly"] || nil);return self;}

,"accessing",unescape("readOnly%0D%0A%09%22%20Return%20the%20readOnly%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27readOnly%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"readOnly:","readOnly_"

,function (anObject){var self=this;(self.handle()["readOnly"]=(anObject));return self;}

,"accessing",unescape("readOnly%3A%20anObject%0D%0A%09%22%20Set%20the%20readOnly%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27readOnly%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"search","search"

,function (){var self=this;return (self.handle()["search"] || nil);return self;}

,"accessing",unescape("search%0D%0A%09%22%20Return%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27search%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"search:","search_"

,function (anObject){var self=this;(self.handle()["search"]=(anObject));return self;}

,"accessing",unescape("search%3A%20anObject%0D%0A%09%22%20Set%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27search%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"value","value"

,function (){var self=this;return (self.handle()["value"] || nil);return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27value%27"));

smalltalk.bind(smalltalk.HTMLTextarea,"value:","value_"

,function (anObject){var self=this;(self.handle()["value"]=(anObject));return self;}

,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27value%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"form","form"

,function (){var self=this;return smalltalk.HTMLForm._at(self['@handle'].form);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLForm%20@%20handle%23form"));

smalltalk.bind(smalltalk.HTMLTextarea,"select","select"

,function (){var self=this;self['@handle'].select();return self;}

,"actions",unescape("select%0D%0A%09%22%20Selects%20the%20entire%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20select"));

smalltalk.bind(smalltalk.HTMLThead.$klass,"tagName","tagName"

,function (){var self=this;return "THEAD";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27THEAD%27"));

smalltalk.bind(smalltalk.HTMLTfoot.$klass,"tagName","tagName"

,function (){var self=this;return "TFOOT";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TFOOT%27"));

smalltalk.bind(smalltalk.HTMLTbody.$klass,"tagName","tagName"

,function (){var self=this;return "TBODY";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TBODY%27"));

smalltalk.bind(smalltalk.HTMLTableRow.$klass,"tagName","tagName"

,function (){var self=this;return "TR";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TR%27"));

smalltalk.bind(smalltalk.HTMLTableRow,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLTableRow,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableRow,"ch","ch"

,function (){var self=this;return (self.handle()["ch"] || nil);return self;}

,"accessing",unescape("ch%0D%0A%09%22%20Return%20the%20ch%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27ch%27"));

smalltalk.bind(smalltalk.HTMLTableRow,"ch:","ch_"

,function (anObject){var self=this;(self.handle()["ch"]=(anObject));return self;}

,"accessing",unescape("ch%3A%20anObject%0D%0A%09%22%20Set%20the%20ch%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27ch%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableRow,"vAlign","vAlign"

,function (){var self=this;return (self.handle()["vAlign"] || nil);return self;}

,"accessing",unescape("vAlign%0D%0A%09%22%20Return%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27vAlign%27"));

smalltalk.bind(smalltalk.HTMLTableRow,"vAlign:","vAlign_"

,function (anObject){var self=this;(self.handle()["vAlign"]=(anObject));return self;}

,"accessing",unescape("vAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27vAlign%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableRow,"rowIndex","rowIndex"

,function (){var self=this;return (self['@handle'].rowIndex || (0));return self;}

,"accessing",unescape("rowIndex%0D%0A%09%22%20Return%20the%20rowIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rowIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTableRow,"sectionRowIndex","sectionRowIndex"

,function (){var self=this;return (self['@handle'].sectionRowIndex || (0));return self;}

,"accessing",unescape("sectionRowIndex%0D%0A%09%22%20Return%20the%20sectionRowIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23sectionRowIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTableRow,"cells","cells"

,function (){var self=this;return self.array_of_(self['@handle'].cells, smalltalk.HTMLTableCell);return self;}

,"accessing",unescape("cells%0D%0A%09%22%20Return%20the%20cells%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell"));

smalltalk.bind(smalltalk.HTMLTableRow,"cellsDo:","cellsDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].cells, smalltalk.HTMLTableCell, aBlock);return self;}

,"accessing",unescape("cellsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20cells%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLTableRow,"cellAt:","cellAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].cells, smalltalk.HTMLTableCell, index);return self;}

,"accessing",unescape("cellAt%3A%20index%0D%0A%09%22%20Return%20the%20cell%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLTableRow,"deleteCell:","deleteCell_"

,function (index){var self=this;self['@handle'].deleteCell(index);return self;}

,"insert/delete",unescape("deleteCell%3A%20index%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver%20at%20index%28zero%20indexed%29%20position.%20%22%0D%0A%0D%0A%09handle%20%23deleteCell%3A%20index"));

smalltalk.bind(smalltalk.HTMLTableRow,"deleteCellAt:","deleteCellAt_"

,function (index){var self=this;return self.deleteCell_((index - (1)));return self;}

,"insert/delete",unescape("deleteCellAt%3A%20index%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver%20at%20index%28ONE%20indexed%29%20position.%20%22%0D%0A%0D%0A%09%5Eself%20deleteCell%3A%20index%20-%201"));

smalltalk.bind(smalltalk.HTMLTableRow,"insertCell:","insertCell_"

,function (index){var self=this;return smalltalk.HTMLTableCell._at(self['@handle'].inserCell(index));return self;}

,"accessing",unescape("insertCell%3A%20index%0D%0A%09%22%20Insert%20a%20cell%20in%20the%20receiver%20at%20index%28zero%20indexed%29%20position.%0D%0A%09index%20specifies%20the%20position%20of%20the%20row%20to%20insert%20%28starts%20at%200%29.%0D%0A%09The%20value%20of%20-1%20can%20also%20be%20used%3B%20which%20result%20in%20insertion%20at%20the%20last%20position.%0D%0A%09%22%0D%0A%0D%0A%09%5EHTMLTableCell%20@%20%28handle%20%23inserCell%3A%20index%29"));

smalltalk.bind(smalltalk.HTMLTableRow,"insertCellAt:","insertCellAt_"

,function (index){var self=this;return smalltalk.HTMLTableCell._at(self['@handle'].inserCell((index - (1))));return self;}

,"accessing",unescape("insertCellAt%3A%20index%0D%0A%09%22%20Insert%20a%20cellin%20the%20receiver%20at%20index%28ONE%20indexed%29%20position.%20%22%0D%0A%0D%0A%09%5EHTMLTableCell%20@%20%28handle%20%23inserCell%3A%20index%20-%201%29"));

smalltalk.bind(smalltalk.HTMLTableCol.$klass,"tagName","tagName"

,function (){var self=this;return "COL";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27COL%27"));

smalltalk.bind(smalltalk.HTMLTableCol,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLTableCol,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCol,"char","$$char"

,function (){var self=this;return (self.handle()["char"] || nil);return self;}

,"accessing",unescape("char%0D%0A%09%22%20Return%20the%20char%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27char%27"));

smalltalk.bind(smalltalk.HTMLTableCol,"char:","char_"

,function (anObject){var self=this;(self.handle()["char"]=(anObject));return self;}

,"accessing",unescape("char%3A%20anObject%0D%0A%09%22%20Set%20the%20char%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27char%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCol,"span","span"

,function (){var self=this;return (self.handle()["span"] || nil);return self;}

,"accessing",unescape("span%0D%0A%09%22%20Return%20the%20span%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27span%27"));

smalltalk.bind(smalltalk.HTMLTableCol,"span:","span_"

,function (anObject){var self=this;(self.handle()["span"]=(anObject));return self;}

,"accessing",unescape("span%3A%20anObject%0D%0A%09%22%20Set%20the%20span%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27span%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCol,"vAlign","vAlign"

,function (){var self=this;return (self.handle()["vAlign"] || nil);return self;}

,"accessing",unescape("vAlign%0D%0A%09%22%20Return%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27vAlign%27"));

smalltalk.bind(smalltalk.HTMLTableCol,"vAlign:","vAlign_"

,function (anObject){var self=this;(self.handle()["vAlign"]=(anObject));return self;}

,"accessing",unescape("vAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27vAlign%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell.$klass,"tagName","tagName"

,function (){var self=this;return "TD";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TD%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"abbr","abbr"

,function (){var self=this;return (self.handle()["abbr"] || nil);return self;}

,"accessing",unescape("abbr%0D%0A%09%22%20Return%20the%20abbr%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27abbr%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"abbr:","abbr_"

,function (anObject){var self=this;(self.handle()["abbr"]=(anObject));return self;}

,"accessing",unescape("abbr%3A%20anObject%0D%0A%09%22%20Set%20the%20abbr%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27abbr%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"axis","axis"

,function (){var self=this;return (self.handle()["axis"] || nil);return self;}

,"accessing",unescape("axis%0D%0A%09%22%20Return%20the%20axis%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27axis%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"axis:","axis_"

,function (anObject){var self=this;(self.handle()["axis"]=(anObject));return self;}

,"accessing",unescape("axis%3A%20anObject%0D%0A%09%22%20Set%20the%20axis%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27axis%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"bgColor","bgColor"

,function (){var self=this;return (self.handle()["bgColor"] || nil);return self;}

,"accessing",unescape("bgColor%0D%0A%09%22%20Return%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27bgColor%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"bgColor:","bgColor_"

,function (anObject){var self=this;(self.handle()["bgColor"]=(anObject));return self;}

,"accessing",unescape("bgColor%3A%20anObject%0D%0A%09%22%20Set%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27bgColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"char","$$char"

,function (){var self=this;return (self.handle()["char"] || nil);return self;}

,"accessing",unescape("char%0D%0A%09%22%20Return%20the%20char%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27char%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"char:","char_"

,function (anObject){var self=this;(self.handle()["char"]=(anObject));return self;}

,"accessing",unescape("char%3A%20anObject%0D%0A%09%22%20Set%20the%20char%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27char%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"headers","headers"

,function (){var self=this;return (self.handle()["headers"] || nil);return self;}

,"accessing",unescape("headers%0D%0A%09%22%20Return%20the%20headers%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27headers%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"headers:","headers_"

,function (anObject){var self=this;(self.handle()["headers"]=(anObject));return self;}

,"accessing",unescape("headers%3A%20anObject%0D%0A%09%22%20Set%20the%20headers%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27headers%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"noWrap","noWrap"

,function (){var self=this;return (self.handle()["noWrap"] || nil);return self;}

,"accessing",unescape("noWrap%0D%0A%09%22%20Return%20the%20noWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27noWrap%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"noWrap:","noWrap_"

,function (anObject){var self=this;(self.handle()["noWrap"]=(anObject));return self;}

,"accessing",unescape("noWrap%3A%20anObject%0D%0A%09%22%20Set%20the%20noWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27noWrap%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"scope","scope"

,function (){var self=this;return (self.handle()["scope"] || nil);return self;}

,"accessing",unescape("scope%0D%0A%09%22%20Return%20the%20scope%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27scope%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"scope:","scope_"

,function (anObject){var self=this;(self.handle()["scope"]=(anObject));return self;}

,"accessing",unescape("scope%3A%20anObject%0D%0A%09%22%20Set%20the%20scope%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27scope%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"vAlign","vAlign"

,function (){var self=this;return (self.handle()["vAlign"] || nil);return self;}

,"accessing",unescape("vAlign%0D%0A%09%22%20Return%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27vAlign%27"));

smalltalk.bind(smalltalk.HTMLTableCell,"vAlign:","vAlign_"

,function (anObject){var self=this;(self.handle()["vAlign"]=(anObject));return self;}

,"accessing",unescape("vAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27vAlign%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"colspan","colspan"

,function (){var self=this;return (self['@handle'].colspan || (0));return self;}

,"accessing",unescape("colspan%0D%0A%09%22%20Return%20the%20colspan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23colspan%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTableCell,"colspan:","colspan_"

,function (anObject){var self=this;(self.handle()["colspan"]=(anObject));return self;}

,"accessing",unescape("colspan%3A%20anObject%0D%0A%09%22%20Set%20the%20colspan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27colspan%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"rowspan","rowspan"

,function (){var self=this;return (self['@handle'].rowspan || (0));return self;}

,"accessing",unescape("rowspan%0D%0A%09%22%20Return%20the%20rowspan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rowspan%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTableCell,"rowspan:","rowspan_"

,function (anObject){var self=this;(self.handle()["rowspan"]=(anObject));return self;}

,"accessing",unescape("rowspan%3A%20anObject%0D%0A%09%22%20Set%20the%20rowspan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rowspan%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"cellIndex","cellIndex"

,function (){var self=this;return (self['@handle'].cellIndex || (0));return self;}

,"accessing",unescape("cellIndex%0D%0A%09%22%20Return%20the%20cellIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cellIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTableCaption.$klass,"tagName","tagName"

,function (){var self=this;return "CAPTION";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27CAPTION%27"));

smalltalk.bind(smalltalk.HTMLTableCaption,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLTableCaption,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable.$klass,"tagName","tagName"

,function (){var self=this;return "TABLE";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TABLE%27"));

smalltalk.bind(smalltalk.HTMLTable,"border","border"

,function (){var self=this;return (self['@handle'].border || (0));return self;}

,"accessing",unescape("border%0D%0A%09%22%20Return%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23border%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTable,"border:","border_"

,function (anObject){var self=this;(self.handle()["border"]=(anObject));return self;}

,"accessing",unescape("border%3A%20anObject%0D%0A%09%22%20Set%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27border%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"cellPadding","cellPadding"

,function (){var self=this;return (self['@handle'].cellPadding || (0));return self;}

,"accessing",unescape("cellPadding%0D%0A%09%22%20Return%20the%20cellPadding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cellPadding%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTable,"cellPadding:","cellPadding_"

,function (anObject){var self=this;(self.handle()["cellPadding"]=(anObject));return self;}

,"accessing",unescape("cellPadding%3A%20anObject%0D%0A%09%22%20Set%20the%20cellPadding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cellPadding%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"cellSpacing","cellSpacing"

,function (){var self=this;return (self['@handle'].cellSpacing || (0));return self;}

,"accessing",unescape("cellSpacing%0D%0A%09%22%20Return%20the%20cellSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cellSpacing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTable,"cellSpacing:","cellSpacing_"

,function (anObject){var self=this;(self.handle()["cellSpacing"]=(anObject));return self;}

,"accessing",unescape("cellSpacing%3A%20anObject%0D%0A%09%22%20Set%20the%20cellSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cellSpacing%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"frame","frame"

,function (){var self=this;return (self.handle()["frame"] || nil);return self;}

,"accessing",unescape("frame%0D%0A%09%22%20Return%20the%20frame%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27frame%27"));

smalltalk.bind(smalltalk.HTMLTable,"frame:","frame_"

,function (anObject){var self=this;(self.handle()["frame"]=(anObject));return self;}

,"accessing",unescape("frame%3A%20anObject%0D%0A%09%22%20Set%20the%20frame%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27frame%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"rules","rules"

,function (){var self=this;return (self.handle()["rules"] || nil);return self;}

,"accessing",unescape("rules%0D%0A%09%22%20Return%20the%20rules%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27rules%27"));

smalltalk.bind(smalltalk.HTMLTable,"rules:","rules_"

,function (anObject){var self=this;(self.handle()["rules"]=(anObject));return self;}

,"accessing",unescape("rules%3A%20anObject%0D%0A%09%22%20Set%20the%20rules%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rules%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"summary","summary"

,function (){var self=this;return (self.handle()["summary"] || nil);return self;}

,"accessing",unescape("summary%0D%0A%09%22%20Return%20the%20summary%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27summary%27"));

smalltalk.bind(smalltalk.HTMLTable,"summary:","summary_"

,function (anObject){var self=this;(self.handle()["summary"]=(anObject));return self;}

,"accessing",unescape("summary%3A%20anObject%0D%0A%09%22%20Set%20the%20summary%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27summary%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"caption","caption"

,function (){var self=this;return (self.handle()["caption"] || nil);return self;}

,"accessing",unescape("caption%0D%0A%09%22%20Return%20the%20caption%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27caption%27"));

smalltalk.bind(smalltalk.HTMLTable,"cells","cells"

,function (){var self=this;return self.array_of_(self['@handle'].cells, smalltalk.HTMLTableCell);return self;}

,"accessing",unescape("cells%0D%0A%09%22%20Return%20the%20cells%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell"));

smalltalk.bind(smalltalk.HTMLTable,"cellsDo:","cellsDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].cells, smalltalk.HTMLTableCell, aBlock);return self;}

,"accessing",unescape("cellsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20cells%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLTable,"cellAt:","cellAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].cells, smalltalk.HTMLTableCell, index);return self;}

,"accessing",unescape("cellAt%3A%20index%0D%0A%09%22%20Return%20the%20cell%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLTable,"rows","rows"

,function (){var self=this;return self.array_of_(self['@handle'].rows, smalltalk.HTMLTableRow);return self;}

,"accessing",unescape("rows%0D%0A%09%22%20Return%20the%20rows%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23rows%20of%3A%20HTMLTableRow"));

smalltalk.bind(smalltalk.HTMLTable,"rowsDo:","rowsDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].rows, smalltalk.HTMLTableRow, aBlock);return self;}

,"accessing",unescape("rowsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20rows%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23rows%20of%3A%20HTMLTableRow%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLTable,"rowAt:","rowAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].rows, smalltalk.HTMLTableRow, index);return self;}

,"accessing",unescape("rowAt%3A%20index%0D%0A%09%22%20Return%20the%20row%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23rows%20of%3A%20HTMLTableRow%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLTable,"tBodies","tBodies"

,function (){var self=this;return self.array_of_(self['@handle'].tBodies, smalltalk.HTMLTbody);return self;}

,"accessing",unescape("tBodies%0D%0A%09%22%20Return%20the%20tBodies%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23tBodies%20of%3A%20HTMLTbody"));

smalltalk.bind(smalltalk.HTMLTable,"tBodiesDo:","tBodiesDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].tBodies, smalltalk.HTMLTbody, aBlock);return self;}

,"accessing",unescape("tBodiesDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20tBodies%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23tBodies%20of%3A%20HTMLTbody%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLTable,"tBodyAt:","tBodyAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].tBodies, smalltalk.HTMLTbody, index);return self;}

,"accessing",unescape("tBodyAt%3A%20index%0D%0A%09%22%20Return%20the%20tBody%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23tBodies%20of%3A%20HTMLTbody%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLTable,"tFoot","tFoot"

,function (){var self=this;return smalltalk.HTMLElement._at(self['@handle'].tFoot);return self;}

,"accessing",unescape("tFoot%0D%0A%09%22%20Return%20the%20tFoot%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23tFoot"));

smalltalk.bind(smalltalk.HTMLTable,"tHead","tHead"

,function (){var self=this;return smalltalk.HTMLElement._at(self['@handle'].tHead);return self;}

,"accessing",unescape("tHead%0D%0A%09%22%20Return%20the%20tHead%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23tHead"));

smalltalk.bind(smalltalk.HTMLTable,"createCaption","createCaption"

,function (){var self=this;return smalltalk.HTMLElement._at(self['@handle'].createCaption);return self;}

,"accessing",unescape("createCaption%0D%0A%09%22%20Return%20the%20caption%20of%20the%20receiver%20%28create%20a%20new%20element%20if%20needed%29.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23createCaption"));

smalltalk.bind(smalltalk.HTMLTable,"createTFoot","createTFoot"

,function (){var self=this;return smalltalk.HTMLElement._at(self['@handle'].createTFoot);return self;}

,"accessing",unescape("createTFoot%0D%0A%09%22%20Return%20the%20foot%20of%20the%20receiver%20%28create%20a%20new%20element%20if%20needed%29.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23createTFoot"));

smalltalk.bind(smalltalk.HTMLTable,"createTHead","createTHead"

,function (){var self=this;return smalltalk.HTMLElement._at(self['@handle'].createTHead);return self;}

,"accessing",unescape("createTHead%0D%0A%09%22%20Return%20the%20head%20of%20the%20receiver%20%28create%20a%20new%20element%20if%20needed%29.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23createTHead"));

smalltalk.bind(smalltalk.HTMLTable,"deleteCaption","deleteCaption"

,function (){var self=this;self['@handle'].deleteCaption();return self;}

,"accessing",unescape("deleteCaption%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20deleteCaption"));

smalltalk.bind(smalltalk.HTMLTable,"deleteTFoot","deleteTFoot"

,function (){var self=this;self['@handle'].deleteTFoot();return self;}

,"accessing",unescape("deleteTFoot%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20deleteTFoot"));

smalltalk.bind(smalltalk.HTMLTable,"deleteTHead","deleteTHead"

,function (){var self=this;self['@handle'].deleteTHead();return self;}

,"accessing",unescape("deleteTHead%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20deleteTHead"));

smalltalk.bind(smalltalk.HTMLTable,"insertRow:","insertRow_"

,function (index){var self=this;return smalltalk.HTMLTableRow._at(self['@handle'].inserRow(index));return self;}

,"accessing",unescape("insertRow%3A%20index%0D%0A%09%22%20Insert%20a%20row%20in%20the%20receiver%20at%20index%28zero%20indexed%29%20position.%0D%0A%09index%20specifies%20the%20position%20of%20the%20row%20to%20insert%20%28starts%20at%200%29.%0D%0A%09The%20value%20of%20-1%20can%20also%20be%20used%3B%20which%20result%20in%20that%20the%20new%20row%20will%20be%20inserted%20at%20the%20last%20position.%0D%0A%09%22%0D%0A%0D%0A%09%5EHTMLTableRow%20@%20%28handle%20%23inserRow%3A%20index%29"));

smalltalk.bind(smalltalk.HTMLTable,"insertRowAt:","insertRowAt_"

,function (index){var self=this;return smalltalk.HTMLTableRow._at(self['@handle'].inserRow((index - (1))));return self;}

,"accessing",unescape("insertRowAt%3A%20index%0D%0A%09%22%20Insert%20a%20row%20in%20the%20receiver%20at%20index%28ONE%20indexed%29%20position.%20%22%0D%0A%0D%0A%09%5EHTMLTableRow%20@%20%28handle%20%23inserRow%3A%20index%20-%201%29"));

smalltalk.bind(smalltalk.HTMLStyle.$klass,"tagName","tagName"

,function (){var self=this;return "STYLE";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27STYLE%27"));

smalltalk.bind(smalltalk.HTMLStyle,"animation","animation"

,function (){var self=this;return (self['@handle'].animation || (0));return self;}

,"accessing",unescape("animation%0D%0A%09%22%20Return%20the%20animation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animation%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animation:","animation_"

,function (anObject){var self=this;(self.handle()["animation"]=(anObject));return self;}

,"accessing",unescape("animation%3A%20anObject%0D%0A%09%22%20Set%20the%20animation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27animation%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationName","animationName"

,function (){var self=this;return (self['@handle'].animationName || (0));return self;}

,"accessing",unescape("animationName%0D%0A%09%22%20Return%20the%20animationName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationName%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationName:","animationName_"

,function (anObject){var self=this;(self.handle()["animationName"]=(anObject));return self;}

,"accessing",unescape("animationName%3A%20anObject%0D%0A%09%22%20Set%20the%20animationName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27animationName%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDuration","animationDuration"

,function (){var self=this;return (self['@handle'].animationDuration || (0));return self;}

,"accessing",unescape("animationDuration%0D%0A%09%22%20Return%20the%20animationDuration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationDuration%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDuration:","animationDuration_"

,function (anObject){var self=this;(self.handle()["animationDuration"]=(anObject));return self;}

,"accessing",unescape("animationDuration%3A%20anObject%0D%0A%09%22%20Set%20the%20animationDuration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27animationDuration%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationTimingFunction","animationTimingFunction"

,function (){var self=this;return (self['@handle'].animationTimingFunction || (0));return self;}

,"accessing",unescape("animationTimingFunction%0D%0A%09%22%20Return%20the%20animationTimingFunction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationTimingFunction%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationTimingFunction:","animationTimingFunction_"

,function (anObject){var self=this;(self.handle()["animationTimingFunction"]=(anObject));return self;}

,"accessing",unescape("animationTimingFunction%3A%20anObject%0D%0A%09%22%20Set%20the%20animationTimingFunction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27animationTimingFunction%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDelay","animationDelay"

,function (){var self=this;return (self['@handle'].animationDelay || (0));return self;}

,"accessing",unescape("animationDelay%0D%0A%09%22%20Return%20the%20animationDelay%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationDelay%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDelay:","animationDelay_"

,function (anObject){var self=this;(self.handle()["animationDelay"]=(anObject));return self;}

,"accessing",unescape("animationDelay%3A%20anObject%0D%0A%09%22%20Set%20the%20animationDelay%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27animationDelay%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationIterationCount","animationIterationCount"

,function (){var self=this;return (self['@handle'].animationIterationCount || (0));return self;}

,"accessing",unescape("animationIterationCount%0D%0A%09%22%20Return%20the%20animationIterationCount%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationIterationCount%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationIterationCount:","animationIterationCount_"

,function (anObject){var self=this;(self.handle()["animationIterationCount"]=(anObject));return self;}

,"accessing",unescape("animationIterationCount%3A%20anObject%0D%0A%09%22%20Set%20the%20animationIterationCount%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27animationIterationCount%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDirection","animationDirection"

,function (){var self=this;return (self['@handle'].animationDirection || (0));return self;}

,"accessing",unescape("animationDirection%0D%0A%09%22%20Return%20the%20animationDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationDirection%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDirection:","animationDirection_"

,function (anObject){var self=this;(self.handle()["animationDirection"]=(anObject));return self;}

,"accessing",unescape("animationDirection%3A%20anObject%0D%0A%09%22%20Set%20the%20animationDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27animationDirection%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationPlayState","animationPlayState"

,function (){var self=this;return (self['@handle'].animationPlayState || (0));return self;}

,"accessing",unescape("animationPlayState%0D%0A%09%22%20Return%20the%20animationPlayState%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationPlayState%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationPlayState:","animationPlayState_"

,function (anObject){var self=this;(self.handle()["animationPlayState"]=(anObject));return self;}

,"accessing",unescape("animationPlayState%3A%20anObject%0D%0A%09%22%20Set%20the%20animationPlayState%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27animationPlayState%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"appearance","appearance"

,function (){var self=this;return (self['@handle'].appearance || (0));return self;}

,"accessing",unescape("appearance%0D%0A%09%22%20Return%20the%20appearance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23appearance%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"appearance:","appearance_"

,function (anObject){var self=this;(self.handle()["appearance"]=(anObject));return self;}

,"accessing",unescape("appearance%3A%20anObject%0D%0A%09%22%20Set%20the%20appearance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27appearance%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backfaceVisibility","backfaceVisibility"

,function (){var self=this;return (self['@handle'].backfaceVisibility || (0));return self;}

,"accessing",unescape("backfaceVisibility%0D%0A%09%22%20Return%20the%20backfaceVisibility%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backfaceVisibility%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backfaceVisibility:","backfaceVisibility_"

,function (anObject){var self=this;(self.handle()["backfaceVisibility"]=(anObject));return self;}

,"accessing",unescape("backfaceVisibility%3A%20anObject%0D%0A%09%22%20Set%20the%20backfaceVisibility%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27backfaceVisibility%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"background","background"

,function (){var self=this;return (self['@handle'].background || (0));return self;}

,"accessing",unescape("background%0D%0A%09%22%20Return%20the%20background%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23background%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"background:","background_"

,function (anObject){var self=this;(self.handle()["background"]=(anObject));return self;}

,"accessing",unescape("background%3A%20anObject%0D%0A%09%22%20Set%20the%20background%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27background%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundAttachment","backgroundAttachment"

,function (){var self=this;return (self['@handle'].backgroundAttachment || (0));return self;}

,"accessing",unescape("backgroundAttachment%0D%0A%09%22%20Return%20the%20backgroundAttachment%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundAttachment%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundAttachment:","backgroundAttachment_"

,function (anObject){var self=this;(self.handle()["backgroundAttachment"]=(anObject));return self;}

,"accessing",unescape("backgroundAttachment%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundAttachment%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27backgroundAttachment%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundColor","backgroundColor"

,function (){var self=this;return (self['@handle'].backgroundColor || (0));return self;}

,"accessing",unescape("backgroundColor%0D%0A%09%22%20Return%20the%20backgroundColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundColor:","backgroundColor_"

,function (anObject){var self=this;(self.handle()["backgroundColor"]=(anObject));return self;}

,"accessing",unescape("backgroundColor%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27backgroundColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundImage","backgroundImage"

,function (){var self=this;return (self['@handle'].backgroundImage || (0));return self;}

,"accessing",unescape("backgroundImage%0D%0A%09%22%20Return%20the%20backgroundImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundImage%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundImage:","backgroundImage_"

,function (anObject){var self=this;(self.handle()["backgroundImage"]=(anObject));return self;}

,"accessing",unescape("backgroundImage%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27backgroundImage%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundPosition","backgroundPosition"

,function (){var self=this;return (self['@handle'].backgroundPosition || (0));return self;}

,"accessing",unescape("backgroundPosition%0D%0A%09%22%20Return%20the%20backgroundPosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundPosition%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundPosition:","backgroundPosition_"

,function (anObject){var self=this;(self.handle()["backgroundPosition"]=(anObject));return self;}

,"accessing",unescape("backgroundPosition%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundPosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27backgroundPosition%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundRepeat","backgroundRepeat"

,function (){var self=this;return (self['@handle'].backgroundRepeat || (0));return self;}

,"accessing",unescape("backgroundRepeat%0D%0A%09%22%20Return%20the%20backgroundRepeat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundRepeat%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundRepeat:","backgroundRepeat_"

,function (anObject){var self=this;(self.handle()["backgroundRepeat"]=(anObject));return self;}

,"accessing",unescape("backgroundRepeat%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundRepeat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27backgroundRepeat%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundClip","backgroundClip"

,function (){var self=this;return (self['@handle'].backgroundClip || (0));return self;}

,"accessing",unescape("backgroundClip%0D%0A%09%22%20Return%20the%20backgroundClip%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundClip%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundClip:","backgroundClip_"

,function (anObject){var self=this;(self.handle()["backgroundClip"]=(anObject));return self;}

,"accessing",unescape("backgroundClip%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundClip%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27backgroundClip%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundOrigin","backgroundOrigin"

,function (){var self=this;return (self['@handle'].backgroundOrigin || (0));return self;}

,"accessing",unescape("backgroundOrigin%0D%0A%09%22%20Return%20the%20backgroundOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundOrigin%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundOrigin:","backgroundOrigin_"

,function (anObject){var self=this;(self.handle()["backgroundOrigin"]=(anObject));return self;}

,"accessing",unescape("backgroundOrigin%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27backgroundOrigin%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundSize","backgroundSize"

,function (){var self=this;return (self['@handle'].backgroundSize || (0));return self;}

,"accessing",unescape("backgroundSize%0D%0A%09%22%20Return%20the%20backgroundSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundSize%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundSize:","backgroundSize_"

,function (anObject){var self=this;(self.handle()["backgroundSize"]=(anObject));return self;}

,"accessing",unescape("backgroundSize%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27backgroundSize%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"border","border"

,function (){var self=this;return (self['@handle'].border || (0));return self;}

,"accessing",unescape("border%0D%0A%09%22%20Return%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23border%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"border:","border_"

,function (anObject){var self=this;(self.handle()["border"]=(anObject));return self;}

,"accessing",unescape("border%3A%20anObject%0D%0A%09%22%20Set%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27border%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderCollapse","borderCollapse"

,function (){var self=this;return (self['@handle'].borderCollapse || (0));return self;}

,"accessing",unescape("borderCollapse%0D%0A%09%22%20Return%20the%20borderCollapse%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderCollapse%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderCollapse:","borderCollapse_"

,function (anObject){var self=this;(self.handle()["borderCollapse"]=(anObject));return self;}

,"accessing",unescape("borderCollapse%3A%20anObject%0D%0A%09%22%20Set%20the%20borderCollapse%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderCollapse%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderColor","borderColor"

,function (){var self=this;return (self['@handle'].borderColor || (0));return self;}

,"accessing",unescape("borderColor%0D%0A%09%22%20Return%20the%20borderColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderColor:","borderColor_"

,function (anObject){var self=this;(self.handle()["borderColor"]=(anObject));return self;}

,"accessing",unescape("borderColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderStyle","borderStyle"

,function (){var self=this;return (self['@handle'].borderStyle || (0));return self;}

,"accessing",unescape("borderStyle%0D%0A%09%22%20Return%20the%20borderStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderStyle:","borderStyle_"

,function (anObject){var self=this;(self.handle()["borderStyle"]=(anObject));return self;}

,"accessing",unescape("borderStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderWidth","borderWidth"

,function (){var self=this;return (self['@handle'].borderWidth || (0));return self;}

,"accessing",unescape("borderWidth%0D%0A%09%22%20Return%20the%20borderWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderWidth:","borderWidth_"

,function (anObject){var self=this;(self.handle()["borderWidth"]=(anObject));return self;}

,"accessing",unescape("borderWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottom","borderBottom"

,function (){var self=this;return (self['@handle'].borderBottom || (0));return self;}

,"accessing",unescape("borderBottom%0D%0A%09%22%20Return%20the%20borderBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottom%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottom:","borderBottom_"

,function (anObject){var self=this;(self.handle()["borderBottom"]=(anObject));return self;}

,"accessing",unescape("borderBottom%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderBottom%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomColor","borderBottomColor"

,function (){var self=this;return (self['@handle'].borderBottomColor || (0));return self;}

,"accessing",unescape("borderBottomColor%0D%0A%09%22%20Return%20the%20borderBottomColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomColor:","borderBottomColor_"

,function (anObject){var self=this;(self.handle()["borderBottomColor"]=(anObject));return self;}

,"accessing",unescape("borderBottomColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderBottomColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomStyle","borderBottomStyle"

,function (){var self=this;return (self['@handle'].borderBottomStyle || (0));return self;}

,"accessing",unescape("borderBottomStyle%0D%0A%09%22%20Return%20the%20borderBottomStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomStyle:","borderBottomStyle_"

,function (anObject){var self=this;(self.handle()["borderBottomStyle"]=(anObject));return self;}

,"accessing",unescape("borderBottomStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderBottomStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomWidth","borderBottomWidth"

,function (){var self=this;return (self['@handle'].borderBottomWidth || (0));return self;}

,"accessing",unescape("borderBottomWidth%0D%0A%09%22%20Return%20the%20borderBottomWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomWidth:","borderBottomWidth_"

,function (anObject){var self=this;(self.handle()["borderBottomWidth"]=(anObject));return self;}

,"accessing",unescape("borderBottomWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderBottomWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeft","borderLeft"

,function (){var self=this;return (self['@handle'].borderLeft || (0));return self;}

,"accessing",unescape("borderLeft%0D%0A%09%22%20Return%20the%20borderLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeft:","borderLeft_"

,function (anObject){var self=this;(self.handle()["borderLeft"]=(anObject));return self;}

,"accessing",unescape("borderLeft%3A%20anObject%0D%0A%09%22%20Set%20the%20borderLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderLeft%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftColor","borderLeftColor"

,function (){var self=this;return (self['@handle'].borderLeftColor || (0));return self;}

,"accessing",unescape("borderLeftColor%0D%0A%09%22%20Return%20the%20borderLeftColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderLeftColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftColor:","borderLeftColor_"

,function (anObject){var self=this;(self.handle()["borderLeftColor"]=(anObject));return self;}

,"accessing",unescape("borderLeftColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderLeftColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderLeftColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftStyle","borderLeftStyle"

,function (){var self=this;return (self['@handle'].borderLeftStyle || (0));return self;}

,"accessing",unescape("borderLeftStyle%0D%0A%09%22%20Return%20the%20borderLeftStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderLeftStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftStyle:","borderLeftStyle_"

,function (anObject){var self=this;(self.handle()["borderLeftStyle"]=(anObject));return self;}

,"accessing",unescape("borderLeftStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderLeftStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderLeftStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftWidth","borderLeftWidth"

,function (){var self=this;return (self['@handle'].borderLeftWidth || (0));return self;}

,"accessing",unescape("borderLeftWidth%0D%0A%09%22%20Return%20the%20borderLeftWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderLeftWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftWidth:","borderLeftWidth_"

,function (anObject){var self=this;(self.handle()["borderLeftWidth"]=(anObject));return self;}

,"accessing",unescape("borderLeftWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderLeftWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderLeftWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRight","borderRight"

,function (){var self=this;return (self['@handle'].borderRight || (0));return self;}

,"accessing",unescape("borderRight%0D%0A%09%22%20Return%20the%20borderRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRight:","borderRight_"

,function (anObject){var self=this;(self.handle()["borderRight"]=(anObject));return self;}

,"accessing",unescape("borderRight%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderRight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightColor","borderRightColor"

,function (){var self=this;return (self['@handle'].borderRightColor || (0));return self;}

,"accessing",unescape("borderRightColor%0D%0A%09%22%20Return%20the%20borderRightColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRightColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightColor:","borderRightColor_"

,function (anObject){var self=this;(self.handle()["borderRightColor"]=(anObject));return self;}

,"accessing",unescape("borderRightColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRightColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderRightColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightStyle","borderRightStyle"

,function (){var self=this;return (self['@handle'].borderRightStyle || (0));return self;}

,"accessing",unescape("borderRightStyle%0D%0A%09%22%20Return%20the%20borderRightStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRightStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightStyle:","borderRightStyle_"

,function (anObject){var self=this;(self.handle()["borderRightStyle"]=(anObject));return self;}

,"accessing",unescape("borderRightStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRightStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderRightStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightWidth","borderRightWidth"

,function (){var self=this;return (self['@handle'].borderRightWidth || (0));return self;}

,"accessing",unescape("borderRightWidth%0D%0A%09%22%20Return%20the%20borderRightWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRightWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightWidth:","borderRightWidth_"

,function (anObject){var self=this;(self.handle()["borderRightWidth"]=(anObject));return self;}

,"accessing",unescape("borderRightWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRightWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderRightWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderSpacing","borderSpacing"

,function (){var self=this;return (self['@handle'].borderSpacing || (0));return self;}

,"accessing",unescape("borderSpacing%0D%0A%09%22%20Return%20the%20borderSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderSpacing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderSpacing:","borderSpacing_"

,function (anObject){var self=this;(self.handle()["borderSpacing"]=(anObject));return self;}

,"accessing",unescape("borderSpacing%3A%20anObject%0D%0A%09%22%20Set%20the%20borderSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderSpacing%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTop","borderTop"

,function (){var self=this;return (self['@handle'].borderTop || (0));return self;}

,"accessing",unescape("borderTop%0D%0A%09%22%20Return%20the%20borderTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTop:","borderTop_"

,function (anObject){var self=this;(self.handle()["borderTop"]=(anObject));return self;}

,"accessing",unescape("borderTop%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderTop%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopColor","borderTopColor"

,function (){var self=this;return (self['@handle'].borderTopColor || (0));return self;}

,"accessing",unescape("borderTopColor%0D%0A%09%22%20Return%20the%20borderTopColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopColor:","borderTopColor_"

,function (anObject){var self=this;(self.handle()["borderTopColor"]=(anObject));return self;}

,"accessing",unescape("borderTopColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderTopColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopStyle","borderTopStyle"

,function (){var self=this;return (self['@handle'].borderTopStyle || (0));return self;}

,"accessing",unescape("borderTopStyle%0D%0A%09%22%20Return%20the%20borderTopStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopStyle:","borderTopStyle_"

,function (anObject){var self=this;(self.handle()["borderTopStyle"]=(anObject));return self;}

,"accessing",unescape("borderTopStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderTopStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopWidth","borderTopWidth"

,function (){var self=this;return (self['@handle'].borderTopWidth || (0));return self;}

,"accessing",unescape("borderTopWidth%0D%0A%09%22%20Return%20the%20borderTopWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopWidth:","borderTopWidth_"

,function (anObject){var self=this;(self.handle()["borderTopWidth"]=(anObject));return self;}

,"accessing",unescape("borderTopWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderTopWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomLeftRadius","borderBottomLeftRadius"

,function (){var self=this;return (self['@handle'].borderBottomLeftRadius || (0));return self;}

,"accessing",unescape("borderBottomLeftRadius%0D%0A%09%22%20Return%20the%20borderBottomLeftRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomLeftRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomLeftRadius:","borderBottomLeftRadius_"

,function (anObject){var self=this;(self.handle()["borderBottomLeftRadius"]=(anObject));return self;}

,"accessing",unescape("borderBottomLeftRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomLeftRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderBottomLeftRadius%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomRightRadius","borderBottomRightRadius"

,function (){var self=this;return (self['@handle'].borderBottomRightRadius || (0));return self;}

,"accessing",unescape("borderBottomRightRadius%0D%0A%09%22%20Return%20the%20borderBottomRightRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomRightRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomRightRadius:","borderBottomRightRadius_"

,function (anObject){var self=this;(self.handle()["borderBottomRightRadius"]=(anObject));return self;}

,"accessing",unescape("borderBottomRightRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomRightRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderBottomRightRadius%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImage","borderImage"

,function (){var self=this;return (self['@handle'].borderImage || (0));return self;}

,"accessing",unescape("borderImage%0D%0A%09%22%20Return%20the%20borderImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImage%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImage:","borderImage_"

,function (anObject){var self=this;(self.handle()["borderImage"]=(anObject));return self;}

,"accessing",unescape("borderImage%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderImage%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageOutset","borderImageOutset"

,function (){var self=this;return (self['@handle'].borderImageOutset || (0));return self;}

,"accessing",unescape("borderImageOutset%0D%0A%09%22%20Return%20the%20borderImageOutset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageOutset%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageOutset:","borderImageOutset_"

,function (anObject){var self=this;(self.handle()["borderImageOutset"]=(anObject));return self;}

,"accessing",unescape("borderImageOutset%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageOutset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderImageOutset%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageRepeat","borderImageRepeat"

,function (){var self=this;return (self['@handle'].borderImageRepeat || (0));return self;}

,"accessing",unescape("borderImageRepeat%0D%0A%09%22%20Return%20the%20borderImageRepeat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageRepeat%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageRepeat:","borderImageRepeat_"

,function (anObject){var self=this;(self.handle()["borderImageRepeat"]=(anObject));return self;}

,"accessing",unescape("borderImageRepeat%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageRepeat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderImageRepeat%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageSlice","borderImageSlice"

,function (){var self=this;return (self['@handle'].borderImageSlice || (0));return self;}

,"accessing",unescape("borderImageSlice%0D%0A%09%22%20Return%20the%20borderImageSlice%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageSlice%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageSlice:","borderImageSlice_"

,function (anObject){var self=this;(self.handle()["borderImageSlice"]=(anObject));return self;}

,"accessing",unescape("borderImageSlice%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageSlice%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderImageSlice%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageSource","borderImageSource"

,function (){var self=this;return (self['@handle'].borderImageSource || (0));return self;}

,"accessing",unescape("borderImageSource%0D%0A%09%22%20Return%20the%20borderImageSource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageSource%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageSource:","borderImageSource_"

,function (anObject){var self=this;(self.handle()["borderImageSource"]=(anObject));return self;}

,"accessing",unescape("borderImageSource%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageSource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderImageSource%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageWidth","borderImageWidth"

,function (){var self=this;return (self['@handle'].borderImageWidth || (0));return self;}

,"accessing",unescape("borderImageWidth%0D%0A%09%22%20Return%20the%20borderImageWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageWidth:","borderImageWidth_"

,function (anObject){var self=this;(self.handle()["borderImageWidth"]=(anObject));return self;}

,"accessing",unescape("borderImageWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderImageWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRadius","borderRadius"

,function (){var self=this;return (self['@handle'].borderRadius || (0));return self;}

,"accessing",unescape("borderRadius%0D%0A%09%22%20Return%20the%20borderRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRadius:","borderRadius_"

,function (anObject){var self=this;(self.handle()["borderRadius"]=(anObject));return self;}

,"accessing",unescape("borderRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderRadius%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopLeftRadius","borderTopLeftRadius"

,function (){var self=this;return (self['@handle'].borderTopLeftRadius || (0));return self;}

,"accessing",unescape("borderTopLeftRadius%0D%0A%09%22%20Return%20the%20borderTopLeftRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopLeftRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopLeftRadius:","borderTopLeftRadius_"

,function (anObject){var self=this;(self.handle()["borderTopLeftRadius"]=(anObject));return self;}

,"accessing",unescape("borderTopLeftRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopLeftRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderTopLeftRadius%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopRightRadius","borderTopRightRadius"

,function (){var self=this;return (self['@handle'].borderTopRightRadius || (0));return self;}

,"accessing",unescape("borderTopRightRadius%0D%0A%09%22%20Return%20the%20borderTopRightRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopRightRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopRightRadius:","borderTopRightRadius_"

,function (anObject){var self=this;(self.handle()["borderTopRightRadius"]=(anObject));return self;}

,"accessing",unescape("borderTopRightRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopRightRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27borderTopRightRadius%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxAlign","boxAlign"

,function (){var self=this;return (self['@handle'].boxAlign || (0));return self;}

,"accessing",unescape("boxAlign%0D%0A%09%22%20Return%20the%20boxAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxAlign%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxAlign:","boxAlign_"

,function (anObject){var self=this;(self.handle()["boxAlign"]=(anObject));return self;}

,"accessing",unescape("boxAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20boxAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxAlign%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxDirection","boxDirection"

,function (){var self=this;return (self['@handle'].boxDirection || (0));return self;}

,"accessing",unescape("boxDirection%0D%0A%09%22%20Return%20the%20boxDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxDirection%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxDirection:","boxDirection_"

,function (anObject){var self=this;(self.handle()["boxDirection"]=(anObject));return self;}

,"accessing",unescape("boxDirection%3A%20anObject%0D%0A%09%22%20Set%20the%20boxDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxDirection%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxFlex","boxFlex"

,function (){var self=this;return (self['@handle'].boxFlex || (0));return self;}

,"accessing",unescape("boxFlex%0D%0A%09%22%20Return%20the%20boxFlex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxFlex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxFlex:","boxFlex_"

,function (anObject){var self=this;(self.handle()["boxFlex"]=(anObject));return self;}

,"accessing",unescape("boxFlex%3A%20anObject%0D%0A%09%22%20Set%20the%20boxFlex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxFlex%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxFlexGroup","boxFlexGroup"

,function (){var self=this;return (self['@handle'].boxFlexGroup || (0));return self;}

,"accessing",unescape("boxFlexGroup%0D%0A%09%22%20Return%20the%20boxFlexGroup%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxFlexGroup%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxFlexGroup:","boxFlexGroup_"

,function (anObject){var self=this;(self.handle()["boxFlexGroup"]=(anObject));return self;}

,"accessing",unescape("boxFlexGroup%3A%20anObject%0D%0A%09%22%20Set%20the%20boxFlexGroup%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxFlexGroup%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxLines","boxLines"

,function (){var self=this;return (self['@handle'].boxLines || (0));return self;}

,"accessing",unescape("boxLines%0D%0A%09%22%20Return%20the%20boxLines%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxLines%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxLines:","boxLines_"

,function (anObject){var self=this;(self.handle()["boxLines"]=(anObject));return self;}

,"accessing",unescape("boxLines%3A%20anObject%0D%0A%09%22%20Set%20the%20boxLines%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxLines%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxOrdinalGroup","boxOrdinalGroup"

,function (){var self=this;return (self['@handle'].boxOrdinalGroup || (0));return self;}

,"accessing",unescape("boxOrdinalGroup%0D%0A%09%22%20Return%20the%20boxOrdinalGroup%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxOrdinalGroup%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxOrdinalGroup:","boxOrdinalGroup_"

,function (anObject){var self=this;(self.handle()["boxOrdinalGroup"]=(anObject));return self;}

,"accessing",unescape("boxOrdinalGroup%3A%20anObject%0D%0A%09%22%20Set%20the%20boxOrdinalGroup%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxOrdinalGroup%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxOrient","boxOrient"

,function (){var self=this;return (self['@handle'].boxOrient || (0));return self;}

,"accessing",unescape("boxOrient%0D%0A%09%22%20Return%20the%20boxOrient%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxOrient%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxOrient:","boxOrient_"

,function (anObject){var self=this;(self.handle()["boxOrient"]=(anObject));return self;}

,"accessing",unescape("boxOrient%3A%20anObject%0D%0A%09%22%20Set%20the%20boxOrient%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxOrient%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxPack","boxPack"

,function (){var self=this;return (self['@handle'].boxPack || (0));return self;}

,"accessing",unescape("boxPack%0D%0A%09%22%20Return%20the%20boxPack%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxPack%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxPack:","boxPack_"

,function (anObject){var self=this;(self.handle()["boxPack"]=(anObject));return self;}

,"accessing",unescape("boxPack%3A%20anObject%0D%0A%09%22%20Set%20the%20boxPack%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxPack%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxSizing","boxSizing"

,function (){var self=this;return (self['@handle'].boxSizing || (0));return self;}

,"accessing",unescape("boxSizing%0D%0A%09%22%20Return%20the%20boxSizing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxSizing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxSizing:","boxSizing_"

,function (anObject){var self=this;(self.handle()["boxSizing"]=(anObject));return self;}

,"accessing",unescape("boxSizing%3A%20anObject%0D%0A%09%22%20Set%20the%20boxSizing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxSizing%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxShadow","boxShadow"

,function (){var self=this;return (self['@handle'].boxShadow || (0));return self;}

,"accessing",unescape("boxShadow%0D%0A%09%22%20Return%20the%20boxShadow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxShadow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxShadow:","boxShadow_"

,function (anObject){var self=this;(self.handle()["boxShadow"]=(anObject));return self;}

,"accessing",unescape("boxShadow%3A%20anObject%0D%0A%09%22%20Set%20the%20boxShadow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27boxShadow%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnCount","columnCount"

,function (){var self=this;return (self['@handle'].columnCount || (0));return self;}

,"accessing",unescape("columnCount%0D%0A%09%22%20Return%20the%20columnCount%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnCount%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnCount:","columnCount_"

,function (anObject){var self=this;(self.handle()["columnCount"]=(anObject));return self;}

,"accessing",unescape("columnCount%3A%20anObject%0D%0A%09%22%20Set%20the%20columnCount%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columnCount%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnFill","columnFill"

,function (){var self=this;return (self['@handle'].columnFill || (0));return self;}

,"accessing",unescape("columnFill%0D%0A%09%22%20Return%20the%20columnFill%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnFill%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnFill:","columnFill_"

,function (anObject){var self=this;(self.handle()["columnFill"]=(anObject));return self;}

,"accessing",unescape("columnFill%3A%20anObject%0D%0A%09%22%20Set%20the%20columnFill%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columnFill%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnGap","columnGap"

,function (){var self=this;return (self['@handle'].columnGap || (0));return self;}

,"accessing",unescape("columnGap%0D%0A%09%22%20Return%20the%20columnGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnGap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnGap:","columnGap_"

,function (anObject){var self=this;(self.handle()["columnGap"]=(anObject));return self;}

,"accessing",unescape("columnGap%3A%20anObject%0D%0A%09%22%20Set%20the%20columnGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columnGap%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRule","columnRule"

,function (){var self=this;return (self['@handle'].columnRule || (0));return self;}

,"accessing",unescape("columnRule%0D%0A%09%22%20Return%20the%20columnRule%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnRule%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRule:","columnRule_"

,function (anObject){var self=this;(self.handle()["columnRule"]=(anObject));return self;}

,"accessing",unescape("columnRule%3A%20anObject%0D%0A%09%22%20Set%20the%20columnRule%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columnRule%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleColor","columnRuleColor"

,function (){var self=this;return (self['@handle'].columnRuleColor || (0));return self;}

,"accessing",unescape("columnRuleColor%0D%0A%09%22%20Return%20the%20columnRuleColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnRuleColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleColor:","columnRuleColor_"

,function (anObject){var self=this;(self.handle()["columnRuleColor"]=(anObject));return self;}

,"accessing",unescape("columnRuleColor%3A%20anObject%0D%0A%09%22%20Set%20the%20columnRuleColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columnRuleColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleStyle","columnRuleStyle"

,function (){var self=this;return (self['@handle'].columnRuleStyle || (0));return self;}

,"accessing",unescape("columnRuleStyle%0D%0A%09%22%20Return%20the%20columnRuleStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnRuleStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleStyle:","columnRuleStyle_"

,function (anObject){var self=this;(self.handle()["columnRuleStyle"]=(anObject));return self;}

,"accessing",unescape("columnRuleStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20columnRuleStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columnRuleStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleWidth","columnRuleWidth"

,function (){var self=this;return (self['@handle'].columnRuleWidth || (0));return self;}

,"accessing",unescape("columnRuleWidth%0D%0A%09%22%20Return%20the%20columnRuleWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnRuleWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleWidth:","columnRuleWidth_"

,function (anObject){var self=this;(self.handle()["columnRuleWidth"]=(anObject));return self;}

,"accessing",unescape("columnRuleWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20columnRuleWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columnRuleWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnSpan","columnSpan"

,function (){var self=this;return (self['@handle'].columnSpan || (0));return self;}

,"accessing",unescape("columnSpan%0D%0A%09%22%20Return%20the%20columnSpan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnSpan%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnSpan:","columnSpan_"

,function (anObject){var self=this;(self.handle()["columnSpan"]=(anObject));return self;}

,"accessing",unescape("columnSpan%3A%20anObject%0D%0A%09%22%20Set%20the%20columnSpan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columnSpan%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnWidth","columnWidth"

,function (){var self=this;return (self['@handle'].columnWidth || (0));return self;}

,"accessing",unescape("columnWidth%0D%0A%09%22%20Return%20the%20columnWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnWidth:","columnWidth_"

,function (anObject){var self=this;(self.handle()["columnWidth"]=(anObject));return self;}

,"accessing",unescape("columnWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20columnWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columnWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columns","columns"

,function (){var self=this;return (self['@handle'].columns || (0));return self;}

,"accessing",unescape("columns%0D%0A%09%22%20Return%20the%20columns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columns%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columns:","columns_"

,function (anObject){var self=this;(self.handle()["columns"]=(anObject));return self;}

,"accessing",unescape("columns%3A%20anObject%0D%0A%09%22%20Set%20the%20columns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27columns%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"content","content"

,function (){var self=this;return (self['@handle'].content || (0));return self;}

,"accessing",unescape("content%0D%0A%09%22%20Return%20the%20content%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23content%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"content:","content_"

,function (anObject){var self=this;(self.handle()["content"]=(anObject));return self;}

,"accessing",unescape("content%3A%20anObject%0D%0A%09%22%20Set%20the%20content%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27content%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"counterIncrement","counterIncrement"

,function (){var self=this;return (self['@handle'].counterIncrement || (0));return self;}

,"accessing",unescape("counterIncrement%0D%0A%09%22%20Return%20the%20counterIncrement%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23counterIncrement%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"counterIncrement:","counterIncrement_"

,function (anObject){var self=this;(self.handle()["counterIncrement"]=(anObject));return self;}

,"accessing",unescape("counterIncrement%3A%20anObject%0D%0A%09%22%20Set%20the%20counterIncrement%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27counterIncrement%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"counterReset","counterReset"

,function (){var self=this;return (self['@handle'].counterReset || (0));return self;}

,"accessing",unescape("counterReset%0D%0A%09%22%20Return%20the%20counterReset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23counterReset%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"counterReset:","counterReset_"

,function (anObject){var self=this;(self.handle()["counterReset"]=(anObject));return self;}

,"accessing",unescape("counterReset%3A%20anObject%0D%0A%09%22%20Set%20the%20counterReset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27counterReset%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"cursor","cursor"

,function (){var self=this;return (self['@handle'].cursor || (0));return self;}

,"accessing",unescape("cursor%0D%0A%09%22%20Return%20the%20cursor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cursor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"cursor:","cursor_"

,function (anObject){var self=this;(self.handle()["cursor"]=(anObject));return self;}

,"accessing",unescape("cursor%3A%20anObject%0D%0A%09%22%20Set%20the%20cursor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cursor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"direction","direction"

,function (){var self=this;return (self['@handle'].direction || (0));return self;}

,"accessing",unescape("direction%0D%0A%09%22%20Return%20the%20direction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23direction%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"direction:","direction_"

,function (anObject){var self=this;(self.handle()["direction"]=(anObject));return self;}

,"accessing",unescape("direction%3A%20anObject%0D%0A%09%22%20Set%20the%20direction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27direction%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outline","outline"

,function (){var self=this;return (self['@handle'].outline || (0));return self;}

,"accessing",unescape("outline%0D%0A%09%22%20Return%20the%20outline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outline%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outline:","outline_"

,function (anObject){var self=this;(self.handle()["outline"]=(anObject));return self;}

,"accessing",unescape("outline%3A%20anObject%0D%0A%09%22%20Set%20the%20outline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27outline%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineColor","outlineColor"

,function (){var self=this;return (self['@handle'].outlineColor || (0));return self;}

,"accessing",unescape("outlineColor%0D%0A%09%22%20Return%20the%20outlineColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineColor:","outlineColor_"

,function (anObject){var self=this;(self.handle()["outlineColor"]=(anObject));return self;}

,"accessing",unescape("outlineColor%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27outlineColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineStyle","outlineStyle"

,function (){var self=this;return (self['@handle'].outlineStyle || (0));return self;}

,"accessing",unescape("outlineStyle%0D%0A%09%22%20Return%20the%20outlineStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineStyle:","outlineStyle_"

,function (anObject){var self=this;(self.handle()["outlineStyle"]=(anObject));return self;}

,"accessing",unescape("outlineStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27outlineStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineWidth","outlineWidth"

,function (){var self=this;return (self['@handle'].outlineWidth || (0));return self;}

,"accessing",unescape("outlineWidth%0D%0A%09%22%20Return%20the%20outlineWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineWidth:","outlineWidth_"

,function (anObject){var self=this;(self.handle()["outlineWidth"]=(anObject));return self;}

,"accessing",unescape("outlineWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27outlineWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyle","listStyle"

,function (){var self=this;return (self['@handle'].listStyle || (0));return self;}

,"accessing",unescape("listStyle%0D%0A%09%22%20Return%20the%20listStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyle:","listStyle_"

,function (anObject){var self=this;(self.handle()["listStyle"]=(anObject));return self;}

,"accessing",unescape("listStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20listStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27listStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleImage","listStyleImage"

,function (){var self=this;return (self['@handle'].listStyleImage || (0));return self;}

,"accessing",unescape("listStyleImage%0D%0A%09%22%20Return%20the%20listStyleImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStyleImage%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleImage:","listStyleImage_"

,function (anObject){var self=this;(self.handle()["listStyleImage"]=(anObject));return self;}

,"accessing",unescape("listStyleImage%3A%20anObject%0D%0A%09%22%20Set%20the%20listStyleImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27listStyleImage%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStylePosition","listStylePosition"

,function (){var self=this;return (self['@handle'].listStylePosition || (0));return self;}

,"accessing",unescape("listStylePosition%0D%0A%09%22%20Return%20the%20listStylePosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStylePosition%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStylePosition:","listStylePosition_"

,function (anObject){var self=this;(self.handle()["listStylePosition"]=(anObject));return self;}

,"accessing",unescape("listStylePosition%3A%20anObject%0D%0A%09%22%20Set%20the%20listStylePosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27listStylePosition%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleType","listStyleType"

,function (){var self=this;return (self['@handle'].listStyleType || (0));return self;}

,"accessing",unescape("listStyleType%0D%0A%09%22%20Return%20the%20listStyleType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStyleType%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleType:","listStyleType_"

,function (anObject){var self=this;(self.handle()["listStyleType"]=(anObject));return self;}

,"accessing",unescape("listStyleType%3A%20anObject%0D%0A%09%22%20Set%20the%20listStyleType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27listStyleType%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"margin","margin"

,function (){var self=this;return (self['@handle'].margin || (0));return self;}

,"accessing",unescape("margin%0D%0A%09%22%20Return%20the%20margin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23margin%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"margin:","margin_"

,function (anObject){var self=this;(self.handle()["margin"]=(anObject));return self;}

,"accessing",unescape("margin%3A%20anObject%0D%0A%09%22%20Set%20the%20margin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27margin%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"marginBottom","marginBottom"

,function (){var self=this;return (self['@handle'].marginBottom || (0));return self;}

,"accessing",unescape("marginBottom%0D%0A%09%22%20Return%20the%20marginBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginBottom%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"marginBottom:","marginBottom_"

,function (anObject){var self=this;(self.handle()["marginBottom"]=(anObject));return self;}

,"accessing",unescape("marginBottom%3A%20anObject%0D%0A%09%22%20Set%20the%20marginBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27marginBottom%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"marginLeft","marginLeft"

,function (){var self=this;return (self['@handle'].marginLeft || (0));return self;}

,"accessing",unescape("marginLeft%0D%0A%09%22%20Return%20the%20marginLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"marginLeft:","marginLeft_"

,function (anObject){var self=this;(self.handle()["marginLeft"]=(anObject));return self;}

,"accessing",unescape("marginLeft%3A%20anObject%0D%0A%09%22%20Set%20the%20marginLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27marginLeft%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"marginTop","marginTop"

,function (){var self=this;return (self['@handle'].marginTop || (0));return self;}

,"accessing",unescape("marginTop%0D%0A%09%22%20Return%20the%20marginTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"marginTop:","marginTop_"

,function (anObject){var self=this;(self.handle()["marginTop"]=(anObject));return self;}

,"accessing",unescape("marginTop%3A%20anObject%0D%0A%09%22%20Set%20the%20marginTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27marginTop%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"marginRight","marginRight"

,function (){var self=this;return (self['@handle'].marginRight || (0));return self;}

,"accessing",unescape("marginRight%0D%0A%09%22%20Return%20the%20marginRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginRight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"marginRight:","marginRight_"

,function (anObject){var self=this;(self.handle()["marginRight"]=(anObject));return self;}

,"accessing",unescape("marginRight%3A%20anObject%0D%0A%09%22%20Set%20the%20marginRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27marginRight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"padding","padding"

,function (){var self=this;return (self['@handle'].padding || (0));return self;}

,"accessing",unescape("padding%0D%0A%09%22%20Return%20the%20padding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23padding%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"padding:","padding_"

,function (anObject){var self=this;(self.handle()["padding"]=(anObject));return self;}

,"accessing",unescape("padding%3A%20anObject%0D%0A%09%22%20Set%20the%20padding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27padding%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingBottom","paddingBottom"

,function (){var self=this;return (self['@handle'].paddingBottom || (0));return self;}

,"accessing",unescape("paddingBottom%0D%0A%09%22%20Return%20the%20paddingBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23paddingBottom%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingBottom:","paddingBottom_"

,function (anObject){var self=this;(self.handle()["paddingBottom"]=(anObject));return self;}

,"accessing",unescape("paddingBottom%3A%20anObject%0D%0A%09%22%20Set%20the%20paddingBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27paddingBottom%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingLeft","paddingLeft"

,function (){var self=this;return (self['@handle'].paddingLeft || (0));return self;}

,"accessing",unescape("paddingLeft%0D%0A%09%22%20Return%20the%20paddingLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23paddingLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingLeft:","paddingLeft_"

,function (anObject){var self=this;(self.handle()["paddingLeft"]=(anObject));return self;}

,"accessing",unescape("paddingLeft%3A%20anObject%0D%0A%09%22%20Set%20the%20paddingLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27paddingLeft%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingTop","paddingTop"

,function (){var self=this;return (self['@handle'].paddingTop || (0));return self;}

,"accessing",unescape("paddingTop%0D%0A%09%22%20Return%20the%20paddingTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23paddingTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingTop:","paddingTop_"

,function (anObject){var self=this;(self.handle()["paddingTop"]=(anObject));return self;}

,"accessing",unescape("paddingTop%3A%20anObject%0D%0A%09%22%20Set%20the%20paddingTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27paddingTop%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingRight","paddingRight"

,function (){var self=this;return (self['@handle'].paddingRight || (0));return self;}

,"accessing",unescape("paddingRight%0D%0A%09%22%20Return%20the%20paddingRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23paddingRight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingRight:","paddingRight_"

,function (anObject){var self=this;(self.handle()["paddingRight"]=(anObject));return self;}

,"accessing",unescape("paddingRight%3A%20anObject%0D%0A%09%22%20Set%20the%20paddingRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27paddingRight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"cssText","cssText"

,function (){var self=this;return (self['@handle'].cssText || (0));return self;}

,"accessing",unescape("cssText%0D%0A%09%22%20Return%20the%20cssText%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cssText%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"cssText:","cssText_"

,function (anObject){var self=this;(self.handle()["cssText"]=(anObject));return self;}

,"accessing",unescape("cssText%3A%20anObject%0D%0A%09%22%20Set%20the%20cssText%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cssText%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"bottom","bottom"

,function (){var self=this;return (self['@handle'].bottom || (0));return self;}

,"accessing",unescape("bottom%0D%0A%09%22%20Return%20the%20bottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23bottom%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"bottom:","bottom_"

,function (anObject){var self=this;(self.handle()["bottom"]=(anObject));return self;}

,"accessing",unescape("bottom%3A%20anObject%0D%0A%09%22%20Set%20the%20bottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27bottom%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"left","left"

,function (){var self=this;return (self['@handle'].left || (0));return self;}

,"accessing",unescape("left%0D%0A%09%22%20Return%20the%20left%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23left%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"left:","left_"

,function (anObject){var self=this;(self.handle()["left"]=(anObject));return self;}

,"accessing",unescape("left%3A%20anObject%0D%0A%09%22%20Set%20the%20left%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27left%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"right","right"

,function (){var self=this;return (self['@handle'].right || (0));return self;}

,"accessing",unescape("right%0D%0A%09%22%20Return%20the%20right%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23right%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"right:","right_"

,function (anObject){var self=this;(self.handle()["right"]=(anObject));return self;}

,"accessing",unescape("right%3A%20anObject%0D%0A%09%22%20Set%20the%20right%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27right%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"top","top"

,function (){var self=this;return (self['@handle'].top || (0));return self;}

,"accessing",unescape("top%0D%0A%09%22%20Return%20the%20top%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23top%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"top:","top_"

,function (anObject){var self=this;(self.handle()["top"]=(anObject));return self;}

,"accessing",unescape("top%3A%20anObject%0D%0A%09%22%20Set%20the%20top%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27top%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"height","height"

,function (){var self=this;return (self['@handle'].height || (0));return self;}

,"accessing",unescape("height%0D%0A%09%22%20Return%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23height%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"height:","height_"

,function (anObject){var self=this;(self.handle()["height"]=(anObject));return self;}

,"accessing",unescape("height%3A%20anObject%0D%0A%09%22%20Set%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27height%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"width","width"

,function (){var self=this;return (self['@handle'].width || (0));return self;}

,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23width%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"width:","width_"

,function (anObject){var self=this;(self.handle()["width"]=(anObject));return self;}

,"accessing",unescape("width%3A%20anObject%0D%0A%09%22%20Set%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27width%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"clear","clear"

,function (){var self=this;return (self['@handle'].clear || (0));return self;}

,"accessing",unescape("clear%0D%0A%09%22%20Return%20the%20clear%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23clear%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"clear:","clear_"

,function (anObject){var self=this;(self.handle()["clear"]=(anObject));return self;}

,"accessing",unescape("clear%3A%20anObject%0D%0A%09%22%20Set%20the%20clear%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27clear%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"clip","clip"

,function (){var self=this;return (self['@handle'].clip || (0));return self;}

,"accessing",unescape("clip%0D%0A%09%22%20Return%20the%20clip%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23clip%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"clip:","clip_"

,function (anObject){var self=this;(self.handle()["clip"]=(anObject));return self;}

,"accessing",unescape("clip%3A%20anObject%0D%0A%09%22%20Set%20the%20clip%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27clip%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"cssFloat","cssFloat"

,function (){var self=this;return (self['@handle'].cssFloat || (0));return self;}

,"accessing",unescape("cssFloat%0D%0A%09%22%20Return%20the%20cssFloat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cssFloat%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"cssFloat:","cssFloat_"

,function (anObject){var self=this;(self.handle()["cssFloat"]=(anObject));return self;}

,"accessing",unescape("cssFloat%3A%20anObject%0D%0A%09%22%20Set%20the%20cssFloat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cssFloat%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"display","display"

,function (){var self=this;return (self['@handle'].display || (0));return self;}

,"accessing",unescape("display%0D%0A%09%22%20Return%20the%20display%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23display%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"display:","display_"

,function (anObject){var self=this;(self.handle()["display"]=(anObject));return self;}

,"accessing",unescape("display%3A%20anObject%0D%0A%09%22%20Set%20the%20display%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27display%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"minHeight","minHeight"

,function (){var self=this;return (self['@handle'].minHeight || (0));return self;}

,"accessing",unescape("minHeight%0D%0A%09%22%20Return%20the%20minHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23minHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"minHeight:","minHeight_"

,function (anObject){var self=this;(self.handle()["minHeight"]=(anObject));return self;}

,"accessing",unescape("minHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20minHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27minHeight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"maxHeight","maxHeight"

,function (){var self=this;return (self['@handle'].maxHeight || (0));return self;}

,"accessing",unescape("maxHeight%0D%0A%09%22%20Return%20the%20maxHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23maxHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"maxHeight:","maxHeight_"

,function (anObject){var self=this;(self.handle()["maxHeight"]=(anObject));return self;}

,"accessing",unescape("maxHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20maxHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27maxHeight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"minWidth","minWidth"

,function (){var self=this;return (self['@handle'].minWidth || (0));return self;}

,"accessing",unescape("minWidth%0D%0A%09%22%20Return%20the%20minWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23minWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"minWidth:","minWidth_"

,function (anObject){var self=this;(self.handle()["minWidth"]=(anObject));return self;}

,"accessing",unescape("minWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20minWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27minWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"maxWidth","maxWidth"

,function (){var self=this;return (self['@handle'].maxWidth || (0));return self;}

,"accessing",unescape("maxWidth%0D%0A%09%22%20Return%20the%20maxWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23maxWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"maxWidth:","maxWidth_"

,function (anObject){var self=this;(self.handle()["maxWidth"]=(anObject));return self;}

,"accessing",unescape("maxWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20maxWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27maxWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"orphans","orphans"

,function (){var self=this;return (self['@handle'].orphans || (0));return self;}

,"accessing",unescape("orphans%0D%0A%09%22%20Return%20the%20orphans%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23orphans%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"orphans:","orphans_"

,function (anObject){var self=this;(self.handle()["orphans"]=(anObject));return self;}

,"accessing",unescape("orphans%3A%20anObject%0D%0A%09%22%20Set%20the%20orphans%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27orphans%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakAfter","pageBreakAfter"

,function (){var self=this;return (self['@handle'].pageBreakAfter || (0));return self;}

,"accessing",unescape("pageBreakAfter%0D%0A%09%22%20Return%20the%20pageBreakAfter%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageBreakAfter%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakAfter:","pageBreakAfter_"

,function (anObject){var self=this;(self.handle()["pageBreakAfter"]=(anObject));return self;}

,"accessing",unescape("pageBreakAfter%3A%20anObject%0D%0A%09%22%20Set%20the%20pageBreakAfter%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27pageBreakAfter%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakBefore","pageBreakBefore"

,function (){var self=this;return (self['@handle'].pageBreakBefore || (0));return self;}

,"accessing",unescape("pageBreakBefore%0D%0A%09%22%20Return%20the%20pageBreakBefore%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageBreakBefore%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakBefore:","pageBreakBefore_"

,function (anObject){var self=this;(self.handle()["pageBreakBefore"]=(anObject));return self;}

,"accessing",unescape("pageBreakBefore%3A%20anObject%0D%0A%09%22%20Set%20the%20pageBreakBefore%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27pageBreakBefore%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakInside","pageBreakInside"

,function (){var self=this;return (self['@handle'].pageBreakInside || (0));return self;}

,"accessing",unescape("pageBreakInside%0D%0A%09%22%20Return%20the%20pageBreakInside%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageBreakInside%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakInside:","pageBreakInside_"

,function (anObject){var self=this;(self.handle()["pageBreakInside"]=(anObject));return self;}

,"accessing",unescape("pageBreakInside%3A%20anObject%0D%0A%09%22%20Set%20the%20pageBreakInside%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27pageBreakInside%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"windows","windows"

,function (){var self=this;return (self['@handle'].windows || (0));return self;}

,"accessing",unescape("windows%0D%0A%09%22%20Return%20the%20windows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23windows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"windows:","windows_"

,function (anObject){var self=this;(self.handle()["windows"]=(anObject));return self;}

,"accessing",unescape("windows%3A%20anObject%0D%0A%09%22%20Set%20the%20windows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27windows%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"captionSide","captionSide"

,function (){var self=this;return (self['@handle'].captionSide || (0));return self;}

,"accessing",unescape("captionSide%0D%0A%09%22%20Return%20the%20captionSide%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23captionSide%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"captionSide:","captionSide_"

,function (anObject){var self=this;(self.handle()["captionSide"]=(anObject));return self;}

,"accessing",unescape("captionSide%3A%20anObject%0D%0A%09%22%20Set%20the%20captionSide%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27captionSide%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"emptyCells","emptyCells"

,function (){var self=this;return (self['@handle'].emptyCells || (0));return self;}

,"accessing",unescape("emptyCells%0D%0A%09%22%20Return%20the%20emptyCells%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23emptyCells%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"emptyCells:","emptyCells_"

,function (anObject){var self=this;(self.handle()["emptyCells"]=(anObject));return self;}

,"accessing",unescape("emptyCells%3A%20anObject%0D%0A%09%22%20Set%20the%20emptyCells%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27emptyCells%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"tableLayout","tableLayout"

,function (){var self=this;return (self['@handle'].tableLayout || (0));return self;}

,"accessing",unescape("tableLayout%0D%0A%09%22%20Return%20the%20tableLayout%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tableLayout%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"tableLayout:","tableLayout_"

,function (anObject){var self=this;(self.handle()["tableLayout"]=(anObject));return self;}

,"accessing",unescape("tableLayout%3A%20anObject%0D%0A%09%22%20Set%20the%20tableLayout%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27tableLayout%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"color","color"

,function (){var self=this;return (self['@handle'].color || (0));return self;}

,"accessing",unescape("color%0D%0A%09%22%20Return%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23color%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"color:","color_"

,function (anObject){var self=this;(self.handle()["color"]=(anObject));return self;}

,"accessing",unescape("color%3A%20anObject%0D%0A%09%22%20Set%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27color%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"font","font"

,function (){var self=this;return (self['@handle'].font || (0));return self;}

,"accessing",unescape("font%0D%0A%09%22%20Return%20the%20font%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23font%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"font:","font_"

,function (anObject){var self=this;(self.handle()["font"]=(anObject));return self;}

,"accessing",unescape("font%3A%20anObject%0D%0A%09%22%20Set%20the%20font%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27font%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontFamily","fontFamily"

,function (){var self=this;return (self['@handle'].fontFamily || (0));return self;}

,"accessing",unescape("fontFamily%0D%0A%09%22%20Return%20the%20fontFamily%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontFamily%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontFamily:","fontFamily_"

,function (anObject){var self=this;(self.handle()["fontFamily"]=(anObject));return self;}

,"accessing",unescape("fontFamily%3A%20anObject%0D%0A%09%22%20Set%20the%20fontFamily%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fontFamily%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontSize","fontSize"

,function (){var self=this;return (self['@handle'].fontSize || (0));return self;}

,"accessing",unescape("fontSize%0D%0A%09%22%20Return%20the%20fontSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontSize%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontSize:","fontSize_"

,function (anObject){var self=this;(self.handle()["fontSize"]=(anObject));return self;}

,"accessing",unescape("fontSize%3A%20anObject%0D%0A%09%22%20Set%20the%20fontSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fontSize%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontSizeAdjust","fontSizeAdjust"

,function (){var self=this;return (self['@handle'].fontSizeAdjust || (0));return self;}

,"accessing",unescape("fontSizeAdjust%0D%0A%09%22%20Return%20the%20fontSizeAdjust%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontSizeAdjust%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontSizeAdjust:","fontSizeAdjust_"

,function (anObject){var self=this;(self.handle()["fontSizeAdjust"]=(anObject));return self;}

,"accessing",unescape("fontSizeAdjust%3A%20anObject%0D%0A%09%22%20Set%20the%20fontSizeAdjust%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fontSizeAdjust%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontStyle","fontStyle"

,function (){var self=this;return (self['@handle'].fontStyle || (0));return self;}

,"accessing",unescape("fontStyle%0D%0A%09%22%20Return%20the%20fontStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontStyle:","fontStyle_"

,function (anObject){var self=this;(self.handle()["fontStyle"]=(anObject));return self;}

,"accessing",unescape("fontStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20fontStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fontStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontVariant","fontVariant"

,function (){var self=this;return (self['@handle'].fontVariant || (0));return self;}

,"accessing",unescape("fontVariant%0D%0A%09%22%20Return%20the%20fontVariant%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontVariant%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontVariant:","fontVariant_"

,function (anObject){var self=this;(self.handle()["fontVariant"]=(anObject));return self;}

,"accessing",unescape("fontVariant%3A%20anObject%0D%0A%09%22%20Set%20the%20fontVariant%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fontVariant%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontWeight","fontWeight"

,function (){var self=this;return (self['@handle'].fontWeight || (0));return self;}

,"accessing",unescape("fontWeight%0D%0A%09%22%20Return%20the%20fontWeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontWeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontWeight:","fontWeight_"

,function (anObject){var self=this;(self.handle()["fontWeight"]=(anObject));return self;}

,"accessing",unescape("fontWeight%3A%20anObject%0D%0A%09%22%20Set%20the%20fontWeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fontWeight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontStretch","fontStretch"

,function (){var self=this;return (self['@handle'].fontStretch || (0));return self;}

,"accessing",unescape("fontStretch%0D%0A%09%22%20Return%20the%20fontStretch%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontStretch%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontStretch:","fontStretch_"

,function (anObject){var self=this;(self.handle()["fontStretch"]=(anObject));return self;}

,"accessing",unescape("fontStretch%3A%20anObject%0D%0A%09%22%20Set%20the%20fontStretch%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27fontStretch%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumns","gridColumns"

,function (){var self=this;return (self['@handle'].gridColumns || (0));return self;}

,"accessing",unescape("gridColumns%0D%0A%09%22%20Return%20the%20gridColumns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridColumns%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumns:","gridColumns_"

,function (anObject){var self=this;(self.handle()["gridColumns"]=(anObject));return self;}

,"accessing",unescape("gridColumns%3A%20anObject%0D%0A%09%22%20Set%20the%20gridColumns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27gridColumns%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRows","gridRows"

,function (){var self=this;return (self['@handle'].gridRows || (0));return self;}

,"accessing",unescape("gridRows%0D%0A%09%22%20Return%20the%20gridRows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridRows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRows:","gridRows_"

,function (anObject){var self=this;(self.handle()["gridRows"]=(anObject));return self;}

,"accessing",unescape("gridRows%3A%20anObject%0D%0A%09%22%20Set%20the%20gridRows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27gridRows%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"hangingPunctuation","hangingPunctuation"

,function (){var self=this;return (self['@handle'].hangingPunctuation || (0));return self;}

,"accessing",unescape("hangingPunctuation%0D%0A%09%22%20Return%20the%20hangingPunctuation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23hangingPunctuation%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"hangingPunctuation:","hangingPunctuation_"

,function (anObject){var self=this;(self.handle()["hangingPunctuation"]=(anObject));return self;}

,"accessing",unescape("hangingPunctuation%3A%20anObject%0D%0A%09%22%20Set%20the%20hangingPunctuation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hangingPunctuation%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"icon","icon"

,function (){var self=this;return (self['@handle'].icon || (0));return self;}

,"accessing",unescape("icon%0D%0A%09%22%20Return%20the%20icon%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23icon%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"icon:","icon_"

,function (anObject){var self=this;(self.handle()["icon"]=(anObject));return self;}

,"accessing",unescape("icon%3A%20anObject%0D%0A%09%22%20Set%20the%20icon%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27icon%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"letterSpacing","letterSpacing"

,function (){var self=this;return (self['@handle'].letterSpacing || (0));return self;}

,"accessing",unescape("letterSpacing%0D%0A%09%22%20Return%20the%20letterSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23letterSpacing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"letterSpacing:","letterSpacing_"

,function (anObject){var self=this;(self.handle()["letterSpacing"]=(anObject));return self;}

,"accessing",unescape("letterSpacing%3A%20anObject%0D%0A%09%22%20Set%20the%20letterSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27letterSpacing%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"lineHeight","lineHeight"

,function (){var self=this;return (self['@handle'].lineHeight || (0));return self;}

,"accessing",unescape("lineHeight%0D%0A%09%22%20Return%20the%20lineHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23lineHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"lineHeight:","lineHeight_"

,function (anObject){var self=this;(self.handle()["lineHeight"]=(anObject));return self;}

,"accessing",unescape("lineHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20lineHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27lineHeight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navDown","navDown"

,function (){var self=this;return (self['@handle'].navDown || (0));return self;}

,"accessing",unescape("navDown%0D%0A%09%22%20Return%20the%20navDown%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navDown%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navDown:","navDown_"

,function (anObject){var self=this;(self.handle()["navDown"]=(anObject));return self;}

,"accessing",unescape("navDown%3A%20anObject%0D%0A%09%22%20Set%20the%20navDown%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27navDown%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navIndex","navIndex"

,function (){var self=this;return (self['@handle'].navIndex || (0));return self;}

,"accessing",unescape("navIndex%0D%0A%09%22%20Return%20the%20navIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navIndex:","navIndex_"

,function (anObject){var self=this;(self.handle()["navIndex"]=(anObject));return self;}

,"accessing",unescape("navIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20navIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27navIndex%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navLeft","navLeft"

,function (){var self=this;return (self['@handle'].navLeft || (0));return self;}

,"accessing",unescape("navLeft%0D%0A%09%22%20Return%20the%20navLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navLeft:","navLeft_"

,function (anObject){var self=this;(self.handle()["navLeft"]=(anObject));return self;}

,"accessing",unescape("navLeft%3A%20anObject%0D%0A%09%22%20Set%20the%20navLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27navLeft%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navRight","navRight"

,function (){var self=this;return (self['@handle'].navRight || (0));return self;}

,"accessing",unescape("navRight%0D%0A%09%22%20Return%20the%20navRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navRight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navRight:","navRight_"

,function (anObject){var self=this;(self.handle()["navRight"]=(anObject));return self;}

,"accessing",unescape("navRight%3A%20anObject%0D%0A%09%22%20Set%20the%20navRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27navRight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navUp","navUp"

,function (){var self=this;return (self['@handle'].navUp || (0));return self;}

,"accessing",unescape("navUp%0D%0A%09%22%20Return%20the%20navUp%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navUp%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navUp:","navUp_"

,function (anObject){var self=this;(self.handle()["navUp"]=(anObject));return self;}

,"accessing",unescape("navUp%3A%20anObject%0D%0A%09%22%20Set%20the%20navUp%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27navUp%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"opacity","opacity"

,function (){var self=this;return (self['@handle'].opacity || (0));return self;}

,"accessing",unescape("opacity%0D%0A%09%22%20Return%20the%20opacity%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23opacity%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"opacity:","opacity_"

,function (anObject){var self=this;(self.handle()["opacity"]=(anObject));return self;}

,"accessing",unescape("opacity%3A%20anObject%0D%0A%09%22%20Set%20the%20opacity%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27opacity%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineOffset","outlineOffset"

,function (){var self=this;return (self['@handle'].outlineOffset || (0));return self;}

,"accessing",unescape("outlineOffset%0D%0A%09%22%20Return%20the%20outlineOffset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineOffset%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineOffset:","outlineOffset_"

,function (anObject){var self=this;(self.handle()["outlineOffset"]=(anObject));return self;}

,"accessing",unescape("outlineOffset%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineOffset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27outlineOffset%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"overflow","overflow"

,function (){var self=this;return (self['@handle'].overflow || (0));return self;}

,"accessing",unescape("overflow%0D%0A%09%22%20Return%20the%20overflow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23overflow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"overflow:","overflow_"

,function (anObject){var self=this;(self.handle()["overflow"]=(anObject));return self;}

,"accessing",unescape("overflow%3A%20anObject%0D%0A%09%22%20Set%20the%20overflow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27overflow%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"overflowX","overflowX"

,function (){var self=this;return (self['@handle'].overflowX || (0));return self;}

,"accessing",unescape("overflowX%0D%0A%09%22%20Return%20the%20overflowX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23overflowX%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"overflowX:","overflowX_"

,function (anObject){var self=this;(self.handle()["overflowX"]=(anObject));return self;}

,"accessing",unescape("overflowX%3A%20anObject%0D%0A%09%22%20Set%20the%20overflowX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27overflowX%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"overflowY","overflowY"

,function (){var self=this;return (self['@handle'].overflowY || (0));return self;}

,"accessing",unescape("overflowY%0D%0A%09%22%20Return%20the%20overflowY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23overflowY%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"overflowY:","overflowY_"

,function (anObject){var self=this;(self.handle()["overflowY"]=(anObject));return self;}

,"accessing",unescape("overflowY%3A%20anObject%0D%0A%09%22%20Set%20the%20overflowY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27overflowY%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"perspective","perspective"

,function (){var self=this;return (self['@handle'].perspective || (0));return self;}

,"accessing",unescape("perspective%0D%0A%09%22%20Return%20the%20perspective%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23perspective%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"perspective:","perspective_"

,function (anObject){var self=this;(self.handle()["perspective"]=(anObject));return self;}

,"accessing",unescape("perspective%3A%20anObject%0D%0A%09%22%20Set%20the%20perspective%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27perspective%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"perspectiveOrigin","perspectiveOrigin"

,function (){var self=this;return (self['@handle'].perspectiveOrigin || (0));return self;}

,"accessing",unescape("perspectiveOrigin%0D%0A%09%22%20Return%20the%20perspectiveOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23perspectiveOrigin%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"perspectiveOrigin:","perspectiveOrigin_"

,function (anObject){var self=this;(self.handle()["perspectiveOrigin"]=(anObject));return self;}

,"accessing",unescape("perspectiveOrigin%3A%20anObject%0D%0A%09%22%20Set%20the%20perspectiveOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27perspectiveOrigin%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"position","position"

,function (){var self=this;return (self['@handle'].position || (0));return self;}

,"accessing",unescape("position%0D%0A%09%22%20Return%20the%20position%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23position%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"position:","position_"

,function (anObject){var self=this;(self.handle()["position"]=(anObject));return self;}

,"accessing",unescape("position%3A%20anObject%0D%0A%09%22%20Set%20the%20position%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27position%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"punctuationTrim","punctuationTrim"

,function (){var self=this;return (self['@handle'].punctuationTrim || (0));return self;}

,"accessing",unescape("punctuationTrim%0D%0A%09%22%20Return%20the%20punctuationTrim%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23punctuationTrim%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"punctuationTrim:","punctuationTrim_"

,function (anObject){var self=this;(self.handle()["punctuationTrim"]=(anObject));return self;}

,"accessing",unescape("punctuationTrim%3A%20anObject%0D%0A%09%22%20Set%20the%20punctuationTrim%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27punctuationTrim%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"quotes","quotes"

,function (){var self=this;return (self['@handle'].quotes || (0));return self;}

,"accessing",unescape("quotes%0D%0A%09%22%20Return%20the%20quotes%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23quotes%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"quotes:","quotes_"

,function (anObject){var self=this;(self.handle()["quotes"]=(anObject));return self;}

,"accessing",unescape("quotes%3A%20anObject%0D%0A%09%22%20Set%20the%20quotes%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27quotes%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"resize","resize"

,function (){var self=this;return (self['@handle'].resize || (0));return self;}

,"accessing",unescape("resize%0D%0A%09%22%20Return%20the%20resize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23resize%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"resize:","resize_"

,function (anObject){var self=this;(self.handle()["resize"]=(anObject));return self;}

,"accessing",unescape("resize%3A%20anObject%0D%0A%09%22%20Set%20the%20resize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27resize%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"rotation","rotation"

,function (){var self=this;return (self['@handle'].rotation || (0));return self;}

,"accessing",unescape("rotation%0D%0A%09%22%20Return%20the%20rotation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rotation%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"rotation:","rotation_"

,function (anObject){var self=this;(self.handle()["rotation"]=(anObject));return self;}

,"accessing",unescape("rotation%3A%20anObject%0D%0A%09%22%20Set%20the%20rotation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rotation%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"rotationPoint","rotationPoint"

,function (){var self=this;return (self['@handle'].rotationPoint || (0));return self;}

,"accessing",unescape("rotationPoint%0D%0A%09%22%20Return%20the%20rotationPoint%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rotationPoint%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"rotationPoint:","rotationPoint_"

,function (anObject){var self=this;(self.handle()["rotationPoint"]=(anObject));return self;}

,"accessing",unescape("rotationPoint%3A%20anObject%0D%0A%09%22%20Set%20the%20rotationPoint%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rotationPoint%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"target","target"

,function (){var self=this;return (self['@handle'].target || (0));return self;}

,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23target%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"target:","target_"

,function (anObject){var self=this;(self.handle()["target"]=(anObject));return self;}

,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27target%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"targetName","targetName"

,function (){var self=this;return (self['@handle'].targetName || (0));return self;}

,"accessing",unescape("targetName%0D%0A%09%22%20Return%20the%20targetName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23targetName%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"targetName:","targetName_"

,function (anObject){var self=this;(self.handle()["targetName"]=(anObject));return self;}

,"accessing",unescape("targetName%3A%20anObject%0D%0A%09%22%20Set%20the%20targetName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27targetName%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"targetNew","targetNew"

,function (){var self=this;return (self['@handle'].targetNew || (0));return self;}

,"accessing",unescape("targetNew%0D%0A%09%22%20Return%20the%20targetNew%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23targetNew%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"targetNew:","targetNew_"

,function (anObject){var self=this;(self.handle()["targetNew"]=(anObject));return self;}

,"accessing",unescape("targetNew%3A%20anObject%0D%0A%09%22%20Set%20the%20targetNew%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27targetNew%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"targetPosition","targetPosition"

,function (){var self=this;return (self['@handle'].targetPosition || (0));return self;}

,"accessing",unescape("targetPosition%0D%0A%09%22%20Return%20the%20targetPosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23targetPosition%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"targetPosition:","targetPosition_"

,function (anObject){var self=this;(self.handle()["targetPosition"]=(anObject));return self;}

,"accessing",unescape("targetPosition%3A%20anObject%0D%0A%09%22%20Set%20the%20targetPosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27targetPosition%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textAlign","textAlign"

,function (){var self=this;return (self['@handle'].textAlign || (0));return self;}

,"accessing",unescape("textAlign%0D%0A%09%22%20Return%20the%20textAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textAlign%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textAlign:","textAlign_"

,function (anObject){var self=this;(self.handle()["textAlign"]=(anObject));return self;}

,"accessing",unescape("textAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20textAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27textAlign%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecoration","textDecoration"

,function (){var self=this;return (self['@handle'].textDecoration || (0));return self;}

,"accessing",unescape("textDecoration%0D%0A%09%22%20Return%20the%20textDecoration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textDecoration%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecoration:","textDecoration_"

,function (anObject){var self=this;(self.handle()["textDecoration"]=(anObject));return self;}

,"accessing",unescape("textDecoration%3A%20anObject%0D%0A%09%22%20Set%20the%20textDecoration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27textDecoration%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textIndent","textIndent"

,function (){var self=this;return (self['@handle'].textIndent || (0));return self;}

,"accessing",unescape("textIndent%0D%0A%09%22%20Return%20the%20textIndent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textIndent%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textIndent:","textIndent_"

,function (anObject){var self=this;(self.handle()["textIndent"]=(anObject));return self;}

,"accessing",unescape("textIndent%3A%20anObject%0D%0A%09%22%20Set%20the%20textIndent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27textIndent%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textJustify","textJustify"

,function (){var self=this;return (self['@handle'].textJustify || (0));return self;}

,"accessing",unescape("textJustify%0D%0A%09%22%20Return%20the%20textJustify%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textJustify%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textJustify:","textJustify_"

,function (anObject){var self=this;(self.handle()["textJustify"]=(anObject));return self;}

,"accessing",unescape("textJustify%3A%20anObject%0D%0A%09%22%20Set%20the%20textJustify%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27textJustify%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textOutline","textOutline"

,function (){var self=this;return (self['@handle'].textOutline || (0));return self;}

,"accessing",unescape("textOutline%0D%0A%09%22%20Return%20the%20textOutline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textOutline%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textOutline:","textOutline_"

,function (anObject){var self=this;(self.handle()["textOutline"]=(anObject));return self;}

,"accessing",unescape("textOutline%3A%20anObject%0D%0A%09%22%20Set%20the%20textOutline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27textOutline%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textOverflow","textOverflow"

,function (){var self=this;return (self['@handle'].textOverflow || (0));return self;}

,"accessing",unescape("textOverflow%0D%0A%09%22%20Return%20the%20textOverflow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textOverflow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textOverflow:","textOverflow_"

,function (anObject){var self=this;(self.handle()["textOverflow"]=(anObject));return self;}

,"accessing",unescape("textOverflow%3A%20anObject%0D%0A%09%22%20Set%20the%20textOverflow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27textOverflow%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textShadow","textShadow"

,function (){var self=this;return (self['@handle'].textShadow || (0));return self;}

,"accessing",unescape("textShadow%0D%0A%09%22%20Return%20the%20textShadow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textShadow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textShadow:","textShadow_"

,function (anObject){var self=this;(self.handle()["textShadow"]=(anObject));return self;}

,"accessing",unescape("textShadow%3A%20anObject%0D%0A%09%22%20Set%20the%20textShadow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27textShadow%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textTransform","textTransform"

,function (){var self=this;return (self['@handle'].textTransform || (0));return self;}

,"accessing",unescape("textTransform%0D%0A%09%22%20Return%20the%20textTransform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textTransform%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textTransform:","textTransform_"

,function (anObject){var self=this;(self.handle()["textTransform"]=(anObject));return self;}

,"accessing",unescape("textTransform%3A%20anObject%0D%0A%09%22%20Set%20the%20textTransform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27textTransform%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textWrap","textWrap"

,function (){var self=this;return (self['@handle'].textWrap || (0));return self;}

,"accessing",unescape("textWrap%0D%0A%09%22%20Return%20the%20textWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textWrap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textWrap:","textWrap_"

,function (anObject){var self=this;(self.handle()["textWrap"]=(anObject));return self;}

,"accessing",unescape("textWrap%3A%20anObject%0D%0A%09%22%20Set%20the%20textWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27textWrap%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transform","transform"

,function (){var self=this;return (self['@handle'].transform || (0));return self;}

,"accessing",unescape("transform%0D%0A%09%22%20Return%20the%20transform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transform%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transform:","transform_"

,function (anObject){var self=this;(self.handle()["transform"]=(anObject));return self;}

,"accessing",unescape("transform%3A%20anObject%0D%0A%09%22%20Set%20the%20transform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27transform%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transformOrigin","transformOrigin"

,function (){var self=this;return (self['@handle'].transformOrigin || (0));return self;}

,"accessing",unescape("transformOrigin%0D%0A%09%22%20Return%20the%20transformOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transformOrigin%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transformOrigin:","transformOrigin_"

,function (anObject){var self=this;(self.handle()["transformOrigin"]=(anObject));return self;}

,"accessing",unescape("transformOrigin%3A%20anObject%0D%0A%09%22%20Set%20the%20transformOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27transformOrigin%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transformStyle","transformStyle"

,function (){var self=this;return (self['@handle'].transformStyle || (0));return self;}

,"accessing",unescape("transformStyle%0D%0A%09%22%20Return%20the%20transformStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transformStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transformStyle:","transformStyle_"

,function (anObject){var self=this;(self.handle()["transformStyle"]=(anObject));return self;}

,"accessing",unescape("transformStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20transformStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27transformStyle%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transition","transition"

,function (){var self=this;return (self['@handle'].transition || (0));return self;}

,"accessing",unescape("transition%0D%0A%09%22%20Return%20the%20transition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transition%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transition:","transition_"

,function (anObject){var self=this;(self.handle()["transition"]=(anObject));return self;}

,"accessing",unescape("transition%3A%20anObject%0D%0A%09%22%20Set%20the%20transition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27transition%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionProperty","transitionProperty"

,function (){var self=this;return (self['@handle'].transitionProperty || (0));return self;}

,"accessing",unescape("transitionProperty%0D%0A%09%22%20Return%20the%20transitionProperty%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transitionProperty%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionProperty:","transitionProperty_"

,function (anObject){var self=this;(self.handle()["transitionProperty"]=(anObject));return self;}

,"accessing",unescape("transitionProperty%3A%20anObject%0D%0A%09%22%20Set%20the%20transitionProperty%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27transitionProperty%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionDuration","transitionDuration"

,function (){var self=this;return (self['@handle'].transitionDuration || (0));return self;}

,"accessing",unescape("transitionDuration%0D%0A%09%22%20Return%20the%20transitionDuration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transitionDuration%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionDuration:","transitionDuration_"

,function (anObject){var self=this;(self.handle()["transitionDuration"]=(anObject));return self;}

,"accessing",unescape("transitionDuration%3A%20anObject%0D%0A%09%22%20Set%20the%20transitionDuration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27transitionDuration%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionTimingFunction","transitionTimingFunction"

,function (){var self=this;return (self['@handle'].transitionTimingFunction || (0));return self;}

,"accessing",unescape("transitionTimingFunction%0D%0A%09%22%20Return%20the%20transitionTimingFunction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transitionTimingFunction%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionTimingFunction:","transitionTimingFunction_"

,function (anObject){var self=this;(self.handle()["transitionTimingFunction"]=(anObject));return self;}

,"accessing",unescape("transitionTimingFunction%3A%20anObject%0D%0A%09%22%20Set%20the%20transitionTimingFunction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27transitionTimingFunction%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionDelay","transitionDelay"

,function (){var self=this;return (self['@handle'].transitionDelay || (0));return self;}

,"accessing",unescape("transitionDelay%0D%0A%09%22%20Return%20the%20transitionDelay%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transitionDelay%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionDelay:","transitionDelay_"

,function (anObject){var self=this;(self.handle()["transitionDelay"]=(anObject));return self;}

,"accessing",unescape("transitionDelay%3A%20anObject%0D%0A%09%22%20Set%20the%20transitionDelay%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27transitionDelay%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"verticalAlign","verticalAlign"

,function (){var self=this;return (self['@handle'].verticalAlign || (0));return self;}

,"accessing",unescape("verticalAlign%0D%0A%09%22%20Return%20the%20verticalAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23verticalAlign%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"verticalAlign:","verticalAlign_"

,function (anObject){var self=this;(self.handle()["verticalAlign"]=(anObject));return self;}

,"accessing",unescape("verticalAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20verticalAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27verticalAlign%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"visibility","visibility"

,function (){var self=this;return (self['@handle'].visibility || (0));return self;}

,"accessing",unescape("visibility%0D%0A%09%22%20Return%20the%20visibility%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23visibility%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"visibility:","visibility_"

,function (anObject){var self=this;(self.handle()["visibility"]=(anObject));return self;}

,"accessing",unescape("visibility%3A%20anObject%0D%0A%09%22%20Set%20the%20visibility%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27visibility%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"unicodeBidi","unicodeBidi"

,function (){var self=this;return (self['@handle'].unicodeBidi || (0));return self;}

,"accessing",unescape("unicodeBidi%0D%0A%09%22%20Return%20the%20unicodeBidi%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23unicodeBidi%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"unicodeBidi:","unicodeBidi_"

,function (anObject){var self=this;(self.handle()["unicodeBidi"]=(anObject));return self;}

,"accessing",unescape("unicodeBidi%3A%20anObject%0D%0A%09%22%20Set%20the%20unicodeBidi%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27unicodeBidi%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"whiteSpace","whiteSpace"

,function (){var self=this;return (self['@handle'].whiteSpace || (0));return self;}

,"accessing",unescape("whiteSpace%0D%0A%09%22%20Return%20the%20whiteSpace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23whiteSpace%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"whiteSpace:","whiteSpace_"

,function (anObject){var self=this;(self.handle()["whiteSpace"]=(anObject));return self;}

,"accessing",unescape("whiteSpace%3A%20anObject%0D%0A%09%22%20Set%20the%20whiteSpace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27whiteSpace%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"wordSpacing","wordSpacing"

,function (){var self=this;return (self['@handle'].wordSpacing || (0));return self;}

,"accessing",unescape("wordSpacing%0D%0A%09%22%20Return%20the%20wordSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23wordSpacing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"wordSpacing:","wordSpacing_"

,function (anObject){var self=this;(self.handle()["wordSpacing"]=(anObject));return self;}

,"accessing",unescape("wordSpacing%3A%20anObject%0D%0A%09%22%20Set%20the%20wordSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27wordSpacing%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"wordWrap","wordWrap"

,function (){var self=this;return (self['@handle'].wordWrap || (0));return self;}

,"accessing",unescape("wordWrap%0D%0A%09%22%20Return%20the%20wordWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23wordWrap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"wordWrap:","wordWrap_"

,function (anObject){var self=this;(self.handle()["wordWrap"]=(anObject));return self;}

,"accessing",unescape("wordWrap%3A%20anObject%0D%0A%09%22%20Set%20the%20wordWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27wordWrap%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"zIndex","zIndex"

,function (){var self=this;return (self['@handle'].zIndex || (0));return self;}

,"accessing",unescape("zIndex%0D%0A%09%22%20Return%20the%20zIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23zIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"zIndex:","zIndex_"

,function (anObject){var self=this;(self.handle()["zIndex"]=(anObject));return self;}

,"accessing",unescape("zIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20zIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27zIndex%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect.$klass,"tagName","tagName"

,function (){var self=this;return "SELECT";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27SELECT%27"));

smalltalk.bind(smalltalk.HTMLSelect,"size","size"

,function (){var self=this;return (self['@handle'].size || (0));return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLSelect,"size:","size_"

,function (anObject){var self=this;(self.handle()["size"]=(anObject));return self;}

,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27size%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"disabled","disabled"

,function (){var self=this;return (self.handle()["disabled"] || nil);return self;}

,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27disabled%27"));

smalltalk.bind(smalltalk.HTMLSelect,"disabled:","disabled_"

,function (anObject){var self=this;(self.handle()["disabled"]=(anObject));return self;}

,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27disabled%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"multiple","multiple"

,function (){var self=this;return (self.handle()["multiple"] || nil);return self;}

,"accessing",unescape("multiple%0D%0A%09%22%20Return%20the%20multiple%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27multiple%27"));

smalltalk.bind(smalltalk.HTMLSelect,"multiple:","multiple_"

,function (anObject){var self=this;(self.handle()["multiple"]=(anObject));return self;}

,"accessing",unescape("multiple%3A%20anObject%0D%0A%09%22%20Set%20the%20multiple%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27multiple%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLSelect,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"value","value"

,function (){var self=this;return (self.handle()["value"] || nil);return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27value%27"));

smalltalk.bind(smalltalk.HTMLSelect,"value:","value_"

,function (anObject){var self=this;(self.handle()["value"]=(anObject));return self;}

,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27value%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"length","length"

,function (){var self=this;return (self['@handle'].length || (0));return self;}

,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLSelect,"form","form"

,function (){var self=this;return (self.handle()["form"] || nil);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27form%27"));

smalltalk.bind(smalltalk.HTMLSelect,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLSelect,"selectedIndex","selectedIndex"

,function (){var self=this;return self['@handle'].selectedIndex;return self;}

,"accessing",unescape("selectedIndex%0D%0A%09%22%20Return%20the%20%28ZERO%20indexed%29%20selectedIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23selectedIndex"));

smalltalk.bind(smalltalk.HTMLSelect,"selectedIndex:","selectedIndex_"

,function (offset){var self=this;self['@handle'].selectedIndex=offset;return self;}

,"accessing",unescape("selectedIndex%3A%20offset%0D%0A%09%22%20Set%20the%20%28ZERO%20indexed%29%20selectedIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%23selectedIndex%20%3A%3D%20offset"));

smalltalk.bind(smalltalk.HTMLSelect,"options","options"

,function (){var self=this;return self.array_of_(self['@handle'].options, smalltalk.HTMLOption);return self;}

,"accessing",unescape("options%0D%0A%09%22%20Return%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23options%20of%3A%20HTMLOption"));

smalltalk.bind(smalltalk.HTMLSelect,"optionsDo:","optionsDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].options, smalltalk.HTMLOption, aBlock);return self;}

,"accessing",unescape("optionsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23options%20of%3A%20HTMLOption%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLSelect,"optionAt:","optionAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].options, smalltalk.HTMLOption, index);return self;}

,"accessing",unescape("optionAt%3A%20index%0D%0A%09%22%20Return%20the%20option%20of%20the%20receiver%20at%20index%20position%20%28ONE%20indexed%29.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23options%20of%3A%20HTMLOption%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLSelect,"selectedOption","selectedOption"

,function (){var self=this;var index=nil;index=self.selectedIndex();

return (((index >= (0))).mustBeBoolean()==true ? (function(){return self.optionAt_(index);})() : nil);return self;}

,"accessing",unescape("selectedOption%0D%0A%09%22%20Return%20the%20selected%20option%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self%20selectedIndex.%0D%0A%09%5Eindex%20%3E%3D%200%20ifTrue%3A%20%5B%20self%20optionAt%3A%20index%20%5D"));

smalltalk.bind(smalltalk.HTMLSelect,"add:before:","add_before_"

,function (anOption,another){var self=this;self['@handle'].add(anOption.handle(), another);return self;}

,"accessing",unescape("add%3A%20anOption%20before%3A%20another%0D%0A%09%22%20Add%20an%20option%20to%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20%23add%3A%20anOption%20handle%20before%3A%20another"));

smalltalk.bind(smalltalk.HTMLSelect,"add:","add_"

,function (anOption){var self=this;return self.addLast_(anOption);return self;}

,"accessing",unescape("add%3A%20anOption%0D%0A%09%22%20Add%20an%20option%20at%20end%20of%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20addLast%3A%20anOption"));

smalltalk.bind(smalltalk.HTMLSelect,"addItems:","addItems_"

,function (textsAndValues){var self=this;var options=nil;options=textsAndValues.collect_((function(tuple){return ((tuple.isArray()).mustBeBoolean()==true ? (function(){return smalltalk.HTMLOption.text_value_(tuple.first(), tuple.last());})() : (function(){return smalltalk.HTMLOption.text_value_(tuple, tuple);})());}));

options.do_((function(each){return self.add_(each);}));

return options;return self;}

,"accessing",unescape("addItems%3A%20textsAndValues%0D%0A%09%22%20Add%20options%20to%20the%20receiver%20from%20textsAndValues%20array.%0D%0A%09Return%20the%20added%20options.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20options%20%7C%0D%0A%09options%20%3A%3D%20textsAndValues%20collect%3A%20%5B%3Atuple%7C%0D%0A%09%09tuple%20isArray%0D%0A%09%09ifTrue%3A%20%5B%20HTMLOption%20text%3A%20tuple%20first%20value%3A%20tuple%20last%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20HTMLOption%20text%3A%20tuple%20value%3A%20tuple%20%5D%0D%0A%09%5D.%0D%0A%09options%20do%3A%20%5B%3Aeach%7C%20self%20add%3A%20each%20%5D.%0D%0A%09%5Eoptions"));

smalltalk.bind(smalltalk.HTMLSelect,"items:","items_"

,function (textsAndValues){var self=this;(function($rec){$rec.removeAll();return $rec.addItems_(textsAndValues);})(self);return self;}

,"accessing",unescape("items%3A%20textsAndValues%0D%0A%09%22%20Set%20the%20items%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20removeAll%3B%20addItems%3A%20textsAndValues"));

smalltalk.bind(smalltalk.HTMLSelect,"addItem:","addItem_"

,function (item){var self=this;return self.addItem_value_(item, item);return self;}

,"accessing",unescape("addItem%3A%20item%0D%0A%09%22%20Add%20option%20to%20the%20receiver%20%28at%20end%29.%20%22%0D%0A%0D%0A%09%5Eself%20addItem%3A%20item%20value%3A%20item"));

smalltalk.bind(smalltalk.HTMLSelect,"addItem:value:","addItem_value_"

,function (text,value){var self=this;return self.add_(smalltalk.HTMLOption.text_value_(text, value));return self;}

,"accessing",unescape("addItem%3A%20text%20value%3A%20value%0D%0A%09%22%20Add%20option%20to%20the%20receiver%20%28at%20end%29.%20%22%0D%0A%0D%0A%09%5Eself%20add%3A%20%28HTMLOption%20text%3A%20text%20value%3A%20value%29"));

smalltalk.bind(smalltalk.HTMLSelect,"addLast:","addLast_"

,function (anOption){var self=this;self['@handle'].add(anOption.handle());return self;}

,"accessing",unescape("addLast%3A%20anOption%0D%0A%09%22%20Add%20an%20option%20at%20end%20of%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20%23add%3A%20anOption%20handle"));

smalltalk.bind(smalltalk.HTMLSelect,"remove:","remove_"

,function (index){var self=this;self['@handle'].remove(index);return self;}

,"accessing",unescape("remove%3A%20index%0D%0A%09%22%20Remove%20option%20at%20index%20%28zero%20indexed%29%20from%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20%23remove%3A%20index"));

smalltalk.bind(smalltalk.HTMLSelect,"removeAll","removeAll"

,function (){var self=this;(function(){while((function(){return self.notEmpty();})()){(function(){return self.remove_((0));})()};return nil})();return self;}

,"accessing",unescape("removeAll%0D%0A%09%22%20Remove%20all%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Bself%20notEmpty%5D%20whileTrue%3A%20%5B%20self%20remove%3A%200%20%5D"));

smalltalk.bind(smalltalk.HTMLSelect,"isEmpty","isEmpty"

,function (){var self=this;try{self.optionsDo_((function(option){return (function(){throw({name: "stReturn", selector: "isEmpty", fn: function(){return false}})})();}));

(function(){throw({name: "stReturn", selector: "isEmpty", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "isEmpty"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("isEmpty%0D%0A%09%22%20Returns%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%09self%20optionsDo%3A%20%5B%3Aoption%7C%20%5Efalse%20%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.HTMLSelect,"notEmpty","notEmpty"

,function (){var self=this;return self.isEmpty().not();return self;}

,"accessing",unescape("notEmpty%0D%0A%09%22%20Returns%20true%20if%20the%20receiver%20has%20at%20least%20one%20option.%20%22%0D%0A%0D%0A%09%5Eself%20isEmpty%20not"));

smalltalk.bind(smalltalk.HTMLSelect,"removeIndex:","removeIndex_"

,function (index){var self=this;return self.remove_((index - (1)));return self;}

,"accessing",unescape("removeIndex%3A%20index%0D%0A%09%22%20Remove%20option%20at%20index%20%28ONE%20indexed%29%20from%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20remove%3A%20index%20-%201"));

smalltalk.bind(smalltalk.HTMLScript.$klass,"tagName","tagName"

,function (){var self=this;return "SCRIPT";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27SCRIPT%27"));

smalltalk.bind(smalltalk.HTMLScript,"charset","charset"

,function (){var self=this;return (self.handle()["charset"] || nil);return self;}

,"accessing",unescape("charset%0D%0A%09%22%20Return%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27charset%27"));

smalltalk.bind(smalltalk.HTMLScript,"charset:","charset_"

,function (anObject){var self=this;(self.handle()["charset"]=(anObject));return self;}

,"accessing",unescape("charset%3A%20anObject%0D%0A%09%22%20Set%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27charset%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"defer","defer"

,function (){var self=this;return (self.handle()["defer"] || nil);return self;}

,"accessing",unescape("defer%0D%0A%09%22%20Return%20the%20defer%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27defer%27"));

smalltalk.bind(smalltalk.HTMLScript,"defer:","defer_"

,function (anObject){var self=this;(self.handle()["defer"]=(anObject));return self;}

,"accessing",unescape("defer%3A%20anObject%0D%0A%09%22%20Set%20the%20defer%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27defer%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"event","event"

,function (){var self=this;return (self.handle()["event"] || nil);return self;}

,"accessing",unescape("event%0D%0A%09%22%20Return%20the%20event%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27event%27"));

smalltalk.bind(smalltalk.HTMLScript,"event:","event_"

,function (anObject){var self=this;(self.handle()["event"]=(anObject));return self;}

,"accessing",unescape("event%3A%20anObject%0D%0A%09%22%20Set%20the%20event%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27event%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"htmlFor","htmlFor"

,function (){var self=this;return (self.handle()["htmlFor"] || nil);return self;}

,"accessing",unescape("htmlFor%0D%0A%09%22%20Return%20the%20htmlFor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27htmlFor%27"));

smalltalk.bind(smalltalk.HTMLScript,"htmlFor:","htmlFor_"

,function (anObject){var self=this;(self.handle()["htmlFor"]=(anObject));return self;}

,"accessing",unescape("htmlFor%3A%20anObject%0D%0A%09%22%20Set%20the%20htmlFor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27htmlFor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"src","src"

,function (){var self=this;return (self.handle()["src"] || nil);return self;}

,"accessing",unescape("src%0D%0A%09%22%20Return%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27src%27"));

smalltalk.bind(smalltalk.HTMLScript,"src:","src_"

,function (anObject){var self=this;(self.handle()["src"]=(anObject));return self;}

,"accessing",unescape("src%3A%20anObject%0D%0A%09%22%20Set%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27src%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"text","text"

,function (){var self=this;return (self.handle()["text"] || nil);return self;}

,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27text%27"));

smalltalk.bind(smalltalk.HTMLScript,"text:","text_"

,function (anObject){var self=this;(self.handle()["text"]=(anObject));return self;}

,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27text%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLScript,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLQuote.$klass,"tagName","tagName"

,function (){var self=this;return "Q";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27Q%27"));

smalltalk.bind(smalltalk.HTMLQuote,"cite","cite"

,function (){var self=this;return (self.handle()["cite"] || nil);return self;}

,"accessing",unescape("cite%0D%0A%09%22%20Return%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27cite%27"));

smalltalk.bind(smalltalk.HTMLQuote,"cite:","cite_"

,function (anObject){var self=this;(self.handle()["cite"]=(anObject));return self;}

,"accessing",unescape("cite%3A%20anObject%0D%0A%09%22%20Set%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cite%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLPre.$klass,"tagName","tagName"

,function (){var self=this;return "PRE";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27PRE%27"));

smalltalk.bind(smalltalk.HTMLParam.$klass,"tagName","tagName"

,function (){var self=this;return "PARAM";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27PARAM%27"));

smalltalk.bind(smalltalk.HTMLParam,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLParam,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLParam,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLParam,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLParam,"value","value"

,function (){var self=this;return (self.handle()["value"] || nil);return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27value%27"));

smalltalk.bind(smalltalk.HTMLParam,"value:","value_"

,function (anObject){var self=this;(self.handle()["value"]=(anObject));return self;}

,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27value%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLParam,"valueType","valueType"

,function (){var self=this;return (self.handle()["valueType"] || nil);return self;}

,"accessing",unescape("valueType%0D%0A%09%22%20Return%20the%20valueType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27valueType%27"));

smalltalk.bind(smalltalk.HTMLParam,"valueType:","valueType_"

,function (anObject){var self=this;(self.handle()["valueType"]=(anObject));return self;}

,"accessing",unescape("valueType%3A%20anObject%0D%0A%09%22%20Set%20the%20valueType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27valueType%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLParagraph.$klass,"tagName","tagName"

,function (){var self=this;return "P";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27P%27"));

smalltalk.bind(smalltalk.HTMLParagraph,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLParagraph,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption.$klass,"tagName","tagName"

,function (){var self=this;return "OPTION";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27OPTION%27"));

smalltalk.bind(smalltalk.HTMLOption.$klass,"text:value:","text_value_"

,function (text,value){var self=this;return self.$$new().text_value_(text, value);return self;}

,unescape("instance%20creation"),unescape("text%3A%20text%20value%3A%20value%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%20text%3A%20text%20value%3A%20value%20"));

smalltalk.bind(smalltalk.HTMLOption,"disabled","disabled"

,function (){var self=this;return (self.handle()["disabled"] || nil);return self;}

,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27disabled%27"));

smalltalk.bind(smalltalk.HTMLOption,"disabled:","disabled_"

,function (anObject){var self=this;(self.handle()["disabled"]=(anObject));return self;}

,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27disabled%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"label","label"

,function (){var self=this;return (self.handle()["label"] || nil);return self;}

,"accessing",unescape("label%0D%0A%09%22%20Return%20the%20label%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27label%27"));

smalltalk.bind(smalltalk.HTMLOption,"label:","label_"

,function (anObject){var self=this;(self.handle()["label"]=(anObject));return self;}

,"accessing",unescape("label%3A%20anObject%0D%0A%09%22%20Set%20the%20label%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27label%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"onsubmit","onsubmit"

,function (){var self=this;return (self.handle()["onsubmit"] || nil);return self;}

,"accessing",unescape("onsubmit%0D%0A%09%22%20Return%20the%20onsubmit%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onsubmit%27"));

smalltalk.bind(smalltalk.HTMLOption,"onsubmit:","onsubmit_"

,function (anObject){var self=this;(self.handle()["onsubmit"]=(anObject));return self;}

,"accessing",unescape("onsubmit%3A%20anObject%0D%0A%09%22%20Set%20the%20onsubmit%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onsubmit%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"selected","selected"

,function (){var self=this;return (self.handle()["selected"] || nil);return self;}

,"accessing",unescape("selected%0D%0A%09%22%20Return%20the%20selected%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27selected%27"));

smalltalk.bind(smalltalk.HTMLOption,"selected:","selected_"

,function (anObject){var self=this;(self.handle()["selected"]=(anObject));return self;}

,"accessing",unescape("selected%3A%20anObject%0D%0A%09%22%20Set%20the%20selected%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27selected%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"text","text"

,function (){var self=this;return (self.handle()["text"] || nil);return self;}

,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27text%27"));

smalltalk.bind(smalltalk.HTMLOption,"text:","text_"

,function (anObject){var self=this;(self.handle()["text"]=(anObject));return self;}

,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27text%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"value","value"

,function (){var self=this;return (self.handle()["value"] || nil);return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27value%27"));

smalltalk.bind(smalltalk.HTMLOption,"value:","value_"

,function (anObject){var self=this;(self.handle()["value"]=(anObject));return self;}

,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27value%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"index","index"

,function (){var self=this;return (self['@handle'].index || (0));return self;}

,"accessing",unescape("index%0D%0A%09%22%20Return%20the%20index%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23index%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLOption,"index:","index_"

,function (anObject){var self=this;(self.handle()["index"]=(anObject));return self;}

,"accessing",unescape("index%3A%20anObject%0D%0A%09%22%20Set%20the%20index%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27index%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"defaultSelected","defaultSelected"

,function (){var self=this;return (self.handle()["defaultSelected"] || nil);return self;}

,"accessing",unescape("defaultSelected%0D%0A%09%22%20Return%20the%20defaultSelected%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27defaultSelected%27"));

smalltalk.bind(smalltalk.HTMLOption,"form","form"

,function (){var self=this;return (self.handle()["form"] || nil);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27form%27"));

smalltalk.bind(smalltalk.HTMLOption,"text:value:","text_value_"

,function (text,value){var self=this;self.handle();

(function($rec){$rec.text_(text);return $rec.value_(value);})(self);return self;}

,"accessing",unescape("text%3A%20text%20value%3A%20value%0D%0A%09%22%20Set%20the%20receiver%27s%20text%20and%20value.%20%22%0D%0A%0D%0A%09self%20handle.%20%22ensure%20valid%20handle%22%0D%0A%09self%20text%3A%20text%3B%20value%3A%20value."));

smalltalk.bind(smalltalk.HTMLOption,"initializeHandle","initializeHandle"

,function (){var self=this;self['@handle']= new Option(); ;return self;}

,"initialize",unescape("initializeHandle%0D%0A%09%22%20Private%20-%20Initialize%20the%20native%20handle.%20%22%0D%0A%0D%0A%09handle%20%3A%3D%20%7B%27%20new%20Option%28%29%3B%20%27%7D."));

smalltalk.bind(smalltalk.HTMLOptGroup.$klass,"tagName","tagName"

,function (){var self=this;return "OPTGROUP";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27OPTGROUP%27"));

smalltalk.bind(smalltalk.HTMLOptGroup,"disabled","disabled"

,function (){var self=this;return (self.handle()["disabled"] || nil);return self;}

,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27disabled%27"));

smalltalk.bind(smalltalk.HTMLOptGroup,"disabled:","disabled_"

,function (anObject){var self=this;(self.handle()["disabled"]=(anObject));return self;}

,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27disabled%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOptGroup,"label","label"

,function (){var self=this;return (self.handle()["label"] || nil);return self;}

,"accessing",unescape("label%0D%0A%09%22%20Return%20the%20label%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27label%27"));

smalltalk.bind(smalltalk.HTMLOptGroup,"label:","label_"

,function (anObject){var self=this;(self.handle()["label"]=(anObject));return self;}

,"accessing",unescape("label%3A%20anObject%0D%0A%09%22%20Set%20the%20label%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27label%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOList.$klass,"tagName","tagName"

,function (){var self=this;return "OL";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27OL%27"));

smalltalk.bind(smalltalk.HTMLOList,"compact","compact"

,function (){var self=this;return (self.handle()["compact"] || nil);return self;}

,"accessing",unescape("compact%0D%0A%09%22%20Return%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27compact%27"));

smalltalk.bind(smalltalk.HTMLOList,"compact:","compact_"

,function (anObject){var self=this;(self.handle()["compact"]=(anObject));return self;}

,"accessing",unescape("compact%3A%20anObject%0D%0A%09%22%20Set%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27compact%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOList,"start","start"

,function (){var self=this;return (self.handle()["start"] || nil);return self;}

,"accessing",unescape("start%0D%0A%09%22%20Return%20the%20start%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27start%27"));

smalltalk.bind(smalltalk.HTMLOList,"start:","start_"

,function (anObject){var self=this;(self.handle()["start"]=(anObject));return self;}

,"accessing",unescape("start%3A%20anObject%0D%0A%09%22%20Set%20the%20start%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27start%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOList,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLOList,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject.$klass,"tagName","tagName"

,function (){var self=this;return "OBJECT";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27OBJECT%27"));

smalltalk.bind(smalltalk.HTMLObject,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLObject,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"archive","archive"

,function (){var self=this;return (self.handle()["archive"] || nil);return self;}

,"accessing",unescape("archive%0D%0A%09%22%20Return%20the%20archive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27archive%27"));

smalltalk.bind(smalltalk.HTMLObject,"archive:","archive_"

,function (anObject){var self=this;(self.handle()["archive"]=(anObject));return self;}

,"accessing",unescape("archive%3A%20anObject%0D%0A%09%22%20Set%20the%20archive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27archive%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"code","code"

,function (){var self=this;return (self.handle()["code"] || nil);return self;}

,"accessing",unescape("code%0D%0A%09%22%20Return%20the%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27code%27"));

smalltalk.bind(smalltalk.HTMLObject,"code:","code_"

,function (anObject){var self=this;(self.handle()["code"]=(anObject));return self;}

,"accessing",unescape("code%3A%20anObject%0D%0A%09%22%20Set%20the%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27code%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"codeBase","codeBase"

,function (){var self=this;return (self.handle()["codeBase"] || nil);return self;}

,"accessing",unescape("codeBase%0D%0A%09%22%20Return%20the%20codeBase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27codeBase%27"));

smalltalk.bind(smalltalk.HTMLObject,"codeBase:","codeBase_"

,function (anObject){var self=this;(self.handle()["codeBase"]=(anObject));return self;}

,"accessing",unescape("codeBase%3A%20anObject%0D%0A%09%22%20Set%20the%20codeBase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27codeBase%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"codeType","codeType"

,function (){var self=this;return (self.handle()["codeType"] || nil);return self;}

,"accessing",unescape("codeType%0D%0A%09%22%20Return%20the%20codeType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27codeType%27"));

smalltalk.bind(smalltalk.HTMLObject,"codeType:","codeType_"

,function (anObject){var self=this;(self.handle()["codeType"]=(anObject));return self;}

,"accessing",unescape("codeType%3A%20anObject%0D%0A%09%22%20Set%20the%20codeType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27codeType%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"data","data"

,function (){var self=this;return (self.handle()["data"] || nil);return self;}

,"accessing",unescape("data%0D%0A%09%22%20Return%20the%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27data%27"));

smalltalk.bind(smalltalk.HTMLObject,"data:","data_"

,function (anObject){var self=this;(self.handle()["data"]=(anObject));return self;}

,"accessing",unescape("data%3A%20anObject%0D%0A%09%22%20Set%20the%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27data%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"declare","declare"

,function (){var self=this;return (self.handle()["declare"] || nil);return self;}

,"accessing",unescape("declare%0D%0A%09%22%20Return%20the%20declare%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27declare%27"));

smalltalk.bind(smalltalk.HTMLObject,"declare:","declare_"

,function (anObject){var self=this;(self.handle()["declare"]=(anObject));return self;}

,"accessing",unescape("declare%3A%20anObject%0D%0A%09%22%20Set%20the%20declare%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27declare%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLObject,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"standby","standby"

,function (){var self=this;return (self.handle()["standby"] || nil);return self;}

,"accessing",unescape("standby%0D%0A%09%22%20Return%20the%20standby%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27standby%27"));

smalltalk.bind(smalltalk.HTMLObject,"standby:","standby_"

,function (anObject){var self=this;(self.handle()["standby"]=(anObject));return self;}

,"accessing",unescape("standby%3A%20anObject%0D%0A%09%22%20Set%20the%20standby%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27standby%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLObject,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"useMap","useMap"

,function (){var self=this;return (self.handle()["useMap"] || nil);return self;}

,"accessing",unescape("useMap%0D%0A%09%22%20Return%20the%20useMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27useMap%27"));

smalltalk.bind(smalltalk.HTMLObject,"useMap:","useMap_"

,function (anObject){var self=this;(self.handle()["useMap"]=(anObject));return self;}

,"accessing",unescape("useMap%3A%20anObject%0D%0A%09%22%20Set%20the%20useMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27useMap%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"border","border"

,function (){var self=this;return (self['@handle'].border || (0));return self;}

,"accessing",unescape("border%0D%0A%09%22%20Return%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23border%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLObject,"border:","border_"

,function (anObject){var self=this;(self.handle()["border"]=(anObject));return self;}

,"accessing",unescape("border%3A%20anObject%0D%0A%09%22%20Set%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27border%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"hspace","hspace"

,function (){var self=this;return (self['@handle'].hspace || (0));return self;}

,"accessing",unescape("hspace%0D%0A%09%22%20Return%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23hspace%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLObject,"hspace:","hspace_"

,function (anObject){var self=this;(self.handle()["hspace"]=(anObject));return self;}

,"accessing",unescape("hspace%3A%20anObject%0D%0A%09%22%20Set%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hspace%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"vspace","vspace"

,function (){var self=this;return (self['@handle'].vspace || (0));return self;}

,"accessing",unescape("vspace%0D%0A%09%22%20Return%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23vspace%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLObject,"vspace:","vspace_"

,function (anObject){var self=this;(self.handle()["vspace"]=(anObject));return self;}

,"accessing",unescape("vspace%3A%20anObject%0D%0A%09%22%20Set%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27vspace%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"form","form"

,function (){var self=this;return (self.handle()["form"] || nil);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27form%27"));

smalltalk.bind(smalltalk.HTMLObject,"extent","extent"

,function (){var self=this;return self.width()._at(self.height());return self;}

,"accessing",unescape("extent%0D%0A%09%22%20Returns%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.HTMLObject,"extent:","extent_"

,function (aPoint){var self=this;(function($rec){$rec.width_(aPoint.x());return $rec.height_(aPoint.y());})(self);return self;}

,"accessing",unescape("extent%3A%20aPoint%0D%0A%09%22%20Set%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20width%3A%20aPoint%20x%3B%20height%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLObject,"spaceExtent","spaceExtent"

,function (){var self=this;return self.hspace()._at(self.vspace());return self;}

,"accessing",unescape("spaceExtent%0D%0A%09%22%20Returns%20the%20space%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20hspace%20@%20self%20vspace"));

smalltalk.bind(smalltalk.HTMLObject,"spaceExtent:","spaceExtent_"

,function (aPoint){var self=this;(function($rec){$rec.hspace_(aPoint.x());return $rec.vspace_(aPoint.y());})(self);return self;}

,"accessing",unescape("spaceExtent%3A%20aPoint%0D%0A%09%22%20Set%20the%20space%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20hspace%3A%20aPoint%20x%3B%20vspace%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLMod.$klass,"tagName","tagName"

,function (){var self=this;return nil;return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.HTMLMod.$klass,"canHandle:tagged:","canHandle_tagged_"

,function (handle,tagName){var self=this;return ["DEL", "INS"].includes_(tagName);return self;}

,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5E%23%28%20%23DEL%20%23INS%20%29%20includes%3A%20tagName"));

smalltalk.bind(smalltalk.HTMLMod,"cite","cite"

,function (){var self=this;return (self.handle()["cite"] || nil);return self;}

,"accessing",unescape("cite%0D%0A%09%22%20Return%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27cite%27"));

smalltalk.bind(smalltalk.HTMLMod,"cite:","cite_"

,function (anObject){var self=this;(self.handle()["cite"]=(anObject));return self;}

,"accessing",unescape("cite%3A%20anObject%0D%0A%09%22%20Set%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cite%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMod,"dateTime","dateTime"

,function (){var self=this;return (self.handle()["dateTime"] || nil);return self;}

,"accessing",unescape("dateTime%0D%0A%09%22%20Return%20the%20dateTime%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27dateTime%27"));

smalltalk.bind(smalltalk.HTMLMod,"dateTime:","dateTime_"

,function (anObject){var self=this;(self.handle()["dateTime"]=(anObject));return self;}

,"accessing",unescape("dateTime%3A%20anObject%0D%0A%09%22%20Set%20the%20dateTime%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27dateTime%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMeta.$klass,"tagName","tagName"

,function (){var self=this;return "META";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27META%27"));

smalltalk.bind(smalltalk.HTMLMeta,"content","content"

,function (){var self=this;return (self.handle()["content"] || nil);return self;}

,"accessing",unescape("content%0D%0A%09%22%20Return%20the%20content%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27content%27"));

smalltalk.bind(smalltalk.HTMLMeta,"content:","content_"

,function (anObject){var self=this;(self.handle()["content"]=(anObject));return self;}

,"accessing",unescape("content%3A%20anObject%0D%0A%09%22%20Set%20the%20content%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27content%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMeta,"httpEquiv","httpEquiv"

,function (){var self=this;return (self.handle()["httpEquiv"] || nil);return self;}

,"accessing",unescape("httpEquiv%0D%0A%09%22%20Return%20the%20httpEquiv%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27httpEquiv%27"));

smalltalk.bind(smalltalk.HTMLMeta,"httpEquiv:","httpEquiv_"

,function (anObject){var self=this;(self.handle()["httpEquiv"]=(anObject));return self;}

,"accessing",unescape("httpEquiv%3A%20anObject%0D%0A%09%22%20Set%20the%20httpEquiv%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27httpEquiv%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMeta,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLMeta,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMeta,"scheme","scheme"

,function (){var self=this;return (self.handle()["scheme"] || nil);return self;}

,"accessing",unescape("scheme%0D%0A%09%22%20Return%20the%20scheme%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27scheme%27"));

smalltalk.bind(smalltalk.HTMLMeta,"scheme:","scheme_"

,function (anObject){var self=this;(self.handle()["scheme"]=(anObject));return self;}

,"accessing",unescape("scheme%3A%20anObject%0D%0A%09%22%20Set%20the%20scheme%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27scheme%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMenu.$klass,"tagName","tagName"

,function (){var self=this;return "MENU";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27MENU%27"));

smalltalk.bind(smalltalk.HTMLMenu,"compact","compact"

,function (){var self=this;return (self.handle()["compact"] || nil);return self;}

,"accessing",unescape("compact%0D%0A%09%22%20Return%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27compact%27"));

smalltalk.bind(smalltalk.HTMLMenu,"compact:","compact_"

,function (anObject){var self=this;(self.handle()["compact"]=(anObject));return self;}

,"accessing",unescape("compact%3A%20anObject%0D%0A%09%22%20Set%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27compact%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMap.$klass,"tagName","tagName"

,function (){var self=this;return "MAP";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27MAP%27"));

smalltalk.bind(smalltalk.HTMLMap,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLMap,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMap,"areas","areas"

,function (){var self=this;return (self.handle()["areas"] || nil);return self;}

,"accessing",unescape("areas%0D%0A%09%22%20Return%20the%20areas%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27areas%27"));

smalltalk.bind(smalltalk.HTMLLink.$klass,"tagName","tagName"

,function (){var self=this;return "LINK";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LINK%27"));

smalltalk.bind(smalltalk.HTMLLink,"charset","charset"

,function (){var self=this;return (self.handle()["charset"] || nil);return self;}

,"accessing",unescape("charset%0D%0A%09%22%20Return%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27charset%27"));

smalltalk.bind(smalltalk.HTMLLink,"charset:","charset_"

,function (anObject){var self=this;(self.handle()["charset"]=(anObject));return self;}

,"accessing",unescape("charset%3A%20anObject%0D%0A%09%22%20Set%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27charset%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"disabled","disabled"

,function (){var self=this;return (self.handle()["disabled"] || nil);return self;}

,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27disabled%27"));

smalltalk.bind(smalltalk.HTMLLink,"disabled:","disabled_"

,function (anObject){var self=this;(self.handle()["disabled"]=(anObject));return self;}

,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27disabled%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"href","href"

,function (){var self=this;return (self.handle()["href"] || nil);return self;}

,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27href%27"));

smalltalk.bind(smalltalk.HTMLLink,"href:","href_"

,function (anObject){var self=this;(self.handle()["href"]=(anObject));return self;}

,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27href%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"hreflang","hreflang"

,function (){var self=this;return (self.handle()["hreflang"] || nil);return self;}

,"accessing",unescape("hreflang%0D%0A%09%22%20Return%20the%20hreflang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hreflang%27"));

smalltalk.bind(smalltalk.HTMLLink,"hreflang:","hreflang_"

,function (anObject){var self=this;(self.handle()["hreflang"]=(anObject));return self;}

,"accessing",unescape("hreflang%3A%20anObject%0D%0A%09%22%20Set%20the%20hreflang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hreflang%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"media","media"

,function (){var self=this;return (self.handle()["media"] || nil);return self;}

,"accessing",unescape("media%0D%0A%09%22%20Return%20the%20media%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27media%27"));

smalltalk.bind(smalltalk.HTMLLink,"media:","media_"

,function (anObject){var self=this;(self.handle()["media"]=(anObject));return self;}

,"accessing",unescape("media%3A%20anObject%0D%0A%09%22%20Set%20the%20media%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27media%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"rel","rel"

,function (){var self=this;return (self.handle()["rel"] || nil);return self;}

,"accessing",unescape("rel%0D%0A%09%22%20Return%20the%20rel%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27rel%27"));

smalltalk.bind(smalltalk.HTMLLink,"rel:","rel_"

,function (anObject){var self=this;(self.handle()["rel"]=(anObject));return self;}

,"accessing",unescape("rel%3A%20anObject%0D%0A%09%22%20Set%20the%20rel%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rel%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"rev","rev"

,function (){var self=this;return (self.handle()["rev"] || nil);return self;}

,"accessing",unescape("rev%0D%0A%09%22%20Return%20the%20rev%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27rev%27"));

smalltalk.bind(smalltalk.HTMLLink,"rev:","rev_"

,function (anObject){var self=this;(self.handle()["rev"]=(anObject));return self;}

,"accessing",unescape("rev%3A%20anObject%0D%0A%09%22%20Set%20the%20rev%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rev%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"target","target"

,function (){var self=this;return (self.handle()["target"] || nil);return self;}

,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27target%27"));

smalltalk.bind(smalltalk.HTMLLink,"target:","target_"

,function (anObject){var self=this;(self.handle()["target"]=(anObject));return self;}

,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27target%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLLink,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLI.$klass,"tagName","tagName"

,function (){var self=this;return "LI";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LI%27"));

smalltalk.bind(smalltalk.HTMLLI,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLLI,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLI,"value","value"

,function (){var self=this;return (self.handle()["value"] || nil);return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27value%27"));

smalltalk.bind(smalltalk.HTMLLI,"value:","value_"

,function (anObject){var self=this;(self.handle()["value"]=(anObject));return self;}

,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27value%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLegend.$klass,"tagName","tagName"

,function (){var self=this;return "LEGEND";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LEGEND%27"));

smalltalk.bind(smalltalk.HTMLLegend,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLLegend,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLegend,"form","form"

,function (){var self=this;return (self.handle()["form"] || nil);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27form%27"));

smalltalk.bind(smalltalk.HTMLILayer.$klass,"tagName","tagName"

,function (){var self=this;return "ILAYER";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27ILAYER%27"));

smalltalk.bind(smalltalk.HTMLILayer,"bgColor","bgColor"

,function (){var self=this;return (self.handle()["bgColor"] || nil);return self;}

,"accessing",unescape("bgColor%0D%0A%09%22%20Return%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27bgColor%27"));

smalltalk.bind(smalltalk.HTMLILayer,"bgColor:","bgColor_"

,function (anObject){var self=this;(self.handle()["bgColor"]=(anObject));return self;}

,"accessing",unescape("bgColor%3A%20anObject%0D%0A%09%22%20Set%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27bgColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLayer.$klass,"tagName","tagName"

,function (){var self=this;return "LAYER";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LAYER%27"));

smalltalk.bind(smalltalk.HTMLLayer,"bgColor","bgColor"

,function (){var self=this;return (self.handle()["bgColor"] || nil);return self;}

,"accessing",unescape("bgColor%0D%0A%09%22%20Return%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27bgColor%27"));

smalltalk.bind(smalltalk.HTMLLayer,"bgColor:","bgColor_"

,function (anObject){var self=this;(self.handle()["bgColor"]=(anObject));return self;}

,"accessing",unescape("bgColor%3A%20anObject%0D%0A%09%22%20Set%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27bgColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLabel.$klass,"tagName","tagName"

,function (){var self=this;return "LABEL";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LABEL%27"));

smalltalk.bind(smalltalk.HTMLLabel,"htmlFor","htmlFor"

,function (){var self=this;return (self.handle()["htmlFor"] || nil);return self;}

,"accessing",unescape("htmlFor%0D%0A%09%22%20Return%20the%20htmlFor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27htmlFor%27"));

smalltalk.bind(smalltalk.HTMLLabel,"htmlFor:","htmlFor_"

,function (anObject){var self=this;(self.handle()["htmlFor"]=(anObject));return self;}

,"accessing",unescape("htmlFor%3A%20anObject%0D%0A%09%22%20Set%20the%20htmlFor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27htmlFor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLabel,"form","form"

,function (){var self=this;return (self.handle()["form"] || nil);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27form%27"));

smalltalk.bind(smalltalk.HTMLIsIndex.$klass,"tagName","tagName"

,function (){var self=this;return "ISINDEX";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27ISINDEX%27"));

smalltalk.bind(smalltalk.HTMLIsIndex,"prompt","prompt"

,function (){var self=this;return (self.handle()["prompt"] || nil);return self;}

,"accessing",unescape("prompt%0D%0A%09%22%20Return%20the%20prompt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27prompt%27"));

smalltalk.bind(smalltalk.HTMLIsIndex,"prompt:","prompt_"

,function (anObject){var self=this;(self.handle()["prompt"]=(anObject));return self;}

,"accessing",unescape("prompt%3A%20anObject%0D%0A%09%22%20Set%20the%20prompt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27prompt%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIsIndex,"form","form"

,function (){var self=this;return (self.handle()["form"] || nil);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27form%27"));

smalltalk.bind(smalltalk.HTMLInput.$klass,"tagName","tagName"

,function (){var self=this;return "INPUT";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27INPUT%27"));

smalltalk.bind(smalltalk.HTMLInput,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLInput,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInput,"value","value"

,function (){var self=this;return (self.handle()["value"] || nil);return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27value%27"));

smalltalk.bind(smalltalk.HTMLInput,"value:","value_"

,function (anObject){var self=this;(self.handle()["value"]=(anObject));return self;}

,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27value%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInput,"form","form"

,function (){var self=this;return (self.handle()["form"] || nil);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27form%27"));

smalltalk.bind(smalltalk.HTMLInput,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLImage.$klass,"tagName","tagName"

,function (){var self=this;return "IMG";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27IMG%27"));

smalltalk.bind(smalltalk.HTMLImage,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLImage,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"alt","alt"

,function (){var self=this;return (self.handle()["alt"] || nil);return self;}

,"accessing",unescape("alt%0D%0A%09%22%20Return%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27alt%27"));

smalltalk.bind(smalltalk.HTMLImage,"alt:","alt_"

,function (anObject){var self=this;(self.handle()["alt"]=(anObject));return self;}

,"accessing",unescape("alt%3A%20anObject%0D%0A%09%22%20Set%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27alt%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"border","border"

,function (){var self=this;return (self.handle()["border"] || nil);return self;}

,"accessing",unescape("border%0D%0A%09%22%20Return%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27border%27"));

smalltalk.bind(smalltalk.HTMLImage,"border:","border_"

,function (anObject){var self=this;(self.handle()["border"]=(anObject));return self;}

,"accessing",unescape("border%3A%20anObject%0D%0A%09%22%20Set%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27border%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"complete","complete"

,function (){var self=this;return (self.handle()["complete"] || nil);return self;}

,"accessing",unescape("complete%0D%0A%09%22%20Return%20the%20complete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27complete%27"));

smalltalk.bind(smalltalk.HTMLImage,"complete:","complete_"

,function (anObject){var self=this;(self.handle()["complete"]=(anObject));return self;}

,"accessing",unescape("complete%3A%20anObject%0D%0A%09%22%20Set%20the%20complete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27complete%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"hspace","hspace"

,function (){var self=this;return (self.handle()["hspace"] || nil);return self;}

,"accessing",unescape("hspace%0D%0A%09%22%20Return%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hspace%27"));

smalltalk.bind(smalltalk.HTMLImage,"hspace:","hspace_"

,function (anObject){var self=this;(self.handle()["hspace"]=(anObject));return self;}

,"accessing",unescape("hspace%3A%20anObject%0D%0A%09%22%20Set%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hspace%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"isMap","isMap"

,function (){var self=this;return (self.handle()["isMap"] || nil);return self;}

,"accessing",unescape("isMap%0D%0A%09%22%20Return%20the%20isMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27isMap%27"));

smalltalk.bind(smalltalk.HTMLImage,"isMap:","isMap_"

,function (anObject){var self=this;(self.handle()["isMap"]=(anObject));return self;}

,"accessing",unescape("isMap%3A%20anObject%0D%0A%09%22%20Set%20the%20isMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27isMap%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"longDesc","longDesc"

,function (){var self=this;return (self.handle()["longDesc"] || nil);return self;}

,"accessing",unescape("longDesc%0D%0A%09%22%20Return%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27longDesc%27"));

smalltalk.bind(smalltalk.HTMLImage,"longDesc:","longDesc_"

,function (anObject){var self=this;(self.handle()["longDesc"]=(anObject));return self;}

,"accessing",unescape("longDesc%3A%20anObject%0D%0A%09%22%20Set%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27longDesc%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"lowscr","lowscr"

,function (){var self=this;return (self.handle()["lowscr"] || nil);return self;}

,"accessing",unescape("lowscr%0D%0A%09%22%20Return%20the%20lowscr%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27lowscr%27"));

smalltalk.bind(smalltalk.HTMLImage,"lowscr:","lowscr_"

,function (anObject){var self=this;(self.handle()["lowscr"]=(anObject));return self;}

,"accessing",unescape("lowscr%3A%20anObject%0D%0A%09%22%20Set%20the%20lowscr%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27lowscr%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLImage,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"src","src"

,function (){var self=this;return (self.handle()["src"] || nil);return self;}

,"accessing",unescape("src%0D%0A%09%22%20Return%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27src%27"));

smalltalk.bind(smalltalk.HTMLImage,"src:","src_"

,function (anObject){var self=this;(self.handle()["src"]=(anObject));return self;}

,"accessing",unescape("src%3A%20anObject%0D%0A%09%22%20Set%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27src%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"useMap","useMap"

,function (){var self=this;return (self.handle()["useMap"] || nil);return self;}

,"accessing",unescape("useMap%0D%0A%09%22%20Return%20the%20useMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27useMap%27"));

smalltalk.bind(smalltalk.HTMLImage,"useMap:","useMap_"

,function (anObject){var self=this;(self.handle()["useMap"]=(anObject));return self;}

,"accessing",unescape("useMap%3A%20anObject%0D%0A%09%22%20Set%20the%20useMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27useMap%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"vspace","vspace"

,function (){var self=this;return (self.handle()["vspace"] || nil);return self;}

,"accessing",unescape("vspace%0D%0A%09%22%20Return%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27vspace%27"));

smalltalk.bind(smalltalk.HTMLImage,"vspace:","vspace_"

,function (anObject){var self=this;(self.handle()["vspace"]=(anObject));return self;}

,"accessing",unescape("vspace%3A%20anObject%0D%0A%09%22%20Set%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27vspace%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"extent","extent"

,function (){var self=this;return self.width()._at(self.height());return self;}

,"accessing",unescape("extent%0D%0A%09%22%20Returns%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.HTMLImage,"extent:","extent_"

,function (aPoint){var self=this;(function($rec){$rec.width_(aPoint.x());return $rec.height_(aPoint.y());})(self);return self;}

,"accessing",unescape("extent%3A%20aPoint%0D%0A%09%22%20Set%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20width%3A%20aPoint%20x%3B%20height%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLImage,"spaceExtent","spaceExtent"

,function (){var self=this;return self.hspace()._at(self.vspace());return self;}

,"accessing",unescape("spaceExtent%0D%0A%09%22%20Returns%20the%20space%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20hspace%20@%20self%20vspace"));

smalltalk.bind(smalltalk.HTMLImage,"spaceExtent:","spaceExtent_"

,function (aPoint){var self=this;(function($rec){$rec.hspace_(aPoint.x());return $rec.vspace_(aPoint.y());})(self);return self;}

,"accessing",unescape("spaceExtent%3A%20aPoint%0D%0A%09%22%20Set%20the%20space%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20hspace%3A%20aPoint%20x%3B%20vspace%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLIFrame.$klass,"tagName","tagName"

,function (){var self=this;return "IFRAME";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27IFRAME%27"));

smalltalk.bind(smalltalk.HTMLIFrame,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLIFrame,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"frameBorder","frameBorder"

,function (){var self=this;return (self.handle()["frameBorder"] || nil);return self;}

,"accessing",unescape("frameBorder%0D%0A%09%22%20Return%20the%20frameBorder%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27frameBorder%27"));

smalltalk.bind(smalltalk.HTMLIFrame,"frameBorder:","frameBorder_"

,function (anObject){var self=this;(self.handle()["frameBorder"]=(anObject));return self;}

,"accessing",unescape("frameBorder%3A%20anObject%0D%0A%09%22%20Set%20the%20frameBorder%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27frameBorder%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"longDesc","longDesc"

,function (){var self=this;return (self.handle()["longDesc"] || nil);return self;}

,"accessing",unescape("longDesc%0D%0A%09%22%20Return%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27longDesc%27"));

smalltalk.bind(smalltalk.HTMLIFrame,"longDesc:","longDesc_"

,function (anObject){var self=this;(self.handle()["longDesc"]=(anObject));return self;}

,"accessing",unescape("longDesc%3A%20anObject%0D%0A%09%22%20Set%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27longDesc%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLIFrame,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"scrolling","scrolling"

,function (){var self=this;return (self.handle()["scrolling"] || nil);return self;}

,"accessing",unescape("scrolling%0D%0A%09%22%20Return%20the%20scrolling%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27scrolling%27"));

smalltalk.bind(smalltalk.HTMLIFrame,"scrolling:","scrolling_"

,function (anObject){var self=this;(self.handle()["scrolling"]=(anObject));return self;}

,"accessing",unescape("scrolling%3A%20anObject%0D%0A%09%22%20Set%20the%20scrolling%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27scrolling%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"src","src"

,function (){var self=this;return (self.handle()["src"] || nil);return self;}

,"accessing",unescape("src%0D%0A%09%22%20Return%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27src%27"));

smalltalk.bind(smalltalk.HTMLIFrame,"src:","src_"

,function (anObject){var self=this;(self.handle()["src"]=(anObject));return self;}

,"accessing",unescape("src%3A%20anObject%0D%0A%09%22%20Set%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27src%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"marginHeight","marginHeight"

,function (){var self=this;return (self['@handle'].marginHeight || (0));return self;}

,"accessing",unescape("marginHeight%0D%0A%09%22%20Return%20the%20marginHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLIFrame,"marginHeight:","marginHeight_"

,function (anObject){var self=this;(self.handle()["marginHeight"]=(anObject));return self;}

,"accessing",unescape("marginHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20marginHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27marginHeight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"marginWidth","marginWidth"

,function (){var self=this;return (self['@handle'].marginWidth || (0));return self;}

,"accessing",unescape("marginWidth%0D%0A%09%22%20Return%20the%20marginWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLIFrame,"marginWidth:","marginWidth_"

,function (anObject){var self=this;(self.handle()["marginWidth"]=(anObject));return self;}

,"accessing",unescape("marginWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20marginWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27marginWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"contentDocument","contentDocument"

,function (){var self=this;return smalltalk.HTMLDocument._at(self['@handle'].contentDocument);return self;}

,"accessing",unescape("contentDocument%0D%0A%0D%0A%09%5EHTMLDocument%20@%20handle%23contentDocument"));

smalltalk.bind(smalltalk.HTMLPage.$klass,"tagName","tagName"

,function (){var self=this;return "HTML";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27HTML%27"));

smalltalk.bind(smalltalk.HTMLPage,"version","version"

,function (){var self=this;return (self.handle()["version"] || nil);return self;}

,"accessing",unescape("version%0D%0A%09%22%20Return%20the%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27version%27"));

smalltalk.bind(smalltalk.HTMLPage,"version:","version_"

,function (anObject){var self=this;(self.handle()["version"]=(anObject));return self;}

,"accessing",unescape("version%3A%20anObject%0D%0A%09%22%20Set%20the%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27version%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHR.$klass,"tagName","tagName"

,function (){var self=this;return "HR";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27HR%27"));

smalltalk.bind(smalltalk.HTMLHR,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLHR,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHR,"noShade","noShade"

,function (){var self=this;return (self.handle()["noShade"] || nil);return self;}

,"accessing",unescape("noShade%0D%0A%09%22%20Return%20the%20noShade%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27noShade%27"));

smalltalk.bind(smalltalk.HTMLHR,"noShade:","noShade_"

,function (anObject){var self=this;(self.handle()["noShade"]=(anObject));return self;}

,"accessing",unescape("noShade%3A%20anObject%0D%0A%09%22%20Set%20the%20noShade%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27noShade%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHR,"size","size"

,function (){var self=this;return (self['@handle'].size || (0));return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLHR,"size:","size_"

,function (anObject){var self=this;(self.handle()["size"]=(anObject));return self;}

,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27size%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHR,"width","width"

,function (){var self=this;return (self['@handle'].width || (0));return self;}

,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23width%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLHR,"width:","width_"

,function (anObject){var self=this;(self.handle()["width"]=(anObject));return self;}

,"accessing",unescape("width%3A%20anObject%0D%0A%09%22%20Set%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27width%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHead.$klass,"tagName","tagName"

,function (){var self=this;return "HEAD";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27HEAD%27"));

smalltalk.bind(smalltalk.HTMLHead,"profile","profile"

,function (){var self=this;return (self.handle()["profile"] || nil);return self;}

,"accessing",unescape("profile%0D%0A%09%22%20Return%20the%20profile%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27profile%27"));

smalltalk.bind(smalltalk.HTMLHead,"profile:","profile_"

,function (anObject){var self=this;(self.handle()["profile"]=(anObject));return self;}

,"accessing",unescape("profile%3A%20anObject%0D%0A%09%22%20Set%20the%20profile%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27profile%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHeading.$klass,"tagName","tagName"

,function (){var self=this;return nil;return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.HTMLHeading.$klass,"canHandle:tagged:","canHandle_tagged_"

,function (handle,tagName){var self=this;return ["H1", "H2", "H3", "H4", "H5", "H6"].includes_(tagName);return self;}

,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5E%23%28%20%23H1%20%23H2%20%23H3%20%23H4%20%23H5%20%23H6%20%29%20includes%3A%20tagName"));

smalltalk.bind(smalltalk.HTMLHeading,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLHeading,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrameset.$klass,"tagName","tagName"

,function (){var self=this;return "FRAMESET";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FRAMESET%27"));

smalltalk.bind(smalltalk.HTMLFrameset,"cols","cols"

,function (){var self=this;return (self['@handle'].cols || (0));return self;}

,"accessing",unescape("cols%0D%0A%09%22%20Return%20the%20cols%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cols%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrameset,"cols:","cols_"

,function (anObject){var self=this;(self.handle()["cols"]=(anObject));return self;}

,"accessing",unescape("cols%3A%20anObject%0D%0A%09%22%20Set%20the%20cols%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cols%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrameset,"rows","rows"

,function (){var self=this;return (self['@handle'].rows || (0));return self;}

,"accessing",unescape("rows%0D%0A%09%22%20Return%20the%20rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrameset,"rows:","rows_"

,function (anObject){var self=this;(self.handle()["rows"]=(anObject));return self;}

,"accessing",unescape("rows%3A%20anObject%0D%0A%09%22%20Set%20the%20rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rows%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrameset,"complete","complete"

,function (){var self=this;return (self.handle()["complete"] || nil);return self;}

,"accessing",unescape("complete%0D%0A%09%22%20Return%20the%20complete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27complete%27"));

smalltalk.bind(smalltalk.HTMLFrame.$klass,"tagName","tagName"

,function (){var self=this;return "FRAME";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FRAME%27"));

smalltalk.bind(smalltalk.HTMLFrame,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLFrame,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"frameBorder","frameBorder"

,function (){var self=this;return (self.handle()["frameBorder"] || nil);return self;}

,"accessing",unescape("frameBorder%0D%0A%09%22%20Return%20the%20frameBorder%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27frameBorder%27"));

smalltalk.bind(smalltalk.HTMLFrame,"frameBorder:","frameBorder_"

,function (anObject){var self=this;(self.handle()["frameBorder"]=(anObject));return self;}

,"accessing",unescape("frameBorder%3A%20anObject%0D%0A%09%22%20Set%20the%20frameBorder%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27frameBorder%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"longDesc","longDesc"

,function (){var self=this;return (self.handle()["longDesc"] || nil);return self;}

,"accessing",unescape("longDesc%0D%0A%09%22%20Return%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27longDesc%27"));

smalltalk.bind(smalltalk.HTMLFrame,"longDesc:","longDesc_"

,function (anObject){var self=this;(self.handle()["longDesc"]=(anObject));return self;}

,"accessing",unescape("longDesc%3A%20anObject%0D%0A%09%22%20Set%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27longDesc%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLFrame,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"noResize","noResize"

,function (){var self=this;return (self.handle()["noResize"] || nil);return self;}

,"accessing",unescape("noResize%0D%0A%09%22%20Return%20the%20noResize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27noResize%27"));

smalltalk.bind(smalltalk.HTMLFrame,"noResize:","noResize_"

,function (anObject){var self=this;(self.handle()["noResize"]=(anObject));return self;}

,"accessing",unescape("noResize%3A%20anObject%0D%0A%09%22%20Set%20the%20noResize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27noResize%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"src","src"

,function (){var self=this;return (self.handle()["src"] || nil);return self;}

,"accessing",unescape("src%0D%0A%09%22%20Return%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27src%27"));

smalltalk.bind(smalltalk.HTMLFrame,"src:","src_"

,function (anObject){var self=this;(self.handle()["src"]=(anObject));return self;}

,"accessing",unescape("src%3A%20anObject%0D%0A%09%22%20Set%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27src%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"marginHeight","marginHeight"

,function (){var self=this;return (self['@handle'].marginHeight || (0));return self;}

,"accessing",unescape("marginHeight%0D%0A%09%22%20Return%20the%20marginHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrame,"marginHeight:","marginHeight_"

,function (anObject){var self=this;(self.handle()["marginHeight"]=(anObject));return self;}

,"accessing",unescape("marginHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20marginHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27marginHeight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"marginWidth","marginWidth"

,function (){var self=this;return (self['@handle'].marginWidth || (0));return self;}

,"accessing",unescape("marginWidth%0D%0A%09%22%20Return%20the%20marginWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrame,"marginWidth:","marginWidth_"

,function (anObject){var self=this;(self.handle()["marginWidth"]=(anObject));return self;}

,"accessing",unescape("marginWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20marginWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27marginWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"scrolling","scrolling"

,function (){var self=this;return (self['@handle'].scrolling || (0));return self;}

,"accessing",unescape("scrolling%0D%0A%09%22%20Return%20the%20scrolling%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrolling%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrame,"scrolling:","scrolling_"

,function (anObject){var self=this;(self.handle()["scrolling"]=(anObject));return self;}

,"accessing",unescape("scrolling%3A%20anObject%0D%0A%09%22%20Set%20the%20scrolling%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27scrolling%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"extent","extent"

,function (){var self=this;return self.width()._at(self.height());return self;}

,"accessing",unescape("extent%0D%0A%09%22%20Returns%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.HTMLFrame,"extent:","extent_"

,function (aPoint){var self=this;(function($rec){$rec.width_(aPoint.x());return $rec.height_(aPoint.y());})(self);return self;}

,"accessing",unescape("extent%3A%20aPoint%0D%0A%09%22%20Set%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20width%3A%20aPoint%20x%3B%20height%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLFrame,"marginExtent","marginExtent"

,function (){var self=this;return self.marginWidth()._at(self.marginHeight());return self;}

,"accessing",unescape("marginExtent%0D%0A%09%22%20Returns%20the%20extent%20of%20margin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20marginWidth%20@%20self%20marginHeight"));

smalltalk.bind(smalltalk.HTMLFrame,"marginExtent:","marginExtent_"

,function (aPoint){var self=this;(function($rec){$rec.marginWidth_(aPoint.x());return $rec.marginHeight_(aPoint.y());})(self);return self;}

,"accessing",unescape("marginExtent%3A%20aPoint%0D%0A%09%22%20Set%20the%20extent%20of%20margin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20marginWidth%3A%20aPoint%20x%3B%20marginHeight%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLFrame,"contentDocument","contentDocument"

,function (){var self=this;return smalltalk.HTMLDocument._at(self['@handle'].contentDocument);return self;}

,"accessing",unescape("contentDocument%0D%0A%09%22%20Returns%20the%20document%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLDocument%20@%20handle%23contentDocument"));

smalltalk.bind(smalltalk.HTMLFrame,"contentWindow","contentWindow"

,function (){var self=this;return smalltalk.DOMWindow._at(self['@handle'].contentWindow);return self;}

,"accessing",unescape("contentWindow%0D%0A%09%22%20Returns%20the%20window%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMWindow%20@%20handle%23contentWindow"));

smalltalk.bind(smalltalk.HTMLForm.$klass,"tagName","tagName"

,function (){var self=this;return "FORM";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FORM%27"));

smalltalk.bind(smalltalk.HTMLForm,"acceptCharset","acceptCharset"

,function (){var self=this;return (self.handle()["acceptCharset"] || nil);return self;}

,"accessing",unescape("acceptCharset%0D%0A%09%22%20Return%20the%20acceptCharset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27acceptCharset%27"));

smalltalk.bind(smalltalk.HTMLForm,"acceptCharset:","acceptCharset_"

,function (anObject){var self=this;(self.handle()["acceptCharset"]=(anObject));return self;}

,"accessing",unescape("acceptCharset%3A%20anObject%0D%0A%09%22%20Set%20the%20acceptCharset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27acceptCharset%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"action","action"

,function (){var self=this;return (self.handle()["action"] || nil);return self;}

,"accessing",unescape("action%0D%0A%09%22%20Return%20the%20action%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27action%27"));

smalltalk.bind(smalltalk.HTMLForm,"action:","action_"

,function (anObject){var self=this;(self.handle()["action"]=(anObject));return self;}

,"accessing",unescape("action%3A%20anObject%0D%0A%09%22%20Set%20the%20action%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27action%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"behavior","behavior"

,function (){var self=this;return (self.handle()["behavior"] || nil);return self;}

,"accessing",unescape("behavior%0D%0A%09%22%20Return%20the%20behavior%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27behavior%27"));

smalltalk.bind(smalltalk.HTMLForm,"behavior:","behavior_"

,function (anObject){var self=this;(self.handle()["behavior"]=(anObject));return self;}

,"accessing",unescape("behavior%3A%20anObject%0D%0A%09%22%20Set%20the%20behavior%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27behavior%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"encoding","encoding"

,function (){var self=this;return (self.handle()["encoding"] || nil);return self;}

,"accessing",unescape("encoding%0D%0A%09%22%20Return%20the%20encoding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27encoding%27"));

smalltalk.bind(smalltalk.HTMLForm,"encoding:","encoding_"

,function (anObject){var self=this;(self.handle()["encoding"]=(anObject));return self;}

,"accessing",unescape("encoding%3A%20anObject%0D%0A%09%22%20Set%20the%20encoding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27encoding%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"enctype","enctype"

,function (){var self=this;return (self.handle()["enctype"] || nil);return self;}

,"accessing",unescape("enctype%0D%0A%09%22%20Return%20the%20enctype%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27enctype%27"));

smalltalk.bind(smalltalk.HTMLForm,"enctype:","enctype_"

,function (anObject){var self=this;(self.handle()["enctype"]=(anObject));return self;}

,"accessing",unescape("enctype%3A%20anObject%0D%0A%09%22%20Set%20the%20enctype%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27enctype%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"method","method"

,function (){var self=this;return (self.handle()["method"] || nil);return self;}

,"accessing",unescape("method%0D%0A%09%22%20Return%20the%20method%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27method%27"));

smalltalk.bind(smalltalk.HTMLForm,"method:","method_"

,function (anObject){var self=this;(self.handle()["method"]=(anObject));return self;}

,"accessing",unescape("method%3A%20anObject%0D%0A%09%22%20Set%20the%20method%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27method%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLForm,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"target","target"

,function (){var self=this;return (self.handle()["target"] || nil);return self;}

,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27target%27"));

smalltalk.bind(smalltalk.HTMLForm,"target:","target_"

,function (anObject){var self=this;(self.handle()["target"]=(anObject));return self;}

,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27target%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"length","length"

,function (){var self=this;return (self['@handle'].length || (0));return self;}

,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLForm,"elements","elements"

,function (){var self=this;return self.array_of_(self['@handle'].elements, smalltalk.HTMLElement);return self;}

,"accessing",unescape("elements%0D%0A%09%22%20Return%20the%20elements%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23elements%20of%3A%20HTMLElement"));

smalltalk.bind(smalltalk.HTMLForm,"elementAt:","elementAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].elements, smalltalk.HTMLElement, index);return self;}

,"accessing",unescape("elementAt%3A%20index%0D%0A%09%22%20Return%20the%20element%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23elements%20of%3A%20HTMLElement%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLForm,"elementsDo:","elementsDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].elements, smalltalk.HTMLElement, aBlock);return self;}

,"accessing",unescape("elementsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20elements%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23elements%20of%3A%20HTMLElement%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLForm,"reset","reset"

,function (){var self=this;return self['@handle'].reset();return self;}

,"accessing",unescape("reset%0D%0A%09%22%20Reset%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20reset"));

smalltalk.bind(smalltalk.HTMLForm,"submit","submit"

,function (){var self=this;return self['@handle'].submit();return self;}

,"accessing",unescape("submit%0D%0A%09%22%20Submit%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20submit"));

smalltalk.bind(smalltalk.HTMLFont.$klass,"tagName","tagName"

,function (){var self=this;return "FONT";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FONT%27"));

smalltalk.bind(smalltalk.HTMLFont,"color","color"

,function (){var self=this;return (self.handle()["color"] || nil);return self;}

,"accessing",unescape("color%0D%0A%09%22%20Return%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27color%27"));

smalltalk.bind(smalltalk.HTMLFont,"color:","color_"

,function (anObject){var self=this;(self.handle()["color"]=(anObject));return self;}

,"accessing",unescape("color%3A%20anObject%0D%0A%09%22%20Set%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27color%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFont,"face","face"

,function (){var self=this;return (self.handle()["face"] || nil);return self;}

,"accessing",unescape("face%0D%0A%09%22%20Return%20the%20face%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27face%27"));

smalltalk.bind(smalltalk.HTMLFont,"face:","face_"

,function (anObject){var self=this;(self.handle()["face"]=(anObject));return self;}

,"accessing",unescape("face%3A%20anObject%0D%0A%09%22%20Set%20the%20face%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27face%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFont,"size","size"

,function (){var self=this;return (self['@handle'].size || (0));return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFont,"size:","size_"

,function (anObject){var self=this;(self.handle()["size"]=(anObject));return self;}

,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27size%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFieldSet.$klass,"tagName","tagName"

,function (){var self=this;return "FIELDSET";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FIELDSET%27"));

smalltalk.bind(smalltalk.HTMLFieldSet,"form","form"

,function (){var self=this;return (self.handle()["form"] || nil);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27form%27"));

smalltalk.bind(smalltalk.HTMLDiv.$klass,"tagName","tagName"

,function (){var self=this;return "DIV";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27DIV%27"));

smalltalk.bind(smalltalk.HTMLDiv,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLDiv,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDList.$klass,"tagName","tagName"

,function (){var self=this;return "DL";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27DL%27"));

smalltalk.bind(smalltalk.HTMLDList,"compact","compact"

,function (){var self=this;return (self.handle()["compact"] || nil);return self;}

,"accessing",unescape("compact%0D%0A%09%22%20Return%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27compact%27"));

smalltalk.bind(smalltalk.HTMLDList,"compact:","compact_"

,function (anObject){var self=this;(self.handle()["compact"]=(anObject));return self;}

,"accessing",unescape("compact%3A%20anObject%0D%0A%09%22%20Set%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27compact%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDirectory.$klass,"tagName","tagName"

,function (){var self=this;return "DIR";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27DIR%27"));

smalltalk.bind(smalltalk.HTMLDirectory,"compact","compact"

,function (){var self=this;return (self.handle()["compact"] || nil);return self;}

,"accessing",unescape("compact%0D%0A%09%22%20Return%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27compact%27"));

smalltalk.bind(smalltalk.HTMLDirectory,"compact:","compact_"

,function (anObject){var self=this;(self.handle()["compact"]=(anObject));return self;}

,"accessing",unescape("compact%3A%20anObject%0D%0A%09%22%20Set%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27compact%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton.$klass,"tagName","tagName"

,function (){var self=this;return "BUTTON";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BUTTON%27"));

smalltalk.bind(smalltalk.HTMLButton,"disabled","disabled"

,function (){var self=this;return (self.handle()["disabled"] || nil);return self;}

,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27disabled%27"));

smalltalk.bind(smalltalk.HTMLButton,"disabled:","disabled_"

,function (anObject){var self=this;(self.handle()["disabled"]=(anObject));return self;}

,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27disabled%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLButton,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton,"value","value"

,function (){var self=this;return (self.handle()["value"] || nil);return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27value%27"));

smalltalk.bind(smalltalk.HTMLButton,"value:","value_"

,function (anObject){var self=this;(self.handle()["value"]=(anObject));return self;}

,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27value%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton,"tabIndex","tabIndex"

,function (){var self=this;return (self['@handle'].tabIndex || (0));return self;}

,"accessing",unescape("tabIndex%0D%0A%09%22%20Return%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tabIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLButton,"tabIndex:","tabIndex_"

,function (anObject){var self=this;(self.handle()["tabIndex"]=(anObject));return self;}

,"accessing",unescape("tabIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27tabIndex%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton,"form","form"

,function (){var self=this;return (self.handle()["form"] || nil);return self;}

,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27form%27"));

smalltalk.bind(smalltalk.HTMLButton,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLBR.$klass,"tagName","tagName"

,function (){var self=this;return "BR";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BR%27"));

smalltalk.bind(smalltalk.HTMLBR,"clear","clear"

,function (){var self=this;return (self.handle()["clear"] || nil);return self;}

,"accessing",unescape("clear%0D%0A%09%22%20Return%20the%20clear%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27clear%27"));

smalltalk.bind(smalltalk.HTMLBR,"clear:","clear_"

,function (anObject){var self=this;(self.handle()["clear"]=(anObject));return self;}

,"accessing",unescape("clear%3A%20anObject%0D%0A%09%22%20Set%20the%20clear%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27clear%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody.$klass,"tagName","tagName"

,function (){var self=this;return "BODY";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BODY%27"));

smalltalk.bind(smalltalk.HTMLBody,"aLink","aLink"

,function (){var self=this;return (self.handle()["aLink"] || nil);return self;}

,"accessing",unescape("aLink%0D%0A%09%22%20Return%20the%20aLink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27aLink%27"));

smalltalk.bind(smalltalk.HTMLBody,"aLink:","aLink_"

,function (anObject){var self=this;(self.handle()["aLink"]=(anObject));return self;}

,"accessing",unescape("aLink%3A%20anObject%0D%0A%09%22%20Set%20the%20aLink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27aLink%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"background","background"

,function (){var self=this;return (self.handle()["background"] || nil);return self;}

,"accessing",unescape("background%0D%0A%09%22%20Return%20the%20background%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27background%27"));

smalltalk.bind(smalltalk.HTMLBody,"background:","background_"

,function (anObject){var self=this;(self.handle()["background"]=(anObject));return self;}

,"accessing",unescape("background%3A%20anObject%0D%0A%09%22%20Set%20the%20background%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27background%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"bgColor","bgColor"

,function (){var self=this;return (self.handle()["bgColor"] || nil);return self;}

,"accessing",unescape("bgColor%0D%0A%09%22%20Return%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27bgColor%27"));

smalltalk.bind(smalltalk.HTMLBody,"bgColor:","bgColor_"

,function (anObject){var self=this;(self.handle()["bgColor"]=(anObject));return self;}

,"accessing",unescape("bgColor%3A%20anObject%0D%0A%09%22%20Set%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27bgColor%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"link","link"

,function (){var self=this;return (self.handle()["link"] || nil);return self;}

,"accessing",unescape("link%0D%0A%09%22%20Return%20the%20link%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27link%27"));

smalltalk.bind(smalltalk.HTMLBody,"link:","link_"

,function (anObject){var self=this;(self.handle()["link"]=(anObject));return self;}

,"accessing",unescape("link%3A%20anObject%0D%0A%09%22%20Set%20the%20link%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27link%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"text","text"

,function (){var self=this;return (self.handle()["text"] || nil);return self;}

,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27text%27"));

smalltalk.bind(smalltalk.HTMLBody,"text:","text_"

,function (anObject){var self=this;(self.handle()["text"]=(anObject));return self;}

,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27text%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"vLink","vLink"

,function (){var self=this;return (self.handle()["vLink"] || nil);return self;}

,"accessing",unescape("vLink%0D%0A%09%22%20Return%20the%20vLink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27vLink%27"));

smalltalk.bind(smalltalk.HTMLBody,"vLink:","vLink_"

,function (anObject){var self=this;(self.handle()["vLink"]=(anObject));return self;}

,"accessing",unescape("vLink%3A%20anObject%0D%0A%09%22%20Set%20the%20vLink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27vLink%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBlockquote.$klass,"tagName","tagName"

,function (){var self=this;return "BLOCKQUOTE";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BLOCKQUOTE%27"));

smalltalk.bind(smalltalk.HTMLBlockquote,"cite","cite"

,function (){var self=this;return (self.handle()["cite"] || nil);return self;}

,"accessing",unescape("cite%0D%0A%09%22%20Return%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27cite%27"));

smalltalk.bind(smalltalk.HTMLBlockquote,"cite:","cite_"

,function (anObject){var self=this;(self.handle()["cite"]=(anObject));return self;}

,"accessing",unescape("cite%3A%20anObject%0D%0A%09%22%20Set%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27cite%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBaseFont.$klass,"tagName","tagName"

,function (){var self=this;return "BASEFONT";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BASEFONT%27"));

smalltalk.bind(smalltalk.HTMLBaseFont,"color","color"

,function (){var self=this;return (self.handle()["color"] || nil);return self;}

,"accessing",unescape("color%0D%0A%09%22%20Return%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27color%27"));

smalltalk.bind(smalltalk.HTMLBaseFont,"color:","color_"

,function (anObject){var self=this;(self.handle()["color"]=(anObject));return self;}

,"accessing",unescape("color%3A%20anObject%0D%0A%09%22%20Set%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27color%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBaseFont,"face","face"

,function (){var self=this;return (self.handle()["face"] || nil);return self;}

,"accessing",unescape("face%0D%0A%09%22%20Return%20the%20face%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27face%27"));

smalltalk.bind(smalltalk.HTMLBaseFont,"face:","face_"

,function (anObject){var self=this;(self.handle()["face"]=(anObject));return self;}

,"accessing",unescape("face%3A%20anObject%0D%0A%09%22%20Set%20the%20face%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27face%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBaseFont,"size","size"

,function (){var self=this;return (self['@handle'].size || (0));return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLBaseFont,"size:","size_"

,function (anObject){var self=this;(self.handle()["size"]=(anObject));return self;}

,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27size%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBase.$klass,"tagName","tagName"

,function (){var self=this;return "BASE";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BASE%27"));

smalltalk.bind(smalltalk.HTMLBase,"href","href"

,function (){var self=this;return (self.handle()["href"] || nil);return self;}

,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27href%27"));

smalltalk.bind(smalltalk.HTMLBase,"href:","href_"

,function (anObject){var self=this;(self.handle()["href"]=(anObject));return self;}

,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27href%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBase,"target","target"

,function (){var self=this;return (self.handle()["target"] || nil);return self;}

,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27target%27"));

smalltalk.bind(smalltalk.HTMLBase,"target:","target_"

,function (anObject){var self=this;(self.handle()["target"]=(anObject));return self;}

,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27target%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea.$klass,"tagName","tagName"

,function (){var self=this;return "AREA";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27AREA%27"));

smalltalk.bind(smalltalk.HTMLArea,"alt","alt"

,function (){var self=this;return (self.handle()["alt"] || nil);return self;}

,"accessing",unescape("alt%0D%0A%09%22%20Return%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27alt%27"));

smalltalk.bind(smalltalk.HTMLArea,"alt:","alt_"

,function (anObject){var self=this;(self.handle()["alt"]=(anObject));return self;}

,"accessing",unescape("alt%3A%20anObject%0D%0A%09%22%20Set%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27alt%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"coords","coords"

,function (){var self=this;return (self.handle()["coords"] || nil);return self;}

,"accessing",unescape("coords%0D%0A%09%22%20Return%20the%20coords%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27coords%27"));

smalltalk.bind(smalltalk.HTMLArea,"coords:","coords_"

,function (anObject){var self=this;(self.handle()["coords"]=(anObject));return self;}

,"accessing",unescape("coords%3A%20anObject%0D%0A%09%22%20Set%20the%20coords%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27coords%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"hash","hash"

,function (){var self=this;return (self.handle()["hash"] || nil);return self;}

,"accessing",unescape("hash%0D%0A%09%22%20Return%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hash%27"));

smalltalk.bind(smalltalk.HTMLArea,"hash:","hash_"

,function (anObject){var self=this;(self.handle()["hash"]=(anObject));return self;}

,"accessing",unescape("hash%3A%20anObject%0D%0A%09%22%20Set%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hash%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"host","host"

,function (){var self=this;return (self.handle()["host"] || nil);return self;}

,"accessing",unescape("host%0D%0A%09%22%20Return%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27host%27"));

smalltalk.bind(smalltalk.HTMLArea,"host:","host_"

,function (anObject){var self=this;(self.handle()["host"]=(anObject));return self;}

,"accessing",unescape("host%3A%20anObject%0D%0A%09%22%20Set%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27host%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"hostname","hostname"

,function (){var self=this;return (self.handle()["hostname"] || nil);return self;}

,"accessing",unescape("hostname%0D%0A%09%22%20Return%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hostname%27"));

smalltalk.bind(smalltalk.HTMLArea,"hostname:","hostname_"

,function (anObject){var self=this;(self.handle()["hostname"]=(anObject));return self;}

,"accessing",unescape("hostname%3A%20anObject%0D%0A%09%22%20Set%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hostname%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"href","href"

,function (){var self=this;return (self.handle()["href"] || nil);return self;}

,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27href%27"));

smalltalk.bind(smalltalk.HTMLArea,"href:","href_"

,function (anObject){var self=this;(self.handle()["href"]=(anObject));return self;}

,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27href%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"noHref","noHref"

,function (){var self=this;return (self.handle()["noHref"] || nil);return self;}

,"accessing",unescape("noHref%0D%0A%09%22%20Return%20the%20noHref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27noHref%27"));

smalltalk.bind(smalltalk.HTMLArea,"noHref:","noHref_"

,function (anObject){var self=this;(self.handle()["noHref"]=(anObject));return self;}

,"accessing",unescape("noHref%3A%20anObject%0D%0A%09%22%20Set%20the%20noHref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27noHref%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"pathname","pathname"

,function (){var self=this;return (self.handle()["pathname"] || nil);return self;}

,"accessing",unescape("pathname%0D%0A%09%22%20Return%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27pathname%27"));

smalltalk.bind(smalltalk.HTMLArea,"pathname:","pathname_"

,function (anObject){var self=this;(self.handle()["pathname"]=(anObject));return self;}

,"accessing",unescape("pathname%3A%20anObject%0D%0A%09%22%20Set%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27pathname%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"port","port"

,function (){var self=this;return (self.handle()["port"] || nil);return self;}

,"accessing",unescape("port%0D%0A%09%22%20Return%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27port%27"));

smalltalk.bind(smalltalk.HTMLArea,"port:","port_"

,function (anObject){var self=this;(self.handle()["port"]=(anObject));return self;}

,"accessing",unescape("port%3A%20anObject%0D%0A%09%22%20Set%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27port%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"protocol","protocol"

,function (){var self=this;return (self.handle()["protocol"] || nil);return self;}

,"accessing",unescape("protocol%0D%0A%09%22%20Return%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27protocol%27"));

smalltalk.bind(smalltalk.HTMLArea,"protocol:","protocol_"

,function (anObject){var self=this;(self.handle()["protocol"]=(anObject));return self;}

,"accessing",unescape("protocol%3A%20anObject%0D%0A%09%22%20Set%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27protocol%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"search","search"

,function (){var self=this;return (self.handle()["search"] || nil);return self;}

,"accessing",unescape("search%0D%0A%09%22%20Return%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27search%27"));

smalltalk.bind(smalltalk.HTMLArea,"search:","search_"

,function (anObject){var self=this;(self.handle()["search"]=(anObject));return self;}

,"accessing",unescape("search%3A%20anObject%0D%0A%09%22%20Set%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27search%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"shape","shape"

,function (){var self=this;return (self.handle()["shape"] || nil);return self;}

,"accessing",unescape("shape%0D%0A%09%22%20Return%20the%20shape%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27shape%27"));

smalltalk.bind(smalltalk.HTMLArea,"shape:","shape_"

,function (anObject){var self=this;(self.handle()["shape"]=(anObject));return self;}

,"accessing",unescape("shape%3A%20anObject%0D%0A%09%22%20Set%20the%20shape%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27shape%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"target","target"

,function (){var self=this;return (self.handle()["target"] || nil);return self;}

,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27target%27"));

smalltalk.bind(smalltalk.HTMLArea,"target:","target_"

,function (anObject){var self=this;(self.handle()["target"]=(anObject));return self;}

,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27target%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"tabIndex","tabIndex"

,function (){var self=this;return (self['@handle'].tabIndex || (0));return self;}

,"accessing",unescape("tabIndex%0D%0A%09%22%20Return%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tabIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLArea,"tabIndex:","tabIndex_"

,function (anObject){var self=this;(self.handle()["tabIndex"]=(anObject));return self;}

,"accessing",unescape("tabIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27tabIndex%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"click","click"

,function (){var self=this;return self['@handle'].click();return self;}

,"actions",unescape("click%0D%0A%09%22%20Executes%20a%20click%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20click"));

smalltalk.bind(smalltalk.HTMLApplet.$klass,"tagName","tagName"

,function (){var self=this;return "APPLET";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27APPLET%27"));

smalltalk.bind(smalltalk.HTMLApplet,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLApplet,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"alt","alt"

,function (){var self=this;return (self.handle()["alt"] || nil);return self;}

,"accessing",unescape("alt%0D%0A%09%22%20Return%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27alt%27"));

smalltalk.bind(smalltalk.HTMLApplet,"alt:","alt_"

,function (anObject){var self=this;(self.handle()["alt"]=(anObject));return self;}

,"accessing",unescape("alt%3A%20anObject%0D%0A%09%22%20Set%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27alt%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"archive","archive"

,function (){var self=this;return (self.handle()["archive"] || nil);return self;}

,"accessing",unescape("archive%0D%0A%09%22%20Return%20the%20archive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27archive%27"));

smalltalk.bind(smalltalk.HTMLApplet,"archive:","archive_"

,function (anObject){var self=this;(self.handle()["archive"]=(anObject));return self;}

,"accessing",unescape("archive%3A%20anObject%0D%0A%09%22%20Set%20the%20archive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27archive%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"code","code"

,function (){var self=this;return (self.handle()["code"] || nil);return self;}

,"accessing",unescape("code%0D%0A%09%22%20Return%20the%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27code%27"));

smalltalk.bind(smalltalk.HTMLApplet,"code:","code_"

,function (anObject){var self=this;(self.handle()["code"]=(anObject));return self;}

,"accessing",unescape("code%3A%20anObject%0D%0A%09%22%20Set%20the%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27code%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"codeBase","codeBase"

,function (){var self=this;return (self.handle()["codeBase"] || nil);return self;}

,"accessing",unescape("codeBase%0D%0A%09%22%20Return%20the%20codeBase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27codeBase%27"));

smalltalk.bind(smalltalk.HTMLApplet,"codeBase:","codeBase_"

,function (anObject){var self=this;(self.handle()["codeBase"]=(anObject));return self;}

,"accessing",unescape("codeBase%3A%20anObject%0D%0A%09%22%20Set%20the%20codeBase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27codeBase%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"hspace","hspace"

,function (){var self=this;return (self.handle()["hspace"] || nil);return self;}

,"accessing",unescape("hspace%0D%0A%09%22%20Return%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hspace%27"));

smalltalk.bind(smalltalk.HTMLApplet,"hspace:","hspace_"

,function (anObject){var self=this;(self.handle()["hspace"]=(anObject));return self;}

,"accessing",unescape("hspace%3A%20anObject%0D%0A%09%22%20Set%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hspace%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLApplet,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"object","object"

,function (){var self=this;return (self.handle()["object"] || nil);return self;}

,"accessing",unescape("object%0D%0A%09%22%20Return%20the%20object%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27object%27"));

smalltalk.bind(smalltalk.HTMLApplet,"object:","object_"

,function (anObject){var self=this;(self.handle()["object"]=(anObject));return self;}

,"accessing",unescape("object%3A%20anObject%0D%0A%09%22%20Set%20the%20object%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27object%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"vspace","vspace"

,function (){var self=this;return (self.handle()["vspace"] || nil);return self;}

,"accessing",unescape("vspace%0D%0A%09%22%20Return%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27vspace%27"));

smalltalk.bind(smalltalk.HTMLApplet,"vspace:","vspace_"

,function (anObject){var self=this;(self.handle()["vspace"]=(anObject));return self;}

,"accessing",unescape("vspace%3A%20anObject%0D%0A%09%22%20Set%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27vspace%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor.$klass,"tagName","tagName"

,function (){var self=this;return "A";return self;}

,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27A%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"charset","charset"

,function (){var self=this;return (self.handle()["charset"] || nil);return self;}

,"accessing",unescape("charset%0D%0A%09%22%20Return%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27charset%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"charset:","charset_"

,function (anObject){var self=this;(self.handle()["charset"]=(anObject));return self;}

,"accessing",unescape("charset%3A%20anObject%0D%0A%09%22%20Set%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27charset%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"coords","coords"

,function (){var self=this;return (self.handle()["coords"] || nil);return self;}

,"accessing",unescape("coords%0D%0A%09%22%20Return%20the%20coords%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27coords%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"coords:","coords_"

,function (anObject){var self=this;(self.handle()["coords"]=(anObject));return self;}

,"accessing",unescape("coords%3A%20anObject%0D%0A%09%22%20Set%20the%20coords%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27coords%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"href","href"

,function (){var self=this;return (self.handle()["href"] || nil);return self;}

,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27href%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"href:","href_"

,function (anObject){var self=this;(self.handle()["href"]=(anObject));return self;}

,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27href%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"hreflang","hreflang"

,function (){var self=this;return (self.handle()["hreflang"] || nil);return self;}

,"accessing",unescape("hreflang%0D%0A%09%22%20Return%20the%20hreflang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hreflang%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"hreflang:","hreflang_"

,function (anObject){var self=this;(self.handle()["hreflang"]=(anObject));return self;}

,"accessing",unescape("hreflang%3A%20anObject%0D%0A%09%22%20Set%20the%20hreflang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27hreflang%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"rel","rel"

,function (){var self=this;return (self.handle()["rel"] || nil);return self;}

,"accessing",unescape("rel%0D%0A%09%22%20Return%20the%20rel%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27rel%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"rel:","rel_"

,function (anObject){var self=this;(self.handle()["rel"]=(anObject));return self;}

,"accessing",unescape("rel%3A%20anObject%0D%0A%09%22%20Set%20the%20rel%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rel%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"rev","rev"

,function (){var self=this;return (self.handle()["rev"] || nil);return self;}

,"accessing",unescape("rev%0D%0A%09%22%20Return%20the%20rev%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27rev%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"rev:","rev_"

,function (anObject){var self=this;(self.handle()["rev"]=(anObject));return self;}

,"accessing",unescape("rev%3A%20anObject%0D%0A%09%22%20Set%20the%20rev%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27rev%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"shape","shape"

,function (){var self=this;return (self.handle()["shape"] || nil);return self;}

,"accessing",unescape("shape%0D%0A%09%22%20Return%20the%20shape%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27shape%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"shape:","shape_"

,function (anObject){var self=this;(self.handle()["shape"]=(anObject));return self;}

,"accessing",unescape("shape%3A%20anObject%0D%0A%09%22%20Set%20the%20shape%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27shape%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"target","target"

,function (){var self=this;return (self.handle()["target"] || nil);return self;}

,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27target%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"target:","target_"

,function (anObject){var self=this;(self.handle()["target"]=(anObject));return self;}

,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27target%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"text","text"

,function (){var self=this;return (self.handle()["text"] || nil);return self;}

,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27text%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"text:","text_"

,function (anObject){var self=this;(self.handle()["text"]=(anObject));return self;}

,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27text%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"type","type"

,function (){var self=this;return (self.handle()["type"] || nil);return self;}

,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27type%27"));

smalltalk.bind(smalltalk.HTMLAnchor,"type:","type_"

,function (anObject){var self=this;(self.handle()["type"]=(anObject));return self;}

,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27type%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"tabIndex","tabIndex"

,function (){var self=this;return (self['@handle'].tabIndex || (0));return self;}

,"accessing",unescape("tabIndex%0D%0A%09%22%20Return%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tabIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLAnchor,"tabIndex:","tabIndex_"

,function (anObject){var self=this;(self.handle()["tabIndex"]=(anObject));return self;}

,"accessing",unescape("tabIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27tabIndex%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"blur","blur"

,function (){var self=this;return self['@handle'].blur();return self;}

,"actions",unescape("blur%0D%0A%09%22%20Removes%20focus%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20blur"));

smalltalk.bind(smalltalk.HTMLAnchor,"focus","focus"

,function (){var self=this;return self['@handle'].focus();return self;}

,"actions",unescape("focus%0D%0A%09%22%20Gives%20focus%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20focus"));

smalltalk.bind(smalltalk.HTMLAnchor,"click","click"

,function (){var self=this;return self['@handle'].click();return self;}

,"actions",unescape("click%0D%0A%09%22%20Executes%20a%20click%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20click"));

smalltalk.bind(smalltalk.HTMLInputText.$klass,"canHandle:tagged:","canHandle_tagged_"

,function (handle,tagName){var self=this;return tagName._eq("INPUT").and_((function(){return handle.type._eq("text");}));return self;}

,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27text%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputText,"defaultValue","defaultValue"

,function (){var self=this;return (self.handle()["defaultValue"] || nil);return self;}

,"accessing",unescape("defaultValue%0D%0A%09%22%20Return%20the%20defaultValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27defaultValue%27"));

smalltalk.bind(smalltalk.HTMLInputText,"defaultValue:","defaultValue_"

,function (anObject){var self=this;(self.handle()["defaultValue"]=(anObject));return self;}

,"accessing",unescape("defaultValue%3A%20anObject%0D%0A%09%22%20Set%20the%20defaultValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27defaultValue%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"readOnly","readOnly"

,function (){var self=this;return (self.handle()["readOnly"] || nil);return self;}

,"accessing",unescape("readOnly%0D%0A%09%22%20Return%20the%20readOnly%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27readOnly%27"));

smalltalk.bind(smalltalk.HTMLInputText,"readOnly:","readOnly_"

,function (anObject){var self=this;(self.handle()["readOnly"]=(anObject));return self;}

,"accessing",unescape("readOnly%3A%20anObject%0D%0A%09%22%20Set%20the%20readOnly%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27readOnly%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"maxLength","maxLength"

,function (){var self=this;return (self['@handle'].maxLength || (0));return self;}

,"accessing",unescape("maxLength%0D%0A%09%22%20Return%20the%20maxLength%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23maxLength%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLInputText,"maxLength:","maxLength_"

,function (anObject){var self=this;(self.handle()["maxLength"]=(anObject));return self;}

,"accessing",unescape("maxLength%3A%20anObject%0D%0A%09%22%20Set%20the%20maxLength%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27maxLength%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"size","size"

,function (){var self=this;return (self['@handle'].size || (0));return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLInputText,"size:","size_"

,function (anObject){var self=this;(self.handle()["size"]=(anObject));return self;}

,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27size%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"onchange","onchange"

,function (){var self=this;return (self['@handle'].onchange || (0));return self;}

,"accessing",unescape("onchange%0D%0A%09%22%20Return%20the%20onchange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23onchange%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLInputText,"onchange:","onchange_"

,function (anObject){var self=this;(self.handle()["onchange"]=(anObject));return self;}

,"accessing",unescape("onchange%3A%20anObject%0D%0A%09%22%20Set%20the%20onchange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onchange%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"select","select"

,function (){var self=this;self['@handle'].select();return self;}

,"actions",unescape("select%0D%0A%09%22%20Select%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20select"));

smalltalk.bind(smalltalk.HTMLInputRadio.$klass,"canHandle:tagged:","canHandle_tagged_"

,function (handle,tagName){var self=this;return tagName._eq("INPUT").and_((function(){return handle.type._eq("radio");}));return self;}

,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27radio%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputRadio,"checked","checked"

,function (){var self=this;return (self.handle()["checked"] || nil);return self;}

,"accessing",unescape("checked%0D%0A%09%22%20Return%20the%20checked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27checked%27"));

smalltalk.bind(smalltalk.HTMLInputRadio,"checked:","checked_"

,function (anObject){var self=this;(self.handle()["checked"]=(anObject));return self;}

,"accessing",unescape("checked%3A%20anObject%0D%0A%09%22%20Set%20the%20checked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27checked%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputRadio,"onclick","onclick"

,function (){var self=this;return (self.handle()["onclick"] || nil);return self;}

,"accessing",unescape("onclick%0D%0A%09%22%20Return%20the%20onclick%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onclick%27"));

smalltalk.bind(smalltalk.HTMLInputRadio,"onclick:","onclick_"

,function (anObject){var self=this;(self.handle()["onclick"]=(anObject));return self;}

,"accessing",unescape("onclick%3A%20anObject%0D%0A%09%22%20Set%20the%20onclick%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onclick%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputRadio,"defaultChecked","defaultChecked"

,function (){var self=this;return (self.handle()["defaultChecked"] || nil);return self;}

,"accessing",unescape("defaultChecked%0D%0A%09%22%20Return%20the%20defaultChecked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27defaultChecked%27"));

smalltalk.bind(smalltalk.HTMLInputHidden.$klass,"canHandle:tagged:","canHandle_tagged_"

,function (handle,tagName){var self=this;return tagName._eq("INPUT").and_((function(){return handle.type._eq("hidden");}));return self;}

,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27hidden%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputFile.$klass,"canHandle:tagged:","canHandle_tagged_"

,function (handle,tagName){var self=this;return tagName._eq("INPUT").and_((function(){return handle.type._eq("file");}));return self;}

,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27file%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputFile,"accept","accept"

,function (){var self=this;return (self.handle()["accept"] || nil);return self;}

,"accessing",unescape("accept%0D%0A%09%22%20Return%20the%20accept%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27accept%27"));

smalltalk.bind(smalltalk.HTMLInputFile,"accept:","accept_"

,function (anObject){var self=this;(self.handle()["accept"]=(anObject));return self;}

,"accessing",unescape("accept%3A%20anObject%0D%0A%09%22%20Set%20the%20accept%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27accept%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputCheckbox.$klass,"canHandle:tagged:","canHandle_tagged_"

,function (handle,tagName){var self=this;return tagName._eq("INPUT").and_((function(){return handle.type._eq("checkbox");}));return self;}

,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27checkbox%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"checked","checked"

,function (){var self=this;return (self.handle()["checked"] || nil);return self;}

,"accessing",unescape("checked%0D%0A%09%22%20Return%20the%20checked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27checked%27"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"checked:","checked_"

,function (anObject){var self=this;(self.handle()["checked"]=(anObject));return self;}

,"accessing",unescape("checked%3A%20anObject%0D%0A%09%22%20Set%20the%20checked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27checked%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"onchange","onchange"

,function (){var self=this;return (self.handle()["onchange"] || nil);return self;}

,"accessing",unescape("onchange%0D%0A%09%22%20Return%20the%20onchange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onchange%27"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"onchange:","onchange_"

,function (anObject){var self=this;(self.handle()["onchange"]=(anObject));return self;}

,"accessing",unescape("onchange%3A%20anObject%0D%0A%09%22%20Set%20the%20onchange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onchange%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"defaultChecked","defaultChecked"

,function (){var self=this;return (self.handle()["defaultChecked"] || nil);return self;}

,"accessing",unescape("defaultChecked%0D%0A%09%22%20Return%20the%20defaultChecked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27defaultChecked%27"));

smalltalk.bind(smalltalk.HTMLInputButton.$klass,"canHandle:tagged:","canHandle_tagged_"

,function (handle,tagName){var self=this;return tagName._eq("INPUT").and_((function(){return handle.type._eq("button");}));return self;}

,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27button%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputButton,"accept","accept"

,function (){var self=this;return (self.handle()["accept"] || nil);return self;}

,"accessing",unescape("accept%0D%0A%09%22%20Return%20the%20accept%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27accept%27"));

smalltalk.bind(smalltalk.HTMLInputButton,"accept:","accept_"

,function (anObject){var self=this;(self.handle()["accept"]=(anObject));return self;}

,"accessing",unescape("accept%3A%20anObject%0D%0A%09%22%20Set%20the%20accept%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27accept%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputButton,"align","align"

,function (){var self=this;return (self.handle()["align"] || nil);return self;}

,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27align%27"));

smalltalk.bind(smalltalk.HTMLInputButton,"align:","align_"

,function (anObject){var self=this;(self.handle()["align"]=(anObject));return self;}

,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27align%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputButton,"alt","alt"

,function (){var self=this;return (self.handle()["alt"] || nil);return self;}

,"accessing",unescape("alt%0D%0A%09%22%20Return%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27alt%27"));

smalltalk.bind(smalltalk.HTMLInputButton,"alt:","alt_"

,function (anObject){var self=this;(self.handle()["alt"]=(anObject));return self;}

,"accessing",unescape("alt%3A%20anObject%0D%0A%09%22%20Set%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27alt%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputButton,"onclick","onclick"

,function (){var self=this;return (self.handle()["onclick"] || nil);return self;}

,"accessing",unescape("onclick%0D%0A%09%22%20Return%20the%20onclick%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27onclick%27"));

smalltalk.bind(smalltalk.HTMLInputButton,"onclick:","onclick_"

,function (anObject){var self=this;(self.handle()["onclick"]=(anObject));return self;}

,"accessing",unescape("onclick%3A%20anObject%0D%0A%09%22%20Set%20the%20onclick%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27onclick%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.DOMText,"splitText:","splitText_"

,function (offset){var self=this;return self.$klass._at(self['@handle'].splitText(offset));return self;}

,"actions",unescape("splitText%3A%20offset%0D%0A%0D%0A%09%5Eself%20class%20@%20%28handle%20%23splitText%3A%20offset%29"));

smalltalk.bind(smalltalk.DOMText,"value:","value_"

,function (aString){var self=this;return (self.handle()["nodeValue"]=(aString));return self;}

,"accessing",unescape("value%3A%20aString%0D%0A%09%22%20Set%20the%20text%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23nodeValue%20put%3A%20aString"));

smalltalk.bind(smalltalk.DOMText,"value","value"

,function (){var self=this;return self.nodeValue();return self;}

,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20text%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20nodeValue"));

smalltalk.bind(smalltalk.HTMLDocument.$klass,"default","$$default"

,function (){var self=this;return self._at(document);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bdocument%7D"));

smalltalk.bind(smalltalk.HTMLDocument.$klass,"elementSupport","elementSupport"

,function (){var self=this;return smalltalk.HTMLElement;return self;}

,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5EHTMLElement"));

smalltalk.bind(smalltalk.HTMLDocument,"cookie","cookie"

,function (){var self=this;return (self.handle()["cookie"] || nil);return self;}

,"accessing",unescape("cookie%0D%0A%09%22%20Return%20the%20cookie%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27cookie%27"));

smalltalk.bind(smalltalk.HTMLDocument,"documentMode","documentMode"

,function (){var self=this;return (self.handle()["documentMode"] || nil);return self;}

,"accessing",unescape("documentMode%0D%0A%09%22%20Return%20the%20documentMode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27documentMode%27"));

smalltalk.bind(smalltalk.HTMLDocument,"domain","domain"

,function (){var self=this;return (self.handle()["domain"] || nil);return self;}

,"accessing",unescape("domain%0D%0A%09%22%20Return%20the%20domain%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27domain%27"));

smalltalk.bind(smalltalk.HTMLDocument,"lastModified","lastModified"

,function (){var self=this;return (self.handle()["lastModified"] || nil);return self;}

,"accessing",unescape("lastModified%0D%0A%09%22%20Return%20the%20lastModified%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27lastModified%27"));

smalltalk.bind(smalltalk.HTMLDocument,"readyState","readyState"

,function (){var self=this;return (self.handle()["readyState"] || nil);return self;}

,"accessing",unescape("readyState%0D%0A%09%22%20Return%20the%20readyState%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27readyState%27"));

smalltalk.bind(smalltalk.HTMLDocument,"referrer","referrer"

,function (){var self=this;return (self.handle()["referrer"] || nil);return self;}

,"accessing",unescape("referrer%0D%0A%09%22%20Return%20the%20referrer%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27referrer%27"));

smalltalk.bind(smalltalk.HTMLDocument,"title","title"

,function (){var self=this;return (self.handle()["title"] || nil);return self;}

,"accessing",unescape("title%0D%0A%09%22%20Return%20the%20title%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27title%27"));

smalltalk.bind(smalltalk.HTMLDocument,"anchors","anchors"

,function (){var self=this;return self.array_of_(self['@handle'].anchors, smalltalk.DOMAnchor);return self;}

,"accessing",unescape("anchors%0D%0A%09%22%20Return%20the%20anchors%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23anchors%20of%3A%20DOMAnchor"));

smalltalk.bind(smalltalk.HTMLDocument,"anchorsDo:","anchorsDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].anchors, smalltalk.DOMAnchor, aBlock);return self;}

,"accessing",unescape("anchorsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20anchors%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23anchors%20of%3A%20DOMAnchor%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"anchorAt:","anchorAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].anchors, smalltalk.DOMAnchor, index);return self;}

,"accessing",unescape("anchorAt%3A%20index%0D%0A%09%22%20Return%20the%20anchor%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23anchors%20of%3A%20DOMAnchor%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLDocument,"forms","forms"

,function (){var self=this;return self.array_of_(self['@handle'].forms, smalltalk.DOMForm);return self;}

,"accessing",unescape("forms%0D%0A%09%22%20Return%20the%20forms%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23forms%20of%3A%20DOMForm"));

smalltalk.bind(smalltalk.HTMLDocument,"formAt:","formAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].forms, smalltalk.DOMForm, index);return self;}

,"accessing",unescape("formAt%3A%20index%0D%0A%09%22%20Return%20the%20form%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23forms%20of%3A%20DOMForm%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLDocument,"formsDo:","formsDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].forms, smalltalk.DOMForm, aBlock);return self;}

,"accessing",unescape("formsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20forms%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23forms%20of%3A%20DOMForm%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"images","images"

,function (){var self=this;return self.array_of_(self['@handle'].images, smalltalk.DOMImage);return self;}

,"accessing",unescape("images%0D%0A%09%22%20Return%20the%20images%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23images%20of%3A%20DOMImage"));

smalltalk.bind(smalltalk.HTMLDocument,"imagesDo:","imagesDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].images, smalltalk.DOMImage, aBlock);return self;}

,"accessing",unescape("imagesDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20images%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23images%20of%3A%20DOMImage%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"imageAt:","imageAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].images, smalltalk.DOMImage, index);return self;}

,"accessing",unescape("imageAt%3A%20index%0D%0A%09%22%20Return%20the%20image%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23images%20of%3A%20DOMImage%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLDocument,"links","links"

,function (){var self=this;return self.array_of_(self['@handle'].links, smalltalk.DOMLink);return self;}

,"accessing",unescape("links%0D%0A%09%22%20Return%20the%20links%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23links%20of%3A%20DOMLink"));

smalltalk.bind(smalltalk.HTMLDocument,"linksDo:","linksDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].links, smalltalk.DOMLink, aBlock);return self;}

,"accessing",unescape("linksDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20links%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23links%20of%3A%20DOMLink%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"linkAt:","linkAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].links, smalltalk.DOMLink, index);return self;}

,"accessing",unescape("linkAt%3A%20index%0D%0A%09%22%20Return%20the%20link%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23links%20of%3A%20DOMLink%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLDocument,"head","head"

,function (){var self=this;return self.getElementsByTagName_("head").first();return self;}

,"accessing",unescape("head%0D%0A%09%22%20Return%20the%20first%20head%20element%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28self%20getElementsByTagName%3A%20%23head%29%20first"));

smalltalk.bind(smalltalk.HTMLDocument,"body","body"

,function (){var self=this;return self.getElementsByTagName_("body").first();return self;}

,"accessing",unescape("body%0D%0A%09%22%20Return%20the%20first%20head%20element%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28self%20getElementsByTagName%3A%20%23body%29%20first"));

smalltalk.bind(smalltalk.HTMLDocument,"add:script:onLoad:","add_script_onLoad_"

,function (type,anURL,aBlock){var self=this;var script=nil;script=self.createElement_("script").handle();

script.type=type;

(((script["readyState"] || (function(){return "missing";}).value())._eq("missing")).mustBeBoolean()==true ? (function(){return script.onload=aBlock;})() : (function(){return script.onreadystatechange=(function(){return ((script.readyState._eq("loaded").or_((function(){return script.readyState._eq("complete");}))).mustBeBoolean()==true ? (function(){script.onreadystatechange=nil.json();return aBlock.evaluate();})() : nil);});})());

script.src=anURL;

self.head().appendChild_(self.elementSupport()._at(script));return self;}

,"adding",unescape("add%3A%20type%20script%3A%20anURL%20onLoad%3A%20aBlock%0D%0A%09%22%20Append%20a%20script%20of%20specified%20type%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20script%20%7C%0D%0A%09script%20%3A%3D%20%28self%20createElement%3A%20%23script%29%20handle.%0D%0A%09script%23type%20%20%20%3A%3D%20type.%0A%0D%0A%09%28script%20basicAt%3A%20%23readyState%20ifAbsent%3A%20%5B%23missing%5D%29%20%3D%20%23missing%0D%0A%09ifTrue%3A%20%5B%20script%23onload%20%3A%3D%20aBlock%20%5D%0D%0A%09ifFalse%3A%20%5B%20%22IE%22%0D%0A%09%09script%23onreadystatechange%20%3A%3D%20%5B%0D%0A%09%09%09%28script%23readyState%20%3D%20%23loaded%20or%3A%20%5B%0D%0A%09%09%09%20script%23readyState%20%3D%20%23complete%20%5D%29%0D%0A%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%09ifTrue%3A%20%5B%0D%0A%09%09%09%09script%23onreadystatechange%20%3A%3D%20nil%20json.%0D%0A%09%09%09%09aBlock%20evaluate.%0D%0A%09%09%09%5D%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09script%23src%20%20%20%20%3A%3D%20anURL.%0D%0A%09self%20%0Ahead%20appendChild%3A%20self%20elementSupport%20@%20script."));

smalltalk.bind(smalltalk.HTMLDocument,"addJavascript:onLoad:","addJavascript_onLoad_"

,function (jsURL,aBlock){var self=this;return self.add_script_onLoad_(unescape("text/javascript"), jsURL, aBlock);return self;}

,"adding",unescape("addJavascript%3A%20jsURL%20onLoad%3A%20aBlock%0D%0A%09%22%20Append%20a%20javascript%20script%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20add%3A%20%27text/javascript%27%20script%3A%20jsURL%20onLoad%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"load:onLoad:","load_onLoad_"

,function (jsURL,action){var self=this;return self.addJavascript_onLoad_(jsURL, (function(){return action.evaluate();}));return self;}

,"loading",unescape("load%3A%20jsURL%20onLoad%3A%20action%0D%0A%09%22%20Load%20a%20javascript%20library%20to%20the%20system%20from%20jsURL%20and%20evaluate%20action%20when%20loading%20has%20finished.%20%22%0D%0A%0D%0A%09%5Eself%20addJavascript%3A%20jsURL%20onLoad%3A%20%5B%20action%20evaluate%20%5D"));

smalltalk.bind(smalltalk.HTMLDocument,"headjsURL","headjsURL"

,function (){var self=this;return unescape("http%3A//u8.smalltalking.net/profile/aleReimondo/Head/Head.st.js");return self;}

,"private",unescape("headjsURL%0D%0A%09%22%20Private%20-%20Return%20the%20URL%20to%20download%20Head.js%20support.%20%22%0D%0A%0D%0A%09%5E%27http%3A//u8.smalltalking.net/profile/aleReimondo/Head/Head.st.js%27"));

smalltalk.bind(smalltalk.HTMLDocument,"loadAll:onLoad:","loadAll_onLoad_"

,function (urls,action){var self=this;try{((urls.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "loadAll_onLoad_", fn: function(){return action.evaluate()}})})();})() : nil);

((smalltalk.Smalltalk.includesKey_("Head")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "loadAll_onLoad_", fn: function(){return smalltalk.Head.loadAll_onLoad_(urls, action)}})})();})() : nil);

((smalltalk.DOM.navigator().appName()._eq("Microsoft Internet Explorer")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "loadAll_onLoad_", fn: function(){return self.load_onLoad_(self.headjsURL(), (function(){return smalltalk.Head.loadAll_onLoad_(urls, action);}))}})})();})() : nil);

self.load_onLoad_(urls.removeFirst(), (function(){return self.loadAll_onLoad_(urls, action);}));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "loadAll_onLoad_"){return $$ex.fn();} throw($$ex);}}

,"loading",unescape("loadAll%3A%20urls%20onLoad%3A%20action%0D%0A%09%22%20Load%20a%20collection%20of%20javascript%20libraries%20to%20the%20system%20from%20URLs%20and%20evaluate%20action%20when%20loading%20has%20finished.%20%22%0D%0A%0D%0A%09urls%20isEmpty%20ifTrue%3A%20%5B%20%5Eaction%20evaluate%20%5D.%0D%0A%09%28Smalltalk%20includesKey%3A%20%23Head%29%20ifTrue%3A%20%5B%0D%0A%09%09%5EHead%20loadAll%3A%20urls%20onLoad%3A%20action%0D%0A%09%5D.%0D%0A%0D%0A%09DOM%20navigator%20appName%20%3D%20%27Microsoft%20Internet%20Explorer%27%20ifTrue%3A%20%5B%20%22we%20use%20Head.js%20support%20on%20this%20browser%22%0D%0A%09%09%5Eself%0D%0A%09%09%09load%3A%20self%20headjsURL%0D%0A%09%09%09onLoad%3A%20%5B%20Head%20loadAll%3A%20urls%20onLoad%3A%20action%20%5D%0D%0A%09%5D.%0D%0A%0D%0A%09self%20load%3A%20urls%20removeFirst%20onLoad%3A%20%5B%20self%20loadAll%3A%20urls%20onLoad%3A%20action%20%5D"));

smalltalk.bind(smalltalk.HTMLDocument,"load:from:onLoad:","load_from_onLoad_"

,function (globalName,jsURL,action){var self=this;var global=nil;return self.load_onLoad_(jsURL, (function(){global=smalltalk.Smalltalk.at_(globalName);return ((action.isString()).mustBeBoolean()==true ? (function(){return action.evaluate();})() : (function(){return action.evaluateWith_(global);})());}));return self;}

,"loading",unescape("load%3A%20globalName%20from%3A%20jsURL%20onLoad%3A%20action%0D%0A%09%22%20Load%20a%20javascript%20library%20to%20the%20system%20from%20jsURL.%0D%0A%09After%20loading%20evaluate%20action%20with%20the%20global%20object%20at%20globalName.%0D%0A%09Generates%20an%20error%20if%20the%20global%20is%20not%20defined%20after%20loading%20the%20library.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20global%20%7C%0D%0A%09%5Eself%20load%3A%20jsURL%20onLoad%3A%20%5B%0D%0A%09%09global%20%3A%3D%20Smalltalk%20at%3A%20globalName.%0D%0A%09%09action%20isString%20ifTrue%3A%20%5B%20action%20evaluate%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20action%20evaluateWith%3A%20global%20%5D.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.HTMLDocument,"addCSS:","addCSS_"

,function (cssURL){var self=this;var node=nil;node=self.createElement_("link");

(function($rec){$rec.type_(unescape("text/css"));$rec.rel_("stylesheet");$rec.href_(cssURL);return $rec.media_("screen");})(node);

self.head().appendChild_(node);return self;}

,"adding",unescape("addCSS%3A%20cssURL%0D%0A%09%22%20Append%20a%20cascading%20style%20sheet%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20node%20%7C%0D%0A%09node%20%3A%3D%20self%20createElement%3A%20%23link.%0D%0A%09node%0A%0D%0A%09%09type%3A%20%27text/css%27%3B%0A%0D%0A%09%09rel%3A%20%23stylesheet%3B%0A%0D%0A%09%09href%3A%20cssURL%3B%0D%0A%09%09media%3A%20%27screen%27.%0D%0A%09self%20head%20appendChild%3A%20node.%0A"));

smalltalk.bind(smalltalk.HTMLDocument,"url","url"

,function (){var self=this;return (self['@handle']["URL"] || nil);return self;}

,"accessing",unescape("url%0D%0A%09%22%20Return%20the%20URL%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20basicAt%3A%20%23URL"));

smalltalk.bind(smalltalk.HTMLDocument,"open:replace:","open_replace_"

,function (mimeType,replace){var self=this;return smalltalk.BrowserDocument._at(self['@handle'].open(mimeType));return self;}

,"io",unescape("open%3A%20mimeType%20replace%3A%20replace%0D%0A%09%22%20Opens%20an%20output%20stream%20to%20collect%20the%20output%20from%20%23write%3A%20or%20%23writeln%3A.%0D%0A%09Once%20all%20the%20writes%20are%20performed%2C%20%23close%20causes%20any%20output%20written%20to%20the%20output%20stream%20to%20be%20displayed.%0D%0A%09Note%3A%20If%20a%20document%20already%20exists%20in%20the%20target%2C%20it%20will%20be%20cleared.%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserDocument%20@%20%28handle%20%23open%3A%20mimeType%29"));

smalltalk.bind(smalltalk.HTMLDocument,"open","open"

,function (){var self=this;return smalltalk.BrowserDocument._at(self['@handle'].open());return self;}

,"io",unescape("open%0D%0A%09%22%20A%20new%20window%20%28about%3Ablank%29%20is%20displayed.%20%22%0D%0A%0D%0A%09%5EBrowserDocument%20@%20handle%20open"));

smalltalk.bind(smalltalk.HTMLDocument,"close","close"

,function (){var self=this;return self['@handle'].close();return self;}

,"io",unescape("close%0D%0A%09%22%20Close%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20close"));

smalltalk.bind(smalltalk.HTMLDocument,"write:","write_"

,function (anObject){var self=this;return self['@handle'].write(anObject);return self;}

,"io",unescape("write%3A%20anObject%0D%0A%09%22%20Output%20anObject%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23write%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDocument,"writeln:","writeln_"

,function (anObject){var self=this;return self['@handle'].writeln(anObject);return self;}

,"io",unescape("writeln%3A%20anObject%0D%0A%09%22%20Output%20anObject%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23writeln%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDocument,"nextPut:","nextPut_"

,function (anObject){var self=this;return self.write_(anObject);return self;}

,"io",unescape("nextPut%3A%20anObject%0D%0A%09%22%20Output%20anObject%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20write%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDocument,"nextPutAll:","nextPutAll_"

,function (anObject){var self=this;return self.write_(anObject);return self;}

,"io",unescape("nextPutAll%3A%20anObject%0D%0A%09%22%20Output%20anObject%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20write%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDocument,"cr","cr"

,function (){var self=this;return self.writeln_("");return self;}

,"io",unescape("cr%0D%0A%09%22%20Output%20a%20new%20line%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20writeln%3A%20%27%27"));

smalltalk.bind(smalltalk.BrowserScreen.$klass,"default","$$default"

,function (){var self=this;return self._at(screen);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bscreen%7D"));

smalltalk.bind(smalltalk.BrowserScreen,"width","width"

,function (){var self=this;return (self['@handle'].width || (0));return self;}

,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23width%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"height","height"

,function (){var self=this;return (self['@handle'].height || (0));return self;}

,"accessing",unescape("height%0D%0A%09%22%20Return%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23height%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"pixelDepth","pixelDepth"

,function (){var self=this;return (self['@handle'].pixelDepth || (0));return self;}

,"accessing",unescape("pixelDepth%0D%0A%09%22%20Return%20the%20pixelDepth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pixelDepth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"colorDepth","colorDepth"

,function (){var self=this;return (self['@handle'].colorDepth || (0));return self;}

,"accessing",unescape("colorDepth%0D%0A%09%22%20Return%20the%20colorDepth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23colorDepth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"availWidth","availWidth"

,function (){var self=this;return (self['@handle'].availWidth || (0));return self;}

,"accessing",unescape("availWidth%0D%0A%09%22%20Return%20the%20availWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23availWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"availHeight","availHeight"

,function (){var self=this;return (self['@handle'].availHeight || (0));return self;}

,"accessing",unescape("availHeight%0D%0A%09%22%20Return%20the%20availHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23availHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"avail","avail"

,function (){var self=this;return self.availWidth()._at(self.availHeight());return self;}

,"measuring",unescape("avail%0D%0A%09%22%20Return%20the%20extent%20of%20the%20receiver%20%28excluding%20taskbar%29.%20%22%0D%0A%0D%0A%09%5Eself%20availWidth%20@%20self%20availHeight"));

smalltalk.bind(smalltalk.BrowserScreen,"extent","extent"

,function (){var self=this;return self.width()._at(self.height());return self;}

,"measuring",unescape("extent%0D%0A%09%22%20Return%20the%20extent%20of%20the%20receiver%20%28excluding%20taskbar%29.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.BrowserNavigator.$klass,"default","$$default"

,function (){var self=this;return self._at(navigator);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D"));

smalltalk.bind(smalltalk.BrowserNavigator,"appCodeName","appCodeName"

,function (){var self=this;return (self.handle()["appCodeName"] || nil);return self;}

,"accessing",unescape("appCodeName%0D%0A%09%22%20Return%20the%20appCodeName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27appCodeName%27"));

smalltalk.bind(smalltalk.BrowserNavigator,"appName","appName"

,function (){var self=this;return (self.handle()["appName"] || nil);return self;}

,"accessing",unescape("appName%0D%0A%09%22%20Return%20the%20appName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27appName%27"));

smalltalk.bind(smalltalk.BrowserNavigator,"appVersion","appVersion"

,function (){var self=this;return (self.handle()["appVersion"] || nil);return self;}

,"accessing",unescape("appVersion%0D%0A%09%22%20Return%20the%20appVersion%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27appVersion%27"));

smalltalk.bind(smalltalk.BrowserNavigator,"platform","platform"

,function (){var self=this;return (self.handle()["platform"] || nil);return self;}

,"accessing",unescape("platform%0D%0A%09%22%20Return%20the%20platform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27platform%27"));

smalltalk.bind(smalltalk.BrowserNavigator,"userAgent","userAgent"

,function (){var self=this;return (self.handle()["userAgent"] || nil);return self;}

,"accessing",unescape("userAgent%0D%0A%09%22%20Return%20the%20userAgent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27userAgent%27"));

smalltalk.bind(smalltalk.BrowserNavigator,"cookieEnabled","cookieEnabled"

,function (){var self=this;return (self.handle()["cookieEnabled"] || nil);return self;}

,"accessing",unescape("cookieEnabled%0D%0A%09%22%20Return%20the%20cookieEnabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27cookieEnabled%27"));

smalltalk.bind(smalltalk.BrowserNavigator,"javaEnabled","javaEnabled"

,function (){var self=this;return self['@handle'].javaEnabled();return self;}

,"navigating",unescape("javaEnabled%0D%0A%09%22%20Specifies%20whether%20or%20not%20the%20browser%20has%20Java%20enabled.%20%22%0D%0A%0D%0A%09%5Ehandle%20javaEnabled"));

smalltalk.bind(smalltalk.BrowserNavigator,"taintEnabled","taintEnabled"

,function (){var self=this;return self['@handle'].taintEnabled();return self;}

,"navigating",unescape("taintEnabled%0D%0A%09%22%20Specifies%20whether%20or%20not%20the%20browser%20hashas%20data%20tainting%20enabled.%20%22%0D%0A%0D%0A%09%5Ehandle%20taintEnabled"));

smalltalk.bind(smalltalk.BrowserLocation.$klass,"default","$$default"

,function (){var self=this;return self._at(location);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Blocation%7D"));

smalltalk.bind(smalltalk.BrowserLocation,"hash","hash"

,function (){var self=this;return (self.handle()["hash"] || nil);return self;}

,"accessing",unescape("hash%0D%0A%09%22%20Return%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hash%27"));

smalltalk.bind(smalltalk.BrowserLocation,"host","host"

,function (){var self=this;return (self.handle()["host"] || nil);return self;}

,"accessing",unescape("host%0D%0A%09%22%20Return%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27host%27"));

smalltalk.bind(smalltalk.BrowserLocation,"hostname","hostname"

,function (){var self=this;return (self.handle()["hostname"] || nil);return self;}

,"accessing",unescape("hostname%0D%0A%09%22%20Return%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27hostname%27"));

smalltalk.bind(smalltalk.BrowserLocation,"href","href"

,function (){var self=this;return (self.handle()["href"] || nil);return self;}

,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27href%27"));

smalltalk.bind(smalltalk.BrowserLocation,"pathname","pathname"

,function (){var self=this;return (self.handle()["pathname"] || nil);return self;}

,"accessing",unescape("pathname%0D%0A%09%22%20Return%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27pathname%27"));

smalltalk.bind(smalltalk.BrowserLocation,"port","port"

,function (){var self=this;return (self.handle()["port"] || nil);return self;}

,"accessing",unescape("port%0D%0A%09%22%20Return%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27port%27"));

smalltalk.bind(smalltalk.BrowserLocation,"protocol","protocol"

,function (){var self=this;return (self.handle()["protocol"] || nil);return self;}

,"accessing",unescape("protocol%0D%0A%09%22%20Return%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27protocol%27"));

smalltalk.bind(smalltalk.BrowserLocation,"search","search"

,function (){var self=this;return (self.handle()["search"] || nil);return self;}

,"accessing",unescape("search%0D%0A%09%22%20Return%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27search%27"));

smalltalk.bind(smalltalk.BrowserLocation,"assign:","assign_"

,function (url){var self=this;return self['@handle'].assign(url);return self;}

,"navigating",unescape("assign%3A%20url%0D%0A%09%22%20Loads%20a%20new%20document.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23assign%3A%20url"));

smalltalk.bind(smalltalk.BrowserLocation,"reload","reload"

,function (){var self=this;return self['@handle'].reload();return self;}

,"navigating",unescape("reload%0D%0A%09%22%20Reload%20current%20document.%20%22%0D%0A%0D%0A%09%5Ehandle%20reload"));

smalltalk.bind(smalltalk.BrowserLocation,"replace:","replace_"

,function (url){var self=this;return self['@handle'].replace(url);return self;}

,"navigating",unescape("replace%3A%20url%0D%0A%09%22%20Replace%20with%20new%20document.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23replace%3A%20url"));

smalltalk.bind(smalltalk.BrowserHistory.$klass,"default","$$default"

,function (){var self=this;return self._at(history);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bhistory%7D"));

smalltalk.bind(smalltalk.BrowserHistory,"length","length"

,function (){var self=this;return self['@handle'].length;return self;}

,"accessing",unescape("length%0D%0A%09%22%20Returns%20the%20number%20of%20URLs%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length"));

smalltalk.bind(smalltalk.BrowserHistory,"size","size"

,function (){var self=this;return self.length();return self;}

,"accessing",unescape("size%0D%0A%09%22%20Returns%20the%20number%20of%20URLs%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20length"));

smalltalk.bind(smalltalk.BrowserHistory,"back","back"

,function (){var self=this;return self['@handle'].back();return self;}

,"navigating",unescape("back%0D%0A%09%22%20Load%20the%20previous%20URL%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20back"));

smalltalk.bind(smalltalk.BrowserHistory,"forward","forward"

,function (){var self=this;return self['@handle'].forward();return self;}

,"navigating",unescape("forward%0D%0A%09%22%20Load%20the%20next%20URL%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20forward"));

smalltalk.bind(smalltalk.BrowserHistory,"next","next"

,function (){var self=this;return self.forward();return self;}

,"navigating",unescape("next%0D%0A%09%22%20Load%20the%20next%20URL%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20forward"));

smalltalk.bind(smalltalk.BrowserHistory,"go:","go_"

,function (location){var self=this;return self['@handle'].go(location);return self;}

,"navigating",unescape("go%3A%20location%0D%0A%09%22%20Load%20the%20page%20in%20the%20receiver.%0D%0A%09The%20parameter%20can%20either%20be%20a%20number%20which%20goes%20to%20the%20URL%20within%20the%20specific%20position%20%28-1%20goes%20back%20one%20page%2C%201%20goes%20forward%20one%20page%29%2C%20or%20a%20string.%0D%0A%09The%20string%20must%20be%20a%20partial%20or%20full%20URL%2C%20and%20it%20will%20go%20to%20the%20first%20URL%20that%20matches%20the%20string.%0D%0A%09%22%0D%0A%0D%0A%09%5Ehandle%20%23go%3A%20location"));

smalltalk.bind(smalltalk.BrowserWindow.$klass,"default","$$default"

,function (){var self=this;return self._at(window);return self;}

,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bwindow%7D"));

smalltalk.bind(smalltalk.BrowserWindow,"name","name"

,function (){var self=this;return (self.handle()["name"] || nil);return self;}

,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%27name%27"));

smalltalk.bind(smalltalk.BrowserWindow,"name:","name_"

,function (anObject){var self=this;(self.handle()["name"]=(anObject));return self;}

,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27name%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"outerHeight","outerHeight"

,function (){var self=this;return (self['@handle'].outerHeight || (0));return self;}

,"accessing",unescape("outerHeight%0D%0A%09%22%20Return%20the%20outerHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outerHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"outerHeight:","outerHeight_"

,function (anObject){var self=this;(self.handle()["outerHeight"]=(anObject));return self;}

,"accessing",unescape("outerHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20outerHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27outerHeight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"outerWidth","outerWidth"

,function (){var self=this;return (self['@handle'].outerWidth || (0));return self;}

,"accessing",unescape("outerWidth%0D%0A%09%22%20Return%20the%20outerWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outerWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"outerWidth:","outerWidth_"

,function (anObject){var self=this;(self.handle()["outerWidth"]=(anObject));return self;}

,"accessing",unescape("outerWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20outerWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27outerWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"innerHeight","innerHeight"

,function (){var self=this;return (self['@handle'].innerHeight || (0));return self;}

,"accessing",unescape("innerHeight%0D%0A%09%22%20Return%20the%20innerHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23innerHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"innerHeight:","innerHeight_"

,function (anObject){var self=this;(self.handle()["innerHeight"]=(anObject));return self;}

,"accessing",unescape("innerHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20innerHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27innerHeight%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"innerWidth","innerWidth"

,function (){var self=this;return (self['@handle'].innerWidth || (0));return self;}

,"accessing",unescape("innerWidth%0D%0A%09%22%20Return%20the%20innerWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23innerWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"innerWidth:","innerWidth_"

,function (anObject){var self=this;(self.handle()["innerWidth"]=(anObject));return self;}

,"accessing",unescape("innerWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20innerWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%27innerWidth%27%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"pageXOffset","pageXOffset"

,function (){var self=this;return (self['@handle'].pageXOffset || (0));return self;}

,"accessing",unescape("pageXOffset%0D%0A%09%22%20Return%20the%20pageXOffset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageXOffset%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"pageYOffset","pageYOffset"

,function (){var self=this;return (self['@handle'].pageYOffset || (0));return self;}

,"accessing",unescape("pageYOffset%0D%0A%09%22%20Return%20the%20pageYOffset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageYOffset%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"screenLeft","screenLeft"

,function (){var self=this;return (self['@handle'].screenLeft || (0));return self;}

,"accessing",unescape("screenLeft%0D%0A%09%22%20Return%20the%20screenLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23screenLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"screenTop","screenTop"

,function (){var self=this;return (self['@handle'].screenTop || (0));return self;}

,"accessing",unescape("screenTop%0D%0A%09%22%20Return%20the%20screenTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23screenTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"screenX","screenX"

,function (){var self=this;return (self['@handle'].screenX || (0));return self;}

,"accessing",unescape("screenX%0D%0A%09%22%20Return%20the%20screenX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23screenX%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"screenY","screenY"

,function (){var self=this;return (self['@handle'].screenY || (0));return self;}

,"accessing",unescape("screenY%0D%0A%09%22%20Return%20the%20screenY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23screenY%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollX","scrollX"

,function (){var self=this;return (self['@handle'].scrollX || (0));return self;}

,"accessing",unescape("scrollX%0D%0A%09%22%20Return%20the%20scrollX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollX%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollY","scrollY"

,function (){var self=this;return (self['@handle'].scrollY || (0));return self;}

,"accessing",unescape("scrollY%0D%0A%09%22%20Return%20the%20scrollY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollY%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"closed","closed"

,function (){var self=this;return self['@handle'].closed;return self;}

,"query",unescape("closed%0D%0A%09%22%20Return%20a%20Boolean%20value%20indicating%20whether%20a%20window%20has%20been%20closed%20or%20not.%20%22%0D%0A%0D%0A%09%5Ehandle%23closed"));

smalltalk.bind(smalltalk.BrowserWindow,"defaultStatus","defaultStatus"

,function (){var self=this;return self['@handle'].defaultStatus;return self;}

,"accessing",unescape("defaultStatus%0D%0A%09%22%20Return%20the%20default%20text%20in%20the%20statusbar%20of%20a%20window.%20%22%0D%0A%0D%0A%09%5Ehandle%23defaultStatus"));

smalltalk.bind(smalltalk.BrowserWindow,"defaultStatus:","defaultStatus_"

,function (status){var self=this;return self['@handle'].defaultStatus=status;return self;}

,"accessing",unescape("defaultStatus%3A%20status%0D%0A%09%22%20Set%20the%20default%20text%20in%20the%20statusbar%20of%20a%20window.%20%22%0D%0A%0D%0A%09%5Ehandle%23defaultStatus%20%3A%3D%20status"));

smalltalk.bind(smalltalk.BrowserWindow,"document","document"

,function (){var self=this;return smalltalk.HTMLDocument.for_(self['@handle'].document);return self;}

,"accessing",unescape("document%0D%0A%09%22%20Return%20the%20Document%20object%20of%20the%20window.%20%22%0D%0A%0D%0A%09%5EHTMLDocument%20for%3A%20handle%23document"));

smalltalk.bind(smalltalk.BrowserWindow,"screen","screen"

,function (){var self=this;return smalltalk.BrowserScreen._at(self['@handle'].screen);return self;}

,"accessing",unescape("screen%0D%0A%09%22%20Return%20the%20screen%20information.%20%22%0D%0A%0D%0A%09%5EBrowserScreen%20@%20handle%23screen"));

smalltalk.bind(smalltalk.BrowserWindow,"frames","frames"

,function (){var self=this;return self.array_of_(self['@handle'].frames, smalltalk.HTMLFrame);return self;}

,"accessing",unescape("frames%0D%0A%09%22%20Return%20the%20frames%20%28including%20iframes%29%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23frames%20of%3A%20HTMLFrame"));

smalltalk.bind(smalltalk.BrowserWindow,"frameAt:","frameAt_"

,function (index){var self=this;return self.array_of_at_(self['@handle'].frames, smalltalk.HTMLFrame, index);return self;}

,"accessing",unescape("frameAt%3A%20index%0D%0A%09%22%20Return%20the%20frame%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23frames%20of%3A%20HTMLFrame%20at%3A%20index"));

smalltalk.bind(smalltalk.BrowserWindow,"framesDo:","framesDo_"

,function (aBlock){var self=this;return self.array_of_do_(self['@handle'].frames, smalltalk.HTMLFrame, aBlock);return self;}

,"accessing",unescape("framesDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20frames%20%28including%20iframes%29%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23frames%20of%3A%20HTMLFrame%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.BrowserWindow,"requestAnimationFrame:","requestAnimationFrame_"

,function (callbackBlock){var self=this;var aFunction=nil;aFunction=self.prefix_ifAbsentPut_("requestAnimationFrame", (function(){return (function(callback){return self['@handle'].setTimeout(callback, ((1000) / (60)));});}));

return aFunction.value_(callbackBlock);return self;}

,"animating",unescape("requestAnimationFrame%3A%20callbackBlock%0D%0A%09%22%20Schedule%20a%20repaint%20of%20the%20window%20for%20the%20next%20animation%20frame.%20%22%0D%0A%0D%0A%09%7C%20aFunction%20%7C%0D%0A%09aFunction%20%3A%3D%20self%20prefix%3A%20%23requestAnimationFrame%20ifAbsentPut%3A%20%5B%0D%0A%09%09%5B%3Acallback%7C%20handle%20%23setTimeout%3A%20callback%20with%3A%201000%20/%2060%20%5D%0D%0A%09%5D.%0D%0A%09%5EaFunction%20value%3A%20callbackBlock"));

smalltalk.bind(smalltalk.BrowserWindow,"cancelAnimationFrame:","cancelAnimationFrame_"

,function (requestID){var self=this;var aFunction=nil;aFunction=self.prefix_ifAbsentPut_("cancelAnimationFrame", (function(){return (function(id){return self['@handle'].clearTimeout(id);});}));

return aFunction.value_(requestID);return self;}

,"animating",unescape("cancelAnimationFrame%3A%20requestID%0D%0A%09%22%20Cancels%20an%20animation%20frame%20request%20previously%20scheduled.%20%22%0D%0A%0D%0A%09%7C%20aFunction%20%7C%0D%0A%09aFunction%20%3A%3D%20self%20prefix%3A%20%23cancelAnimationFrame%20ifAbsentPut%3A%20%5B%0D%0A%09%09%5B%3Aid%7C%20handle%20%23clearTimeout%3A%20id%20%5D%0D%0A%09%5D.%0D%0A%09%5EaFunction%20value%3A%20requestID"));

smalltalk.bind(smalltalk.BrowserWindow,"length","length"

,function (){var self=this;return self['@handle'].length;return self;}

,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20number%20of%20frames%20%28including%20iframes%29%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length"));

smalltalk.bind(smalltalk.BrowserWindow,"size","size"

,function (){var self=this;return self.length();return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20number%20of%20frames%20%28including%20iframes%29%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20length"));

smalltalk.bind(smalltalk.BrowserWindow,"history","history"

,function (){var self=this;return smalltalk.BrowserHistory._at(self['@handle'].history);return self;}

,"accessing",unescape("history%0D%0A%09%22%20Return%20the%20history%20of%20URLs%20visited%20by%20the%20user%20%28within%20a%20browser%20window%29.%20%22%0D%0A%0D%0A%09%5EBrowserHistory%20@%20handle%23history"));

smalltalk.bind(smalltalk.BrowserWindow,"navigator","navigator"

,function (){var self=this;return smalltalk.BrowserNavigator._at(self['@handle'].navigator);return self;}

,"accessing",unescape("navigator%0D%0A%09%22%20Return%20information%20about%20the%20browser.%20%22%0D%0A%0D%0A%09%5EBrowserNavigator%20@%20handle%23navigator"));

smalltalk.bind(smalltalk.BrowserWindow,"inner","inner"

,function (){var self=this;return self.innerWidth()._at(self.innerHeight());return self;}

,"accessing",unescape("inner%0D%0A%09%22%20Return%20the%20inner%20extent%20of%20the%20receiver%27s%20content%20area%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09%5Eself%20innerWidth%20@%20self%20innerHeight"));

smalltalk.bind(smalltalk.BrowserWindow,"inner:","inner_"

,function (aPoint){var self=this;(function($rec){$rec.innerWidth_(aPoint.x());return $rec.innerHeight_(aPoint.y());})(self);return self;}

,"accessing",unescape("inner%3A%20aPoint%0D%0A%09%22%20Set%20the%20inner%20extent%20of%20the%20receiver%27s%20content%20area%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09self%20innerWidth%3A%20aPoint%20x%3B%20innerHeight%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"outer","outer"

,function (){var self=this;return self.outerWidth()._at(self.outerHeight());return self;}

,"accessing",unescape("outer%0D%0A%09%22%20Return%20the%20outer%20extent%20of%20the%20receiver%27s%20content%20area%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09%5Eself%20outerWidth%20@%20self%20outerHeight"));

smalltalk.bind(smalltalk.BrowserWindow,"outer:","outer_"

,function (aPoint){var self=this;(function($rec){$rec.outerWidth_(aPoint.x());return $rec.outerHeight_(aPoint.y());})(self);return self;}

,"accessing",unescape("outer%3A%20aPoint%0D%0A%09%22%20Set%20the%20outer%20extent%20of%20the%20receiver%27s%20content%20area%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09self%20outerWidth%3A%20aPoint%20x%3B%20outerHeight%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"pageOffset","pageOffset"

,function (){var self=this;return self.pageXOffset()._at(self.pageYOffset());return self;}

,"accessing",unescape("pageOffset%0D%0A%09%22%20Return%20the%20amount%20pixels%20the%20current%20document%20has%20been%20scrolled%20from%20the%20upper%20left%20corner%20of%20the%20window.%20%22%0D%0A%0D%0A%09%5Eself%20pageXOffset%20@%20self%20pageYOffset"));

smalltalk.bind(smalltalk.BrowserWindow,"screenExtent","screenExtent"

,function (){var self=this;return self.screenX()._at(self.screenY());return self;}

,"accessing",unescape("screenExtent%0D%0A%09%22%20Return%20the%20screen%20extent%20in%20pixels.%20%22%0D%0A%0D%0A%09%5Eself%20screenX%20@%20self%20screenY"));

smalltalk.bind(smalltalk.BrowserWindow,"screenLeftTop","screenLeftTop"

,function (){var self=this;return self.screenLeft()._at(self.screenTop());return self;}

,"accessing",unescape("screenLeftTop%0D%0A%09%22%20Return%20the%20screen%20leftTop%20in%20pixels.%20%22%0D%0A%0D%0A%09%5Eself%20screenLeft%20@%20self%20screenTop"));

smalltalk.bind(smalltalk.BrowserWindow,"boundingBox","boundingBox"

,function (){var self=this;return self.screenLeftTop().extent_(self.screenExtent());return self;}

,"accessing",unescape("boundingBox%0D%0A%09%22%20Return%20the%20screen%20bounds%20in%20pixels.%20%22%0D%0A%0D%0A%09%5Eself%20screenLeftTop%20extent%3A%20self%20screenExtent"));

smalltalk.bind(smalltalk.BrowserWindow,"location","location"

,function (){var self=this;return smalltalk.BrowserLocation._at(self['@handle'].location);return self;}

,"accessing",unescape("location%0D%0A%09%22%20Return%20the%20Location%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EBrowserLocation%20@%20handle%23location"));

smalltalk.bind(smalltalk.BrowserWindow,"opener","opener"

,function (){var self=this;return smalltalk.BrowserWindow._at(self['@handle'].opener);return self;}

,"accessing",unescape("opener%0D%0A%09%22%20Return%20the%20window%20that%20created%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20handle%23opener"));

smalltalk.bind(smalltalk.BrowserWindow,"parent","parent"

,function (){var self=this;return smalltalk.BrowserWindow._at(self['@handle'].parent);return self;}

,"accessing",unescape("parent%0D%0A%09%22%20Return%20the%20parent%20window%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20handle%23parent"));

smalltalk.bind(smalltalk.BrowserWindow,"top","top"

,function (){var self=this;return smalltalk.BrowserWindow._at(self['@handle'].top);return self;}

,"accessing",unescape("top%0D%0A%09%22%20Return%20the%20topmost%20window%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20handle%23top"));

smalltalk.bind(smalltalk.BrowserWindow,"status:","status_"

,function (aStatus){var self=this;self['@handle'].status=aStatus;return self;}

,"accessing",unescape("status%3A%20aStatus%0D%0A%09%22%20Set%20the%20text%20in%20the%20status%20bar%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%23status%20%3A%3D%20aStatus"));

smalltalk.bind(smalltalk.BrowserWindow,"alert:","alert_"

,function (message){var self=this;return self['@handle'].alert(message);return self;}

,"navigating",unescape("alert%3A%20message%0D%0A%09%22%20Display%20an%20alert%20box%20with%20a%20specified%20message%20and%20an%20OK%20button.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23alert%3A%20message"));

smalltalk.bind(smalltalk.BrowserWindow,"blur","blur"

,function (){var self=this;return self['@handle'].blur();return self;}

,"navigating",unescape("blur%0D%0A%09%22%20Remove%20focus%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20blur"));

smalltalk.bind(smalltalk.BrowserWindow,"clearInterval:","clearInterval_"

,function (id){var self=this;return self['@handle'].clearInterval(id);return self;}

,"navigating",unescape("clearInterval%3A%20id%0D%0A%09%22%20Clear%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23clearInterval%3A%20id"));

smalltalk.bind(smalltalk.BrowserWindow,"clearTimeout:","clearTimeout_"

,function (id){var self=this;return self['@handle'].clearTimeout(id);return self;}

,"navigating",unescape("clearTimeout%3A%20id%0D%0A%09%22%20Clear%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23clearTimeout%3A%20id"));

smalltalk.bind(smalltalk.BrowserWindow,"setInterval:with:lang:","setInterval_with_lang_"

,function (code,milliseconds,lang){var self=this;return self['@handle'].setInterval(code, milliseconds, lang);return self;}

,"navigating",unescape("setInterval%3A%20code%20with%3A%20milliseconds%20lang%3A%20lang%0D%0A%09%22%20Set%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setInterval%3A%20code%20with%3A%20milliseconds%20with%3A%20lang"));

smalltalk.bind(smalltalk.BrowserWindow,"setInterval:with:","setInterval_with_"

,function (code,milliseconds){var self=this;return self['@handle'].setInterval(code, milliseconds);return self;}

,"navigating",unescape("setInterval%3A%20code%20with%3A%20milliseconds%0D%0A%09%22%20Set%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setInterval%3A%20code%20with%3A%20milliseconds"));

smalltalk.bind(smalltalk.BrowserWindow,"setTimeout:with:lang:","setTimeout_with_lang_"

,function (code,milliseconds,lang){var self=this;return self['@handle'].setTimeout(code, milliseconds, lang);return self;}

,"navigating",unescape("setTimeout%3A%20code%20with%3A%20milliseconds%20lang%3A%20lang%0D%0A%09%22%20Set%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setTimeout%3A%20code%20with%3A%20milliseconds%20with%3A%20lang"));

smalltalk.bind(smalltalk.BrowserWindow,"setTimeout:with:","setTimeout_with_"

,function (code,milliseconds){var self=this;return self['@handle'].setTimeout(code, milliseconds);return self;}

,"navigating",unescape("setTimeout%3A%20code%20with%3A%20milliseconds%0D%0A%09%22%20Set%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setTimeout%3A%20code%20with%3A%20milliseconds"));

smalltalk.bind(smalltalk.BrowserWindow,"close","close"

,function (){var self=this;return self['@handle'].close();return self;}

,"navigating",unescape("close%0D%0A%09%22%20Close%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20close"));

smalltalk.bind(smalltalk.BrowserWindow,"confirm:","confirm_"

,function (message){var self=this;return self['@handle'].confirm(message);return self;}

,"navigating",unescape("confirm%3A%20message%0D%0A%09%22%20Open%20a%20confirmation%20box.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23confirm%3A%20message"));

smalltalk.bind(smalltalk.BrowserWindow,"focus","focus"

,function (){var self=this;return self['@handle'].focus();return self;}

,"navigating",unescape("focus%0D%0A%09%22%20Set%20the%20focus%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20focus"));

smalltalk.bind(smalltalk.BrowserWindow,"moveBy:y:","moveBy_y_"

,function (x,y){var self=this;return self['@handle'].moveBy(x, y);return self;}

,"navigating",unescape("moveBy%3A%20x%20y%3A%20y%0D%0A%09%22%20Move%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23moveBy%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"moveTo:y:","moveTo_y_"

,function (x,y){var self=this;return self['@handle'].moveTo(x, y);return self;}

,"navigating",unescape("moveTo%3A%20x%20y%3A%20y%0D%0A%09%22%20Move%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23moveTo%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"resizeBy:y:","resizeBy_y_"

,function (x,y){var self=this;return self['@handle'].resizeBy(x, y);return self;}

,"navigating",unescape("resizeBy%3A%20x%20y%3A%20y%0D%0A%09%22%20Resize%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23resizeBy%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"resizeTo:y:","resizeTo_y_"

,function (x,y){var self=this;return self['@handle'].resizeTo(x, y);return self;}

,"navigating",unescape("resizeTo%3A%20x%20y%3A%20y%0D%0A%09%22%20Resize%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23resizeTo%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scroll","scroll"

,function (){var self=this;return self.scrollX()._at(self.scrollY());return self;}

,"navigating",unescape("scroll%0D%0A%09%22%20Return%20the%20scroll%20%28aPoint%29%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollX%20@%20self%20scrollY"));

smalltalk.bind(smalltalk.BrowserWindow,"scroll:","scroll_"

,function (aPoint){var self=this;return self['@handle'].scroll(aPoint.x(), aPoint.y());return self;}

,"navigating",unescape("scroll%3A%20aPoint%0D%0A%09%22%20Set%20the%20scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scroll%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollTo:y:","scrollTo_y_"

,function (x,y){var self=this;return self['@handle'].scrollTo(x, y);return self;}

,"navigating",unescape("scrollTo%3A%20x%20y%3A%20y%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scrollTo%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollBy:y:","scrollBy_y_"

,function (x,y){var self=this;return self['@handle'].scrollBy(x, y);return self;}

,"navigating",unescape("scrollBy%3A%20x%20y%3A%20y%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scrollBy%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollTo:","scrollTo_"

,function (aPoint){var self=this;return self['@handle'].scrollTo(aPoint.x(), aPoint.y());return self;}

,"navigating",unescape("scrollTo%3A%20aPoint%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scrollTo%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollBy:","scrollBy_"

,function (aPoint){var self=this;return self['@handle'].scrollBy(aPoint.x(), aPoint.y());return self;}

,"navigating",unescape("scrollBy%3A%20aPoint%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scrollBy%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"moveBy:","moveBy_"

,function (aPoint){var self=this;return self['@handle'].moveBy(aPoint.x(), aPoint.y());return self;}

,"navigating",unescape("moveBy%3A%20aPoint%0D%0A%09%22%20Move%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23moveBy%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"moveTo:","moveTo_"

,function (aPoint){var self=this;return self['@handle'].moveTo(aPoint.x(), aPoint.y());return self;}

,"navigating",unescape("moveTo%3A%20aPoint%0D%0A%09%22%20Move%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23moveTo%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"resizeBy:","resizeBy_"

,function (aPoint){var self=this;return self['@handle'].resizeBy(aPoint.x(), aPoint.y());return self;}

,"navigating",unescape("resizeBy%3A%20aPoint%0D%0A%09%22%20Resize%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23resizeBy%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"resizeTo:","resizeTo_"

,function (aPoint){var self=this;return self['@handle'].resizeTo(aPoint.x(), aPoint.y());return self;}

,"navigating",unescape("resizeTo%3A%20aPoint%0D%0A%09%22%20Resize%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23resizeTo%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"open:name:specs:replace:","open_name_specs_replace_"

,function (url,name,specs,replace){var self=this;return smalltalk.BrowserWindow._at(self['@handle'].open(url, name, specs, replace));return self;}

,"navigating",unescape("open%3A%20url%20name%3A%20name%20specs%3A%20specs%20replace%3A%20replace%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20%28handle%20%23open%3A%20url%20name%3A%20name%20specs%3A%20specs%20replace%3A%20replace%29"));

smalltalk.bind(smalltalk.BrowserWindow,"open:name:specs:","open_name_specs_"

,function (url,name,specs){var self=this;return smalltalk.BrowserWindow._at(self['@handle'].open(url, name, specs));return self;}

,"navigating",unescape("open%3A%20url%20name%3A%20name%20specs%3A%20specs%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20%28handle%20%23open%3A%20url%20name%3A%20name%20specs%3A%20specs%29"));

smalltalk.bind(smalltalk.BrowserWindow,"open:name:","open_name_"

,function (url,name){var self=this;return smalltalk.BrowserWindow._at(self['@handle'].open(url, name));return self;}

,"navigating",unescape("open%3A%20url%20name%3A%20name%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20%28handle%20%23open%3A%20url%20name%3A%20name%29"));

smalltalk.bind(smalltalk.BrowserWindow,"open:","open_"

,function (url){var self=this;return smalltalk.BrowserWindow._at(self['@handle'].open(url));return self;}

,"navigating",unescape("open%3A%20url%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20%28handle%20%23open%3A%20url%29"));

smalltalk.bind(smalltalk.BrowserWindow,"open","open"

,function (){var self=this;return smalltalk.BrowserWindow._at(self['@handle'].open());return self;}

,"navigating",unescape("open%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20handle%20open"));

smalltalk.bind(smalltalk.BrowserWindow,"print","print"

,function (){var self=this;return self['@handle'].print();return self;}

,"navigating",unescape("print%0D%0A%09%22%20Print%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20print"));

smalltalk.bind(smalltalk.BrowserWindow,"prompt:defaultText:","prompt_defaultText_"

,function (message,text){var self=this;return self['@handle'].prompt(message, text);return self;}

,"navigating",unescape("prompt%3A%20message%20defaultText%3A%20text%0D%0A%09%22%20Open%20a%20Prompter.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23prompt%3A%20message%20defaultText%3A%20text"));

smalltalk.bind(smalltalk.BrowserWindow,"prompt:","prompt_"

,function (message){var self=this;return self['@handle'].prompt(message);return self;}

,"navigating",unescape("prompt%3A%20message%0D%0A%09%22%20Open%20a%20Prompter.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23prompt%3A%20message"));

smalltalk.bind(smalltalk.Set.$klass,"newContents:","newContents_"

,function (contents){var self=this;return self.basicNew().initialize_(contents);return self;}

,"private",unescape("newContents%3A%20contents%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver%20initialized%20from%20given%20contents.%20%22%0D%0A%0D%0A%09%5Eself%20basicNew%20initialize%3A%20contents"));

smalltalk.bind(smalltalk.Set.$klass,"basicNew:","basicNew_"

,function (size){var self=this;return self.$$new();return self;}

,unescape("instance%20creation"),unescape("basicNew%3A%20size%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver%20of%20specified%20size.%20%22%0D%0A%0D%0A%09%5Eself%20new"));

smalltalk.bind(smalltalk.Set,"initialize","initialize"

,function (){var self=this;smalltalk.whoImplements(smalltalk.Set,'initialize').$superclass.$fn.prototype['initialize'].apply(self, []);

self['@contents']=[];return self;}

,"initialize",unescape("initialize%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%20%22%0D%0A%0D%0A%09super%20initialize.%0D%0A%09contents%20%3A%3D%20%23%28%29."));

smalltalk.bind(smalltalk.Set,"initialize:","initialize_"

,function (initializer){var self=this;self['@contents']=initializer;return self;}

,"initialize",unescape("initialize%3A%20initializer%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%20%22%0D%0A%0D%0A%09contents%20%3A%3D%20initializer."));

smalltalk.bind(smalltalk.Set,"size","size"

,function (){var self=this;return self['@contents'].size();return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Econtents%20size"));

smalltalk.bind(smalltalk.Set,"basicAdd:","basicAdd_"

,function (anObject){var self=this;self['@contents'].add_(anObject);

return anObject;return self;}

,"private",unescape("basicAdd%3A%20anObject%0D%0A%09%22%20Private%20-%20Add%20anObject%20to%20the%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%09contents%20add%3A%20anObject.%0D%0A%09%5EanObject"));

smalltalk.bind(smalltalk.Set,"includes:","includes_"

,function (anObject){var self=this;return self['@contents'].includes_(anObject);return self;}

,"testing",unescape("includes%3A%20anObject%0D%0A%09%22%20Return%20true%20if%20anObject%20is%20in%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%09%5Econtents%20includes%3A%20anObject"));

smalltalk.bind(smalltalk.Set,"add:","add_"

,function (anObject){var self=this;try{((self.includes_(anObject)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "add_", fn: function(){return anObject}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "add_", fn: function(){return self.basicAdd_(anObject)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "add_"){return $$ex.fn();} throw($$ex);}}

,"adding/removing",unescape("add%3A%20anObject%0D%0A%09%22%20Add%20anObject%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%28self%20includes%3A%20anObject%29%20ifTrue%3A%20%5B%20%5EanObject%20%5D.%0D%0A%09%5Eself%20basicAdd%3A%20anObject"));

smalltalk.bind(smalltalk.Set,"remove:ifAbsent:","remove_ifAbsent_"

,function (anObject,aBlock){var self=this;return self['@contents'].remove_ifAbsent_(anObject, aBlock);return self;}

,"adding/removing",unescape("remove%3A%20anObject%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Remove%20anObject%20from%20the%20receiver.%0D%0A%09Return%20the%20result%20of%20evaluating%20aBlock%20if%20anObject%20is%20not%20in%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%5Econtents%20remove%3A%20anObject%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.Set,"copyFrom:to:","copyFrom_to_"

,function (anIndex,anotherIndex){var self=this;return self.shouldNotImplement();return self;}

,"copying",unescape("copyFrom%3A%20anIndex%20to%3A%20anotherIndex%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20in%20interval.%20%22%0D%0A%0D%0A%09%5Eself%20shouldNotImplement"));

smalltalk.bind(smalltalk.Set,"asJavascript","asJavascript"

,function (){var self=this;return "smalltalk."._comma(self.$klass.name())._comma(unescape(".newContents_%28"))._comma(self['@contents'].asJavascript())._comma(unescape("%29"));return self;}

,"converting",unescape("asJavascript%0D%0A%09%22%20Return%20the%20javascript%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27smalltalk.%27%2Cself%20class%20name%0D%0A%09%09%2C%27.newContents_%28%27%2C%20contents%20asJavascript%20%2C%27%29%27"));

smalltalk.bind(smalltalk.Set,"=","_eq"

,function (aSet){var self=this;try{((self.$klass._eq(aSet.$klass)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());

((self.size()._eq(aSet.size())).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());

self.do_((function(each){return ((aSet.includes_(each)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());}));

(function(){throw({name: "stReturn", selector: "_eq", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_eq"){return $$ex.fn();} throw($$ex);}}

,"comparing",unescape("%3D%20aSet%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20equal%20to%20aSet.%20%22%0D%0A%0D%0A%09self%20class%20%3D%20aSet%20class%20ifFalse%3A%20%5B%5Efalse%5D.%0D%0A%09self%20size%20%3D%20aSet%20size%20ifFalse%3A%20%5B%5Efalse%5D.%0D%0A%09self%20do%3A%20%5B%3Aeach%20%7C%20%28aSet%20includes%3A%20each%29%20ifFalse%3A%20%5B%5Efalse%5D%20%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Set,"asArray","asArray"

,function (){var self=this;return self['@contents'].copy();return self;}

,"converting",unescape("asArray%0D%0A%09%22%20Return%20an%20array%20with%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Econtents%20copy"));

smalltalk.bind(smalltalk.Set,"do:","do_"

,function (aBlock){var self=this;return self['@contents'].do_(aBlock);return self;}

,"enumerating",unescape("do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Econtents%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.Set,"detect:ifNone:","detect_ifNone_"

,function (aBlock,anotherBlock){var self=this;return self['@contents'].detect_ifNone_(aBlock, anotherBlock);return self;}

,"enumerating",unescape("detect%3A%20aBlock%20ifNone%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver%20that%20return%20true%20when%20evaluated%20with%20aBlock%20or%20the%20result%20of%20evaluating%20anotherBlock.%20%22%0D%0A%0D%0A%09%5Econtents%20detect%3A%20aBlock%20ifNone%3A%20anotherBlock"));

smalltalk.bind(smalltalk.Set,"reverseDo:","reverseDo_"

,function (aBlock){var self=this;return self['@contents'].reverseDo_(aBlock);return self;}

,"enumerating",unescape("reverseDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20contents%20of%20the%20receiver%20in%20reverse%20order%20of%20iteration.%20%22%0D%0A%0D%0A%09%5Econtents%20reverseDo%3A%20aBlock"));

smalltalk.bind(smalltalk.Set,"collect:","collect_"

,function (aBlock){var self=this;return self.$klass.withAll_(self['@contents'].collect_(aBlock));return self;}

,"enumerating",unescape("collect%3A%20aBlock%0D%0A%09%22%20Return%20a%20collection%20with%20the%20result%20of%20evaluating%20aBlock%20with%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20withAll%3A%20%28contents%20collect%3A%20aBlock%29"));

smalltalk.bind(smalltalk.Set,"do:separatedBy:","do_separatedBy_"

,function (aBlock,anotherBlock){var self=this;return self['@contents'].do_separatedBy_(aBlock, anotherBlock);return self;}

,"enumerating",unescape("do%3A%20aBlock%20separatedBy%3A%20anotherBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20contents%20of%20the%20receiver%20evaluating%20anotherBlock%20inbetween%20aBlock%20evaluations.%20%22%0D%0A%0D%0A%09%5Econtents%20do%3A%20aBlock%20separatedBy%3A%20anotherBlock"));

smalltalk.bind(smalltalk.Set,"inject:into:","inject_into_"

,function (anObject,aBlock){var self=this;return self['@contents'].inject_into_(anObject, aBlock);return self;}

,"enumerating",unescape("inject%3A%20anObject%20into%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20result%20of%20previous%20evaluation%20and%20contents%20of%20the%20receiver.%0D%0A%09On%20first%20evaluation%20anObject%20is%20used%20as%20first%20argument%20to%20evaluate%20aBlock.%0D%0A%09%22%0D%0A%0D%0A%09%5Econtents%20inject%3A%20anObject%20into%3A%20aBlock"));

smalltalk.bind(smalltalk.Set,"select:","select_"

,function (aBlock){var self=this;return self.$klass.withAll_(self['@contents'].select_(aBlock));return self;}

,"enumerating",unescape("select%3A%20aBlock%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20elements%20wich%20evaluates%20aBlock%20to%20true.%20%22%0D%0A%0D%0A%09%5Eself%20class%20withAll%3A%20%28contents%20select%3A%20aBlock%29"));

smalltalk.bind(smalltalk.Set,"reject:","reject_"

,function (aBlock){var self=this;return self.$klass.withAll_(self['@contents'].reject_(aBlock));return self;}

,"enumerating",unescape("reject%3A%20aBlock%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver%20wich%20evaluates%20aBlock%20to%20false.%20%22%0D%0A%0D%0A%09%5Eself%20class%20withAll%3A%20%28contents%20reject%3A%20aBlock%29"));

smalltalk.bind(smalltalk.Set,"reversed","reversed"

,function (){var self=this;return self['@contents'].reversed();return self;}

,"copying",unescape("reversed%0D%0A%09%22%20Return%20an%20array%20with%20the%20contents%20of%20the%20receiver%20in%20reverse%20order.%20%22%0D%0A%0D%0A%09%5Econtents%20reversed"));

smalltalk.bind(smalltalk.Set,"notEmpty","notEmpty"

,function (){var self=this;return self['@contents'].notEmpty();return self;}

,"testing",unescape("notEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20not%20empty.%20%22%0D%0A%0D%0A%09%5Econtents%20notEmpty"));

smalltalk.bind(smalltalk.Set,"isEmpty","isEmpty"

,function (){var self=this;return self['@contents'].isEmpty();return self;}

,"testing",unescape("isEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%09%5Econtents%20isEmpty"));

smalltalk.bind(smalltalk.Set,"occurrencesOf:","occurrencesOf_"

,function (anObject){var self=this;return ((self.includes_(anObject)).mustBeBoolean()==true ? (function(){return (1);})() : (function(){return (0);})());return self;}

,"counting",unescape("occurrencesOf%3A%20anObject%0D%0A%09%22%20Return%20the%20occurrences%20of%20anObject%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28self%20includes%3A%20anObject%29%20ifTrue%3A%20%5B%201%20%5D%20ifFalse%3A%20%5B%200%20%5D"));

smalltalk.bind(smalltalk.Set,"asSet","asSet"

,function (){var self=this;return self;return self;}

,"converting",unescape("asSet%0D%0A%09%22%20Return%20the%20receiver%20contents%20in%20a%20Set.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Set,"shallowCopy","shallowCopy"

,function (){var self=this;return self.$klass.newContents_(self['@contents'].copy());return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20newContents%3A%20contents%20copy"));

smalltalk.bind(smalltalk.Set,"deepCopy","deepCopy"

,function (){var self=this;return self.$klass.newContents_(self['@contents'].deepCopy());return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20newContents%3A%20contents%20deepCopy"));

smalltalk.bind(smalltalk.Dictionary.$klass,"fromTuples:","fromTuples_"

,function (tuples){var self=this;return tuples.inject_into_(self.$$new(), (function(result, tuple){return (function($rec){$rec.at_put_(tuple.first(), tuple.last());return $rec.yourself();})(result);}));return self;}

,unescape("instance%20creation"),unescape("fromTuples%3A%20tuples%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etuples%20inject%3A%20self%20new%20into%3A%20%5B%3Aresult%20%3Atuple%7C%0D%0A%09%09result%0D%0A%09%09%09at%3A%20tuple%20first%20put%3A%20tuple%20last%3B%0D%0A%09%09%09yourself%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Dictionary.$klass,"fromKeys:and:","fromKeys_and_"

,function (keys,values){var self=this;return self.basicNew().initializeKeys_values_(keys, values);return self;}

,unescape("instance%20creation"),unescape("fromKeys%3A%20keys%20and%3A%20values%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicNew%20initializeKeys%3A%20keys%20values%3A%20values"));

smalltalk.bind(smalltalk.Dictionary.$klass,"basicNew:","basicNew_"

,function (size){var self=this;return self.$$new();return self;}

,unescape("instance%20creation"),unescape("basicNew%3A%20size%0D%0A%09%22%20Return%20a%20new%20instance%20of%20the%20receiver%20of%20specified%20size.%20%22%0D%0A%0D%0A%09%5Eself%20new"));

smalltalk.bind(smalltalk.Dictionary,"initialize","initialize"

,function (){var self=this;smalltalk.whoImplements(smalltalk.Dictionary,'initialize').$superclass.$fn.prototype['initialize'].apply(self, []);

self['@keys']=smalltalk.HashedSet.$$new();

self['@values']=[];return self;}

,"initialize",unescape("initialize%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%20%22%0D%0A%0D%0A%09super%20initialize.%0D%0A%09keys%20%3A%3D%20HashedSet%20new.%0D%0A%09values%20%3A%3D%20%23%28%29."));

smalltalk.bind(smalltalk.Dictionary,"initializeKeys:values:","initializeKeys_values_"

,function (privateKeys,privateValues){var self=this;smalltalk.whoImplements(smalltalk.Dictionary,'initialize').$superclass.$fn.prototype['initialize'].apply(self, []);

self['@keys']=smalltalk.HashedSet.newContents_(privateKeys);

self['@values']=privateValues.asArray();return self;}

,"initialize",unescape("initializeKeys%3A%20privateKeys%20values%3A%20privateValues%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%20%22%0D%0A%0D%0A%09super%20initialize.%0D%0A%09keys%20%3A%3D%20HashedSet%20newContents%3A%20privateKeys.%0D%0A%09values%20%3A%3D%20privateValues%20asArray."));

smalltalk.bind(smalltalk.Dictionary,"size","size"

,function (){var self=this;return self['@keys'].size();return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ekeys%20size"));

smalltalk.bind(smalltalk.Dictionary,"isEmpty","isEmpty"

,function (){var self=this;return self['@keys'].isEmpty();return self;}

,"testing",unescape("isEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%09%5Ekeys%20isEmpty"));

smalltalk.bind(smalltalk.Dictionary,"lookUpKey:","lookUpKey_"

,function (aKey){var self=this;return self['@keys'].indexOf_ifAbsent_(aKey, (function(){return nil;}));return self;}

,"private",unescape("lookUpKey%3A%20aKey%0D%0A%09%22%20Private%20-%20Return%20the%20index%20where%20aKey%20is%20found%2C%20or%20nil.%20%22%0D%0A%0D%0A%09%5Ekeys%20indexOf%3A%20aKey%20ifAbsent%3A%20%5B%20nil%20%5D"));

smalltalk.bind(smalltalk.Dictionary,"keysAndValuesDo:","keysAndValuesDo_"

,function (aBlock){var self=this;self['@keys'].withIndexDo_((function(aKey, index){return aBlock.value_value_(aKey, self['@values'].at_(index));}));return self;}

,"enumerating",unescape("keysAndValuesDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20key/value%20pairs%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09keys%20withIndexDo%3A%20%5B%3AaKey%20%3Aindex%20%7C%20aBlock%20value%3A%20aKey%20value%3A%20%28values%20at%3A%20index%29%20%5D"));

smalltalk.bind(smalltalk.Dictionary,"keys","keys"

,function (){var self=this;return self['@keys'].copy();return self;}

,"accessing",unescape("keys%0D%0A%09%22%20Return%20the%20keys%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ekeys%20copy"));

smalltalk.bind(smalltalk.Dictionary,"keysDo:","keysDo_"

,function (aBlock){var self=this;self['@keys'].do_(aBlock);return self;}

,"accessing",unescape("keysDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20keys%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09keys%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.Dictionary,"values","values"

,function (){var self=this;return self['@values'].copy();return self;}

,"accessing",unescape("values%0D%0A%09%22%20Return%20the%20values%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Evalues%20copy"));

smalltalk.bind(smalltalk.Dictionary,"at:put:","at_put_"

,function (aKey,aValue){var self=this;var index=nil;index=self.lookUpKey_(aKey);

((((index || nil) === nil)).mustBeBoolean()==true ? (function(){self['@keys'].add_(aKey);return self['@values'].add_(aValue);})() : (function(){return self['@values'].at_put_(index, aValue);})());

return aValue;return self;}

,"accessing",unescape("at%3A%20aKey%20put%3A%20aValue%0D%0A%09%22%20Set%20the%20value%20at%20aKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self%20lookUpKey%3A%20aKey.%0D%0A%09index%20isNil%0D%0A%09%09ifTrue%3A%20%5B%20keys%20add%3A%20aKey.%20values%20add%3A%20aValue.%5D%0D%0A%09%09ifFalse%3A%20%5B%20values%20at%3A%20index%20put%3A%20aValue%20%5D.%0D%0A%09%5EaValue"));

smalltalk.bind(smalltalk.Dictionary,"at:ifAbsent:","at_ifAbsent_"

,function (aKey,aBlock){var self=this;try{var index=nil;index=self.lookUpKey_(aKey);

((((index || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "at_ifAbsent_", fn: function(){return aBlock.value()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "at_ifAbsent_", fn: function(){return self['@values'].at_(index)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "at_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("at%3A%20aKey%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20value%20at%20aKey%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self%20lookUpKey%3A%20aKey.%0D%0A%09index%20isNil%20ifTrue%3A%20%5B%20%5EaBlock%20value%20%5D.%0D%0A%09%5Evalues%20at%3A%20index"));

smalltalk.bind(smalltalk.Dictionary,"at:ifAbsentPut:","at_ifAbsentPut_"

,function (aKey,aBlock){var self=this;try{var index=nil;index=self.lookUpKey_(aKey);

((((index || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "at_ifAbsentPut_", fn: function(){return self.at_put_(aKey, aBlock.value())}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "at_ifAbsentPut_", fn: function(){return self['@values'].at_(index)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "at_ifAbsentPut_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("at%3A%20aKey%20ifAbsentPut%3A%20aBlock%0D%0A%09%22%20Return%20the%20value%20at%20aKey%2C%20or%20add%20the%20result%20of%20evaluating%20aBlock%20to%20the%20receiver%20if%20it%20is%20absent.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self%20lookUpKey%3A%20aKey.%0D%0A%09index%20isNil%20ifTrue%3A%20%5B%20%5Eself%20at%3A%20aKey%20put%3A%20aBlock%20value%20%5D.%0D%0A%09%5Evalues%20at%3A%20index"));

smalltalk.bind(smalltalk.Dictionary,"at:ifPresent:","at_ifPresent_"

,function (aKey,aBlock){var self=this;try{var aValue=nil;aValue=self.at_ifAbsent_(aKey, (function(){return (function(){throw({name: "stReturn", selector: "at_ifPresent_", fn: function(){return nil}})})();}));

(function(){throw({name: "stReturn", selector: "at_ifPresent_", fn: function(){return aBlock.value_(aValue)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "at_ifPresent_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("at%3A%20aKey%20ifPresent%3A%20aBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%20if%20there%20is%20a%20value%20at%20aKey%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%7C%20aValue%20%7C%0D%0A%09aValue%20%3A%3D%20self%20at%3A%20aKey%20ifAbsent%3A%20%5B%20%5Enil%20%5D.%0D%0A%09%5EaBlock%20value%3A%20aValue"));

smalltalk.bind(smalltalk.Dictionary,"at:ifPresent:ifAbsent:","at_ifPresent_ifAbsent_"

,function (aKey,aBlock,anotherBlock){var self=this;try{var aValue=nil;aValue=self.at_ifAbsent_(aKey, (function(){return (function(){throw({name: "stReturn", selector: "at_ifPresent_ifAbsent_", fn: function(){return anotherBlock.value()}})})();}));

(function(){throw({name: "stReturn", selector: "at_ifPresent_ifAbsent_", fn: function(){return aBlock.value_(aValue)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "at_ifPresent_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("at%3A%20aKey%20ifPresent%3A%20aBlock%20ifAbsent%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20aBlock%20if%20there%20is%20a%20value%20at%20aKey%20%28or%20the%20result%20of%20evaluating%20anotherBlock%29.%20%22%0D%0A%0D%0A%09%7C%20aValue%20%7C%0D%0A%09aValue%20%3A%3D%20self%20at%3A%20aKey%20ifAbsent%3A%20%5B%20%5EanotherBlock%20value%20%5D.%0D%0A%09%5EaBlock%20value%3A%20aValue"));

smalltalk.bind(smalltalk.Dictionary,"add:","add_"

,function (anAssociation){var self=this;self.at_put_(anAssociation.key(), anAssociation.value());

return anAssociation;return self;}

,"adding/removing",unescape("add%3A%20anAssociation%0D%0A%09%22%20Bind%20anAssociation%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20at%3A%20anAssociation%20key%20put%3A%20anAssociation%20value.%0D%0A%09%5EanAssociation"));

smalltalk.bind(smalltalk.Dictionary,"addAll:","addAll_"

,function (aDictionary){var self=this;smalltalk.whoImplements(smalltalk.Dictionary,'addAll_').$superclass.$fn.prototype['addAll_'].apply(self, [aDictionary.associations()]);

return aDictionary;return self;}

,"adding/removing",unescape("addAll%3A%20aDictionary%0D%0A%09%22%20Bind%20all%20associations%20in%20aDictionary%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09super%20addAll%3A%20aDictionary%20associations.%0D%0A%09%5EaDictionary"));

smalltalk.bind(smalltalk.Dictionary,"associations","associations"

,function (){var self=this;var result=nil;result=smalltalk.Array.$$new();

self.associationsDo_((function(each){return result.add_(each);}));

return result;return self;}

,"accessing",unescape("associations%0D%0A%09%22%20Return%20the%20associations%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09self%20associationsDo%3A%20%5B%3Aeach%7C%20result%20add%3A%20each%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Dictionary,"associationsDo:","associationsDo_"

,function (aBlock){var self=this;self.keysAndValuesDo_((function(key, value){return aBlock.value_(smalltalk.Association.key_value_(key, value));}));return self;}

,"enumerating",unescape("associationsDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20for%20all%20the%20receiver%27s%20associations.%20%22%0D%0A%0D%0A%09self%20keysAndValuesDo%3A%20%5B%3Akey%20%3Avalue%7C%0D%0A%09%09aBlock%20value%3A%20%28Association%20key%3A%20key%20value%3A%20value%29%0D%0A%09%5D."));

smalltalk.bind(smalltalk.Dictionary,"do:","do_"

,function (aBlock){var self=this;return self['@values'].do_(aBlock);return self;}

,"enumerating",unescape("do%3A%20aBlock%0D%0A%09%22%20Evaluates%20aBlock%20for%20all%20values%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Evalues%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.Dictionary,"select:","select_"

,function (aBlock){var self=this;var result=nil;result=self.$klass.$$new();

self.keysAndValuesDo_((function(key, value){return ((aBlock.value_(value)).mustBeBoolean()==true ? (function(){return result.at_put_(key, value);})() : nil);}));

return result;return self;}

,"enumerating",unescape("select%3A%20aBlock%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver%20wich%20evaluates%20aBlock%20to%20true.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20class%20new.%0D%0A%09self%20keysAndValuesDo%3A%20%5B%3Akey%20%3Avalue%20%7C%0D%0A%09%09%28aBlock%20value%3A%20value%29%20ifTrue%3A%20%5B%20result%20at%3A%20key%20put%3A%20value%20%5D%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Dictionary,"collect:","collect_"

,function (aBlock){var self=this;var result=nil;result=self.$klass.$$new();

self.keysAndValuesDo_((function(key, value){return result.at_put_(key, aBlock.value_(value));}));

return result;return self;}

,"enumerating",unescape("collect%3A%20aBlock%0D%0A%09%22%20Return%20a%20dictionary%20with%20keys%20and%20result%20of%20evaluating%20aBlock%20with%20value.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20class%20new.%0D%0A%09self%20keysAndValuesDo%3A%20%5B%3Akey%20%3Avalue%20%7C%0D%0A%09%09result%20at%3A%20key%20put%3A%20%28aBlock%20value%3A%20value%29%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Dictionary,"detect:ifNone:","detect_ifNone_"

,function (aBlock,anotherBlock){var self=this;return self['@values'].detect_ifNone_(aBlock, anotherBlock);return self;}

,"enumerating",unescape("detect%3A%20aBlock%20ifNone%3A%20anotherBlock%0D%0A%09%22%20Detect%20the%20value%20who%20matches%20aBlock.%0D%0A%09Return%20the%20result%20of%20evaluating%20aBlock%20if%20no%20value%20matches%20detection%20block.%0D%0A%09%22%0D%0A%0D%0A%09%5Evalues%20detect%3A%20aBlock%20ifNone%3A%20anotherBlock"));

smalltalk.bind(smalltalk.Dictionary,"includes:","includes_"

,function (anObject){var self=this;return self['@values'].includes_(anObject);return self;}

,"enumerating",unescape("includes%3A%20anObject%0D%0A%09%22%20Return%20true%20if%20the%20receiver%27s%20values%20include%20anObject.%20%22%0D%0A%0D%0A%09%5Evalues%20includes%3A%20anObject"));

smalltalk.bind(smalltalk.Dictionary,"includesKey:","includesKey_"

,function (aKey){var self=this;return self['@keys'].includes_(aKey);return self;}

,"enumerating",unescape("includesKey%3A%20aKey%0D%0A%09%22%20Return%20true%20if%20the%20receiver%27s%20keys%20include%20aKey.%20%22%0D%0A%0D%0A%09%5Ekeys%20includes%3A%20aKey"));

smalltalk.bind(smalltalk.Dictionary,"remove:","remove_"

,function (aKey){var self=this;self.removeKey_(aKey);return self;}

,"adding/removing",unescape("remove%3A%20aKey%0D%0A%09%22%20Remove%20the%20binding%20at%20aKey.%20%22%0D%0A%0D%0A%09self%20removeKey%3A%20aKey"));

smalltalk.bind(smalltalk.Dictionary,"removeKey:","removeKey_"

,function (aKey){var self=this;return self.removeKey_ifAbsent_(aKey, (function(){return self.errorNotFound();}));return self;}

,"adding/removing",unescape("removeKey%3A%20aKey%0D%0A%09%22%20Remove%20the%20binding%20at%20aKey.%0D%0A%09Signal%20an%20error%20if%20the%20key%20is%20not%20present.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20removeKey%3A%20aKey%20ifAbsent%3A%20%5B%20self%20errorNotFound%20%5D"));

smalltalk.bind(smalltalk.Dictionary,"removeKey:ifAbsent:","removeKey_ifAbsent_"

,function (aKey,aBlock){var self=this;try{var index=nil;index=self.lookUpKey_(aKey);

((((index || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "removeKey_ifAbsent_", fn: function(){return aBlock.value()}})})();})() : nil);

self['@keys'].removeIndex_(index);

self['@values'].removeIndex_(index);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "removeKey_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"adding/removing",unescape("removeKey%3A%20aKey%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Remove%20the%20binding%20at%20aKey.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self%20lookUpKey%3A%20aKey.%0D%0A%09index%20isNil%20ifTrue%3A%20%5B%20%5EaBlock%20value%20%5D.%0D%0A%09keys%20removeIndex%3A%20index.%0D%0A%09values%20removeIndex%3A%20index."));

smalltalk.bind(smalltalk.Dictionary,"at:","at_"

,function (aKey){var self=this;return self.at_ifAbsent_(aKey, (function(){return self.errorNotFound();}));return self;}

,"accessing",unescape("at%3A%20aKey%0D%0A%09%22%20Return%20the%20value%20at%20aKey.%0D%0A%09Signal%20an%20error%20if%20the%20key%20is%20not%20present.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20at%3A%20aKey%20ifAbsent%3A%20%5B%20self%20errorNotFound%20%5D"));

smalltalk.bind(smalltalk.Dictionary,",","_comma"

,function (aCollection){var self=this;return self.shouldNotImplement();return self;}

,"copying",unescape("%2C%20aCollection%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20aCollection%20appended.%20%22%0D%0A%0D%0A%09%5Eself%20shouldNotImplement"));

smalltalk.bind(smalltalk.Dictionary,"copyFrom:to:","copyFrom_to_"

,function (anIndex,anotherIndex){var self=this;return self.shouldNotImplement();return self;}

,"copying",unescape("copyFrom%3A%20anIndex%20to%3A%20anotherIndex%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20in%20interval.%20%22%0D%0A%0D%0A%09%5Eself%20shouldNotImplement"));

smalltalk.bind(smalltalk.Dictionary,"asJSONObject","asJSONObject"

,function (){var self=this;var result=nil;var value=nil;result={};

self.keysAndValuesDo_((function(key, aValue){value=((self.isObject_(aValue)).mustBeBoolean()==true ? (function(){return aValue.asJSONObject();})() : (function(){return aValue;})());return (result[key]=(value));}));

return result;return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20object%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%7C%20result%20value%20%7C%0D%0A%09result%20%3A%3D%20%7B%27%7B%7D%27%7D.%0D%0A%09self%20keysAndValuesDo%3A%20%5B%3Akey%20%3AaValue%20%7C%0D%0A%09%09value%20%3A%3D%20%28self%20isObject%3A%20aValue%29%0D%0A%09%09%09ifTrue%3A%20%5B%20aValue%20asJSONObject%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20aValue%20%5D.%0D%0A%09%09result%20basicAt%3A%20key%20put%3A%20value%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Dictionary,"asJavascript","asJavascript"

,function (){var self=this;return "smalltalk."._comma(self.$klass.name())._comma(unescape(".fromKeys_and_%28"))._comma(self['@keys'].asArray().asJavascript())._comma(unescape("%2C"))._comma(self['@values'].asJavascript())._comma(unescape("%29"));return self;}

,"converting",unescape("asJavascript%0D%0A%09%22%20Return%20the%20javascript%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27smalltalk.%27%2Cself%20class%20name%0D%0A%09%09%2C%27.fromKeys_and_%28%27%20%2Ckeys%20asArray%20asJavascript%0D%0A%09%09%09%2C%27%2C%27%20%2Cvalues%20asJavascript%20%2C%27%29%27"));

smalltalk.bind(smalltalk.Dictionary,"=","_eq"

,function (anObject){var self=this;try{((self.$klass._eq(anObject.$klass)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());

((self.size()._eq(anObject.size())).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());

self.keysAndValuesDo_((function(key, value){return ((anObject.at_ifAbsent_(key, (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();}))._eq(value)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());}));

(function(){throw({name: "stReturn", selector: "_eq", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_eq"){return $$ex.fn();} throw($$ex);}}

,"comparing",unescape("%3D%20anObject%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20equal%20to%20anObject.%20%22%0D%0A%0D%0A%09self%20class%20%3D%20anObject%20class%20ifFalse%3A%20%5B%5Efalse%5D.%0D%0A%09self%20size%20%3D%20anObject%20size%20ifFalse%3A%20%5B%5Efalse%5D.%0D%0A%09self%20keysAndValuesDo%3A%20%5B%3Akey%20%3Avalue%20%7C%0D%0A%09%09%28anObject%20at%3A%20key%20ifAbsent%3A%20%5B%5Efalse%5D%29%0D%0A%09%09%09%3D%20value%20ifFalse%3A%20%5B%5Efalse%5D%0D%0A%09%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Dictionary,"shallowCopy","shallowCopy"

,function (){var self=this;var result=nil;result=self.$klass.$$new();

self.keysAndValuesDo_((function(key, value){return result.at_put_(key, value);}));

return result;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20class%20new.%0D%0A%09self%20keysAndValuesDo%3A%20%5B%3Akey%20%3Avalue%20%7C%20result%20at%3A%20key%20put%3A%20value%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Dictionary,"deepCopy","deepCopy"

,function (){var self=this;var result=nil;result=self.$klass.$$new();

self.keysAndValuesDo_((function(key, value){return result.at_put_(key, value.deepCopy());}));

return result;return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20class%20new.%0D%0A%09self%20keysAndValuesDo%3A%20%5B%3Akey%20%3Avalue%20%7C%20result%20at%3A%20key%20put%3A%20value%20deepCopy%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.SequenceableCollection,"at:","at_"

,function (anIndex){var self=this;return self.at_ifAbsent_(anIndex, (function(){return self.errorNotFound();}));return self;}

,"accessing",unescape("at%3A%20anIndex%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver%20at%20anIndex%20position.%20%22%0D%0A%0D%0A%09%5Eself%20at%3A%20anIndex%20ifAbsent%3A%20%5B%20self%20errorNotFound%20%5D"));

smalltalk.bind(smalltalk.SequenceableCollection,"at:ifAbsent:","at_ifAbsent_"

,function (anIndex,aBlock){var self=this;return self.subclassResponsibility();return self;}

,"accessing",unescape("at%3A%20anIndex%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver%20at%20anIndex%20position%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5Eself%20subclassResponsibility"));

smalltalk.bind(smalltalk.SequenceableCollection,"at:put:","at_put_"

,function (anIndex,anObject){var self=this;return self.subclassResponsibility();return self;}

,"accessing",unescape("at%3A%20anIndex%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20object%20in%20the%20receiver%20at%20anIndex%20position.%20%22%0D%0A%0D%0A%09%5Eself%20subclassResponsibility"));

smalltalk.bind(smalltalk.SequenceableCollection,"copyFrom:to:","copyFrom_to_"

,function (anIndex,anotherIndex){var self=this;return self.subclassResponsibility();return self;}

,"copying",unescape("copyFrom%3A%20anIndex%20to%3A%20anotherIndex%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20subclassResponsibility"));

smalltalk.bind(smalltalk.SequenceableCollection,"indexOf:ifAbsent:","indexOf_ifAbsent_"

,function (anObject,aBlock){var self=this;	var i = self.length;
	while (i--) { if (self[i]._eq(anObject)) { return i + 1; } }
	return aBlock();;return self;}

,"query",unescape("indexOf%3A%20anObject%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20position%20of%20anObject%20in%20the%20receiver%2C%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%7B%27%09var%20i%20%3D%20self.length%3B%0D%0A%09while%20%28i--%29%20%7B%20if%20%28self%5Bi%5D._eq%28anObject%29%29%20%7B%20return%20i%20+%201%3B%20%7D%20%7D%0D%0A%09return%20aBlock%28%29%3B%27%7D"));

smalltalk.bind(smalltalk.SequenceableCollection,"indexOf:","indexOf_"

,function (anObject){var self=this;return self.indexOf_ifAbsent_(anObject, (function(){return (0);}));return self;}

,"query",unescape("indexOf%3A%20anObject%0D%0A%09%22%20Return%20the%20position%20of%20anObject%20in%20the%20receiver%2C%20or%200.%20%22%0D%0A%0D%0A%09%5Eself%20indexOf%3A%20anObject%20ifAbsent%3A%20%5B%200%20%5D"));

smalltalk.bind(smalltalk.SequenceableCollection,"first","first"

,function (){var self=this;return self.at_((1));return self;}

,"accessing",unescape("first%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20at%3A%201"));

smalltalk.bind(smalltalk.SequenceableCollection,"fourth","fourth"

,function (){var self=this;return self.at_((4));return self;}

,"accessing",unescape("fourth%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20at%3A%204"));

smalltalk.bind(smalltalk.SequenceableCollection,"last","last"

,function (){var self=this;return self.at_(self.size());return self;}

,"accessing",unescape("last%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20at%3A%20self%20size"));

smalltalk.bind(smalltalk.SequenceableCollection,"second","second"

,function (){var self=this;return self.at_((2));return self;}

,"accessing",unescape("second%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20at%3A%202"));

smalltalk.bind(smalltalk.SequenceableCollection,"third","third"

,function (){var self=this;return self.at_((3));return self;}

,"accessing",unescape("third%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20at%3A%203"));

smalltalk.bind(smalltalk.SequenceableCollection,"removeLast","removeLast"

,function (){var self=this;return self.remove_(self.last());return self;}

,"adding/removing",unescape("removeLast%0D%0A%09%22%20Remove%20the%20last%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20remove%3A%20self%20last"));

smalltalk.bind(smalltalk.SequenceableCollection,"removeFirst","removeFirst"

,function (){var self=this;return self.remove_(self.first());return self;}

,"adding/removing",unescape("removeFirst%0D%0A%09%22%20Remove%20the%20first%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20remove%3A%20self%20first"));

smalltalk.bind(smalltalk.SequenceableCollection,"addLast:","addLast_"

,function (anObject){var self=this;return self.add_(anObject);return self;}

,"adding/removing",unescape("addLast%3A%20anObject%0D%0A%09%22%20Add%20the%20object%20in%20the%20receiver%20%28at%20end%29.%20%22%0D%0A%0D%0A%09%5Eself%20add%3A%20anObject"));

smalltalk.bind(smalltalk.SequenceableCollection,"atAll:put:","atAll_put_"

,function (aCollection,anObject){var self=this;indices.do_((function(index){return self.at_put_(index, anObject);}));return self;}

,"adding/removing",unescape("atAll%3A%20aCollection%20put%3A%20anObject%0D%0A%09%22%20Return%20the%20receiver%20after%20replacing%20those%20elements%2C%20indexed%20by%20the%20indices%2C%20with%20anObject.%20%22%0D%0A%0D%0A%09indices%20do%3A%20%5B%20%3Aindex%20%7C%20self%20at%3A%20index%20put%3A%20anObject%20%5D"));

smalltalk.bind(smalltalk.SequenceableCollection,"atAllPut:","atAllPut_"

,function (anObject){var self=this;(1).to_(self.size()).do_((function(index){return self.at_put_(index, anObject);}));return self;}

,"adding/removing",unescape("atAllPut%3A%20anObject%0D%0A%09%22%20Replace%20all%20elements%20of%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%09%281%20to%3A%20self%20size%29%20do%3A%20%5B%20%3Aindex%20%7C%20self%20at%3A%20index%20put%3A%20anObject%20%5D"));

smalltalk.bind(smalltalk.SequenceableCollection,"withIndexDo:","withIndexDo_"

,function (aBlock){var self=this;(1).to_(self.size()).do_((function(index){return aBlock.value_value_(self.at_(index), index);}));return self;}

,"enumerating",unescape("withIndexDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20the%20index%20positions%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%281%20to%3A%20self%20size%29%20do%3A%20%5B%20%3Aindex%20%7C%0D%0A%09%09aBlock%20value%3A%20%28self%20at%3A%20index%29%20value%3A%20index%0D%0A%09%5D"));

smalltalk.bind(smalltalk.SequenceableCollection,"=","_eq"

,function (aCollection){var self=this;try{var index=nil;(((self === aCollection)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return true}})})();})() : nil);

(((self.$klass === aCollection.$klass)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());

index=self.size();

((index._no_eq(aCollection.size())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})() : nil);

(function(){while(!(function(){return (index <= (0));})()){(function(){((self.at_(index)._eq(aCollection.at_(index))).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_eq", fn: function(){return false}})})();})());return index=(index - (1));})()};return nil})();

(function(){throw({name: "stReturn", selector: "_eq", fn: function(){return true}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_eq"){return $$ex.fn();} throw($$ex);}}

,"testing",unescape("%3D%20aCollection%0D%0A%09%22%20Return%20true%20if%20the%20elements%20contained%20by%20the%20receiver%20are%20equal%20to%20the%20elements%20contained%20in%20aCollection.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09self%20%3D%3D%20aCollection%20ifTrue%3A%20%5B%20%5Etrue%20%5D.%0D%0A%09self%20class%20%3D%3D%20aCollection%20class%20ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09index%20%3A%3D%20self%20size.%0D%0A%09index%20%7E%3D%20aCollection%20size%20ifTrue%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%5B%20index%20%3C%3D%200%20%5D%20whileFalse%3A%20%5B%0D%0A%09%09%28self%20at%3A%20index%29%20%3D%20%28aCollection%20at%3A%20index%29%20ifFalse%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09%09index%20%3A%3D%20index%20-%201%0D%0A%09%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.SequenceableCollection,"beginsWith:","beginsWith_"

,function (aCollection){var self=this;try{((self.size()._lt(aCollection.size())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "beginsWith_", fn: function(){return false}})})();})() : nil);

((self.size()._eq(aCollection.size())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "beginsWith_", fn: function(){return aCollection._eq(self)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "beginsWith_", fn: function(){return aCollection._eq(self.copyFrom_to_((1), aCollection.size()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "beginsWith_"){return $$ex.fn();} throw($$ex);}}

,"testing",unescape("beginsWith%3A%20aCollection%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20begins%20with%20aCollection.%20%22%0D%0A%0D%0A%09self%20size%20%3C%20aCollection%20size%20ifTrue%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09self%20size%20%3D%20aCollection%20size%20ifTrue%3A%20%5B%20%5EaCollection%20%3D%20self%20%5D.%0D%0A%09%5EaCollection%20%3D%20%28self%20copyFrom%3A%201%20to%3A%20aCollection%20size%29"));

smalltalk.bind(smalltalk.SequenceableCollection,"endsWith:","endsWith_"

,function (aCollection){var self=this;try{((self.size()._lt(aCollection.size())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "endsWith_", fn: function(){return false}})})();})() : nil);

((self.size()._eq(aCollection.size())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "endsWith_", fn: function(){return aCollection._eq(self)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "endsWith_", fn: function(){return aCollection._eq(self.copyFrom_to_((self.size()._minus(aCollection.size()) + (1)), self.size()))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "endsWith_"){return $$ex.fn();} throw($$ex);}}

,"testing",unescape("endsWith%3A%20aCollection%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20ends%20with%20aCollection.%20%22%0D%0A%0D%0A%09self%20size%20%3C%20aCollection%20size%20ifTrue%3A%20%5B%20%5Efalse%20%5D.%0D%0A%09self%20size%20%3D%20aCollection%20size%20ifTrue%3A%20%5B%20%5EaCollection%20%3D%20self%20%5D.%0D%0A%09%5EaCollection%20%3D%20%28self%20copyFrom%3A%20self%20size%20-%20aCollection%20size%20+%201%20to%3A%20self%20size%29"));

smalltalk.bind(smalltalk.SequenceableCollection,"copyReplaceFrom:to:with:","copyReplaceFrom_to_with_"

,function (start,stop,aCollection){var self=this;return self.copyFrom_to_((1), (start - (1)))._comma(aCollection)._comma(self.copyFrom_to_((stop + (1)), self.size()));return self;}

,"copying",unescape("copyReplaceFrom%3A%20start%20to%3A%20stop%20with%3A%20aCollection%0D%0A%09%22%20Return%20a%20collection%20containing%20a%20copy%20of%20the%20receiver%20with%20the%20elements%20at%20index%20positions%20from%20start%20through%20stop%20replaced%20with%20the%20elements%20of%20aCollection.%20%22%0D%0A%0D%0A%09%5E%28self%20copyFrom%3A%201%20to%3A%20start%20-%201%29%0D%0A%09%09%2C%20aCollection%0D%0A%09%09%2C%20%28self%20copyFrom%3A%20stop%20+%201%20to%3A%20self%20size%29"));

smalltalk.bind(smalltalk.SequenceableCollection,"copyWithout:","copyWithout_"

,function (anObject){var self=this;try{var index=nil;index=self.indexOf_ifAbsent_(anObject, (function(){return (function(){throw({name: "stReturn", selector: "copyWithout_", fn: function(){return self.copy()}})})();}));

(function(){throw({name: "stReturn", selector: "copyWithout_", fn: function(){return self.copyFrom_to_((1), (index - (1)))._comma(self.copyFrom_to_((index + (1)), self.size()).copyWithout_(anObject))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "copyWithout_"){return $$ex.fn();} throw($$ex);}}

,"copying",unescape("copyWithout%3A%20anObject%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20excluding%20the%20first%20element%20that%20equals%20anObject%2C%20if%20any.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self%20indexOf%3A%20anObject%20ifAbsent%3A%20%5B%20%5Eself%20copy%20%5D.%0D%0A%09%5E%28self%20copyFrom%3A%201%20to%3A%20index%20-%201%29%0D%0A%09%09%2C%28%28self%20copyFrom%3A%20index%20+%201%20to%3A%20self%20size%29%0D%0A%09%09%09copyWithout%3A%20anObject%29"));

smalltalk.bind(smalltalk.SequenceableCollection,"copyWithAll:","copyWithAll_"

,function (aCollection){var self=this;return self._comma(aCollection);return self;}

,"copying",unescape("copyWithAll%3A%20aCollection%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20all%20contents%20of%20aCollection.%20%22%0D%0A%0D%0A%09%5Eself%20%2C%20aCollection%20"));

smalltalk.bind(smalltalk.SequenceableCollection,"findFirst:","findFirst_"

,function (aBlock){var self=this;return self.findFirst_ifAbsent_(aBlock, (function(){return self.errorAbsentObject();}));return self;}

,"searching",unescape("findFirst%3A%20aBlock%0D%0A%09%22%20Return%20the%20index%20of%20the%20first%20element%20of%20the%20receiver%20that%20causes%20aBlock%20to%20evaluate%20to%20true.%0D%0A%20%20%20%20%20%20%20%20%20If%20no%20such%20element%20is%20found%2C%20report%20an%20error.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20findFirst%3A%20aBlock%20ifAbsent%3A%20%5B%20self%20errorAbsentObject%20%5D"));

smalltalk.bind(smalltalk.SequenceableCollection,"findFirst:ifAbsent:","findFirst_ifAbsent_"

,function (aBlock,absentBlock){var self=this;try{var index=nil;var size=nil;size=self.size();

index=(1);

(function(){while((function(){return index._lt_eq(size);})()){(function(){((aBlock.value_(self.at_(index))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "findFirst_ifAbsent_", fn: function(){return index}})})();})() : nil);return index=(index + (1));})()};return nil})();

(function(){throw({name: "stReturn", selector: "findFirst_ifAbsent_", fn: function(){return absentBlock.value()}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "findFirst_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"searching",unescape("findFirst%3A%20aBlock%20ifAbsent%3A%20absentBlock%0D%0A%09%22%20Return%20the%20index%20of%20the%20first%20element%20of%20the%20receiver%20that%20causes%20aBlock%20to%20evaluate%20to%20true.%0D%0A%09If%20no%20such%20element%20is%20found%2C%20return%20the%20result%20of%20evaluating%20the%20argument%20block.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20index%20size%20%7C%0D%0A%09size%20%3A%3D%20self%20size.%0D%0A%09index%20%3A%3D%201.%0D%0A%09%5B%20index%20%3C%3D%20size%20%5D%20whileTrue%3A%20%5B%0D%0A%09%09%28aBlock%20value%3A%20%28self%20at%3A%20index%29%29%20ifTrue%3A%20%5B%20%5Eindex%20%5D.%0D%0A%09%09index%20%3A%3D%20index%20+%201%0D%0A%09%5D.%0D%0A%09%5EabsentBlock%20value"));

smalltalk.bind(smalltalk.SequenceableCollection,"findLast:","findLast_"

,function (aBlock){var self=this;return self.findLast_ifAbsent_(aBlock, (function(){return self.errorAbsentObject();}));return self;}

,"searching",unescape("findLast%3A%20aBlock%0D%0A%09%22%20Return%20the%20index%20of%20the%20last%20element%20of%20the%20receiver%20that%20causes%20aBlock%20to%20evaluate%20to%20true.%0D%0A%09If%20no%20such%20element%20is%20found%2C%20report%20an%20error.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20findLast%3A%20aBlock%20ifAbsent%3A%20%5B%20self%20errorAbsentObject%20%5D"));

smalltalk.bind(smalltalk.SequenceableCollection,"findLast:ifAbsent:","findLast_ifAbsent_"

,function (aBlock,absentBlock){var self=this;try{var index=nil;index=self.size();

(function(){while((function(){return (index > (0));})()){(function(){((aBlock.value_(self.at_(index))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "findLast_ifAbsent_", fn: function(){return index}})})();})() : nil);return index=(index - (1));})()};return nil})();

(function(){throw({name: "stReturn", selector: "findLast_ifAbsent_", fn: function(){return absentBlock.value()}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "findLast_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"searching",unescape("findLast%3A%20aBlock%20ifAbsent%3A%20absentBlock%0D%0A%09%22%20Return%20the%20index%20of%20the%20last%20element%20of%20the%20receiver%20that%20causes%20aBlock%20to%20evaluate%20to%20true.%0D%0A%09If%20no%20such%20element%20is%20found%2C%20return%20the%20result%20of%20evaluating%20the%20argument%20block.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self%20size.%0D%0A%09%5B%20index%20%3E%200%20%5D%20whileTrue%3A%20%5B%0D%0A%09%09%28aBlock%20value%3A%20%28self%20at%3A%20index%29%29%20ifTrue%3A%20%5B%20%5Eindex%20%5D.%0D%0A%09%09index%20%3A%3D%20index%20-%201%0D%0A%09%5D.%0D%0A%09%5EabsentBlock%20value"));

smalltalk.bind(smalltalk.SequenceableCollection,"indexOfCollection:","indexOfCollection_"

,function (aCollection){var self=this;try{var index1=nil;var index2=nil;var limit1=nil;var limit2=nil;limit2=aCollection.size();

limit1=(self.size()._minus(limit2) + (1));

index1=(1);

(function(){while((function(){return index1._lt_eq(limit1);})()){(function(){((self.at_(index1)._eq(aCollection.at_((1)))).mustBeBoolean()==true ? (function(){index2=(2);(function(){while((function(){return index2._lt_eq(limit2).and_((function(){return self.at_((index1._plus(index2) - (1)))._eq(aCollection.at_(index2));}));})()){(function(){return index2=(index2 + (1));})()};return nil})();return ((index2._gt(limit2)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "indexOfCollection_", fn: function(){return index1}})})();})() : nil);})() : nil);return index1=(index1 + (1));})()};return nil})();

(function(){throw({name: "stReturn", selector: "indexOfCollection_", fn: function(){return (0)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "indexOfCollection_"){return $$ex.fn();} throw($$ex);}}

,"indexing",unescape("indexOfCollection%3A%20aCollection%0D%0A%09%22%20Return%20the%20index%20position%20of%20the%20first%20occurrence%20of%20aCollection%20in%20the%20receiver%20%28or%200%29.%20%22%0D%0A%0D%0A%09%7C%20index1%20index2%20limit1%20limit2%20%7C%0D%0A%09limit2%20%3A%3D%20aCollection%20size.%0D%0A%09limit1%20%3A%3D%20self%20size%20-%20limit2%20+%201.%0D%0A%09index1%20%3A%3D%201.%0D%0A%09%5B%20index1%20%3C%3D%20limit1%20%5D%20whileTrue%3A%20%5B%0D%0A%09%09%28self%20at%3A%20index1%29%20%3D%20%28aCollection%20at%3A%201%29%20ifTrue%3A%20%5B%0D%0A%09%09%09index2%20%3A%3D%202.%0D%0A%09%09%09%5B%20index2%20%3C%3D%20limit2%20and%3A%20%5B%0D%0A%09%09%09%09%28self%20at%3A%20index1%20+%20index2%20-%201%29%20%3D%20%28aCollection%20at%3A%20index2%29%0D%0A%09%09%09%5D%20%5D%20whileTrue%3A%20%5B%20index2%20%3A%3D%20index2%20+%201%20%5D.%0D%0A%09%09index2%20%3E%20limit2%20ifTrue%3A%20%5B%20%5Eindex1%20%5D%0D%0A%09%09%5D.%0D%0A%09%09index1%20%3A%3D%20index1%20+%201%0D%0A%09%5D.%0D%0A%09%5E0"));

smalltalk.bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:","replaceFrom_to_with_"

,function (start,stop,aCollection){var self=this;try{(((stop._minus(start) + (1))._eq(aCollection.size())).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "replaceFrom_to_with_", fn: function(){return self.error_("Replacement has wrong size")}})})();})());

self.replaceFrom_to_with_startingAt_(start, stop, aCollection, (1));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "replaceFrom_to_with_"){return $$ex.fn();} throw($$ex);}}

,"copy/replace",unescape("replaceFrom%3A%20start%20to%3A%20stop%20with%3A%20aCollection%0D%0A%09%22%20Return%20the%20receiver.%0D%0A%09Replace%20the%20elements%20of%20the%20receiver%20at%20index%20positions%20start%20through%20stop%2C%20with%20the%20elements%20of%20aCollection.%20%22%0D%0A%0D%0A%09stop%20-%20start%20+%201%20%3D%20aCollection%20size%20ifFalse%3A%20%5B%0D%0A%09%09%5Eself%20error%3A%20%27Replacement%20has%20wrong%20size%27%0D%0A%09%5D.%0D%0A%09self%0D%0A%09%09replaceFrom%3A%20start%0D%0A%09%09to%3A%20stop%0D%0A%09%09with%3A%20aCollection%0D%0A%09%09startingAt%3A%201"));

smalltalk.bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:startingAt:","replaceFrom_to_with_startingAt_"

,function (start,stop,aCollection,repStart){var self=this;try{var index1=nil;var index2=nil;(((self === aCollection).and_((function(){return repStart._lt(start);}))).mustBeBoolean()==true ? (function(){index2=repStart._plus(stop)._minus(start);index1=stop;(function(){while((function(){return start._lt_eq(index1);})()){(function(){self.at_put_(index1, aCollection.at_(index2));index1=(index1 - (1));return index2=(index2 - (1));})()};return nil})();return (function(){throw({name: "stReturn", selector: "replaceFrom_to_with_startingAt_", fn: function(){return self}})})();})() : nil);

index2=repStart;

index1=start;

(function(){while((function(){return index1._lt_eq(stop);})()){(function(){self.at_put_(index1, aCollection.at_(index2));index1=(index1 + (1));return index2=(index2 + (1));})()};return nil})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "replaceFrom_to_with_startingAt_"){return $$ex.fn();} throw($$ex);}}

,"copy/replace",unescape("replaceFrom%3A%20start%0D%0A%20%20%20%20to%3A%20stop%0D%0A%20%20%20%20with%3A%20aCollection%0D%0A%20%20%20%20startingAt%3A%20repStart%0D%0A%09%22%20Return%20the%20receiver.%0D%0A%09Replace%20the%20elements%20of%20the%20receiver%20at%20index%20positions%20start%20through%20stop%20with%20consecutive%0D%0A%20%20%20%20%20%20%20%20%20elements%20of%20aCollection%20beginning%20at%20index%20position%20repStart.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20index1%20index2%20%7C%0D%0A%09%28self%20%3D%3D%20aCollection%20and%3A%20%5B%20repStart%20%3C%20start%20%5D%29%20ifTrue%3A%20%5B%20%22do%20backward%20move%20for%20same%20object%22%0D%0A%09%09index2%20%3A%3D%20repStart%20+%20stop%20-%20start.%0D%0A%09%09index1%20%3A%3D%20stop.%0D%0A%09%09%5B%20start%20%3C%3D%20index1%20%5D%20whileTrue%3A%20%5B%0D%0A%09%09%09self%20at%3A%20index1%20put%3A%20%28aCollection%20at%3A%20index2%29.%0D%0A%09%09%09index1%20%3A%3D%20index1%20-%201.%0D%0A%09%09%09index2%20%3A%3D%20index2%20-%201%0D%0A%09%09%5D.%0D%0A%09%09%5Eself%0D%0A%09%5D.%0D%0A%09index2%20%3A%3D%20repStart.%0D%0A%09index1%20%3A%3D%20start.%0D%0A%09%5B%20index1%20%3C%3D%20stop%20%5D%20whileTrue%3A%20%5B%0D%0A%09%09self%20at%3A%20index1%20put%3A%20%28aCollection%20at%3A%20index2%29.%0D%0A%09%09index1%20%3A%3D%20index1%20+%201.%0D%0A%09%09index2%20%3A%3D%20index2%20+%201%0D%0A%09%5D"));

smalltalk.bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:startingWith:","replaceFrom_to_with_startingWith_"

,function (start,stop,replacement,replacementStart){var self=this;return self.replaceFrom_to_with_startingAt_(start, stop, replacement, replacementStart);return self;}

,"copy/replace",unescape("replaceFrom%3A%20start%0D%0A%20%20%20%20to%3A%20stop%0D%0A%20%20%20%20with%3A%20replacement%0D%0A%20%20%20%20startingWith%3A%20replacementStart%0D%0A%09%22%20Replace%20the%20elements%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09replaceFrom%3A%20start%0D%0A%09%09to%3A%20stop%0D%0A%09%09with%3A%20replacement%0D%0A%09%09startingAt%3A%20replacementStart"));

smalltalk.bind(smalltalk.SequenceableCollection,"replaceFrom:to:withObject:","replaceFrom_to_withObject_"

,function (start,stop,anObject){var self=this;var index=nil;index=start;

(function(){while((function(){return index._lt_eq(stop);})()){(function(){self.at_put_(index, anObject);return index=(index + (1));})()};return nil})();

return anObject;return self;}

,"copy/replace",unescape("replaceFrom%3A%20start%20to%3A%20stop%20withObject%3A%20anObject%0D%0A%09%22Replace%20each%20of%20the%20elements%20of%20the%20receiver%20at%20index%20positions%20start%20through%20stop%20with%20anObject.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20start.%0D%0A%09%5B%20index%20%3C%3D%20stop%20%5D%20whileTrue%3A%20%5B%0D%0A%09%09self%20at%3A%20index%20put%3A%20anObject.%0D%0A%09%09index%20%3A%3D%20index%20+%201%0D%0A%09%5D.%0D%0A%09%5EanObject"));

smalltalk.bind(smalltalk.SequenceableCollection,"with:do:","with_do_"

,function (aCollection,aBlock){var self=this;var first=nil;var second=nil;first=self.stream();

second=aCollection.stream();

(function(){while(!(function(){return first.atEnd().or_((function(){return second.atEnd();}));})()){(function(){return aBlock.value_value_(first.next(), second.next());})()};return nil})();return self;}

,"iterating",unescape("with%3A%20aCollection%20do%3A%20aBlock%0D%0A%09%22%20For%20each%20pair%20of%20elements%20evaluate%20aBlock%20with%20those%20elements%20as%20the%20arguments.%20%22%0D%0A%0D%0A%09%7C%20first%20second%20%7C%0D%0A%09first%09%3A%3D%20self%20stream.%0D%0A%09second%09%3A%3D%20aCollection%20stream.%0D%0A%09%5B%20first%20atEnd%20or%3A%20%5B%20second%20atEnd%20%5D%20%5D%20whileFalse%3A%20%5B%0D%0A%09%09aBlock%20value%3A%20first%20next%20value%3A%20second%20next%0D%0A%09%5D."));

smalltalk.bind(smalltalk.SequenceableCollection,"asActionSequence","asActionSequence"

,function (){var self=this;return smalltalk.ActionSequence.withAll_(self);return self;}

,"conversion",unescape("asActionSequence%0D%0A%09%22%20Return%20an%20ActionSequence%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EActionSequence%20withAll%3A%20self"));

smalltalk.bind(smalltalk.HashedSet,"initialize","initialize"

,function (){var self=this;smalltalk.whoImplements(smalltalk.HashedSet,'initialize').$superclass.$fn.prototype['initialize'].apply(self, []);

self.initializeHash();return self;}

,"initialize",unescape("initialize%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%20%22%0D%0A%0D%0A%09super%20initialize.%0D%0A%09self%20initializeHash."));

smalltalk.bind(smalltalk.HashedSet,"initialize:","initialize_"

,function (initializer){var self=this;self['@contents']=initializer;

self.rehash();return self;}

,"initialize",unescape("initialize%3A%20initializer%0D%0A%09%22%20Private%20-%20Initialize%20the%20receiver.%20%22%0D%0A%0D%0A%09contents%20%3A%3D%20initializer.%0D%0A%09self%20rehash."));

smalltalk.bind(smalltalk.HashedSet,"initializeHash","initializeHash"

,function (){var self=this;self['@hash']= {} ;return self;}

,"private",unescape("initializeHash%0D%0A%09%22%20Private%20-%20Initialize%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09hash%20%3A%3D%20%7B%27%20%7B%7D%20%27%7D."));

smalltalk.bind(smalltalk.HashedSet,"rehash","rehash"

,function (){var self=this;self['@hash']= {} ;

self['@contents'].do_((function(each){return (self['@hash'][each]=(each));}));return self;}

,"private",unescape("rehash%0D%0A%09%22%20Private%20-%20Rehash%20the%20receiver%20contents.%20%22%0D%0A%0D%0A%09hash%20%3A%3D%20%7B%27%20%7B%7D%20%27%7D.%0D%0A%09contents%20do%3A%20%5B%3Aeach%7C%20hash%20basicAt%3A%20each%20put%3A%20each%20%5D"));

smalltalk.bind(smalltalk.HashedSet,"includes:","includes_"

,function (anObject){var self=this;	return anObject in self["@hash"]; ;return self;}

,"testing",unescape("includes%3A%20anObject%0D%0A%09%22%20Return%20true%20if%20anObject%20is%20in%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%7B%27%09return%20anObject%20in%20self%5B%22@hash%22%5D%3B%20%27%7D"));

smalltalk.bind(smalltalk.HashedSet,"indexOf:ifAbsent:","indexOf_ifAbsent_"

,function (anObject,aBlock){var self=this;try{((self.includes_(anObject)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "indexOf_ifAbsent_", fn: function(){return aBlock.value()}})})();})());

(function(){throw({name: "stReturn", selector: "indexOf_ifAbsent_", fn: function(){return self['@contents'].indexOf_ifAbsent_(anObject, aBlock)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "indexOf_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("indexOf%3A%20anObject%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Private%2CInternal%20-%20Return%20the%20position%20of%20anObject%20in%20the%20receiver%2C%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%28self%20includes%3A%20anObject%29%20ifFalse%3A%20%5B%20%5EaBlock%20value%20%5D.%0D%0A%09%5Econtents%20indexOf%3A%20anObject%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.HashedSet,"withIndexDo:","withIndexDo_"

,function (aBlock){var self=this;return self['@contents'].withIndexDo_(aBlock);return self;}

,"private",unescape("withIndexDo%3A%20aBlock%0D%0A%09%22%20Private%2CInternal%20-%20Evaluate%20aBlock%20with%20all%20the%20index%20positions%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Econtents%20withIndexDo%3A%20aBlock"));

smalltalk.bind(smalltalk.HashedSet,"removeIndex:","removeIndex_"

,function (index){var self=this;var toRemove=nil;toRemove=self['@contents'].at_(index);

return self.remove_(toRemove);return self;}

,"private",unescape("removeIndex%3A%20index%0D%0A%09%22%20Private%2CInternal%20-%20Remove%20the%20element%20at%20index.%20%22%0D%0A%0D%0A%09%7C%20toRemove%20%7C%0D%0A%09toRemove%20%3A%3D%20contents%20at%3A%20index.%0D%0A%09%5Eself%20remove%3A%20toRemove"));

smalltalk.bind(smalltalk.HashedSet,"add:","add_"

,function (anObject){var self=this;try{((self.includes_(anObject)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "add_", fn: function(){return anObject}})})();})() : nil);

(self['@hash'][anObject]=(anObject));

(function(){throw({name: "stReturn", selector: "add_", fn: function(){return self.basicAdd_(anObject)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "add_"){return $$ex.fn();} throw($$ex);}}

,"adding/removing",unescape("add%3A%20anObject%0D%0A%09%22%20Add%20anObject%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%28self%20includes%3A%20anObject%29%20ifTrue%3A%20%5B%20%5EanObject%20%5D.%0D%0A%09hash%20basicAt%3AanObject%20put%3A%20anObject.%0D%0A%09%5Eself%20basicAdd%3A%20anObject"));

smalltalk.bind(smalltalk.HashedSet,"remove:ifAbsent:","remove_ifAbsent_"

,function (anObject,aBlock){var self=this;try{((self.includes_(anObject)).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "remove_ifAbsent_", fn: function(){return aBlock.value()}})})();})());

self['@contents'].remove_ifAbsent_(anObject, (function(){return nil;}));

	delete self["@hash"][anObject];
	return anObject;	;return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "remove_ifAbsent_"){return $$ex.fn();} throw($$ex);}}

,"adding/removing",unescape("remove%3A%20anObject%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Remove%20anObject%20from%20the%20receiver.%0D%0A%09Return%20the%20result%20of%20evaluating%20aBlock%20if%20anObject%20is%20not%20in%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%28self%20includes%3A%20anObject%29%20ifFalse%3A%20%5B%20%5EaBlock%20value%20%5D.%0D%0A%09contents%20remove%3A%20anObject%20ifAbsent%3A%20%5B%20%5D.%0D%0A%7B%27%09delete%20self%5B%22@hash%22%5D%5BanObject%5D%3B%0D%0A%09return%20anObject%3B%09%27%7D."));

smalltalk.bind(smalltalk.ArrayedContents,"contents","contents"

,function (){var self=this;((((self['@contents'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@contents']=smalltalk.Array.$$new();})() : nil);

return self['@contents'];return self;}

,"private",unescape("contents%0D%0A%09%22%20Private%20-%20Return%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09contents%20isNil%20ifTrue%3A%20%5B%20contents%20%3A%3D%20Array%20new%20%5D.%0D%0A%09%5Econtents"));

smalltalk.bind(smalltalk.ArrayedContents,"add:","add_"

,function (anObject){var self=this;return self.contents().add_(anObject);return self;}

,"adding/removing",unescape("add%3A%20anObject%0D%0A%09%22%20Add%20anObject%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20add%3A%20anObject"));

smalltalk.bind(smalltalk.ArrayedContents,"at:ifAbsent:","at_ifAbsent_"

,function (anIndex,aBlock){var self=this;return self.contents().at_ifAbsent_(anIndex, aBlock);return self;}

,"accessing",unescape("at%3A%20anIndex%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver%20at%20anIndex%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20at%3A%20anIndex%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.ArrayedContents,"at:put:","at_put_"

,function (anIndex,anObject){var self=this;return self.contents().at_put_(anIndex, anObject);return self;}

,"accessing",unescape("at%3A%20anIndex%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20contents%20of%20the%20receiver%20at%20anIndex.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20at%3A%20anIndex%20put%3A%20anObject"));

smalltalk.bind(smalltalk.ArrayedContents,"atAllPut:","atAllPut_"

,function (anObject){var self=this;return self.contents().atAllPut_(anObject);return self;}

,"accessing",unescape("atAllPut%3A%20anObject%0D%0A%09%22%20Replace%20all%20elements%20of%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20atAllPut%3A%20anObject"));

smalltalk.bind(smalltalk.ArrayedContents,"copyFrom:to:","copyFrom_to_"

,function (anIndex,anotherIndex){var self=this;var result=nil;result=self.$klass.$$new();

anIndex.to_do_(anotherIndex, (function(each){return result.add_(self.at_(each));}));

return result;return self;}

,"copying",unescape("copyFrom%3A%20anIndex%20to%3A%20anotherIndex%0D%0A%09%22%20Return%20the%20receiver%20contents%20in%20the%20interval.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20class%20new.%0D%0A%09anIndex%20to%3A%20anotherIndex%20do%3A%20%5B%3Aeach%20%7C%20result%20add%3A%20%28self%20at%3A%20each%29%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.ArrayedContents,"indexOf:ifAbsent:","indexOf_ifAbsent_"

,function (anObject,aBlock){var self=this;return self.contents().indexOf_ifAbsent_(anObject, aBlock);return self;}

,"query",unescape("indexOf%3A%20anObject%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20position%20of%20anObject%20in%20the%20receiver%2C%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20indexOf%3A%20anObject%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.ArrayedContents,"detect:ifNone:","detect_ifNone_"

,function (aBlock,anotherBlock){var self=this;return self.contents().detect_ifNone_(aBlock, anotherBlock);return self;}

,"enumerating",unescape("detect%3A%20aBlock%20ifNone%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver%20that%20return%20true%20when%20evaluated%20with%20aBlock%20or%20the%20result%20of%20evaluating%20anotherBlock.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20detect%3A%20aBlock%20ifNone%3A%20anotherBlock"));

smalltalk.bind(smalltalk.ArrayedContents,"do:","do_"

,function (aBlock){var self=this;return self.contents().do_(aBlock);return self;}

,"enumerating",unescape("do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.ArrayedContents,"includes:","includes_"

,function (anObject){var self=this;return self.contents().includes_(anObject);return self;}

,"testing",unescape("includes%3A%20anObject%0D%0A%09%22%20Return%20true%20if%20anObject%20is%20in%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20includes%3A%20anObject"));

smalltalk.bind(smalltalk.ArrayedContents,"isEmpty","isEmpty"

,function (){var self=this;return self.contents().isEmpty();return self;}

,"testing",unescape("isEmpty%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20isEmpty"));

smalltalk.bind(smalltalk.ArrayedContents,"occurrencesOf:","occurrencesOf_"

,function (anObject){var self=this;return self.contents().occurrencesOf_(anObject);return self;}

,"counting",unescape("occurrencesOf%3A%20anObject%0D%0A%09%22%20Return%20the%20occurrences%20of%20anObject%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20occurrencesOf%3A%20anObject"));

smalltalk.bind(smalltalk.ArrayedContents,"reverseDo:","reverseDo_"

,function (aBlock){var self=this;return self.contents().reverseDo_(aBlock);return self;}

,"enumerating",unescape("reverseDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20contents%20of%20the%20receiver%20in%20reverse%20order%20of%20iteration.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20reverseDo%3A%20aBlock"));

smalltalk.bind(smalltalk.ArrayedContents,"reversed","reversed"

,function (){var self=this;return self.$klass.withAll_(self.contents().reversed());return self;}

,"copying",unescape("reversed%0D%0A%09%22%20Return%20an%20array%20with%20the%20contents%20of%20the%20receiver%20in%20reverse%20order.%20%22%0D%0A%0D%0A%09%5Eself%20class%20withAll%3A%20self%20contents%20reversed"));

smalltalk.bind(smalltalk.ArrayedContents,"remove:ifAbsent:","remove_ifAbsent_"

,function (anObject,aBlock){var self=this;return self.contents().remove_ifAbsent_(anObject, aBlock);return self;}

,"adding/removing",unescape("remove%3A%20anObject%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Remove%20anObject%20from%20the%20receiver.%0D%0A%09Return%20the%20result%20of%20evaluating%20aBlock%20if%20anObject%20is%20not%20in%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20contents%20remove%3A%20anObject%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.ArrayedContents,"removeAll","removeAll"

,function (){var self=this;self['@contents']=nil;return self;}

,"adding/removing",unescape("removeAll%0D%0A%09%22%20Remove%20all%20the%20objects%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09contents%20%3A%3D%20nil"));

smalltalk.bind(smalltalk.ArrayedContents,"removeFirst","removeFirst"

,function (){var self=this;return self.contents().removeFirst();return self;}

,"adding/removing",unescape("removeFirst%0D%0A%09%22%20Remove%20the%20first%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20removeFirst"));

smalltalk.bind(smalltalk.ArrayedContents,"removeLast","removeLast"

,function (){var self=this;return self.contents().removeLast();return self;}

,"adding/removing",unescape("removeLast%0D%0A%09%22%20Remove%20the%20last%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20removeLast"));

smalltalk.bind(smalltalk.ArrayedContents,"removeIndex:","removeIndex_"

,function (index){var self=this;return self.contents().removeIndex_(index);return self;}

,"adding/removing",unescape("removeIndex%3A%20index%0D%0A%09%22%20Remove%20the%20element%20at%20index.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20removeIndex%3A%20index"));

smalltalk.bind(smalltalk.ArrayedContents,"size","size"

,function (){var self=this;return self.contents().size();return self;}

,"accesing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20size"));

smalltalk.bind(smalltalk.ArrayedContents,"withIndexDo:","withIndexDo_"

,function (aBlock){var self=this;return self.contents().withIndexDo_(aBlock);return self;}

,"enumerating",unescape("withIndexDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20the%20index%20positions%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20contents%20withIndexDo%3A%20aBlock"));

smalltalk.bind(smalltalk.Array.$klass,"basicNew:","basicNew_"

,function (size){var self=this;	return new Array(size);return self;}

,unescape("instance%20creation"),unescape("basicNew%3A%20size%0D%0A%09%22%20Return%20a%20new%20instance%20of%20the%20receiver%20of%20specified%20size.%20%22%0D%0A%0D%0A%7B%27%09return%20new%20Array%28size%29%27%7D"));

smalltalk.bind(smalltalk.Array.$klass,"new:","new_"

,function (size){var self=this;return self.basicNew_(size).atAllPut_(nil);return self;}

,unescape("instance%20creation"),unescape("new%3A%20size%0D%0A%09%22%20Return%20a%20new%20instance%20of%20the%20receiver%20of%20specified%20size.%20%22%0D%0A%0D%0A%09%5E%28self%20basicNew%3A%20size%29%20atAllPut%3A%20nil"));

smalltalk.bind(smalltalk.Array,"size","size"

,function (){var self=this;	return self.length;return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20self.length%27%7D"));

smalltalk.bind(smalltalk.Array,"at:put:","at_put_"

,function (anIndex,anObject){var self=this;	return self[anIndex - 1] = anObject;return self;}

,"accessing",unescape("at%3A%20anIndex%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20contents%20of%20the%20receiver%20at%20anIndex.%20%22%0D%0A%0D%0A%7B%27%09return%20self%5BanIndex%20-%201%5D%20%3D%20anObject%27%7D"));

smalltalk.bind(smalltalk.Array,"at:ifAbsent:","at_ifAbsent_"

,function (anIndex,aBlock){var self=this;	var value = self[anIndex - 1];
	if(value === undefined) { return aBlock(); }
	return value;;return self;}

,"accessing",unescape("at%3A%20anIndex%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver%20at%20anIndex%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%7B%27%09var%20value%20%3D%20self%5BanIndex%20-%201%5D%3B%0D%0A%09if%28value%20%3D%3D%3D%20undefined%29%20%7B%20return%20aBlock%28%29%3B%20%7D%0D%0A%09return%20value%3B%27%7D"));

smalltalk.bind(smalltalk.Array,"add:","add_"

,function (anObject){var self=this;self.push(anObject);

return anObject;return self;}

,"adding/removing",unescape("add%3A%20anObject%0D%0A%09%22%20Add%20anObject%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23push%3A%20anObject.%0D%0A%09%5EanObject"));

smalltalk.bind(smalltalk.Array,"isArray","isArray"

,function (){var self=this;return (self.$klass === smalltalk.Array);return self;}

,"testing",unescape("isArray%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20an%20Array.%20%22%0D%0A%0D%0A%09%5Eself%20class%20%3D%3D%20Array"));

smalltalk.bind(smalltalk.Array,"shallowCopy","shallowCopy"

,function (){var self=this;	return self.slice(0); ;return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20self.slice%280%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Array,"deepCopy","deepCopy"

,function (){var self=this;return self.collect_((function(each){return each.deepCopy();}));return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20collect%3A%20%5B%3Aeach%20%7C%20each%20deepCopy%20%5D"));

smalltalk.bind(smalltalk.Array,"copyFrom:to:","copyFrom_to_"

,function (anIndex,anotherIndex){var self=this;var result=nil;result=self.$klass.$$new();

anIndex.to_do_(anotherIndex, (function(each){return result.add_(self.at_(each));}));

return result;return self;}

,"copying",unescape("copyFrom%3A%20anIndex%20to%3A%20anotherIndex%0D%0A%09%22%20Return%20the%20receiver%20contents%20in%20the%20interval.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20class%20new.%0D%0A%09anIndex%20to%3A%20anotherIndex%20do%3A%20%5B%3Aeach%20%7C%20result%20add%3A%20%28self%20at%3A%20each%29%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Array,"join:","join_"

,function (aString){var self=this;return self.join(aString);return self;}

,"enumerating",unescape("join%3A%20aString%0D%0A%09%22%20Return%20a%20string%20with%20the%20receiver%27s%20contents%20separated%20by%20aString.%20%22%0D%0A%0D%0A%09%5Eself%20%23join%3A%20aString"));

smalltalk.bind(smalltalk.Array,"asJavascript","asJavascript"

,function (){var self=this;return unescape("%5B")._comma(self.collect_((function(each){return each.asJavascript();})).join_(unescape("%2C%20")))._comma(unescape("%5D"));return self;}

,"converting",unescape("asJavascript%0D%0A%09%22%20Return%20the%20javascript%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%5B%27%2C%20%28%28self%20collect%3A%20%5B%3Aeach%20%7C%20each%20asJavascript%5D%29%20join%3A%20%27%2C%20%27%29%2C%20%20%27%5D%27"));

smalltalk.bind(smalltalk.Array,"sortJS","sortJS"

,function (){var self=this;return self.basicPerform_("sort");return self;}

,"enumerating",unescape("sortJS%0D%0A%09%22%20OBSOLETE%20-%20This%20method%20must%20not%20be%20implemented/used.%20%22%0D%0A%0D%0A%09%5Eself%20basicPerform%3A%20%27sort%27"));

smalltalk.bind(smalltalk.Array,"sort:","sort_"

,function (aBlock){var self=this;	return self.sort(function(a, b) {
		if(aBlock(a,b)) {return -1} else {return 1}
	}) ;return self;}

,"enumerating",unescape("sort%3A%20aBlock%0D%0A%09%22%20Sort%20%28inplace%29%20the%20receiver%27s%20contents%20with%20aBlock.%20%22%0D%0A%0D%0A%7B%27%09return%20self.sort%28function%28a%2C%20b%29%20%7B%0D%0A%09%09if%28aBlock%28a%2Cb%29%29%20%7Breturn%20-1%7D%20else%20%7Breturn%201%7D%0D%0A%09%7D%29%20%27%7D"));

smalltalk.bind(smalltalk.Array,"remove:ifAbsent:","remove_ifAbsent_"

,function (anObject,aBlock){var self=this;	for(var i=0;i<self.length;i++) {
		if(self[i] == anObject) {
			self.splice(i,1); return anObject;
		}
	}; return aBlock.value(); ;return self;}

,"adding/removing",unescape("remove%3A%20anObject%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Remove%20anObject%20from%20the%20receiver.%0D%0A%09Return%20the%20result%20of%20evaluating%20aBlock%20if%20anObject%20is%20not%20in%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%7B%27%09for%28var%20i%3D0%3Bi%3Cself.length%3Bi++%29%20%7B%0D%0A%09%09if%28self%5Bi%5D%20%3D%3D%20anObject%29%20%7B%0D%0A%09%09%09self.splice%28i%2C1%29%3B%20return%20anObject%3B%0D%0A%09%09%7D%0D%0A%09%7D%3B%20return%20aBlock.value%28%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Array,"removeLast","removeLast"

,function (){var self=this;var result=nil;result=self.last();

self.splice((self.size() - (1)), (1));

return result;return self;}

,"adding/removing",unescape("removeLast%0D%0A%09%22%20Remove%20the%20last%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20last.%0D%0A%09self%20%23splice%3A%20self%20size%20-%201%20count%3A%201.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Array,"removeFirst","removeFirst"

,function (){var self=this;var result=nil;result=self.first();

self.splice((0), (1));

return result;return self;}

,"adding/removing",unescape("removeFirst%0D%0A%09%22%20Remove%20the%20first%20object%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20first.%0D%0A%09self%20%23splice%3A%200%20count%3A%201.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Array,"removeAll","removeAll"

,function (){var self=this;self.splice((0), self.size());return self;}

,"adding/removing",unescape("removeAll%0D%0A%09%22%20Remove%20all%20the%20objects%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20%23splice%3A%200%20count%3A%20self%20size."));

smalltalk.bind(smalltalk.Array,"removeIndex:","removeIndex_"

,function (index){var self=this;self.splice((index - (1)), (1));return self;}

,"adding/removing",unescape("removeIndex%3A%20index%0D%0A%09%22%20Remove%20the%20element%20at%20index.%20%22%0D%0A%0D%0A%09self%20%23splice%3A%20index-1%20count%3A%201"));

smalltalk.bind(smalltalk.Array,"sorted","sorted"

,function (){var self=this;return self.copy().sort();return self;}

,"enumerating",unescape("sorted%0D%0A%09%22%20Return%20a%20sorted%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20copy%20sort"));

smalltalk.bind(smalltalk.Array,"sorted:","sorted_"

,function (aBlock){var self=this;return self.copy().sort_(aBlock);return self;}

,"enumerating",unescape("sorted%3A%20aBlock%0D%0A%09%22%20Return%20a%20sorted%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20copy%20sort%3A%20aBlock"));

smalltalk.bind(smalltalk.Array,"atAllPut:","atAllPut_"

,function (anObject){var self=this;	for(var i=0;i<self.length;i++){ self[i] = anObject; };return self;}

,"accessing",unescape("atAllPut%3A%20anObject%0D%0A%09%22%20Replace%20all%20elements%20of%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%7B%27%09for%28var%20i%3D0%3Bi%3Cself.length%3Bi++%29%7B%20self%5Bi%5D%20%3D%20anObject%3B%20%7D%27%7D"));

smalltalk.bind(smalltalk.Array,"withIndexDo:","withIndexDo_"

,function (aBlock){var self=this;	for(var i=0;i<self.length;i++){aBlock(self[i], i+1);};return self;}

,"enumerating",unescape("withIndexDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20the%20index%20positions%20in%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09for%28var%20i%3D0%3Bi%3Cself.length%3Bi++%29%7BaBlock%28self%5Bi%5D%2C%20i+1%29%3B%7D%27%7D"));

smalltalk.bind(smalltalk.Array,"printString","printString"

,function (){var self=this;try{var result=nil;((self.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "printString", fn: function(){return unescape("%23%28%29")}})})();})() : nil);

result=unescape("%23%28%20");

self.do_((function(each){(((result.size() > (10000))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "printString", fn: function(){return result._comma(unescape("...%29"))}})})();})() : nil);return result=result._comma(((self.isObject_(each)).mustBeBoolean()==true ? (function(){return each.printString();})() : (function(){return each;})()))._comma(" ");}));

(function(){throw({name: "stReturn", selector: "printString", fn: function(){return result._comma(unescape("%29"))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "printString"){return $$ex.fn();} throw($$ex);}}

,"printing",unescape("printString%0D%0A%09%22%20DEBUG%20-%20Temporary%20printing%20method%20%28must%20check%20for%20recursion%29.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09self%20isEmpty%20ifTrue%3A%20%5B%20%5E%27%23%28%29%27%20%5D.%0D%0A%09result%20%3A%3D%20%27%23%28%20%27.%0D%0A%09self%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09result%20size%20%3E%2010000%20ifTrue%3A%20%5B%20%5Eresult%2C%27...%29%27%20%5D.%0D%0A%09%09result%20%3A%3D%20result%20%2C%20%28%0D%0A%09%09%09%28self%20isObject%3A%20each%29%0D%0A%09%09%09ifTrue%3A%20%5B%20each%20printString%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20each%20%5D%29%20%2C%27%20%27%0D%0A%09%5D.%0D%0A%09%5Eresult%2C%27%29%27"));

smalltalk.bind(smalltalk.Array,"asJSONObject","asJSONObject"

,function (){var self=this;return self.collect_((function(each){return ((self.isObject_(each)).mustBeBoolean()==true ? (function(){return each.asJSONObject();})() : (function(){return each;})());}));return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20Array%20with%20the%20contents%20of%20the%20receiver%20converted%20to%20JSON%20structures.%20%22%0D%0A%0D%0A%09%5Eself%20collect%3A%20%5B%3Aeach%7C%20%0D%0A%09%09%28self%20isObject%3A%20each%29%0D%0A%09%09ifTrue%3A%20%5B%20each%20asJSONObject%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20each%20%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Array,"json","json"

,function (){var self=this;return self.collect_((function(each){return ((self.isObject_(each)).mustBeBoolean()==true ? (function(){return each.json();})() : (function(){return each;})());}));return self;}

,"converting",unescape("json%0D%0A%09%22%20Return%20an%20Array%20with%20the%20contents%20of%20the%20receiver%20converted%20to%20JSON%20structures.%20%22%0D%0A%0D%0A%09%5Eself%20collect%3A%20%5B%3Aeach%7C%20%0D%0A%09%09%28self%20isObject%3A%20each%29%0D%0A%09%09ifTrue%3A%20%5B%20each%20json%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20each%20%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.Array,"emmit","emmit"

,function (){var self=this;self.do_((function(fileName){return self.emmit_(fileName);}));return self;}

,unescape("code%20generation"),unescape("emmit%0D%0A%09%22%20Emmit%28fileIn%20%26%20save%20generated%20code%20of%29%20the%20fileNames%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20do%3A%20%5B%3AfileName%7C%20self%20emmit%3A%20fileName%20%5D"));

smalltalk.bind(smalltalk.Array,"emmitSt","emmitSt"

,function (){var self=this;self.do_((function(module){return self.emmit_(module._comma(".st"));}));return self;}

,unescape("code%20generation"),unescape("emmitSt%0D%0A%09%22%20Emmit%20the%20code%20of%20modules%20%28.st%20files%29%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20do%3A%20%5B%3Amodule%7C%20self%20emmit%3A%20module%20%2C%27.st%27%20%5D"));

smalltalk.bind(smalltalk.String.$klass,"streamClass","streamClass"

,function (){var self=this;return smalltalk.StringStream;return self;}

,"accessing",unescape("streamClass%0D%0A%09%22%20Return%20the%20streamming%20support%20for%20the%20receiver%27s%20instances.%20%22%0D%0A%0D%0A%09%5EStringStream"));

smalltalk.bind(smalltalk.String.$klass,"fromString:","fromString_"

,function (aString){var self=this;	return new self.$fn(aString);;return self;}

,unescape("instance%20creation"),unescape("fromString%3A%20aString%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20new%20self.%24fn%28aString%29%3B%27%7D"));

smalltalk.bind(smalltalk.String.$klass,"cr","cr"

,function (){var self=this;return "\n";return self;}

,"accessing",unescape("cr%0D%0A%09%22%20Return%20the%20singular%20instance.%20%22%0D%0A%0D%0A%09%5E%7B%27%22%5Cn%22%27%7D"));

smalltalk.bind(smalltalk.String.$klass,"lf","lf"

,function (){var self=this;return "\r";return self;}

,"accessing",unescape("lf%0D%0A%09%22%20Return%20the%20singular%20instance.%20%22%0D%0A%0D%0A%09%5E%7B%27%22%5Cr%22%27%7D"));

smalltalk.bind(smalltalk.String.$klass,"crlf","crlf"

,function (){var self=this;return "\n\r";return self;}

,"accessing",unescape("crlf%0D%0A%09%22%20Return%20the%20singular%20instance.%20%22%0D%0A%0D%0A%09%5E%7B%27%22%5Cn%5Cr%22%27%7D"));

smalltalk.bind(smalltalk.String.$klass,"space","space"

,function (){var self=this;return " ";return self;}

,"accessing",unescape("space%0D%0A%09%22%20Return%20the%20singular%20instance.%20%22%0D%0A%0D%0A%09%5E%7B%27%22%20%22%27%7D"));

smalltalk.bind(smalltalk.String.$klass,"tab","tab"

,function (){var self=this;return "\t";return self;}

,"accessing",unescape("tab%0D%0A%09%22%20Return%20the%20singular%20instance.%20%22%0D%0A%0D%0A%09%5E%7B%27%22%5Ct%22%27%7D"));

smalltalk.bind(smalltalk.String.$klass,"zero","zero"

,function (){var self=this;return "\0";return self;}

,"accessing",unescape("zero%0D%0A%09%22%20Return%20the%20singular%20instance.%20%22%0D%0A%0D%0A%09%5E%7B%27%22%5C0%22%27%7D"));

smalltalk.bind(smalltalk.String.$klass,"with:","with_"

,function (aCharacter){var self=this;return aCharacter;return self;}

,unescape("instance%20creation"),unescape("with%3A%20aCharacter%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EaCharacter"));

smalltalk.bind(smalltalk.String.$klass,"with:with:","with_with_"

,function (aCharacter,bCharacter){var self=this;return aCharacter._comma(bCharacter);return self;}

,unescape("instance%20creation"),unescape("with%3A%20aCharacter%20with%3A%20bCharacter%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EaCharacter%20%2C%20bCharacter"));

smalltalk.bind(smalltalk.String.$klass,"with:with:with:","with_with_with_"

,function (aCharacter,bCharacter,cCharacter){var self=this;return aCharacter._comma(bCharacter)._comma(cCharacter);return self;}

,unescape("instance%20creation"),unescape("with%3A%20aCharacter%20with%3A%20bCharacter%20with%3A%20cCharacter%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EaCharacter%20%2C%20bCharacter%20%2C%20cCharacter"));

smalltalk.bind(smalltalk.String.$klass,"with:with:with:with:","with_with_with_with_"

,function (aCharacter,bCharacter,cCharacter,dCharacter){var self=this;return aCharacter._comma(bCharacter)._comma(cCharacter)._comma(dCharacter);return self;}

,unescape("instance%20creation"),unescape("with%3A%20aCharacter%20with%3A%20bCharacter%0D%0A%09with%3A%20cCharacter%20with%3A%20dCharacter%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EaCharacter%20%2C%20bCharacter%20%2C%20cCharacter%20%2C%20dCharacter"));

smalltalk.bind(smalltalk.String.$klass,"reservedWords","reservedWords"

,function (){var self=this;return ["abstract", "as", "boolean", "break", "byte", "case", "catch", "char", "class", "continue", "const", "debugger", "default", "delete", "do", "double", "else", "enum", "export", "extends", "false", "final", "finally", "float", "for", "function", "goto", "if", "implements", "import", "in", "instanceof", "int", "interface", "is", "long", "namespace", "native", "new", "null", "package", "private", "protected", "public", "return", "short", "static", "super", "switch", "synchronized", "this", "throw", "throws", "transient", "true", "try", "typeof", "use", "var", "void", "volatile", "while", "with"];return self;}

,unescape("reserved%20words"),unescape("reservedWords%0D%0A%09%22%20Private%20-%20Return%20the%20reserved%20names%20of%20javascript%20language.%20%22%0D%0A%0D%0A%09%5E%23%28%0D%0A%09abstract%09as%09%09boolean%09%09break%09%09byte%0D%0A%09case%09%09catch%09%09char%09%09class%09%09continue%0D%0A%09const%09%09debugger%09default%09%09delete%09%09do%0D%0A%09double%09%09else%09%09enum%09%09export%09%09extends%0D%0A%09false%09%09final%09%09finally%09%09float%09%09for%0D%0A%09function%09goto%09%09if%09%09implements%09import%0D%0A%09in%09%09instanceof%09int%09%09interface%09is%0D%0A%09long%09%09namespace%09native%09%09new%09%09null%0D%0A%09package%09%09private%09%09protected%09public%09%09return%0D%0A%09short%09%09static%09%09super%09%09switch%09%09synchronized%0D%0A%09this%09%09throw%09%09throws%09%09transient%09true%0D%0A%09try%09%09typeof%09%09use%09%09var%09%09void%0D%0A%09volatile%09while%09%09with%0D%0A%09%29"));

smalltalk.bind(smalltalk.String,"=","_eq"

,function (aString){var self=this;	return String(self) == aString; ;return self;}

,"comparing",unescape("%3D%20aString%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20equal%20to%20aString.%20%22%0D%0A%0D%0A%7B%27%09return%20String%28self%29%20%3D%3D%20aString%3B%20%27%7D"));

smalltalk.bind(smalltalk.String,"size","size"

,function (){var self=this;	return self.length; ;return self;}

,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20self.length%3B%20%27%7D"));

smalltalk.bind(smalltalk.String,"at:","at_"

,function (anIndex){var self=this;return self.charAt((anIndex - (1)));return self;}

,"accessing",unescape("at%3A%20anIndex%0D%0A%09%22%20Return%20the%20receiver%20at%20anIndex.%20%22%0D%0A%0D%0A%09%5Eself%20%23charAt%3A%20anIndex%20-%201"));

smalltalk.bind(smalltalk.String,"at:put:","at_put_"

,function (anIndex,anObject){var self=this;return self.errorReadOnly();return self;}

,"accessing",unescape("at%3A%20anIndex%20put%3A%20anObject%0D%0A%09%22%20Set%20the%20receiver%20at%20anIndex.%20%22%0D%0A%0D%0A%09%5Eself%20errorReadOnly"));

smalltalk.bind(smalltalk.String,"at:ifAbsent:","at_ifAbsent_"

,function (anIndex,aBlock){var self=this;return self.at_(anIndex).ifNil_(aBlock);return self;}

,"accessing",unescape("at%3A%20anIndex%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20receiver%20at%20anIndex%20position%20or%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5E%28self%20at%3A%20anIndex%29%20ifNil%3A%20aBlock"));

smalltalk.bind(smalltalk.String,"do:","do_"

,function (aBlock){var self=this;	for(var i=0;i<self.length;i++){aBlock(self.charAt(i));};return self;}

,"enumerating",unescape("do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09for%28var%20i%3D0%3Bi%3Cself.length%3Bi++%29%7BaBlock%28self.charAt%28i%29%29%3B%7D%27%7D"));

smalltalk.bind(smalltalk.String,"detect:ifNone:","detect_ifNone_"

,function (aBlock,anotherBlock){var self=this;	for(var i = 0; i < self.length; i++)
		if(aBlock(self.charAt(i))) return self.charAt(i);
	return anotherBlock();;return self;}

,"enumerating",unescape("detect%3A%20aBlock%20ifNone%3A%20anotherBlock%0D%0A%09%22%20Return%20the%20object%20in%20the%20receiver%20that%20return%20true%20when%20evaluated%20with%20aBlock%20or%20the%20result%20of%20evaluating%20anotherBlock.%20%22%0D%0A%0D%0A%7B%27%09for%28var%20i%20%3D%200%3B%20i%20%3C%20self.length%3B%20i++%29%0D%0A%09%09if%28aBlock%28self.charAt%28i%29%29%29%20return%20self.charAt%28i%29%3B%0D%0A%09return%20anotherBlock%28%29%3B%27%7D"));

smalltalk.bind(smalltalk.String,"includes:","includes_"

,function (anObject){var self=this;return (self.indexOf_(anObject) > (0));return self;}

,"testing",unescape("includes%3A%20anObject%0D%0A%09%22%20Return%20true%20if%20anObject%20is%20in%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%09%5E%28self%20indexOf%3A%20anObject%29%20%3E%200"));

smalltalk.bind(smalltalk.String,"withIndexDo:","withIndexDo_"

,function (aBlock){var self=this;	for(var i=0;i<self.length;i++){aBlock(self.charAt(i), i+1);};return self;}

,"enumerating",unescape("withIndexDo%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20the%20index%20positions%20in%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09for%28var%20i%3D0%3Bi%3Cself.length%3Bi++%29%7BaBlock%28self.charAt%28i%29%2C%20i+1%29%3B%7D%27%7D"));

smalltalk.bind(smalltalk.String,"asSymbol","asSymbol"

,function (){var self=this;return self;return self;}

,"conversion",unescape("asSymbol%0D%0A%09%22%20Return%20a%20symbol%20with%20the%20same%20characters%20as%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%22we%20do%20not%20discriminate%20singular%20strings%22"));

smalltalk.bind(smalltalk.String,"argumentCount","argumentCount"

,function (){var self=this;try{((self.isEmpty().or_((function(){return self.first().isLetter();}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "argumentCount", fn: function(){return self.occurrencesOf_(":")}})})();})() : nil);

((unescape("%7C%26%5C%5C+*/%3D%3E%3C%2C@%25%7E-").includes_(self.first())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "argumentCount", fn: function(){return (1)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "argumentCount", fn: function(){return self.occurrencesOf_(":")}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "argumentCount"){return $$ex.fn();} throw($$ex);}}

,"evaluating",unescape("argumentCount%0D%0A%09%22%20Return%20the%20number%20of%20arguments%20required%20to%20evaluate%20the%20receiver.%20%22%0D%0A%0D%0A%09%28self%20isEmpty%20or%3A%20%5B%20self%20first%20isLetter%20%5D%29%20ifTrue%3A%20%5B%20%5Eself%20occurrencesOf%3A%20%24%3A%20%5D.%0D%0A%09%28%27%7C%26%5C%5C+*/%3D%3E%3C%2C@%25%7E-%27%20includes%3A%20self%20first%29%20ifTrue%3A%20%5B%20%5E1%20%5D.%0D%0A%09%5Eself%20occurrencesOf%3A%20%24%3A"));

smalltalk.bind(smalltalk.String,"isLiteral","isLiteral"

,function (){var self=this;return ((smalltalk.RegularExpression.fromString_(unescape("%5B%5Ea-zA-Z0-9_%3A%5D")).exec_(self) || nil) === nil);return self;}

,"testing",unescape("isLiteral%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20can%20be%20output%20using%20literal%20notation.%20%22%0D%0A%0D%0A%09%5E%28%28RegularExpression%20fromString%3A%20%27%5B%5Ea-zA-Z0-9_%3A%5D%27%29%20exec%3A%20self%29%20isNil"));

smalltalk.bind(smalltalk.String,"asLiteral","asLiteral"

,function (){var self=this;return ((self.isLiteral()).mustBeBoolean()==true ? (function(){return unescape("%23")._comma(self);})() : (function(){return self.printString();})());return self;}

,"converting",unescape("asLiteral%0D%0A%09%22%20Return%20the%20receiver%20represented%20in%20literal%20notation.%20%22%0D%0A%0D%0A%09%5Eself%20isLiteral%20ifTrue%3A%20%5B%20%24%23%20%2Cself%20%5D%20ifFalse%3A%20%5B%20self%20printString%20%5D"));

smalltalk.bind(smalltalk.String,"occurrencesOf:","occurrencesOf_"

,function (aString){var self=this;try{var result=nil;var index=nil;((aString.isString()).mustBeBoolean()==true ? nil : (function(){result=(self.match(aString) || nil);return (function(){throw({name: "stReturn", selector: "occurrencesOf_", fn: function(){return ((((result || nil) === nil)).mustBeBoolean()==true ? (function(){return (0);})() : (function(){return (result["length"] || nil);})())}})})();})());

((aString.size()._eq((1))).mustBeBoolean()==true ? (function(){result=(self.match(smalltalk.RegularExpression.fromString_flag_(unescape("%5B")._comma(aString)._comma(unescape("%5D")), "g")) || nil);return (function(){throw({name: "stReturn", selector: "occurrencesOf_", fn: function(){return ((((result || nil) === nil)).mustBeBoolean()==true ? (function(){return (0);})() : (function(){return (result["length"] || nil);})())}})})();})() : nil);

result=(0);

index=(0);

(function(){while((function(){index=self.indexOf_startingAt_(aString, (index + (1)));return (index > (1));})()){(function(){return result=(result + (1));})()};return nil})();

(function(){throw({name: "stReturn", selector: "occurrencesOf_", fn: function(){return result}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "occurrencesOf_"){return $$ex.fn();} throw($$ex);}}

,"query",unescape("occurrencesOf%3A%20aString%0D%0A%09%22%20Return%20the%20times%20aString%20can%20be%20found%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20index%20%7C%0D%0A%09aString%20isString%20ifFalse%3A%20%5B%0D%0A%09%09result%20%3A%3D%20%28self%20%23match%3A%20aString%29%20%7C%7C%20nil.%0D%0A%09%09%5Eresult%20isNil%0D%0A%09%09%09ifTrue%3A%20%5B%200%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20result%20basicAt%3A%20%27length%27%20%5D%0D%0A%09%5D.%0D%0A%09aString%20size%20%3D%201%20ifTrue%3A%20%5B%0D%0A%09%09result%20%3A%3D%20%28self%20%23match%3A%20%28RegularExpression%0D%0A%09%09%09%09fromString%3A%20%27%5B%27%2CaString%2C%27%5D%27%0D%0A%09%09%09%09flag%3A%20%27g%27%29%0D%0A%09%09%09%09%29%20%7C%7C%20nil.%0D%0A%09%09%5Eresult%20isNil%0D%0A%09%09%09ifTrue%3A%20%5B%200%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20result%20basicAt%3A%20%27length%27%20%5D%0D%0A%09%5D.%0D%0A%09result%20%3A%3D%200.%20index%20%3A%3D%200.%0D%0A%09%5B%09index%20%3A%3D%20self%20indexOf%3A%20aString%20startingAt%3A%20index%20+%201.%0D%0A%09%09index%20%3E%201%20%5D%20whileTrue%3A%20%5B%20result%20%3A%3D%20result%20+%201%20%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.String,"escaped","escaped"

,function (){var self=this;return escape(self);return self;}

,"converting",unescape("escaped%0D%0A%09%22%20Return%20the%20receiver%20with%20escape%20codes.%20%22%0D%0A%0D%0A%09%5E%23%20%23escape%3A%20self"));

smalltalk.bind(smalltalk.String,"unescaped","unescaped"

,function (){var self=this;return unescape(self);return self;}

,"converting",unescape("unescaped%0D%0A%09%22%20Return%20the%20receiver%20from%20escape%20codes.%20%22%0D%0A%0D%0A%09%5E%23%20%23unescape%3A%20self"));

smalltalk.bind(smalltalk.String,"escapedCode","escapedCode"

,function (){var self=this;try{var escaped=nil;escaped=self.escaped();

((escaped._eq(self)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "escapedCode", fn: function(){return unescape("%22")._comma(escaped)._comma(unescape("%22"))}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "escapedCode", fn: function(){return unescape("unescape%28%22")._comma(escaped)._comma(unescape("%22%29"))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "escapedCode"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("escapedCode%0D%0A%09%22%20Return%20the%20code%20to%20reproduce%20receiver%20from%20%28javascript%29%20code.%20%22%0D%0A%0D%0A%09%7C%20escaped%20%7C%0D%0A%09escaped%20%3A%3D%20self%20escaped.%0D%0A%09escaped%20%3D%20self%20ifTrue%3A%20%5B%20%5E%24%22%20%2Cescaped%20%2C%24%22%20%5D.%0D%0A%09%5E%27unescape%28%22%27%20%2Cescaped%20%2C%27%22%29%27"));

smalltalk.bind(smalltalk.String,"asEncodedURI","asEncodedURI"

,function (){var self=this;return encodeURIComponent(self);return self;}

,"converting",unescape("asEncodedURI%0D%0A%09%22%20Return%20the%20receiver%20encoded%20as%20an%20URI%20component.%0D%0A%09Encodes%20special%20characters%20and%20it%20encodes%20the%20following%20characters%3A%20%2C%20/%20%3F%20%3A%20@%20%26%20%3D%20+%20%24%20%23%0D%0A%09%22%0D%0A%0D%0A%09%5E%23%20%23encodeURIComponent%3A%20self"));

smalltalk.bind(smalltalk.String,"asDecodedURI","asDecodedURI"

,function (){var self=this;return decodeURIComponent(self);return self;}

,"converting",unescape("asDecodedURI%0D%0A%09%22%20Return%20the%20receiver%20decoded%20as%20an%20URI%20component.%20%22%0D%0A%0D%0A%09%5E%23%20%23decodeURIComponent%3A%20self"));

smalltalk.bind(smalltalk.String,"add:","add_"

,function (anObject){var self=this;return self.errorReadOnly();return self;}

,"adding/removing",unescape("add%3A%20anObject%0D%0A%09%22%20Add%20anObject%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20errorReadOnly"));

smalltalk.bind(smalltalk.String,",","_comma"

,function (aString){var self=this;	return self + aString;return self;}

,"copying",unescape("%2C%20aString%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20aString%20appended.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20+%20aString%27%7D"));

smalltalk.bind(smalltalk.String,"copyWith:","copyWith_"

,function (anObject){var self=this;	return self + anObject;return self;}

,"copying",unescape("copyWith%3A%20anObject%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%7B%27%09return%20self%20+%20anObject%27%7D"));

smalltalk.bind(smalltalk.String,"copyFrom:to:","copyFrom_to_"

,function (anIndex,anotherIndex){var self=this;return self.substring((anIndex - (1)), anotherIndex);return self;}

,"copying",unescape("copyFrom%3A%20anIndex%20to%3A%20anotherIndex%0D%0A%09%22%20Return%20the%20receiver%20between%20limits.%20%22%0D%0A%0D%0A%09%5Eself%20%23substring%3A%20anIndex%20-%201%20to%3A%20anotherIndex"));

smalltalk.bind(smalltalk.String,"shallowCopy","shallowCopy"

,function (){var self=this;return self.$klass.fromString_(self);return self;}

,"copying",unescape("shallowCopy%0D%0A%09%22%20Return%20a%20shallow%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20fromString%3A%20self"));

smalltalk.bind(smalltalk.String,"deepCopy","deepCopy"

,function (){var self=this;return self.shallowCopy();return self;}

,"copying",unescape("deepCopy%0D%0A%09%22%20Return%20a%20deep%20copy%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20shallowCopy"));

smalltalk.bind(smalltalk.String,"indexOf:","indexOf_"

,function (aString){var self=this;return (self.indexOf(aString) + (1));return self;}

,"accessing",unescape("indexOf%3A%20aString%0D%0A%09%22%20Return%20the%20position%20of%20first%20occurrence%20of%20aString%20%28or%200%20if%20not%20present%29.%20%22%0D%0A%0D%0A%09%5E%28self%20%23indexOf%3A%20aString%29%20+%201"));

smalltalk.bind(smalltalk.String,"indexOf:ifAbsent:","indexOf_ifAbsent_"

,function (aString,aBlock){var self=this;var result=nil;result=self.indexOf_(aString);

return result._eq((0)).ifTrue_ifFalse_(aBlock, (function(){return result;}));return self;}

,"accessing",unescape("indexOf%3A%20aString%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20position%20of%20first%20occurrence%20of%20aString%20%28or%20the%20result%20of%20evaluating%20aBlock%29.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20indexOf%3A%20aString.%0D%0A%09%5Eresult%20%3D%200%20ifTrue%3A%20aBlock%20ifFalse%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.String,"indexOf:startingAt:","indexOf_startingAt_"

,function (aString,position){var self=this;return (self.indexOf(aString, (position - (1))) + (1));return self;}

,"accessing",unescape("indexOf%3A%20aString%20startingAt%3A%20position%0D%0A%09%22%20Return%20the%20position%20of%20first%20occurrence%20of%20aString%20after%20position%20%28or%200%20if%20not%20present%29.%20%22%0D%0A%0D%0A%09%5E%28self%20%23indexOf%3A%20aString%20from%3A%20position%20-%201%29%20+%201"));

smalltalk.bind(smalltalk.String,"lastIndexOf:","lastIndexOf_"

,function (aString){var self=this;return (self.lastIndexOf(aString) + (1));return self;}

,"accessing",unescape("lastIndexOf%3A%20aString%0D%0A%09%22%20Return%20the%20position%20of%20last%20occurrence%20of%20aString%20%28or%200%20if%20not%20present%29.%20%22%0D%0A%0D%0A%09%5E%28self%20%23lastIndexOf%3A%20aString%29%20+%201"));

smalltalk.bind(smalltalk.String,"lastIndexOf:ifAbsent:","lastIndexOf_ifAbsent_"

,function (aString,aBlock){var self=this;var result=nil;result=self.lastIndexOf_(aString);

return result._eq((0)).ifTrue_ifFalse_(aBlock, (function(){return result;}));return self;}

,"accessing",unescape("lastIndexOf%3A%20aString%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Return%20the%20position%20of%20last%20occurrence%20of%20aString%20%28or%20the%20result%20of%20evaluating%20aBlock%29.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20lastIndexOf%3A%20aString.%0D%0A%09%5Eresult%20%3D%200%20ifTrue%3A%20aBlock%20ifFalse%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.String,"lastIndexOf:startingAt:","lastIndexOf_startingAt_"

,function (aString,position){var self=this;return (self.lastIndexOf(aString, (position - (1))) + (1));return self;}

,"accessing",unescape("lastIndexOf%3A%20aString%20startingAt%3A%20position%0D%0A%09%22%20Return%20the%20position%20of%20last%20occurrence%20of%20aString%20before%20position%20%28or%200%20if%20not%20present%29.%20%22%0D%0A%0D%0A%09%5E%28self%20%23lastIndexOf%3A%20aString%20from%3A%20position%20-%201%29%20+%201"));

smalltalk.bind(smalltalk.String,"upTo:startingAt:","upTo_startingAt_"

,function (aString,position){var self=this;var index=nil;index=self.indexOf_startingAt_(aString, position);

index=((index._eq((0))).mustBeBoolean()==true ? (function(){return self.size();})() : (function(){return (index - (1));})());

return self.copyFrom_to_(position, index);return self;}

,"accessing",unescape("upTo%3A%20aString%20startingAt%3A%20position%0D%0A%09%22%20Return%20the%20receiver%20upto%20first%20occurrence%20of%20aString%20after%20position.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self%20indexOf%3A%20aString%20startingAt%3A%20position.%0D%0A%09index%20%3A%3D%20index%20%3D%200%20ifTrue%3A%20%5B%20self%20size%20%5D%20ifFalse%3A%20%5B%20index%20-%201%20%5D.%0D%0A%09%5Eself%20copyFrom%3A%20position%20to%3A%20index"));

smalltalk.bind(smalltalk.String,"upTo:","upTo_"

,function (aCharacter){var self=this;return self.upTo_startingAt_(aCharacter, (1));return self;}

,"accessing",unescape("upTo%3A%20aCharacter%0D%0A%09%22%20Return%20the%20receiver%20upto%20first%20occurrence%20of%20aCharacter.%20%22%0D%0A%0D%0A%09%5Eself%20upTo%3A%20aCharacter%20startingAt%3A%201"));

smalltalk.bind(smalltalk.String,"upToLast:","upToLast_"

,function (aString){var self=this;try{var index=nil;index=self.lastIndexOf_ifAbsent_(aString, (function(){return (function(){throw({name: "stReturn", selector: "upToLast_", fn: function(){return self}})})();}));

(function(){throw({name: "stReturn", selector: "upToLast_", fn: function(){return self.copyFrom_to_((1), index)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "upToLast_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("upToLast%3A%20aString%0D%0A%09%22%20Return%20the%20receiver%20upto%20last%20occurrence%20of%20aString.%20%22%0D%0A%0D%0A%09%7C%20index%20%7C%0D%0A%09index%20%3A%3D%20self%20lastIndexOf%3A%20aString%20ifAbsent%3A%20%5B%20%5Eself%20%5D.%0D%0A%09%5Eself%20copyFrom%3A%201%20to%3A%20index"));

smalltalk.bind(smalltalk.String,"asJavascriptName","asJavascriptName"

,function (){var self=this;try{((self.first()._eq("_")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asJavascriptName", fn: function(){return self}})})();})() : nil);

((smalltalk.String.reservedWords().includes_(self)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asJavascriptName", fn: function(){return "$$"._comma(self)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "asJavascriptName", fn: function(){return self}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "asJavascriptName"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("asJavascriptName%0D%0A%09%22%20Private%20-%20Return%20the%20receiver%20as%20a%20valid%20javascript%20name.%20%22%0D%0A%0D%0A%09self%20first%20%3D%20%24_%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09%28String%20reservedWords%20includes%3A%20self%29%20ifTrue%3A%20%5B%20%5E%27%24%24%27%2Cself%20%5D.%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.String,"asSelector","asSelector"

,function (){var self=this;try{var selector=nil;((self.isEmpty()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asSelector", fn: function(){return "$"}})})();})() : nil);

((self.match_(unescape("%5E%23"))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asSelector", fn: function(){return self.upTo_startingAt_(":", (2))}})})();})() : nil);

((self.isBackSlash()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asSelector", fn: function(){return "_bk"}})})();})() : nil);

	 return self
		.replace(/:/g,"_")
		.replace(/[+]/g,"_plus")
		.replace(/-/g,"_minus")
		.replace(/[*]/g,"_star")
		.replace(/[/]/g,"_slash")
		.replace(/[|]/g,"_bar")
		.replace(/[&]/g,"_amp")
		.replace(/>/g,"_gt")
		.replace(/</g,"_lt")
		.replace(/=/g,"_eq")
		.replace(/,/g,"_comma")
		.replace(/[@]/g,"_at")
		.replace(/~/g,"_no")
		.replace(/\\/g,"_bk")
		.asJavascriptName();
	;return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "asSelector"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("asSelector%0D%0A%09%22%20Private%20-%20Return%20the%20receiver%20as%20a%20valid%20javascript%20selector.%20%22%0D%0A%0D%0A%09%7C%20selector%20%7C%0D%0A%09self%20isEmpty%20ifTrue%3A%20%5B%20%5E%27%24%27%20%5D.%0D%0A%09%28self%20match%3A%20%27%5E%23%27%29%20ifTrue%3A%20%5B%20%5Eself%20upTo%3A%20%24%3A%20startingAt%3A%202%20%5D.%0D%0A%09self%20isBackSlash%20ifTrue%3A%20%5B%20%5E%27_bk%27%20%5D.%0D%0A%7B%27%09%20return%20self%0D%0A%09%09.replace%28/%3A/g%2C%22_%22%29%0D%0A%09%09.replace%28/%5B+%5D/g%2C%22_plus%22%29%0D%0A%09%09.replace%28/-/g%2C%22_minus%22%29%0D%0A%09%09.replace%28/%5B*%5D/g%2C%22_star%22%29%0D%0A%09%09.replace%28/%5B/%5D/g%2C%22_slash%22%29%0D%0A%09%09.replace%28/%5B%7C%5D/g%2C%22_bar%22%29%0D%0A%09%09.replace%28/%5B%26%5D/g%2C%22_amp%22%29%0D%0A%09%09.replace%28/%3E/g%2C%22_gt%22%29%0D%0A%09%09.replace%28/%3C/g%2C%22_lt%22%29%0D%0A%09%09.replace%28/%3D/g%2C%22_eq%22%29%0D%0A%09%09.replace%28/%2C/g%2C%22_comma%22%29%0D%0A%09%09.replace%28/%5B@%5D/g%2C%22_at%22%29%0D%0A%09%09.replace%28/%7E/g%2C%22_no%22%29%0D%0A%09%09.replace%28/%5C%5C/g%2C%22_bk%22%29%0D%0A%09%09.asJavascriptName%28%29%3B%0D%0A%09%27%7D"));

smalltalk.bind(smalltalk.String,"asJavascript","asJavascript"

,function (){var self=this;	 if(self.search(/^[a-zA-Z0-9_:.$ ]*$/) == -1)
			return "unescape(\"" + escape(self) + "\")";
		else
			return "\"" + self + "\""; ;return self;}

,"converting",unescape("asJavascript%0D%0A%09%22%20Return%20the%20javascript%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09%20if%28self.search%28/%5E%5Ba-zA-Z0-9_%3A.%24%20%5D*%24/%29%20%3D%3D%20-1%29%0D%0A%09%09%09return%20%22unescape%28%5C%22%22%20+%20escape%28self%29%20+%20%22%5C%22%29%22%3B%0D%0A%09%09else%0D%0A%09%09%09return%20%22%5C%22%22%20+%20self%20+%20%22%5C%22%22%3B%20%27%7D"));

smalltalk.bind(smalltalk.String,"replace:with:","replace_with_"

,function (aString,anotherString){var self=this;return self.replaceRegexp_with_(smalltalk.RegularExpression.fromString_flag_(aString, "g"), anotherString);return self;}

,unescape("regular%20expressions"),unescape("replace%3A%20aString%20with%3A%20anotherString%0D%0A%09%22%20Return%20the%20result%20of%20replacement%20of%20aString%20with%20anotherString%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09replaceRegexp%3A%20%28RegularExpression%20fromString%3A%20aString%20flag%3A%20%27g%27%29%0D%0A%09%09with%3A%20anotherString"));

smalltalk.bind(smalltalk.String,"replaceRegexp:with:","replaceRegexp_with_"

,function (aRegexp,aString){var self=this;return self.replace(aRegexp, aString);return self;}

,unescape("regular%20expressions"),unescape("replaceRegexp%3A%20aRegexp%20with%3A%20aString%0D%0A%09%22%20Return%20the%20result%20of%20replacement%20of%20aRegexp%20with%20aString%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23replace%3A%20aRegexp%20with%3A%20aString"));

smalltalk.bind(smalltalk.String,"tokenize:","tokenize_"

,function (aString){var self=this;return self.split(aString);return self;}

,"converting",unescape("tokenize%3A%20aString%0D%0A%09%22%20Return%20the%20split%20tokenization%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23split%3A%20aString"));

smalltalk.bind(smalltalk.String,"asArrayOfSubstrings","asArrayOfSubstrings"

,function (){var self=this;var result=nil;var start=nil;var i=nil;result=smalltalk.Array.$$new();

i=(1);

self.do_((function(c){((((start || nil) === nil)).mustBeBoolean()==true ? (function(){return ((c.isSeparator()).mustBeBoolean()==true ? nil : (function(){return start=i;})());})() : (function(){return ((c.isSeparator()).mustBeBoolean()==true ? (function(){result.add_(self.copyFrom_to_(start, (i - (1))));return start=nil;})() : nil);})());return i=(i + (1));}));

((((start || nil) !== nil)).mustBeBoolean()==true ? (function(){return result.add_(self.copyFrom_to_(start, self.size()));})() : nil);

return result;return self;}

,"converting",unescape("asArrayOfSubstrings%0D%0A%09%22%20Return%20an%20array%20of%20substrings%20from%20the%20receiver.%0D%0A%09The%20receiver%20is%20divided%20into%20substrings%20by%20one%20or%20more%20occurrences%20of%20separators.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20result%20start%20i%20%7C%0D%0A%09result%20%3A%3D%20Array%20new.%20i%20%3A%3D%201.%0D%0A%09self%20do%3A%20%5B%3Ac%7C%0D%0A%09%09start%20isNil%20ifTrue%3A%20%5B%20%22in%20separator%22%0D%0A%09%09%09c%20isSeparator%20ifFalse%3A%20%5B%20%22start%20of%20substring%22%0D%0A%09%09%09%09start%20%3A%3D%20i.%0D%0A%09%09%09%5D%0D%0A%09%09%5D%20ifFalse%3A%20%5B%20%22in%20word%22%0D%0A%09%09%09c%20isSeparator%20ifTrue%3A%20%5B%20%22end%20of%20substring%22%0D%0A%09%09%09%09result%20add%3A%20%28self%20copyFrom%3A%20start%20to%3A%20i%20-%201%29.%0D%0A%09%09%09%09start%20%3A%3D%20nil.%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%09i%20%3A%3D%20i%20+%201.%0D%0A%09%5D.%0D%0A%09start%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09result%20add%3A%20%28self%20copyFrom%3A%20start%20to%3A%20self%20size%29%0D%0A%09%5D.%0D%0A%09%5Eresult%0D%0A%0D%0A%22%09Obsolete%2C%20wrong%20implementation%0D%0A%09%5E%28self%20tokenize%3A%20%27%20%27%29%20reject%3A%20%5B%3Aeach%7C%20each%20isEmpty%20%5D%0D%0A%22"));

smalltalk.bind(smalltalk.String,"asArrayOfSubstringsSeparatedBy:","asArrayOfSubstringsSeparatedBy_"

,function (aCharacter){var self=this;return self.tokenize_(aCharacter);return self;}

,"converting",unescape("asArrayOfSubstringsSeparatedBy%3A%20aCharacter%0D%0A%09%22%20Return%20an%20array%20of%20substrings%20from%20the%20receiver.%0D%0A%09The%20receiver%20is%20divided%20into%20substrings%20by%20one%20or%20more%20occurrences%20of%20aCharacter.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20tokenize%3A%20aCharacter"));

smalltalk.bind(smalltalk.String,"match:","match_"

,function (aRegexp){var self=this;	return self.search(aRegexp) != -1;return self;}

,unescape("regular%20expressions"),unescape("match%3A%20aRegexp%0D%0A%09%22%20Return%20the%20match%20index%20of%20aRegexp%20in%20the%20receiver.%20%22%0D%0A%0D%0A%7B%27%09return%20self.search%28aRegexp%29%20%21%3D%20-1%27%7D"));

smalltalk.bind(smalltalk.String,"asString","asString"

,function (){var self=this;return self;return self;}

,"converting",unescape("asString%0D%0A%09%22%20Return%20the%20text%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.String,"between:and:","between_and_"

,function (min,max){var self=this;return min._lt_eq(self).and_((function(){return self._lt_eq(max);}));return self;}

,"query",unescape("between%3A%20min%20and%3A%20max%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20greater%20than%20or%20equal%20to%20min%20and%20less%20than%20or%20equal%20to%20max.%20%22%0D%0A%0D%0A%09%5Emin%20%3C%3D%20self%20and%3A%20%5B%20self%20%3C%3D%20max%20%5D"));

smalltalk.bind(smalltalk.String,"isLetter","isLetter"

,function (){var self=this;return self.size()._eq((1)).and_((function(){return self.match_(unescape("%5BA-Za-z%5D"));}));return self;}

,"query",unescape("isLetter%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20one%20character%20letter.%20%22%0D%0A%0D%0A%09%5Eself%20size%20%3D%201%20and%3A%20%5B%20self%20match%3A%20%27%5BA-Za-z%5D%27%20%5D"));

smalltalk.bind(smalltalk.String,"isDigit","isDigit"

,function (){var self=this;return self.size()._eq((1)).and_((function(){return self.match_(unescape("%5B0-9%5D"));}));return self;}

,"query",unescape("isDigit%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20one%20character%20numeric%20digit.%20%22%0D%0A%0D%0A%09%5Eself%20size%20%3D%201%20and%3A%20%5B%20self%20match%3A%20%27%5B0-9%5D%27%20%5D"));

smalltalk.bind(smalltalk.String,"isUpperCase","isUpperCase"

,function (){var self=this;return self.match_(unescape("%5B%5EA-Z%5D")).not();return self;}

,"query",unescape("isUpperCase%0D%0A%09%22%20Return%20true%20if%20all%20the%20receiver%20characters%20are%20uppercase.%20%22%0D%0A%0D%0A%09%5E%28self%20match%3A%20%27%5B%5EA-Z%5D%27%29%20not"));

smalltalk.bind(smalltalk.String,"isLowerCase","isLowerCase"

,function (){var self=this;return self.match_(unescape("%5B%5Ea-z%5D")).not();return self;}

,"query",unescape("isLowerCase%0D%0A%09%22%20Return%20true%20if%20all%20the%20receiver%20characters%20are%20lowercase.%20%22%0D%0A%0D%0A%09%5E%28self%20match%3A%20%27%5B%5Ea-z%5D%27%29%20not"));

smalltalk.bind(smalltalk.String,"isUppercase","isUppercase"

,function (){var self=this;return self.isUpperCase();return self;}

,"query",unescape("isUppercase%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20one%20character%20uppercase.%20%22%0D%0A%0D%0A%09%5Eself%20isUpperCase"));

smalltalk.bind(smalltalk.String,"isLowercase","isLowercase"

,function (){var self=this;return self.isLowerCase();return self;}

,"query",unescape("isLowercase%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20one%20character%20lowercase.%20%22%0D%0A%0D%0A%09%5Eself%20isLowerCase"));

smalltalk.bind(smalltalk.String,"asUppercase","asUppercase"

,function (){var self=this;return self.toUpperCase();return self;}

,"converting",unescape("asUppercase%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20converted%20to%20uppercase.%20%22%0D%0A%0D%0A%09%5Eself%20%23toUpperCase"));

smalltalk.bind(smalltalk.String,"asUpperCase","asUpperCase"

,function (){var self=this;return self.asUppercase();return self;}

,"converting",unescape("asUpperCase%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20converted%20to%20uppercase.%20%22%0D%0A%0D%0A%09%5Eself%20asUppercase"));

smalltalk.bind(smalltalk.String,"asLowercase","asLowercase"

,function (){var self=this;return self.toLowerCase();return self;}

,"converting",unescape("asLowercase%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20converted%20to%20lowercase.%20%22%0D%0A%0D%0A%09%5Eself%20%23toLowerCase"));

smalltalk.bind(smalltalk.String,"asLowerCase","asLowerCase"

,function (){var self=this;return self.asLowercase();return self;}

,"converting",unescape("asLowerCase%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20converted%20to%20lowercase.%20%22%0D%0A%0D%0A%09%5Eself%20asLowercase"));

smalltalk.bind(smalltalk.String,"asSmalltalkName:","asSmalltalkName_"

,function (upCase){var self=this;try{var up=nil;((upCase).mustBeBoolean()==true ? nil : (function(){return ((self.notEmpty().and_((function(){return self.first().isUppercase();}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asSmalltalkName_", fn: function(){return self.first().asLowercase()._comma(self.copyFrom_to_((2), self.size())).asSmalltalkName_(false)}})})();})() : nil);})());

up=upCase;

(function(){throw({name: "stReturn", selector: "asSmalltalkName_", fn: function(){return self.inject_into_("", (function(result, each){return ((unescape("_%3A.%26%25%24%3F").includes_(each)).mustBeBoolean()==true ? (function(){up=true;return result;})() : (function(){return result._comma(((up).mustBeBoolean()==true ? (function(){up=false;return each.asUppercase();})() : (function(){return each;})()));})());}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "asSmalltalkName_"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("asSmalltalkName%3A%20upCase%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20converted%20to%20a%20smalltalk%20global%20name.%20%22%0D%0A%0D%0A%09%7C%20up%20%7C%0D%0A%09upCase%20ifFalse%3A%20%5B%20%22force%20first%20letter%20in%20lowercase%22%0D%0A%09%09%28self%20notEmpty%20and%3A%20%5B%20self%20first%20isUppercase%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%5E%28self%20first%20asLowercase%2C%20%28self%20copyFrom%3A%202%20to%3A%20self%20size%29%29%0D%0A%09%09%09%09asSmalltalkName%3A%20false%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09up%20%3A%3D%20upCase.%0D%0A%09%5Eself%20inject%3A%20%27%27%20into%3A%20%5B%3Aresult%20%3Aeach%7C%0D%0A%09%09%28%27_%3A.%26%25%24%3F%27%20includes%3A%20each%29%20ifTrue%3A%20%5B%20up%20%3A%3D%20true.%20result%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20result%20%2C%20%28up%0D%0A%09%09%09ifTrue%3A%20%5B%20%20up%20%3A%3D%20false.%20each%20asUppercase%20%5D%0D%0A%09%09%09ifFalse%3A%20%5Beach%5D%29%0D%0A%09%09%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.String,"asGlobalName","asGlobalName"

,function (){var self=this;return self.asSmalltalkName_(true);return self;}

,"converting",unescape("asGlobalName%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20converted%20to%20a%20smalltalk%20global%20name.%20%22%0D%0A%0D%0A%09%5Eself%20asSmalltalkName%3A%20true"));

smalltalk.bind(smalltalk.String,"asLocalName","asLocalName"

,function (){var self=this;return self.asSmalltalkName_(false);return self;}

,"converting",unescape("asLocalName%0D%0A%09%22%20Return%20a%20copy%20of%20the%20receiver%20converted%20to%20a%20smalltalk%20local%20name.%20%22%0D%0A%0D%0A%09%5Eself%20asSmalltalkName%3A%20false"));

smalltalk.bind(smalltalk.String,"digitValue","digitValue"

,function (){var self=this;return ("0123456789ABCDEF".indexOf_(self) - (1)).max_(((0) - (1)));return self;}

,"converting",unescape("digitValue%0D%0A%09%22%20Return%20the%20digit%20value%20of%20the%20receiver%20%28or%20-1%29.%20%22%0D%0A%0D%0A%09%5E%28%270123456789ABCDEF%27%20indexOf%3A%20self%29%20-%201%20max%3A%200%20-%201"));

smalltalk.bind(smalltalk.String,"asNumber","asNumber"

,function (){var self=this;try{((self.includes_("r")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asNumber", fn: function(){return smalltalk.Number.readFrom_(self.readStream())}})})();})() : nil);

	return Number(self); ;return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "asNumber"){return $$ex.fn();} throw($$ex);}}

,"converting",unescape("asNumber%0D%0A%09%22%20Return%20the%20receiver%20as%20a%20Number.%20%22%0D%0A%0D%0A%09%28self%20includes%3A%20%22%24r%22%27r%27%29%20ifTrue%3A%20%5B%0D%0A%09%09%5ENumber%20readFrom%3A%20self%20readStream%0D%0A%09%5D.%0D%0A%7B%27%09return%20Number%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.String,"errorReadOnly","errorReadOnly"

,function (){var self=this;return self.error_(unescape("Object%20is%20read-only"));return self;}

,unescape("error%20handling"),unescape("errorReadOnly%0D%0A%09%22%20Private%20-%20The%20receiver%20is%20read-only%20instance.%20%22%0D%0A%0D%0A%09%5Eself%20error%3A%20%27Object%20is%20read-only%27"));

smalltalk.bind(smalltalk.String,"printString","printString"

,function (){var self=this;return unescape("%27")._comma(self)._comma(unescape("%27"));return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20the%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%27%27%27%2C%20self%2C%20%27%27%27%27"));

smalltalk.bind(smalltalk.String,"isString","isString"

,function (){var self=this;return true;return self;}

,"testing",unescape("isString%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20String.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.String,"isBackSlash","isBackSlash"

,function (){var self=this;return self._eq(unescape("%5C"));return self;}

,"testing",unescape("isBackSlash%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20back-slash%20string.%20%22%0D%0A%0D%0A%09%5Eself%20%3D%20%24%5C%20"));

smalltalk.bind(smalltalk.String,">","_gt"

,function (aString){var self=this;	return String(self) > aString; ;return self;}

,"comparing",unescape("%3E%20aString%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20greater%20than%20aString.%20%22%0D%0A%0D%0A%7B%27%09return%20String%28self%29%20%3E%20aString%3B%20%27%7D"));

smalltalk.bind(smalltalk.String,"<","_lt"

,function (aString){var self=this;	return String(self) < aString;return self;}

,"comparing",unescape("%3C%20aString%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20smaller%20than%20aString.%20%22%0D%0A%0D%0A%7B%27%09return%20String%28self%29%20%3C%20aString%27%7D"));

smalltalk.bind(smalltalk.String,">=","_gt_eq"

,function (aString){var self=this;	return String(self) >= aString;return self;}

,"comparing",unescape("%3E%3D%20aString%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20greater%20than%20or%20equal%20to%20aString.%20%22%0D%0A%0D%0A%7B%27%09return%20String%28self%29%20%3E%3D%20aString%27%7D"));

smalltalk.bind(smalltalk.String,"<=","_lt_eq"

,function (aString){var self=this;	return String(self) <= aString;return self;}

,"comparing",unescape("%3C%3D%20aString%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20smaller%20than%20or%20equal%20to%20aString.%20%22%0D%0A%0D%0A%7B%27%09return%20String%28self%29%20%3C%3D%20aString%27%7D"));

smalltalk.bind(smalltalk.String,"remove:ifAbsent:","remove_ifAbsent_"

,function (anObject,aBlock){var self=this;return self.errorReadOnly();return self;}

,"adding/removing",unescape("remove%3A%20anObject%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Remove%20anObject%20from%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20errorReadOnly"));

smalltalk.bind(smalltalk.String,"asJSONObject","asJSONObject"

,function (){var self=this;return self._comma("");return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20an%20object%20mapping%20the%20receiver%20to%20JSON%20structure.%20%22%0D%0A%0D%0A%09%5Eself%20%2C%20%27%27%0D%0A%22Note%3A%09we%20need%20to%20normalize%20result%20to%20do%20not%20destroy%20typeof%20checkings%0D%0A%09Do%20NOT%20modify%20this%20method%20if%20you%20do%20not%20know%20what%20you%20are%20doing.%0D%0A%09If%20you%20remove%20the%20%2C%27%27%20computation%2C%20the%20returned%20object%20will%20return%20%27object%27%20and%20not%20%27string%27%20as%20result%20of%20typeof%20operation.%0D%0A%22"));

smalltalk.bind(smalltalk.String,"isCharacter","isCharacter"

,function (){var self=this;	 return self.length == 1; ;return self;}

,"conversion",unescape("isCharacter%0D%0A%09%22%20Characters%20-%20Implemented%20to%20support%20Character%20protocoll%20for%20one-character%20Strings.%20%22%0D%0A%0D%0A%7B%27%09%20return%20self.length%20%3D%3D%201%3B%20%27%7D"));

smalltalk.bind(smalltalk.String,"asciiValue","asciiValue"

,function (){var self=this;return self.charCodeAt((0));return self;}

,"conversion",unescape("asciiValue%0D%0A%09%22%20Characters%20-%20Return%20the%20number%20corresponding%20to%20the%20ASCII%20encoding%20of%20the%20first%20character%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23charCodeAt%3A%200"));

smalltalk.bind(smalltalk.String,"isSeparator","isSeparator"

,function (){var self=this;	 return (new RegExp("\\s")).test(self); ;return self;}

,"query",unescape("isSeparator%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20character%20is%20either%20a%20space%2C%20tab%2C%20carriage-return%2C%20line-feed%2C%20form-feed%20character%2C%20or%20double-byte%20space%2C%20else%20answer%20false.%22%0D%0A%0D%0A%7B%27%09%20return%20%28new%20RegExp%28%22%5C%5Cs%22%29%29.test%28self%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.String,"asAsciiZ","asAsciiZ"

,function (){var self=this;return self._comma(self.$klass.zero());return self;}

,"converting",unescape("asAsciiZ%0D%0A%09%22%20Return%20the%20receiver%20with%20ascii%20zero%20appended.%20%22%0D%0A%0D%0A%09%5Eself%20%2C%20self%20class%20zero"));

smalltalk.bind(smalltalk.String,"trimFirst:last:","trimFirst_last_"

,function (firstBlock,lastBlock){var self=this;try{var start=nil;var stop=nil;start=(1);

stop=self.size();

(function(){while((function(){((start._gt(stop)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "trimFirst_last_", fn: function(){return smalltalk.String.$$new()}})})();})() : nil);return firstBlock.value_(self.at_(start));})()){(function(){return start=(start + (1));})()};return nil})();

(function(){while((function(){((stop._lt(start)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "trimFirst_last_", fn: function(){return smalltalk.String.$$new()}})})();})() : nil);return lastBlock.value_(self.at_(stop));})()){(function(){return stop=(stop - (1));})()};return nil})();

(function(){throw({name: "stReturn", selector: "trimFirst_last_", fn: function(){return self.copyFrom_to_(start, stop)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "trimFirst_last_"){return $$ex.fn();} throw($$ex);}}

,"selection",unescape("trimFirst%3A%20firstBlock%20last%3A%20lastBlock%0D%0A%09%22%20Return%20a%20String%20containing%20the%20result%20of%20trimming%20characters%20matching%20blocks%20from%20both%20sides%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20start%20stop%20%7C%0D%0A%09start%20%3A%3D%201.%20stop%20%3A%3D%20self%20size.%0D%0A%09%5B%09start%20%3E%20stop%20ifTrue%3A%20%5B%20%5EString%20new%20%5D.%0D%0A%09%09firstBlock%20value%3A%20%28self%20at%3A%20start%29%0D%0A%09%5D%20whileTrue%3A%20%5B%20start%20%3A%3D%20start%20+%201%20%5D.%0D%0A%09%5B%09stop%20%3C%20start%20ifTrue%3A%20%5B%20%5EString%20new%20%5D.%0D%0A%09%09lastBlock%20value%3A%20%28self%20at%3A%20stop%29%0D%0A%09%5D%20whileTrue%3A%20%5B%20stop%20%3A%3D%20stop%20-%201%20%5D.%0D%0A%09%5Eself%20copyFrom%3A%20start%20to%3A%20stop"));

smalltalk.bind(smalltalk.String,"trim:","trim_"

,function (aBlock){var self=this;return self.trimFirst_last_(aBlock, aBlock);return self;}

,"selection",unescape("trim%3A%20aBlock%0D%0A%09%22%20Return%20a%20String%20containing%20the%20result%20of%20trimming%20characters%20matching%20aBlock%20from%20both%20sides%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20trimFirst%3A%20aBlock%20last%3A%20aBlock"));

smalltalk.bind(smalltalk.String,"trimFirst:","trimFirst_"

,function (aBlock){var self=this;return self.trimFirst_last_(aBlock, (function(c){return false;}));return self;}

,"selection",unescape("trimFirst%3A%20aBlock%0D%0A%09%22%20Return%20a%20String%20containing%20the%20result%20of%20trimming%20characters%20matching%20aBlock%20from%20start%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20trimFirst%3A%20aBlock%20last%3A%20%5B%3Ac%7C%20false%20%5D"));

smalltalk.bind(smalltalk.String,"trimLast:","trimLast_"

,function (aBlock){var self=this;return self.trimFirst_last_((function(c){return false;}), aBlock);return self;}

,"selection",unescape("trimLast%3A%20aBlock%0D%0A%09%22%20Return%20a%20String%20containing%20the%20result%20of%20trimming%20characters%20matching%20aBlock%20from%20end%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20trimFirst%3A%20%5B%3Ac%7C%20false%20%5D%20last%3A%20aBlock"));

smalltalk.bind(smalltalk.String,"trimBlanks","trimBlanks"

,function (){var self=this;return self.trim_((function(c){return c.isSeparator();}));return self;}

,"selection",unescape("trimBlanks%0D%0A%09%22%20Return%20a%20String%20containing%20the%20receiver%20string%20with%20leading%20and%20trailing%20blanks%20removed.%20%22%0D%0A%0D%0A%09%5Eself%20trim%3A%20%5B%3Ac%7C%20c%20isSeparator%20%5D"));

smalltalk.bind(smalltalk.String,"yourself","yourself"

,function (){var self=this;return self._comma("");return self;}

,"identity",unescape("yourself%20%0D%0A%09%22%20Return%20the%20receiver.%0D%0A%09Note%3A%20do%20NOT%20modify/remove%20this%20method%20if%20you%20dont%20know%20what%20you%20are%20doing.%0D%0A%09Test%20the%20following%20expression%20after%20changing%20this%20code%3A%0D%0A%09%09%23new%20yourself%20%3D%3D%20%23new%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20%2C%27%27"));

smalltalk.bind(smalltalk.String,"evaluateFor:","evaluateFor_"

,function (anObject){var self=this;return anObject.perform_(self);return self;}

,"evaluating",unescape("evaluateFor%3A%20anObject%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20with%20anObject.%20%22%0D%0A%0D%0A%09%5EanObject%20perform%3A%20self"));

smalltalk.bind(smalltalk.String,"asParser","asParser"

,function (){var self=this;return smalltalk.PPStringParser.$$new().string_(self);return self;}

,"Compiler-converting",unescape("asParser%0D%0A%09%22%20Return%20a%20parser%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPStringParser%20new%20string%3A%20self"));

smalltalk.bind(smalltalk.String,"asChoiceParser","asChoiceParser"

,function (){var self=this;return smalltalk.PPChoiceParser.withAll_(self.asArray().collect_((function(each){return each.asParser();})));return self;}

,"Compiler-converting",unescape("asChoiceParser%0D%0A%09%22%20Return%20a%20parser%20of%20choices%20for%20each%20character%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPChoiceParser%20withAll%3A%20%28self%20asArray%20collect%3A%20%5B%3Aeach%20%7C%20each%20asParser%20%5D%29"));

smalltalk.bind(smalltalk.String,"asCharacterParser","asCharacterParser"

,function (){var self=this;return smalltalk.PPCharacterParser.$$new().string_(self);return self;}

,"Compiler-converting",unescape("asCharacterParser%0D%0A%09%22%20Return%20a%20parser%20on%20the%20characters%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EPPCharacterParser%20new%20string%3A%20self"));

smalltalk.bind(smalltalk.String,"showIt","showIt"

,function (){var self=this;return self.print_(self.evaluate());return self;}

,"Compiler-evaluating",unescape("showIt%0D%0A%09%22%20Show/Print%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20print%3A%20self%20evaluate"));

smalltalk.bind(smalltalk.String,"evaluate","evaluate"

,function (){var self=this;return smalltalk.Compiler.evaluate_(self);return self;}

,"Compiler-evaluating",unescape("evaluate%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ECompiler%20evaluate%3A%20self"));

smalltalk.bind(smalltalk.String,"evaluateIn:","evaluateIn_"

,function (aReceiver){var self=this;return smalltalk.Compiler.evaluate_to_(self, aReceiver);return self;}

,"Compiler-evaluating",unescape("evaluateIn%3A%20aReceiver%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20in%20the%20context%20of%20aReceiver.%20%22%0D%0A%0D%0A%09%5ECompiler%20evaluate%3A%20self%20to%3A%20aReceiver"));

smalltalk.bind(smalltalk.String,"doIt","doIt"

,function (){var self=this;return smalltalk.Compiler.doIt_(self);return self;}

,"Compiler-evaluating",unescape("doIt%0D%0A%09%22%20Return%20the%20result%20of%20evaluating%20the%20receiver%20or%20the%20error%20occurred%20during%20compilation%20or%20evaluation.%20%22%0D%0A%0D%0A%09%5ECompiler%20doIt%3A%20self"));

smalltalk.bind(smalltalk.String,"fileIn","fileIn"

,function (){var self=this;return self.stream().fileIn();return self;}

,"Compiler-fileIn",unescape("fileIn%0D%0A%09%22%20FileIn%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20stream%20fileIn"));

smalltalk.bind(smalltalk.String,"senders","senders"

,function (){var self=this;return smalltalk.Smalltalk.sendersOf_(self);return self;}

,"Compiler-query",unescape("senders%0D%0A%09%22%20Return%20the%20senders%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ESmalltalk%20sendersOf%3A%20self"));

smalltalk.bind(smalltalk.String,"implementors","implementors"

,function (){var self=this;return smalltalk.Smalltalk.implementorsOf_(self);return self;}

,"Compiler-query",unescape("implementors%0D%0A%09%22%20Return%20the%20implementors%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ESmalltalk%20implementorsOf%3A%20self"));

smalltalk.bind(smalltalk.String,"asStSelector","asStSelector"

,function (){var self=this;try{var operations=nil;((self._eq("$")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asStSelector", fn: function(){return ""}})})();})() : nil);

((self._eq("_bk")).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asStSelector", fn: function(){return unescape("%5C")}})})();})() : nil);

((self.match_(unescape("%5E%5B%24%5D%5B%24%5D"))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asStSelector", fn: function(){return self.copyFrom_to_((3), self.size()).asStSelector()}})})();})() : nil);

operations=[[unescape("+"), "_plus"], [unescape("-"), "_minus"], [unescape("*"), "_star"], [unescape("/"), "_slash"], [unescape("%7C"), "_bar"], [unescape("%26"), "_amp"], [unescape("%3E"), "_gt"], [unescape("%3C"), "_lt"], [unescape("%3D"), "_eq"], [unescape("%2C"), "_comma"], [unescape("@"), "_at"], [unescape("%7E"), "_no"], [unescape("%5C"), "_bk"]];

operations.do_((function(tuple){return ((self.match_(unescape("%5E")._comma(tuple.last()))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "asStSelector", fn: function(){return operations.reversed().inject_into_(self, (function(result, each){return result.replace_with_(each.last(), each.first());}))}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "asStSelector", fn: function(){return self.replace_with_("_", ":")}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "asStSelector"){return $$ex.fn();} throw($$ex);}}

,"Compiler-converting",unescape("asStSelector%0D%0A%09%22%20Return%20a%20smalltalk%20selector%20from%20a%20javascript%20function%20name.%0D%0A%09Note%3A%20it%20must%20be%20the%20reverse%20operation%20of%20%23asSelector%0D%0A%09%22%0D%0A%0D%0A%09%7C%20operations%20%7C%0D%0A%09self%20%3D%20%27%24%27%20ifTrue%3A%20%5B%20%5E%27%27%20%5D.%0D%0A%09self%20%3D%20%27_bk%27%20ifTrue%3A%20%5B%20%5E%24%5C%20%5D.%0D%0A%09%28self%20match%3A%20%27%5E%5B%24%5D%5B%24%5D%27%29%20ifTrue%3A%20%5B%20%5E%28self%20copyFrom%3A%203%20to%3A%20self%20size%29%20asStSelector%20%5D.%0D%0A%09operations%20%3A%3D%20%23%28%0D%0A%09%09%23%28%20%24+%20%23_plus%20%29%0D%0A%09%09%23%28%20%24-%20%23_minus%20%29%0D%0A%09%09%23%28%20%24*%20%23_star%20%29%0D%0A%09%09%23%28%20%24/%20%23_slash%20%29%0D%0A%09%09%23%28%20%24%7C%20%23_bar%20%29%0D%0A%09%09%23%28%20%24%26%20%23_amp%20%29%0D%0A%09%09%23%28%20%24%3E%20%23_gt%20%29%0D%0A%09%09%23%28%20%24%3C%20%23_lt%20%29%0D%0A%09%09%23%28%20%24%3D%20%23_eq%20%29%0D%0A%09%09%23%28%20%24%2C%20%23_comma%20%29%0D%0A%09%09%23%28%20%24@%20%23_at%20%29%0D%0A%09%09%23%28%20%24%7E%20%23_no%20%29%0D%0A%09%09%23%28%20%24%5C%20%23_bk%20%29%0D%0A%09%29.%0D%0A%09operations%20do%3A%20%5B%3Atuple%7C%0D%0A%09%09%28self%20match%3A%20%24%5E%20%2C%20tuple%20last%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%5Eoperations%20reversed%20inject%3A%20self%20into%3A%20%5B%3Aresult%20%3Aeach%7C%0D%0A%09%09%09%09result%20replace%3A%20each%20last%20with%3A%20each%20first%0D%0A%09%09%09%5D%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09%5Eself%20replace%3A%20%24_%20with%3A%20%24%3A"));

smalltalk.bind(smalltalk.String,"outputToFile:","outputToFile_"

,function (fileName){var self=this;return fileWrite(fileName, self, "wb");return self;}

,"image-io",unescape("outputToFile%3A%20fileName%0D%0A%09%22%20Save%20the%20receiver%27s%20contents%20onto%20a%20file%20at%20fileName.%20%22%0D%0A%0D%0A%09%5E%23%20%23fileWrite%3A%20fileName%20string%3A%20self%20mode%3A%20%27wb%27"));

smalltalk.bind(smalltalk.String,"appendToFile:","appendToFile_"

,function (fileName){var self=this;return fileWrite(fileName, self, "ab");return self;}

,"image-io",unescape("appendToFile%3A%20fileName%0D%0A%09%22%20Append%20the%20receiver%27s%20contents%20onto%20a%20file%20at%20fileName.%20%22%0D%0A%0D%0A%09%5E%23%20%23fileWrite%3A%20fileName%20string%3A%20self%20mode%3A%20%27ab%27"));

smalltalk.bind(smalltalk.String,"anchor:","anchor_"

,function (aName){var self=this;return ((((aName || nil) === nil)).mustBeBoolean()==true ? (function(){return self.anchor();})() : (function(){return self.anchor(aName);})());return self;}

,"DOM-conversion",unescape("anchor%3A%20aName%0D%0A%09%22%20Return%20the%20string%20code%20for%20the%20HTML%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EaName%20isNil%0D%0A%09ifTrue%3A%20%5B%20self%20anchor%20%5D%0D%0A%09ifFalse%3A%20%5B%20self%20%23anchor%3A%20aName%20%5D"));

smalltalk.bind(smalltalk.String,"fontColor:","fontColor_"

,function (aColor){var self=this;return self.fontcolor(aColor);return self;}

,"DOM-conversion",unescape("fontColor%3A%20aColor%0D%0A%09%22%20Return%20the%20string%20code%20for%20the%20HTML%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23fontcolor%3A%20aColor"));

smalltalk.bind(smalltalk.String,"fontSize:","fontSize_"

,function (aSize){var self=this;return self.fontsize(aSize);return self;}

,"DOM-conversion",unescape("fontSize%3A%20aSize%0D%0A%09%22%20Return%20the%20string%20code%20for%20the%20HTML%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23fontsize%3A%20aSize"));

smalltalk.bind(smalltalk.String,"link:","link_"

,function (url){var self=this;return self.link(url);return self;}

,"DOM-conversion",unescape("link%3A%20url%0D%0A%09%22%20Return%20the%20string%20code%20for%20the%20HTML%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23link%3A%20url"));

smalltalk.bind(smalltalk.ComposedAssociations,",","_comma"

,function (anObject){var self=this;try{((anObject.isAssociation()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_comma", fn: function(){return (function($rec){$rec.add_(anObject);return $rec.yourself();})(self)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "_comma", fn: function(){return smalltalk.whoImplements(smalltalk.ComposedAssociations,'_comma').$superclass.$fn.prototype['_comma'].apply(self, [anObject])}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_comma"){return $$ex.fn();} throw($$ex);}}

,"composing",unescape("%2C%20anObject%0D%0A%09%22%20Compose%20the%20receiver%20with%20object%20anObject%20%28anAssociation%20or%20collection%29.%0D%0A%09Return%20the%20composite%20result.%0D%0A%09%22%0D%0A%0D%0A%09anObject%20isAssociation%20ifTrue%3A%20%5B%20%5Eself%20add%3A%20anObject%3B%20yourself%20%5D.%0D%0A%09%5Esuper%20%2C%20anObject"));

smalltalk.bind(smalltalk.ComposedAssociations,"hashObject","hashObject"

,function (){var self=this;	return {}; ;return self;}

,"private",unescape("hashObject%0D%0A%09%22%20Private%20-%20Return%20an%20empty%20hash%20object.%20%22%0D%0A%0D%0A%7B%27%09return%20%7B%7D%3B%20%27%7D"));

smalltalk.bind(smalltalk.ComposedAssociations,"install:value:into:","install_value_into_"

,function (key,value,jsObject){var self=this;try{((self.isObject_(key).and_((function(){return key.isArray();}))).mustBeBoolean()==true ? (function(){((key.size()._eq((1))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "install_value_into_", fn: function(){return self.install_value_into_(key.first(), value, jsObject)}})})();})() : nil);return (((key.size() > (1))).mustBeBoolean()==true ? (function(){var target=nil;target=(jsObject[key.first()] || (function(){return (jsObject[key.first()]=(self.hashObject()));}).value());return (function(){throw({name: "stReturn", selector: "install_value_into_", fn: function(){return self.install_value_into_(key.copyFrom_to_((2), key.size()), value, target)}})})();})() : nil);})() : nil);

(function(){throw({name: "stReturn", selector: "install_value_into_", fn: function(){return (jsObject[key]=(value))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "install_value_into_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("install%3A%20key%20value%3A%20value%20into%3A%20jsObject%0D%0A%09%22%20Private%20-%20Install%20a%20key/value%20pair%20into%20jsObject.%20%22%0D%0A%0D%0A%09%28%28self%20isObject%3A%20key%29%20and%3A%20%5B%20key%20isArray%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09key%20size%20%3D%201%20ifTrue%3A%20%5B%20%5Eself%20install%3A%20key%20first%20value%3A%20value%20into%3A%20jsObject%20%5D.%0D%0A%09%09key%20size%20%3E%201%20ifTrue%3A%20%5B%20%7C%20target%20%7C%0D%0A%09%09%09target%20%3A%3D%20jsObject%20basicAt%3A%20key%20first%20ifAbsent%3A%20%5B%0D%0A%09%09%09%09jsObject%20basicAt%3A%20key%20first%20put%3A%20self%20hashObject%0D%0A%09%09%09%5D.%0D%0A%09%09%09%5Eself%20install%3A%20%28key%20copyFrom%3A%202%20to%3A%20key%20size%29%20value%3A%20value%20into%3A%20target%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09%5EjsObject%20basicAt%3A%20key%20put%3A%20value"));

smalltalk.bind(smalltalk.ComposedAssociations,"asJSONObject","asJSONObject"

,function (){var self=this;return self.json();return self;}

,"converting",unescape("asJSONObject%0D%0A%09%22%20Return%20a%20JSON%20structure%20with%20the%20receiver%27s%20contents.%20%22%0D%0A%0D%0A%09%5Eself%20json"));

smalltalk.bind(smalltalk.ComposedAssociations,"json","json"

,function (){var self=this;var result=nil;var value=nil;result=self.hashObject();

self.do_((function(assoc){value=((self.isObject_(assoc.value())).mustBeBoolean()==true ? (function(){return assoc.value().json();})() : (function(){return assoc.value();})());return self.install_value_into_(assoc.key(), value, result);}));

return result;return self;}

,"converting",unescape("json%0D%0A%09%22%20Return%20the%20receiver%20as%20a%20hash%20object.%20%22%0D%0A%0D%0A%09%7C%20result%20value%20%7C%0D%0A%09result%20%3A%3D%20self%20hashObject.%0D%0A%09self%20do%3A%20%5B%3Aassoc%20%7C%0D%0A%09%09value%20%3A%3D%20%28self%20isObject%3A%20assoc%20value%29%0D%0A%09%09%09ifTrue%3A%20%5B%20assoc%20value%20json%20%5D%0D%0A%09%09%09ifFalse%3A%20%5B%20assoc%20value%20%5D.%0D%0A%09%09self%20install%3A%20assoc%20key%20value%3A%20value%20into%3A%20result%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.Metaclass,"instanceClass","instanceClass"

,function (){var self=this;return self['@instanceClass'];return self;}

,"accessing",unescape("instanceClass%0D%0A%09%22%20Return%20the%20instance%20class%20of%20receiver.%20%22%0D%0A%0D%0A%09%5EinstanceClass"));

smalltalk.bind(smalltalk.Metaclass,"instanceVariableNames:","instanceVariableNames_"

,function (aCollection){var self=this;smalltalk.ClassBuilder.$$new().class_instanceVariableNames_(self, aCollection);return self;}

,"accessing",unescape("instanceVariableNames%3A%20aCollection%0D%0A%09%22%20Set%20the%20instance%20variable%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09ClassBuilder%20new%0D%0A%09%09class%3A%20self%0D%0A%09%09instanceVariableNames%3A%20aCollection"));

smalltalk.bind(smalltalk.Metaclass,"isMetaclass","isMetaclass"

,function (){var self=this;return true;return self;}

,"testing",unescape("isMetaclass%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20metaclass.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Metaclass,"printString","printString"

,function (){var self=this;return self.instanceClass().name()._comma(" class");return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20a%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20instanceClass%20name%2C%20%27%20class%27"));

smalltalk.bind(smalltalk.Metaclass,"poolDictionaries","poolDictionaries"

,function (){var self=this;return self.instanceClass().poolDictionaries();return self;}

,"accessing",unescape("poolDictionaries%0D%0A%09%22%20Return%20the%20poolDictionaries%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20instanceClass%20poolDictionaries"));

smalltalk.bind(smalltalk.Metaclass,"classVariables","classVariables"

,function (){var self=this;return self.instanceClass().classVariables();return self;}

,"accessing",unescape("classVariables%0D%0A%09%22%20Return%20the%20class%20variables%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20instanceClass%20classVariables"));

smalltalk.bind(smalltalk.Class.$klass,"categories","categories"

,function (){var self=this;return smalltalk.Smalltalk.current().classes().collect_((function(each){return each.category();})).asSet();return self;}

,"export",unescape("categories%0D%0A%09%22%20Return%20a%20collection%20with%20all%20defined%20categories.%20%22%0D%0A%0D%0A%09%5E%28Smalltalk%20current%20classes%20collect%3A%20%5B%3Aeach%20%7C%20each%20category%20%5D%29%20asSet"));

smalltalk.bind(smalltalk.Class.$klass,"uncategorized","uncategorized"

,function (){var self=this;return smalltalk.Smalltalk.current().classes().select_((function(each){return each.category()._eq("unclassified");}));return self;}

,"export",unescape("uncategorized%0D%0A%09%22%20Return%20a%20collection%20with%20classes%20without%20category.%20%22%0D%0A%0D%0A%09%5ESmalltalk%20current%20classes%20select%3A%20%5B%3Aeach%20%7C%20each%20category%20%3D%20%23unclassified%20%5D"));

smalltalk.bind(smalltalk.Class,"category","category"

,function (){var self=this;return (self["$category"] || nil);return self;}

,"accessing",unescape("category%0D%0A%09%22%20Return%20the%20category%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24category%27"));

smalltalk.bind(smalltalk.Class,"category:","category_"

,function (aString){var self=this;(self["$category"]=(aString));return self;}

,"accessing",unescape("category%3A%20aString%0D%0A%09%22%20Set%20the%20category%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20basicAt%3A%20%27%24category%27%20put%3A%20aString"));

smalltalk.bind(smalltalk.Class,"classVariables","classVariables"

,function (){var self=this;try{var deferred=nil;deferred=(self["$classVariableNames"] || (function(){return (function(){throw({name: "stReturn", selector: "classVariables", fn: function(){return (self["$classVariables"] || nil)}})})();}).value());

self.basicDelete_("$classVariableNames");

self.classVariableNames_(deferred);

(function(){throw({name: "stReturn", selector: "classVariables", fn: function(){return (self["$classVariables"] || nil)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "classVariables"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("classVariables%0D%0A%09%22%20Return%20the%20class%20variables%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20deferred%20%7C%0D%0A%09deferred%20%3A%3D%20self%20basicAt%3A%20%27%24classVariableNames%27%20ifAbsent%3A%20%5B%0D%0A%09%09%5Eself%20basicAt%3A%20%27%24classVariables%27%0D%0A%09%5D.%0D%0A%09self%20basicDelete%3A%20%27%24classVariableNames%27.%0D%0A%09self%20classVariableNames%3A%20deferred.%0D%0A%09%5Eself%20basicAt%3A%20%27%24classVariables%27"));

smalltalk.bind(smalltalk.Class,"classVariables:","classVariables_"

,function (aDictionary){var self=this;try{((((aDictionary || nil) !== nil).and_((function(){return aDictionary.isEmpty();}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "classVariables_", fn: function(){return self.classVariables_(nil)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "classVariables_", fn: function(){return (self["$classVariables"]=(aDictionary))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "classVariables_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("classVariables%3A%20aDictionary%0D%0A%09%22%20Set%20the%20class%20variables%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%28aDictionary%20notNil%20and%3A%20%5B%20aDictionary%20isEmpty%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20classVariables%3A%20nil%0D%0A%09%5D.%0D%0A%09%5Eself%20basicAt%3A%20%27%24classVariables%27%20put%3A%20aDictionary"));

smalltalk.bind(smalltalk.Class,"poolDictionaries","poolDictionaries"

,function (){var self=this;return (self["$poolDictionaries"] || nil);return self;}

,"accessing",unescape("poolDictionaries%0D%0A%09%22%20Return%20the%20poolDictionaries%20of%20the%20receiver%20%28anArray%20or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24poolDictionaries%27"));

smalltalk.bind(smalltalk.Class,"poolDictionaries:","poolDictionaries_"

,function (anArray){var self=this;try{((((anArray || nil) !== nil).and_((function(){return anArray.isEmpty();}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "poolDictionaries_", fn: function(){return self.poolDictionaries_(nil)}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "poolDictionaries_", fn: function(){return (self["$poolDictionaries"]=(anArray))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "poolDictionaries_"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("poolDictionaries%3A%20anArray%0D%0A%09%22%20Set%20the%20poolDictionaries%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%28anArray%20notNil%20and%3A%20%5B%20anArray%20isEmpty%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20poolDictionaries%3A%20nil%0D%0A%09%5D.%0D%0A%09%5Eself%20basicAt%3A%20%27%24poolDictionaries%27%20put%3A%20anArray"));

smalltalk.bind(smalltalk.Class,"classVariableNames","classVariableNames"

,function (){var self=this;return ((((self.classVariables() || nil) === nil)).mustBeBoolean()==true ? (function(){return smalltalk.Array.$$new();})() : (function(){return self.classVariables().keys();})());return self;}

,"accessing",unescape("classVariableNames%0D%0A%09%22%20Return%20the%20class%20variable%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classVariables%20isNil%0D%0A%09%09ifTrue%3A%20%5B%20Array%20new%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20self%20classVariables%20keys%20%5D"));

smalltalk.bind(smalltalk.Class,"classVariablesString","classVariablesString"

,function (){var self=this;return self.classVariableNames().inject_into_("", (function(total, each){return total._comma(each)._comma(" ");})).trimBlanks();return self;}

,"accessing",unescape("classVariablesString%0D%0A%09%22%20Return%20the%20class%20variable%20names%20of%20the%20receiver%20as%20aString.%20%22%0D%0A%0D%0A%09%5E%28self%20classVariableNames%20inject%3A%20%27%27%0D%0A%09%09into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%20%2C%20each%20%2C%20%27%20%27%20%5D%0D%0A%09%09%29%20trimBlanks"));

smalltalk.bind(smalltalk.Class,"poolDictionaryNames","poolDictionaryNames"

,function (){var self=this;return ((((self.poolDictionaries() || nil) === nil)).mustBeBoolean()==true ? (function(){return smalltalk.Array.$$new();})() : (function(){return self.poolDictionaries();})());return self;}

,"accessing",unescape("poolDictionaryNames%0D%0A%09%22%20Return%20the%20pool%20dictionary%20names%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20poolDictionaries%20isNil%0D%0A%09%09ifTrue%3A%20%5B%20Array%20new%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20self%20poolDictionaries%20%5D"));

smalltalk.bind(smalltalk.Class,"poolDictionariesString","poolDictionariesString"

,function (){var self=this;return self.poolDictionaryNames().inject_into_("", (function(total, each){return total._comma(each)._comma(" ");})).trimBlanks();return self;}

,"accessing",unescape("poolDictionariesString%0D%0A%09%22%20Return%20the%20poolDictionary%20names%20of%20the%20receiver%20as%20aString.%20%22%0D%0A%0D%0A%09%5E%28self%20poolDictionaryNames%20inject%3A%20%27%27%0D%0A%09%09into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%20%2C%20each%20%2C%20%27%20%27%20%5D%0D%0A%09%09%29%20trimBlanks"));

smalltalk.bind(smalltalk.Class,"classVariableNames:","classVariableNames_"

,function (classVarNames){var self=this;try{var names=nil;var dictionary=nil;var old=nil;((((classVarNames || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "classVariableNames_", fn: function(){return self.classVariables_(nil)}})})();})() : nil);

names=((classVarNames.isString()).mustBeBoolean()==true ? (function(){return classVarNames.asArrayOfSubstrings();})() : (function(){return classVarNames;})());

dictionary=smalltalk.Dictionary.$$new();

old=self.classVariables();

((((old || nil) === nil)).mustBeBoolean()==true ? (function(){return old=dictionary;})() : nil);

names.do_((function(each){return dictionary.at_put_(each, old.at_ifAbsent_(each, (function(){return nil;})));}));

self.classVariables_(dictionary);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "classVariableNames_"){return $$ex.fn();} throw($$ex);}}

,"instantiation",unescape("classVariableNames%3A%20classVarNames%0D%0A%09%22%20Set%20the%20variable%20names%20defined%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20names%20dictionary%20old%20%7C%0D%0A%09classVarNames%20isNil%20ifTrue%3A%20%5B%20%5Eself%20classVariables%3A%20nil%20%5D.%0D%0A%09names%20%3A%3D%20classVarNames%20isString%0D%0A%09%09ifTrue%3A%20%5B%20classVarNames%20asArrayOfSubstrings%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20classVarNames%20%5D.%0D%0A%09dictionary%20%3A%3D%20Dictionary%20new.%0D%0A%09old%20%3A%3D%20self%20classVariables.%20old%20isNil%20ifTrue%3A%20%5B%20old%20%3A%3D%20dictionary%20%5D.%0D%0A%09names%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09dictionary%20at%3A%20each%20put%3A%20%28old%20at%3A%20each%20ifAbsent%3A%20%5B%20nil%20%5D%29%0D%0A%09%5D.%0D%0A%09self%20classVariables%3A%20dictionary."));

smalltalk.bind(smalltalk.Class,"poolDictionaryNames:","poolDictionaryNames_"

,function (poolVarNames){var self=this;self.poolDictionaries_(((poolVarNames.isString()).mustBeBoolean()==true ? (function(){return poolVarNames.asArrayOfSubstrings();})() : (function(){return poolVarNames;})()));return self;}

,"instantiation",unescape("poolDictionaryNames%3A%20poolVarNames%0D%0A%09%22%20Set%20the%20pool%20dictionary%20names%20known%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20poolDictionaries%3A%20%28poolVarNames%20isString%0D%0A%09%09ifTrue%3A%20%5B%20poolVarNames%20asArrayOfSubstrings%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20poolVarNames%20%5D%29."));

smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:","subclass_instanceVariableNames_"

,function (aString,aString2){var self=this;return self.subclass_instanceVariableNames_classVariableNames_(aString, aString2, "");return self;}

,"instantiation",unescape("subclass%3A%20aString%20instanceVariableNames%3A%20aString2%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20%27%27"));

smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:category:","subclass_instanceVariableNames_category_"

,function (aString,aString2,aString3){var self=this;return smalltalk.ClassBuilder.$$new().superclass_subclass_instanceVariableNames_category_(self, aString, aString2, aString3);return self;}

,"instantiation",unescape("subclass%3A%20aString%20instanceVariableNames%3A%20aString2%20category%3A%20aString3%0D%0A%09%22%20Create%20a%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EClassBuilder%20new%0D%0A%09%09superclass%3A%20self%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09category%3A%20aString3"));

smalltalk.bind(smalltalk.Class,"isClass","isClass"

,function (){var self=this;return true;return self;}

,"testing",unescape("isClass%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20a%20Class.%20%22%0D%0A%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.Class,"printString","printString"

,function (){var self=this;return self.name();return self;}

,"printing",unescape("printString%0D%0A%09%22%20Return%20a%20printable%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20name"));

smalltalk.bind(smalltalk.Class,"instanceClass","instanceClass"

,function (){var self=this;return self;return self;}

,"accessing",unescape("instanceClass%0D%0A%09%22%20Return%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Class,"rename:","rename_"

,function (aString){var self=this;	smalltalk.rename(self.$className,aString); ;return self;}

,"renaming",unescape("rename%3A%20aString%0D%0A%09%22%20Rename%20the%20receiver%20to%20aString.%20%22%0D%0A%0D%0A%7B%27%09smalltalk.rename%28self.%24className%2CaString%29%3B%20%27%7D"));

smalltalk.bind(smalltalk.Class,"variableByteSubclass:classVariableNames:poolDictionaries:","variableByteSubclass_classVariableNames_poolDictionaries_"

,function (aString,classVarNames,poolVarNames){var self=this;self.print_(unescape("//%20WARNING%3A%20")._comma(aString)._comma(" defined as variableByteSubclass:..."));

return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString, "", classVarNames, poolVarNames);return self;}

,"instantiation",unescape("variableByteSubclass%3A%20aString%0D%0A%09classVariableNames%3A%20classVarNames%0D%0A%09poolDictionaries%3A%20poolVarNames%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20print%3A%20%27//%20WARNING%3A%20%27%2CaString%2C%27%20defined%20as%20variableByteSubclass%3A...%27.%0D%0A%09%5Eself%20%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20%27%27%0D%0A%09%09classVariableNames%3A%20classVarNames%0D%0A%09%09poolDictionaries%3A%20poolVarNames"));

smalltalk.bind(smalltalk.Class,"variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:","variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_"

,function (aString,aString2,classVarNames,poolVarNames){var self=this;self.print_(unescape("//%20WARNING%3A%20")._comma(aString)._comma(" defined as variableSubclass:..."));

return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString, aString2, classVarNames, poolVarNames);return self;}

,"instantiation",unescape("variableSubclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09classVariableNames%3A%20classVarNames%0D%0A%09poolDictionaries%3A%20poolVarNames%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20print%3A%20%27//%20WARNING%3A%20%27%2CaString%2C%27%20defined%20as%20variableSubclass%3A...%27.%0D%0A%09%5Eself%20%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20classVarNames%0D%0A%09%09poolDictionaries%3A%20poolVarNames"));

smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:","subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_"

,function (aString,aString2,classVarNames,poolVarNames,aCategory){var self=this;(((((self.smalltalk()[aString] || nil) || nil) !== nil)).mustBeBoolean()==true ? (function(){return self.print_(unescape("//%20WARNING%3A%20class%20REdefinition%20for%20")._comma(aString));})() : nil);

return smalltalk.ClassBuilder.$$new().superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self, aString, aString2, classVarNames, poolVarNames, aCategory);return self;}

,"instantiation",unescape("subclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09classVariableNames%3A%20classVarNames%0D%0A%09poolDictionaries%3A%20poolVarNames%0D%0A%09category%3A%20aCategory%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%28self%20smalltalk%20basicAt%3A%20aString%29%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09self%20print%3A%20%27//%20WARNING%3A%20class%20REdefinition%20for%20%27%2CaString.%0D%0A%09%09%22%5Eself%20smalltalk%20basicAt%3A%20aString%22%0D%0A%09%5D.%0D%0A%0D%0A%09%22self%20print%3A%20%27//%20Creating%20%27%2CaString.%22%0D%0A%09%5EClassBuilder%20new%0D%0A%09%09superclass%3A%20self%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20classVarNames%0D%0A%09%09poolDictionaries%3A%20poolVarNames%0D%0A%09%09category%3A%20aCategory"));

smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:","subclass_instanceVariableNames_classVariableNames_poolDictionaries_"

,function (aString,aString2,classVarNames,poolVarNames){var self=this;return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString, aString2, classVarNames, poolVarNames, nil);return self;}

,"instantiation",unescape("subclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09classVariableNames%3A%20classVarNames%0D%0A%09poolDictionaries%3A%20poolVarNames%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20classVarNames%0D%0A%09%09poolDictionaries%3A%20poolVarNames%0D%0A%09%09category%3A%20nil"));

smalltalk.bind(smalltalk.Class,"variableByteSubclass:classVariableNames:","variableByteSubclass_classVariableNames_"

,function (aString,classVarNames){var self=this;return self.variableByteSubclass_classVariableNames_poolDictionaries_(aString, classVarNames, "");return self;}

,"instantiation",unescape("variableByteSubclass%3A%20aString%20classVariableNames%3A%20classVarNames%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09variableByteSubclass%3A%20aString%0D%0A%09%09classVariableNames%3A%20classVarNames%0D%0A%09%09poolDictionaries%3A%20%27%27"));

smalltalk.bind(smalltalk.Class,"variableByteSubclass:poolDictionaries:","variableByteSubclass_poolDictionaries_"

,function (aString,aString2){var self=this;return self.variableByteSubclass_classVariableNames_poolDictionaries_(aString, "", aString2);return self;}

,"instantiation",unescape("variableByteSubclass%3A%20aString%20poolDictionaries%3A%20aString2%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09variableByteSubclass%3A%20aString%0D%0A%09%09classVariableNames%3A%20%27%27%0D%0A%09%09poolDictionaries%3A%20aString2"));

smalltalk.bind(smalltalk.Class,"variableByteSubclass:","variableByteSubclass_"

,function (aString){var self=this;return self.variableByteSubclass_classVariableNames_(aString, "");return self;}

,"instantiation",unescape("variableByteSubclass%3A%20aString%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09variableByteSubclass%3A%20aString%0D%0A%09%09classVariableNames%3A%20%27%27"));

smalltalk.bind(smalltalk.Class,"variableSubclass:instanceVariableNames:classVariableNames:","variableSubclass_instanceVariableNames_classVariableNames_"

,function (aString,aString2,classVarNames){var self=this;return self.variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString, aString2, classVarNames, "");return self;}

,"instantiation",unescape("variableSubclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09classVariableNames%3A%20classVarNames%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%0D%0A%09%09variableSubclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20classVarNames%0D%0A%09%09poolDictionaries%3A%20%27%27"));

smalltalk.bind(smalltalk.Class,"variableSubclass:instanceVariableNames:","variableSubclass_instanceVariableNames_"

,function (aString,aString2){var self=this;return self.variableSubclass_instanceVariableNames_classVariableNames_(aString, aString2, "");return self;}

,"instantiation",unescape("variableSubclass%3A%20aString%20instanceVariableNames%3A%20aString2%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%0D%0A%09%09variableSubclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20%27%27"));

smalltalk.bind(smalltalk.Class,"variableSubclass:classVariableNames:","variableSubclass_classVariableNames_"

,function (aString,aString2){var self=this;return self.variableSubclass_instanceVariableNames_classVariableNames_(aString, "", aString2);return self;}

,"instantiation",unescape("variableSubclass%3A%20aString%20classVariableNames%3A%20aString2%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%0D%0A%09%09variableSubclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20%27%27%0D%0A%09%09classVariableNames%3A%20aString2"));

smalltalk.bind(smalltalk.Class,"variableSubclass:poolDictionaries:","variableSubclass_poolDictionaries_"

,function (aString,aString2){var self=this;return self.variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString, "", "", aString2);return self;}

,"instantiation",unescape("variableSubclass%3A%20aString%20poolDictionaries%3A%20aString2%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%0D%0A%09%09variableSubclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20%27%27%0D%0A%09%09classVariableNames%3A%20%27%27%0D%0A%09%09poolDictionaries%3A%20aString2"));

smalltalk.bind(smalltalk.Class,"variableSubclass:","variableSubclass_"

,function (aString){var self=this;return self.variableSubclass_instanceVariableNames_(aString, "");return self;}

,"instantiation",unescape("variableSubclass%3A%20aString%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%0D%0A%09%09variableSubclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20%27%27"));

smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:","subclass_instanceVariableNames_classVariableNames_"

,function (aString,aString2,classVarNames){var self=this;return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString, aString2, classVarNames, "");return self;}

,"instantiation",unescape("subclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09classVariableNames%3A%20classVarNames%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20classVarNames%0D%0A%09%09poolDictionaries%3A%20%27%27"));

smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:poolDictionaries:","subclass_instanceVariableNames_poolDictionaries_"

,function (aString,aString2,aString3){var self=this;return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString, aString2, "", aString3);return self;}

,"instantiation",unescape("subclass%3A%20aString%0D%0A%09instanceVariableNames%3A%20aString2%0D%0A%09poolDictionaries%3A%20aString3%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20aString2%0D%0A%09%09classVariableNames%3A%20%27%27%0D%0A%09%09poolDictionaries%3A%20aString3"));

smalltalk.bind(smalltalk.Class,"subclass:classVariableNames:","subclass_classVariableNames_"

,function (aString,aString2){var self=this;return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString, "", aString2, "");return self;}

,"instantiation",unescape("subclass%3A%20aString%20classVariableNames%3A%20aString2%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20%27%27%0D%0A%09%09classVariableNames%3A%20aString2%0D%0A%09%09poolDictionaries%3A%20%27%27"));

smalltalk.bind(smalltalk.Class,"subclass:poolDictionaries:","subclass_poolDictionaries_"

,function (aString,aString2){var self=this;return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString, "", "", aString2);return self;}

,"instantiation",unescape("subclass%3A%20aString%20poolDictionaries%3A%20aString2%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20%27%27%0D%0A%09%09classVariableNames%3A%20%27%27%0D%0A%09%09poolDictionaries%3A%20aString2"));

smalltalk.bind(smalltalk.Class,"subclass:","subclass_"

,function (aString){var self=this;return self.subclass_instanceVariableNames_(aString, "");return self;}

,"instantiation",unescape("subclass%3A%20aString%0D%0A%09%22%20Create%20a%20new%20subclass%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09subclass%3A%20aString%0D%0A%09%09instanceVariableNames%3A%20%27%27"));

smalltalk.bind(smalltalk.Class,"launch","launch"

,function (){var self=this;return self;}

,"image-startup",unescape("launch%0D%0A%09%22%20Private%20-%20The%20system%20has%20been%20launched%20and%20start%20execution.%0D%0A%09The%20default%20action%20is%20to%20do%20nothing.%0D%0A%09Subclasses%20can%20refine%20this%20method%20to%20execute%20actions%20on%20startup.%0D%0A%09%22"));

smalltalk.bind(smalltalk.Class,"aboutToSaveImage:on:","aboutToSaveImage_on_"

,function (snapshot,stream){var self=this;return self;return self;}

,"image-snapshot",unescape("aboutToSaveImage%3A%20snapshot%20on%3A%20stream%0D%0A%09%22%20Private%20-%20A%20system%20snapshot%20will%20be%20taken%2C%20the%20receiver%20can%20prepare%20the%20contents%20to%20be%20stored%20on%20snapshot.%0D%0A%09Must%20return%20the%20receiver%20or%20a%20replacement%20to%20act%20as%20the%20receiver%20when%20persisting%20data.%0D%0A%09The%20default%20action%20return%20the%20receiver.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself"));

smalltalk.bind(smalltalk.Class,"imageSaved:on:","imageSaved_on_"

,function (snapshot,stream){var self=this;return self;}

,"image-snapshot",unescape("imageSaved%3A%20snapshot%20on%3A%20stream%0D%0A%09%22%20Private%20-%20A%20system%20snapshot%20has%20been%20taken%2C%20the%20receiver%20can%20restore%20state.%0D%0A%09The%20default%20action%20do%20nothing.%0D%0A%09This%20method%20can%20be%20refined%20by%20the%20subclasses.%0D%0A%09%22"));

smalltalk.bind(smalltalk.Class,"aboutToExit:","aboutToExit_"

,function (aSystemDictionary){var self=this;return self;}

,"image-snapshot",unescape("aboutToExit%3A%20aSystemDictionary%0D%0A%09%22%20Private%20-%20A%20system%20will%20exit%2C%20and%20the%20receiver%20can%20act%20executing%20actions%20just%20before%20exiting.%0D%0A%09The%20default%20action%20do%20nothing.%0D%0A%09This%20method%20can%20be%20refined%20by%20the%20subclasses.%0D%0A%09%22"));


// Smalltalk Globals set-up.

smalltalk.initRoots();

smalltalk.$imageFileName="pg8.image.js";

smalltalk.OverwriteMethods=true;

smalltalk.DumpOverwriteMethods=nil;

smalltalk.DumpOverwritenMethods=nil;